--
-- Table structure for table `npc`
-- 
DROP TABLE IF EXISTS `npc`;
CREATE TABLE `npc`(
  `id` decimal(11,0) NOT NULL default '0',
  `idTemplate` int(11) NOT NULL default '0',
  `name` varchar(200) default NULL,
  `serverSideName` int(1) default '0',
  `title` varchar(45) default '',
  `serverSideTitle` int(1) default '0',
  `class` varchar(200) default NULL,
  `collision_radius` decimal(5,2) default NULL,
  `collision_height` decimal(5,2) default NULL,
  `level` decimal(2,0) default NULL,
  `sex` varchar(6) default NULL,
  `type` varchar(20) default NULL,
  `attackrange` int(11) default NULL,
  `hp` decimal(8,0) default NULL,
  `mp` decimal(5,0) default NULL,
  `hpreg` decimal(8,2) default NULL,
  `mpreg` decimal(5,2) default NULL,
  `str` decimal(7,0) default NULL,
  `con` decimal(7,0) default NULL,
  `dex` decimal(7,0) default NULL,
  `int` decimal(7,0) default NULL,
  `wit` decimal(7,0) default NULL,
  `men` decimal(7,0) default NULL,
  `exp` decimal(9,0) default NULL,
  `sp` decimal(8,0) default NULL,
  `patk` decimal(5,0) default NULL,
  `pdef` decimal(5,0) default NULL,
  `matk` decimal(5,0) default NULL,
  `mdef` decimal(5,0) default NULL,
  `atkspd` decimal(3,0) default NULL,
  `aggro` decimal(6,0) default NULL,
  `matkspd` decimal(4,0) default NULL,
  `rhand` decimal(4,0) default NULL,
  `lhand` decimal(4,0) default NULL,
  `armor` decimal(1,0) default NULL,
  `walkspd` decimal(3,0) default NULL,
  `runspd` decimal(3,0) default NULL,
  `faction_id` varchar(40) default NULL,
  `faction_range` decimal(4,0) default NULL,
  `isUndead` int(11) default 0,
  `absorb_level` decimal(2,0) default 0,
  `absorb_type` enum('FULL_PARTY','LAST_HIT','PARTY_ONE_RANDOM') DEFAULT 'LAST_HIT' NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;
-- 
-- Dumping data for table `npc`
-- 
INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(12077,12077,'Wolf',0,'',0,'Monster.pet_wolf',13.00,11.50,15,'male','L2Pet',40,195,164,3.95,1.21,40,43,30,21,20,25,0,0,9,19,3,17,282,0,333,0,0,0,26,137,NULL,0,0,0,'LAST_HIT'),
	(12311,12311,'Hatchling of the Wind',0,'',0,'Monster.hatchling',9.00,10.00,35,'male','L2Pet',40,610,433,7.11,1.84,40,43,30,21,20,25,0,0,48,42,22,39,282,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(12312,12312,'Hatchling of the Stars',0,'',0,'Monster.hatchling',9.00,10.00,35,'male','L2Pet',40,610,433,7.11,1.84,40,43,30,21,20,25,0,0,48,42,22,39,282,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(12313,12313,'Hatchling of Twilight',0,'',0,'Monster.hatchling',9.00,10.00,35,'male','L2Pet',40,610,433,7.11,1.84,40,43,30,21,20,25,0,0,48,42,22,39,282,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(12526,12526,'Wind Strider',0,'',0,'Monster.strider',23.00,31.00,55,'male','L2Pet',40,2728,1138,10.27,2.45,40,43,30,21,20,25,0,0,703,332,360,301,282,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(12527,12527,'Star Strider',0,'',0,'Monster.strider',23.00,31.00,55,'male','L2Pet',40,2728,1138,10.27,2.45,40,43,30,21,20,25,0,0,703,332,360,301,282,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(12528,12528,'Twilight Strider',0,'',0,'Monster.strider',23.00,31.00,55,'male','L2Pet',40,2728,1138,10.27,2.45,40,43,30,21,20,25,0,0,703,332,360,301,282,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(12564,12564,'Sin Eater',0,'',0,'Monster.imp',10.00,24.00,15,'male','L2Monster',40,195,164,1.15,1.21,40,1,30,21,20,25,0,0,9,19,3,17,282,0,333,0,0,0,66,137,NULL,0,0,0,'LAST_HIT'),
	(12621,12621,'Wyvern',0,'',0,'Monster.wyvern',60.00,58.00,70,'male','L2Monster',40,3862,1722,11.85,2.78,40,43,30,21,20,25,0,0,1335,470,780,440,282,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(12774,12774,'Young Squash',0,'',0,'NPC.drop_gourd_50_sm',10.00,10.50,1,'etc','L2Monster',40,158,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12775,12775,'High Quality Squash',0,'',0,'NPC.drop_gourd',20.00,21.00,1,'etc','L2Monster',40,205,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12776,12776,'Low Quality Squash',0,'',0,'NPC.drop_gourd_25_sm',15.00,16.00,1,'etc','L2Monster',40,205,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12777,12777,'Large Young Squash',0,'',0,'NPC.drop_gourd',20.00,21.00,1,'etc','L2Monster',40,158,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12778,12778,'High Quality Large Squash',0,'',0,'NPC.drop_gourd_50_bi',30.00,31.50,1,'etc','L2Monster',40,205,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12779,12779,'Low Quality Large Squash',0,'',0,'NPC.drop_gourd_25_bi',25.00,26.50,1,'etc','L2Monster',40,205,0,1.42,0.00,40,43,30,21,20,10,0,0,4,41,3,33,278,0,333,0,0,0,33,88,NULL,0,1,0,'LAST_HIT'),
	(12780,12780,'Baby Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,25,'male','L2BabyPet',40,751,331,2.37,1.53,40,43,30,21,20,25,0,0,88,119,37,112,282,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(12781,12781,'Baby Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,25,'male','L2BabyPet',40,751,331,2.37,1.53,40,43,30,21,20,25,0,0,88,119,37,112,282,0,333,0,0,0,14,132,NULL,0,0,0,'LAST_HIT'),
	(12782,12782,'Baby Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,25,'male','L2BabyPet',40,751,331,2.37,1.53,40,43,30,21,20,25,0,0,88,119,37,112,282,0,333,0,0,0,30,132,NULL,0,0,0,'LAST_HIT'),
	(13001,13001,'Heart of Warding',0,'',0,'NPC.heart_of_warding',17.00,75.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(13002,13002,'Life Control Tower',0,'',0,'NPC.broadcasting_tower',13.00,54.00,20,'etc','L2ControlTower',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(13003,13003,'Life Control Tower',0,'',0,'NPC.dead_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2ControlTower',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(13004,13004,'Flame Control Tower',0,'',0,'NPC.broadcasting_tower',13.00,54.00,20,'etc','L2Npc',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(13005,13005,'Flame Control Tower',0,'',0,'NPC.dead_castle_aden_controltower_jewel',7.00,35.00,20,'etc','L2Npc',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(13006,13006,'Christmas Tree',0,'',0,'Deco.x_mas_tree',0.00,0.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(13007,13007,'Special Christmas Tree',0,'',0,'Deco.x_mas_tree_50_bi',0.00,0.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(13014,13014,' ',0,'',0,'NPC.clear_npc',0.10,0.10,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13015,13015,'',0,'',0,'Monster3.Evilate_weather',20.00,31.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13016,13016,'King Squash',0,'',0,'NPC.drop_gourd',24.00,40.00,1,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,333,0,0,0,40,176,NULL,0,0,0,'LAST_HIT'),
	(13017,13017,'Emperor Squash',0,'',0,'NPC.drop_gourd_50_bi',24.00,40.00,1,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7557,858,2255,534,1731,433,278,0,333,0,0,0,40,176,NULL,0,0,0,'LAST_HIT'),
	(13018,13018,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13019,13019,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13020,13020,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13021,13021,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13022,13022,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13023,13023,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13024,13024,'',0,'',0,'NPC2.skill_dummy_00_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13025,13025,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13026,13026,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13027,13027,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13028,13028,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13029,13029,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13030,13030,'',0,'',0,'NPC2.skill_dummy_01_a',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13031,13031,'Huge Cursed Pig',0,'',0,'NPC2.E_pig_ball',5.50,5.25,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13032,13032,'Huge Cursed Pig',0,'',0,'NPC2.E_pig_ball',5.50,5.25,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13033,13033,'Huge Cursed Pig',0,'',0,'NPC2.E_pig_ball',5.50,5.25,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13034,13034,'Super Huge Cursed Pig',0,'',0,'NPC2.E_pig_ball_H',29.00,38.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(13035,13035,'Golden Cursed Pig',0,'',0,'NPC2.E_pig_ball',5.50,5.25,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14001,14001,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,46,'male','L2Pet',40,2914,816,8.69,2.14,40,43,30,21,20,25,0,0,482,245,202,230,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14002,14002,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,54,'male','L2Pet',40,3843,1102,10.27,2.45,40,43,30,21,20,25,0,0,763,313,339,293,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14003,14003,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,62,'male','L2Pet',40,4829,1404,11.85,2.78,40,43,30,21,20,25,0,0,1133,388,532,363,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14004,14004,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,66,'male','L2Pet',40,5319,1561,11.85,2.78,40,43,30,21,20,25,0,0,1347,428,649,401,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14005,14005,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,70,'male','L2Pet',40,5793,1722,11.85,2.78,40,43,30,21,20,25,0,0,1577,470,780,440,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14006,14006,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,74,'male','L2Pet',40,6238,1888,13.43,3.09,40,43,30,21,20,25,0,0,1816,512,921,480,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14007,14007,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,76,'male','L2Pet',40,6446,1972,13.43,3.09,40,43,30,21,20,25,0,0,1937,534,994,500,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14008,14008,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14009,14009,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14010,14010,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14011,14011,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14012,14012,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14013,14013,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14014,14014,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14015,14015,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14016,14016,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14017,14017,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14018,14018,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14019,14019,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14020,14020,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14021,14021,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14022,14022,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14023,14023,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14024,14024,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14025,14025,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14026,14026,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14027,14027,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14028,14028,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14029,14029,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14030,14030,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14031,14031,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14032,14032,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14033,14033,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14034,14034,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14035,14035,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14036,14036,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14037,14037,'Reanimated Man',0,'',0,'Monster.skeleton',11.00,25.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,333,0,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(14038,14038,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,42,'male','L2Pet',40,2490,1019,8.69,2.14,40,43,30,21,20,25,0,0,374,215,152,202,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14039,14039,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,50,'male','L2Pet',40,3367,1435,8.69,2.14,40,43,30,21,20,25,0,0,611,278,264,260,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14040,14040,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,58,'male','L2Pet',40,4333,1876,10.27,2.45,40,43,30,21,20,25,0,0,937,349,428,327,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14041,14041,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,64,'male','L2Pet',40,5076,2223,11.85,2.78,40,43,30,21,20,25,0,0,1238,408,589,382,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14042,14042,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,68,'male','L2Pet',40,5559,2462,11.85,2.78,40,43,30,21,20,25,0,0,1460,449,713,421,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14043,14043,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,72,'male','L2Pet',40,6020,2707,13.43,3.09,40,43,30,21,20,25,0,0,1695,491,849,460,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14044,14044,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2068,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14045,14045,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2078,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14046,14046,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2088,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14047,14047,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2099,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14048,14048,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2109,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14049,14049,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2119,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14050,14050,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2130,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14051,14051,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2140,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14052,14052,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,78,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2150,555,1069,520,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14053,14053,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2173,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14054,14054,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2184,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14055,14055,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2194,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14056,14056,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2204,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14057,14057,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2215,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14058,14058,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2225,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14059,14059,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2236,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14060,14060,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2246,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14061,14061,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,79,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2256,558,1082,523,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14062,14062,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2280,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14063,14063,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2290,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14064,14064,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2301,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14065,14065,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2311,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14066,14066,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2322,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14067,14067,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2332,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14068,14068,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2343,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14069,14069,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2353,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14070,14070,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2363,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14071,14071,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2374,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14072,14072,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2384,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14073,14073,'Corrupted Man',0,'',0,'Monster.zombie',13.00,21.00,80,'male','L2Pet',40,6642,3086,13.43,3.09,40,43,30,21,20,25,0,0,2395,562,1095,526,278,0,333,0,0,0,16,154,NULL,0,1,0,'LAST_HIT'),
	(14074,14074,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,58,'male','L2Pet',80,3467,1251,12.32,2.45,40,43,30,21,20,25,0,0,1015,349,428,327,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14075,14075,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,62,'male','L2Pet',80,3863,1404,14.22,2.78,40,43,30,21,20,25,0,0,1227,388,532,363,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14076,14076,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,66,'male','L2Pet',80,4255,1561,14.22,2.78,40,43,30,21,20,25,0,0,1459,428,649,401,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14077,14077,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,70,'male','L2Pet',80,4634,1722,14.22,2.78,40,43,30,21,20,25,0,0,1708,470,780,440,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14078,14078,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,72,'male','L2Pet',80,4816,1804,16.12,3.09,40,43,30,21,20,25,0,0,1837,491,849,460,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14079,14079,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,74,'male','L2Pet',80,4990,1888,16.12,3.09,40,43,30,21,20,25,0,0,1967,512,921,480,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14080,14080,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,76,'male','L2Pet',80,5157,1972,16.12,3.09,40,43,30,21,20,25,0,0,2098,534,994,500,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14081,14081,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2229,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14082,14082,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2245,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14083,14083,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2261,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14084,14084,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2277,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14085,14085,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2293,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14086,14086,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2309,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14087,14087,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2325,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14088,14088,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2341,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14089,14089,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,78,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2357,555,1069,520,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14090,14090,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2388,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14091,14091,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2404,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14092,14092,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2420,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14093,14093,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2436,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14094,14094,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2452,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14095,14095,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2468,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14096,14096,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2484,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14097,14097,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2500,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14098,14098,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,79,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2517,558,1082,523,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14099,14099,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2548,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14100,14100,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2564,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14101,14101,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2580,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14102,14102,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2596,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14103,14103,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2613,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14104,14104,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2629,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14105,14105,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2645,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14106,14106,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2661,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14107,14107,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2678,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14108,14108,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2694,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14109,14109,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2710,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14110,14110,'Cursed Man',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2Pet',80,5314,2057,16.12,3.09,40,43,30,21,20,25,0,0,2726,562,1095,526,278,0,333,0,0,0,88,176,NULL,0,1,0,'LAST_HIT'),
	(14111,14111,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,22,'male','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14112,14112,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,32,'male','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14113,14113,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,42,'male','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14114,14114,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,50,'male','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14115,14115,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,58,'male','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14116,14116,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,27,'male','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14117,14117,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,37,'male','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14118,14118,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,46,'male','L2Pet',40,3108,816,8.69,2.14,40,43,30,21,20,25,0,0,401,245,202,230,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14119,14119,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,54,'male','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14120,14120,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,60,'male','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14121,14121,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,62,'male','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14122,14122,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,64,'male','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14123,14123,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,66,'male','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14124,14124,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,68,'male','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14125,14125,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14126,14126,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,72,'male','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14127,14127,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,74,'male','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14128,14128,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,76,'male','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14129,14129,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14130,14130,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14131,14131,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14132,14132,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14133,14133,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14134,14134,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14135,14135,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14136,14136,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14137,14137,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14138,14138,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14139,14139,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14140,14140,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14141,14141,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14142,14142,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14143,14143,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14144,14144,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14145,14145,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14146,14146,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14147,14147,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14148,14148,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14149,14149,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14150,14150,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14151,14151,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14152,14152,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14153,14153,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14154,14154,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14155,14155,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14156,14156,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14157,14157,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14158,14158,'Kat the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(14159,14159,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,27,'female','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14160,14160,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,37,'female','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14161,14161,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,47,'female','L2Pet',40,3227,851,8.69,2.14,40,43,30,21,20,25,0,0,427,253,216,237,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14162,14162,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,54,'female','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14163,14163,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,22,'female','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14164,14164,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,32,'female','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14165,14165,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,42,'female','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14166,14166,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,50,'female','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14167,14167,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,58,'female','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14168,14168,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,60,'female','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14169,14169,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,62,'female','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14170,14170,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,64,'female','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14171,14171,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,66,'female','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14172,14172,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,68,'female','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14173,14173,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14174,14174,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,72,'female','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14175,14175,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,74,'female','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14176,14176,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,76,'female','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14177,14177,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Npc',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14178,14178,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14179,14179,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14180,14180,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14181,14181,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14182,14182,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14183,14183,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14184,14184,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14185,14185,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14186,14186,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14187,14187,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14188,14188,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14189,14189,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14190,14190,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14191,14191,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14192,14192,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14193,14193,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14194,14194,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14195,14195,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14196,14196,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14197,14197,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14198,14198,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14199,14199,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14200,14200,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14201,14201,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14202,14202,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14203,14203,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14204,14204,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14205,14205,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14206,14206,'Mew the Cat',0,'',0,'Monster.cutie_cat',8.00,15.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14207,14207,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,42,'male','L2Pet',40,1992,679,8.69,2.14,40,43,30,21,20,25,0,0,342,215,152,202,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14208,14208,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,46,'male','L2Pet',40,2331,816,8.69,2.14,40,43,30,21,20,25,0,0,442,245,202,230,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14209,14209,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,50,'male','L2Pet',40,2694,957,8.69,2.14,40,43,30,21,20,25,0,0,560,278,264,260,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14210,14210,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,54,'male','L2Pet',40,3074,1102,10.27,2.45,40,43,30,21,20,25,0,0,699,313,339,293,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14211,14211,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,58,'male','L2Pet',40,3467,1251,10.27,2.45,40,43,30,21,20,25,0,0,859,349,428,327,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14212,14212,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,60,'male','L2Pet',40,3665,1327,10.27,2.45,40,43,30,21,20,25,0,0,946,368,478,345,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14213,14213,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,62,'male','L2Pet',40,3863,1404,11.85,2.78,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14214,14214,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,64,'male','L2Pet',40,4060,1482,11.85,2.78,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14215,14215,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,66,'male','L2Pet',40,4255,1561,11.85,2.78,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14216,14216,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,68,'male','L2Pet',40,4447,1641,11.85,2.78,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14217,14217,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,70,'male','L2Pet',40,4634,1722,11.85,2.78,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14218,14218,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,72,'male','L2Pet',40,4816,1804,13.43,3.09,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14219,14219,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,74,'male','L2Pet',40,4990,1888,13.43,3.09,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14220,14220,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,76,'male','L2Pet',40,5157,1972,8.69,2.14,40,43,30,21,20,25,0,0,1775,534,994,510,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),
	(14221,14221,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14222,14222,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14223,14223,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14224,14224,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14225,14225,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14226,14226,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14227,14227,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14228,14228,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14229,14229,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14230,14230,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14231,14231,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14232,14232,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14233,14233,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14234,14234,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14235,14235,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14236,14236,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14237,14237,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14238,14238,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14239,14239,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14240,14240,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14241,14241,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14242,14242,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14243,14243,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14244,14244,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14245,14245,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14246,14246,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14247,14247,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14248,14248,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14249,14249,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14250,14250,'Kai the Cat',0,'',0,'Monster.silver_cat',7.00,15.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14251,14251,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,58,'female','L2Pet',40,2889,1251,10.27,2.45,40,43,30,21,20,25,0,0,313,349,428,327,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14252,14252,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,60,'female','L2Pet',40,3054,1327,10.27,2.45,40,43,30,21,20,25,0,0,340,368,478,345,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14253,14253,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,62,'female','L2Pet',40,3219,1404,11.85,2.78,40,43,30,21,20,25,0,0,368,388,532,363,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14254,14254,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,64,'female','L2Pet',40,3384,1482,11.85,2.78,40,43,30,21,20,25,0,0,397,408,589,382,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14255,14255,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,66,'female','L2Pet',40,3546,1561,11.85,2.78,40,43,30,21,20,25,0,0,427,428,649,401,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14256,14256,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,68,'female','L2Pet',40,3706,1641,11.85,2.78,40,43,30,21,20,25,0,0,457,449,713,421,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14257,14257,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Pet',40,3862,1722,11.85,2.78,40,43,30,21,20,25,0,0,487,470,780,440,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14258,14258,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,72,'female','L2Pet',40,4013,1804,13.43,3.09,40,43,30,21,20,25,0,0,517,491,849,460,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14259,14259,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,74,'female','L2Pet',40,4158,1888,13.43,3.09,40,43,30,21,20,25,0,0,547,512,921,480,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14260,14260,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,76,'female','L2Pet',40,4297,1972,13.43,3.09,40,43,30,21,20,25,0,0,577,534,994,500,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14265,14265,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14266,14266,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14267,14267,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14268,14268,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14269,14269,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14270,14270,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14271,14271,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14272,14272,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14273,14273,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,78,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14274,14274,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14275,14275,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14276,14276,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14277,14277,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14278,14278,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14279,14279,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14280,14280,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14281,14281,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14282,14282,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,79,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14283,14283,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14284,14284,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14285,14285,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14286,14286,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14287,14287,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14288,14288,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14289,14289,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14290,14290,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14291,14291,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14292,14292,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14293,14293,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14294,14294,'Feline Queen',0,'',0,'Monster2.queen_of_cat',8.00,15.00,80,'female','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,28,198,NULL,0,0,0,'LAST_HIT'),
	(14295,14295,'Boxer the Unicorn ',0,'',0,'Monster.unicorn_boxer',11.00,18.00,22,'male','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14296,14296,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,32,'male','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14297,14297,'Boxer the Unicorn ',0,'',0,'Monster.unicorn_boxer',11.00,18.00,42,'male','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14298,14298,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,50,'male','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14299,14299,'Boxer the Unicorn ',0,'',0,'Monster.unicorn_boxer',11.00,18.00,58,'male','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14300,14300,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,27,'male','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14301,14301,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,37,'male','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14302,14302,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,46,'male','L2Pet',40,3108,816,8.69,2.14,40,43,30,21,20,25,0,0,401,245,202,230,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14303,14303,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,54,'male','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14304,14304,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,60,'male','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14305,14305,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,62,'male','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14306,14306,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,64,'male','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14307,14307,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,66,'male','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14308,14308,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,68,'male','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14309,14309,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,70,'male','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14310,14310,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,72,'male','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14311,14311,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,74,'male','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14312,14312,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,76,'male','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14313,14313,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14314,14314,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14315,14315,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14316,14316,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14317,14317,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14318,14318,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14319,14319,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14320,14320,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14321,14321,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14322,14322,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14323,14323,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14324,14324,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14325,14325,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14326,14326,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14327,14327,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14328,14328,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14329,14329,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14330,14330,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14331,14331,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14332,14332,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14333,14333,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14334,14334,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14335,14335,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14336,14336,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14337,14337,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14338,14338,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14339,14339,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14340,14340,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14341,14341,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14342,14342,'Boxer the Unicorn',0,'',0,'Monster.unicorn_boxer',11.00,18.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14343,14343,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,27,'male','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14344,14344,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,37,'male','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14345,14345,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,47,'male','L2Pet',40,3227,851,8.69,2.14,40,43,30,21,20,25,0,0,427,253,216,237,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14346,14346,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,54,'male','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14347,14347,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,22,'male','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14348,14348,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,32,'male','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14349,14349,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,42,'male','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14350,14350,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,50,'male','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14351,14351,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,58,'male','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14352,14352,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,60,'male','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14353,14353,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,62,'male','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14354,14354,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,64,'male','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14355,14355,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,66,'male','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14356,14356,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,68,'male','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14357,14357,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,70,'male','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14358,14358,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,72,'male','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14359,14359,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,74,'male','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14360,14360,'Mirage the Unicorn',0,'',0,'Monster.unicorn_mirage',13.00,17.00,76,'male','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14361,14361,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14362,14362,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14363,14363,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14364,14364,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14365,14365,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14366,14366,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14367,14367,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14368,14368,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14369,14369,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14370,14370,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14371,14371,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14372,14372,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14373,14373,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14374,14374,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14375,14375,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14376,14376,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14377,14377,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14378,14378,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14379,14379,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14380,14380,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14381,14381,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14382,14382,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14383,14383,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14384,14384,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14385,14385,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14386,14386,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14387,14387,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14388,14388,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14389,14389,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14390,14390,'Mirage the Unicorn ',0,'',0,'Monster.unicorn_mirage',13.00,17.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14391,14391,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,42,'male','L2Pet',40,1992,679,8.69,2.14,40,43,30,21,20,25,0,0,342,215,152,202,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14392,14392,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,46,'male','L2Pet',40,2331,816,8.69,2.14,40,43,30,21,20,25,0,0,442,245,202,230,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14393,14393,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,50,'male','L2Pet',40,2694,957,8.69,2.14,40,43,30,21,20,25,0,0,560,278,264,260,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14394,14394,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,54,'male','L2Pet',40,3074,1102,10.27,2.45,40,43,30,21,20,25,0,0,699,313,339,293,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14395,14395,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,58,'male','L2Pet',40,3467,1251,10.27,2.45,40,43,30,21,20,25,0,0,859,349,428,327,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14396,14396,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,60,'male','L2Pet',40,3665,1327,10.27,2.45,40,43,30,21,20,25,0,0,946,368,478,345,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14397,14397,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,62,'male','L2Pet',40,3863,1404,11.85,2.78,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14398,14398,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,64,'male','L2Pet',40,4060,1482,11.85,2.78,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14399,14399,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,66,'male','L2Pet',40,4255,1561,11.85,2.78,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14400,14400,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,68,'male','L2Pet',40,4447,1641,11.85,2.78,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14401,14401,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,70,'male','L2Pet',40,4634,1722,11.85,2.78,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14402,14402,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,72,'male','L2Pet',40,4816,1804,13.43,3.09,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14403,14403,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,74,'male','L2Pet',40,4990,1888,13.43,3.09,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14404,14404,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,76,'male','L2Pet',40,5157,1972,8.69,2.14,40,43,30,21,20,25,0,0,1775,534,994,510,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),
	(14405,14405,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14406,14406,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14407,14407,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14408,14408,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14409,14409,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14410,14410,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14411,14411,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14412,14412,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14413,14413,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14414,14414,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14415,14415,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14416,14416,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14417,14417,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14418,14418,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14419,14419,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14420,14420,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14421,14421,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14422,14422,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14423,14423,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14424,14424,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14425,14425,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14426,14426,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14427,14427,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14428,14428,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14429,14429,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14430,14430,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14431,14431,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14432,14432,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14433,14433,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14434,14434,'Merrow the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14435,14435,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,58,'male','L2Pet',40,2889,1251,10.27,2.45,40,43,30,21,20,25,0,0,313,349,428,327,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14436,14436,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,60,'male','L2Pet',40,3054,1327,10.27,2.45,40,43,30,21,20,25,0,0,340,368,478,345,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14437,14437,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,62,'male','L2Pet',40,3219,1404,11.85,2.78,40,43,30,21,20,25,0,0,368,388,532,363,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14438,14438,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,64,'male','L2Pet',40,3384,1482,11.85,2.78,40,43,30,21,20,25,0,0,397,408,589,382,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14439,14439,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,66,'male','L2Pet',40,3546,1561,11.85,2.78,40,43,30,21,20,25,0,0,427,428,649,401,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14440,14440,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,68,'male','L2Pet',40,3706,1641,11.85,2.78,40,43,30,21,20,25,0,0,457,449,713,421,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14441,14441,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,70,'male','L2Pet',40,3862,1722,11.85,2.78,40,43,30,21,20,25,0,0,487,470,780,440,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14442,14442,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,72,'male','L2Pet',40,4013,1804,13.43,3.09,40,43,30,21,20,25,0,0,517,491,849,460,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14443,14443,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,74,'male','L2Pet',40,4158,1888,13.43,3.09,40,43,30,21,20,25,0,0,547,512,921,480,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14444,14444,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,76,'male','L2Pet',40,4297,1972,13.43,3.09,40,43,30,21,20,25,0,0,577,534,994,500,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14449,14449,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14450,14450,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14451,14451,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14452,14452,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14453,14453,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14454,14454,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14455,14455,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14456,14456,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14457,14457,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,78,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14458,14458,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14459,14459,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14460,14460,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14461,14461,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14462,14462,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14463,14463,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14464,14464,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14465,14465,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14466,14466,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,79,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14467,14467,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14468,14468,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14469,14469,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14470,14470,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14471,14471,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14472,14472,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14473,14473,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14474,14474,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14475,14475,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14476,14476,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14477,14477,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14478,14478,'Unicorn Seraphim',0,'',0,'Monster2.angelic_unicorn',9.00,25.50,80,'male','L2Pet',40,4428,2057,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(14479,14479,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,22,'male','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14480,14480,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,32,'male','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14481,14481,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,42,'male','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14482,14482,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,50,'male','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14483,14483,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,58,'male','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14484,14484,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,27,'male','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14485,14485,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,37,'male','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14486,14486,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,46,'male','L2Pet',40,3108,816,8.69,2.14,40,43,30,21,20,25,0,0,401,245,202,230,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14487,14487,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,54,'male','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14488,14488,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,60,'male','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14489,14489,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,62,'male','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14490,14490,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,64,'male','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14491,14491,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,66,'male','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14492,14492,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,68,'male','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14493,14493,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,70,'male','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14494,14494,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,72,'male','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14495,14495,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,74,'male','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14496,14496,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,76,'male','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14497,14497,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14498,14498,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14499,14499,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14500,14500,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14501,14501,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14502,14502,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14503,14503,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14504,14504,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14505,14505,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,78,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14506,14506,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14507,14507,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14508,14508,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14509,14509,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14510,14510,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14511,14511,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14512,14512,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14513,14513,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14514,14514,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,79,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14515,14515,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14516,14516,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14517,14517,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14518,14518,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14519,14519,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14520,14520,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14521,14521,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14522,14522,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14523,14523,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14524,14524,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14525,14525,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14526,14526,'Shadow',0,'',0,'Monster.shadow',10.00,30.00,80,'male','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14527,14527,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,27,'female','L2Pet',40,1302,367,5.53,1.53,40,43,30,21,20,25,0,0,104,125,45,117,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14528,14528,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,37,'female','L2Pet',40,2142,553,7.11,1.84,40,43,30,21,20,25,0,0,222,182,104,170,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14529,14529,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,47,'female','L2Pet',40,3227,851,8.69,2.14,40,43,30,21,20,25,0,0,427,253,216,237,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14530,14530,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,54,'female','L2Pet',40,4099,1102,10.27,2.45,40,43,30,21,20,25,0,0,636,313,339,293,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14531,14531,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,22,'female','L2Pet',40,978,279,5.53,1.53,40,43,30,21,20,25,0,0,68,102,28,96,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14532,14532,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,32,'female','L2Pet',40,1689,458,7.11,1.84,40,43,30,21,20,25,0,0,154,151,69,142,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14533,14533,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,42,'female','L2Pet',40,2656,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14534,14534,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,50,'female','L2Pet',40,3592,957,8.69,2.14,40,43,30,21,20,25,0,0,509,278,264,260,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14535,14535,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,58,'female','L2Pet',40,4622,1251,10.27,2.45,40,43,30,21,20,25,0,0,781,349,428,327,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14536,14536,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,60,'female','L2Pet',40,4887,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14537,14537,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,62,'female','L2Pet',40,5151,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14538,14538,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,64,'female','L2Pet',40,5414,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14539,14539,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,66,'female','L2Pet',40,5674,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14540,14540,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,68,'female','L2Pet',40,5930,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14541,14541,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,70,'female','L2Pet',40,6179,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14542,14542,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,72,'female','L2Pet',40,6421,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14543,14543,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,74,'female','L2Pet',40,6654,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14544,14544,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,76,'female','L2Pet',40,6876,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14545,14545,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1715,555,1069,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14546,14546,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1081,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14547,14547,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1093,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14548,14548,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1105,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14549,14549,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1117,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14550,14550,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1129,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14551,14551,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1141,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14552,14552,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1153,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14553,14553,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,78,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1165,520,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14554,14554,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1802,558,1192,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14555,14555,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1204,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14556,14556,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1216,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14557,14557,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1228,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14558,14558,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1240,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14559,14559,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1253,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14560,14560,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1265,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14561,14561,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1277,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14562,14562,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,79,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1289,523,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14563,14563,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1891,562,1317,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14564,14564,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1329,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14565,14565,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1342,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14566,14566,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1354,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14567,14567,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1366,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14568,14568,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1379,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14569,14569,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1391,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14570,14570,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1403,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14571,14571,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1416,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14572,14572,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1428,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14573,14573,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1440,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14574,14574,'Silhouette',0,'',0,'Monster.silhouette',8.00,23.00,80,'female','L2Pet',40,7085,2057,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1453,526,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(14575,14575,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,42,'male','L2Pet',40,1992,679,8.69,2.14,40,43,30,21,20,25,0,0,342,215,152,202,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14576,14576,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,46,'male','L2Pet',40,2331,816,8.69,2.14,40,43,30,21,20,25,0,0,442,245,202,230,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14577,14577,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,50,'male','L2Pet',40,2694,957,8.69,2.14,40,43,30,21,20,25,0,0,560,278,264,260,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14578,14578,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,54,'male','L2Pet',40,3074,1102,10.27,2.45,40,43,30,21,20,25,0,0,699,313,339,293,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14579,14579,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,58,'male','L2Pet',40,3467,1251,10.27,2.45,40,43,30,21,20,25,0,0,859,349,428,327,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14580,14580,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,60,'male','L2Pet',40,3665,1327,10.27,2.45,40,43,30,21,20,25,0,0,946,368,478,345,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14581,14581,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,62,'male','L2Pet',40,3863,1404,11.85,2.78,40,43,30,21,20,25,0,0,1038,388,532,363,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14582,14582,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,64,'male','L2Pet',40,4060,1482,11.85,2.78,40,43,30,21,20,25,0,0,1135,408,589,382,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14583,14583,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,66,'male','L2Pet',40,4255,1561,11.85,2.78,40,43,30,21,20,25,0,0,1235,428,649,401,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14584,14584,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,68,'male','L2Pet',40,4447,1641,11.85,2.78,40,43,30,21,20,25,0,0,1339,449,713,421,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14585,14585,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,70,'male','L2Pet',40,4634,1722,11.85,2.78,40,43,30,21,20,25,0,0,1445,470,780,440,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14586,14586,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,72,'male','L2Pet',40,4816,1804,13.43,3.09,40,43,30,21,20,25,0,0,1554,491,849,460,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14587,14587,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,74,'male','L2Pet',40,4990,1888,13.43,3.09,40,43,30,21,20,25,0,0,1664,512,921,480,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14588,14588,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,76,'male','L2Pet',40,5157,1972,8.69,2.14,40,43,30,21,20,25,0,0,1775,534,994,510,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),
	(14589,14589,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1886,555,1069,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14590,14590,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1895,555,1081,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14591,14591,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1905,555,1093,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14592,14592,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1914,555,1105,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14593,14593,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1924,555,1117,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14594,14594,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1933,555,1129,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14595,14595,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1943,555,1141,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14596,14596,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1952,555,1153,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14597,14597,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,78,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1962,555,1165,520,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14598,14598,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1983,558,1192,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14599,14599,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,1992,558,1204,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14600,14600,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2002,558,1216,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14601,14601,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2011,558,1228,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14602,14602,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2021,558,1240,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14603,14603,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2030,558,1253,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14604,14604,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2040,558,1265,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14605,14605,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2049,558,1277,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14606,14606,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,79,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2059,558,1289,523,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14607,14607,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2080,562,1317,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14608,14608,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2090,562,1329,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14609,14609,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2100,562,1342,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14610,14610,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2109,562,1354,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14611,14611,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2119,562,1366,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14612,14612,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2128,562,1379,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14613,14613,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2138,562,1391,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14614,14614,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2147,562,1403,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14615,14615,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2157,562,1416,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14616,14616,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2166,562,1428,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14617,14617,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2176,562,1440,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14618,14618,'Soulless',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Pet',40,5314,2057,13.43,3.09,40,43,30,21,20,25,0,0,2185,562,1453,526,278,0,333,0,0,0,52,209,NULL,0,0,0,'LAST_HIT'),
	(14619,14619,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,58,'male','L2Pet',40,5778,1251,8.69,2.45,40,43,30,21,20,25,0,0,313,349,428,327,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14620,14620,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,60,'male','L2Pet',40,6109,1327,8.69,2.45,40,43,30,21,20,25,0,0,340,368,478,345,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14621,14621,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,62,'male','L2Pet',40,6439,1404,8.69,2.78,40,43,30,21,20,25,0,0,368,388,532,363,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14622,14622,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,64,'male','L2Pet',40,6768,1482,10.27,2.78,40,43,30,21,20,25,0,0,397,408,589,382,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14623,14623,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,66,'male','L2Pet',40,7093,1561,10.27,2.78,40,43,30,21,20,25,0,0,427,428,649,401,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14624,14624,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,68,'male','L2Pet',40,7412,1641,10.27,2.78,40,43,30,21,20,25,0,0,457,449,713,421,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14625,14625,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,70,'male','L2Pet',40,7724,1722,11.85,2.78,40,43,30,21,20,25,0,0,487,470,780,440,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14626,14626,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,72,'male','L2Pet',40,8026,1804,11.85,3.09,40,43,30,21,20,25,0,0,517,491,849,460,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14627,14627,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,74,'male','L2Pet',40,8317,1888,11.85,3.09,40,43,30,21,20,25,0,0,547,512,921,480,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14628,14628,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,76,'male','L2Pet',40,8595,1972,11.85,3.09,40,43,30,21,20,25,0,0,577,534,994,500,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14633,14633,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14634,14634,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14635,14635,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14636,14636,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14637,14637,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14638,14638,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14639,14639,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14640,14640,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14641,14641,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,78,'male','L2Pet',40,8857,2143,13.43,3.09,40,43,30,21,20,25,0,0,595,555,1069,520,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14642,14642,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14643,14643,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14644,14644,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14645,14645,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14646,14646,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14647,14647,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14648,14648,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14649,14649,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14650,14650,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,79,'male','L2Pet',40,8981,2143,13.43,3.09,40,43,30,21,20,25,0,0,598,558,1082,523,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14651,14651,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14652,14652,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14653,14653,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14654,14654,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14655,14655,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14656,14656,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14657,14657,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14658,14658,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14659,14659,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14660,14660,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14661,14661,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14662,14662,'Nightshade',0,'',0,'Monster2.knight_of_shadow',10.00,35.50,80,'male','L2Pet',40,9101,2143,13.43,3.09,40,43,30,21,20,25,0,0,602,562,1095,526,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(14663,14663,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,30,'male','L2Pet',40,1049,421,5.53,1.53,40,43,30,21,20,25,0,0,132,140,58,132,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14664,14664,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,38,'male','L2Pet',40,1540,573,7.11,1.84,40,43,30,21,20,25,0,0,238,188,112,176,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14665,14665,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,45,'male','L2Pet',40,2057,781,8.69,2.14,40,43,30,21,20,25,0,0,377,238,188,223,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14666,14666,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,51,'male','L2Pet',40,2555,993,10.27,2.45,40,43,30,21,20,25,0,0,539,286,281,268,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14667,14667,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,57,'male','L2Pet',40,3087,1213,10.27,2.45,40,43,30,21,20,25,0,0,743,340,405,318,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14668,14668,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,62,'male','L2Pet',40,3541,1404,11.85,2.78,40,43,30,21,20,25,0,0,944,388,532,363,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14669,14669,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,66,'male','L2Pet',40,3901,1561,11.85,2.78,40,43,30,21,20,25,0,0,1123,428,649,401,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14670,14670,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,70,'male','L2Pet',40,4248,1722,11.85,2.78,40,43,30,21,20,25,0,0,1314,470,780,440,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14671,14671,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,74,'male','L2Pet',40,4574,1888,13.43,3.09,40,43,30,21,20,25,0,0,1513,512,921,480,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14672,14672,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14673,14673,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14674,14674,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Npc',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14675,14675,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14676,14676,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14677,14677,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14678,14678,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14679,14679,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14680,14680,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14681,14681,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14682,14682,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14683,14683,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14684,14684,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14685,14685,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14686,14686,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14687,14687,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14688,14688,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14689,14689,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14690,14690,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14691,14691,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14692,14692,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14693,14693,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14694,14694,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14695,14695,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14696,14696,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14697,14697,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14698,14698,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14699,14699,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14700,14700,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14701,14701,'Mechanic Golem',0,'',0,'Monster.mechanic_golem',5.00,19.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,333,0,0,0,33,165,NULL,0,0,0,'LAST_HIT'),
	(14702,14702,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,60,'male','L2Pet',40,3054,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14703,14703,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,64,'male','L2Pet',40,3054,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14704,14704,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,68,'male','L2Pet',40,3384,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14705,14705,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,72,'male','L2Pet',40,3706,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14706,14706,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,76,'male','L2Pet',40,4013,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14707,14707,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14708,14708,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14709,14709,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14710,14710,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14711,14711,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14712,14712,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14713,14713,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14714,14714,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14715,14715,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,78,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1793,553,1118,533,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14716,14716,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14717,14717,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14718,14718,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14719,14719,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14720,14720,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14721,14721,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14722,14722,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14723,14723,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14724,14724,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1803,556,1131,537,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14725,14725,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14726,14726,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14727,14727,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14728,14728,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14729,14729,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14730,14730,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14731,14731,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14732,14732,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14733,14733,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14734,14734,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14735,14735,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14736,14736,'Big Boom',0,'',0,'Monster.big_boom',6.00,13.00,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,1814,559,1144,540,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(14737,14737,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,55,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,2592,1205,360,1242,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14738,14738,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3036,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14739,14739,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3066,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14740,14740,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3096,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14741,14741,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3126,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14742,14742,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3156,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14743,14743,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3186,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14744,14744,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3216,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14745,14745,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3246,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14746,14746,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,78,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3276,1397,484,1440,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14747,14747,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3326,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14748,14748,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3356,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14749,14749,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3386,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14750,14750,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3417,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14751,14751,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3447,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14752,14752,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3477,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14753,14753,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3507,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14754,14754,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3538,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14755,14755,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,79,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3568,1406,490,1449,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14756,14756,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3619,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14757,14757,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3650,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14758,14758,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3680,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14759,14759,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3711,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14760,14760,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3741,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14761,14761,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3772,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14762,14762,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3802,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14763,14763,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3832,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14764,14764,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3863,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14765,14765,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3893,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14766,14766,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3924,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14767,14767,'Siege Golem',0,'',0,'Monster.siege_golem',60.00,140.00,80,'male','L2SiegeSummon',80,790000,1138,10.27,2.45,40,43,30,21,20,25,0,0,3954,1414,496,1457,165,0,333,0,0,0,44,44,NULL,0,1,0,'LAST_HIT'),
	(14768,14768,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,60,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,888,709,478,730,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14769,14769,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1012,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14770,14770,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1022,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14771,14771,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1032,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14772,14772,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1042,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14773,14773,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1052,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14774,14774,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1062,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14775,14775,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1072,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14776,14776,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1082,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14777,14777,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,78,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1092,794,601,818,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14778,14778,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1108,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14779,14779,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1118,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14780,14780,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1128,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14781,14781,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1139,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14782,14782,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1149,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14783,14783,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1159,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14784,14784,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1169,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14785,14785,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1179,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14786,14786,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,79,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1189,799,608,823,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14787,14787,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1206,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14788,14788,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1216,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14789,14789,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1226,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14790,14790,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1237,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14791,14791,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1247,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14792,14792,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1257,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14793,14793,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1267,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14794,14794,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1277,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14795,14795,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1287,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14796,14796,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1297,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14797,14797,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1308,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14798,14798,'Wild Hog Cannon',0,'',0,'Monster.range_golem',93.00,90.00,80,'male','L2SiegeSummon',40,3153,1327,10.27,2.45,40,43,30,21,20,25,0,0,1318,804,615,828,278,0,333,0,0,0,11,11,NULL,0,1,0,'LAST_HIT'),
	(14799,14799,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,42,'male','L2Pet',40,1826,679,8.69,2.14,40,43,30,21,20,25,0,0,311,215,152,202,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14800,14800,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,51,'male','L2Pet',40,2555,993,10.27,2.45,40,43,30,21,20,25,0,0,539,286,281,268,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14801,14801,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,60,'male','L2Pet',40,3359,1327,10.27,2.45,40,43,30,21,20,25,0,0,860,368,478,345,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14802,14802,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,64,'male','L2Pet',40,3722,1482,11.85,2.78,40,43,30,21,20,25,0,0,1031,408,589,382,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14803,14803,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,68,'male','L2Pet',40,4076,1641,11.85,2.78,40,43,30,21,20,25,0,0,1217,449,713,421,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14804,14804,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,72,'male','L2Pet',40,4414,1804,13.43,3.09,40,43,30,21,20,25,0,0,1413,491,849,460,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14805,14805,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,76,'male','L2Pet',40,4727,1972,13.43,3.09,40,43,30,21,20,25,0,0,1614,534,994,500,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14806,14806,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1723,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14807,14807,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1732,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14808,14808,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1740,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14809,14809,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1749,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14810,14810,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1757,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14811,14811,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1766,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14812,14812,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1775,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14813,14813,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1783,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14814,14814,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,78,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1792,555,1069,520,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14815,14815,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1811,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14816,14816,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1820,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14817,14817,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1828,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14818,14818,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1837,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14819,14819,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1846,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14820,14820,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1854,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14821,14821,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1863,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14822,14822,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1871,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14823,14823,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,79,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1880,558,1082,523,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14824,14824,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1900,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14825,14825,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1909,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14826,14826,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1917,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14827,14827,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1926,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14828,14828,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1935,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14829,14829,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1943,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14830,14830,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1952,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14831,14831,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1961,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14832,14832,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1969,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14833,14833,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1978,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14834,14834,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1987,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14835,14835,'Dark Panther',0,'',0,'Monster.dark_fencer',7.00,13.00,80,'male','L2Pet',40,5025,2143,13.43,3.09,40,43,30,21,20,25,0,0,1995,562,1095,526,278,0,333,0,0,0,27,165,NULL,0,0,0,'LAST_HIT'),
	(14836,14836,'Feline King',0,'',0,'Monster3.king_of_cat',6.00,16.01,80,'male','L2Pet',40,5461,2143,13.43,3.09,40,43,30,21,20,25,0,0,2606,795,1662,840,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),-- needs hp/atk/def buff effects removed
	(14837,14837,'Magnus the Unicorn',0,'',0,'Monster3.unicorn_magnus',13.50,17.00,80,'male','L2Pet',40,5461,2143,13.43,3.09,40,43,30,21,20,25,0,0,2369,795,3510,840,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),-- needs hp/atk/def buff effects removed
	(14838,14838,'Spectral Lord',0,'',0,'Monster3.spectral_knight',12.50,33.50,80,'male','L2Pet',40,4550,2143,13.43,3.09,40,43,30,21,20,25,0,0,2647,437,1671,490,278,0,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),
	(14839,14839,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,68,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14840,14840,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,69,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14841,14841,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,70,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14842,14842,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,71,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14843,14843,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,72,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14844,14844,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,73,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14845,14845,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,74,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14846,14846,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,75,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14847,14847,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,76,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14848,14848,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,77,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14849,14849,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,78,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14850,14850,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,79,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14851,14851,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,80,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14852,14852,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,81,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14853,14853,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,82,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14854,14854,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,83,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14855,14855,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,84,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14856,14856,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,85,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14857,14857,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,86,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14858,14858,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,87,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14859,14859,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,88,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14860,14860,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,89,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14861,14861,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,90,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14862,14862,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,91,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14863,14863,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,92,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14864,14864,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,93,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14865,14865,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,94,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14866,14866,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,95,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14867,14867,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,96,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14868,14868,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,97,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(14869,14869,'Swoop Cannon',0,'',0,'Monster3.toad_cannon',45.00,47.50,98,'male','L2SiegeSummon',40,79000,1138,11.85,2.78,40,43,30,21,20,25,0,0,22,1314,428,1354,165,0,333,0,0,0,44,44,NULL,0,0,0,'LAST_HIT'),-- to be confirmed
	(16013,16013,'Trained Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,67,'male','L2TamedBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,333,0,0,0,22,187,'pet_clan',400,0,0,'LAST_HIT'),
	(16014,16014,'Trained Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,67,'male','L2TamedBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,0,0,1169,439,681,356,278,0,333,0,0,0,22,187,'pet_clan',400,0,0,'LAST_HIT'),
	(16015,16015,'Trained Cougar',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,69,'male','L2TamedBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,333,0,0,0,66,192,'pet_clan',400,0,0,'LAST_HIT'),
	(16016,16016,'Trained Cougar',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,69,'male','L2TamedBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,0,0,1265,460,746,373,278,0,333,0,0,0,66,192,'pet_clan',400,0,0,'LAST_HIT'),
	(16017,16017,'Trained Kookaburra',0,'',0,'Monster2.pet_ostrich',10.00,33.00,65,'male','L2TamedBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,25,209,'pet_clan',400,0,0,'LAST_HIT'),
	(16018,16018,'Trained Kookaburra',0,'',0,'Monster2.pet_ostrich',10.00,33.00,65,'male','L2TamedBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,25,209,'pet_clan',400,0,0,'LAST_HIT'),
	(16019,16019,'Tiny Baby Buffalo',0,'',0,'Monster2.baby_buffalo',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(16020,16020,'Tame Tiny Baby Buffalo',0,'',0,'Monster2.baby_buffalo',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(16021,16021,'Tiny Baby Cougar',0,'',0,'Monster2.baby_tiger',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(16022,16022,'Tame Tiny Baby Cougar',0,'',0,'Monster2.baby_tiger',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(16023,16023,'Tiny Baby Kookaburra',0,'',0,'Monster2.baby_ostrich',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(16024,16024,'Tame Tiny Baby Kookaburra',0,'',0,'Monster2.baby_ostrich',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(18001,18001,'Blood Queen',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,333,0,0,0,88,176,'cave_servant_clan',400,0,0,'LAST_HIT'),
	(18002,18002,'Blood Queen',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,4320,375,946,368,478,299,282,500,333,0,0,0,88,176,'cave_servant_clan',300,0,0,'LAST_HIT'),
	(18003,18003,'Bearded Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,4,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(18004,18004,'Susceptor Prime',0,'',0,'Monster.susceptor_prime',45.00,72.00,49,'male','L2Monster',50,2168,799,8.69,2.14,40,43,30,21,20,10,0,1,480,270,247,219,282,0,333,0,0,0,85,187,NULL,0,0,0,'LAST_HIT'),
	(18005,18005,'Mimic',0,'',0,'Monster.mimic',8.50,8.50,52,'male','L2Monster',40,2479,892,10.27,2.45,40,43,30,21,20,10,3244,251,588,304,300,239,278,0,333,0,0,0,88,171,NULL,0,0,0,'LAST_HIT'),
	(18006,18006,'Maruk Lord',0,'',0,'Monster.death_blader',15.00,45.00,68,'male','L2Monster',40,3825,1423,11.85,2.78,40,43,30,21,20,10,6057,586,1256,464,713,365,278,500,333,1472,0,0,110,187,'malruk_clan',300,1,0,'LAST_HIT'),
	(18007,18007,'Limal Karinness',0,'',0,'Monster.bloody_queen',14.00,40.00,69,'female','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,5951,582,1392,460,821,373,278,500,333,0,0,0,88,154,'malruk_clan',300,0,0,'LAST_HIT'),
	(18008,18008,'Karik',0,'',0,'Monster.karik',25.00,90.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,6370,632,1445,470,858,382,278,500,333,0,0,0,40,220,NULL,0,0,0,'LAST_HIT'),
	(18009,18009,'Offering of Branded Elder',0,'',0,'Monster.orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1754,102,178,163,82,132,278,0,333,127,0,0,49,33,'mercenary_siege_clan',500,0,0,'LAST_HIT'),
	(18010,18010,'Offering of the Branded',0,'',0,'Monster.orc',10.00,21.00,32,'male','L2FestivalMonster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1523,86,134,129,69,123,237,0,333,218,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18011,18011,'Offering of Branded Archer',0,'',0,'Monster.orc_archer',14.00,25.00,28,'male','L2FestivalMonster',500,859,334,5.53,1.53,40,43,30,21,20,10,1001,53,251,110,49,106,249,0,333,14,0,0,49,66,NULL,0,0,0,'LAST_HIT'),
	(18012,18012,'Offering of Branded Warrior',0,'',0,'Monster.orc_champion',10.00,23.00,29,'male','L2FestivalMonster',40,906,349,5.53,1.53,40,43,30,21,20,10,1026,55,122,135,53,110,278,0,333,125,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(18013,18013,'Offering of Branded Follower',0,'',0,'Monster.orc_shaman',9.00,22.00,29,'male','L2FestivalMonster',40,906,349,5.53,1.53,40,43,30,21,20,10,1227,66,107,115,53,110,237,0,333,316,0,0,49,165,NULL,0,0,0,'LAST_HIT'),
	(18014,18014,'Offering of Branded Berserker',0,'',0,'Monster.virud_lizardman',10.00,23.00,37,'male','L2FestivalMonster',40,1338,480,7.11,1.84,40,43,30,21,20,10,2276,140,222,182,104,147,278,0,333,292,0,0,47,126,NULL,0,0,0,'LAST_HIT'),
	(18015,18015,'Offering of Branded Zealot',0,'',0,'Monster.orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1650,96,156,138,82,132,237,0,333,158,0,0,49,170,NULL,0,0,0,'LAST_HIT'),
	(18016,18016,'Offering of Branded Marksman',0,'',0,'Monster.orc_archer_20_bi',16.00,30.00,32,'male','L2FestivalMonster',500,1056,397,7.11,1.84,40,43,30,21,20,10,1265,71,342,129,69,123,249,0,333,273,0,0,49,143,NULL,0,0,0,'LAST_HIT'),
	(18017,18017,'Offering of Branded Disciple',0,'',0,'Monster.batur_orc',9.00,21.50,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1650,96,178,163,82,132,278,0,333,129,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18018,18018,'Offering of Branded Saint',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,39,'male','L2FestivalMonster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2171,138,255,195,121,158,278,0,333,72,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18019,18019,'Apostate''s Offering Elder',0,'',0,'Monster.orc_champion_20_bi',12.00,27.60,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3013,210,377,238,188,193,278,0,333,72,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18020,18020,'Apostate''s Offering ',0,'',0,'Monster.orc_fighter',12.00,22.00,43,'male','L2FestivalMonster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2751,186,291,189,163,181,237,0,333,223,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18021,18021,'Apostate''s Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,39,'male','L2FestivalMonster',500,1462,514,7.11,1.84,40,43,30,21,20,10,1879,119,566,165,121,158,249,0,333,275,0,0,49,66,NULL,0,0,0,'LAST_HIT'),
	(18022,18022,'Apostate''s Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,40,'male','L2FestivalMonster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1920,124,273,201,131,164,278,0,333,127,0,0,88,126,NULL,0,0,0,'LAST_HIT'),
	(18023,18023,'Apostate''s Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,40,'male','L2FestivalMonster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2296,148,238,171,131,164,237,0,333,316,0,0,55,170,NULL,0,0,0,'LAST_HIT'),
	(18024,18024,'Apostate''s Offering Berserker',0,'',0,'Monster.zenta_lizardman',11.00,32.00,48,'male','L2FestivalMonster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3832,280,453,261,231,212,278,0,333,297,0,0,40,132,NULL,0,0,0,'LAST_HIT'),
	(18025,18025,'Apostate''s Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2891,201,330,202,188,193,237,0,333,172,0,0,88,176,NULL,0,0,0,'LAST_HIT'),
	(18026,18026,'Apostate''s Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,43,'male','L2FestivalMonster',500,1728,618,8.69,2.14,40,43,30,21,20,10,2285,154,739,189,163,181,249,0,333,277,0,0,49,148,NULL,0,0,0,'LAST_HIT'),
	(18027,18027,'Apostate''s Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2891,201,377,238,188,193,278,0,333,74,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18028,18028,'Apostate''s Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,50,'male','L2FestivalMonster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3570,269,509,278,264,226,278,0,333,133,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18029,18029,'Witch''s Offering Elder',0,'',0,'Monster.batur_orc_warrior_20_bi',12.00,24.00,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4666,383,706,331,382,269,278,0,333,133,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18030,18030,'Witch''s Offering',0,'',0,'Monster.batur_orc',9.00,21.50,54,'male','L2FestivalMonster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4339,346,556,266,339,254,237,0,333,226,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18031,18031,'Witch''s Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,50,'male','L2FestivalMonster',500,2245,830,8.69,2.14,40,43,30,21,20,10,3090,233,1132,236,264,226,249,0,333,278,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18032,18032,'Witch''s Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,51,'male','L2FestivalMonster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,333,72,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18033,18033,'Witch''s Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,51,'male','L2FestivalMonster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3732,285,472,243,281,232,237,0,333,316,0,0,55,176,NULL,0,0,0,'LAST_HIT'),
	(18034,18034,'Witch''s Offering Berserker',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,59,'male','L2FestivalMonster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,5789,495,820,359,453,291,278,0,333,301,0,0,57,137,NULL,0,0,0,'LAST_HIT'),
	(18035,18035,'Witch''s Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4478,368,618,281,382,269,237,0,333,91,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18036,18036,'Witch''s Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,54,'male','L2FestivalMonster',500,2562,955,10.27,2.45,40,43,30,21,20,10,3604,287,1413,266,339,254,249,0,333,282,0,0,49,154,NULL,0,0,0,'LAST_HIT'),
	(18037,18037,'Witch''s Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4478,368,706,331,382,269,278,0,333,135,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18038,18038,'Witch''s Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,61,'male','L2FestivalMonster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,5313,468,901,378,505,307,278,0,333,79,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18039,18039,'Dark Omen Offering Elder',0,'',0,'Monster.batur_orc_warrior_20_bi',12.00,24.00,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6679,636,1169,439,681,356,278,0,333,79,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18040,18040,'Dark Omen Offering',0,'',0,'Monster.batur_orc',9.00,21.50,65,'male','L2FestivalMonster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6286,584,942,355,619,340,237,0,333,234,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18041,18041,'Dark Omen Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,61,'male','L2FestivalMonster',500,3137,1184,11.85,2.78,40,43,30,21,20,10,4599,405,2004,321,505,307,249,0,333,283,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18042,18042,'Dark Omen Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,62,'male','L2FestivalMonster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,4612,411,944,388,532,315,278,0,333,133,0,0,88,137,NULL,0,0,0,'LAST_HIT'),
	(18043,18043,'Dark Omen Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,62,'male','L2FestivalMonster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,5516,492,826,330,532,315,237,0,333,316,0,0,55,181,NULL,0,0,0,'LAST_HIT'),
	(18044,18044,'Dark Omen Offering Berserker',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,70,'male','L2FestivalMonster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,8149,808,1314,470,780,382,278,0,333,97,0,0,57,143,NULL,0,0,0,'LAST_HIT'),
	(18045,18045,'Dark Omen Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6410,610,1023,373,681,356,237,0,333,2503,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18046,18046,'Dark Omen Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,65,'male','L2FestivalMonster',500,3465,1319,11.85,2.78,40,43,30,21,20,10,5222,485,2393,355,619,340,249,0,333,286,0,0,49,159,NULL,0,0,0,'LAST_HIT'),
	(18047,18047,'Dark Omen Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6410,610,1169,439,681,356,278,0,333,142,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(18048,18048,'Dark Omen Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,72,'male','L2FestivalMonster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,7402,752,1413,491,849,399,278,0,333,2500,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(18049,18049,'Offering of Forbidden Path Elder',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,0,333,2500,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18050,18050,'Offering of Forbidden Path',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,76,'male','L2FestivalMonster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,8594,919,1412,454,994,433,237,0,333,236,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18051,18051,'Offering of Forbidden Path Archer',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,80,'male','L2FestivalMonster',500,4663,1934,13.43,3.09,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,0,333,287,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18052,18052,'Offering of Forbidden Path Warrior',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,80,'male','L2FestivalMonster',40,4550,1859,13.43,3.09,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,0,333,79,0,0,39,143,NULL,0,0,0,'LAST_HIT'),
	(18053,18053,'Offering of Forbidden Path Follower',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2FestivalMonster',40,4550,1859,13.43,3.09,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,0,333,316,0,0,11,198,NULL,0,0,0,'LAST_HIT'),
	(18054,18054,'Offering of Forbidden Path Berserker',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,81,'male','L2FestivalMonster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,0,333,305,0,0,44,148,NULL,0,0,0,'LAST_HIT'),
	(18055,18055,'Offering of Forbidden Path Zealot',0,'',0,'Monster.ketra_orc_20_bi',14.00,34.80,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,0,333,175,0,0,49,214,NULL,0,0,0,'LAST_HIT'),
	(18056,18056,'Offering of Forbidden Path Marksman',0,'',0,'Monster.ketra_orc_archer_20_bi',14.00,32.40,76,'male','L2FestivalMonster',500,4297,1710,13.43,3.09,40,43,30,21,20,10,7139,763,3587,454,994,433,249,0,333,289,0,0,49,165,NULL,0,0,0,'LAST_HIT'),
	(18057,18057,'Offering of Forbidden Path Disciple',0,'',0,'Monster.ketra_orc_overload',12.00,24.00,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,0,333,151,0,0,36,214,NULL,0,0,0,'LAST_HIT'),
	(18058,18058,'Offering of Forbidden Path Saint',0,'',0,'Monster.ketra_orc_overload_20_bi',14.00,28.80,80,'male','L2FestivalMonster',40,4716,1972,13.43,3.09,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,0,333,2500,0,0,36,214,NULL,0,0,0,'LAST_HIT'),
	(18059,18059,'Offering of Branded Elder',0,'',0,'Monster.orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1720,100,178,163,82,132,278,0,333,127,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18060,18060,'Offering of the Branded',0,'',0,'Monster.orc',10.00,21.00,32,'male','L2FestivalMonster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1523,86,134,129,69,123,237,0,333,218,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18061,18061,'Offering of Branded Archer',0,'',0,'Monster.orc_archer',14.00,25.00,28,'male','L2FestivalMonster',500,859,334,5.53,1.53,40,43,30,21,20,10,1001,53,251,110,49,106,249,0,333,14,0,0,49,66,NULL,0,0,0,'LAST_HIT'),
	(18062,18062,'Offering of Branded Warrior',0,'',0,'Monster.orc_champion',10.00,23.00,29,'male','L2FestivalMonster',40,906,349,5.53,1.53,40,43,30,21,20,10,1026,55,122,135,53,110,278,0,333,125,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(18063,18063,'Offering of Branded Follower',0,'',0,'Monster.orc_shaman',9.00,22.00,29,'male','L2FestivalMonster',40,906,349,5.53,1.53,40,43,30,21,20,10,1227,66,107,115,53,110,237,0,333,316,0,0,49,165,NULL,0,0,0,'LAST_HIT'),
	(18064,18064,'Offering of Branded Berserker',0,'',0,'Monster.virud_lizardman',10.00,23.00,37,'male','L2FestivalMonster',40,1338,480,7.11,1.84,40,43,30,21,20,10,2276,140,222,182,104,147,278,0,333,292,0,0,47,126,NULL,0,0,0,'LAST_HIT'),
	(18065,18065,'Offering of Branded Zealot',0,'',0,'Monster.orc_fighter_bi',12.00,26.40,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1650,96,156,138,82,132,237,0,333,158,0,0,49,170,NULL,0,0,0,'LAST_HIT'),
	(18066,18066,'Offering of Branded Marksman',0,'',0,'Monster.orc_archer_20_bi',16.00,30.00,32,'male','L2FestivalMonster',500,1056,397,7.11,1.84,40,43,30,21,20,10,1265,71,342,129,69,123,249,0,333,273,0,0,49,143,NULL,0,0,0,'LAST_HIT'),
	(18067,18067,'Offering of Branded Disciple',0,'',0,'Monster.batur_orc',9.00,21.50,34,'male','L2FestivalMonster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1650,96,178,163,82,132,278,0,333,129,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18068,18068,'Offering of Branded Saint',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,39,'male','L2FestivalMonster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2171,138,255,195,121,158,278,0,333,72,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18069,18069,'Apostate''s Offering Elder',0,'',0,'Monster.orc_champion_20_bi',12.00,27.60,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3013,210,377,238,188,193,278,0,333,72,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18070,18070,'Apostate''s Offering ',0,'',0,'Monster.orc_fighter',12.00,22.00,43,'male','L2FestivalMonster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2751,186,291,189,163,181,237,0,333,223,0,0,49,33,NULL,0,0,0,'LAST_HIT'),
	(18071,18071,'Apostate''s Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,39,'male','L2FestivalMonster',500,1462,514,7.11,1.84,40,43,30,21,20,10,1879,119,566,165,121,158,249,0,333,275,0,0,49,66,NULL,0,0,0,'LAST_HIT'),
	(18072,18072,'Apostate''s Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,40,'male','L2FestivalMonster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1920,124,273,201,131,164,278,0,333,127,0,0,88,126,NULL,0,0,0,'LAST_HIT'),
	(18073,18073,'Apostate''s Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,40,'male','L2FestivalMonster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2296,148,238,171,131,164,237,0,333,316,0,0,55,170,NULL,0,0,0,'LAST_HIT'),
	(18074,18074,'Apostate''s Offering Berserker',0,'',0,'Monster.zenta_lizardman',11.00,32.00,48,'male','L2FestivalMonster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3832,280,453,261,231,212,278,0,333,297,0,0,40,132,NULL,0,0,0,'LAST_HIT'),
	(18075,18075,'Apostate''s Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2891,201,330,202,188,193,237,0,333,172,0,0,88,176,NULL,0,0,0,'LAST_HIT'),
	(18076,18076,'Apostate''s Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,43,'male','L2FestivalMonster',500,1728,618,8.69,2.14,40,43,30,21,20,10,2285,154,739,189,163,181,249,0,333,277,0,0,49,148,NULL,0,0,0,'LAST_HIT'),
	(18077,18077,'Apostate''s Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,45,'male','L2FestivalMonster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2891,201,377,238,188,193,278,0,333,74,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18078,18078,'Apostate''s Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,50,'male','L2FestivalMonster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3570,269,509,278,264,226,278,0,333,133,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18079,18079,'Witch''s Offering Elder',0,'',0,'Monster.batur_orc_warrior_20_bi',12.00,24.00,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4666,383,706,331,382,269,278,0,333,133,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18080,18080,'Witch''s Offering',0,'',0,'Monster.batur_orc',9.00,21.50,54,'male','L2FestivalMonster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4339,346,556,266,339,254,237,0,333,226,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18081,18081,'Witch''s Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,50,'male','L2FestivalMonster',500,2245,830,8.69,2.14,40,43,30,21,20,10,3090,233,1132,236,264,226,249,0,333,278,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18082,18082,'Witch''s Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,51,'male','L2FestivalMonster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,333,72,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18083,18083,'Witch''s Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,51,'male','L2FestivalMonster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3732,285,472,243,281,232,237,0,333,316,0,0,55,176,NULL,0,0,0,'LAST_HIT'),
	(18084,18084,'Witch''s Offering Berserker',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,59,'male','L2FestivalMonster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,5789,495,820,359,453,291,278,0,333,301,0,0,57,137,NULL,0,0,0,'LAST_HIT'),
	(18085,18085,'Witch''s Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4478,368,618,281,382,269,237,0,333,91,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18086,18086,'Witch''s Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,54,'male','L2FestivalMonster',500,2562,955,10.27,2.45,40,43,30,21,20,10,3604,287,1413,266,339,254,249,0,333,282,0,0,49,154,NULL,0,0,0,'LAST_HIT'),
	(18087,18087,'Witch''s Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,56,'male','L2FestivalMonster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4478,368,706,331,382,269,278,0,333,135,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18088,18088,'Witch''s Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,61,'male','L2FestivalMonster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,5313,468,901,378,505,307,278,0,333,79,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18089,18089,'Dark Omen Offering Elder',0,'',0,'Monster.batur_orc_warrior_20_bi',12.00,24.00,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6679,636,1169,439,681,356,278,0,333,79,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18090,18090,'Dark Omen Offering',0,'',0,'Monster.batur_orc',9.00,21.50,65,'male','L2FestivalMonster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6286,584,942,355,619,340,237,0,333,234,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18091,18091,'Dark Omen Offering Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,61,'male','L2FestivalMonster',500,3137,1184,11.85,2.78,40,43,30,21,20,10,4599,405,2004,321,505,307,249,0,333,283,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18092,18092,'Dark Omen Offering Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,62,'male','L2FestivalMonster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,4612,411,944,388,532,315,278,0,333,133,0,0,88,137,NULL,0,0,0,'LAST_HIT'),
	(18093,18093,'Dark Omen Offering Follower',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,62,'male','L2FestivalMonster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,5516,492,826,330,532,315,237,0,333,316,0,0,55,181,NULL,0,0,0,'LAST_HIT'),
	(18094,18094,'Dark Omen Offering Berserker',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,70,'male','L2FestivalMonster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,8149,808,1314,470,780,382,278,0,333,97,0,0,57,143,NULL,0,0,0,'LAST_HIT'),
	(18095,18095,'Dark Omen Offering Zealot',0,'',0,'Monster.batur_orc_20_bi',10.00,25.30,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6410,610,1023,373,681,356,237,0,333,2503,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18096,18096,'Dark Omen Offering Marksman',0,'',0,'Monster.batur_orc_archer_20_bi',13.00,25.30,65,'male','L2FestivalMonster',500,3465,1319,11.85,2.78,40,43,30,21,20,10,5222,485,2393,355,619,340,249,0,333,286,0,0,49,159,NULL,0,0,0,'LAST_HIT'),
	(18097,18097,'Dark Omen Offering Disciple',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,67,'male','L2FestivalMonster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6410,610,1169,439,681,356,278,0,333,142,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(18098,18098,'Dark Omen Offering Saint',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,72,'male','L2FestivalMonster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,7402,752,1413,491,849,399,278,0,333,2500,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(18099,18099,'Offering of Forbidden Path Elder',0,'',0,'Monster.batur_orc_overlord_20_bi',14.00,28.80,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,9052,991,1715,555,1069,451,278,0,333,2500,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18100,18100,'Offering of Forbidden Path',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,76,'male','L2FestivalMonster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,8594,919,1412,454,994,433,237,0,333,236,0,0,88,33,NULL,0,0,0,'LAST_HIT'),
	(18101,18101,'Offering of Forbidden Path Archer',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,80,'male','L2FestivalMonster',500,4663,1934,13.43,3.09,40,43,30,21,20,10,8310,955,4248,508,1220,485,249,0,333,287,0,0,49,77,NULL,0,0,0,'LAST_HIT'),
	(18102,18102,'Offering of Forbidden Path Warrior',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,80,'male','L2FestivalMonster',40,4550,1859,13.43,3.09,40,43,30,21,20,10,7680,862,1814,576,1144,468,278,0,333,79,0,0,39,143,NULL,0,0,0,'LAST_HIT'),
	(18103,18103,'Offering of Forbidden Path Follower',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2FestivalMonster',40,4550,1859,13.43,3.09,40,43,30,21,20,10,9185,1031,1587,490,1144,468,237,0,333,316,0,0,11,198,NULL,0,0,0,'LAST_HIT'),
	(18104,18104,'Offering of Forbidden Path Berserker',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,80,'male','L2FestivalMonster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,10912,1239,1863,587,1182,477,278,0,333,305,0,0,44,148,NULL,0,0,0,'LAST_HIT'),
	(18105,18105,'Offering of Forbidden Path Zealot',0,'',0,'Monster.ketra_orc_20_bi',14.00,34.80,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,8687,951,1500,472,1069,451,237,0,333,175,0,0,49,214,NULL,0,0,0,'LAST_HIT'),
	(18106,18106,'Offering of Forbidden Path Marksman',0,'',0,'Monster.ketra_orc_archer_20_bi',14.00,32.40,76,'male','L2FestivalMonster',500,4297,1710,13.43,3.09,40,43,30,21,20,10,7139,763,3587,454,994,433,249,0,333,289,0,0,49,165,NULL,0,0,0,'LAST_HIT'),
	(18107,18107,'Offering of Forbidden Path Disciple',0,'',0,'Monster.ketra_orc_overload',12.00,24.00,78,'male','L2FestivalMonster',40,4428,1784,13.43,3.09,40,43,30,21,20,10,8687,951,1715,555,1069,451,278,0,333,151,0,0,36,214,NULL,0,0,0,'LAST_HIT'),
	(18108,18108,'Offering of Forbidden Path Saint',0,'',0,'Monster.ketra_orc_overload_20_bi',14.00,28.80,83,'male','L2FestivalMonster',40,4716,1972,13.43,3.09,40,43,30,21,20,10,9837,1144,1959,608,1258,494,278,0,333,2500,0,0,36,214,NULL,0,0,0,'LAST_HIT'),
	(18109,18109,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,30,'male','L2FestivalMonster',0,999,365,5.53,1.53,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18110,18110,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,41,'male','L2FestivalMonster',0,1488,560,8.69,2.14,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18111,18111,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,52,'male','L2FestivalMonster',0,2058,892,10.27,2.45,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18112,18112,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,63,'male','L2FestivalMonster',0,2640,1251,11.85,2.78,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18113,18113,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,72,'male','L2FestivalMonster',0,3063,1565,13.43,3.09,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18114,18114,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,30,'male','L2FestivalMonster',0,999,365,5.53,1.53,40,43,30,21,20,10,90,0,0,140,0,114,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18115,18115,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,41,'male','L2FestivalMonster',0,1488,560,8.69,2.14,40,43,30,21,20,10,168,0,0,208,0,169,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18116,18116,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,52,'male','L2FestivalMonster',0,2058,892,10.27,2.45,40,43,30,21,20,10,270,0,0,295,0,239,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18117,18117,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,63,'male','L2FestivalMonster',0,2640,1251,11.85,2.78,40,43,30,21,20,10,396,0,0,398,0,323,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18118,18118,'Treasures of the Festival',0,'',0,'Monster.mimic',8.50,8.50,72,'male','L2FestivalMonster',0,3063,1565,13.43,3.09,40,43,30,21,20,10,518,0,0,491,0,399,0,0,0,0,0,0,88,214,NULL,0,0,0,'LAST_HIT'),
	(18119,18119,'Corpse of Deadman',0,'',0,'Monster.zombie_corpse',13.00,21.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,0,0,987,398,560,323,278,0,333,0,0,0,16,0,NULL,0,1,0,'LAST_HIT'),
	(18120,18120,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18121,18121,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18122,18122,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18123,18123,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18124,18124,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18125,18125,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18126,18126,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18127,18127,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18128,18128,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18129,18129,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9764,1108,2255,534,1731,433,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18130,18130,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9260,1051,1694,710,977,577,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18131,18131,'Halisha''s Officer',0,'',0,'Monster2.imperial_warlord_zombie_20_bi',9.00,36.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7072,803,1863,587,1182,477,278,0,333,134,6721,0,42,165,'tomb1_clan',600,1,0,'LAST_HIT'),
	(18132,18132,'Imperial Healer',0,'',0,'Monster2.tera_beetle',19.00,54.50,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9949,1129,1540,782,807,635,278,0,333,0,0,0,49,187,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18133,18133,'Imperial Mosaic',0,'',0,'Monster2.scorpion',28.00,66.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9190,1043,1630,587,1182,477,237,0,333,0,0,0,40,187,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18134,18134,'Imperial Mosaic',0,'',0,'Monster2.scorpion',28.00,66.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6906,784,1630,587,1182,477,237,0,333,0,0,0,40,187,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18135,18135,'Imperial Mosaic',0,'',0,'Monster2.scorpion',28.00,66.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9149,1039,1630,587,1182,477,237,0,333,0,0,0,40,187,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18136,18136,'Imperial Mosaic',0,'',0,'Monster2.scorpion',28.00,66.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9190,1043,1482,710,977,577,237,0,333,0,0,0,40,187,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18137,18137,'Imperial Mosaic',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6812,773,1863,587,1182,477,278,0,333,0,0,0,49,198,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18138,18138,'Imperial Mosaic',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9069,1029,1863,587,1182,477,278,0,333,0,0,0,49,198,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18139,18139,'Imperial Mosaic',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,8935,1014,1863,587,1182,477,278,0,333,0,0,0,49,198,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18140,18140,'Imperial Mosaic',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9065,1029,1694,710,977,577,278,0,333,0,0,0,49,198,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18141,18141,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18142,18142,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18143,18143,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18144,18144,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,8745,993,3001,401,3068,325,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18145,18145,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,7399,840,2480,485,2095,394,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18146,18146,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,7568,859,2480,485,2095,394,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18147,18147,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,7046,800,2480,485,2095,394,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18148,18148,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,8203,931,2480,485,2095,394,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18149,18149,'Beetle of Grave',0,'',0,'Monster2.scarab',14.00,22.00,81,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,7247,823,2480,485,2095,394,278,0,333,0,0,0,49,198,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18150,18150,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18151,18151,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18152,18152,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18153,18153,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18154,18154,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18155,18155,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18156,18156,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18157,18157,'Victim',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,81,'female','L2Monster',40,4608,1896,13.43,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,55,110,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18158,18158,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18159,18159,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18160,18160,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18161,18161,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18162,18162,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18163,18163,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18164,18164,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18165,18165,'Executioner of Halisha',0,'',0,'Monster2.erinyes',21.00,50.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,0,0,2255,534,1731,433,278,0,333,0,0,0,34,165,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18166,18166,'Imperial Guard',0,'',0,'Monster.death_knight',12.00,31.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7005,795,2255,534,1731,433,278,0,333,142,0,0,29,121,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18167,18167,'Imperial Guard',0,'',0,'Monster.death_knight',12.00,31.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6906,784,1694,710,977,577,278,0,333,142,0,0,29,121,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18168,18168,'Imperial Guard',0,'',0,'Monster.death_knight',12.00,31.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7099,806,1863,587,1182,477,278,0,333,142,0,0,29,121,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18169,18169,'Imperial Guard',0,'',0,'Monster.death_knight',12.00,31.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6872,780,1694,710,977,577,278,0,333,142,0,0,29,121,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18170,18170,'Imperial Guard',0,'',0,'Monster.doll_master',20.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6879,781,2170,485,2095,394,237,0,333,0,0,0,88,176,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18171,18171,'Imperial Guard',0,'',0,'Monster.doll_master',20.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7147,811,1347,782,807,635,237,0,333,0,0,0,88,176,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18172,18172,'Imperial Guard',0,'',0,'Monster.doll_master',20.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6812,773,1630,587,1182,477,237,0,333,0,0,0,88,176,'tomb3_clan',600,1,0,'LAST_HIT'),
	(18173,18173,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18174,18174,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18175,18175,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18176,18176,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18177,18177,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18178,18178,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18179,18179,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18180,18180,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18181,18181,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18182,18182,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18183,18183,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9321,1058,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18184,18184,'Halisha''s Foreman',0,'',0,'Monster.kaim_vanul',24.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,7133,810,2255,534,1731,433,278,0,333,0,0,0,40,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18185,18185,'Evil Astrologer',0,'',0,'Monster.doll_blader',6.00,12.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9413,1069,1694,710,977,577,278,0,333,5129,5129,0,24,165,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18186,18186,'Evil Astrologer',0,'',0,'Monster.doll_blader',6.00,12.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9467,1075,1694,710,977,577,278,0,333,5129,5129,0,24,165,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18187,18187,'Knight of Darkness',0,'',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,333,78,0,0,44,176,'tomb4_clan',600,1,0,'LAST_HIT'),
	(18188,18188,'Knight of Darkness',0,'',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6906,784,2255,534,1731,433,278,0,333,78,0,0,44,176,'tomb4_clan',600,1,0,'LAST_HIT'),
	(18189,18189,'Knight of Darkness',0,'',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9149,1039,2255,534,1731,433,278,0,333,78,0,0,44,176,'tomb4_clan',600,1,0,'LAST_HIT'),
	(18190,18190,'Knight of Darkness',0,'',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9190,1043,2255,534,1731,433,278,0,333,78,0,0,44,176,'tomb4_clan',600,1,0,'LAST_HIT'),
	(18191,18191,'Witch of dust',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6812,773,2255,534,1731,433,278,0,333,3939,0,0,88,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18192,18192,'Witch of dust',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9069,1029,2255,534,1731,433,278,0,333,3939,0,0,88,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18193,18193,'Witch of dust',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,8935,1014,2255,534,1731,433,278,0,333,3939,0,0,88,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18194,18194,'Witch of dust',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9065,1029,2255,534,1731,433,278,0,333,3939,0,0,88,176,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18195,18195,'Signet of Emperor',0,'',0,'Monster.ant_larva',12.00,8.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6946,788,3001,401,3068,325,278,0,333,0,0,0,44,66,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18196,18196,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18197,18197,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18198,18198,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18199,18199,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18200,18200,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18201,18201,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18202,18202,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18203,18203,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18204,18204,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18205,18205,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18206,18206,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18207,18207,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18208,18208,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18209,18209,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18210,18210,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18211,18211,'Charm of Corner',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,22690,2576,1272,946,551,768,278,0,333,0,0,0,1,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18212,18212,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18213,18213,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18214,18214,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18215,18215,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18216,18216,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18217,18217,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18218,18218,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18219,18219,'Archon of Halisha',0,'',0,'Monster2.ahrimanes',14.00,57.75,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,28935,3285,1540,782,807,635,278,0,333,6722,0,0,38,203,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18220,18220,'Shaman of Darkness',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9467,1075,2050,587,1431,477,278,0,333,3939,0,0,88,176,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18221,18221,'Shaman of Darkness',0,'',0,'Monster.banshee',9.00,23.00,81,'female','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9721,1103,2050,587,1431,477,278,0,333,3939,0,0,88,176,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18222,18222,'Assassin of Darkness',0,'',0,'Monster2.ashuras',13.00,37.50,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9210,1045,2480,485,2095,394,278,0,333,0,0,0,45,209,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18223,18223,'Assassin of Darkness',0,'',0,'Monster2.ashuras',13.00,37.50,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6906,784,1863,587,1182,477,278,0,333,0,0,0,45,209,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18224,18224,'Assassin of Darkness',0,'',0,'Monster2.ashuras',13.00,37.50,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9303,1056,2480,485,2095,394,278,0,333,0,0,0,45,209,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18225,18225,'Assassin of Darkness',0,'',0,'Monster2.ashuras',13.00,37.50,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9210,1045,1863,587,1182,477,278,0,333,0,0,0,45,209,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18226,18226,'Caster of Darkness',0,'',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,6812,773,2480,485,2095,394,278,0,333,0,0,0,77,170,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18227,18227,'Caster of Darkness',0,'',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11706,1329,1863,587,1182,477,278,0,333,0,0,0,77,170,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18228,18228,'Caster of Darkness',0,'',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,8801,999,2480,485,2095,394,278,0,333,0,0,0,77,170,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18229,18229,'Caster of Darkness',0,'',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,9065,1029,1863,587,1182,477,278,0,333,0,0,0,77,170,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18230,18230,'Signet of Emperor',0,'',0,'Monster.ant_larva',12.00,8.00,81,'male','L2Monster',40,4608,1896,40.29,3.09,40,43,30,21,20,10,7495,851,3001,401,3068,325,278,0,333,0,0,0,44,66,'tomb5_clan',600,0,0,'LAST_HIT'),
	(18231,18231,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18232,18232,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18233,18233,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18234,18234,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18235,18235,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18236,18236,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18237,18237,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18238,18238,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18239,18239,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18240,18240,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18241,18241,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18242,18242,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18243,18243,'Statue of Protection',0,'',0,'Monster2.temple_guard_a',15.00,42.00,81,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,11149,1266,1694,710,977,577,278,0,333,5795,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(18244,18244,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,333,0,0,0,99,1,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18245,18245,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,333,0,0,0,99,1,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18246,18246,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,99,1,'tomb1_clan',600,0,0,'LAST_HIT'),
	(18247,18247,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,333,0,0,0,99,1,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18248,18248,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,333,0,0,0,99,1,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18249,18249,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,99,1,'tomb2_clan',600,0,0,'LAST_HIT'),
	(18250,18250,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,333,0,0,0,99,1,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18251,18251,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,333,0,0,0,99,1,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18252,18252,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,99,1,'tomb3_clan',600,0,0,'LAST_HIT'),
	(18253,18253,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,2480,485,2095,394,278,0,333,0,0,0,99,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18254,18254,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1694,710,977,577,278,0,333,0,0,0,99,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18255,18255,'Watchman of Grave',0,'',0,'Monster.mana_vampire',11.00,20.00,81,'male','L2Monster',40,3456,1896,40.29,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,0,333,0,0,0,99,1,'tomb4_clan',600,0,0,'LAST_HIT'),
	(18256,18256,'Halisha''s Treasure Box',0,'',0,'Monster.mimic',8.50,8.50,85,'male','L2Monster',40,1,1,0.00,0.00,40,43,30,21,20,10,0,0,2,1,1,1,1,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18257,18257,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18258,18258,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18259,18259,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18260,18260,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18261,18261,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18262,18262,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18263,18263,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18264,18264,'Treasure Chest',0,'',0,'Monster.mechanic_golem',8.50,8.50,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18265,18265,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,21,'male','L2Chest',40,575,227,5.53,1.53,40,43,30,21,20,10,630,29,63,98,25,80,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18266,18266,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,24,'male','L2Chest',40,687,272,5.53,1.53,40,43,30,21,20,10,771,38,81,111,34,90,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18267,18267,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,27,'male','L2Chest',40,813,318,5.53,1.53,40,43,30,21,20,10,918,47,104,125,45,102,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18268,18268,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,30,'male','L2Chest',40,954,365,5.53,1.53,40,43,30,21,20,10,1080,59,132,140,58,114,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18269,18269,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,33,'male','L2Chest',40,1109,413,7.11,1.84,40,43,30,21,20,10,1306,75,166,157,75,128,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18270,18270,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,36,'male','L2Chest',40,1279,463,7.11,1.84,40,43,30,21,20,10,1555,94,206,175,96,142,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18271,18271,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,39,'male','L2Chest',40,1462,514,7.11,1.84,40,43,30,21,20,10,1825,116,255,195,121,158,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18272,18272,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,42,'male','L2Chest',40,1660,589,8.69,2.14,40,43,30,21,20,10,2116,141,311,215,152,175,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18273,18273,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,45,'male','L2Chest',40,1870,677,8.69,2.14,40,43,30,21,20,10,2430,169,377,238,188,193,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18274,18274,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,48,'male','L2Chest',40,2091,768,8.69,2.14,40,43,30,21,20,10,2764,202,453,261,231,212,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18275,18275,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,51,'male','L2Chest',40,2323,861,10.27,2.45,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18276,18276,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,54,'male','L2Chest',40,2562,955,10.27,2.45,40,43,30,21,20,10,3499,279,636,313,339,254,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18277,18277,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,57,'male','L2Chest',40,2806,1052,10.27,2.45,40,43,30,21,20,10,3898,324,743,340,405,276,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18278,18278,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,60,'male','L2Chest',40,3054,1150,10.27,2.45,40,43,30,21,20,10,4320,375,860,368,478,299,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18279,18279,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,63,'male','L2Chest',40,3302,1251,11.85,2.78,40,43,30,21,20,10,4762,430,987,398,560,323,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18280,18280,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,66,'male','L2Chest',40,3546,1353,11.85,2.78,40,43,30,21,20,10,5227,492,1123,428,649,348,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18281,18281,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,69,'male','L2Chest',40,3784,1458,11.85,2.78,40,43,30,21,20,10,5713,559,1265,460,746,373,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18282,18282,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,72,'male','L2Chest',40,4013,1565,13.43,3.09,40,43,30,21,20,10,6220,632,1413,491,849,399,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18283,18283,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,75,'male','L2Chest',40,4229,1673,13.43,3.09,40,43,30,21,20,10,6750,712,1563,523,957,425,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18284,18284,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,78,'male','L2Chest',40,4428,1784,13.43,3.09,40,43,30,21,20,10,7300,799,1715,555,1069,451,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18285,18285,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,81,'male','L2Chest',40,4608,1896,13.43,3.09,40,43,30,21,20,10,7873,894,1863,587,1182,477,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18286,18286,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,84,'male','L2Chest',40,4766,2011,13.43,3.09,40,43,30,21,20,10,8467,996,2006,619,1296,502,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18287,18287,'Otherworldly Invader Food',0,'',0,'Monster.mimic',8.50,8.50,33,'male','L2Chest',40,1109,413,7.11,1.84,40,43,30,21,20,10,0,0,166,157,75,128,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18288,18288,'Otherworldly Invader Food',0,'',0,'Monster.mimic',8.50,8.50,35,'male','L2Chest',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18289,18289,'Dimension Invader Food',0,'',0,'Monster.mimic',8.50,8.50,43,'male','L2Chest',40,1728,618,8.69,2.14,40,43,30,21,20,10,0,0,332,223,163,181,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18290,18290,'Dimension Invader Food',0,'',0,'Monster.mimic',8.50,8.50,45,'male','L2Chest',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18291,18291,'Purgatory Invader Food',0,'',0,'Monster.mimic',8.50,8.50,53,'male','L2Chest',40,2481,923,10.27,2.45,40,43,30,21,20,10,0,0,602,304,319,247,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18292,18292,'Purgatory Invader Food',0,'',0,'Monster.mimic',8.50,8.50,55,'male','L2Chest',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18293,18293,'Forbidden Path Invader Food',0,'',0,'Monster.mimic',8.50,8.50,63,'male','L2Chest',40,3302,1251,11.85,2.78,40,43,30,21,20,10,0,0,987,398,560,323,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18294,18294,'Forbidden Path Invader Food',0,'',0,'Monster.mimic',8.50,8.50,65,'male','L2Chest',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18295,18295,'Dark Omen Invader Food',0,'',0,'Monster.mimic',8.50,8.50,73,'male','L2Chest',40,4086,1601,13.43,3.09,40,43,30,21,20,10,0,0,1463,502,885,407,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18296,18296,'Dark Omen Invader Food',0,'',0,'Monster.mimic',8.50,8.50,75,'male','L2Chest',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18297,18297,'Messenger Invader Food',0,'',0,'Monster.mimic',8.50,8.50,83,'male','L2Chest',40,4716,1972,13.43,3.09,40,43,30,21,20,10,0,0,1959,608,1258,494,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18298,18298,'Messenger Invader Food',0,'',0,'Monster.mimic',8.50,8.50,85,'male','L2Chest',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(18299,18299,'Flame of the Branded',0,'',0,'Monster.big_boom',6.00,13.00,35,'male','L2Npc',40,1220,446,21.33,1.84,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18300,18300,'Offering of the Branded, Evoked Spirit',0,'',0,'Monster.orc',10.00,21.00,33,'male','L2Npc',40,1109,413,7.11,1.84,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,333,158,0,0,49,170,NULL,0,0,0,'LAST_HIT'),
	(18301,18301,'Flame of Apostates',0,'',0,'Monster.big_boom',6.00,13.00,46,'male','L2Npc',40,1943,707,26.07,2.14,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18302,18302,'Offering of Apostates, Evoked Spirit',0,'',0,'Monster.orc_fighter',12.00,22.00,44,'male','L2Npc',40,1799,648,8.69,2.14,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,333,172,0,0,49,176,NULL,0,0,0,'LAST_HIT'),
	(18303,18303,'Flame of the Witch',0,'',0,'Monster.big_boom',6.00,13.00,57,'male','L2Npc',40,2806,1052,30.81,2.45,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18304,18304,'Offering of the Witch, Evoked Spirit',0,'',0,'Monster.batur_orc',9.00,21.50,55,'male','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,333,91,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18305,18305,'Flame of Dark Omen',0,'',0,'Monster.big_boom',6.00,13.00,68,'male','L2Npc',40,3706,1423,35.55,2.78,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18306,18306,'Offering of Dark Omen, Evoked Spirit',0,'',0,'Monster.batur_orc',9.00,21.50,66,'male','L2Npc',40,3546,1353,11.85,2.78,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,333,2503,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18307,18307,'Flame of Forbidden Path',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Npc',40,4490,1821,40.29,3.09,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18308,18308,'Offering of /Forbidden Path, Evoked Spirit',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,77,'male','L2Npc',40,4364,1747,13.43,3.09,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,333,175,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18309,18309,'Flame of the Branded',0,'',0,'Monster.big_boom',6.00,13.00,35,'male','L2Npc',40,1220,446,21.33,1.84,40,43,30,21,20,10,1631,96,192,169,89,137,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18310,18310,'Offering of the Branded, Evoked Spirit',0,'',0,'Monster.orc',10.00,21.00,33,'male','L2Npc',40,1109,413,7.11,1.84,40,43,30,21,20,10,1751,100,166,157,75,128,278,0,333,158,0,0,49,170,NULL,0,0,0,'LAST_HIT'),
	(18311,18311,'Flame of Apostates',0,'',0,'Monster.big_boom',6.00,13.00,46,'male','L2Npc',40,1943,707,26.07,2.14,40,43,30,21,20,10,2817,199,401,245,202,199,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18312,18312,'Offering of Apostates, Evoked Spirit',0,'',0,'Monster.orc_fighter',12.00,22.00,44,'male','L2Npc',40,1799,648,8.69,2.14,40,43,30,21,20,10,3113,213,354,230,176,187,278,0,333,172,0,0,49,176,NULL,0,0,0,'LAST_HIT'),
	(18313,18313,'Flame of the Witch',0,'',0,'Monster.big_boom',6.00,13.00,57,'male','L2Npc',40,2806,1052,30.81,2.45,40,43,30,21,20,10,4326,359,743,340,405,276,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18314,18314,'Offering of the Witch, Evoked Spirit',0,'',0,'Monster.batur_orc',9.00,21.50,55,'male','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,4864,393,670,322,360,261,278,0,333,91,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(18315,18315,'Flame of Dark Omen',0,'',0,'Monster.big_boom',6.00,13.00,68,'male','L2Npc',40,3706,1423,35.55,2.78,40,43,30,21,20,10,6157,594,1217,449,713,365,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18316,18316,'Offering of Dark Omen, Evoked Spirit',0,'',0,'Monster.batur_orc',9.00,21.50,66,'male','L2Npc',40,3546,1353,11.85,2.78,40,43,30,21,20,10,7004,659,1123,428,649,348,278,0,333,2503,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(18317,18317,'Flame of Forbidden Path',0,'',0,'Monster.big_boom',6.00,13.00,79,'male','L2Npc',40,4490,1821,40.29,3.09,40,43,30,21,20,10,8311,921,1765,566,1107,459,278,0,333,0,0,0,52,33,NULL,0,0,0,'LAST_HIT'),
	(18318,18318,'Offering of Forbidden Path, Evoked Spirit',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,77,'male','L2Npc',40,4364,1747,13.43,3.09,40,43,30,21,20,10,9533,1032,1664,544,1031,442,278,0,333,175,0,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(18319,18319,'Caught Frog',0,'',0,'Monster.poison_toad',20.00,10.00,10,'male','L2PenaltyMonster',40,257,120,3.16,0.91,40,43,30,21,20,10,421,14,22,52,8,49,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(18320,18320,'Caught Undine',0,'',0,'Monster.undine',12.00,27.00,20,'female','L2PenaltyMonster',40,541,213,3.95,1.21,40,43,30,21,20,10,843,37,57,80,23,76,278,0,333,0,0,0,66,132,NULL,0,0,0,'LAST_HIT'),
	(18321,18321,'Caught Rakul',0,'',0,'Monster.rakul',30.00,39.00,30,'male','L2PenaltyMonster',40,954,365,5.53,1.53,40,43,30,21,20,10,1550,85,132,119,58,114,278,0,333,156,0,0,66,143,NULL,0,1,0,'LAST_HIT'),
	(18322,18322,'Caught Sea Giant',0,'',0,'Monster.water_giant',13.00,44.00,40,'male','L2PenaltyMonster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2755,178,273,171,131,164,278,0,333,131,0,0,38,154,NULL,0,0,0,'LAST_HIT'),
	(18323,18323,'Caught Sea Horse Soldier',0,'',0,'Monster.theeder',9.00,32.00,50,'male','L2PenaltyMonster',80,2245,830,8.69,2.14,40,43,30,21,20,10,4305,324,509,236,264,226,237,0,333,291,0,0,88,165,NULL,0,0,0,'LAST_HIT'),
	(18324,18324,'Caught Homunculus',0,'',0,'Monster2.homunculus',12.00,32.50,60,'male','L2PenaltyMonster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,6200,538,860,313,478,299,278,0,333,0,0,0,33,176,NULL,0,0,0,'LAST_HIT'),
	(18325,18325,'Caught Flava',0,'',0,'Monster2.flava',18.00,34.00,70,'male','L2PenaltyMonster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,8438,837,1314,399,780,382,278,0,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(18326,18326,'Caught Gigantic Eye',0,'',0,'Monster2.hundred_eye',21.00,55.00,80,'male','L2PenaltyMonster',40,4550,1859,13.43,3.09,40,43,30,21,20,10,11022,1237,1814,490,1144,468,278,0,333,0,0,0,33,198,NULL,0,0,0,'LAST_HIT'),
	(18327,18327,'Freya''s Servant',0,'',0,'Monster.gargoyle_02te',11.00,20.00,58,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18328,18328,'Hall Alarm Device',0,'',0,'NPC.grave_keeper_key',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18329,18329,'Hall Keeper Captain',0,'',0,'Monster.death_lord',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18330,18330,'Hall Keeper Wizard',0,'',0,'Monster.vale_master',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18331,18331,'Hall Keeper Guard',0,'',0,'Monster.death_knight',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18332,18332,'Hall Keeper Patrol',0,'',0,'Monster.headless_knight',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18333,18333,'Hall Keeper Suicidal Soldier',0,'',0,'Monster3.self_blaster',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18334,18334,'Dark Choir Captain',0,'',0,'Monster2.erinyes_cmd',11.00,20.00,85,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18335,18335,'Dark Choir Prima Donna',0,'',0,'Monster3.portrait_spirit',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18336,18336,'Dark Choir Lancer',0,'',0,'Monster.death_blader',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18337,18337,'Dark Choir Archer',0,'',0,'Monster.skeleton_archer_20_bi',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18338,18338,'Dark Choir Witch Doctor',0,'',0,'Monster3.portrait_spirit_winged',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18339,18339,'Dark Choir Player',0,'',0,'Monster.skeleton',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18340,18340,'Hall Keeper Suicidal Soldier',0,'',0,'Monster3.self_blaster',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18341,18341,'Hall Keeper Suicidal Soldier',0,'',0,'Monster3.self_blaster',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18342,18342,'Gremlin',0,'',0,'Monster.gremlin',10.00,15.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,9,39,3,32,278,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(18343,18343,'Gatekeeper Zombie',0,'',0,'Monster3.zombie_gateguard',11.00,20.00,80,'male','L2Monster',80,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(18344,18344,'Ancient Egg',0,'',0,'NpcEV.dinosaur_nest',43.00,33.50,80,'male','L2Monster',0,3,3,4.74,3.09,40,43,30,21,20,10,0,0,1,606,1,1182,300,0,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(18345,18345,'Sprigant',0,'',0,'Monster3.Arachnoid',45.00,67.00,80,'male','L2Monster',40,1179,2057,13.43,3.09,40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(18346,18346,'Sprigant',0,'',0,'Monster3.Arachnoid',45.00,67.00,80,'male','L2Monster',40,1179,2057,13.43,3.09,40,43,30,21,20,10,0,0,2129,615,2129,511,300,500,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(20001,20001,'Gremlin',0,'',0,'Monster.gremlin',10.00,15.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,9,39,3,32,278,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(20002,20002,'Rabbit',0,'',0,'Monster.rabbit',5.00,4.50,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,9,39,3,32,278,0,333,0,0,0,55,88,NULL,0,0,0,'LAST_HIT'),
	(20003,20003,'Goblin',0,'',0,'Monster.goblin',10.00,16.50,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,178,5,13,48,4,39,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20004,20004,'Imp',0,'',0,'Monster.imp',10.00,24.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,213,6,15,50,5,41,278,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20005,20005,'Imp Elder',0,'',0,'Monster.imp',10.00,24.00,7,'male','L2Monster',40,171,94,3.16,0.91,40,43,30,21,20,10,249,8,18,48,6,43,278,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20006,20006,'Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,293,10,41,55,6,45,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20007,20007,'Green Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,321,11,22,53,7,47,278,0,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20008,20008,'Felim Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,30,80,12,59,278,0,333,1,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20009,20009,'Vuku Orc',0,'',0,'Monster.orc',10.00,21.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,33,73,12,59,278,0,333,156,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20010,20010,'Felim Lizardman Scout',0,'',0,'Monster.virud_lizardman',10.00,23.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,40,69,14,62,278,0,333,16,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20011,20011,'Vuku Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,15,'male','L2Monster',500,390,165,3.95,1.21,40,43,30,21,20,10,550,22,82,76,14,62,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20012,20012,'Gora Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,582,23,44,72,15,64,278,500,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20013,20013,'Dryad',0,'',0,'Monster.dryad',9.00,20.00,13,'female','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,462,18,27,77,11,56,278,0,333,0,0,0,44,121,'elemental1_clan',300,0,0,'LAST_HIT'),
	(20014,20014,'Felim Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,605,25,48,75,17,67,278,0,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20015,20015,'Marsh Zombie',0,'',0,'Monster.zombie',13.00,21.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,654,26,33,63,11,56,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20016,20016,'Stone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,654,26,30,70,11,56,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20017,20017,'Vuku Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20018,20018,'Carnivorous Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,424,16,37,66,12,59,278,500,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20019,20019,'Dryad Elder',0,'',0,'Monster.dryad',9.00,20.00,14,'female','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,30,80,12,59,278,0,333,0,0,0,44,121,'elemental1_clan',300,0,0,'LAST_HIT'),
	(20020,20020,'Marsh Zombie Lord',0,'',0,'Monster.zombie',13.00,21.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,705,27,30,80,12,59,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20021,20021,'Red Bear',0,'',0,'Monster.grizzly',21.00,40.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,37,66,12,59,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20022,20022,'Misery Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,424,16,32,66,12,59,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20023,20023,'Shadow Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,40,69,14,62,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20024,20024,'Langk Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,16,0,0,57,143,NULL,0,0,0,'LAST_HIT'),
	(20025,20025,'Lesser Dark Horror',0,'',0,'Monster.dark_horror',20.00,35.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,545,22,36,76,14,62,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20026,20026,'Ruin Zombie',0,'',0,'Monster.zombie',13.00,21.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,755,31,40,69,14,62,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20027,20027,'Langk Lizardman Scout',0,'',0,'Monster.virud_lizardman',10.00,23.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,16,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20028,20028,'Pincher',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20029,20029,'Ruin Zombie Leader',0,'',0,'Monster.zombie',13.00,21.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,807,33,36,87,15,64,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20030,20030,'Langk Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,36,76,14,62,278,0,333,1,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20031,20031,'Omen Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,504,21,48,75,17,67,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20032,20032,'Pinrul',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,605,25,48,75,17,67,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20033,20033,'Shade Horror',0,'',0,'Monster.dark_horror',20.00,35.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,504,21,48,75,17,67,278,0,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20034,20034,'Prowler',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20035,20035,'Tracker Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,605,25,42,75,17,67,317,0,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20036,20036,'Lirein',0,'',0,'Monster.sylph',11.00,35.00,18,'female','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,652,28,53,79,19,70,278,500,333,0,0,0,66,66,'elemental2_clan',300,0,0,'LAST_HIT'),
	(20037,20037,'Mana Seeker',0,'',0,'Monster.mana_vampire',11.00,20.00,18,'male','L2Monster',40,476,193,7.90,1.21,40,43,30,21,20,10,496,21,44,95,19,70,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20038,20038,'Poison Spider',0,'',0,'Monster.poison_spider',27.00,25.50,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,704,31,53,79,19,70,278,0,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(20039,20039,'Scavenger Wererat',0,'',0,'Monster.wererat',14.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,640,28,46,79,19,70,317,0,333,12,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20040,20040,'Sukar Wererat',0,'',0,'Monster.wererat',14.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,533,23,46,79,19,70,317,0,333,216,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20041,20041,'Tainted Zombie',0,'',0,'Monster.zombie',13.00,21.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,754,33,44,95,19,70,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20042,20042,'Tracker Skeleton Leader',0,'',0,'Monster.skeleton',11.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,652,28,46,79,19,70,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20043,20043,'Arachnid Tracker',0,'',0,'Monster.poison_spider',27.00,25.50,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,760,34,48,99,21,73,278,500,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(20044,20044,'Lirein Elder',0,'',0,'Monster.sylph',11.00,35.00,19,'female','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,691,31,58,82,21,73,278,500,333,0,0,0,66,66,'elemental1_clan',300,0,0,'LAST_HIT'),
	(20045,20045,'Skeleton Scout',0,'',0,'Monster.skeleton_archer',11.00,27.00,19,'male','L2Monster',500,508,203,3.95,1.21,40,43,30,21,20,10,698,31,107,99,21,73,249,0,333,275,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20046,20046,'Stink Zombie',0,'',0,'Monster.zombie',13.00,21.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,799,36,48,99,21,73,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20047,20047,'Sukar Wererat Leader',0,'',0,'Monster.wererat',14.00,25.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,576,26,42,99,21,73,317,500,333,216,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20048,20048,'Lesser Succubus',0,'',0,'Monster.succubus',10.00,36.00,20,'female','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,57,94,23,76,278,500,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(20049,20049,'Lycanthrope',0,'',0,'Monster.werewolf',10.00,26.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,726,32,63,86,23,76,278,500,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20050,20050,'Arachnid Predator',0,'',0,'Monster.poison_spider',27.00,25.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,799,35,63,86,23,76,278,500,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(20051,20051,'Skeleton Bowman',0,'',0,'Monster.skeleton_archer',11.00,27.00,20,'male','L2Monster',500,541,213,3.95,1.21,40,43,30,21,20,10,734,32,117,104,23,76,249,0,333,275,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20052,20052,'Lesser Succubus Turen',0,'',0,'Monster.succubus',10.00,36.00,21,'female','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,69,89,25,80,278,500,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(20053,20053,'Ol Mahum Patrol',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,21,'male','L2Monster',500,575,227,5.53,1.53,40,43,30,21,20,10,787,36,140,98,25,80,249,0,333,14,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20054,20054,'Ruin Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,57,108,25,80,278,0,333,73,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20055,20055,'Wandering Eye',0,'',0,'Monster.monster_eye',21.00,43.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,57,108,25,80,278,0,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20056,20056,'Dre Vanul Disposer',0,'',0,'Monster.dre_vanul',14.00,36.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,767,36,75,93,28,83,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20057,20057,'Lesser Succubus Tilfo',0,'',0,'Monster.succubus',10.00,36.00,22,'female','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,698,33,75,93,28,83,278,500,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(20058,20058,'Ol Mahum Guard',0,'',0,'Monster.ol_mahum',13.50,25.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,821,39,75,93,28,83,278,0,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20059,20059,'Hungry Eye',0,'',0,'Monster.monster_eye',21.00,43.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,821,39,75,93,28,83,278,0,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20060,20060,'Raging Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,837,40,54,113,28,83,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20061,20061,'Ol Mahum Straggler',0,'',0,'Monster.ol_mahum',13.50,25.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,895,43,75,107,31,87,278,500,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20062,20062,'Tumran Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,878,42,68,117,31,87,278,0,333,156,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20063,20063,'Ol Mahum Shooter',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,24,'male','L2Monster',500,687,272,5.53,1.53,40,43,30,21,20,10,963,47,181,111,34,90,249,0,333,14,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20064,20064,'Tumran Bugbear Warrior',0,'',0,'Monster.bugbear',17.00,35.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,954,47,89,101,34,90,278,500,333,88,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20065,20065,'Ol Mahum Patrolman',0,'',0,'Monster.ol_mahum',13.50,25.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,826,41,80,127,37,94,278,0,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20066,20066,'Ol Mahum Captain',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,1052,53,97,105,37,94,278,500,333,69,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20067,20067,'Monster Eye Watcher',0,'',0,'Monster.monster_eye',21.00,43.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,992,50,80,127,37,94,278,0,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20068,20068,'Monster Eye Destroyer',0,'',0,'Monster.monster_eye',21.00,43.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,1078,54,87,132,41,98,278,500,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20069,20069,'Selu Lizardman Scout',0,'',0,'Monster.virud_lizardman',10.00,23.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,880,44,87,132,41,98,278,0,333,16,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20070,20070,'Lesser Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,333,0,0,0,38,144,NULL,0,0,0,'LAST_HIT'),
	(20071,20071,'Selu Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,946,48,114,114,45,102,278,500,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20072,20072,'Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1189,62,102,143,49,106,278,500,333,0,0,0,38,144,NULL,0,0,0,'LAST_HIT'),
	(20073,20073,'Ol Mahum Legionnaire',0,'',0,'Monster.ol_mahum',13.50,25.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,981,52,113,130,49,106,278,0,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20074,20074,'Androscorpio',0,'',0,'Monster.onyx_beast',14.00,14.50,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1243,67,122,135,53,110,278,0,333,0,0,0,33,132,'scropio_clan',300,0,0,'LAST_HIT'),
	(20075,20075,'Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1139,61,111,149,53,110,278,0,333,0,0,0,44,66,'ant_clan',300,0,0,'LAST_HIT'),
	(20076,20076,'Ol Mahum Commander',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1319,71,134,123,53,110,278,500,333,69,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20077,20077,'Androscorpio Hunter',0,'',0,'Monster.onyx_beast',14.00,14.50,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,333,0,0,0,33,132,'scropio_clan',300,0,0,'LAST_HIT'),
	(20078,20078,'Whispering Wind',0,'',0,'Monster.sylph_100_bi',20.00,70.00,30,'female','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,120,155,58,114,278,0,333,0,0,0,66,66,'elemental2_clan',300,0,0,'LAST_HIT'),
	(20079,20079,'Ant',0,'',0,'Monster.ant',26.00,15.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,145,128,58,114,278,0,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20080,20080,'Ant Captain',0,'',0,'Monster.ant',26.00,21.00,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1425,79,157,133,64,118,278,500,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20081,20081,'Ant Overseer',0,'',0,'Monster.ant',26.00,15.00,32,'male','L2Monster',40,1056,397,14.22,1.84,40,43,30,21,20,10,1200,67,169,138,69,123,278,0,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20082,20082,'Ant Recruit',0,'',0,'Monster.ant_soldier',35.00,17.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1451,83,151,173,75,128,278,0,333,0,0,0,88,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20083,20083,'Granite Golem',0,'',0,'Monster.stone_golem',20.00,31.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,2239,129,151,173,75,128,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20084,20084,'Ant Patrol',0,'',0,'Monster.ant_soldier',35.00,17.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1667,97,196,148,82,132,278,0,333,0,0,0,88,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20085,20085,'Puncher',0,'',0,'Monster.stone_golem',20.00,31.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,2424,142,196,148,82,132,278,500,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20086,20086,'Ant Guard',0,'',0,'Monster.ant_soldier',35.00,17.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1484,88,192,169,89,137,278,0,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20087,20087,'Ant Soldier',0,'',0,'Monster.ant_soldier',35.00,17.00,35,'male','L2Monster',40,1220,446,14.22,1.84,40,43,30,21,20,10,1780,105,192,169,89,137,278,500,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20088,20088,'Ant Warrior Captain',0,'',0,'Monster.ant_soldier',35.00,17.00,36,'male','L2Monster',40,1279,463,14.22,1.84,40,43,30,21,20,10,1984,120,227,159,96,142,278,500,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20089,20089,'Noble Ant',0,'',0,'Monster.noble_ant',20.00,48.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,1659,102,222,182,104,147,278,0,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20090,20090,'Noble Ant Leader',0,'',0,'Monster.noble_ant',20.00,48.00,38,'male','L2Monster',40,1400,497,14.22,1.84,40,43,30,21,20,10,1829,114,261,171,112,153,278,500,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20091,20091,'Young Fox',0,'',0,'Monster.fox',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20092,20092,'Monster Eye',0,'',0,'Monster.monster_eye',21.00,43.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,294,10,22,61,8,49,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20093,20093,'Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,22,61,8,49,278,500,333,1,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20094,20094,'Orc Marksman',0,'',0,'Monster.orc_archer',14.00,25.00,10,'male','L2Monster',500,257,120,3.16,0.91,40,43,30,21,20,10,305,10,56,55,8,49,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20095,20095,'Vampire Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,296,10,22,61,8,49,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20096,20096,'Orc Lieutenant',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,391,15,23,70,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20097,20097,'Drill Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,326,12,27,58,9,52,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20098,20098,'Orc Fighter Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,447,17,30,60,10,54,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20099,20099,'Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,26,60,10,54,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20100,20100,'Skeleton Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,13,'male','L2Monster',500,339,147,3.95,1.21,40,43,30,21,20,10,405,16,74,63,11,56,249,500,333,14,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20101,20101,'Crasher',0,'',0,'Monster.stone_golem',20.00,31.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,705,27,30,80,12,59,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20102,20102,'Skeleton Marksman',0,'',0,'Monster.skeleton_archer',11.00,27.00,14,'male','L2Monster',500,364,156,3.95,1.21,40,43,30,21,20,10,428,17,82,66,12,59,249,0,333,14,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20103,20103,'Giant Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,545,22,40,69,14,62,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20104,20104,'Skeleton Lord',0,'',0,'Monster.skeleton',11.00,25.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,445,18,29,84,14,62,317,0,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20105,20105,'Dark Horror',0,'',0,'Monster.dark_horror',20.00,35.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,576,23,44,72,15,64,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20106,20106,'Talon Spider',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20107,20107,'Wererat',0,'',0,'Monster.wererat',14.00,25.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,475,19,40,79,15,64,278,0,333,0,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20108,20108,'Blade Spider',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20109,20109,'Salamander',0,'',0,'Monster.salamander',16.00,6.80,17,'male','L2Monster',40,446,184,7.90,1.21,40,43,30,21,20,10,494,21,44,83,17,67,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(20110,20110,'Undine',0,'',0,'Monster.undine',12.00,27.00,17,'female','L2Monster',40,446,184,7.90,1.21,40,43,30,21,20,10,479,20,44,83,17,67,278,500,333,0,0,0,66,66,'elemental4_clan',300,0,0,'LAST_HIT'),
	(20111,20111,'Wererat Leader',0,'',0,'Monster.wererat',14.00,25.00,17,'male','L2Monster',40,446,184,7.90,1.21,40,43,30,21,20,10,479,20,40,91,17,67,278,500,333,1,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20112,20112,'Salamander Elder',0,'',0,'Monster.salamander',16.00,6.80,18,'male','L2Monster',40,476,193,7.90,1.21,40,43,30,21,20,10,496,21,53,79,19,70,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(20113,20113,'Undine Elder',0,'',0,'Monster.undine',12.00,27.00,18,'female','L2Monster',40,476,193,7.90,1.21,40,43,30,21,20,10,505,22,44,95,19,70,278,500,333,0,0,0,66,66,'elemental4_clan',300,0,0,'LAST_HIT'),
	(20114,20114,'Salamander Noble',0,'',0,'Monster.salamander',16.00,6.80,19,'male','L2Monster',40,508,203,7.90,1.21,40,43,30,21,20,10,525,23,58,82,21,73,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(20115,20115,'Undine Noble',0,'',0,'Monster.undine',12.00,27.00,19,'female','L2Monster',40,508,203,7.90,1.21,40,43,30,21,20,10,536,24,58,82,21,73,278,500,333,0,0,0,66,66,'elemental4_clan',300,0,0,'LAST_HIT'),
	(20116,20116,'Fox',0,'',0,'Monster.fox',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,58,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20117,20117,'Dre Vanul',0,'',0,'Monster.dre_vanul',14.00,36.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,666,29,63,86,23,76,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20118,20118,'Dre Vanul Scout',0,'',0,'Monster.dre_vanul',14.00,36.00,21,'male','L2Minion',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,69,89,25,80,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20119,20119,'Elder Fox',0,'',0,'Monster.fox',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,88,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20120,20120,'Wolf',0,'',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,141,4,12,46,4,37,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20121,20121,'Giant Toad',0,'',0,'Monster.poison_toad',20.00,10.00,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,178,5,13,48,4,39,278,0,333,0,0,0,55,110,NULL,0,0,0,'LAST_HIT'),
	(20130,20130,'Orc',0,'',0,'Monster.orc',10.00,21.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,213,6,15,50,5,41,278,0,333,156,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20131,20131,'Orc Grunt',0,'',0,'Monster.orc',10.00,21.00,7,'male','L2Monster',40,171,94,3.16,0.91,40,43,30,21,20,10,249,8,17,53,6,43,278,0,333,4,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20132,20132,'Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,321,11,20,58,7,47,278,0,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20133,20133,'Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,63,98,25,80,278,500,333,4,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20134,20134,'Cave Maiden',0,'',0,'Monster.cave_maiden',25.00,65.00,59,'female','L2Monster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,5112,437,902,326,453,291,278,500,333,68,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20135,20135,'Alligator',0,'',0,'Monster.crocodile',28.00,11.50,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2373,153,300,183,131,164,278,500,333,0,0,0,77,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20136,20136,'Death Knight',0,'',0,'Monster.death_knight',12.00,31.00,50,'male','L2Monster',40,2245,830,17.38,2.14,40,43,30,21,20,10,4651,350,616,230,264,226,278,500,333,75,0,0,29,191,'undead_clan',300,1,0,'LAST_HIT'),
	(20137,20137,'Drake',0,'',0,'Monster.drake',30.00,100.00,57,'male','L2Monster',40,2806,1052,10.27,2.45,40,43,30,21,20,10,4819,401,817,309,405,276,278,500,333,0,0,0,77,191,'dragon_clan',300,0,0,'LAST_HIT'),
	(20138,20138,'Gargoyle',0,'',0,'Monster.gargoyle',16.00,50.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,946,48,104,125,45,102,278,500,333,0,0,0,154,154,NULL,0,0,0,'LAST_HIT'),
	(20139,20139,'Giant Bee',0,'',0,'Monster.giant_bee',8.00,24.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,471,19,40,79,15,64,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20140,20140,'Giant Leech',0,'',0,'Monster.giant_leech',70.00,29.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,795,39,81,111,34,90,278,500,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(20141,20141,'Giant Wild Hog',0,'',0,'Monster.giant_wild_hog',35.00,27.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,2730,196,427,253,216,206,278,500,333,0,0,0,38,132,NULL,0,0,0,'LAST_HIT'),
	(20142,20142,'Griffon',0,'',0,'Monster.griffin',20.00,44.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,593,26,57,94,23,76,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20143,20143,'Grizzly',0,'',0,'Monster.grizzly',21.00,40.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,436,16,27,66,10,54,278,500,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20144,20144,'Hangman Tree',0,'',0,'Monster.hanged_man_ripper',35.00,80.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1817,108,192,169,89,137,278,500,333,0,0,0,60,191,NULL,0,0,0,'LAST_HIT'),
	(20145,20145,'Harpy',0,'',0,'Monster.harpy',10.00,42.00,32,'female','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1504,84,154,151,69,123,278,500,333,0,0,0,66,110,NULL,0,0,0,'LAST_HIT'),
	(20146,20146,'Headless Knight',0,'',0,'Monster.headless_knight',21.00,31.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3708,279,463,306,264,226,278,500,333,124,0,0,77,191,NULL,0,1,0,'LAST_HIT'),
	(20147,20147,'Hobgoblin',0,'',0,'Monster.hobgoblin',12.00,24.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,63,98,25,80,278,0,333,4,0,0,49,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20148,20148,'Hungry Spirit',0,'',0,'Monster.hungry_spirit',30.00,40.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,333,0,0,0,16,132,NULL,0,1,0,'LAST_HIT'),
	(20149,20149,'Iron Golem',0,'',0,'Monster.iron_golem',18.00,34.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,2524,157,216,207,112,153,278,500,333,0,0,0,22,22,NULL,0,0,0,'LAST_HIT'),
	(20150,20150,'King Bugbear',0,'',0,'Monster.king_bugbear',15.00,40.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1265,71,169,138,69,123,278,500,333,88,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20151,20151,'Kobold',0,'',0,'Monster.kobold',10.00,15.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,118,3,12,46,4,37,278,0,333,4,0,0,51,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20152,20152,'Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,565,25,53,90,21,73,278,0,333,291,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20153,20153,'Magical Weaver',0,'',0,'Monster.magical_weaver',11.00,20.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,391,15,27,58,9,52,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20154,20154,'Mandragora Sprout',0,'',0,'Monster.manadragora',14.00,17.80,21,'female','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,63,98,25,80,278,0,333,0,0,0,88,88,'mandragora_clan',300,0,0,'LAST_HIT'),
	(20155,20155,'Mandragora Sapling',0,'',0,'Monster.mandragora_a',15.00,26.00,23,'female','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,895,43,82,97,31,87,278,500,333,0,0,0,88,132,'mandragora_clan',300,0,0,'LAST_HIT'),
	(20156,20156,'Mandragora Blossom',0,'',0,'Monster.mandragora_b',12.00,25.50,25,'female','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,1012,51,97,105,37,94,278,500,333,0,0,0,88,132,'mandragora_clan',300,0,0,'LAST_HIT'),
	(20157,20157,'Marsh Stakato',0,'',0,'Monster.marsh_stakato',10.00,20.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1509,81,117,123,53,110,317,500,333,223,0,0,23,132,'stakato_clan',300,0,0,'LAST_HIT'),
	(20158,20158,'Medusa',0,'',0,'Monster.medusa',10.00,25.00,34,'female','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1714,100,178,163,82,132,278,500,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(20159,20159,'Minotaur',0,'',0,'Monster.minotaur',21.00,45.50,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2263,153,365,202,163,181,278,500,333,300,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(20160,20160,'Neer Crawler',0,'',0,'Monster.neer_crawler',14.00,22.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1201,63,124,118,49,106,278,500,333,0,0,0,55,99,'neer_crawler_clan',300,1,0,'LAST_HIT'),
	(20161,20161,'Oel Mahum',0,'',0,'Monster.oel_mahum',20.00,37.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4167,328,602,304,319,247,278,500,333,0,0,0,77,191,'oel_mahum_clan',300,0,0,'LAST_HIT'),
	(20162,20162,'Ogre',0,'',0,'Monster.ogre',21.00,44.00,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,2057,135,446,189,141,169,200,500,333,98,0,0,24,88,NULL,0,0,0,'LAST_HIT'),
	(20163,20163,'Ol Mahum',0,'',0,'Monster.ol_mahum',13.50,25.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,731,35,82,97,31,87,278,0,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20164,20164,'Ol Mahum Archer',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,25,'male','L2Monster',500,728,287,5.53,1.53,40,43,30,21,20,10,868,44,216,105,37,94,249,500,333,14,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20165,20165,'Ol Mahum Champion',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1257,67,134,123,53,110,278,500,333,69,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20166,20166,'Succubus',0,'',0,'Monster.succubus',10.00,36.00,32,'female','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1265,71,154,151,69,123,278,500,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(20167,20167,'Serpent Slave',0,'',0,'Monster.serpent_slave',17.00,46.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1977,128,273,201,131,164,278,500,333,73,0,0,77,121,'serpent_clan',300,0,0,'LAST_HIT'),
	(20168,20168,'Silenos',0,'',0,'Monster.silenos',14.00,32.50,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,333,88,0,0,77,121,'silenos_clan',300,0,0,'LAST_HIT'),
	(20169,20169,'Skeleton Royal Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,898,45,92,109,41,98,317,500,333,946,945,0,88,132,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20170,20170,'Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,454,19,35,69,14,62,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20171,20171,'Specter',0,'',0,'Monster.dark_horror',20.00,35.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,1078,54,96,120,41,98,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20172,20172,'Sylph',0,'',0,'Monster.sylph',11.00,35.00,10,'female','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,296,10,25,55,8,49,278,0,333,0,0,0,66,66,'elemental2_clan',300,0,0,'LAST_HIT'),
	(20173,20173,'Troll',0,'',0,'Monster.troll',21.00,35.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1332,76,182,143,75,128,278,500,333,0,0,0,60,121,NULL,0,0,0,'LAST_HIT'),
	(20174,20174,'Two-Headed Giant',0,'',0,'Monster.twin_headed_giant',17.00,39.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1499,89,174,186,89,137,278,500,333,4,0,0,49,110,NULL,0,0,0,'LAST_HIT'),
	(20175,20175,'Walking Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,237,8,18,55,6,45,278,0,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20176,20176,'Wyrm',0,'',0,'Monster.wyrm',29.00,72.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1817,108,211,154,89,137,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20177,20177,'Zombie',0,'',0,'Monster.zombie',13.00,21.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,178,5,15,50,5,41,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20189,20189,'Puma',0,'',0,'Monster.onyx_beast',14.00,14.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,441,18,40,69,14,62,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20190,20190,'Skeleton Marauder',0,'',0,'Monster.skeleton_archer',11.00,27.00,29,'male','L2Monster',500,906,349,5.53,1.53,40,43,30,21,20,10,1306,70,299,123,53,110,249,500,333,14,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20191,20191,'Skeleton Raider',0,'',0,'Monster.skeleton',11.00,25.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1335,73,127,128,58,114,317,500,333,946,945,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20192,20192,'Tyrant',0,'',0,'Monster.grave',15.00,29.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,333,0,0,0,77,191,'tyrant_clan',300,0,0,'LAST_HIT'),
	(20193,20193,'Tyrant Kingpin',0,'',0,'Monster.grave',15.00,29.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,1922,116,227,159,96,142,278,500,333,0,0,0,77,191,'tyrant_clan',300,0,0,'LAST_HIT'),
	(20194,20194,'Queen Undine',0,'',0,'Monster.undine',12.00,27.00,50,'female','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3090,233,560,253,264,226,278,500,333,0,0,0,66,66,NULL,0,0,0,'LAST_HIT'),
	(20197,20197,'Sorrow Maiden',0,'',0,'Monster.sylph',11.00,35.00,27,'female','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1102,56,104,125,45,102,278,0,333,0,0,0,66,66,NULL,0,0,0,'LAST_HIT'),
	(20198,20198,'Neer Ghoul Berserker',0,'',0,'Monster.neer_crawler',14.00,22.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1268,68,134,123,53,110,278,500,333,0,0,0,55,99,'neer_crawler_clan',300,1,0,'LAST_HIT'),
	(20199,20199,'Amber Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1557,85,120,155,58,114,278,0,333,0,0,0,38,144,NULL,0,0,0,'LAST_HIT'),
	(20200,20200,'Strain',0,'',0,'Monster.hungry_spirit',30.00,40.00,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1383,77,157,133,64,118,278,0,333,0,0,0,16,132,NULL,0,1,0,'LAST_HIT'),
	(20201,20201,'Ghoul',0,'',0,'Monster.zombie',13.00,21.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,2085,117,169,138,69,123,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20202,20202,'Dead Seeker',0,'',0,'Monster.vampire_bat',10.00,33.50,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1664,97,178,163,82,132,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20203,20203,'Dion Grizzly',0,'',0,'Monster.grizzly',21.00,40.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,705,31,52,104,23,76,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20204,20204,'Bloody Bee',0,'',0,'Monster.giant_bee',8.00,24.50,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,956,46,82,97,31,87,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20205,20205,'Dire Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,954,47,89,101,34,90,278,500,333,0,0,0,26,121,'wolf_clan',300,0,0,'LAST_HIT'),
	(20206,20206,'Kadif Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,982,49,97,105,37,94,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(20207,20207,'Ol Mahum Guerilla',0,'',0,'Monster.ol_mahum',13.50,25.00,26,'male','L2Monster',40,770,303,11.06,1.53,40,43,30,21,20,10,982,49,87,132,41,98,278,0,333,2,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20208,20208,'Ol Mahum Raider',0,'',0,'Monster.ol_mahum',13.50,25.00,27,'male','L2Monster',40,813,318,11.06,1.53,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,333,10,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20209,20209,'Ol Mahum Marksman',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,28,'male','L2Monster',500,859,334,11.06,1.53,40,43,30,21,20,10,1128,59,276,118,49,106,249,0,333,275,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20210,20210,'Ol Mahum Sergeant',0,'',0,'Monster.ol_mahum',13.50,25.00,29,'male','L2Monster',40,906,349,11.06,1.53,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,333,68,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20211,20211,'Ol Mahum Captain',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,30,'male','L2Monster',40,954,365,11.06,1.53,40,43,30,21,20,10,1241,68,145,128,58,114,278,500,333,123,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20212,20212,'Bloody Axe Turmak',0,'Ol Mahum Lord',0,'Monster.ol_mahum_champion',14.00,27.00,34,'male','L2Monster',40,1164,430,14.22,1.84,40,43,30,21,20,10,1469,86,196,148,82,132,278,500,333,69,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20213,20213,'Porta',0,'',0,'Monster.stone_golem',20.00,31.00,40,'male','L2Monster',40,1527,531,14.22,1.84,40,43,30,21,20,10,2364,152,248,222,131,164,278,0,333,0,0,0,25,25,'porta_clan',400,0,0,'LAST_HIT'),
	(20214,20214,'Excuro',0,'',0,'Monster.mana_vampire',11.00,20.00,41,'male','L2Monster',40,1593,560,17.38,2.14,40,43,30,21,20,10,2028,132,265,229,141,169,278,0,333,0,0,0,99,191,'porta_clan',400,0,0,'LAST_HIT'),
	(20215,20215,'Mordeo',0,'',0,'Monster.onyx_beast',14.00,14.50,42,'male','L2Monster',40,1660,589,17.38,2.14,40,43,30,21,20,10,2625,175,342,196,152,175,278,500,333,0,0,0,33,191,'beast_clan',400,0,0,'LAST_HIT'),
	(20216,20216,'Ricenseo',0,'',0,'Monster.monster_eye',21.00,43.00,43,'male','L2Monster',40,1728,618,17.38,2.14,40,43,30,21,20,10,2104,142,332,223,163,181,278,0,333,0,0,0,99,191,'porta_clan',400,0,0,'LAST_HIT'),
	(20217,20217,'Krator',0,'',0,'Monster.stone_golem',20.00,31.00,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,2688,184,322,253,176,187,278,500,333,0,0,0,25,25,'porta_clan',400,0,0,'LAST_HIT'),
	(20218,20218,'Premo',0,'',0,'Monster.troll',21.00,35.00,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,2812,195,415,216,188,193,278,0,333,0,0,0,60,191,'porta_clan',400,0,0,'LAST_HIT'),
	(20219,20219,'Validus',0,'',0,'Monster.grave',15.00,29.00,46,'male','L2Monster',40,1943,707,17.38,2.14,40,43,30,21,20,10,2408,170,365,270,202,199,278,0,333,0,0,0,77,191,'torfe_clan',400,0,0,'LAST_HIT'),
	(20220,20220,'Dicor',0,'',0,'Monster.mandragora_b',12.00,25.50,47,'female','L2Monster',40,2016,738,17.38,2.14,40,43,30,21,20,10,2867,205,469,230,216,206,278,500,333,0,0,0,88,191,'torfe_clan',400,0,0,'LAST_HIT'),
	(20221,20221,'Perum',0,'',0,'Monster.iron_golem',18.00,34.00,48,'male','L2Monster',40,2091,768,17.38,2.14,40,43,30,21,20,10,3438,251,412,288,231,212,278,500,333,0,0,0,22,22,'torfe_clan',300,0,0,'LAST_HIT'),
	(20222,20222,'Torfe',0,'',0,'Monster.grave',15.00,29.00,49,'male','L2Monster',40,2168,799,17.38,2.14,40,43,30,21,20,10,3025,223,529,245,247,219,278,0,333,0,0,0,77,191,'torfe_clan',300,0,0,'LAST_HIT'),
	(20223,20223,'Mandragora Sprout',0,'',0,'Monster.manadragora',14.00,17.80,20,'female','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,783,35,63,86,23,76,278,0,333,0,0,0,88,88,'mandragora_clan',300,0,0,'LAST_HIT'),
	(20224,20224,'Ol Mahum Ranger',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,22,'male','L2Monster',500,611,242,5.53,1.53,40,43,30,21,20,10,1059,50,139,113,28,83,249,0,333,13,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20225,20225,'Giant Mist Leech',0,'',0,'Monster.giant_leech',70.00,29.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,992,50,88,116,37,94,278,0,333,0,0,0,55,121,'giant_leech_clan',300,0,0,'LAST_HIT'),
	(20226,20226,'Gray Ant',0,'',0,'Monster.ant',26.00,15.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20227,20227,'Horror Mist Ripper',0,'',0,'Monster.dark_horror',20.00,35.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1124,58,114,114,45,102,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20228,20228,'Giant Crimson Ant',0,'',0,'Monster.ant_soldier',35.00,17.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1296,68,124,118,49,106,278,0,333,0,0,0,88,143,'ant_clan',300,0,0,'LAST_HIT'),
	(20229,20229,'Stinger Wasp',0,'',0,'Monster.giant_bee',8.00,24.50,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1454,79,120,155,58,114,278,500,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20230,20230,'Marsh Stakato Worker',0,'',0,'Monster.marsh_stakato_worker',9.00,21.00,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1663,92,142,146,64,118,278,0,333,153,0,0,22,154,'stakato_clan',300,0,0,'LAST_HIT'),
	(20231,20231,'Toad Lord',0,'',0,'Monster.poison_toad',20.00,10.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1622,91,140,167,69,123,278,0,333,0,0,0,55,110,NULL,0,0,0,'LAST_HIT'),
	(20232,20232,'Marsh Stakato Soldier',0,'',0,'Monster.marsh_stakato_soldier',10.00,25.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1583,91,132,173,75,128,317,0,333,217,0,0,33,170,'stakato_clan',300,0,0,'LAST_HIT'),
	(20233,20233,'Marsh Spider',0,'',0,'Monster.poison_spider',27.00,25.50,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1867,109,178,163,82,132,278,500,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(20234,20234,'Marsh Stakato Drone',0,'',0,'Monster.marsh_stakato_drone',9.00,24.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1889,112,185,154,89,137,317,500,333,219,0,0,88,191,'stakato_clan',300,0,0,'LAST_HIT'),
	(20235,20235,'Shackle',0,'',0,'Monster.hungry_spirit',30.00,40.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2974,207,343,262,188,193,278,500,333,0,0,0,16,191,NULL,0,1,0,'LAST_HIT'),
	(20236,20236,'Cave Servant',0,'',0,'Monster.skeleton',11.00,25.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3077,218,365,270,202,199,278,0,333,79,945,0,66,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20237,20237,'Cave Servant Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,47,'male','L2Monster',500,2016,738,8.69,2.14,40,43,30,21,20,10,4143,297,1043,230,216,206,249,0,333,14,0,0,44,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20238,20238,'Cave Servant Warrior',0,'',0,'Monster.skeleton',11.00,25.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3987,291,498,238,231,212,278,0,333,77,2495,0,66,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20239,20239,'Cave Servant Captain',0,'',0,'Monster.spartoi',11.00,27.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,4238,313,437,297,247,219,278,500,333,73,2495,0,66,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20240,20240,'Royal Cave Servant',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,4546,347,429,315,281,232,317,0,333,946,945,0,88,191,'cave_servant_clan',400,1,0,'LAST_HIT'),
	(20241,20241,'Hunter Gargoyle',0,'',0,'Monster.hunter_gargoyle',25.00,65.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,4633,358,627,268,300,239,278,0,333,0,0,0,110,191,NULL,0,0,0,'LAST_HIT'),
	(20242,20242,'Dustwind Gargoyle',0,'',0,'Monster.hunter_gargoyle',25.00,65.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4813,378,547,334,319,247,278,0,333,0,0,0,110,191,NULL,0,0,0,'LAST_HIT'),
	(20243,20243,'Thunder Wyrm',0,'',0,'Monster.wyrm',29.00,72.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4283,341,699,284,339,254,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20244,20244,'Malruk Succubus',0,'',0,'Monster.succubus',10.00,36.00,55,'female','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,333,0,0,0,66,191,'succubus_clan',300,0,0,'LAST_HIT'),
	(20245,20245,'Malruk Succubus Turen',0,'',0,'Monster.succubus',10.00,36.00,56,'female','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,4560,375,777,301,382,269,278,0,333,0,0,0,66,191,'succubus_clan',300,0,0,'LAST_HIT'),
	(20246,20246,'Cave Keeper',0,'',0,'Monster.serpent_slave',17.00,46.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,5822,492,751,318,428,284,317,0,333,223,0,0,77,191,'cave_servant_clan',300,0,0,'LAST_HIT'),
	(20248,20248,'Turak Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1397,78,129,161,64,118,278,0,333,88,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20249,20249,'Turak Bugbear Warrior',0,'',0,'Monster.bugbear',17.00,35.00,33,'male','L2Monster',40,1109,413,14.22,1.84,40,43,30,21,20,10,1502,86,151,173,75,128,278,500,333,73,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20250,20250,'Glass Jaguar',0,'',0,'Monster.onyx_beast',14.00,14.50,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1102,56,114,114,45,102,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20251,20251,'Delu Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1166,61,102,143,49,106,278,0,333,1,19,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(20252,20252,'Delu Lizardman Scout',0,'',0,'Monster.virud_lizardman',10.00,23.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1231,66,134,123,53,110,278,0,333,123,0,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(20253,20253,'Delu Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1321,72,120,155,58,114,278,500,333,16,0,0,57,143,NULL,0,0,0,'LAST_HIT'),
	(20254,20254,'Skeleton Axeman',0,'',0,'Monster.skeleton',11.00,25.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1201,63,113,130,49,106,278,500,333,86,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20255,20255,'Batur Orc',0,'',0,'Monster.batur_orc',9.00,21.50,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1164,65,129,161,64,118,278,0,333,123,0,0,88,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20256,20256,'Batur Orc Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,32,'male','L2Monster',500,1056,397,7.11,1.84,40,43,30,21,20,10,1600,90,311,167,69,123,249,0,333,13,0,0,49,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20257,20257,'Batur Orc Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1602,92,182,143,75,128,278,500,333,123,19,0,88,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20258,20258,'Batur Orc Shaman',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1401,82,196,148,82,132,278,0,333,7,0,0,55,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20259,20259,'Batur Orc Overlord',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1802,107,211,154,89,137,278,500,333,79,0,0,88,154,'orc_clan',300,0,0,'LAST_HIT'),
	(20260,20260,'Orc Champion',0,'',0,'Monster.orc_champion',10.00,23.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,435,17,30,80,12,59,278,500,333,2,0,0,49,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20261,20261,'Orc Shaman',0,'',0,'Monster.orc_shaman',9.00,22.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,504,21,40,91,17,67,278,0,333,7,0,0,49,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20265,20265,'Monster Eye Searcher',0,'',0,'Monster.monster_eye',21.00,43.00,22,'male','L2Monster',40,611,242,11.06,1.53,40,43,30,21,20,10,763,36,75,93,28,83,278,0,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20266,20266,'Monster Eye Gazer',0,'',0,'Monster.monster_eye',21.00,43.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,992,50,80,127,37,94,278,0,333,0,0,0,99,174,NULL,0,0,0,'LAST_HIT'),
	(20267,20267,'Breka Orc',0,'',0,'Monster.batur_orc',9.00,21.50,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1397,78,113,161,64,118,317,0,333,215,0,0,88,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20268,20268,'Breka Orc Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,32,'male','L2Monster',500,1056,397,7.11,1.84,40,43,30,21,20,10,1920,108,311,167,69,123,249,0,333,275,0,0,49,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20269,20269,'Breka Orc Shaman',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1681,98,162,179,82,132,278,0,333,7,0,0,55,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20270,20270,'Breka Orc Overlord',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,2380,141,211,154,89,137,278,500,333,79,0,0,88,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20271,20271,'Breka Orc Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1922,110,182,143,75,128,278,500,333,123,20,0,88,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20272,20272,'Cave Servant',0,'',0,'Monster.skeleton',11.00,25.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,2564,182,365,270,202,199,278,0,333,79,945,0,66,154,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20273,20273,'Cave Servant Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,47,'male','L2Monster',500,2016,738,8.69,2.14,40,43,30,21,20,10,2757,198,1043,230,216,206,249,0,333,275,0,0,44,154,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20274,20274,'Cave Servant Warrior',0,'',0,'Monster.skeleton',11.00,25.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,2792,204,498,238,231,212,278,0,333,77,0,0,66,154,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20275,20275,'Cave Servant Captain',0,'',0,'Monster.spartoi',11.00,27.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,2968,219,437,297,247,219,278,500,333,73,0,0,66,154,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20276,20276,'Royal Cave Servant',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3152,240,429,315,281,232,317,0,333,946,945,0,88,132,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20277,20277,'Cave Keeper',0,'',0,'Monster.serpent_slave',17.00,46.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,4077,344,751,318,428,284,317,0,333,223,0,0,77,121,'cave_servant_clan',300,0,0,'LAST_HIT'),
	(20279,20279,'Shackle',0,'',0,'Monster.hungry_spirit',30.00,40.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2478,172,343,262,188,193,278,500,333,0,0,0,16,132,NULL,0,1,0,'LAST_HIT'),
	(20280,20280,'Headless Knight',0,'',0,'Monster.headless_knight',21.00,31.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3090,233,463,306,264,226,278,500,333,124,0,0,77,121,NULL,0,1,0,'LAST_HIT'),
	(20281,20281,'Dustwind Gargoyle',0,'',0,'Monster.hunter_gargoyle',25.00,65.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,3370,265,547,334,319,247,278,0,333,0,0,0,110,110,NULL,0,0,0,'LAST_HIT'),
	(20282,20282,'Thunder Wyrm',0,'',0,'Monster.wyrm',29.00,72.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,3569,285,699,284,339,254,278,500,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(20283,20283,'Malruk Succubus',0,'',0,'Monster.succubus',10.00,36.00,55,'female','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,3666,296,737,292,360,261,278,0,333,0,0,0,66,110,'succubus_clan',300,0,0,'LAST_HIT'),
	(20284,20284,'Malruk Succubus Turen',0,'',0,'Monster.succubus',10.00,36.00,56,'female','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,3800,312,777,301,382,269,278,0,333,0,0,0,66,110,'succubus_clan',300,0,0,'LAST_HIT'),
	(20285,20285,'Drake',0,'',0,'Monster.drake',30.00,100.00,57,'male','L2Monster',40,2806,1052,10.27,2.45,40,43,30,21,20,10,4016,334,817,309,405,276,278,500,333,0,0,0,77,77,'dragon_clan',300,0,0,'LAST_HIT'),
	(20286,20286,'Hunter Gargoyle',0,'',0,'Monster.hunter_gargoyle',25.00,65.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,3244,251,627,268,300,239,278,0,333,0,0,0,110,110,NULL,0,0,0,'LAST_HIT'),
	(20287,20287,'Cave Maiden',0,'',0,'Monster.cave_maiden',25.00,65.00,59,'female','L2Monster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,4260,364,902,326,453,291,278,500,333,68,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(20291,20291,'Enku Orc Champion',0,'',0,'Monster.orc_champion',10.00,23.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,927,43,57,108,25,80,278,500,333,2,0,0,49,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20292,20292,'Enku Orc Shaman',0,'',0,'Monster.orc_shaman',9.00,22.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,813,36,52,104,23,76,278,0,333,7,0,0,49,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20293,20293,'Virud Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,593,26,52,104,23,76,278,0,333,291,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20294,20294,'Virud Lizardman Matriarch',0,'',0,'Monster.virud_lizardman_matriarch',13.00,37.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,951,47,89,101,34,90,278,500,333,2,19,0,61,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20295,20295,'Virud Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,698,33,75,93,28,83,278,500,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20296,20296,'Virud Lizardman Scout',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,21,'male','L2Monster',500,575,227,5.53,1.53,40,43,30,21,20,10,656,30,127,108,25,80,249,0,333,2507,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20297,20297,'Virud Lizardman Shaman ',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,731,35,68,117,31,87,278,0,333,7,0,0,47,132,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20298,20298,'Virud Lizardman Shaman ',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,731,35,68,117,31,87,278,0,333,7,0,0,47,132,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20299,20299,'Zenta Lizardman',0,'',0,'Monster.zenta_lizardman',11.00,32.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1939,125,248,222,131,164,278,0,333,68,0,0,40,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20300,20300,'Zenta Lizardman Matriarch',0,'',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,44,'male','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,2848,195,341,209,176,187,317,500,333,221,0,0,58,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20301,20301,'Zenta Lizardman Scout',0,'',0,'Monster.zenta_lizardman_scout',11.00,30.00,41,'male','L2Monster',500,1593,560,8.69,2.14,40,43,30,21,20,10,2098,137,589,229,141,169,249,0,333,14,0,0,40,165,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20302,20302,'Zenta Lizardman Warrior',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,333,16,0,0,44,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20303,20303,'Zenta Lizardman Shaman',0,'',0,'Monster.zenta_lizardman_shaman',13.00,35.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2240,152,302,245,163,181,278,0,333,7,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20304,20304,'Marsh Stakato Queen',0,'',0,'Monster.marsh_stakato_queen',15.00,37.00,36,'female','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,1906,115,227,159,96,142,278,500,333,74,0,0,143,143,'stakato_clan',300,0,0,'LAST_HIT'),
	(20305,20305,'Grave',0,'',0,'Monster.grave',15.00,29.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,1958,126,300,183,131,164,278,500,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20307,20307,'Garum Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,321,11,22,53,7,47,278,0,333,5,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20308,20308,'Hook Spider',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20309,20309,'Brown Fox',0,'',0,'Monster.fox',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,58,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20310,20310,'Brown Bear',0,'',0,'Monster.grizzly_bi',21.00,50.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,576,23,36,87,15,64,278,500,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20311,20311,'Rakeclaw Imp',0,'',0,'Monster.imp',10.00,24.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,213,6,16,46,5,41,278,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20312,20312,'Rakeclaw Imp Hunter',0,'',0,'Monster.imp',10.00,24.00,7,'male','L2Monster',40,171,94,3.16,0.91,40,43,30,21,20,10,249,8,18,48,6,43,278,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20313,20313,'Rakeclaw Imp Chieftain',0,'',0,'Monster.imp_bi',10.00,30.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,25,55,8,49,278,500,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20314,20314,'Great White Shark',0,'',0,'Monster.great_white_shark',20.00,7.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,2180,145,342,196,152,175,278,500,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20316,20316,'Darkwing Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,391,15,27,58,9,52,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20317,20317,'Black Wolf',0,'',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,141,4,12,46,4,37,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20318,20318,'Black Timber Wolf',0,'',0,'Monster.wolf_bi',13.00,10.80,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,211,6,15,50,5,41,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20319,20319,'Goblin Grave Robber',0,'',0,'Monster.goblin',10.00,16.50,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,178,5,13,48,4,39,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20320,20320,'Goblin Tomb Raider Leader',0,'',0,'Monster.goblin_bi',10.00,21.40,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,427,16,24,66,10,54,317,0,333,12,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20321,20321,'Goblin Thief',0,'',0,'Monster.goblin_bi',10.00,21.40,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,356,12,20,61,8,49,317,0,333,217,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20322,20322,'Goblin Brigand',0,'',0,'Monster.goblin',10.00,16.50,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,284,10,18,55,6,45,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20323,20323,'Goblin Brigand Leader',0,'',0,'Monster.goblin_bi',10.00,21.40,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,508,20,29,73,12,59,317,500,333,217,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20324,20324,'Goblin Brigand Lieutenant',0,'',0,'Monster.goblin',10.00,16.50,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,20,61,8,49,317,500,333,10,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20325,20325,'Goblin Raider',0,'',0,'Monster.goblin',10.00,16.50,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,178,5,13,48,4,39,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20326,20326,'Goblin Scout',0,'',0,'Monster.goblin',10.00,16.50,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,284,10,18,55,6,45,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20327,20327,'Goblin Snooper',0,'',0,'Monster.goblin',10.00,16.50,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,178,5,13,48,4,39,278,0,333,4,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20328,20328,'Goblin Lookout',0,'',0,'Monster.goblin',10.00,16.50,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,284,10,16,55,6,45,317,0,333,12,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20329,20329,'Ghost Guardian',0,'',0,'Monster.human_ghost',8.00,22.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,643,30,63,98,25,80,278,500,333,0,0,0,88,154,NULL,0,1,0,'LAST_HIT'),
	(20330,20330,'Mineshaft Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,326,12,27,58,9,52,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20331,20331,'Monster Eye Tracker',0,'',0,'Monster.monster_eye',21.00,43.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,296,10,20,67,8,49,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20333,20333,'Greystone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,654,26,27,77,11,56,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20334,20334,'Gremlin Scavenger',0,'',0,'Monster.gremlin',10.00,15.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,9,39,3,32,278,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(20335,20335,'Grizzly Bear',0,'',0,'Monster.grizzly_bi',21.00,50.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,599,25,40,91,17,67,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20336,20336,'Green Dryad',0,'',0,'Monster.dryad_sm',6.00,15.00,8,'female','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,284,10,18,55,6,45,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20337,20337,'Longtail Fox',0,'',0,'Monster.fox',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,58,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20338,20338,'Nightmare Weaver',0,'',0,'Monster.magical_weaver',11.00,20.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,707,33,69,89,25,80,278,500,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20340,20340,'Slave Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,26,60,10,54,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20341,20341,'Undead Slave',0,'',0,'Monster.zombie',13.00,21.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,799,36,58,82,21,73,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20342,20342,'Werewolf Chieftain',0,'',0,'Monster.werewolf_bi',11.00,29.70,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,436,16,30,60,10,54,278,500,333,5,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20343,20343,'Werewolf Hunter',0,'',0,'Monster.werewolf',10.00,26.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,25,55,8,49,278,500,333,5,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20345,20345,'Dark Terror',0,'',0,'Monster.dark_horror',20.00,35.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,533,22,44,72,15,64,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20346,20346,'Darkstone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,545,21,27,77,11,56,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20347,20347,'Death Wraith',0,'',0,'Monster.death_blader',15.00,45.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,3739,302,737,292,360,261,278,500,333,1472,0,0,110,191,'undead_clan',300,1,0,'LAST_HIT'),
	(20348,20348,'Cave Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,445,18,40,69,14,62,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20349,20349,'Cave Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,385,15,33,63,11,56,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20350,20350,'Cave Fang Spider',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,485,20,44,72,15,64,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20351,20351,'Dre Vanul Tracker',0,'',0,'Monster.dre_vanul',14.00,36.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,63,86,23,76,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20352,20352,'Dre Vanul Slayer',0,'',0,'Monster.dre_vanul',14.00,36.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,767,36,75,93,28,83,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20353,20353,'Dre Vanul Beholder',0,'',0,'Monster.dre_vanul',14.00,36.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,69,89,25,80,278,500,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20354,20354,'Dwarf Ghost',0,'',0,'Monster.dwarf_ghost',9.00,16.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,63,86,23,76,278,500,333,0,0,0,88,154,'ghost_clan',300,1,0,'LAST_HIT'),
	(20356,20356,'Langk Lizardman Leader',0,'',0,'Monster.virud_lizardman_warrior_bi',12.00,34.50,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,1012,51,80,127,37,94,278,500,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20357,20357,'Langk Lizardman Lieutenant',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,821,39,62,113,28,83,278,0,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20358,20358,'Ratman Hunter',0,'',0,'Monster.wererat',14.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,640,28,38,95,19,70,317,0,333,11,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20359,20359,'Ratman Warrior',0,'',0,'Monster.wererat',14.00,25.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,678,30,58,82,21,73,278,0,333,2,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20360,20360,'Ratman Spy',0,'',0,'Monster.wererat_sm',12.00,18.70,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,39,72,15,64,317,0,333,12,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20361,20361,'Tunath Orc Marksman',0,'',0,'Monster.orc_archer',14.00,25.00,10,'male','L2Monster',500,257,120,3.16,0.91,40,43,30,21,20,10,305,10,51,61,8,49,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20362,20362,'Tunath Orc Warrior',0,'',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,25,73,10,54,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20363,20363,'Maraku Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,321,11,22,53,7,47,278,0,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20364,20364,'Maraku Werewolf Chieftain',0,'',0,'Monster.werewolf_bi',11.00,29.70,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,508,20,32,66,12,59,317,500,333,217,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20365,20365,'Mountain Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,284,10,20,50,6,45,278,0,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20367,20367,'Merkenis Escort',0,'',0,'Monster.spartoi',11.00,27.00,20,'male','L2Minion',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,52,104,23,76,278,500,333,68,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20368,20368,'Grave Keeper',0,'',0,'Monster.stone_golem',20.00,31.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,545,21,27,77,11,56,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20369,20369,'Moonstone Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,599,25,48,75,17,67,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20370,20370,'Barbed Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,427,16,30,60,10,54,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20371,20371,'Mist Terror',0,'',0,'Monster.dark_horror',20.00,35.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,454,19,40,69,14,62,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20372,20372,'Baraq Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,302,10,25,55,8,49,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20373,20373,'Baraq Orc Warrior Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,326,12,27,58,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20374,20374,'Baranka''s Guard',0,'',0,'Monster.spartoi',11.00,27.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,910,43,62,113,28,83,278,500,333,68,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20375,20375,'Baranka''s Escort',0,'',0,'Monster.spartoi',11.00,27.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,50,108,25,80,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20376,20376,'Varikan Brigand Leader',0,'',0,'Monster.goblin_bi',10.00,21.40,10,'male','L2Monster',40,257,120,6.32,0.91,40,43,30,21,20,10,503,17,22,61,8,49,278,500,333,12,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20377,20377,'Varika''s Bandit',0,'',0,'Monster.goblin',10.00,16.50,7,'male','L2Minion',40,171,94,1.58,0.91,40,43,30,21,20,10,334,12,20,44,6,43,278,0,333,0,0,0,44,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(20378,20378,'Stone Giant',0,'',0,'Monster.stone_golem',20.00,31.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,545,21,27,77,11,56,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20379,20379,'Stone Soldier',0,'',0,'Monster.stone_golem',20.00,31.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,705,27,30,80,12,59,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20380,20380,'Stone Guardian',0,'',0,'Monster.stone_golem',20.00,31.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,807,33,36,87,15,64,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20381,20381,'Vaiss Orc',0,'',0,'Monster.orc',10.00,21.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,296,10,22,61,8,49,278,0,333,156,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20382,20382,'Vaiss Orc Warrior Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,326,12,27,58,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20383,20383,'Arachnid Hunter',0,'',0,'Monster.binding',12.00,21.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1223,67,120,155,58,114,278,500,333,0,0,0,11,154,'undead_clan',300,1,0,'LAST_HIT'),
	(20385,20385,'Balor Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,293,10,41,55,6,45,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20386,20386,'Balor Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,25,55,8,49,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20387,20387,'Balor Orc Fighter Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,436,16,30,60,10,54,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20388,20388,'Balor Orc Lieutenant',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,391,15,27,58,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20389,20389,'Boogle Ratman',0,'',0,'Monster.wererat',14.00,25.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,475,19,39,72,15,64,317,0,333,12,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20390,20390,'Boogle Ratman Leader',0,'',0,'Monster.wererat',14.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,533,23,46,79,19,70,317,0,333,12,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20391,20391,'Red Fox',0,'',0,'Monster.fox',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,58,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20392,20392,'Redeye Bat',0,'',0,'Monster.vampire_bat_bi',10.00,42.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,40,69,14,62,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20393,20393,'Red Scavenger Spider',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20394,20394,'Crimson Tarantula',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,449,18,40,69,14,62,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20398,20398,'Vrykolakas',0,'',0,'Monster.werewolf_bi',11.00,29.70,15,'male','L2Monster',40,390,165,7.90,1.21,40,43,30,21,20,10,692,28,40,69,14,62,278,500,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20399,20399,'Vrykolakas Wolfkin',0,'',0,'Monster.wolf_bi',13.00,10.80,9,'male','L2Minion',40,226,111,1.58,0.91,40,43,30,21,20,10,354,12,25,48,7,47,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20400,20400,'Blood Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,427,16,30,60,10,54,278,0,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20401,20401,'Veelan Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,878,42,68,117,31,87,278,0,333,156,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20402,20402,'Veelan Bugbear Warrior',0,'',0,'Monster.bugbear',17.00,35.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,954,47,89,101,34,90,278,500,333,88,0,0,60,143,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20403,20403,'Hunter Tarantula',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20404,20404,'Silent Horror',0,'',0,'Monster.dark_horror',20.00,35.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,485,20,44,72,15,64,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20405,20405,'Young Brown Fox',0,'',0,'Monster.fox',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,10,36,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20406,20406,'Young Red Fox',0,'',0,'Monster.fox',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,10,36,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20407,20407,'Young Crimson Fox',0,'',0,'Monster.fox',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,29,2,10,36,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20410,20410,'Scavenger Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,545,22,40,69,14,62,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20411,20411,'Scavenger Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,640,28,53,79,19,70,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20412,20412,'Susceptor',0,'',0,'Monster.susceptor',20.00,35.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,2910,215,437,297,247,219,278,500,333,0,0,0,29,191,NULL,0,0,0,'LAST_HIT'),
	(20415,20415,'Scarlet Salamander',0,'',0,'Monster.salamander',16.00,6.80,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,555,23,48,75,17,67,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(20416,20416,'Scarlet Salamander Elder',0,'',0,'Monster.salamander',16.00,6.80,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,586,26,53,79,19,70,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(20418,20418,'Crystalline Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,633,28,53,79,19,70,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20419,20419,'Akaste Succubus',0,'',0,'Monster.succubus',10.00,36.00,20,'female','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,63,86,23,76,278,500,333,0,0,0,66,110,'succubus_clan',300,0,0,'LAST_HIT'),
	(20420,20420,'Akaste Succubus Turen',0,'',0,'Monster.succubus',10.00,36.00,21,'female','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,649,30,69,89,25,80,278,500,333,0,0,0,66,110,'succubus_clan',300,0,0,'LAST_HIT'),
	(20421,20421,'Akaste Succubus Tilfo',0,'',0,'Monster.succubus_bi',10.00,43.20,22,'female','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,698,33,75,93,28,83,278,500,333,0,0,0,66,110,'succubus_clan',300,0,0,'LAST_HIT'),
	(20422,20422,'Akaste Bone Warlord',0,'',0,'Monster.skeleton',11.00,25.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,612,26,48,75,17,67,278,500,333,2,18,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20423,20423,'Akaste Bone Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,14,'male','L2Monster',500,364,156,3.95,1.21,40,43,30,21,20,10,428,17,68,80,12,59,249,0,333,275,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20424,20424,'Akaste Bone Lord',0,'',0,'Monster.skeleton',11.00,25.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,592,26,58,82,21,73,278,500,333,68,19,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20425,20425,'Akaste Bone Soldier',0,'',0,'Monster.skeleton',11.00,25.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,26,60,10,54,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20426,20426,'Evil Eye',0,'',0,'Monster.monster_eye',21.00,43.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,356,12,20,67,8,49,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20427,20427,'Evil Eye Watcher',0,'',0,'Monster.monster_eye',21.00,43.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,296,10,20,67,8,49,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20428,20428,'Evil Eye Patroller',0,'',0,'Monster.monster_eye',21.00,43.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,30,80,12,59,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20429,20429,'Evil Eye Lookout',0,'',0,'Monster.monster_eye',21.00,43.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,415,16,30,80,12,59,278,0,333,0,0,0,99,147,NULL,0,0,0,'LAST_HIT'),
	(20431,20431,'Elf Ghost',0,'',0,'Monster.elf_ghost',7.00,21.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,52,104,23,76,278,500,333,0,0,0,88,154,NULL,0,1,0,'LAST_HIT'),
	(20432,20432,'Elpy',0,'',0,'Monster.elpy',5.00,4.50,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,55,88,NULL,0,0,0,'LAST_HIT'),
	(20433,20433,'Festering Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,462,18,33,63,11,56,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20435,20435,'Opal Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,449,18,40,69,14,62,278,500,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20436,20436,'Ol Mahum Supplier',0,'',0,'Monster.ol_mahum_bi',14.00,29.20,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,878,42,68,117,31,87,278,0,333,2,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20437,20437,'Ol Mahum Recruit',0,'',0,'Monster.ol_mahum',13.50,25.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,57,108,25,80,278,0,333,68,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20438,20438,'Ol Mahum General',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,1078,54,105,109,41,98,278,500,333,67,102,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20439,20439,'Ol Mahum Officer',0,'',0,'Monster.ol_mahum',13.50,25.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,935,46,74,122,34,90,278,0,333,66,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20440,20440,'Elder Brown Fox',0,'',0,'Monster.fox',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,88,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20441,20441,'Elder Longtail Fox',0,'',0,'Monster.fox',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,88,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20442,20442,'Elder Wolf',0,'',0,'Monster.wolf',13.00,9.00,5,'male','L2Monster',40,126,77,3.16,0.91,40,43,30,21,20,10,176,5,13,48,4,39,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20443,20443,'Elder Red Fox',0,'',0,'Monster.fox',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,88,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20444,20444,'Elder Prairie Fox',0,'',0,'Monster.fox',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,88,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20445,20445,'Uthanka Pirate',0,'',0,'Monster.orc',10.00,21.00,7,'male','L2Minion',40,171,94,1.58,0.91,40,43,30,21,20,10,307,10,20,44,6,43,278,0,333,3,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20446,20446,'Utuku Orc',0,'',0,'Monster.orc',10.00,21.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,213,6,15,50,5,41,278,0,333,156,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20447,20447,'Utuku Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,293,10,41,55,6,45,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20448,20448,'Utuku Orc Grunt',0,'',0,'Monster.orc',10.00,21.00,7,'male','L2Monster',40,171,94,3.16,0.91,40,43,30,21,20,10,249,8,17,53,6,43,278,0,333,3,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20449,20449,'Will-O-Wisp',0,'',0,'Monster.will_o_wisp',13.00,22.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,533,22,40,69,14,62,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(20450,20450,'Relic Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,267,9,22,53,7,47,278,0,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(20451,20451,'Relic Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,21,'male','L2Monster',40,575,227,11.06,1.53,40,43,30,21,20,10,592,27,57,108,25,80,278,0,333,68,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20453,20453,'Human Ghost',0,'',0,'Monster.human_ghost',8.00,22.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,605,27,52,104,23,76,278,500,333,0,0,0,88,154,'ghost_clan',300,1,0,'LAST_HIT'),
	(20454,20454,'Oblivion Watcher',0,'',0,'Monster.monster_eye',21.00,43.00,17,'male','L2Minion',40,446,184,1.98,1.21,40,43,30,21,20,10,454,20,53,68,17,67,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20455,20455,'Doom Soldier',0,'',0,'Monster.skeleton',11.00,25.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,424,16,32,66,12,59,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20456,20456,'Ashen Wolf',0,'',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,141,4,12,46,4,37,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20457,20457,'Zombie Soldier',0,'',0,'Monster.zombie',13.00,21.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,958,43,58,82,21,73,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20458,20458,'Zombie Warrior',0,'',0,'Monster.zombie_bi',12.00,27.50,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,1184,56,75,93,28,83,278,500,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20460,20460,'Crimson Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,545,22,40,69,14,62,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20461,20461,'Dungeon Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,454,19,40,69,14,62,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20462,20462,'Cave Blade Spider',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,515,22,48,75,17,67,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20463,20463,'Dungeon Skeleton Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,13,'male','L2Monster',500,339,147,3.95,1.21,40,43,30,21,20,10,397,16,61,77,11,56,249,0,333,275,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20464,20464,'Dungeon Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,26,60,10,54,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20465,20465,'Prairie Fox',0,'',0,'Monster.fox',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,58,2,11,38,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20466,20466,'Pincer Spider',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20468,20468,'Kaboo Orc',0,'',0,'Monster.orc',10.00,21.00,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,213,6,15,50,5,41,278,0,333,156,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20469,20469,'Kaboo Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,293,10,41,55,6,45,249,0,333,14,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20470,20470,'Kaboo Orc Grunt',0,'',0,'Monster.orc',10.00,21.00,7,'male','L2Monster',40,171,94,3.16,0.91,40,43,30,21,20,10,249,8,17,53,6,43,278,0,333,3,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20471,20471,'Kaboo Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,363,12,20,67,8,49,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20472,20472,'Kaboo Orc Fighter Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,436,16,25,73,10,54,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20473,20473,'Kaboo Orc Fighter Lieutenant',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,391,15,23,70,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20474,20474,'Kasha Spider',0,'',0,'Monster.giant_spider',26.00,25.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,40,69,14,62,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20475,20475,'Kasha Wolf',0,'',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,141,4,12,46,4,37,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20476,20476,'Kasha Fang Spider',0,'',0,'Monster.giant_spider',26.00,25.50,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20477,20477,'Kasha Timber Wolf',0,'',0,'Monster.wolf_bi',13.00,10.80,6,'male','L2Monster',40,147,85,3.16,0.91,40,43,30,21,20,10,211,6,15,50,5,41,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20478,20478,'Kasha Blade Spider',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,666,28,48,75,17,67,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20479,20479,'Kasha Bear',0,'',0,'Monster.grizzly_bi',21.00,50.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,539,22,33,84,14,62,278,500,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20480,20480,'Blade Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,356,12,25,55,8,49,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20481,20481,'Bearded Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20483,20483,'Corpse Candle',0,'',0,'Monster.will_o_wisp',13.00,22.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,604,25,40,91,17,67,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(20487,20487,'Kuruka Ratman',0,'',0,'Monster.wererat',14.00,25.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,475,19,32,87,15,64,317,0,333,216,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20488,20488,'Kuruka Ratman Hunter',0,'',0,'Monster.wererat',14.00,25.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,504,21,40,91,17,67,278,0,333,3,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(20489,20489,'Quicksilver Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,449,18,40,69,14,62,278,500,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20490,20490,'Death Doll',0,'',0,'Monster.crimson_doll',15.00,38.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2175,141,300,183,131,164,278,500,333,0,0,0,66,165,'undead_clan',300,1,0,'LAST_HIT'),
	(20491,20491,'Crypt Horror',0,'',0,'Monster.dark_horror',20.00,35.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,454,19,40,69,14,62,278,500,333,0,0,0,110,110,NULL,0,1,0,'LAST_HIT'),
	(20492,20492,'Kirunak''s Guards',0,'',0,'Monster.spartoi',11.00,27.00,21,'male','L2Minion',40,575,227,5.53,1.53,40,43,30,21,20,10,636,29,57,108,25,80,278,0,333,68,0,0,66,154,'kirunak_clan',300,1,0,'LAST_HIT'),
	(20494,20494,'Turek War Hound',0,'',0,'Monster.dire_wolf',13.00,11.00,24,'male','L2Monster',40,687,272,11.06,1.53,40,43,30,21,20,10,869,43,89,101,34,90,278,0,333,0,0,0,26,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20495,20495,'Turek Orc Warlord',0,'',0,'Monster.orc_champion',10.00,23.00,30,'male','L2Monster',40,954,365,11.06,1.53,40,43,30,21,20,10,1390,76,120,155,58,114,278,500,333,127,0,0,49,143,'orc_clan',300,0,0,'LAST_HIT'),
	(20496,20496,'Turek Orc Archer',0,'',0,'Monster.orc_archer',14.00,25.00,27,'male','L2Monster',500,813,318,11.06,1.53,40,43,30,21,20,10,1076,55,231,125,45,102,249,0,333,14,0,0,49,121,'orc_clan',400,0,0,'LAST_HIT'),
	(20497,20497,'Turek Orc Skirmisher',0,'',0,'Monster.orc_fighter',12.00,22.00,28,'male','L2Monster',40,859,334,11.06,1.53,40,43,30,21,20,10,1117,58,102,143,49,106,278,500,333,121,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20498,20498,'Turek Orc Supplier',0,'',0,'Monster.orc_fighter',12.00,22.00,27,'male','L2Monster',40,813,318,11.06,1.53,40,43,30,21,20,10,1035,53,83,138,45,102,317,0,333,11,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20499,20499,'Turek Orc Footman',0,'',0,'Monster.orc',10.00,21.00,26,'male','L2Monster',40,770,303,11.06,1.53,40,43,30,21,20,10,982,49,96,120,41,98,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20500,20500,'Turek Orc Sentinel',0,'',0,'Monster.orc',10.00,21.00,25,'male','L2Monster',40,728,287,11.06,1.53,40,43,30,21,20,10,922,46,88,116,37,94,278,0,333,3,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20501,20501,'Turek Orc Shaman',0,'',0,'Monster.orc_shaman',9.00,22.00,29,'male','L2Monster',40,906,349,11.06,1.53,40,43,30,21,20,10,1156,62,111,149,53,110,278,0,333,7,0,0,49,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20502,20502,'Twink Puma',0,'',0,'Monster.onyx_beast',14.00,14.50,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,539,22,40,69,14,62,278,500,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20504,20504,'Dread Soldier',0,'',0,'Monster.skeleton',11.00,25.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,424,16,32,66,12,59,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20505,20505,'Ruin Bat',0,'',0,'Monster.vampire_bat_bi',10.00,42.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,712,32,63,86,23,76,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20506,20506,'Ruin Imp',0,'',0,'Monster.imp_bi',10.00,30.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,605,25,48,75,17,67,278,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20507,20507,'Ruin Imp Elder',0,'',0,'Monster.imp_bi',10.00,30.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,779,36,69,89,25,80,278,500,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20508,20508,'Plunder Tarantula',0,'',0,'Monster.giant_spider',26.00,25.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,48,75,17,67,278,500,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(20509,20509,'Spore Fungus',0,'',0,'Monster.walking_fungus',15.00,22.50,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,321,11,22,53,7,47,278,0,333,0,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(20510,20510,'Puma',0,'',0,'Monster.onyx_beast',14.00,14.50,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,423,16,30,60,10,54,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20511,20511,'Pitchstone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,799,36,48,99,21,73,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20512,20512,'Field Stalker',0,'',0,'Monster.field_stalker',15.00,30.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1812,107,211,154,89,137,278,500,333,0,0,0,77,121,'monster_eye_clan',300,0,0,'LAST_HIT'),
	(20513,20513,'Skeleton Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1265,71,140,167,69,123,278,500,333,150,0,0,44,176,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20514,20514,'Shield Skeleton',0,'',0,'Monster.skeleton',11.00,25.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,534,22,40,69,14,62,278,0,333,157,103,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20515,20515,'Skeleton Infantryman',0,'',0,'Monster.skeleton',11.00,25.00,16,'male','L2Monster',40,417,174,3.95,1.21,40,43,30,21,20,10,570,23,44,72,15,64,278,0,333,157,18,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20516,20516,'Skeleton Sentinel',0,'',0,'Monster.skeleton_bi',11.00,31.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,424,16,32,66,12,59,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20517,20517,'Skeleton Hunter',0,'',0,'Monster.skeleton',11.00,25.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,363,13,26,60,10,54,317,500,333,946,0,0,66,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20518,20518,'Skeleton Hunter Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,13,'male','L2Monster',500,339,147,3.95,1.21,40,43,30,21,20,10,397,16,61,77,11,56,249,0,333,275,0,0,44,154,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20519,20519,'Skeleton Pikeman',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,946,48,114,114,45,102,278,500,333,299,0,0,55,170,'skeleton_clan',300,1,0,'LAST_HIT'),
	(20520,20520,'Pirate Captain Uthanka',0,'',0,'Monster.orc_fighter_bi',12.00,26.40,10,'male','L2Monster',40,257,120,6.32,0.91,40,43,30,21,20,10,463,16,20,67,8,49,278,500,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(20521,20521,'Whinstone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,705,27,30,80,12,59,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20522,20522,'White Fang',0,'',0,'Monster.wolf_bi',13.00,10.80,10,'male','L2Monster',40,257,120,6.32,0.91,40,43,30,21,20,10,458,15,22,61,8,49,278,500,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20524,20524,'Grey Wolf Elder',0,'',0,'Monster.wolf',13.00,9.00,7,'male','L2Minion',40,171,94,1.58,0.91,40,43,30,21,20,10,304,10,20,44,6,43,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20525,20525,'Gray Wolf',0,'',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,141,4,12,46,4,37,278,0,333,0,0,0,26,121,NULL,0,0,0,'LAST_HIT'),
	(20526,20526,'Obsidian Golem',0,'',0,'Monster.stone_golem',20.00,31.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,755,31,33,84,14,62,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20527,20527,'White Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,121,3,13,42,4,37,278,500,333,0,0,0,26,121,'wolf_clan',300,0,0,'LAST_HIT'),
	(20528,20528,'Goblin Lord',0,'',0,'Monster.goblin',10.00,16.50,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,458,18,29,63,11,56,317,0,333,217,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20529,20529,'Young Brown Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20530,20530,'Young Red Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20531,20531,'Young Prairie Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20532,20532,'Brown Keltir',0,'',0,'Monster.keltir',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,70,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20533,20533,'Longtail Keltir',0,'',0,'Monster.keltir',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,70,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20534,20534,'Red Keltir',0,'',0,'Monster.keltir',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,70,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20535,20535,'Prairie Keltir',0,'',0,'Monster.keltir',9.50,10.00,2,'male','L2Monster',40,75,52,3.16,0.91,40,43,30,21,20,10,70,2,10,42,3,34,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20536,20536,'Elder Brown Keltir',0,'',0,'Monster.keltir',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,105,2,11,44,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20537,20537,'Elder Red Keltir',0,'',0,'Monster.keltir',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,105,2,11,44,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20538,20538,'Elder Prairie Keltir',0,'',0,'Monster.keltir',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,105,2,11,44,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20539,20539,'Elder Longtail Keltir',0,'',0,'Monster.keltir',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,105,2,11,44,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20540,20540,'Gemstone Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,352,13,25,73,10,54,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(20541,20541,'Ore Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,499,21,48,75,17,67,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(20542,20542,'Skeleton Longbowman',0,'',0,'Monster.skeleton_archer',11.00,27.00,19,'male','L2Monster',500,508,203,3.95,1.21,40,43,30,21,20,10,587,26,129,82,21,73,249,500,333,275,0,0,44,154,NULL,0,1,0,'LAST_HIT'),
	(20543,20543,'Ghost',0,'',0,'Monster.human_ghost',8.00,22.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,599,27,63,86,23,76,278,500,333,0,0,0,88,154,NULL,0,1,0,'LAST_HIT'),
	(20544,20544,'Elder Keltir',0,'',0,'Monster.keltir',9.50,10.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,105,2,12,40,3,35,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20545,20545,'Young Keltir',0,'',0,'Monster.keltir',9.50,10.00,1,'male','L2Monster',40,62,44,3.16,0.91,40,43,30,21,20,10,35,2,9,39,3,32,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(20546,20546,'Turek Orc Elder',0,'',0,'Monster.orc_shaman',9.00,22.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1714,100,162,179,82,132,278,500,333,7,0,0,49,132,'orc_clan',300,0,0,'LAST_HIT'),
	(20547,20547,'Ol Mahum Reserve',0,'',0,'Monster.ol_mahum_bi',14.00,29.20,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,878,42,68,117,31,87,278,0,333,2,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20548,20548,'Ol Mahum Deserter',0,'',0,'Monster.ol_mahum',13.50,25.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,895,43,75,107,31,87,278,500,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20549,20549,'Ol Mahum Lord',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,34,'male','L2Monster',40,1164,430,14.22,1.84,40,43,30,21,20,10,1763,103,196,148,82,132,278,500,333,69,19,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20550,20550,'Guardian Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,1960,118,206,175,96,142,278,0,333,0,0,0,38,191,NULL,0,0,0,'LAST_HIT'),
	(20551,20551,'Road Scavenger',0,'',0,'Monster.wererat',14.00,25.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,1991,122,194,154,104,147,317,0,333,221,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20552,20552,'Fettered Soul',0,'',0,'Monster.binding',12.00,21.00,38,'male','L2Monster',40,1400,497,14.22,1.84,40,43,30,21,20,10,2146,134,238,188,112,153,278,0,333,0,0,0,11,191,NULL,0,1,0,'LAST_HIT'),
	(20553,20553,'Windsus',0,'',0,'Monster.giant_wild_hog',35.00,27.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2212,141,255,195,121,158,278,0,333,0,0,0,38,191,NULL,0,0,0,'LAST_HIT'),
	(20554,20554,'Grandis',0,'',0,'Monster.twin_headed_giant',17.00,39.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2585,167,273,201,131,164,278,500,333,0,0,0,49,191,NULL,0,0,0,'LAST_HIT'),
	(20555,20555,'Giant Fungus',0,'',0,'Monster.walking_fungus_bi',15.00,31.30,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20556,20556,'Giant Monstereye',0,'',0,'Monster.monster_eye_bi',29.00,60.00,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,2444,160,321,189,141,169,278,0,333,0,0,0,99,191,NULL,0,0,0,'LAST_HIT'),
	(20557,20557,'Dire Wyrm',0,'',0,'Monster.wyrm',29.00,72.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,2590,173,283,237,152,175,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20558,20558,'Rotting tree',0,'',0,'Monster.hanged_man_ripper',35.00,80.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2662,180,302,245,163,181,278,0,333,0,0,0,60,191,NULL,0,0,0,'LAST_HIT'),
	(20559,20559,'Rotting Golem',0,'',0,'Monster.stone_golem_bi_one',22.00,43.40,44,'male','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,3942,270,322,253,176,187,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20560,20560,'Trisalim Spider',0,'',0,'Monster.giant_spider',26.00,25.50,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2916,203,415,216,188,193,278,0,333,0,0,0,79,191,NULL,0,0,0,'LAST_HIT'),
	(20561,20561,'Trisalim Tarantula',0,'',0,'Monster.poison_spider',27.00,25.50,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3452,245,365,270,202,199,278,500,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20562,20562,'Spore Zombie',0,'',0,'Monster.zombie_bi',12.00,27.50,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,3591,257,469,230,216,206,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20563,20563,'Manashen Gargoyle',0,'',0,'Monster.gargoyle',16.00,50.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2769,179,300,183,131,164,278,0,333,0,0,0,154,191,NULL,0,0,0,'LAST_HIT'),
	(20564,20564,'Enchanted Monstereye',0,'',0,'Monster.monster_eye',21.00,43.00,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,2493,163,321,189,141,169,278,500,333,0,0,0,99,191,NULL,0,0,0,'LAST_HIT'),
	(20565,20565,'Enchanted Stone Golem',0,'',0,'Monster.stone_golem_bi',20.00,40.30,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,3627,242,342,196,152,175,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(20566,20566,'Enchanted Iron Golem',0,'',0,'Monster.iron_golem',18.00,34.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,3802,257,302,245,163,181,278,0,333,0,0,0,22,22,NULL,0,0,0,'LAST_HIT'),
	(20567,20567,'Enchanted Gargoyle',0,'',0,'Monster.gargoyle',16.00,50.00,44,'male','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,3350,229,390,209,176,187,278,0,333,0,0,0,154,191,NULL,0,0,0,'LAST_HIT'),
	(20568,20568,'Formor',0,'',0,'Monster.troll',21.00,35.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2945,205,377,238,188,193,278,0,333,0,0,0,60,191,'beast_clan',300,0,0,'LAST_HIT'),
	(20569,20569,'Formor Elder',0,'',0,'Monster.troll',21.00,35.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3200,227,401,245,202,199,278,0,333,0,0,0,60,191,'beast_clan',300,0,0,'LAST_HIT'),
	(20570,20570,'Tarlk Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,3212,230,427,253,216,206,278,0,333,88,0,0,60,191,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20571,20571,'Tarlk Bugbear Warrior',0,'',0,'Monster.bugbear',17.00,35.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3793,277,453,261,231,212,278,500,333,169,0,0,60,191,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20572,20572,'Tarlk Bugbear High Warrior',0,'',0,'Monster.king_bugbear',15.00,40.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,4155,307,529,245,247,219,278,0,333,160,0,0,60,191,'bugbear_clan',300,0,0,'LAST_HIT'),
	(20573,20573,'Tarlk Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3600,271,463,306,264,226,278,0,333,0,0,0,38,191,NULL,0,0,0,'LAST_HIT'),
	(20574,20574,'Elder Tarlk Basilisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3820,291,593,260,281,232,278,500,333,0,0,0,38,191,NULL,0,0,0,'LAST_HIT'),
	(20575,20575,'Oel Mahum Warrior',0,'',0,'Monster.oel_mahum_warrior',20.00,38.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,333,72,0,0,77,191,'oel_mahum_clan',300,0,0,'LAST_HIT'),
	(20576,20576,'Oel Mahum Witch Doctor',0,'',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,55,'male','L2Monster',40,2643,987,20.54,2.45,40,43,30,21,20,10,4401,355,609,354,360,261,278,0,333,201,0,0,77,191,'oel_mahum_clan',300,0,0,'LAST_HIT'),
	(20577,20577,'Leto Lizardman',0,'',0,'Monster.zenta_lizardman',11.00,32.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1781,105,192,169,89,137,278,0,333,66,0,0,40,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20578,20578,'Leto Lizardman Archer',0,'',0,'Monster.zenta_lizardman_scout',11.00,30.00,36,'male','L2Monster',500,1279,463,7.11,1.84,40,43,30,21,20,10,1941,117,417,193,96,142,249,0,333,14,0,0,40,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20579,20579,'Leto Lizardman Soldier',0,'',0,'Monster.zenta_lizardman',11.00,32.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,2030,125,222,182,104,147,278,500,333,68,0,0,40,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20580,20580,'Leto Lizardman Warrior',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,38,'male','L2Monster',40,1400,497,14.22,1.84,40,43,30,21,20,10,1953,121,261,171,112,153,278,0,333,93,0,0,44,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20581,20581,'Leto Lizardman Shaman',0,'',0,'Monster.zenta_lizardman_shaman',13.00,35.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2212,141,280,177,121,158,278,0,333,159,0,0,47,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20582,20582,'Leto Lizardman Overlord',0,'',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster',40,1527,531,14.22,1.84,40,43,30,21,20,10,2207,142,217,222,131,164,317,500,333,221,0,0,58,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20583,20583,'Timak Orc',0,'',0,'Monster.batur_orc',9.00,21.50,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2327,150,300,183,131,164,278,0,333,2,0,0,88,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20584,20584,'Timak Orc Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,41,'male','L2Monster',500,1593,560,8.69,2.14,40,43,30,21,20,10,3152,206,589,229,141,169,249,0,333,14,0,0,49,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20585,20585,'Timak Orc Soldier',0,'',0,'Monster.batur_orc',9.00,21.50,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,3114,207,311,215,152,175,278,500,333,66,0,0,88,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20586,20586,'Timak Orc Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2984,202,332,223,163,181,278,0,333,68,0,0,88,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20587,20587,'Timak Orc Shaman',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,44,'male','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,2815,193,390,209,176,187,278,0,333,179,0,0,55,191,'orc_clan',300,0,3,'LAST_HIT'),
	(20588,20588,'Timak Orc Overlord',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3701,257,415,216,188,193,278,500,333,127,0,0,88,191,'orc_clan',300,0,3,'LAST_HIT'),
	(20589,20589,'Fline',0,'',0,'Monster.sylph',11.00,35.00,45,'female','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,2766,192,343,262,188,193,278,0,333,0,0,0,66,191,'elemental_clan',400,0,0,'LAST_HIT'),
	(20590,20590,'Liele',0,'',0,'Monster.undine',12.00,27.00,46,'female','L2Monster',40,1943,707,17.38,2.14,40,43,30,21,20,10,2862,203,365,270,202,199,278,0,333,0,0,0,66,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20591,20591,'Valley Treant',0,'',0,'Monster.ti_mi_tran',23.00,90.00,47,'male','L2Monster',40,2016,738,17.38,2.14,40,43,30,21,20,10,4224,303,388,279,216,206,278,0,333,0,0,0,13,13,'elemental_clan',300,0,0,'LAST_HIT'),
	(20592,20592,'Satyr',0,'',0,'Monster.pan',14.00,35.00,48,'male','L2Monster',40,2091,768,26.07,2.14,40,43,30,21,20,10,3076,224,412,288,231,212,278,500,333,291,0,0,49,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20593,20593,'Unicorn',0,'',0,'Monster.unicorn',14.00,30.00,49,'male','L2Monster',40,2168,799,26.07,2.14,40,43,30,21,20,10,3299,244,437,297,247,219,278,0,333,0,0,0,50,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20594,20594,'Forest Runner',0,'',0,'Monster.mandragora_b',12.00,25.50,50,'female','L2Monster',40,2245,830,17.38,2.14,40,43,30,21,20,10,3381,254,463,306,264,226,278,0,333,0,0,0,88,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20595,20595,'Fline Elder',0,'',0,'Monster.sylph',11.00,35.00,51,'female','L2Monster',40,2323,861,20.54,2.45,40,43,30,21,20,10,3518,268,593,260,281,232,278,0,333,0,0,0,66,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20596,20596,'Liele Elder',0,'',0,'Monster.undine',12.00,27.00,52,'female','L2Monster',40,2402,892,20.54,2.45,40,43,30,21,20,10,3730,288,627,268,300,239,278,500,333,0,0,0,66,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20597,20597,'Valley treant Elder',0,'',0,'Monster.ti_mi_tran',23.00,90.00,53,'male','L2Monster',40,2481,923,30.81,2.45,40,43,30,21,20,10,5199,408,662,276,319,247,278,0,333,0,0,0,13,13,'elemental_clan',300,0,0,'LAST_HIT'),
	(20598,20598,'Satyr Elder',0,'',0,'Monster.pan',14.00,35.00,54,'male','L2Monster',40,2562,955,30.81,2.45,40,43,30,21,20,10,3816,304,699,284,339,254,278,0,333,297,0,0,49,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20599,20599,'Unicorn Elder',0,'',0,'Monster.unicorn',14.00,30.00,55,'male','L2Monster',40,2643,987,30.81,2.45,40,43,30,21,20,10,3959,319,737,292,360,261,278,0,333,0,0,0,50,191,'elemental_clan',300,0,0,'LAST_HIT'),
	(20600,20600,'Karul Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2741,177,300,183,131,164,278,0,333,88,0,0,60,191,NULL,0,0,0,'LAST_HIT'),
	(20601,20601,'Tamlin Orc',0,'',0,'Monster.batur_orc',9.00,21.50,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,2444,160,291,208,141,169,278,0,333,2,0,0,88,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20602,20602,'Tamlin Orc Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,42,'male','L2Monster',500,1660,589,8.69,2.14,40,43,30,21,20,10,3308,220,692,215,152,175,249,0,333,14,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20603,20603,'Kronbe Spider',0,'',0,'Monster.giant_spider',26.00,25.50,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2715,184,302,245,163,181,278,500,333,0,0,0,79,191,NULL,0,0,0,'LAST_HIT'),
	(20604,20604,'Lakin',0,'',0,'Monster.twin_headed_giant',17.00,39.00,44,'male','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,3317,227,390,209,176,187,278,0,333,89,0,0,49,191,NULL,0,0,0,'LAST_HIT'),
	(20605,20605,'Weird Drake',0,'',0,'Monster.drake',30.00,100.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3004,209,377,238,188,193,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20606,20606,'Kuran Kobold',0,'',0,'Monster.kobold',10.00,15.00,27,'male','L2Monster',40,813,318,11.06,1.53,40,43,30,21,20,10,950,48,94,138,45,102,278,0,333,0,0,0,51,121,'kobold_clan',300,0,0,'LAST_HIT'),
	(20607,20607,'Kuran Kobold Warrior',0,'',0,'Monster.kobold',10.00,15.00,28,'male','L2Monster',40,859,334,11.06,1.53,40,43,30,21,20,10,1006,53,124,118,49,106,278,0,333,0,0,0,51,121,'kobold_clan',300,0,0,'LAST_HIT'),
	(20608,20608,'Patin Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,29,'male','L2Monster',500,906,349,11.06,1.53,40,43,30,21,20,10,1022,55,271,135,53,110,249,500,333,14,0,0,44,154,NULL,0,1,0,'LAST_HIT'),
	(20609,20609,'Lakin Salamander',0,'',0,'Monster.salamander',16.00,6.80,30,'male','L2Monster',40,954,365,11.06,1.53,40,43,30,21,20,10,1068,58,120,155,58,114,278,0,333,0,0,0,70,105,'elemental_clan',300,0,0,'LAST_HIT'),
	(20610,20610,'Sentinel Of Water',0,'',0,'Monster.monster_eye',21.00,43.00,31,'male','L2Monster',40,1004,381,14.22,1.84,40,43,30,21,20,10,1083,60,157,133,64,118,278,0,333,0,0,0,99,99,'elemental_clan',300,0,0,'LAST_HIT'),
	(20611,20611,'Dre Vanul Warrior',0,'',0,'Monster.dre_vanul',14.00,36.00,32,'male','L2Monster',40,1056,397,14.22,1.84,40,43,30,21,20,10,1154,65,169,138,69,123,278,0,333,0,0,0,88,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(20612,20612,'Salamander Rowin',0,'',0,'Monster.salamander',16.00,6.80,33,'male','L2Monster',40,1109,413,14.22,1.84,40,43,30,21,20,10,1319,75,151,173,75,128,278,500,333,0,0,0,70,105,'elemental_clan',300,0,0,'LAST_HIT'),
	(20613,20613,'Lafi Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,27,'male','L2Monster',40,813,318,11.06,1.53,40,43,30,21,20,10,950,48,104,125,45,102,278,0,333,291,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20614,20614,'Lafi Lizardman Scout',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,28,'male','L2Monster',500,859,334,11.06,1.53,40,43,30,21,20,10,940,49,228,143,49,106,249,0,333,2507,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20615,20615,'Ritmal Swordsman',0,'',0,'Monster.spartoi',11.00,27.00,29,'male','L2Monster',40,906,349,11.06,1.53,40,43,30,21,20,10,1094,58,122,135,53,110,278,500,333,73,0,0,66,154,NULL,0,1,0,'LAST_HIT'),
	(20616,20616,'Lakin Undine',0,'',0,'Monster.undine',12.00,27.00,30,'female','L2Monster',40,954,365,11.06,1.53,40,43,30,21,20,10,1434,78,145,128,58,114,278,0,333,0,0,0,66,66,'elemental_clan',300,0,0,'LAST_HIT'),
	(20617,20617,'Sentinel Of Water',0,'',0,'Monster.magical_weaver',11.00,20.00,31,'male','L2Monster',40,1004,381,14.22,1.84,40,43,30,21,20,10,1093,60,129,161,64,118,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(20618,20618,'Kanil Succubus',0,'',0,'Monster.succubus',10.00,36.00,32,'female','L2Monster',40,1056,397,14.22,1.84,40,43,30,21,20,10,1216,68,169,138,69,123,278,0,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(20619,20619,'Rowin Undine',0,'',0,'Monster.undine',12.00,27.00,33,'female','L2Monster',40,1109,413,14.22,1.84,40,43,30,21,20,10,1252,72,151,173,75,128,278,500,333,0,0,0,66,66,'elemental_clan',300,0,0,'LAST_HIT'),
	(20620,20620,'Cave Beast',0,'',0,'Monster.troll',21.00,35.00,61,'male','L2Monster',40,3137,1184,35.55,2.78,40,43,30,21,20,10,4304,378,992,344,505,307,278,500,333,0,0,0,60,191,NULL,0,0,0,'LAST_HIT'),
	(20621,20621,'Death Wave',0,'',0,'Monster.will_o_wisp',13.00,22.00,62,'male','L2Monster',40,3219,1217,35.55,2.78,40,43,30,21,20,10,4639,413,1038,353,532,315,278,500,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20622,20622,'Malruk Soldier',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,63,'male','L2Monster',40,3302,1251,35.55,2.78,40,43,30,21,20,10,4953,447,950,362,560,323,317,500,333,221,0,0,88,191,'malruk_clan',500,1,0,'LAST_HIT'),
	(20623,20623,'Plando',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,64,'male','L2Monster',500,3384,1285,47.40,2.78,40,43,30,21,20,10,4953,453,2084,449,589,331,249,500,333,2507,0,0,47,191,NULL,0,0,0,'LAST_HIT'),
	(20624,20624,'Cave Howler',0,'',0,'Monster.twin_headed_giant',17.00,39.00,65,'male','L2Monster',40,3465,1319,47.40,2.78,40,43,30,21,20,10,5037,468,979,460,619,340,278,500,333,0,0,0,49,191,NULL,0,0,0,'LAST_HIT'),
	(20625,20625,'Malruk Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,66,'male','L2Monster',40,3546,1353,47.40,2.78,40,43,30,21,20,10,5030,473,1020,471,649,348,278,500,333,78,0,0,44,191,'malruk_clan',500,1,10,'LAST_HIT'),
	(20626,20626,'Malruk Berserker',0,'',0,'Monster.death_knight',12.00,31.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,7220,687,1415,362,681,356,278,500,333,77,0,0,29,191,'malruk_clan',500,1,10,'LAST_HIT'),
	(20627,20627,'Malruk Lord',0,'',0,'Monster.death_blader',15.00,45.00,68,'male','L2Monster',40,3706,1423,59.25,2.78,40,43,30,21,20,10,4964,479,1217,449,713,365,278,500,333,1472,0,0,110,191,'malruk_clan',500,1,10,'LAST_HIT'),
	(20628,20628,'Limal Karinness',0,'',0,'Monster.bloody_queen',14.00,40.00,69,'female','L2Monster',40,3784,1458,59.25,2.78,40,43,30,21,20,10,5349,523,1392,418,746,373,278,500,333,0,0,0,88,191,'malruk_clan',500,0,10,'LAST_HIT'),
	(20629,20629,'Karik',0,'',0,'Monster.karik',25.00,90.00,70,'male','L2Monster',40,3862,1493,59.25,2.78,40,43,30,21,20,10,6584,652,1445,427,780,382,278,500,333,0,0,0,40,191,NULL,0,0,10,'LAST_HIT'),
	(20630,20630,'Taik Orc',0,'',0,'Monster.ketra_orc',12.00,29.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,333,127,0,0,49,191,NULL,0,0,0,'LAST_HIT'),
	(20631,20631,'Taik Orc Archer',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,41,'male','L2Monster',500,1593,560,8.69,2.14,40,43,30,21,20,10,3152,206,589,195,141,169,249,0,333,14,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20632,20632,'Taik Orc Warrior',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,3144,209,342,196,152,175,278,500,333,75,0,0,39,191,'orc_clan',400,0,0,'LAST_HIT'),
	(20633,20633,'Taik Orc Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,3068,207,302,245,163,181,278,0,333,9,0,0,11,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20634,20634,'Taik Orc Captain',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,2943,201,322,253,176,187,278,500,333,75,104,0,39,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20635,20635,'Carinkain',0,'',0,'Monster.mana_vampire',11.00,20.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2974,207,415,216,188,193,278,500,333,0,0,0,99,191,NULL,0,0,0,'LAST_HIT'),
	(20636,20636,'Forest of Mirrors Ghost',0,'',0,'Monster.dwarf_ghost',9.00,16.50,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3310,235,442,223,202,199,278,500,333,0,0,0,88,191,'mirrorforest_clan',200,1,3,'LAST_HIT'),
	(20637,20637,'Forest of Mirrors Ghost',0,'',0,'Monster.elf_ghost',7.00,21.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,3456,248,469,230,216,206,278,500,333,0,0,0,88,191,'mirrorforest_clan',200,1,4,'LAST_HIT'),
	(20638,20638,'Forest of Mirrors Ghost',0,'',0,'Monster.human_ghost',8.00,22.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3605,263,498,238,231,212,278,500,333,0,0,0,88,191,'mirrorforest_clan',200,1,4,'LAST_HIT'),
	(20639,20639,'Mirror',0,'',0,'Monster.mirror',26.00,52.00,49,'male','L2Monster',40,2168,799,17.38,2.14,40,43,30,21,20,10,4254,314,437,297,247,219,278,0,333,0,0,0,88,191,NULL,0,0,4,'LAST_HIT'),
	(20640,20640,'Harit Lizardman',0,'',0,'Monster.zenta_lizardman',11.00,32.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,333,88,945,0,40,191,'lizardman_clan',300,0,5,'LAST_HIT'),
	(20641,20641,'Harit Lizardman Grunt',0,'',0,'Monster.zenta_lizardman',11.00,32.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,4501,343,539,286,281,232,278,0,333,70,0,0,40,191,'lizardman_clan',300,0,5,'LAST_HIT'),
	(20642,20642,'Harit Lizardman Archer',0,'',0,'Monster.zenta_lizardman_scout',11.00,30.00,52,'male','L2Monster',500,2402,892,10.27,2.45,40,43,30,21,20,10,4214,326,1152,324,300,239,249,500,333,14,0,0,40,191,'lizardman_clan',300,0,5,'LAST_HIT'),
	(20643,20643,'Harit Lizardman Warrior',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4332,341,662,276,319,247,278,0,333,291,0,0,44,191,'lizardman_clan',400,0,0,'LAST_HIT'),
	(20644,20644,'Harit Lizardman Shaman',0,'',0,'Monster.zenta_lizardman_shaman',13.00,35.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4241,338,699,284,339,254,278,0,333,9,0,0,47,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20645,20645,'Harit Lizardman Matriarch',0,'',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,55,'male','L2Monster',40,2643,987,20.54,2.45,40,43,30,21,20,10,4768,385,609,354,360,261,278,500,333,221,0,0,58,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20646,20646,'Halingka',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,55,'male','L2Monster',40,2643,987,20.54,2.45,40,43,30,21,20,10,3592,290,737,292,360,261,278,0,333,0,0,0,66,187,'beast_clan',300,0,6,'LAST_HIT'),
	(20647,20647,'Yintzu',0,'',0,'Monster.field_stalker',15.00,30.00,56,'male','L2Monster',40,2724,1019,20.54,2.45,40,43,30,21,20,10,3605,296,777,301,382,269,278,500,333,0,0,0,77,121,'beast_clan',300,0,6,'LAST_HIT'),
	(20648,20648,'Paliote',0,'',0,'Monster.will_o_wisp',13.00,22.00,57,'male','L2Monster',40,2806,1052,20.54,2.45,40,43,30,21,20,10,4094,340,817,309,405,276,278,0,333,0,0,0,88,154,'beast_clan',300,0,7,'LAST_HIT'),
	(20649,20649,'Hamrut',0,'',0,'Monster.poison_spider',27.00,25.50,58,'male','L2Monster',40,2889,1084,20.54,2.45,40,43,30,21,20,10,4075,344,859,318,428,284,278,500,333,0,0,0,66,154,'beast_clan',300,0,7,'LAST_HIT'),
	(20650,20650,'Kranrot',0,'',0,'Monster.crimson_bear',19.00,36.00,59,'male','L2Monster',40,2971,1117,20.54,2.45,40,43,30,21,20,10,4410,377,902,326,453,291,278,500,333,0,0,0,40,187,'beast_clan',300,0,8,'LAST_HIT'),
	(20651,20651,'Gamlin',0,'',0,'Monster.gamlin',11.00,32.00,60,'male','L2Monster',40,3054,1150,20.54,2.45,40,43,30,21,20,10,4097,355,782,405,478,299,278,0,333,0,0,0,88,187,'giant_clan',400,0,0,'LAST_HIT'),
	(20652,20652,'Leogul',0,'',0,'Monster.leogul',15.00,35.00,61,'male','L2Monster',40,3137,1184,23.70,2.78,40,43,30,21,20,10,4320,380,819,416,505,307,278,500,333,0,0,0,88,187,'giant_clan',400,0,0,'LAST_HIT'),
	(20653,20653,'Lesser Giant',0,'',0,'Monster.lesser_giant',21.00,44.00,61,'male','L2Monster',40,3137,1184,35.55,2.78,40,43,30,21,20,10,4058,357,901,378,505,307,278,0,333,3937,0,0,16,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20654,20654,'Lesser Giant Soldier',0,'',0,'Monster.lesser_giant',21.00,44.00,62,'male','L2Monster',40,3219,1217,35.55,2.78,40,43,30,21,20,10,6224,554,1142,321,532,315,278,0,333,3937,0,0,16,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20655,20655,'Lesser Giant Shooter',0,'',0,'Monster.lesser_giant_shooter',21.00,44.00,63,'male','L2Monster',500,3302,1251,35.55,2.78,40,43,30,21,20,10,5085,459,2194,398,560,323,249,500,333,4028,0,0,88,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20656,20656,'Lesser Giant Scout',0,'',0,'Monster.lesser_giant_shooter',21.00,44.00,63,'male','L2Monster',500,3302,1251,35.55,2.78,40,43,30,21,20,10,4639,419,2194,338,560,323,249,500,333,4028,0,0,88,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20657,20657,'Lesser Giant Mage',0,'',0,'Monster.lesser_giant_mage',21.00,44.00,64,'male','L2Monster',40,3384,1285,23.70,2.78,40,43,30,21,20,10,5511,504,1135,371,589,331,278,0,333,3938,0,0,16,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20658,20658,'Lesser Giant Elder',0,'',0,'Monster.lesser_giant_mage',21.00,44.00,65,'male','L2Monster',40,3465,1319,23.70,2.78,40,43,30,21,20,10,5324,494,1184,380,619,340,278,0,333,3938,0,0,16,198,'giant_clan',300,0,0,'LAST_HIT'),
	(20659,20659,'Grave Wanderer',0,'',0,'Monster.zombie',13.00,21.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,4123,287,377,238,188,193,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(20660,20660,'Archer of Greed',0,'',0,'Monster.skeleton_archer',11.00,27.00,46,'male','L2Monster',500,1943,707,8.69,2.14,40,43,30,21,20,10,4048,287,982,190,202,199,249,500,333,14,0,0,44,191,NULL,0,1,0,'LAST_HIT'),
	(20661,20661,'Hatar Ratman Thief',0,'',0,'Monster.wererat',14.00,25.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,3823,274,373,253,216,206,317,0,333,946,0,0,88,191,'hatar_clan',300,0,0,'LAST_HIT'),
	(20662,20662,'Hatar Ratman Boss',0,'',0,'Monster.wererat',14.00,25.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,3987,291,396,261,231,212,317,0,333,221,0,0,88,191,'hatar_clan',300,0,0,'LAST_HIT'),
	(20663,20663,'Hatar Hanishee',0,'',0,'Monster.medusa',10.00,25.00,49,'female','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,333,0,0,0,55,191,'hatar_clan',300,0,0,'LAST_HIT'),
	(20664,20664,'Deprive',0,'',0,'Monster.field_stalker',15.00,30.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3672,277,560,253,264,226,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20665,20665,'Taik Orc Supply',0,'',0,'Monster.ketra_orc',12.00,29.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,4501,343,490,315,281,232,278,0,333,69,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20666,20666,'Taik Orc Seeker',0,'',0,'Monster.ketra_orc',12.00,29.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,4679,362,627,268,300,239,278,0,333,72,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20667,20667,'Farcran',0,'',0,'Monster.crimson_bear',19.00,36.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4813,378,602,304,319,247,278,0,333,0,0,0,40,191,NULL,0,0,0,'LAST_HIT'),
	(20668,20668,'Grave Guard',0,'',0,'Monster.gargoyle',16.00,50.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4283,341,578,344,339,254,278,500,333,0,0,0,154,191,NULL,0,0,0,'LAST_HIT'),
	(20669,20669,'Taik Orc Supply Leader',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,5340,431,737,292,360,261,278,500,333,75,0,0,39,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20670,20670,'Crimson Drake',0,'',0,'Monster.drake',30.00,100.00,61,'male','L2Monster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,5465,481,992,344,505,307,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20671,20671,'Kadios',0,'',0,'Monster.devastator',35.00,35.00,62,'male','L2Monster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,5702,508,1038,353,532,315,278,500,333,0,0,0,27,191,NULL,0,0,0,'LAST_HIT'),
	(20672,20672,'Trives',0,'',0,'Monster.serpent_slave',17.00,46.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,5772,521,897,438,560,323,278,0,333,127,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20673,20673,'Falibati',0,'',0,'Monster.cave_maiden',25.00,65.00,64,'female','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,6016,551,938,449,589,331,278,500,333,73,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20674,20674,'Doom Knight',0,'',0,'Monster.death_blader',15.00,45.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,8649,804,1184,380,619,340,278,500,333,1472,0,0,110,191,'doom_clan',300,1,10,'LAST_HIT'),
	(20675,20675,'Tairim',0,'',0,'Monster.will_o_wisp',13.00,22.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3817,288,463,306,264,226,278,0,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20676,20676,'Judge of Marsh',0,'',0,'Monster.hanged_man_ripper',35.00,80.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6205,577,1184,380,619,340,278,500,333,0,0,0,60,191,NULL,0,0,0,'LAST_HIT'),
	(20677,20677,'Tulben',0,'',0,'Monster.vampire_bat',10.00,33.50,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,6968,656,1123,428,649,348,278,0,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20678,20678,'Tortured Undead',0,'',0,'Monster.hungry_spirit',30.00,40.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4085,321,662,276,319,247,278,0,333,0,0,0,16,191,NULL,0,1,0,'LAST_HIT'),
	(20679,20679,'Marsh Stalker',0,'',0,'Monster.gargoyle',16.00,50.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4199,335,636,313,339,254,278,0,333,0,0,0,154,191,NULL,0,0,0,'LAST_HIT'),
	(20680,20680,'Marsh Drake',0,'',0,'Monster.drake',30.00,100.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,4443,359,737,292,360,261,278,500,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(20681,20681,'Vanor Silenos',0,'',0,'Monster.heltor_silenos',13.00,29.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3092,215,377,238,188,193,278,0,333,88,0,0,37,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20682,20682,'Vanor Silenos Grunt',0,'',0,'Monster.heltor_silenos',13.00,29.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3077,218,401,245,202,199,278,0,333,158,18,0,37,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20683,20683,'Vanor Silenos Scout',0,'',0,'Monster.heltor_silenos',13.00,29.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,4004,287,388,279,216,206,278,500,333,5,0,0,37,191,'silenos_clan',400,0,0,'LAST_HIT'),
	(20684,20684,'Vanor Silenos Warrior',0,'',0,'Monster.heltor_silenos_warrior',13.00,31.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,4188,306,498,238,231,212,278,0,333,160,0,0,39,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20685,20685,'Vanor Silenos Shaman',0,'',0,'Monster.heltor_silenos_shaman',13.00,32.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,3492,258,529,245,247,219,278,0,333,9,0,0,31,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20686,20686,'Vanor Silenos Chieftain',0,'',0,'Monster.heltor_silenos_chieftain',13.00,31.50,50,'male','L2Monster',40,2245,830,17.38,2.14,40,43,30,21,20,10,3637,274,463,306,264,226,278,0,333,75,0,0,29,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20738,20738,'Kobold Looter Bepook',0,'',0,'Monster.kobold_bi',15.00,24.00,13,'male','L2Monster',40,339,147,7.90,1.21,40,43,30,21,20,10,663,26,33,63,11,56,278,500,333,4,0,0,51,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(20739,20739,'Bepook''s Pet',0,'',0,'Monster.wolf',13.00,9.00,10,'male','L2Minion',40,257,120,1.58,0.91,40,43,30,21,20,10,439,14,27,50,8,49,278,0,333,0,0,0,26,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(20742,20742,'Mystical Weaver',0,'',0,'Monster.magical_weaver',11.00,20.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,684,32,62,113,28,83,278,0,333,0,0,0,99,99,'partisan_clan',300,0,0,'LAST_HIT'),
	(20743,20743,'Howler',0,'',0,'Monster.werewolf',10.00,26.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,843,42,80,127,37,94,278,500,333,0,0,0,55,132,'partisan_clan',300,0,0,'LAST_HIT'),
	(20744,20744,'Red Eye Vampire Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,684,32,75,93,28,83,278,0,333,0,0,0,66,88,'partisan_clan',300,0,0,'LAST_HIT'),
	(20745,20745,'Gigantiops',0,'',0,'Monster.ant_soldier',35.00,17.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,2681,159,174,186,89,137,278,500,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(20746,20746,'Young Gigantiops',0,'',0,'Monster.ant',26.00,15.00,31,'male','L2Minion',40,1004,381,7.11,1.84,40,43,30,21,20,10,2062,114,157,133,64,118,278,0,333,0,0,0,44,152,'ant_clan',300,0,0,'LAST_HIT'),
	(20747,20747,'Roxide',0,'',0,'Monster.succubus',10.00,36.00,32,'female','L2Monster',40,1056,397,14.22,1.84,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,333,0,0,0,66,174,'demonic_clan',300,0,0,'LAST_HIT'),
	(20748,20748,'Roxide Cohort',0,'',0,'Monster.spartoi',11.00,27.00,29,'male','L2Minion',40,906,349,11.06,1.53,40,43,30,21,20,10,1349,72,111,149,53,110,278,0,333,73,0,0,66,174,'demonic_clan',300,1,0,'LAST_HIT'),
	(20749,20749,'Death Fire',0,'',0,'Monster.dre_vanul',14.00,36.00,32,'male','L2Monster',40,1056,397,14.22,1.84,40,43,30,21,20,10,1459,82,169,138,69,123,278,500,333,0,0,0,88,174,'demonic_clan',300,0,0,'LAST_HIT'),
	(20750,20750,'Fire Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,29,'male','L2Minion',500,906,349,11.06,1.53,40,43,30,21,20,10,1397,75,247,149,53,110,249,0,333,14,0,0,44,174,'demonic_clan',300,1,0,'LAST_HIT'),
	(20751,20751,'Snipe',0,'',0,'Monster.onyx_beast',14.00,14.50,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,3387,232,390,209,176,187,278,500,333,0,0,0,33,191,NULL,0,0,0,'LAST_HIT'),
	(20752,20752,'Snipe Cohort',0,'',0,'Monster.onyx_beast',14.00,14.50,42,'male','L2Minion',40,1660,589,17.38,2.14,40,43,30,21,20,10,3290,219,283,237,152,175,278,0,333,0,0,0,33,191,NULL,0,0,0,'LAST_HIT'),
	(20753,20753,'Dark Lord',0,'',0,'Monster.death_blader',15.00,45.00,50,'male','L2Monster',40,2245,830,17.38,2.14,40,43,30,21,20,10,4282,322,463,306,264,226,278,500,333,1472,0,0,110,191,'undead_clan',300,1,0,'LAST_HIT'),
	(20754,20754,'Dark Knight',0,'',0,'Monster.death_knight',12.00,31.00,48,'male','L2Monster',40,2091,768,17.38,2.14,40,43,30,21,20,10,4960,362,498,238,231,212,278,0,333,127,0,0,29,191,'undead_clan',300,1,0,'LAST_HIT'),
	(20755,20755,'Talakin',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1970,108,120,155,58,114,278,500,333,2,0,0,55,146,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20756,20756,'Talakin Archer',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,28,'male','L2Minion',500,859,334,5.53,1.53,40,43,30,21,20,10,1884,99,228,143,49,106,249,0,333,14,0,0,55,146,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20757,20757,'Talakin Raider',0,'',0,'Monster.ol_mahum',13.50,25.00,27,'male','L2Minion',40,813,318,5.53,1.53,40,43,30,21,20,10,1380,71,114,114,45,102,278,0,333,3,0,0,55,146,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20758,20758,'Dragon Bearer Chief',0,'',0,'Monster.spartoi',11.00,27.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,5255,389,437,297,247,219,278,500,333,123,945,0,66,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20759,20759,'Dragon Bearer Warrior',0,'',0,'Monster.skeleton',11.00,25.00,48,'male','L2Minion',40,2091,768,8.69,2.14,40,43,30,21,20,10,4944,361,498,238,231,212,278,0,333,2,945,0,66,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20760,20760,'Dragon Bearer Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,47,'male','L2Minion',500,2016,738,8.69,2.14,40,43,30,21,20,10,5137,368,862,279,216,206,249,0,333,14,0,0,44,191,'cave_servant_clan',300,1,0,'LAST_HIT'),
	(20761,20761,'Pytan',0,'',0,'Monster.bloody_queen',14.00,40.00,69,'female','L2Monster',40,3784,1458,35.55,2.78,40,43,30,21,20,10,6633,649,1392,418,746,373,278,500,333,0,0,0,88,191,'malruk_clan',500,0,10,'LAST_HIT'),
	(20762,20762,'Pytan Knight',0,'',0,'Monster.death_blader',15.00,45.00,68,'male','L2Minion',40,3706,1423,23.70,2.78,40,43,30,21,20,10,7021,678,1106,494,713,365,278,0,333,1472,0,0,110,191,'malruk_clan',500,1,10,'LAST_HIT'),
	(20763,20763,'Lord of the Plains',0,'',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,3869,250,217,222,131,164,317,500,333,221,0,0,58,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20764,20764,'Shaman of the Plains',0,'',0,'Monster.zenta_lizardman_shaman',13.00,35.00,39,'male','L2Minion',40,1462,514,7.11,1.84,40,43,30,21,20,10,3457,220,231,214,121,158,278,0,333,179,0,0,47,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20765,20765,'Warrior of the Plains',0,'',0,'Monster.zenta_lizardman_warrior',13.00,35.00,38,'male','L2Minion',40,1400,497,7.11,1.84,40,43,30,21,20,10,2992,187,261,171,112,153,278,0,333,16,0,0,44,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20766,20766,'Scout of the Plains',0,'',0,'Monster.zenta_lizardman_scout',11.00,30.00,36,'male','L2Minion',500,1279,463,7.11,1.84,40,43,30,21,20,10,2659,161,417,193,96,142,249,0,333,14,0,0,40,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20767,20767,'Timak Orc Troop Leader',0,'',0,'Monster.batur_orc_overlord',12.00,24.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,4801,334,415,216,188,193,278,0,333,79,0,0,88,191,'orc_clan',300,0,3,'LAST_HIT'),
	(20768,20768,'Timak Orc Troop Shaman',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,44,'male','L2Minion',40,1799,648,8.69,2.14,40,43,30,21,20,10,4632,317,390,209,176,187,278,0,333,7,0,0,55,191,'orc_clan',300,0,3,'LAST_HIT'),
	(20769,20769,'Timak Orc Troop Warrior',0,'',0,'Monster.batur_orc_warrior',10.00,20.00,43,'male','L2Minion',40,1728,618,8.69,2.14,40,43,30,21,20,10,3684,249,365,202,163,181,278,0,333,123,19,0,88,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20770,20770,'Timak Orc Troop Archer',0,'',0,'Monster.batur_orc_archer',11.00,21.50,41,'male','L2Minion',500,1593,560,8.69,2.14,40,43,30,21,20,10,4319,283,713,189,141,169,249,0,333,13,0,0,49,191,'orc_clan',300,0,2,'LAST_HIT'),
	(20771,20771,'Barif',0,'',0,'Monster.lesser_giant_mage',21.00,44.00,64,'male','L2Monster',40,3384,1285,23.70,2.78,40,43,30,21,20,10,6515,596,938,449,589,331,278,500,333,3938,0,0,16,198,'giant_clan',400,0,0,'LAST_HIT'),
	(20772,20772,'Barif''s Pet',0,'',0,'Monster.leogul',15.00,35.00,61,'male','L2Minion',40,3137,1184,23.70,2.78,40,43,30,21,20,10,6332,557,992,344,505,307,278,0,333,0,0,0,88,187,'giant_clan',300,0,0,'LAST_HIT'),
	(20773,20773,'Conjurer Bat Lord',0,'',0,'Monster.vampire_bat',10.00,33.50,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,10535,1070,1284,540,849,399,278,500,333,0,0,0,66,191,'giant_clan',300,0,0,'LAST_HIT'),
	(20774,20774,'Conjurer Bat ',0,'',0,'Monster.vampire_bat',10.00,33.50,70,'male','L2Minion',40,3862,1493,11.85,2.78,40,43,30,21,20,10,11140,1105,1194,517,780,382,278,0,333,0,0,0,66,191,'giant_clan',300,0,0,'LAST_HIT'),
	(20775,20775,'Bugbear Raider',0,'',0,'Monster.bugbear',17.00,35.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,599,25,48,75,17,67,278,0,333,0,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(20776,20776,'Dark Succubus',0,'',0,'Monster.succubus',10.00,36.00,20,'female','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,783,35,57,94,23,76,278,0,333,0,0,0,66,110,NULL,0,0,0,'LAST_HIT'),
	(20777,20777,'Hunter Bear',0,'',0,'Monster.grizzly',21.00,40.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,498,19,37,66,12,59,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(20778,20778,'Ragna Orc Overlord',0,'',0,'Monster.orc_champion',10.00,23.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2477,157,231,214,121,158,278,0,333,2,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20779,20779,'Ragna Orc Seer',0,'',0,'Monster.orc_shaman',9.00,22.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,2212,141,231,214,121,158,278,0,333,7,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(20780,20780,'Bloody Axe Elite',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1799,106,174,186,89,137,278,500,333,2,0,0,55,191,NULL,0,0,0,'LAST_HIT'),
	(20781,20781,'Delu Lizardman Shaman',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,1781,105,211,154,89,137,278,0,333,7,0,0,47,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20782,20782,'Ol Mahum Novice',0,'',0,'Monster.ol_mahum',13.50,25.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,618,26,44,83,17,67,278,500,333,1,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(20783,20783,'Dread Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,35,'male','L2Monster',40,1220,446,3.56,1.84,40,43,30,21,20,10,1635,96,256,127,89,137,278,500,333,0,0,0,26,154,NULL,0,0,0,'LAST_HIT'),
	(20784,20784,'Tasaba Lizardman',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,36,'male','L2Monster',500,1279,463,3.56,1.84,40,43,30,21,20,10,1852,112,505,159,96,142,249,0,333,2507,0,0,47,154,'lizardman_clan1',300,0,0,'LAST_HIT'),
	(20785,20785,'Tasaba Lizardman Shaman',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,37,'male','L2Monster',40,1338,480,3.56,1.84,40,43,30,21,20,10,1791,110,244,140,104,147,278,0,333,7,0,0,47,154,'lizardman_clan1',300,0,0,'LAST_HIT'),
	(20786,20786,'Lienrik',0,'',0,'Monster.lienrik',12.00,50.00,39,'male','L2Monster',40,1462,514,3.56,1.84,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,333,0,0,0,110,165,'lienrik_clan',300,0,0,'LAST_HIT'),
	(20787,20787,'Lienrik Lad',0,'',0,'Monster.lienrik',12.00,50.00,40,'male','L2Monster',40,1527,531,3.56,1.84,40,43,30,21,20,10,2421,156,317,151,131,164,317,500,333,0,0,0,110,191,'lienrik_clan',300,0,0,'LAST_HIT'),
	(20788,20788,'Rakul',0,'',0,'Monster.rakul',30.00,39.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,2120,125,192,169,89,137,278,0,333,3,0,0,66,191,NULL,0,1,0,'LAST_HIT'),
	(20789,20789,'Crokian',0,'',0,'Monster.crokian',18.00,29.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,1999,121,187,193,96,142,278,500,333,5128,0,0,19,191,'croc_clan',300,0,0,'LAST_HIT'),
	(20790,20790,'Dailaon',0,'',0,'Monster.dailaon',20.00,28.00,37,'male','L2Monster',500,1338,480,7.11,1.84,40,43,30,21,20,10,2567,158,448,200,104,147,249,0,333,5127,0,0,19,191,'croc_clan',300,0,0,'LAST_HIT'),
	(20791,20791,'Crokian Warrior',0,'',0,'Monster.crokian',18.00,29.00,38,'male','L2Monster',40,1400,497,14.22,1.84,40,43,30,21,20,10,2211,138,261,171,112,153,278,500,333,5128,0,0,19,191,'croc_clan',300,0,0,'LAST_HIT'),
	(20792,20792,'Farhite',0,'',0,'Monster.farhite',16.00,31.00,39,'male','L2Monster',40,1462,514,14.22,1.84,40,43,30,21,20,10,2057,131,280,150,121,158,278,0,333,5131,0,0,16,191,'croc_clan',300,0,0,'LAST_HIT'),
	(20793,20793,'Nos',0,'',0,'Monster.nos',26.00,42.00,40,'male','L2Monster',40,1527,531,14.22,1.84,40,43,30,21,20,10,2251,145,300,183,131,164,278,500,333,5130,0,0,19,191,'croc_clan',300,0,2,'LAST_HIT'),
	(20794,20794,'Blade Stakato',0,'',0,'Monster.blade_stakato',15.00,36.00,41,'male','L2Monster',40,1593,560,17.38,2.14,40,43,30,21,20,10,2103,137,265,229,141,169,278,0,333,223,0,0,27,191,'stakato_clan',300,0,2,'LAST_HIT'),
	(20795,20795,'Blade Stakato Worker',0,'',0,'Monster.blade_stakato_worker',13.00,40.00,42,'male','L2Monster',40,1660,589,17.38,2.14,40,43,30,21,20,10,1988,132,272,215,152,175,317,0,333,226,0,0,27,191,'stakato_clan',300,0,2,'LAST_HIT'),
	(20796,20796,'Blade Stakato Warrior',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,43,'male','L2Monster',40,1728,618,17.38,2.14,40,43,30,21,20,10,2125,143,365,202,163,181,278,500,333,232,0,0,27,191,'stakato_clan',300,0,2,'LAST_HIT'),
	(20797,20797,'Blade Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,44,'male','L2Monster',40,1799,648,26.07,2.14,40,43,30,21,20,10,2154,147,390,178,176,187,278,0,333,74,0,0,27,191,'stakato_clan',300,0,3,'LAST_HIT'),
	(20798,20798,'Water Giant',0,'',0,'Monster.water_giant',13.00,44.00,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,2612,181,343,262,188,193,278,500,333,5132,0,0,38,191,NULL,0,0,3,'LAST_HIT'),
	(20799,20799,'Queen Undine Lad',0,'',0,'Monster.undine',12.00,27.00,46,'female','L2Monster',40,1943,707,17.38,2.14,40,43,30,21,20,10,2630,186,442,190,202,199,278,0,333,0,0,0,66,191,NULL,0,0,3,'LAST_HIT'),
	(20800,20800,'Eva''s Seeker',0,'',0,'Monster.field_stalker',15.00,30.00,47,'male','L2Monster',40,2016,738,17.38,2.14,40,43,30,21,20,10,2465,176,388,279,216,206,278,0,333,0,0,0,77,191,NULL,0,0,4,'LAST_HIT'),
	(20801,20801,'Theeder Piker',0,'',0,'Monster.theeder',9.00,32.00,48,'male','L2Monster',80,2091,768,17.38,2.14,40,43,30,21,20,10,2972,217,481,288,231,212,237,500,333,302,0,0,88,191,'theeder_clan',300,0,4,'LAST_HIT'),
	(20802,20802,'Theeder Mage',0,'',0,'Monster.theeder',9.00,32.00,49,'male','L2Monster',40,2168,799,17.38,2.14,40,43,30,21,20,10,3025,223,529,208,247,219,278,0,333,192,0,0,88,191,'theeder_clan',300,0,4,'LAST_HIT'),
	(20803,20803,'Doll Master',0,'',0,'Monster.doll_master',20.00,42.00,50,'male','L2Monster',40,2245,830,26.07,2.14,40,43,30,21,20,10,3949,297,616,230,264,226,278,500,333,0,0,0,88,191,NULL,0,1,5,'LAST_HIT'),
	(20804,20804,'Crokian Lad',0,'',0,'Monster.crokian_100_bi',36.00,61.00,41,'male','L2Monster',40,1593,560,17.38,2.14,40,43,30,21,20,10,2574,168,291,208,141,169,278,500,333,5128,0,0,19,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20805,20805,'Dailaon Lad',0,'',0,'Monster.dailaon_100_bi',40.00,58.00,42,'male','L2Monster',500,1660,589,17.38,2.14,40,43,30,21,20,10,2790,186,762,196,152,175,249,0,333,5127,0,0,19,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20806,20806,'Crokian Lad Warrior',0,'',0,'Monster.crokian_100_bi',36.00,61.00,43,'male','L2Monster',40,1728,618,17.38,2.14,40,43,30,21,20,10,2678,181,365,202,163,181,278,500,333,5128,0,0,19,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20807,20807,'Farhite Lad',0,'',0,'Monster.farhite_50_bi',24.00,48.00,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,2817,193,390,178,176,187,278,0,333,5131,0,0,16,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20808,20808,'Nos Lad',0,'',0,'Monster.nos_100_bi',52.00,86.00,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,3487,242,343,262,188,193,278,500,333,128,0,0,19,191,'croc_clan2',300,0,0,'LAST_HIT'),
	(20809,20809,'Ghost of the Tower',0,'',0,'Monster.human_ghost',8.00,22.00,60,'male','L2Monster',40,3054,1150,30.81,2.45,40,43,30,21,20,10,4045,351,860,368,478,299,278,500,333,0,0,0,88,157,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(20810,20810,'Seer of Hallate',0,'',0,'Monster.field_stalker',15.00,30.00,60,'male','L2Monster',40,3054,1150,30.81,2.45,40,43,30,21,20,10,4045,351,946,335,478,299,278,500,333,0,0,0,77,187,'hallate_clan',400,0,0,'LAST_HIT'),
	(20811,20811,'Ghastly Warrior',0,'',0,'Monster.unpleasant_humming',12.00,26.00,61,'male','L2Monster',40,3137,1184,35.55,2.78,40,43,30,21,20,10,4769,419,717,416,505,307,317,500,333,0,0,0,23,165,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(20812,20812,'Archer of Despair',0,'',0,'Monster.skeleton_archer',11.00,27.00,61,'male','L2Monster',500,3137,1184,35.55,2.78,40,43,30,21,20,10,4708,414,2204,292,505,307,249,500,333,284,0,0,44,176,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(20813,20813,'Crendion',0,'',0,'Monster.liviona',15.00,28.00,62,'male','L2Monster',40,3219,1217,35.55,2.78,40,43,30,21,20,10,4276,381,944,388,532,315,278,500,333,0,0,0,88,176,'tower_ghost_clan',300,0,0,'LAST_HIT'),
	(20814,20814,'Blader of Despair',0,'',0,'Monster.spartoi',11.00,27.00,62,'male','L2Monster',80,3219,1217,35.55,2.78,40,43,30,21,20,10,4938,440,1212,353,532,315,237,500,333,79,0,0,66,157,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(20815,20815,'Hound Dog of Hallate',0,'',0,'Monster.dire_wolf',13.00,11.00,63,'male','L2Monster',40,3302,1251,47.40,2.78,40,43,30,21,20,10,4583,413,897,438,560,323,278,500,333,0,0,0,26,181,'hallate_clan',400,0,0,'LAST_HIT'),
	(20816,20816,'Hallate''s Royal Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,63,'male','L2Monster',40,3302,1251,35.55,2.78,40,43,30,21,20,10,5098,460,785,438,560,323,317,500,333,946,945,0,88,180,'hallate_clan',400,1,0,'LAST_HIT'),
	(20817,20817,'Corrupt Sage',0,'',0,'Monster.vale_master',12.00,40.00,64,'male','L2Monster',40,3384,1285,35.55,2.78,40,43,30,21,20,10,5315,486,1135,315,589,331,278,500,333,210,0,0,77,176,'tower_ghost_clan',400,0,0,'LAST_HIT'),
	(20818,20818,'Hallate''s Warrior',0,'',0,'Monster.skeleton_knight',10.00,25.00,64,'male','L2Monster',40,3384,1285,35.55,2.78,40,43,30,21,20,10,4926,451,1135,371,589,331,278,500,333,78,0,0,44,176,'hallate_clan',400,1,0,'LAST_HIT'),
	(20819,20819,'Archer of Abyss',0,'',0,'Monster.fiend_archer',17.00,55.00,65,'male','L2Monster',500,3465,1319,35.55,2.78,40,43,30,21,20,10,4889,454,2632,380,619,340,249,500,333,0,0,0,77,181,'tower_ghost_clan',400,0,0,'LAST_HIT'),
	(20820,20820,'Hallate''s Knight',0,'',0,'Monster.death_knight',12.00,31.00,65,'male','L2Monster',40,3465,1319,47.40,2.78,40,43,30,21,20,10,7310,679,979,460,619,340,278,500,333,80,0,0,29,176,'hallate_clan',400,1,0,'LAST_HIT'),
	(20821,20821,'Erin Ediunce',0,'',0,'Monster.banshee',9.00,23.00,66,'female','L2Monster',40,3546,1353,47.40,2.78,40,43,30,21,20,10,5335,502,1020,401,649,348,278,500,333,3939,0,0,88,181,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20822,20822,'Hallate''s Maid',0,'',0,'Monster.bloody_queen',14.00,40.00,66,'female','L2Monster',40,3546,1353,47.40,2.78,40,43,30,21,20,10,4964,467,893,471,649,348,317,500,333,0,0,0,88,176,'hallate_clan',400,0,0,'LAST_HIT'),
	(20823,20823,'Platinum Tribe Soldier',0,'',0,'Monster.kel_mahum',13.00,26.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,5764,549,1126,399,681,356,317,500,333,242,0,0,55,176,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20824,20824,'Hallate''s Commander',0,'',0,'Monster.death_blader',15.00,45.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,5184,493,1286,399,681,356,278,500,333,1472,0,0,110,187,'hallate_clan',400,1,0,'LAST_HIT'),
	(20825,20825,'Hallate''s Inspector',0,'',0,'Monster.karik_25_bi',31.00,110.00,68,'male','L2Monster',40,3706,1423,47.40,2.78,40,43,30,21,20,10,5414,523,1339,408,713,365,278,500,333,0,0,0,40,187,'hallate_clan',400,0,0,'LAST_HIT'),
	(20826,20826,'Platinum Tribe Archer',0,'',0,'Monster.kel_mahum_archer',13.00,27.00,68,'male','L2Monster',500,3706,1423,35.55,2.78,40,43,30,21,20,10,7650,739,2975,347,713,365,249,500,333,288,0,0,55,176,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20827,20827,'Platinum Tribe Warrior',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,69,'male','L2Monster',40,3784,1458,47.40,2.78,40,43,30,21,20,10,5991,586,1150,506,746,373,278,500,333,148,0,0,55,176,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20828,20828,'Platinum Tribe Shaman',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,70,'male','L2Monster',40,3862,1493,59.25,2.78,40,43,30,21,20,10,5881,583,1445,427,780,382,278,500,333,202,0,0,55,176,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20829,20829,'Platinum Tribe Overlord',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,71,'male','L2Monster',40,3938,1529,67.15,3.09,40,43,30,21,20,10,8449,847,1239,529,814,390,278,500,333,147,0,0,55,187,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20830,20830,'Guardian Angel',0,'',0,'Monster.angel',13.50,36.50,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,0,0,1710,406,849,399,278,500,333,148,0,0,33,187,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20831,20831,'Seal Angel',0,'',0,'Monster.angel',13.50,36.50,73,'male','L2Monster',40,4086,1601,67.15,3.09,40,43,30,21,20,10,0,0,1770,415,885,407,278,500,333,148,0,0,33,187,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20832,20832,'Zaken''s Pikeman',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,2720,184,249,252,163,181,278,500,333,292,0,0,55,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(20833,20833,'Zaken''s Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,44,'male','L2Monster',500,1799,648,8.69,2.14,40,43,30,21,20,10,3025,207,592,260,176,187,249,0,333,279,0,0,44,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(20834,20834,'Mardian',0,'',0,'Monster.giant_spider',26.00,25.50,42,'male','L2Monster',40,1660,589,17.38,2.14,40,43,30,21,20,10,2251,150,342,196,152,175,278,500,333,0,0,0,79,191,NULL,0,0,0,'LAST_HIT'),
	(20835,20835,'Zaken''s Seer',0,'',0,'Monster.liviona',15.00,28.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,2478,172,283,269,188,193,278,500,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20836,20836,'Pirate Zombie',0,'',0,'Monster.pirates_zombie',10.00,23.00,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,2832,194,341,209,176,187,317,0,333,225,0,0,12,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(20837,20837,'Tainted Ogre',0,'',0,'Monster.ogre',21.00,44.00,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,2565,178,577,216,188,193,200,500,333,194,0,0,24,191,'undead_clan1',300,0,0,'LAST_HIT'),
	(20838,20838,'Bloody Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,2405,167,300,262,188,193,317,0,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20839,20839,'Unpleasant Humming',0,'',0,'Monster.unpleasant_humming',12.00,26.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,2877,204,301,327,202,199,278,500,333,0,0,0,23,191,'undead_clan',300,1,3,'LAST_HIT'),
	(20840,20840,'Death Flyer',0,'',0,'Monster.dark_horror',20.00,35.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,2971,213,320,287,216,206,278,0,333,0,0,0,110,191,'undead_clan',300,1,4,'LAST_HIT'),
	(20841,20841,'Fiend Archer',0,'',0,'Monster.fiend_archer',17.00,55.00,48,'male','L2Monster',500,2091,768,8.69,2.14,40,43,30,21,20,10,3052,223,757,296,231,212,249,500,333,0,0,0,77,191,'demonic_clan',300,0,4,'LAST_HIT'),
	(20842,20842,'Musveren',0,'',0,'Monster.field_stalker',15.00,30.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,2910,215,361,359,247,219,278,0,333,0,0,0,77,191,'undead_clan',300,0,4,'LAST_HIT'),
	(20843,20843,'Zaken''s Royal Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3677,277,335,370,264,226,317,500,333,225,945,0,88,191,'undead_clan',300,1,5,'LAST_HIT'),
	(20844,20844,'Kaim Vanul',0,'',0,'Monster.kaim_vanul',24.00,40.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3279,250,405,381,281,232,278,0,333,0,0,0,40,191,'demonic_clan',300,0,5,'LAST_HIT'),
	(20845,20845,'Pirate''s Zombie Captain',0,'',0,'Monster.pirates_zombie_captain',17.00,28.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,4954,383,375,393,300,239,317,500,333,232,0,0,15,191,'zaken_clan',300,1,5,'LAST_HIT'),
	(20846,20846,'Doll Blader',0,'',0,'Monster.doll_blader',6.00,12.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,3931,309,396,344,319,247,317,0,333,5129,5129,0,24,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(20847,20847,'Vale Master',0,'',0,'Monster.vale_master',12.00,40.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,3750,299,477,354,339,254,278,500,333,0,0,0,77,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(20848,20848,'Light Bringer',0,'',0,'Monster.light_bringer',10.00,23.00,46,'male','L2Monster',40,1943,707,17.38,2.14,40,43,30,21,20,10,2432,172,401,245,202,199,278,500,333,0,0,0,66,191,NULL,0,0,3,'LAST_HIT'),
	(20849,20849,'Light Worm',0,'',0,'Monster.light_worm',5.00,16.00,41,'male','L2Monster',40,1593,560,17.38,2.14,40,43,30,21,20,10,1932,126,265,229,141,169,278,500,333,0,0,0,66,191,NULL,0,0,2,'LAST_HIT'),
	(20850,20850,'Golden Stag Lord',0,'',0,'Monster.golden_stag_lord',25.00,30.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3152,237,509,278,264,226,278,0,333,0,0,0,38,191,NULL,0,0,0,'LAST_HIT'),
	(20851,20851,'Theeder',0,'',0,'Monster.theeder',9.00,32.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,2841,204,498,253,216,206,237,500,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20852,20852,'Banshee',0,'',0,'Monster.banshee',9.00,23.00,60,'female','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,4450,386,828,335,478,299,317,500,333,3939,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20853,20853,'Kel Mahum',0,'',0,'Monster.kel_mahum',13.00,26.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7824,727,942,418,619,340,317,500,333,242,0,0,55,191,'kel_mahum_clan',300,0,0,'LAST_HIT'),
	(20854,20854,'Kel Mahum Warrior',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,7686,723,1235,389,649,348,278,500,333,148,0,0,55,191,'kel_mahum_clan',300,0,0,'LAST_HIT'),
	(20855,20855,'Kel Mahum Archer',0,'',0,'Monster.kel_mahum_archer',13.00,27.00,67,'male','L2Monster',500,3626,1388,11.85,2.78,40,43,30,21,20,10,8900,848,2859,339,681,356,249,0,333,288,0,0,55,191,'kel_mahum_clan',300,0,0,'LAST_HIT'),
	(20856,20856,'Kel Mahum Shaman',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,6390,617,1339,347,713,365,278,500,333,202,0,0,55,191,'kel_mahum_clan',300,0,0,'LAST_HIT'),
	(20857,20857,'Kel Mahum Champion',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,8149,808,1445,427,780,382,278,500,333,147,0,0,55,191,'kel_mahum_clan',300,0,0,'LAST_HIT'),
	(20858,20858,'Angel',0,'',0,'Monster.angel',13.50,36.50,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,9102,925,1554,446,849,399,278,500,333,148,0,0,33,191,'tower_guard_clan',300,0,0,'LAST_HIT'),
	(20859,20859,'Guardian Angel',0,'',0,'Monster.angel',13.50,36.50,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,12443,1264,1554,446,849,399,278,500,333,148,0,0,33,187,'tower_guard_clan',400,0,0,'LAST_HIT'),
	(20860,20860,'Seal Angel',0,'',0,'Monster.angel',13.50,36.50,73,'male','L2Monster',40,4086,1601,67.15,3.09,40,43,30,21,20,10,13949,1435,1330,552,885,407,278,500,333,148,0,0,33,187,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(20861,20861,'Oel Mahum Champion',0,'',0,'Monster.oel_mahum_champion',23.00,61.00,56,'male','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,5533,454,777,301,382,269,278,500,333,127,0,0,73,191,'oel_mahum_clan',300,0,0,'LAST_HIT'),
	(20862,20862,'Death Lord',0,'',0,'Monster.death_lord',21.00,40.00,75,'male','L2Monster',40,4229,1673,13.43,3.09,40,43,30,21,20,10,7774,820,1720,475,957,425,278,0,333,78,0,0,44,191,'demonic_clan',300,1,0,'LAST_HIT'),
	(20919,20919,'Maille Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,20,'male','L2Monster',40,541,213,1.98,1.21,40,43,30,21,20,10,641,28,57,94,23,76,278,0,333,291,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20920,20920,'Maille Lizardman Scout',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,22,'male','L2Monster',500,611,242,2.77,1.53,40,43,30,21,20,10,1187,56,153,102,28,83,249,0,333,2507,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20921,20921,'Maille Lizardman Guard',0,'',0,'Monster.virud_lizardman',10.00,23.00,24,'male','L2Monster',40,687,272,2.77,1.53,40,43,30,21,20,10,858,42,81,111,34,90,278,500,333,291,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20922,20922,'Maille Lizardman Warrior',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,26,'male','L2Monster',40,770,303,2.77,1.53,40,43,30,21,20,10,951,48,96,120,41,98,278,0,333,16,0,0,57,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20923,20923,'Maille Lizardman Shaman',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,28,'male','L2Monster',40,859,334,2.77,1.53,40,43,30,21,20,10,1392,74,113,130,49,106,278,0,333,7,0,0,47,132,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20924,20924,'Maille Lizardman Matriarch',0,'',0,'Monster.virud_lizardman_matriarch',13.00,37.00,30,'male','L2Monster',40,954,365,2.77,1.53,40,43,30,21,20,10,1708,94,132,140,58,114,278,500,333,69,627,0,61,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20925,20925,'Giant Araneid',0,'',0,'Monster.giant_spider',26.00,25.50,24,'male','L2Monster',40,687,272,2.77,1.53,40,43,30,21,20,10,875,44,81,94,34,90,278,0,333,0,0,0,79,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20926,20926,'Poison Araneid',0,'',0,'Monster.poison_spider',27.00,25.50,25,'male','L2Monster',40,728,287,2.77,1.53,40,43,30,21,20,10,1012,50,88,98,37,94,278,0,333,0,0,0,66,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20927,20927,'King of the Araneid',0,'',0,'Monster.giant_spider_50_bi',39.00,38.00,27,'male','L2Monster',40,813,318,2.77,1.53,40,43,30,21,20,10,1453,74,104,106,45,102,278,500,333,0,0,0,79,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(20928,20928,'Hatu Weird Bee',0,'',0,'Monster.giant_bee',8.00,24.50,30,'male','L2Minion',40,954,365,2.77,1.53,40,43,30,21,20,10,1468,80,132,140,58,114,278,500,333,0,0,0,99,132,'hatu_clan',300,0,0,'LAST_HIT'),
	(20929,20929,'Hatu Dire Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,32,'male','L2Minion',40,1056,397,3.56,1.84,40,43,30,21,20,10,1393,78,154,151,69,123,278,0,333,0,0,0,26,121,'hatu_clan',300,0,0,'LAST_HIT'),
	(20930,20930,'Hatu Brown Bear',0,'',0,'Monster.grizzly',21.00,40.00,34,'male','L2Monster',40,1164,430,3.56,1.84,40,43,30,21,20,10,2195,128,178,163,82,132,278,500,333,0,0,0,44,157,'hatu_clan',300,0,0,'LAST_HIT'),
	(20931,20931,'Hatu Onyx Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,36,'male','L2Minion',40,1279,463,3.56,1.84,40,43,30,21,20,10,2035,124,206,175,96,142,278,0,333,0,0,0,33,191,'hatu_clan',300,0,0,'LAST_HIT'),
	(20932,20932,'Hatu Crimson Bear',0,'',0,'Monster.crimson_bear',19.00,36.00,38,'male','L2Minion',40,1400,497,3.56,1.84,40,43,30,21,20,10,2688,168,238,188,112,153,278,0,333,0,0,0,40,191,'hatu_clan',300,0,0,'LAST_HIT'),
	(20933,20933,'Hatu Windsus',0,'',0,'Monster.giant_wild_hog',35.00,27.00,40,'male','L2Monster',40,1527,531,3.56,1.84,40,43,30,21,20,10,3080,198,273,201,131,164,278,500,333,0,0,0,38,191,'hatu_clan',300,0,0,'LAST_HIT'),
	(20934,20934,'Wasp Worker',0,'',0,'Monster.giant_bee_bi',8.00,32.00,35,'male','L2Minion',40,1220,446,3.56,1.84,40,43,30,21,20,10,1651,98,192,144,89,137,278,0,333,0,0,0,99,191,NULL,0,0,0,'LAST_HIT'),
	(20935,20935,'Wasp Leader',0,'',0,'Monster.giant_bee_100_bi',16.00,49.00,37,'male','L2Monster',40,1338,480,3.56,1.84,40,43,30,21,20,10,1809,112,222,154,104,147,278,500,333,0,0,0,99,191,NULL,0,0,0,'LAST_HIT'),
	(20936,20936,'Tanor Silenos',0,'',0,'Monster.heltor_silenos',13.00,29.00,40,'male','L2Monster',40,1527,531,3.56,1.84,40,43,30,21,20,10,3443,222,273,201,131,164,278,0,333,88,0,0,37,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20937,20937,'Tanor Silenos Grunt',0,'',0,'Monster.heltor_silenos',13.00,29.00,42,'male','L2Minion',40,1660,589,4.35,2.14,40,43,30,21,20,10,4498,300,311,215,152,175,278,0,333,158,18,0,37,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20938,20938,'Tanor Silenos Scout',0,'',0,'Monster.heltor_silenos',13.00,29.00,44,'male','L2Minion',40,1799,648,4.35,2.14,40,43,30,21,20,10,4937,338,354,230,176,187,278,0,333,5,0,0,37,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20939,20939,'Tanor Silenos Warrior',0,'',0,'Monster.heltor_silenos_warrior',13.00,31.00,46,'male','L2Minion',40,1943,707,4.35,2.14,40,43,30,21,20,10,5504,390,401,245,202,199,278,500,333,160,0,0,39,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20940,20940,'Tanor Silenos Shaman',0,'',0,'Monster.heltor_silenos_shaman',13.00,32.00,48,'male','L2Minion',40,2091,768,4.35,2.14,40,43,30,21,20,10,6707,490,453,261,231,212,278,0,333,9,0,0,31,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20941,20941,'Tanor Silenos Chieftain',0,'',0,'Monster.heltor_silenos_chieftain',13.00,31.50,50,'male','L2Monster',40,2245,830,4.35,2.14,40,43,30,21,20,10,6503,490,509,278,264,226,278,500,333,75,0,0,29,191,'silenos_clan',300,0,0,'LAST_HIT'),
	(20942,20942,'Nightmare Guide',0,'',0,'Monster.harpy',10.00,42.00,43,'female','L2Minion',40,1728,618,4.35,2.14,40,43,30,21,20,10,3282,222,332,189,163,181,278,0,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20943,20943,'Nightmare Keeper',0,'',0,'Monster.harpy',10.00,42.00,45,'female','L2Minion',40,1870,677,4.35,2.14,40,43,30,21,20,10,4721,328,377,202,188,193,278,0,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20944,20944,'Nightmare Lord',0,'',0,'Monster.succubus_100_bi',20.00,75.00,47,'female','L2Monster',40,2016,738,4.35,2.14,40,43,30,21,20,10,4000,286,427,215,216,206,278,500,333,0,0,0,66,191,NULL,0,0,0,'LAST_HIT'),
	(20945,20945,'Cadeine',0,'',0,'Monster.hobgoblin',12.00,24.00,50,'male','L2Minion',40,2245,830,4.35,2.14,40,43,30,21,20,10,4483,338,509,278,264,226,278,0,333,127,625,0,49,191,'green_clan',300,0,0,'LAST_HIT'),
	(20946,20946,'Sanhidro',0,'',0,'Monster.troll',21.00,35.00,52,'male','L2Minion',40,2402,892,5.14,2.45,40,43,30,21,20,10,6896,534,570,295,300,239,278,0,333,0,0,0,60,191,'green_clan',300,0,0,'LAST_HIT'),
	(20947,20947,'Connabi',0,'',0,'Monster.bugbear',17.00,35.00,54,'male','L2Monster',40,2562,955,5.14,2.45,40,43,30,21,20,10,7437,592,636,313,339,254,278,0,333,88,0,0,60,191,'green_clan',300,0,0,'LAST_HIT'),
	(20948,20948,'Bartal',0,'',0,'Monster.liviona',15.00,28.00,56,'male','L2Minion',40,2724,1019,5.14,2.45,40,43,30,21,20,10,7385,606,706,331,382,269,278,0,333,0,0,0,88,191,'green_clan',300,0,0,'LAST_HIT'),
	(20949,20949,'Luminun',0,'',0,'Monster.twin_headed_giant',17.00,39.00,58,'male','L2Minion',40,2889,1084,5.14,2.45,40,43,30,21,20,10,8700,734,781,349,428,284,278,0,333,157,0,0,49,191,'green_clan',300,0,0,'LAST_HIT'),
	(20950,20950,'Innersen',0,'',0,'Monster.king_bugbear',15.00,40.00,60,'male','L2Monster',40,3054,1150,5.14,2.45,40,43,30,21,20,10,9365,812,860,368,478,299,278,500,333,160,0,0,60,191,'green_clan',300,0,0,'LAST_HIT'),
	(20951,20951,'Pobby''s Maid',0,'',0,'Monster.manadragora',14.00,17.80,53,'female','L2Minion',40,2481,923,5.14,2.45,40,43,30,21,20,10,5037,396,602,258,319,247,278,0,333,0,0,0,88,191,'green_clan',300,0,0,'LAST_HIT'),
	(20952,20952,'Pobby Escort',0,'',0,'Monster.mandragora_b',12.00,25.50,55,'female','L2Minion',40,2643,987,5.14,2.45,40,43,30,21,20,10,9101,734,670,273,360,261,278,0,333,0,0,0,88,191,'green_clan',300,0,0,'LAST_HIT'),
	(20953,20953,'Pobby',0,'',0,'Monster.mandragora_a',15.00,26.00,57,'female','L2Monster',40,2806,1052,5.14,2.45,40,43,30,21,20,10,8452,702,743,289,405,276,278,500,333,0,0,0,88,191,'green_clan',300,0,0,'LAST_HIT'),
	(20954,20954,'Hungered Corpse',0,'',0,'Monster.skeleton',11.00,25.00,60,'male','L2Minion',40,3054,1150,5.14,2.45,40,43,30,21,20,10,9985,866,860,368,478,299,278,0,333,123,945,0,66,198,'bloody_clan',300,1,0,'LAST_HIT'),
	(20955,20955,'Ghostly Warrior',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,62,'male','L2Minion',40,3219,1217,5.93,2.78,40,43,30,21,20,10,10662,950,944,388,532,315,278,0,333,299,0,0,55,198,'bloody_clan',300,1,0,'LAST_HIT'),
	(20956,20956,'Past Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,64,'male','L2Monster',40,3384,1285,5.93,2.78,40,43,30,21,20,10,11588,1060,1031,408,589,331,278,500,333,150,103,0,44,191,'bloody_clan',300,1,0,'LAST_HIT'),
	(20957,20957,'Nihil Invader',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,66,'male','L2Minion',40,3546,1353,5.93,2.78,40,43,30,21,20,10,12082,1138,1123,428,649,348,278,0,333,946,945,0,88,203,'bloody_clan',300,1,0,'LAST_HIT'),
	(20958,20958,'Death Agent',0,'',0,'Monster.death_blader',15.00,45.00,68,'male','L2Minion',40,3706,1423,5.93,2.78,40,43,30,21,20,10,9018,872,1217,449,713,365,278,0,333,1472,0,0,110,214,'bloody_clan',300,1,0,'LAST_HIT'),
	(20959,20959,'Dark Guard',0,'',0,'Monster.headless_knight',21.00,31.00,70,'male','L2Monster',40,3862,1493,5.93,2.78,40,43,30,21,20,10,13863,1374,1314,470,780,382,278,500,333,124,0,0,77,187,'bloody_clan',300,1,0,'LAST_HIT'),
	(20960,20960,'Bloody Ghost',0,'',0,'Monster.succubus',10.00,36.00,64,'female','L2Minion',40,3384,1285,5.93,2.78,40,43,30,21,20,10,7988,732,1031,347,589,331,278,0,333,0,0,0,66,192,'bloody_clan',300,0,0,'LAST_HIT'),
	(20961,20961,'Bloody Knight',0,'',0,'Monster.doll_blader',6.00,12.00,65,'male','L2Minion',40,3465,1319,5.93,2.78,40,43,30,21,20,10,11719,1088,1077,355,619,340,278,0,333,5129,5129,0,24,192,'bloody_clan',300,0,0,'LAST_HIT'),
	(20962,20962,'Bloody Priest',0,'',0,'Monster.bloody_queen',14.00,40.00,66,'female','L2Minion',40,3546,1353,5.93,2.78,40,43,30,21,20,10,13045,1228,1123,364,649,348,278,0,333,0,0,0,88,203,'bloody_clan',300,0,0,'LAST_HIT'),
	(20963,20963,'Bloody Lord',0,'',0,'Monster.banshee',9.00,23.00,68,'female','L2Monster',40,3706,1423,5.93,2.78,40,43,30,21,20,10,9382,906,1217,382,713,365,278,500,333,3939,0,0,88,198,'bloody_clan',300,0,0,'LAST_HIT'),
	(20964,20964,'Huge Footmark',0,'',0,'Monster.stone_golem',20.00,31.00,70,'male','L2Minion',40,3862,1493,5.93,2.78,40,43,30,21,20,10,13513,1340,1314,470,780,382,278,0,333,0,0,0,25,25,'giant_clan',300,0,0,'LAST_HIT'),
	(20965,20965,'Chimera Piece',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,72,'male','L2Minion',40,4013,1565,6.72,3.09,40,43,30,21,20,10,14379,1460,1413,491,849,399,278,0,333,0,0,0,66,191,'giant_clan',300,0,0,'LAST_HIT'),
	(20966,20966,'Black Shadow',0,'',0,'Monster.drake',30.00,100.00,74,'male','L2Monster',40,4158,1637,6.72,3.09,40,43,30,21,20,10,15493,1616,1513,512,921,416,278,500,333,0,0,0,77,203,'giant_clan',300,0,0,'LAST_HIT'),
	(20967,20967,'Past Creature',0,'',0,'Monster.gamlin',11.00,32.00,76,'male','L2Minion',40,4297,1710,6.72,3.09,40,43,30,21,20,10,16021,1712,1614,534,994,433,278,0,333,0,0,0,88,187,'giant_clan',300,0,0,'LAST_HIT'),
	(20968,20968,'Nonexistent Man',0,'',0,'Monster.susceptor',20.00,35.00,78,'male','L2Minion',40,4428,1784,6.72,3.09,40,43,30,21,20,10,15583,1706,1715,555,1069,451,278,0,333,0,0,0,29,165,'giant_clan',300,0,0,'LAST_HIT'),
	(20969,20969,'Giant''s Shadow',0,'',0,'Monster.lesser_giant_shooter',21.00,44.00,79,'male','L2Monster',500,4490,1821,6.72,3.09,40,43,30,21,20,10,13043,1446,3921,566,1107,459,249,500,333,4028,0,0,88,209,'giant_clan',300,0,0,'LAST_HIT'),
	(20970,20970,'Soldier of Ancient Times',0,'',0,'Monster.lesser_giant',21.00,44.00,73,'male','L2Minion',40,4086,1601,6.72,3.09,40,43,30,21,20,10,10913,1122,1463,426,885,407,278,0,333,3937,0,0,16,209,'giant_clan',300,0,0,'LAST_HIT'),
	(20971,20971,'Warrior of Ancient Times',0,'',0,'Monster.lesser_giant',21.00,44.00,75,'male','L2Minion',40,4229,1673,6.72,3.09,40,43,30,21,20,10,15602,1646,1563,445,957,425,278,0,333,3937,0,0,16,203,'giant_clan',300,0,0,'LAST_HIT'),
	(20972,20972,'Shaman of Ancient Times',0,'',0,'Monster.lesser_giant_mage',21.00,44.00,75,'male','L2Minion',40,4229,1673,6.72,3.09,40,43,30,21,20,10,10970,1158,1563,445,957,425,278,0,333,3938,0,0,16,214,'giant_clan',300,0,0,'LAST_HIT'),
	(20973,20973,'Forgotten Ancient People',0,'',0,'Monster.lesser_giant_mage',21.00,44.00,77,'male','L2Monster',40,4364,1747,6.72,3.09,40,43,30,21,20,10,16958,1836,1664,463,1031,442,278,500,333,3938,0,0,16,203,'giant_clan',300,0,0,'LAST_HIT'),
	(20974,20974,'Spiteful Soul Leader',0,'',0,'Monster.skeleton_royal_guard_bi',16.00,44.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,11772,1094,1077,418,619,340,278,0,333,946,945,0,88,191,'undead_clan',300,1,0,'LAST_HIT'),
	(20975,20975,'Spiteful Soul Wizard',0,'',0,'Monster.elf_ghost_50_bi',10.00,32.00,63,'male','L2Minion',40,3302,1251,11.85,2.78,40,43,30,21,20,10,10499,948,987,398,560,323,278,0,333,0,0,0,88,191,NULL,0,1,0,'LAST_HIT'),
	(20976,20976,'Spiteful Soul Fighter',0,'',0,'Monster.human_ghost_50_bi',12.00,33.00,62,'male','L2Minion',40,3219,1217,11.85,2.78,40,43,30,21,20,10,8911,794,944,388,532,315,278,0,333,0,0,0,88,191,NULL,0,1,0,'LAST_HIT'),
	(20977,20977,'Elmoradan''s Lady',0,'',0,'Monster.banshee_50_bi',13.50,38.00,65,'female','L2Monster',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7513,698,979,460,619,340,278,500,333,3939,0,0,88,176,'tower_ghost_clan',400,0,0,'LAST_HIT'),
	(20978,20978,'Elmoradan''s Archer Escort',0,'',0,'Monster.skeleton_archer',11.00,27.00,64,'male','L2Minion',500,3384,1285,23.70,2.78,40,43,30,21,20,10,7470,684,2522,315,589,331,249,0,333,284,0,0,44,154,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(20979,20979,'Elmoradan''s Maid',0,'',0,'Monster.doll_blader',6.00,12.00,64,'male','L2Minion',40,3384,1285,23.70,2.78,40,43,30,21,20,10,7141,654,1135,371,589,331,278,0,333,5129,5129,0,24,187,'tower_ghost_clan',400,0,0,'LAST_HIT'),
	(20980,20980,'Hallate''s Follower Mul',0,'',0,'Monster.vale_master',12.00,40.00,68,'male','L2Monster',40,3706,1423,23.70,2.78,40,43,30,21,20,10,7606,735,1339,408,713,365,278,500,333,210,0,0,77,187,'hallate_clan',400,0,0,'LAST_HIT'),
	(20981,20981,'Mul''s Wizard',0,'',0,'Monster.kaim_vanul_50_bi',36.00,60.00,67,'male','L2Minion',40,3626,1388,23.70,2.78,40,43,30,21,20,10,7564,720,1063,483,681,356,278,0,333,0,0,0,40,176,'hallate_clan',400,0,0,'LAST_HIT'),
	(20982,20982,'Mul''s Knight',0,'',0,'Monster.dre_vanul_100_bi',28.00,75.00,67,'male','L2Minion',40,3626,1388,23.70,2.78,40,43,30,21,20,10,6676,636,1126,399,681,356,317,0,333,0,0,0,88,157,'hallate_clan',400,0,0,'LAST_HIT'),
	(20983,20983,'Binder',0,'',0,'Monster.kel_mahum_champion_50_bi',19.00,48.00,73,'male','L2Monster',40,4086,1601,26.86,3.09,40,43,30,21,20,10,10342,1064,1609,456,885,407,278,500,333,147,0,0,55,187,'tower_guard_clan',400,0,0,'LAST_HIT'),
	(20984,20984,'Bound Warrior',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,72,'male','L2Monster',40,4013,1565,26.86,3.09,40,43,30,21,20,10,9719,987,1554,446,849,399,278,0,333,148,0,0,55,176,'tower_guard_clan',50,0,0,'LAST_HIT'),
	(20985,20985,'Bound Archer',0,'',0,'Monster.kel_mahum_archer',13.00,27.00,72,'male','L2Monster',500,4013,1565,26.86,3.09,40,43,30,21,20,10,9647,980,3454,379,849,399,249,0,333,288,0,0,55,187,'tower_guard_clan',50,0,0,'LAST_HIT'),
	(20986,20986,'Sairon',0,'',0,'Monster.doll_blader_50_bi',9.00,20.50,54,'male','L2Monster',40,2562,955,20.54,2.45,40,43,30,21,20,10,5524,440,636,313,339,254,278,500,333,5129,5129,0,24,191,'demonic_clan',300,0,6,'LAST_HIT'),
	(20987,20987,'Sairon''s Doll',0,'',0,'Monster.doll_blader',6.00,12.00,53,'male','L2Minion',40,2481,923,20.54,2.45,40,43,30,21,20,10,5025,395,602,304,319,247,278,0,333,5129,5129,0,24,191,NULL,0,0,6,'LAST_HIT'),
	(20988,20988,'Sairon''s Puppet',0,'',0,'Monster.doll_blader',6.00,12.00,53,'male','L2Minion',40,2481,923,20.54,2.45,40,43,30,21,20,10,5527,434,602,304,319,247,278,0,333,5129,5129,0,24,191,NULL,0,0,6,'LAST_HIT'),
	(20989,20989,'Lageos',0,'',0,'Monster.marsh_stakato_drone_50_bi',13.00,37.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,2749,171,238,188,112,153,278,0,333,182,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(20990,20990,'Pageos',0,'',0,'Monster.marsh_stakato_soldier',10.00,25.00,38,'male','L2Minion',40,1400,497,7.11,1.84,40,43,30,21,20,10,2609,163,238,188,112,153,278,0,333,128,0,0,33,191,NULL,0,0,0,'LAST_HIT'),
	(20991,20991,'Swamp Tribe',0,'',0,'Monster.farhite_50_bi',24.00,48.00,45,'male','L2Monster',40,1870,677,17.38,2.14,40,43,30,21,20,10,5139,357,377,238,188,193,278,500,333,5131,0,0,16,191,'croc_clan',300,0,0,'LAST_HIT'),
	(20992,20992,'Swamp Alligator',0,'',0,'Monster.crokian',18.00,29.00,44,'male','L2Minion',40,1799,648,17.38,2.14,40,43,30,21,20,10,4600,315,354,230,176,187,278,0,333,5128,0,0,19,191,NULL,0,0,0,'LAST_HIT'),
	(20993,20993,'Swamp Warrior',0,'',0,'Monster.dailaon',20.00,28.00,44,'male','L2Minion',500,1799,648,17.38,2.14,40,43,30,21,20,10,4881,334,788,230,176,187,249,0,333,5127,0,0,19,191,NULL,0,0,0,'LAST_HIT'),
	(20994,20994,'Garden Guard Leader',0,'',0,'Monster.doll_master_50_bi',30.00,63.00,50,'male','L2Monster',40,2245,830,17.38,2.14,40,43,30,21,20,10,6194,466,560,253,264,226,278,500,333,0,0,0,88,191,'theeder_clan',300,1,5,'LAST_HIT'),
	(20995,20995,'Garden Guard',0,'',0,'Monster.theeder',9.00,32.00,48,'male','L2Minion',40,2091,768,17.38,2.14,40,43,30,21,20,10,4222,308,453,261,231,212,278,0,333,94,0,0,88,191,NULL,0,0,4,'LAST_HIT'),
	(20996,20996,'Spiteful Ghost of Ruins',0,'',0,'Monster.zombie',13.00,21.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,5349,403,560,253,264,226,278,500,333,0,0,0,16,16,'undead_clan',300,1,0,'LAST_HIT'),
	(20997,20997,'Soldier of Grief',0,'',0,'Monster.unpleasant_humming',12.00,26.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,3782,288,593,260,281,232,278,0,333,0,0,0,23,165,'undead_clan',300,1,0,'LAST_HIT'),
	(20998,20998,'Cruel Punisher',0,'',0,'Monster.hungry_spirit',30.00,40.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,4168,322,518,324,300,239,278,0,333,0,0,0,16,132,'undead_clan',300,1,0,'LAST_HIT'),
	(20999,20999,'Roving Soul',0,'',0,'Monster.skeleton',11.00,25.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,4943,389,527,304,319,247,317,0,333,75,0,0,66,176,'undead_clan',300,1,0,'LAST_HIT'),
	(21000,21000,'Soul of Ruins',0,'',0,'Monster.human_ghost',8.00,22.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,4325,345,578,344,339,254,278,500,333,0,0,0,88,191,'undead_clan',300,1,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(21001,21001,'Wretched Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,55,'male','L2Monster',500,2643,987,10.27,2.45,40,43,30,21,20,10,5856,473,1639,292,360,261,249,0,333,282,0,0,44,191,'undead_clan',300,1,0,'LAST_HIT'),
	(21002,21002,'Doom Scout',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,56,'male','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,5163,424,679,301,382,269,317,500,333,242,2496,0,88,191,'doom_clan',300,1,0,'LAST_HIT'),
	(21003,21003,'Grave Lich',0,'',0,'Monster.liviona',15.00,28.00,57,'male','L2Monster',40,2806,1052,10.27,2.45,40,43,30,21,20,10,4725,393,675,374,405,276,278,0,333,0,0,0,88,191,'undead_clan',300,0,0,'LAST_HIT'),
	(21004,21004,'Dismal Pole',0,'',0,'Monster.hanged_man_ripper',35.00,80.00,58,'male','L2Monster',80,2889,1084,10.27,2.45,40,43,30,21,20,10,5239,443,828,384,428,284,237,500,333,0,0,0,60,191,'undead_clan',300,0,0,'LAST_HIT'),
	(21005,21005,'Grave Predator',0,'',0,'Monster.devastator',35.00,35.00,59,'male','L2Monster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,5732,490,902,326,453,291,278,500,333,0,0,0,27,191,NULL,0,0,0,'LAST_HIT'),
	(21006,21006,'Doom Servant',0,'',0,'Monster.hungry_spirit',30.00,40.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,5447,473,946,335,478,299,278,500,333,0,0,0,16,191,'doom_clan',300,1,8,'LAST_HIT'),
	(21007,21007,'Doom Guard',0,'',0,'Monster.hungry_spirit',30.00,40.00,61,'male','L2Monster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,5844,514,992,344,505,307,278,0,333,0,0,0,16,191,'doom_clan',300,1,9,'LAST_HIT'),
	(21008,21008,'Doom Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,62,'male','L2Monster',500,3219,1217,11.85,2.78,40,43,30,21,20,10,7471,666,2308,353,532,315,249,500,333,286,0,0,44,191,'doom_clan',300,1,9,'LAST_HIT'),
	(21009,21009,'Doom Trooper',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,63,'male','L2Monster',80,3302,1251,11.85,2.78,40,43,30,21,20,10,7966,719,1267,362,560,323,237,0,333,301,0,0,55,191,'doom_clan',300,1,10,'LAST_HIT'),
	(21010,21010,'Doom Warrior',0,'',0,'Monster.skeleton_knight',10.00,25.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,6380,584,993,371,589,331,317,0,333,71,0,0,44,191,'doom_clan',300,1,10,'LAST_HIT'),
	(21011,21011,'Ol Mahum Van Grunt',0,'',0,'Monster.ol_mahum',13.50,25.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,333,5,0,0,55,165,'wererat_clan',300,0,0,'LAST_HIT'),
	(21012,21012,'Magical Eye',0,'',0,'Monster.magical_weaver',11.00,20.00,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1736,96,129,161,64,118,278,500,333,0,0,0,99,165,NULL,0,0,0,'LAST_HIT'),
	(21013,21013,'Ol Mahum Van Archer',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,32,'male','L2Monster',500,1056,397,7.11,1.84,40,43,30,21,20,10,1920,108,376,138,69,123,249,0,333,273,0,0,55,165,'wererat_clan',300,0,0,'LAST_HIT'),
	(21014,21014,'Lesser Warlike Tyrant',0,'',0,'Monster.grave',15.00,29.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,1987,114,151,173,75,128,278,500,333,0,0,0,77,165,'kinpin_clan',300,0,0,'LAST_HIT'),
	(21015,21015,'Ol Mahum Van Leader',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,2040,119,196,148,82,132,278,500,333,67,0,0,55,165,'wererat_clan',300,0,0,'LAST_HIT'),
	(21016,21016,'Warlike Tyrant',0,'',0,'Monster.grave',15.00,29.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,2192,130,211,154,89,137,278,0,333,0,0,0,77,191,'kinpin_clan',300,0,0,'LAST_HIT'),
	(21017,21017,'Fallen Orc',0,'',0,'Monster.ketra_orc',12.00,29.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,4399,355,737,292,360,261,278,0,333,127,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(21018,21018,'Ancient Gargoyle',0,'',0,'Monster.hunter_gargoyle',25.00,65.00,56,'male','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,5536,455,642,364,382,269,278,500,333,0,0,0,110,191,NULL,0,0,0,'LAST_HIT'),
	(21019,21019,'Fallen Orc Archer',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,57,'male','L2Monster',500,2806,1052,10.27,2.45,40,43,30,21,20,10,6093,506,1501,374,405,276,249,0,333,279,0,0,49,191,'orc_clan',300,0,0,'LAST_HIT'),
	(21020,21020,'Fallen Orc Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,6898,583,710,384,428,284,278,0,333,9,0,0,11,191,'orc_clan',300,0,0,'LAST_HIT'),
	(21021,21021,'Sharp Talon Tiger',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,59,'male','L2Monster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,6353,543,902,277,453,291,278,500,333,0,0,0,66,191,'beast_clan',300,0,0,'LAST_HIT'),
	(21022,21022,'Fallen Orc Captain',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,6462,561,946,285,478,299,278,500,333,160,0,0,39,191,'orc_clan',300,0,0,'LAST_HIT'),
	(21023,21023,'Sobbing Wind',0,'',0,'Monster.sylph',11.00,35.00,26,'female','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,1056,53,87,132,41,98,278,0,333,0,0,0,66,165,'elemental2_clan',300,0,0,'LAST_HIT'),
	(21024,21024,'Babbling Wind',0,'',0,'Monster.sylph',11.00,35.00,27,'female','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1113,57,94,138,45,102,278,0,333,0,0,0,66,165,'elemental2_clan',300,0,0,'LAST_HIT'),
	(21025,21025,'Giggling Wind',0,'',0,'Monster.sylph',11.00,35.00,28,'female','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,1178,62,102,143,49,106,278,0,333,0,0,0,66,165,'elemental2_clan',300,0,0,'LAST_HIT'),
	(21026,21026,'Singing Wind',0,'',0,'Monster.sylph',11.00,35.00,29,'female','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1268,68,111,149,53,110,278,500,333,0,0,0,66,165,'elemental2_clan',300,0,0,'LAST_HIT'),
	(21034,21034,'Ogre',0,'',0,'Monster.ogre',21.00,44.00,38,'male','L2Monster',40,1400,497,3.56,1.84,40,43,30,21,20,10,3594,224,440,141,112,153,200,500,333,98,0,0,24,191,'lizardman_clan1',300,0,0,'LAST_HIT'),
	(21035,21035,'Catherok',0,'',0,'Monster.marsh_stakato_soldier',10.00,25.00,42,'male','L2Monster',40,1660,589,17.38,2.14,40,43,30,21,20,10,2275,151,342,196,152,175,278,500,333,127,0,0,33,191,'beast_clan',300,0,0,'LAST_HIT'),
	(21036,21036,'Shindebarn',0,'',0,'Monster.magical_weaver',11.00,20.00,44,'male','L2Monster',40,1799,648,17.38,2.14,40,43,30,21,20,10,2869,196,390,209,176,187,278,500,333,0,0,0,99,191,'porta_clan',300,0,0,'LAST_HIT'),
	(21037,21037,'Ossiud',0,'',0,'Monster.field_stalker',15.00,30.00,47,'male','L2Monster',40,2016,738,17.38,2.14,40,43,30,21,20,10,3326,238,469,230,216,206,278,500,333,0,0,0,77,191,'torfe_clan',300,0,0,'LAST_HIT'),
	(21038,21038,'Liangma',0,'',0,'Monster.will_o_wisp',13.00,22.00,49,'male','L2Monster',40,2168,799,17.38,2.14,40,43,30,21,20,10,2926,216,529,245,247,219,278,500,333,0,0,0,88,191,'undead_clan',300,0,0,'LAST_HIT'),
	(21039,21039,'Snipe Cohort',0,'',0,'Monster.onyx_beast',14.00,14.50,43,'male','L2Monster',40,1728,618,17.38,2.14,40,43,30,21,20,10,3041,205,302,245,163,181,278,0,333,0,0,0,33,191,NULL,0,0,0,'LAST_HIT'),
	(21040,21040,'Soldier of Darkness',0,'',0,'Monster.death_knight',12.00,31.00,49,'male','L2Minion',40,2168,799,17.38,2.14,40,43,30,21,20,10,5077,375,581,223,247,219,278,0,333,127,0,0,29,191,NULL,0,1,0,'LAST_HIT'),
	(21058,21058,'Beast Lord',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,60,'male','L2Monster',40,3054,1150,20.54,2.45,40,43,30,21,20,10,7880,684,946,335,478,299,278,500,333,0,0,0,66,191,'beast_clan',400,0,0,'LAST_HIT'),
	(21059,21059,'Beast Guardian',0,'',0,'Monster.onyx_beast',14.00,14.50,59,'male','L2Minion',40,2971,1117,20.54,2.45,40,43,30,21,20,10,6289,537,902,326,453,291,278,0,333,0,0,0,33,191,'beast_clan',300,0,0,'LAST_HIT'),
	(21060,21060,'Beast Seer',0,'',0,'Monster.field_stalker',15.00,30.00,59,'male','L2Minion',40,2971,1117,20.54,2.45,40,43,30,21,20,10,6289,537,745,395,453,291,278,0,333,0,0,0,77,191,'beast_clan',300,0,0,'LAST_HIT'),
	(21061,21061,'Hallate''s Guardian',0,'',0,'Monster.kaim_vanul',24.00,40.00,69,'male','L2Monster',40,3784,1458,47.40,2.78,40,43,30,21,20,10,6396,625,1392,418,746,373,278,500,333,0,0,0,40,191,'hallate_clan',400,0,0,'LAST_HIT'),
	(21062,21062,'Messenger Angel',0,'',0,'Monster.angel',13.50,36.50,70,'male','L2Monster',40,3862,1493,47.40,2.78,40,43,30,21,20,10,0,0,1590,388,780,382,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21063,21063,'Messenger Angel',0,'',0,'Monster.angel',13.50,36.50,70,'male','L2Monster',40,3862,1493,47.40,2.78,40,43,30,21,20,10,13079,1297,1194,517,780,382,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21064,21064,'Platinum Guardian Archer',0,'',0,'Monster.kel_mahum_archer',13.00,27.00,71,'male','L2Monster',500,3938,1529,53.72,3.09,40,43,30,21,20,10,8009,803,3332,371,814,390,249,500,333,288,0,0,55,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21065,21065,'Platinum Guardian Warrior',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,72,'male','L2Monster',40,4013,1565,67.15,3.09,40,43,30,21,20,10,6036,613,1284,540,849,399,278,500,333,148,0,0,55,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21066,21066,'Platinum Guardian Shaman',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,73,'male','L2Monster',40,4086,1601,67.15,3.09,40,43,30,21,20,10,6529,672,1609,456,885,407,278,500,333,202,0,0,55,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21067,21067,'Guardian Archangel',0,'',0,'Monster.angel',13.50,36.50,74,'male','L2Monster',40,4158,1637,67.15,3.09,40,43,30,21,20,10,0,0,1831,423,921,416,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21068,21068,'Guardian Archangel',0,'',0,'Monster.angel',13.50,36.50,74,'male','L2Monster',40,4158,1637,67.15,3.09,40,43,30,21,20,10,14206,1481,1664,466,921,416,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21069,21069,'Platinum Guardian Prefect',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,74,'male','L2Monster',40,4158,1637,67.15,3.09,40,43,30,21,20,10,8909,928,1831,423,921,416,278,500,333,147,0,0,55,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21070,21070,'Seal Archangel',0,'',0,'Monster.angel',13.50,36.50,75,'male','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,0,0,1892,432,957,425,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21071,21071,'Seal Archangel',0,'',0,'Monster.angel',13.50,36.50,75,'male','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,14733,1554,1421,575,957,425,278,500,333,148,0,0,33,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21072,21072,'Platinum Guardian Chief',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,75,'male','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,6752,712,1720,475,957,425,278,500,333,202,0,0,55,191,'tower_guard_clan',400,0,10,'LAST_HIT'),
	(21073,21073,'Guardian Warrior of Elmoreden',0,'',0,'Monster.skeleton_knight',10.00,25.00,64,'male','L2Monster',40,3384,1285,23.70,2.78,40,43,30,21,20,10,7040,644,1135,371,589,331,278,0,333,84,0,0,44,191,'tower_ghost_clan',400,1,0,'LAST_HIT'),
	(21074,21074,'Bound Shaman',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,72,'male','L2Monster',40,4013,1565,26.86,3.09,40,43,30,21,20,10,9651,980,1284,540,849,399,278,0,333,202,0,0,55,191,'tower_guard_clan',400,0,0,'LAST_HIT'),
	(21075,21075,'Slaughter Bathin',0,'',0,'Monster.death_knight',12.00,31.00,63,'male','L2Monster',40,3302,1251,23.70,2.78,40,43,30,21,20,10,6995,631,1086,362,560,323,278,500,333,84,0,0,29,191,'hallate_clan',200,1,0,'LAST_HIT'),
	(21076,21076,'Bathin''s Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,62,'male','L2Minion',40,3219,1217,23.70,2.78,40,43,30,21,20,10,6881,613,1038,353,532,315,278,0,333,78,0,0,44,191,'hallate_clan',200,1,0,'LAST_HIT'),
	(21077,21077,'Bathin''s Wizard',0,'',0,'Monster.banshee',9.00,23.00,62,'female','L2Minion',40,3219,1217,23.70,2.78,40,43,30,21,20,10,6669,594,1038,353,532,315,278,0,333,3939,0,0,88,191,'hallate_clan',200,0,0,'LAST_HIT'),
	(21078,21078,'Magus Valac',0,'',0,'Monster.vale_master',12.00,40.00,70,'male','L2Monster',40,3862,1493,23.70,2.78,40,43,30,21,20,10,8481,841,1445,427,780,382,278,500,333,198,0,0,77,191,'hallate_clan',200,0,0,'LAST_HIT'),
	(21079,21079,'Valac''s Creature',0,'',0,'Monster.serpent_slave',17.00,46.00,69,'male','L2Minion',40,3784,1458,23.70,2.78,40,43,30,21,20,10,7707,754,1392,418,746,373,278,0,333,150,0,0,77,191,'hallate_clan',200,0,0,'LAST_HIT'),
	(21080,21080,'Valac''s Guardian Spirit',0,'',0,'Monster.shadow',10.00,30.00,69,'male','L2Minion',40,3784,1458,23.70,2.78,40,43,30,21,20,10,7123,697,1006,506,746,373,317,0,333,0,0,0,88,191,'hallate_clan',200,0,0,'LAST_HIT'),
	(21081,21081,'Power Angel Amon',0,'',0,'Monster.angel',13.50,36.50,75,'male','L2Monster',40,4229,1673,26.86,3.09,40,43,30,21,20,10,8887,937,1720,475,957,425,278,500,333,4700,0,0,33,191,'tower_guard_clan',200,0,0,'LAST_HIT'),
	(21082,21082,'Amon''s Captain of the Guards',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,74,'male','L2Minion',40,4158,1637,26.86,3.09,40,43,30,21,20,10,8546,891,1664,466,921,416,278,0,333,150,0,0,55,191,'tower_guard_clan',200,0,0,'LAST_HIT'),
	(21083,21083,'Amon''s Spirits',0,'',0,'Monster.pixy',5.00,25.00,74,'female','L2Minion',40,4158,1637,26.86,3.09,40,43,30,21,20,10,10096,1052,1664,466,921,416,278,0,333,0,0,0,88,191,'tower_guard_clan',200,0,0,'LAST_HIT'),
	(21084,21084,'Bloody Lady',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2Monster',40,3054,1150,30.81,2.45,40,43,30,21,20,10,4536,394,860,368,478,299,278,500,333,0,0,0,88,191,'cave_servant_clan',400,0,0,'LAST_HIT'),
	(21085,21085,'Bloody Sniper',0,'',0,'Monster.fiend_archer',17.00,55.00,71,'male','L2Monster',500,3938,1529,67.15,3.09,40,43,30,21,20,10,5574,559,3332,437,814,390,249,500,333,0,0,0,77,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21086,21086,'Bloody Liviona',0,'',0,'Monster.liviona',15.00,28.00,72,'male','L2Monster',40,4013,1565,67.15,3.09,40,43,30,21,20,10,5566,565,1413,491,849,399,278,500,333,0,0,0,88,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21087,21087,'Bloody Knight',0,'',0,'Monster.death_knight',12.00,31.00,73,'male','L2Monster',40,4086,1601,67.15,3.09,40,43,30,21,20,10,8932,919,1770,415,885,407,278,500,333,137,0,0,29,191,'bloody_clan',400,1,0,'LAST_HIT'),
	(21088,21088,'Bloody Banshee',0,'',0,'Monster.banshee',9.00,23.00,74,'female','L2Monster',40,4158,1637,67.15,3.09,40,43,30,21,20,10,5879,612,1513,512,921,416,278,500,333,3939,0,0,88,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21089,21089,'Bloody Lord',0,'',0,'Monster.karik',25.00,90.00,75,'male','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,6817,719,1720,475,957,425,278,500,333,0,0,0,40,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21090,21090,'Bloody Guardian',0,'',0,'Monster.death_blader',15.00,45.00,75,'male','L2Monster',40,4229,1673,40.29,3.09,40,43,30,21,20,10,8734,921,1720,475,957,425,278,500,333,1472,0,0,110,191,'bloody_clan',400,1,0,'LAST_HIT'),
	(21091,21091,'Bloody Keeper',0,'',0,'Monster.kaim_vanul',24.00,40.00,74,'male','L2Monster',40,4158,1637,26.86,3.09,40,43,30,21,20,10,8831,920,1513,512,921,416,278,0,333,0,0,0,40,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21092,21092,'Bloody Mystic',0,'',0,'Monster.banshee',9.00,23.00,74,'female','L2Monster',40,4158,1637,26.86,3.09,40,43,30,21,20,10,8627,899,1513,512,921,416,278,0,333,3939,0,0,88,191,'bloody_clan',400,0,0,'LAST_HIT'),
	(21093,21093,'Ratman Sub Chieftain',0,'',0,'Monster.wererat',14.00,25.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,691,31,58,70,21,73,278,400,333,216,0,0,88,165,'wererat_clan',300,0,0,'LAST_HIT'),
	(21094,21094,'Ratman Chieftain',0,'',0,'Monster.wererat',14.00,25.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,712,32,52,104,23,76,278,0,333,3,0,0,88,170,'wererat_clan',300,0,0,'LAST_HIT'),
	(21095,21095,'Giant Poison Bee',0,'',0,'Monster.giant_bee',8.00,24.50,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,840,39,55,83,25,80,317,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(21096,21096,'Cloudy Beast',0,'',0,'Monster.onyx_beast',14.00,14.50,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,837,40,68,87,28,83,278,400,333,0,0,0,33,154,'beast_clan',300,0,0,'LAST_HIT'),
	(21097,21097,'Young Araneid',0,'',0,'Monster.poison_spider',27.00,25.50,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,985,48,75,107,31,87,278,400,333,0,0,0,66,143,NULL,0,0,0,'LAST_HIT'),
	(21098,21098,'Plain Grizzly',0,'',0,'Monster.grizzly',21.00,40.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,935,46,81,111,34,90,278,0,333,0,0,0,44,126,NULL,0,0,0,'LAST_HIT'),
	(21099,21099,'Cloudy Beast Turen',0,'',0,'Monster.onyx_beast',14.00,14.50,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,1012,51,88,98,37,94,278,400,333,0,0,0,33,159,'beast_clan',300,0,0,'LAST_HIT'),
	(21100,21100,'Langk Lizardman Sentinel',0,'',0,'Monster.virud_lizardman',10.00,23.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,691,31,53,90,21,73,278,500,333,2,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21101,21101,'Langk Lizardman Shaman',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,935,46,81,94,34,90,278,0,333,6,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21102,21102,'Watchman of the Plains',0,'',0,'Monster.magical_weaver',11.00,20.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1335,73,132,119,58,114,278,500,333,0,0,0,99,176,'monster_eye_clan',300,0,0,'LAST_HIT'),
	(21103,21103,'Roughly Hewn Rock Golem',0,'',0,'Monster.stone_golem_bi',20.00,40.30,31,'male','L2Monster',40,1004,381,7.11,1.84,40,43,30,21,20,10,1397,78,142,146,64,118,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(21104,21104,'Delu Lizardman Supplier',0,'',0,'Monster.virud_lizardman',10.00,23.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,1754,99,134,151,69,123,317,0,333,223,0,0,47,148,NULL,0,0,0,'LAST_HIT'),
	(21105,21105,'Delu Lizardman Special Agent',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,33,'male','L2Monster',500,1109,413,7.11,1.84,40,43,30,21,20,10,2022,116,406,143,75,128,249,0,333,2507,0,0,47,148,NULL,0,0,0,'LAST_HIT'),
	(21106,21106,'Cursed Seer',0,'',0,'Monster.magical_weaver',11.00,20.00,34,'male','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,1714,100,178,138,82,132,278,500,333,0,0,0,99,176,'monster_eye_clan',300,0,0,'LAST_HIT'),
	(21107,21107,'Delu Lizardman Commander',0,'',0,'Monster.virud_lizardman_warrior',12.00,30.00,35,'male','L2Monster',40,1220,446,14.22,1.84,40,43,30,21,20,10,1814,107,192,169,89,137,278,0,333,93,0,0,57,148,NULL,0,0,0,'LAST_HIT'),
	(21108,21108,'Glow Wisp',0,'',0,'Monster.will_o_wisp',13.00,22.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6528,622,1169,439,681,356,278,0,333,0,0,0,88,176,NULL,0,0,0,'LAST_HIT'),
	(21109,21109,'Hames Orc Scout',0,'',0,'Monster.ketra_orc',12.00,29.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8082,781,1065,382,713,365,317,0,333,229,0,0,49,203,'orc_clan',400,0,0,'LAST_HIT'),
	(21110,21110,'Marsh Predator',0,'',0,'Monster.devastator',35.00,35.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,6890,674,1265,460,746,373,278,0,333,0,0,0,27,192,NULL,0,0,0,'LAST_HIT'),
	(21111,21111,'Lava Wyrm',0,'',0,'Monster.wyrm',29.00,72.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,7197,714,1314,470,780,382,278,500,333,0,0,0,77,192,NULL,0,0,0,'LAST_HIT'),
	(21112,21112,'Hames Orc Footman',0,'',0,'Monster.ketra_orc',12.00,29.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,8724,875,1363,481,814,390,278,0,333,233,110,0,49,198,'orc_clan',300,0,0,'LAST_HIT'),
	(21113,21113,'Hames Orc Sniper',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,72,'male','L2Monster',500,4013,1565,13.43,3.09,40,43,30,21,20,10,9722,988,3140,417,849,399,249,0,333,287,0,0,49,176,'orc_clan',300,0,0,'LAST_HIT'),
	(21114,21114,'Cursed Guardian',0,'',0,'Monster.death_blader',15.00,45.00,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,9231,950,1463,426,885,407,278,0,333,1472,0,0,110,192,NULL,0,1,0,'LAST_HIT'),
	(21115,21115,'Hames Orc Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,74,'male','L2Monster',40,4158,1637,13.43,3.09,40,43,30,21,20,10,8043,838,1513,435,921,416,278,0,333,186,0,0,11,159,'orc_clan',400,0,0,'LAST_HIT'),
	(21116,21116,'Hames Orc Overlord',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,75,'male','L2Monster',40,4229,1673,13.43,3.09,40,43,30,21,20,10,12699,1340,1720,475,957,425,278,500,333,75,103,0,39,192,'orc_clan',500,0,0,'LAST_HIT'),
	(21117,21117,'Kasha Imp',0,'',0,'Monster.imp_bi',10.00,30.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,678,30,53,77,21,73,278,0,333,0,0,0,66,93,NULL,0,0,0,'LAST_HIT'),
	(21118,21118,'Baar Dre Vanul',0,'',0,'Monster.dre_vanul',14.00,36.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,726,32,57,94,23,76,278,400,333,0,0,0,88,93,'demonic_clan',300,0,0,'LAST_HIT'),
	(21119,21119,'Hobgoblin',0,'',0,'Monster.hobgoblin',12.00,24.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,63,98,25,80,278,0,333,4,0,0,49,121,'goblin_clan',300,0,0,'LAST_HIT'),
	(21120,21120,'Kasha Imp Turen',0,'',0,'Monster.imp_bi',10.00,30.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,996,47,75,79,28,83,278,400,333,0,0,0,66,93,NULL,0,0,0,'LAST_HIT'),
	(21121,21121,'Kasha Dire Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,895,43,75,91,31,87,278,400,333,0,0,0,26,148,NULL,0,0,0,'LAST_HIT'),
	(21122,21122,'Kasha Bugbear',0,'',0,'Monster.bugbear',17.00,35.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,954,47,81,111,34,90,278,400,333,169,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(21123,21123,'Baar Dre Vanul Destroyer',0,'',0,'Monster.dre_vanul',14.00,36.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,1267,63,97,105,37,94,278,400,333,0,0,0,88,93,'demonic_clan',300,0,0,'LAST_HIT'),
	(21124,21124,'Red Eye Barbed Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,640,28,48,73,19,70,278,0,333,0,0,0,66,99,NULL,0,0,0,'LAST_HIT'),
	(21125,21125,'Northern Trimden',0,'',0,'Monster.poison_spider',27.00,25.50,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,684,31,53,90,21,73,278,400,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(21126,21126,'Kerope Werewolf',0,'',0,'Monster.werewolf_bi',11.00,29.70,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,712,32,57,80,23,76,278,0,333,0,0,0,55,137,'werewolf_clan',300,0,0,'LAST_HIT'),
	(21127,21127,'Northern Goblin',0,'',0,'Monster2.northern_goblin',4.00,15.00,21,'male','L2Monster',40,575,227,5.53,1.53,40,43,30,21,20,10,764,35,63,98,25,80,278,0,333,152,0,0,33,132,'goblin_clan',300,0,0,'LAST_HIT'),
	(21128,21128,'Spine Golem',0,'',0,'Monster.stone_golem_bi',20.00,40.30,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,821,39,68,102,28,83,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(21129,21129,'Kerope Werewolf Chief',0,'',0,'Monster.werewolf_bi',11.00,29.70,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,895,43,82,82,31,87,278,400,333,0,0,0,55,154,'werewolf_clan',300,0,0,'LAST_HIT'),
	(21130,21130,'Northern Goblin Leader',0,'',0,'Monster2.northern_goblin',4.00,15.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,954,47,81,111,34,90,278,400,333,66,102,0,33,137,'goblin_clan',300,0,0,'LAST_HIT'),
	(21131,21131,'Enchanted Spine Golem',0,'',0,'Monster.stone_golem_bi',20.00,40.30,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,992,50,97,105,37,94,278,0,333,0,0,0,25,31,NULL,0,0,0,'LAST_HIT'),
	(21132,21132,'Underground Kobold',0,'',0,'Monster.kobold',10.00,15.00,24,'male','L2Monster',40,687,272,5.53,1.53,40,43,30,21,20,10,779,38,81,94,34,90,278,0,333,0,0,0,51,121,'kobold_clan',300,0,0,'LAST_HIT'),
	(21133,21133,'Dead Pit Skeleton Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,25,'male','L2Monster',500,728,287,5.53,1.53,40,43,30,21,20,10,851,43,197,98,37,94,249,0,333,274,0,0,44,143,'undead_clan',300,1,0,'LAST_HIT'),
	(21134,21134,'Dead Pit Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,898,45,96,102,41,98,278,400,333,219,0,0,66,159,'undead_clan',300,1,0,'LAST_HIT'),
	(21135,21135,'Underground Kobold Warrior',0,'',0,'Monster.kobold',10.00,15.00,27,'male','L2Monster',40,813,318,5.53,1.53,40,43,30,21,20,10,1103,56,114,114,45,102,278,0,333,0,0,0,51,126,'kobold_clan',300,0,0,'LAST_HIT'),
	(21136,21136,'Dead Pit Horror',0,'',0,'Monster.dark_horror',20.00,35.00,28,'male','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,981,52,113,110,49,106,278,0,333,0,0,0,110,110,'undead_clan',300,1,0,'LAST_HIT'),
	(21137,21137,'Iron Ore Golem',0,'',0,'Monster.iron_golem',18.00,34.00,29,'male','L2Monster',40,906,349,5.53,1.53,40,43,30,21,20,10,1057,57,111,149,53,110,278,400,333,0,0,0,22,23,NULL,0,0,0,'LAST_HIT'),
	(21138,21138,'Greedy Geist',0,'',0,'Monster.hungry_spirit',30.00,40.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,1134,62,132,119,58,114,278,0,333,0,0,0,16,165,'undead_clan',300,1,0,'LAST_HIT'),
	(21139,21139,'Catacomb Barbed Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,23,'male','L2Monster',40,648,257,22.12,1.53,40,43,30,21,20,10,655,31,75,91,31,87,278,500,333,0,0,0,66,143,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21140,21140,'Catacomb Wisp',0,'',0,'Monster.will_o_wisp',13.00,22.00,26,'male','L2Monster',40,770,303,22.12,1.53,40,43,30,21,20,10,788,39,96,102,41,98,278,500,333,0,0,0,88,132,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21141,21141,'Catacomb Serpent',0,'',0,'Monster.serpent_slave',17.00,46.00,28,'male','L2Monster',40,859,334,22.12,1.53,40,43,30,21,20,10,926,48,113,110,49,106,278,500,333,73,0,0,77,143,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21142,21142,'Grave Keeper Spartoi',0,'',0,'Monster.spartoi',11.00,27.00,29,'male','L2Monster',40,906,349,22.12,1.53,40,43,30,21,20,10,927,49,111,149,53,110,278,500,333,221,0,0,66,154,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21143,21143,'Catacomb Scavenger Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,31,'male','L2Monster',40,1004,381,28.44,1.84,40,43,30,21,20,10,1042,57,142,124,64,118,278,500,333,0,0,0,66,154,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21144,21144,'Catacomb Shadow',0,'',0,'Monster.shadow',10.00,30.00,34,'male','L2Monster',40,1164,430,28.44,1.84,40,43,30,21,20,10,1254,73,178,138,82,132,278,500,333,0,0,0,88,143,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21145,21145,'Catacomb Stakato Soldier',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,38,'male','L2Monster',40,1400,497,28.44,1.84,40,43,30,21,20,10,1611,100,238,160,112,153,278,500,333,232,0,0,27,165,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21146,21146,'Grave Keeper Dark Horror',0,'',0,'Monster.dark_horror',20.00,35.00,40,'male','L2Monster',40,1527,531,28.44,1.84,40,43,30,21,20,10,1735,112,248,222,131,164,278,500,333,0,0,0,110,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21147,21147,'Catacomb Gargoyle',0,'',0,'Monster.gargoyle',16.00,50.00,43,'male','L2Monster',40,1728,618,34.76,2.14,40,43,30,21,20,10,2114,143,332,223,163,181,278,500,333,0,0,0,154,187,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21148,21148,'Catacomb Liviona',0,'',0,'Monster.liviona',15.00,28.00,44,'male','L2Monster',40,1799,648,34.76,2.14,40,43,30,21,20,10,2100,143,354,196,176,187,278,500,333,0,0,0,88,154,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21149,21149,'Decayed Ancient Pikeman',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,46,'male','L2Monster',40,1943,707,34.76,2.14,40,43,30,21,20,10,2419,171,401,245,202,199,278,500,333,96,0,0,55,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21150,21150,'Decayed Ancient Soldier',0,'',0,'Monster.skeleton_knight',10.00,25.00,49,'male','L2Monster',40,2168,799,34.76,2.14,40,43,30,21,20,10,2745,203,480,270,247,219,278,500,333,125,0,0,44,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21151,21151,'Decayed Ancient Knight',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,50,'male','L2Monster',40,2245,830,34.76,2.14,40,43,30,21,20,10,2858,215,509,278,264,226,278,500,333,227,0,0,88,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21152,21152,'Purgatory Wisp',0,'',0,'Monster.will_o_wisp',13.00,22.00,53,'male','L2Monster',40,2481,923,41.08,2.45,40,43,30,21,20,10,3047,239,602,258,319,247,278,500,333,0,0,0,88,165,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21153,21153,'Purgatory Serpent',0,'',0,'Monster.serpent_slave',17.00,46.00,56,'male','L2Monster',40,2724,1019,41.08,2.45,40,43,30,21,20,10,3586,294,706,281,382,269,278,500,333,73,0,0,77,192,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21154,21154,'Hell Keeper Medusa',0,'',0,'Monster.medusa',10.00,25.00,58,'female','L2Monster',40,2889,1084,41.08,2.45,40,43,30,21,20,10,3753,317,710,384,428,284,278,500,333,0,0,0,55,181,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21155,21155,'Purgatory Conjurer',0,'',0,'Monster.vampire_bat',10.00,33.50,59,'male','L2Monster',40,2971,1117,41.08,2.45,40,43,30,21,20,10,3776,322,820,305,453,291,278,500,333,0,0,0,66,192,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21156,21156,'Purgatory Shadow',0,'',0,'Monster.shadow',10.00,30.00,61,'male','L2Monster',40,3137,1184,47.40,2.78,40,43,30,21,20,10,4036,355,901,321,505,307,278,500,333,0,0,0,88,170,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21157,21157,'Purgatory Tarantula',0,'',0,'Monster.poison_spider',27.00,25.50,64,'male','L2Monster',40,3384,1285,47.40,2.78,40,43,30,21,20,10,4569,418,1031,347,589,331,278,500,333,0,0,0,66,192,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21158,21158,'Hell Keeper Crimson Doll',0,'',0,'Monster.crimson_doll',15.00,38.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,5133,488,1063,483,681,356,278,500,333,0,0,0,66,198,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21159,21159,'Purgatory Gargoyle',0,'',0,'Monster.gargoyle',16.00,50.00,68,'male','L2Monster',40,3706,1423,47.40,2.78,40,43,30,21,20,10,5287,510,1217,449,713,365,278,500,333,0,0,0,154,192,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21160,21160,'Purgatory Liviona',0,'',0,'Monster.liviona',15.00,28.00,71,'male','L2Monster',40,3938,1529,53.72,3.09,40,43,30,21,20,10,5468,548,1363,408,814,390,278,500,333,0,0,0,88,176,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21161,21161,'Lesser Ancient Soldier',0,'',0,'Monster.medusa',10.00,25.00,73,'female','L2Monster',40,4086,1601,53.72,3.09,40,43,30,21,20,10,5945,611,1463,502,885,407,278,500,333,0,0,0,55,198,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21162,21162,'Lesser Ancient Scout',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,74,'male','L2Monster',40,4158,1637,53.72,3.09,40,43,30,21,20,10,5940,619,1513,512,921,416,278,500,333,135,0,0,27,176,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21163,21163,'Lesser Ancient Shaman',0,'',0,'Monster.silhouette',8.00,23.00,76,'female','L2Monster',40,4297,1710,53.72,3.09,40,43,30,21,20,10,6265,669,1614,454,994,433,278,500,333,0,0,0,88,220,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21164,21164,'Guardian Spirit of Ancient Holy Ground',0,'',0,'Monster.death_lord',21.00,40.00,79,'male','L2Monster',40,4490,1821,53.72,3.09,40,43,30,21,20,10,7136,791,1765,566,1107,459,278,500,333,78,0,0,44,209,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21165,21165,'Lesser Ancient Warrior',0,'',0,'Monster.shadeless',7.00,28.00,80,'male','L2Monster',40,4550,1859,53.72,3.09,40,43,30,21,20,10,7761,871,2195,476,1144,468,278,500,333,0,0,0,52,220,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21166,21166,'Lith Scout',0,'',0,'Monster2.temple_guard_a_20_sm',12.00,33.60,21,'male','L2Monster',40,575,227,22.12,1.53,40,43,30,21,20,10,594,27,66,69,25,80,317,0,333,5795,0,0,58,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21167,21167,'Lith Witch',0,'',0,'Monster2.temple_savant_a_20_sm',8.00,32.00,24,'male','L2Monster',40,687,272,22.12,1.53,40,43,30,21,20,10,690,34,98,92,34,90,278,0,333,5797,0,0,27,121,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21168,21168,'Lith Warrior',0,'',0,'Monster2.temple_guard_b_20_sm',12.00,33.60,27,'male','L2Monster',40,813,318,22.12,1.53,40,43,30,21,20,10,855,43,126,103,45,102,278,0,333,5796,0,0,58,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21169,21169,'Lith Guard',0,'',0,'Monster2.temple_guard_a',15.00,42.00,30,'male','L2Monster',40,954,365,22.12,1.53,40,43,30,21,20,10,1133,62,140,99,58,114,317,0,333,5795,0,0,58,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21170,21170,'Lith Medium',0,'',0,'Monster2.temple_savant_a',10.00,40.00,33,'male','L2Monster',40,1109,413,28.44,1.84,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,333,5797,0,0,27,132,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21171,21171,'Lith Overlord',0,'',0,'Monster2.temple_guard_b',15.00,42.00,36,'male','L2Monster',40,1279,463,28.44,1.84,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,333,5796,0,0,58,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21172,21172,'Lith Patrolman',0,'',0,'Monster2.temple_guard_a',15.00,42.00,39,'male','L2Monster',40,1462,514,28.44,1.84,40,43,30,21,20,10,1972,125,270,137,121,158,317,0,333,5795,0,0,58,165,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21173,21173,'Lith Shaman',0,'',0,'Monster2.temple_savant_a',10.00,40.00,42,'male','L2Monster',40,1660,589,34.76,2.14,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,333,5798,0,0,27,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21174,21174,'Lith Commander',0,'',0,'Monster2.temple_guard_b',15.00,42.00,45,'male','L2Monster',40,1870,677,34.76,2.14,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,333,5796,0,0,58,165,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21175,21175,'Lilim Butcher',0,'',0,'Monster2.lilim_assassin_10_sm',11.00,36.00,48,'male','L2Monster',40,2091,768,34.76,2.14,40,43,30,21,20,10,3093,226,480,183,231,212,317,0,333,232,232,0,39,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21176,21176,'Lilim Magus',0,'',0,'Monster2.lilim_wizard_10_sm',8.00,30.60,51,'female','L2Monster',40,2323,861,41.08,2.45,40,43,30,21,20,10,3123,238,652,237,281,232,278,0,333,0,0,0,55,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21177,21177,'Lilim Knight Errant',0,'',0,'Monster2.lilim_knight_10_sm',11.00,45.00,54,'male','L2Monster',40,2562,955,41.08,2.45,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,333,5800,5799,0,61,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21178,21178,'Lilim Marauder',0,'',0,'Monster2.lilim_assassin_10_sm',11.00,36.00,57,'male','L2Monster',40,2806,1052,41.08,2.45,40,43,30,21,20,10,4697,390,786,239,405,276,317,0,333,229,229,0,39,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21179,21179,'Lilim Priest',0,'',0,'Monster2.lilim_wizard_10_sm',8.00,30.60,60,'female','L2Monster',40,3054,1150,41.08,2.45,40,43,30,21,20,10,4322,375,1041,304,478,299,278,0,333,0,0,0,55,176,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21180,21180,'Lilim Knight',0,'',0,'Monster2.lilim_knight_10_sm',11.00,45.00,63,'male','L2Monster',40,3302,1251,47.40,2.78,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,333,5800,5799,0,61,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21181,21181,'Lilim Assassin',0,'',0,'Monster2.lilim_assassin_10_bi',13.00,44.00,66,'male','L2Monster',40,3546,1353,47.40,2.78,40,43,30,21,20,10,6868,646,1189,301,649,348,317,0,333,234,234,0,39,209,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21182,21182,'Lilim Soldier',0,'',0,'Monster2.lilim_wizard_10_bi',10.00,37.50,69,'female','L2Monster',40,3784,1458,47.40,2.78,40,43,30,21,20,10,5717,559,1531,380,746,373,278,0,333,0,0,0,55,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21183,21183,'Lilim Knight Banneret',0,'',0,'Monster2.lilim_knight_10_bi',13.00,55.00,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,333,5800,5799,0,61,209,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21184,21184,'Lilim Slayer',0,'',0,'Monster2.lilim_assassin_10_bi',13.00,44.00,75,'male','L2Monster',40,4229,1673,53.72,3.09,40,43,30,21,20,10,8869,935,1655,367,957,425,317,0,333,236,236,0,39,220,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21185,21185,'Lilim Great Mystic',0,'',0,'Monster2.lilim_wizard_10_bi',10.00,37.50,78,'female','L2Monster',40,4428,1784,53.72,3.09,40,43,30,21,20,10,7305,799,2075,459,1069,451,278,0,333,0,0,0,55,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21186,21186,'Lilim Court Knight',0,'',0,'Monster2.lilim_knight_10_bi',13.00,55.00,80,'male','L2Monster',40,4550,1859,53.72,3.09,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,333,5800,5799,0,61,220,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21187,21187,'Gigant Slave',0,'',0,'Monster2.tomb_guard_a_20_sm',8.00,32.00,21,'male','L2Monster',40,575,227,22.12,1.53,40,43,30,21,20,10,594,27,76,69,25,80,278,0,333,5791,0,0,53,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21188,21188,'Gigant Acolyte',0,'',0,'Monster2.tomb_savant_a_20_sm',8.00,32.00,24,'male','L2Monster',40,687,272,22.12,1.53,40,43,30,21,20,10,690,34,98,92,34,90,278,0,333,5793,0,0,53,121,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21189,21189,'Gigant Overseer',0,'',0,'Monster2.tomb_guard_b_20_sm',12.00,34.00,27,'male','L2Monster',40,813,318,22.12,1.53,40,43,30,21,20,10,855,43,126,103,45,102,278,0,333,5792,0,0,53,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21190,21190,'Gigant Footman',0,'',0,'Monster2.tomb_guard_a',10.00,40.00,30,'male','L2Monster',40,954,365,22.12,1.53,40,43,30,21,20,10,1133,62,160,99,58,114,278,0,333,5791,0,0,53,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21191,21191,'Gigant Cleric',0,'',0,'Monster2.tomb_savant_a',10.00,40.00,33,'male','L2Monster',40,1109,413,28.44,1.84,40,43,30,21,20,10,1307,75,201,130,75,128,278,0,333,5793,0,0,53,132,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21192,21192,'Gigant Officer',0,'',0,'Monster2.tomb_guard_b',15.00,42.50,36,'male','L2Monster',40,1279,463,28.44,1.84,40,43,30,21,20,10,1669,101,250,145,96,142,278,0,333,5792,0,0,53,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21193,21193,'Gigant Raider',0,'',0,'Monster2.tomb_guard_a',10.00,40.00,39,'male','L2Monster',40,1462,514,28.44,1.84,40,43,30,21,20,10,1972,125,308,137,121,158,278,0,333,5791,0,0,53,165,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21194,21194,'Gigant Confessor',0,'',0,'Monster2.tomb_savant_a',10.00,40.00,42,'male','L2Monster',40,1660,589,34.76,2.14,40,43,30,21,20,10,2118,141,377,178,152,175,278,0,333,5794,0,0,53,143,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21195,21195,'Gigant Commander',0,'',0,'Monster2.tomb_guard_b',15.00,42.50,45,'male','L2Monster',40,1870,677,34.76,2.14,40,43,30,21,20,10,2731,190,457,196,188,193,278,0,333,5792,0,0,53,165,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21196,21196,'Nephilim Sentinel',0,'',0,'Monster2.nephilim_slayer_10_sm',11.00,32.40,48,'male','L2Monster',40,2091,768,34.76,2.14,40,43,30,21,20,10,3093,226,548,183,231,212,278,0,333,0,0,0,71,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21197,21197,'Nephilim Priest',0,'',0,'Monster2.nephilim_priest_10_sm',21.00,36.50,51,'male','L2Monster',40,2323,861,41.08,2.45,40,43,30,21,20,10,3391,258,652,237,281,232,278,0,333,0,0,0,55,154,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21198,21198,'Nephilim Swordsman',0,'',0,'Monster2.nephilim_lord_10_sm',9.00,37.40,54,'male','L2Monster',40,2562,955,41.08,2.45,40,43,30,21,20,10,4385,349,769,258,339,254,278,0,333,0,0,0,71,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21199,21199,'Nephilim Guard',0,'',0,'Monster2.nephilim_slayer_10_sm',11.00,32.40,57,'male','L2Monster',40,2806,1052,41.08,2.45,40,43,30,21,20,10,4697,390,899,239,405,276,278,0,333,0,0,0,71,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21200,21200,'Nephilim Bishop',0,'',0,'Monster2.nephilim_priest_10_sm',21.00,36.50,60,'male','L2Monster',40,3054,1150,41.08,2.45,40,43,30,21,20,10,4694,407,1041,304,478,299,278,0,333,0,0,0,55,176,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21201,21201,'Nephilim Centurion',0,'',0,'Monster2.nephilim_lord_10_sm',9.00,37.40,63,'male','L2Monster',40,3302,1251,47.40,2.78,40,43,30,21,20,10,6489,586,1194,329,560,323,278,0,333,0,0,0,71,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21202,21202,'Nephilim Scout',0,'',0,'Monster2.nephilim_slayer_10_bi',13.00,39.60,66,'male','L2Monster',40,3546,1353,47.40,2.78,40,43,30,21,20,10,6868,646,1358,301,649,348,278,0,333,0,0,0,71,209,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21203,21203,'Nephilim Archbishop',0,'',0,'Monster2.nephilim_priest_10_bi',21.00,44.00,69,'male','L2Monster',40,3784,1458,47.40,2.78,40,43,30,21,20,10,6208,607,1531,380,746,373,278,0,333,0,0,0,55,187,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21204,21204,'Nephilim Praetorian',0,'',0,'Monster2.nephilim_lord_10_bi',11.00,45.30,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,8475,861,1710,406,849,399,278,0,333,0,0,0,71,209,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21205,21205,'Nephilim Royal Guard',0,'',0,'Monster2.nephilim_slayer_10_bi',13.00,39.60,75,'male','L2Monster',40,4229,1673,53.72,3.09,40,43,30,21,20,10,8869,935,1892,367,957,425,278,0,333,0,0,0,71,220,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21206,21206,'Nephilim Cardinal',0,'',0,'Monster2.nephilim_priest_10_bi',21.00,44.00,78,'male','L2Monster',40,4428,1784,53.72,3.09,40,43,30,21,20,10,7933,868,2075,459,1069,451,278,0,333,0,0,0,55,198,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21207,21207,'Nephilim Commander',0,'',0,'Monster2.nephilim_lord_10_bi',11.00,45.30,80,'male','L2Monster',40,4550,1859,53.72,3.09,40,43,30,21,20,10,10464,1174,2195,476,1144,468,278,0,333,0,0,0,71,220,'c_dungeon_clan',400,0,0,'LAST_HIT'),
	(21208,21208,'Hallowed Watchman',0,'',0,'Monster.skeleton',11.00,25.00,20,'male','L2Monster',40,541,213,15.80,1.21,40,43,30,21,20,10,521,23,57,94,23,76,278,0,333,216,111,0,66,143,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21209,21209,'Hallowed Seer',0,'',0,'Monster.binding',12.00,21.00,22,'male','L2Monster',40,611,242,22.12,1.53,40,43,30,21,20,10,612,29,68,87,28,83,278,500,333,0,0,0,11,121,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21210,21210,'Vault Guardian',0,'',0,'Monster.imp',10.00,24.00,25,'male','L2Monster',40,728,287,22.12,1.53,40,43,30,21,20,10,780,39,88,116,37,94,278,500,333,0,0,0,66,143,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21211,21211,'Vault Seer',0,'',0,'Monster.succubus',10.00,36.00,27,'female','L2Monster',40,813,318,22.12,1.53,40,43,30,21,20,10,830,42,104,106,45,102,278,500,333,0,0,0,66,121,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21212,21212,'Hallowed Sentinel',0,'',0,'Monster.skeleton_bi',11.00,31.00,30,'male','L2Monster',40,954,365,22.12,1.53,40,43,30,21,20,10,957,52,132,140,58,114,278,0,333,69,646,0,66,154,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21213,21213,'Hallowed Monk',0,'',0,'Monster.binding_20_bi',14.00,25.30,32,'male','L2Monster',40,1056,397,28.44,1.84,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,333,0,0,0,11,121,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21214,21214,'Vault Sentinel',0,'',0,'Monster.imp_bi',10.00,30.00,35,'male','L2Monster',40,1220,446,28.44,1.84,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,333,0,0,0,66,154,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21215,21215,'Vault Monk',0,'',0,'Monster.succubus_bi',10.00,43.20,37,'female','L2Monster',40,1338,480,28.44,1.84,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,333,0,0,0,66,132,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21216,21216,'Overlord of the Holy Lands',0,'',0,'Monster.skeleton_knight_20_bi',12.00,30.50,40,'male','L2Monster',40,1527,531,28.44,1.84,40,43,30,21,20,10,1701,110,300,183,131,164,278,0,333,129,646,0,44,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21217,21217,'Hallowed Priest',0,'',0,'Monster.banshee_20_bi',10.00,27.50,42,'female','L2Monster',40,1660,589,34.76,2.14,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,333,0,0,0,88,148,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21218,21218,'Vault Overlord',0,'',0,'Monster.death_blader_10_sm',14.00,40.50,45,'male','L2Monster',40,1870,677,34.76,2.14,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,333,297,0,0,110,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21219,21219,'Vault Priest',0,'',0,'Monster.bloody_queen_10_sm',13.00,38.00,47,'female','L2Monster',40,2016,738,34.76,2.14,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,333,0,0,0,88,148,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21220,21220,'Sepulcher Archon',0,'',0,'Monster.skeleton_knight_30_bi',13.00,33.00,50,'male','L2Monster',40,2245,830,34.76,2.14,40,43,30,21,20,10,2658,200,560,253,264,226,278,0,333,131,107,0,44,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21221,21221,'Sepulcher Inquisitor',0,'',0,'Monster.banshee_30_bi',11.00,30.00,52,'female','L2Monster',40,2402,892,41.08,2.45,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,333,0,0,0,88,159,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21222,21222,'Sepulcher Archon',0,'',0,'Monster.death_blader_10_bi',16.00,49.50,55,'male','L2Monster',40,2643,987,41.08,2.45,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,333,298,0,0,110,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21223,21223,'Sepulcher Inquisitor',0,'',0,'Monster.bloody_queen_10_bi',15.00,46.00,57,'female','L2Monster',40,2806,1052,41.08,2.45,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,333,0,0,0,88,159,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21224,21224,'Sepulcher Guardian',0,'',0,'Monster.skeleton_royal_guard_20_bi',13.00,34.50,60,'male','L2Monster',40,3054,1150,41.08,2.45,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,333,233,0,0,88,209,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21225,21225,'Sepulcher Sage',0,'',0,'Monster.vale_master_10_bi',13.00,44.00,62,'male','L2Monster',40,3219,1217,47.40,2.78,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,333,311,0,0,77,176,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21226,21226,'Sepulcher Guardian',0,'',0,'Monster.death_knight',12.00,31.00,65,'male','L2Monster',40,3465,1319,47.40,2.78,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,333,0,0,0,29,209,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21227,21227,'Sepulcher Sage',0,'',0,'Monster.doll_master',20.00,42.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,333,0,0,0,88,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21228,21228,'Sepulcher Guard ',0,'',0,'Monster.skeleton_royal_guard_30_bi',14.00,37.50,70,'male','L2Monster',40,3862,1493,47.40,2.78,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,333,236,0,0,88,220,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21229,21229,'Sepulcher Preacher',0,'',0,'Monster.vale_master_30_bi',15.00,52.00,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,333,326,0,0,77,181,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21230,21230,'Sepulcher Guard',0,'',0,'Monster.death_knight',12.00,31.00,75,'male','L2Monster',40,4229,1673,53.72,3.09,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,333,0,0,0,29,220,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21231,21231,'Sepulcher Preacher',0,'',0,'Monster.doll_master_20_bi',24.00,50.40,77,'male','L2Monster',40,4364,1747,53.72,3.09,40,43,30,21,20,10,6431,696,1664,463,1031,442,278,500,333,0,0,0,88,181,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21232,21232,'Barrow Guardian',0,'',0,'Monster.skeleton',11.00,25.00,20,'male','L2Monster',40,541,213,15.80,1.21,40,43,30,21,20,10,521,23,57,94,23,76,278,0,333,216,0,0,66,143,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21233,21233,'Barrow Seer',0,'',0,'Monster.binding',12.00,21.00,22,'male','L2Monster',40,611,242,22.12,1.53,40,43,30,21,20,10,612,29,68,87,28,83,278,500,333,0,0,0,11,121,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21234,21234,'Grave Guardian',0,'',0,'Monster.imp',10.00,24.00,25,'male','L2Monster',40,728,287,22.12,1.53,40,43,30,21,20,10,780,39,88,116,37,94,278,500,333,0,0,0,66,143,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21235,21235,'Grave Seer',0,'',0,'Monster.succubus',10.00,36.00,27,'female','L2Monster',40,813,318,22.12,1.53,40,43,30,21,20,10,830,42,104,106,45,102,278,500,333,0,0,0,66,121,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21236,21236,'Barrow Sentinel',0,'',0,'Monster.skeleton_bi',11.00,31.00,30,'male','L2Monster',40,954,365,22.12,1.53,40,43,30,21,20,10,957,52,132,140,58,114,278,0,333,69,0,0,66,154,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21237,21237,'Barrow Monk',0,'',0,'Monster.binding_20_bi',14.00,25.30,32,'male','L2Monster',40,1056,397,28.44,1.84,40,43,30,21,20,10,1110,62,154,129,69,123,278,500,333,0,0,0,11,121,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21238,21238,'Grave Sentinel',0,'',0,'Monster.imp_bi',10.00,30.00,35,'male','L2Monster',40,1220,446,28.44,1.84,40,43,30,21,20,10,1400,83,192,169,89,137,278,500,333,0,0,0,66,154,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21239,21239,'Grave Monk',0,'',0,'Monster.succubus_bi',10.00,43.20,37,'female','L2Monster',40,1338,480,28.44,1.84,40,43,30,21,20,10,1485,91,222,154,104,147,278,500,333,0,0,0,66,132,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21240,21240,'Barrow Overlord',0,'',0,'Monster.skeleton_knight_20_bi',12.00,30.50,40,'male','L2Monster',40,1527,531,28.44,1.84,40,43,30,21,20,10,1701,110,300,183,131,164,278,0,333,129,0,0,44,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21241,21241,'Barrow Priest',0,'',0,'Monster.banshee_20_bi',10.00,27.50,42,'female','L2Monster',40,1660,589,34.76,2.14,40,43,30,21,20,10,1913,127,311,183,152,175,278,500,333,0,0,0,88,148,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21242,21242,'Grave Overlord',0,'',0,'Monster.death_blader_10_sm',14.00,40.50,45,'male','L2Monster',40,1870,677,34.76,2.14,40,43,30,21,20,10,2315,161,415,216,188,193,278,500,333,297,0,0,110,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21243,21243,'Grave Priest',0,'',0,'Monster.bloody_queen_10_sm',13.00,38.00,47,'female','L2Monster',40,2016,738,34.76,2.14,40,43,30,21,20,10,2396,171,427,215,216,206,278,500,333,0,0,0,88,148,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21244,21244,'Crypt Archon',0,'',0,'Monster.skeleton_knight_30_bi',13.00,33.00,50,'male','L2Monster',40,2245,830,34.76,2.14,40,43,30,21,20,10,2658,200,560,253,264,226,278,0,333,131,0,0,44,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21245,21245,'Crypt Inquisitor',0,'',0,'Monster.banshee_30_bi',11.00,30.00,52,'female','L2Monster',40,2402,892,41.08,2.45,40,43,30,21,20,10,2933,227,570,251,300,239,278,500,333,0,0,0,88,159,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21246,21246,'Tomb Archon',0,'',0,'Monster.death_blader_10_bi',16.00,49.50,55,'male','L2Monster',40,2643,987,41.08,2.45,40,43,30,21,20,10,3459,279,737,292,360,261,278,500,333,298,0,0,110,187,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21247,21247,'Tomb Inquisitor',0,'',0,'Monster.bloody_queen_10_bi',15.00,46.00,57,'female','L2Monster',40,2806,1052,41.08,2.45,40,43,30,21,20,10,3524,293,743,289,405,276,278,500,333,0,0,0,88,159,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21248,21248,'Crypt Guardian',0,'',0,'Monster.skeleton_royal_guard_20_bi',13.00,34.50,60,'male','L2Monster',40,3054,1150,41.08,2.45,40,43,30,21,20,10,3828,332,828,335,478,299,317,0,333,233,0,0,88,209,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21249,21249,'Crypt Sage',0,'',0,'Monster.vale_master_10_bi',13.00,44.00,62,'male','L2Monster',40,3219,1217,47.40,2.78,40,43,30,21,20,10,4169,371,944,330,532,315,278,500,333,311,0,0,77,176,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21250,21250,'Tomb Guardian',0,'',0,'Monster.death_knight',12.00,31.00,65,'male','L2Monster',40,3465,1319,47.40,2.78,40,43,30,21,20,10,4831,448,1184,380,619,340,278,500,333,0,0,0,29,209,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21251,21251,'Tomb Sage',0,'',0,'Monster.doll_master',20.00,42.00,67,'male','L2Monster',40,3626,1388,47.40,2.78,40,43,30,21,20,10,5444,518,1169,373,681,356,278,500,333,0,0,0,88,176,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21252,21252,'Crypt Guard ',0,'',0,'Monster.skeleton_royal_guard_30_bi',14.00,37.50,70,'male','L2Monster',40,3862,1493,47.40,2.78,40,43,30,21,20,10,5211,516,1265,427,780,382,317,0,333,236,0,0,88,220,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21253,21253,'Crypt Preacher',0,'',0,'Monster.vale_master_30_bi',15.00,52.00,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,5623,571,1413,417,849,399,278,500,333,326,0,0,77,181,'c_dungeon_clan',300,0,0,'LAST_HIT'),
	(21254,21254,'Tomb Guard',0,'',0,'Monster.death_knight',12.00,31.00,75,'male','L2Monster',40,4229,1673,53.72,3.09,40,43,30,21,20,10,6432,678,1720,475,957,425,278,500,333,78,0,0,29,220,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21255,21255,'Tomb Preacher',0,'',0,'Monster.doll_master_20_bi',24.00,50.40,77,'male','L2Monster',40,4364,1747,53.72,3.09,40,43,30,21,20,10,7190,778,1664,463,1031,442,278,500,333,0,0,0,88,181,'c_dungeon_clan',300,1,0,'LAST_HIT'),
	(21256,21256,'Underground Werewolf',0,'',0,'Monster.werewolf_bi',11.00,29.70,23,'male','L2Monster',40,648,257,5.53,1.53,40,43,30,21,20,10,754,36,75,91,31,87,278,400,333,0,0,0,55,148,NULL,0,0,0,'LAST_HIT'),
	(21257,21257,'Evil Eye Seer',0,'',0,'Monster.monster_eye',21.00,43.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,646,28,48,73,19,70,278,0,333,0,0,0,99,170,NULL,0,0,0,'LAST_HIT'),
	(21258,21258,'Fallen Orc Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,0,0,781,297,428,284,278,0,333,9,0,0,11,143,NULL,0,0,0,'LAST_HIT'),
	(21259,21259,'Fallen Orc Shaman',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,59,'male','L2Monster',40,2971,1117,10.27,2.45,40,43,30,21,20,10,12983,1110,820,305,453,291,278,500,333,0,0,0,66,198,'beast_clan',1000,0,0,'LAST_HIT'),
	(21260,21260,'Betrayer Orc Hero',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,3691,278,509,278,264,226,278,0,333,74,0,0,39,187,NULL,0,0,0,'LAST_HIT'),
	(21261,21261,'Ol Mahum Transcender',0,'',0,'Monster.ol_mahum',13.50,25.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,4284,323,509,236,264,226,278,0,333,127,0,0,55,143,NULL,0,0,0,'LAST_HIT'),
	(21262,21262,'Ol Mahum Transcender',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,7732,608,602,304,319,247,278,500,333,127,0,0,55,154,NULL,0,0,0,'LAST_HIT'),
	(21263,21263,'Ol Mahum Transcender',0,'',0,'Monster.oel_mahum',20.00,37.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,11790,952,670,322,360,261,278,500,333,127,0,0,77,165,NULL,0,0,0,'LAST_HIT'),
	(21264,21264,'Ol Mahum Transcender',0,'',0,'Monster.kel_mahum',13.00,26.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,19082,1612,781,349,428,284,278,500,333,127,0,0,55,176,NULL,0,0,0,'LAST_HIT'),
	(21265,21265,'Cave Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,1586,96,206,175,96,142,278,0,333,0,0,0,44,66,'ant_clan',500,0,0,'LAST_HIT'),
	(21266,21266,'Cave Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,0,333,0,0,0,44,66,'ant_clan',500,0,0,'LAST_HIT'),
	(21267,21267,'Cave Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,0,333,0,0,0,44,66,'ant_clan',500,0,0,'LAST_HIT'),
	(21268,21268,'Cave Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,36,'male','L2Monster',40,1279,463,14.22,1.84,40,43,30,21,20,10,1475,89,187,193,96,142,278,0,333,0,0,0,44,66,'ant_clan',500,0,0,'LAST_HIT'),
	(21269,21269,'Cave Ant',0,'',0,'Monster.ant',26.00,15.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,3368,207,222,154,104,147,278,500,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(21270,21270,'Cave Ant Soldier',0,'',0,'Monster.ant_soldier',35.00,17.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,3891,243,238,188,112,153,278,500,333,0,0,0,88,143,'ant_clan',300,0,0,'LAST_HIT'),
	(21271,21271,'Cave Ant',0,'',0,'Monster.ant',26.00,15.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,2298,141,222,154,104,147,278,500,333,0,0,0,44,143,'ant_clan',300,0,0,'LAST_HIT'),
	(21272,21272,'Cave Ant Soldier',0,'',0,'Monster.ant_soldier',35.00,17.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,4085,255,238,188,112,153,278,500,333,0,0,0,88,143,'ant_clan',300,0,0,'LAST_HIT'),
	(21273,21273,'Cave Noble Ant',0,'',0,'Monster.noble_ant',20.00,48.00,39,'male','L2Monster',40,1462,514,14.22,1.84,40,43,30,21,20,10,5918,376,280,177,121,158,278,500,333,0,0,0,88,191,'ant_clan',300,0,0,'LAST_HIT'),
	(21274,21274,'Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,67,'male','L2Monster',40,3626,1388,5.93,2.78,40,43,30,21,20,10,8356,796,1169,373,681,356,278,0,333,0,0,0,25,209,'animal_clan',300,0,0,'LAST_HIT'),
	(21275,21275,'Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,67,'male','L2Monster',40,3626,1388,5.93,2.78,40,43,30,21,20,10,8356,796,1415,308,681,356,278,0,333,0,0,0,25,209,'animal_clan',300,0,0,'LAST_HIT'),
	(21276,21276,'Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,67,'male','L2Monster',40,3626,1388,5.93,2.78,40,43,30,21,20,10,8356,796,1063,410,681,356,278,0,333,0,0,0,25,209,'animal_clan',300,0,0,'LAST_HIT'),
	(21277,21277,'Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,67,'male','L2Monster',40,3626,1388,5.93,2.78,40,43,30,21,20,10,5875,560,1169,373,681,356,278,0,333,0,0,0,25,209,'animal_clan',300,0,0,'LAST_HIT'),
	(21278,21278,'Antelope',0,'',0,'Monster2.antelope',17.00,34.00,68,'male','L2Monster',40,3706,1423,5.93,2.78,40,43,30,21,20,10,8608,832,1217,449,713,365,278,0,333,0,0,0,49,203,'animal_clan',300,0,0,'LAST_HIT'),
	(21279,21279,'Antelope',0,'',0,'Monster2.antelope',17.00,34.00,68,'male','L2Monster',40,3706,1423,5.93,2.78,40,43,30,21,20,10,8608,832,1106,494,713,365,278,0,333,0,0,0,49,181,'animal_clan',300,0,0,'LAST_HIT'),
	(21280,21280,'Antelope',0,'',0,'Monster2.antelope',17.00,34.00,68,'male','L2Monster',40,3706,1423,5.93,2.78,40,43,30,21,20,10,8608,832,1473,371,713,365,278,0,333,0,0,0,49,181,'animal_clan',300,0,0,'LAST_HIT'),
	(21281,21281,'Antelope',0,'',0,'Monster2.antelope',17.00,34.00,68,'male','L2Monster',40,3706,1423,5.93,2.78,40,43,30,21,20,10,6052,584,1217,449,713,365,278,0,333,0,0,0,49,181,'animal_clan',300,0,0,'LAST_HIT'),
	(21282,21282,'Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,69,'male','L2Monster',40,3784,1458,5.93,2.78,40,43,30,21,20,10,9040,884,1757,460,746,373,200,150,333,0,0,0,33,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21283,21283,'Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,69,'male','L2Monster',40,3784,1458,5.93,2.78,40,43,30,21,20,10,9040,884,2127,380,746,373,200,150,333,0,0,0,33,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21284,21284,'Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,69,'male','L2Monster',40,3784,1458,5.93,2.78,40,43,30,21,20,10,9040,884,1598,506,746,373,200,150,333,0,0,0,33,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21285,21285,'Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,69,'male','L2Monster',40,3784,1458,5.93,2.78,40,43,30,21,20,10,6356,622,1757,460,746,373,200,150,333,0,0,0,33,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21286,21286,'Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,70,'male','L2Monster',40,3862,1493,5.93,2.78,40,43,30,21,20,10,9121,904,1825,470,780,382,200,0,333,0,0,0,22,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21287,21287,'Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,70,'male','L2Monster',40,3862,1493,5.93,2.78,40,43,30,21,20,10,9121,904,1659,517,780,382,200,0,333,0,0,0,22,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21288,21288,'Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,70,'male','L2Monster',40,3862,1493,5.93,2.78,40,43,30,21,20,10,9121,904,2209,388,780,382,200,0,333,0,0,0,22,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21289,21289,'Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,70,'male','L2Monster',40,3862,1493,5.93,2.78,40,43,30,21,20,10,6413,636,1825,470,780,382,200,0,333,0,0,0,22,187,'animal_clan',300,0,0,'LAST_HIT'),
	(21290,21290,'Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,71,'male','L2Monster',40,3938,1529,6.72,3.09,40,43,30,21,20,10,9572,960,1894,481,814,390,200,150,333,0,0,0,39,176,'animal_clan',300,0,0,'LAST_HIT'),
	(21291,21291,'Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,71,'male','L2Monster',40,3938,1529,6.72,3.09,40,43,30,21,20,10,9572,960,1721,529,814,390,200,150,333,0,0,0,39,176,'animal_clan',300,0,0,'LAST_HIT'),
	(21292,21292,'Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,71,'male','L2Monster',40,3938,1529,6.72,3.09,40,43,30,21,20,10,9572,960,2291,397,814,390,200,150,333,0,0,0,39,176,'animal_clan',300,0,0,'LAST_HIT'),
	(21293,21293,'Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,71,'male','L2Monster',40,3938,1529,6.72,3.09,40,43,30,21,20,10,6730,676,1894,481,814,390,200,150,333,0,0,0,39,176,'animal_clan',300,0,0,'LAST_HIT'),
	(21294,21294,'Canyon Antelope ',0,'',0,'Monster2.antelope',17.00,34.00,68,'male','L2Monster',40,3706,1423,23.70,2.78,40,43,30,21,20,10,6893,666,1217,449,713,365,278,0,333,0,0,0,49,203,NULL,0,0,0,'LAST_HIT'),
	(21295,21295,'Canyon Antelope Slave',0,'',0,'Monster2.antelope',17.00,34.00,69,'male','L2Monster',40,3784,1458,23.70,2.78,40,43,30,21,20,10,7311,715,1265,460,746,373,278,150,333,0,0,0,49,181,'eye_clan',400,0,0,'LAST_HIT'),
	(21296,21296,'Canyon Bandersnatch ',0,'',0,'Monster2.bandersnatch',18.00,25.00,70,'male','L2Monster',40,3862,1493,35.55,2.78,40,43,30,21,20,10,7244,718,2429,353,780,382,200,150,333,0,0,0,33,198,NULL,0,0,0,'LAST_HIT'),
	(21297,21297,'Canyon Bandersnatch Slave',0,'',0,'Monster2.bandersnatch',18.00,25.00,71,'male','L2Monster',40,3938,1529,40.29,3.09,40,43,30,21,20,10,7275,730,1721,529,814,390,200,150,333,0,0,0,33,187,'eye_clan',400,0,0,'LAST_HIT'),
	(21298,21298,'Eye of Restrainer ',0,'',0,'Monster.monster_eye',21.00,43.00,71,'male','L2Monster',40,3938,1529,26.86,3.09,40,43,30,21,20,10,7023,705,1239,449,814,390,278,150,333,0,0,0,99,154,'eye_clan',400,0,0,'LAST_HIT'),
	(21299,21299,'Buffalo Slave',0,'',0,'Monster2.buffalo_ec',22.00,31.00,72,'male','L2Monster',40,4013,1565,40.29,3.09,40,43,30,21,20,10,7481,760,2159,446,849,399,200,150,333,0,0,0,22,176,'eye_clan',400,0,0,'LAST_HIT'),
	(21300,21300,'Eye of Guide',0,'',0,'Monster2.parasitic_eye_20_sm',20.00,50.50,72,'male','L2Monster',40,4013,1565,40.29,3.09,40,43,30,21,20,10,7360,747,1168,505,849,399,278,0,333,0,0,0,33,170,'eye_clan',400,0,0,'LAST_HIT'),
	(21301,21301,'Gaze of Nightmare',0,'',0,'Monster.field_stalker',15.00,30.00,72,'male','L2Monster',40,4013,1565,53.72,3.09,40,43,30,21,20,10,6624,673,1061,654,849,399,278,0,333,0,0,0,77,214,'eye_clan',400,0,0,'LAST_HIT'),
	(21302,21302,'Eye of Watchman',0,'',0,'Monster2.parasitic_eye',25.00,63.00,73,'male','L2Monster',40,4086,1601,40.29,3.09,40,43,30,21,20,10,7105,731,1770,352,885,407,278,150,333,0,0,0,33,176,'eye_clan',400,0,0,'LAST_HIT'),
	(21303,21303,'Homunculus',0,'',0,'Monster2.homunculus_20_sm',10.00,26.00,73,'male','L2Monster',40,4086,1601,40.29,3.09,40,43,30,21,20,10,7185,739,1947,320,885,407,278,150,333,0,0,0,33,203,'eye_clan',400,0,0,'LAST_HIT'),
	(21304,21304,'Grendel Slave',0,'',0,'Monster2.bionic_bear',15.00,39.00,74,'male','L2Monster',40,4158,1637,53.72,3.09,40,43,30,21,20,10,7918,825,2312,466,921,416,200,150,333,0,0,0,39,154,'eye_clan',400,0,0,'LAST_HIT'),
	(21305,21305,'Eye of Pilgrim',0,'',0,'Monster2.parasitic_eye_20_sm',20.00,50.50,74,'male','L2Monster',40,4158,1637,40.29,3.09,40,43,30,21,20,10,7775,810,1375,479,921,416,278,0,333,0,0,0,33,181,'eye_clan',400,0,0,'LAST_HIT'),
	(21306,21306,'Disciples of Protection',0,'',0,'Monster2.apostle_warrior',8.00,30.00,74,'female','L2Monster',40,4158,1637,67.15,3.09,40,43,30,21,20,10,8441,880,1579,682,921,416,200,150,333,6717,0,0,55,176,'divine_clan',600,0,0,'LAST_HIT'),
	(21307,21307,'Elder Homunculus',0,'',0,'Monster2.homunculus',12.00,32.50,75,'male','L2Monster',40,4229,1673,53.72,3.09,40,43,30,21,20,10,7394,780,1892,367,957,425,278,150,333,0,0,0,33,220,'eye_clan',400,0,0,'LAST_HIT'),
	(21308,21308,'Disciples of Punishment',0,'',0,'Monster2.apostle_warrior',8.00,30.00,75,'female','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,7860,829,2389,475,957,425,200,150,333,6717,0,0,55,209,'divine_clan',600,0,0,'LAST_HIT'),
	(21309,21309,'Disciples of Punishment',0,'',0,'Monster2.apostle_warrior',8.00,30.00,75,'female','L2Monster',40,4229,1673,67.15,3.09,40,43,30,21,20,10,8192,864,1795,633,957,425,200,150,333,6717,0,0,55,209,'divine_clan',600,0,0,'LAST_HIT'),
	(21310,21310,'Disciples of Authority',0,'',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,67.15,3.09,40,43,30,21,20,10,8071,863,1775,412,994,433,278,150,333,6718,0,0,55,170,'divine_clan',600,0,0,'LAST_HIT'),
	(21311,21311,'Disciples of Authority',0,'',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,67.15,3.09,40,43,30,21,20,10,7441,795,1334,549,994,433,278,150,333,6718,0,0,55,170,'divine_clan',600,0,0,'LAST_HIT'),
	(21312,21312,'Eye of Ruler',0,'',0,'Monster2.parasitic_eye',25.00,63.00,74,'male','L2Monster',40,4158,1637,40.29,3.09,40,43,30,21,20,10,10752,1121,1375,479,921,416,278,150,333,0,0,0,33,176,'eye_clan',400,0,0,'LAST_HIT'),
	(21313,21313,'Sly Hound Dog',0,'',0,'Monster2.bandersnatch',18.00,25.00,72,'male','L2Monster',40,4013,1565,40.29,3.09,40,43,30,21,20,10,10294,1046,2375,406,849,399,200,0,333,0,0,0,33,203,NULL,0,0,0,'LAST_HIT'),
	(21314,21314,'Hot Springs Bandersnatchling',0,'',0,'Monster2.bandersnatch',18.00,25.00,73,'male','L2Monster',40,4086,1601,26.86,3.09,40,43,30,21,20,10,8609,886,2032,502,885,407,200,150,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(21315,21315,'Hot Springs Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,73,'male','L2Monster',40,4086,1601,26.86,3.09,40,43,30,21,20,10,8971,923,2032,502,885,407,200,0,333,0,0,0,22,187,NULL,0,0,0,'LAST_HIT'),
	(21316,21316,'Hot Springs Flava',0,'',0,'Monster2.flava',18.00,34.00,74,'male','L2Monster',40,4158,1637,26.86,3.09,40,43,30,21,20,10,10556,1100,1513,512,921,416,278,150,333,0,0,0,33,181,NULL,0,0,0,'LAST_HIT'),
	(21317,21317,'Hot Springs Atroxspawn',0,'',0,'Monster2.kailiharim',45.00,39.00,74,'male','L2Monster',40,4158,1637,26.86,3.09,40,43,30,21,20,10,8846,922,2102,512,921,416,200,150,333,0,0,0,115,192,NULL,0,0,0,'LAST_HIT'),
	(21318,21318,'Hot Springs Antelope',0,'',0,'Monster2.antelope',17.00,34.00,74,'male','L2Monster',40,4158,1637,26.86,3.09,40,43,30,21,20,10,9247,964,1513,512,921,416,278,0,333,0,0,0,49,203,NULL,0,0,0,'LAST_HIT'),
	(21319,21319,'Hot Springs Nepenthes',0,'',0,'Monster2.nephenthes',28.00,43.50,75,'male','L2Monster',40,4229,1673,26.86,3.09,40,43,30,21,20,10,11636,1227,2172,523,957,425,200,150,333,0,0,0,52,187,NULL,0,0,0,'LAST_HIT'),
	(21320,21320,'Hot Springs Yeti',0,'',0,'Monster.yeti_20_bi',18.00,32.00,75,'male','L2Monster',40,4229,1673,26.86,3.09,40,43,30,21,20,10,9470,999,1563,523,957,425,278,0,333,0,0,0,17,187,NULL,0,0,0,'LAST_HIT'),
	(21321,21321,'Hot Springs Atrox',0,'',0,'Monster2.kailiharim',45.00,39.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,333,0,0,0,115,192,NULL,0,0,0,'LAST_HIT'),
	(21322,21322,'Hot Springs Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,11135,1190,2242,534,994,433,200,150,333,0,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(21323,21323,'Hot Springs Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,9753,1042,2242,534,994,433,200,0,333,0,0,0,39,181,NULL,0,0,0,'LAST_HIT'),
	(21324,21324,'Ketra Orc Footman',0,'',0,'Monster.ketra_orc',12.00,29.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,9323,1009,1664,544,1031,442,278,150,333,79,0,0,49,192,'ketra',300,0,0,'LAST_HIT'),
	(21325,21325,'Ketra''s War Hound',0,'',0,'Monster2.bandersnatch',18.00,25.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,9015,975,2543,495,1031,442,200,150,333,0,0,0,33,203,'ketra',300,0,0,'LAST_HIT'),
	(21326,21326,'Grazing Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,333,0,0,0,25,209,'ketra',0,0,0,'LAST_HIT'),
	(21327,21327,'Ketra Orc Raider',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,78,'male','L2Monster',40,4428,1784,26.86,3.09,40,43,30,21,20,10,10240,1120,2075,459,1069,451,278,150,333,79,6919,0,39,192,'ketra',300,0,0,'LAST_HIT'),
	(21328,21328,'Ketra Orc Scout',0,'',0,'Monster.ketra_orc_archer',12.00,27.00,78,'male','L2Monster',500,4428,1784,26.86,3.09,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,333,288,0,0,49,192,'ketra',300,0,0,'LAST_HIT'),
	(21329,21329,'Ketra Orc Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,79,'male','L2Monster',40,4490,1821,26.86,3.09,40,43,30,21,20,10,9955,1103,1765,481,1107,459,278,150,333,92,0,0,11,165,'ketra',300,0,0,'LAST_HIT'),
	(21330,21330,'Grazing Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,79,'male','L2Monster',40,4490,1821,26.86,3.09,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,333,0,0,0,22,181,'ketra',0,0,0,'LAST_HIT'),
	(21331,21331,'Ketra Orc Warrior',0,'',0,'Monster.ketra_orc_warrior',12.00,24.00,80,'male','L2Monster',40,4550,1859,26.86,3.09,40,43,30,21,20,10,9304,1044,1996,524,1144,468,278,150,333,79,6919,0,39,192,'ketra',300,0,0,'LAST_HIT'),
	(21332,21332,'Ketra Orc Lieutenant',0,'',0,'Monster2.ketra_orc_chieftain',11.00,38.50,80,'male','L2Monster',40,4550,1859,26.86,3.09,40,43,30,21,20,10,10420,1169,2291,634,1144,468,200,150,333,6719,0,0,26,192,'ketra',300,0,0,'LAST_HIT'),
	(21333,21333,'Grazing Windsus',0,'',0,'Monster.giant_wild_hog',35.00,27.00,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,9976,1133,1540,710,1182,477,278,150,333,0,0,0,38,187,'ketra',0,0,0,'LAST_HIT'),
	(21334,21334,'Ketra Orc Medium',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,14933,1695,1863,499,1182,477,278,150,333,92,0,0,11,165,'ketra',300,0,0,'LAST_HIT'),
	(21335,21335,'Ketra Orc Elite Soldier',0,'',0,'Monster.ketra_orc',12.00,29.00,80,'male','L2Monster',40,4663,1934,26.86,3.09,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,333,79,0,0,49,192,'ketra',300,0,0,'LAST_HIT'),
	(21336,21336,'Ketra Orc White Captain',0,'',0,'Monster.ketra_orc_overload_20_bi',14.00,28.80,80,'male','L2Monster',40,4663,1934,26.86,3.09,40,43,30,21,20,10,11317,1300,1738,657,1220,485,278,150,333,80,0,0,36,192,'ketra',300,0,0,'LAST_HIT'),
	(21337,21337,'Grazing Elder Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,80,'male','L2Monster',40,4716,1972,26.86,3.09,40,43,30,21,20,10,10475,1217,2249,736,1258,494,200,150,333,0,0,0,22,181,'ketra',0,0,0,'LAST_HIT'),
	(21338,21338,'Ketra Orc Seer',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Monster',40,4716,1972,26.86,3.09,40,43,30,21,20,10,13783,1602,2155,470,1258,494,278,150,333,213,0,0,11,176,'ketra',300,0,0,'LAST_HIT'),
	(21339,21339,'Ketra Orc General',0,'',0,'Monster2.ketra_orc_chieftain_20_bi',17.00,46.20,80,'male','L2Monster',40,4766,2011,26.86,3.09,40,43,30,21,20,10,10494,1234,3372,511,1296,502,200,150,333,6719,0,0,26,192,'ketra',300,0,0,'LAST_HIT'),
	(21340,21340,'Ketra Orc Battalion Commander',0,'',0,'Monster2.ketra_orc_warlord',12.00,30.00,80,'male','L2Monster',40,4766,2011,26.86,3.09,40,43,30,21,20,10,10494,1234,2006,619,1296,502,278,150,333,80,6919,0,29,192,'ketra',300,0,0,'LAST_HIT'),
	(21341,21341,'Grazing Elder Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,333,0,0,0,25,209,'ketra',0,0,0,'LAST_HIT'),
	(21342,21342,'Ketra Orc Grand Seer',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,14456,1720,2052,629,1333,511,278,150,333,213,0,0,11,176,'ketra',300,0,0,'LAST_HIT'),
	(21343,21343,'Ketra Commander',0,'',0,'Monster2.ketra_orc_warlord_20_bi',15.00,36.00,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,16400,1862,1630,587,1182,477,317,150,333,80,6919,0,29,192,'ketra',300,0,0,'LAST_HIT'),
	(21344,21344,'Ketra Elite Guard',0,'',0,'Monster.ketra_orc_overload',12.00,24.00,80,'male','L2Monster',40,4550,1859,26.86,3.09,40,43,30,21,20,10,11138,1250,2195,476,1144,468,278,0,333,80,0,0,36,198,'ketra',300,0,0,'LAST_HIT'),
	(21345,21345,'Ketra''s Head Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,12360,1471,2257,572,1333,511,278,150,333,210,0,0,11,192,'ketra',300,0,0,'LAST_HIT'),
	(21346,21346,'Ketra''s Head Guard',0,'',0,'Monster2.ketra_orc_chieftain',11.00,38.50,80,'male','L2Minion',40,4766,2011,26.86,3.09,40,43,30,21,20,10,12279,1444,2303,749,1296,502,200,0,333,6719,0,0,26,192,'ketra',300,0,0,'LAST_HIT'),
	(21347,21347,'Ketra Prophet',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Monster',40,4899,2127,26.86,3.09,40,43,30,21,20,10,18779,2289,2141,650,1406,528,278,150,333,213,0,0,11,192,'ketra',300,0,0,'LAST_HIT'),
	(21348,21348,'Prophet''s Guard',0,'',0,'Monster2.ketra_orc_chieftain',11.00,38.50,80,'male','L2Minion',40,4858,2088,26.86,3.09,40,43,30,21,20,10,12871,1550,2913,639,1370,519,200,0,333,6719,0,0,26,198,'ketra',300,0,0,'LAST_HIT'),
	(21349,21349,'Prophet''s Aide',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,80,'male','L2Minion',40,4858,2088,26.86,3.09,40,43,30,21,20,10,13071,1574,2097,639,1370,519,278,0,333,210,0,0,11,198,'ketra',300,0,0,'LAST_HIT'),
	(21350,21350,'Varka Silenos Recruit',0,'',0,'Monster2.barka_silenos_hunter',16.00,38.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,9851,1066,1664,544,1031,442,278,150,333,2504,0,0,48,192,'varka',300,0,0,'LAST_HIT'),
	(21351,21351,'Varka Silenos Footman',0,'',0,'Monster2.barka_silenos_warrior',16.00,41.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,8487,918,1831,495,1031,442,278,150,333,2504,0,0,37,203,'varka',300,0,0,'LAST_HIT'),
	(21352,21352,'Grazing Antelope',0,'',0,'Monster2.antelope',17.00,34.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,9015,975,1375,560,1031,442,278,150,333,0,0,0,49,203,'varka',0,0,0,'LAST_HIT'),
	(21353,21353,'Varka Silenos Scout',0,'',0,'Monster2.barka_silenos_hunter',16.00,38.00,78,'male','L2Monster',40,4428,1784,26.86,3.09,40,43,30,21,20,10,9906,1084,2075,459,1069,451,278,150,333,142,6918,0,48,192,'varka',300,0,0,'LAST_HIT'),
	(21354,21354,'Varka Silenos Hunter',0,'',0,'Monster2.barka_silenos_archer',8.00,37.50,78,'male','L2Monster',500,4428,1784,26.86,3.09,40,43,30,21,20,10,9816,1074,3464,611,1069,451,249,150,333,6917,0,0,33,192,'varka',300,0,0,'LAST_HIT'),
	(21355,21355,'Varka Silenos Shaman',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,79,'male','L2Monster',40,4490,1821,26.86,3.09,40,43,30,21,20,10,9492,1052,2451,481,1107,459,200,150,333,6716,0,0,39,165,'varka',300,0,0,'LAST_HIT'),
	(21356,21356,'Grazing Nepenthes',0,'',0,'Monster2.nephenthes',28.00,43.50,79,'male','L2Monster',40,4490,1821,26.86,3.09,40,43,30,21,20,10,9489,1051,2026,685,1107,459,200,150,333,0,0,0,52,187,'varka',0,0,0,'LAST_HIT'),
	(21357,21357,'Varka Silenos Priest',0,'',0,'Monster2.barka_silenos_priest',9.00,41.50,80,'male','L2Monster',40,4550,1859,26.86,3.09,40,43,30,21,20,10,10277,1153,1996,524,1144,468,278,150,333,6716,0,0,39,192,'varka',300,0,0,'LAST_HIT'),
	(21358,21358,'Varka Silenos Warrior',0,'',0,'Monster2.barka_silenos_warrior',16.00,41.00,80,'male','L2Monster',40,4550,1859,26.86,3.09,40,43,30,21,20,10,10771,1209,1649,634,1144,468,278,150,333,142,6918,0,37,192,'varka',300,0,0,'LAST_HIT'),
	(21359,21359,'Grazing Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,9976,1133,2139,710,1182,477,200,150,333,0,0,0,33,192,'varka',0,0,0,'LAST_HIT'),
	(21360,21360,'Varka Silenos Medium',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,15892,1804,2588,499,1182,477,200,150,333,6716,0,0,39,165,'varka',300,0,0,'LAST_HIT'),
	(21361,21361,'Varka Silenos Magus',0,'',0,'Monster2.barka_silenos_mage_20_bi',11.00,55.20,80,'male','L2Monster',40,4663,1934,26.86,3.09,40,43,30,21,20,10,9625,1106,1912,598,1220,485,278,150,333,6716,0,0,39,192,'varka',300,0,0,'LAST_HIT'),
	(21362,21362,'Varka Silenos Officer',0,'',0,'Monster2.barka_silenos_chieftain',18.00,42.50,80,'male','L2Monster',40,4663,1934,26.86,3.09,40,43,30,21,20,10,11317,1300,2414,657,1220,485,200,150,333,2504,0,0,27,192,'varka',300,0,0,'LAST_HIT'),
	(21363,21363,'Grazing Flava',0,'',0,'Monster2.flava',18.00,34.00,80,'male','L2Monster',40,4716,1972,26.86,3.09,40,43,30,21,20,10,10475,1217,1619,736,1258,494,278,150,333,0,0,0,33,181,'varka',0,0,0,'LAST_HIT'),
	(21364,21364,'Varka Silenos Seer',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,80,'male','L2Monster',40,4716,1972,26.86,3.09,40,43,30,21,20,10,13272,1543,2994,470,1258,494,200,150,333,6716,0,0,39,176,'varka',300,0,0,'LAST_HIT'),
	(21365,21365,'Varka Silenos Great Magus',0,'',0,'Monster2.barka_silenos_warrior_20_bi',20.00,49.20,80,'male','L2Monster',40,4766,2011,26.86,3.09,40,43,30,21,20,10,11525,1355,2428,511,1296,502,278,150,333,2500,0,0,37,192,'varka',300,0,0,'LAST_HIT'),
	(21366,21366,'Varka Silenos General',0,'',0,'Monster2.barka_silenos_chieftain',18.00,42.50,80,'male','L2Monster',40,4766,2011,26.86,3.09,40,43,30,21,20,10,12718,1496,2787,619,1296,502,200,150,333,2500,0,0,27,192,'varka',300,0,0,'LAST_HIT'),
	(21367,21367,'Grazing Elder Antelope',0,'',0,'Monster2.antelope',17.00,34.00,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,10986,1307,1696,647,1333,511,278,150,333,0,0,0,49,203,'varka',0,0,0,'LAST_HIT'),
	(21368,21368,'Varka Silenos Great Seer',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,16964,2019,2851,629,1333,511,200,150,333,6716,0,0,39,176,'varka',300,0,0,'LAST_HIT'),
	(21369,21369,'Varka''s Commander',0,'',0,'Monster2.barka_silenos_chieftain_20_bi',22.00,51.00,80,'male','L2Monster',40,4608,1896,26.86,3.09,40,43,30,21,20,10,15953,1811,2588,587,1182,477,200,150,333,2500,0,0,27,192,'varka',300,0,0,'LAST_HIT'),
	(21370,21370,'Varka''s Elite Guard',0,'',0,'Monster2.barka_silenos_warrior',16.00,41.00,80,'male','L2Minion',40,4550,1859,26.86,3.09,40,43,30,21,20,10,11565,1298,2195,476,1144,468,278,0,333,2500,0,0,37,198,'varka',300,0,0,'LAST_HIT'),
	(21371,21371,'Varka''s Head Magus',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,80,'male','L2Monster',40,4813,2049,26.86,3.09,40,43,30,21,20,10,12360,1471,3136,572,1333,511,200,150,333,6716,0,0,39,192,'varka',300,0,0,'LAST_HIT'),
	(21372,21372,'Varka''s Head Guard',0,'',0,'Monster2.barka_silenos_hunter',16.00,38.00,80,'male','L2Minion',40,4766,2011,26.86,3.09,40,43,30,21,20,10,12279,1444,1658,749,1296,502,278,0,333,2500,6918,0,48,192,'varka',300,0,0,'LAST_HIT'),
	(21373,21373,'Varka''s Prophet',0,'',0,'Monster2.barka_silenos_shaman_20_bi',17.00,47.50,80,'male','L2Monster',40,4899,2127,26.86,3.09,40,43,30,21,20,10,18082,2204,2973,650,1406,528,200,150,333,6716,0,0,39,192,'varka',300,0,0,'LAST_HIT'),
	(21374,21374,'Prophet Guard',0,'',0,'Monster2.barka_silenos_warrior',16.00,41.00,80,'male','L2Minion',40,4858,2088,26.86,3.09,40,43,30,21,20,10,12871,1550,2097,639,1370,519,278,0,333,2500,6918,0,37,198,'varka',300,0,0,'LAST_HIT'),
	(21375,21375,'Disciple of Prophet',0,'',0,'Monster2.barka_silenos_priest',9.00,41.50,80,'male','L2Minion',40,4858,2088,26.86,3.09,40,43,30,21,20,10,12404,1494,2097,639,1370,519,278,0,333,6716,0,0,39,198,'varka',300,0,0,'LAST_HIT'),
	(21376,21376,'Scarlet Stakato Walker',0,'',0,'Monster.blade_stakato_worker',13.00,40.00,78,'male','L2Monster',40,4428,1784,67.15,3.09,40,43,30,21,20,10,7054,772,1886,505,1069,451,278,150,333,235,0,0,27,143,'fire_clan',300,0,0,'LAST_HIT'),
	(21377,21377,'Scarlet Stakato Soldier',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,78,'male','L2Monster',40,4428,1784,67.15,3.09,40,43,30,21,20,10,6904,755,1886,429,1069,451,278,150,333,148,0,0,27,198,'fire_clan',300,0,0,'LAST_HIT'),
	(21378,21378,'Scarlet Stakato Noble',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,9829,1089,1941,514,1107,459,278,150,333,235,0,0,27,198,'fire_clan',300,0,0,'LAST_HIT'),
	(21379,21379,'Tepra Scorpion',0,'',0,'Monster2.scorpion_20_sm',24.00,52.80,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,7098,786,1698,514,1107,459,317,150,333,0,0,0,40,137,'fire_clan',300,0,0,'LAST_HIT'),
	(21380,21380,'Tepra Scarab',0,'',0,'Monster2.scarab',14.00,22.00,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,7237,802,1941,514,1107,459,278,150,333,0,0,0,49,192,'fire_clan',300,0,0,'LAST_HIT'),
	(21381,21381,'Assassin Beetle',0,'',0,'Monster2.tera_beetle',19.00,54.50,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,8414,944,1996,524,1144,468,278,150,333,0,0,0,49,159,'fire_clan',300,0,0,'LAST_HIT'),
	(21382,21382,'Mercenary of Destruction',0,'',0,'Monster.skeleton_knight',10.00,25.00,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,10380,1165,1996,524,1144,468,278,150,333,150,103,0,44,181,'fire_clan',300,1,0,'LAST_HIT'),
	(21383,21383,'Knight of Destruction',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,10396,1167,1996,524,1144,468,278,150,333,946,945,0,88,203,'fire_clan',300,1,0,'LAST_HIT'),
	(21384,21384,'Necromancer of Destruction',0,'',0,'Monster.vale_master_20_bi',14.50,48.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,8915,1012,2050,454,1182,477,278,150,333,0,0,0,77,159,'fire_clan',300,0,0,'LAST_HIT'),
	(21385,21385,'Lavastone Golem',0,'',0,'Monster.stone_golem',20.00,31.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,8585,975,2050,534,1182,477,278,150,333,0,0,0,25,44,'fire_clan',300,0,0,'LAST_HIT'),
	(21386,21386,'Magma Golem',0,'',0,'Monster2.lava_golem',22.00,45.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,9174,1041,2847,534,1182,477,200,150,333,0,0,0,14,66,'fire_clan',300,0,0,'LAST_HIT'),
	(21387,21387,'Arimanes of Destruction',0,'',0,'Monster2.ahrimanes',14.00,57.75,80,'male','L2Monster',40,4663,1934,67.15,3.09,40,43,30,21,20,10,7314,840,2921,543,1220,485,200,150,333,6722,0,0,38,203,'fire_clan',300,0,0,'LAST_HIT'),
	(21388,21388,'Iblis of Destruction',0,'',0,'Monster.fiend_archer',17.00,55.00,80,'male','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,9221,1059,2103,543,1220,485,278,150,333,0,0,0,77,165,'fire_clan',300,0,0,'LAST_HIT'),
	(21389,21389,'Balrog of Destruction',0,'',0,'Monster.kaim_vanul',24.00,40.00,80,'male','L2Monster',40,4716,1972,80.58,3.09,40,43,30,21,20,10,9888,1149,2155,553,1258,494,278,150,333,0,0,0,40,170,'fire_clan',300,0,0,'LAST_HIT'),
	(21390,21390,'Ashuras of Destruction',0,'',0,'Monster2.ashuras_30_bi',17.00,49.00,80,'male','L2Monster',40,4766,2011,80.58,3.09,40,43,30,21,20,10,11408,1342,2207,562,1296,502,278,150,333,0,0,0,45,209,'fire_clan',300,0,0,'LAST_HIT'),
	(21391,21391,'Lavasillisk',0,'',0,'Monster.lesser_basilisk',34.00,25.00,80,'male','L2Monster',40,4716,1972,80.58,3.09,40,43,30,21,20,10,7886,916,2155,553,1258,494,278,150,333,0,0,0,38,154,'fire_clan',300,0,0,'LAST_HIT'),
	(21392,21392,'Blazing Ifrit',0,'',0,'Monster2.ifrit_30_bi',13.00,55.00,80,'male','L2Monster',40,4766,2011,80.58,3.09,40,43,30,21,20,10,11251,1323,2207,562,1296,502,278,150,333,0,0,0,41,165,'fire_clan',300,0,0,'LAST_HIT'),
	(21393,21393,'Magma Drake',0,'',0,'Monster2.inferno_drake_20_bi',29.00,42.00,80,'male','L2Monster',40,4813,2049,80.58,3.09,40,43,30,21,20,10,9494,1130,2257,572,1333,511,278,150,333,0,0,0,62,214,'fire_clan',300,0,0,'LAST_HIT'),
	(21394,21394,'Lavasaurus',0,'',0,'Monster2.magmagoil',15.00,75.00,79,'male','L2Monster',500,4490,1821,67.15,3.09,40,43,30,21,20,10,8988,996,5991,437,1107,459,179,150,333,0,0,0,1,1,'fire_clan',300,0,0,'LAST_HIT'),
	(21395,21395,'Elder Lavasaurus',0,'',0,'Monster2.magmagoil_lad',15.00,75.00,80,'male','L2Monster',500,4716,1972,80.58,3.09,40,43,30,21,20,10,9760,1134,6652,470,1258,494,179,150,333,0,0,0,1,1,'fire_clan',300,0,0,'LAST_HIT'),
	(21396,21396,'Carrion Scarab',0,'',0,'Monster2.scarab',14.00,22.00,78,'male','L2Monster',40,4428,1784,40.29,3.09,40,43,30,21,20,10,8182,895,1417,672,1069,451,278,0,333,0,0,0,49,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21397,21397,'Carrion Scarab',0,'',0,'Monster2.scarab',14.00,22.00,78,'male','L2Monster',40,4428,1784,40.29,3.09,40,43,30,21,20,10,7103,777,2282,417,1069,451,278,0,333,0,0,0,49,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21398,21398,'Soldier Scarab',0,'',0,'Monster2.scarab',14.00,22.00,78,'male','L2Monster',40,4428,1784,80.58,3.09,40,43,30,21,20,10,6744,738,1715,555,1069,451,278,150,333,0,0,0,49,198,'tomb_clan',300,0,0,'LAST_HIT'),
	(21399,21399,'Soldier Scarab',0,'',0,'Monster2.scarab',14.00,22.00,78,'male','L2Monster',40,4428,1784,67.15,3.09,40,43,30,21,20,10,7736,846,1715,555,1069,451,278,150,333,0,0,0,49,198,'tomb_clan',300,0,0,'LAST_HIT'),
	(21400,21400,'Hexa Beetle',0,'',0,'Monster2.tera_beetle',25.00,54.50,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,6611,732,1765,566,1107,459,278,0,333,0,0,0,49,159,'tomb_clan',300,0,0,'LAST_HIT'),
	(21401,21401,'Hexa Beetle',0,'',0,'Monster2.tera_beetle',25.00,54.50,79,'male','L2Monster',40,4490,1821,53.72,3.09,40,43,30,21,20,10,7271,806,1941,514,1107,459,278,150,333,0,0,0,49,159,'tomb_clan',300,0,0,'LAST_HIT'),
	(21402,21402,'Katraxis',0,'',0,'Monster2.scorpion_20_sm',24.00,52.80,79,'male','L2Monster',40,4490,1821,53.72,3.09,40,43,30,21,20,10,7503,831,1544,566,1107,459,317,150,333,0,0,0,40,181,'tomb_clan',300,0,0,'LAST_HIT'),
	(21403,21403,'Katraxis',0,'',0,'Monster2.scorpion_20_sm',24.00,52.80,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,6928,767,1544,566,1107,459,317,150,333,0,0,0,40,181,'tomb_clan',300,0,0,'LAST_HIT'),
	(21404,21404,'Tera Beetle',0,'',0,'Monster2.tera_beetle',25.00,54.50,80,'male','L2Monster',40,4550,1859,53.72,3.09,40,43,30,21,20,10,14906,1673,1649,634,1144,468,278,0,333,0,0,0,49,203,'tomb_clan',300,0,0,'LAST_HIT'),
	(21405,21405,'Tera Beetle',0,'',0,'Monster2.tera_beetle',25.00,54.50,80,'male','L2Monster',40,4550,1859,53.72,3.09,40,43,30,21,20,10,7146,802,1814,576,1144,468,278,0,333,0,0,0,49,203,'tomb_clan',300,0,0,'LAST_HIT'),
	(21406,21406,'Knight of Empire',0,'',0,'Monster.skeleton_knight',10.00,25.00,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,8454,949,1814,576,1144,468,278,150,333,150,103,0,44,159,'tomb_clan',300,1,0,'LAST_HIT'),
	(21407,21407,'Knight of Empire',0,'',0,'Monster.skeleton_knight',10.00,25.00,80,'male','L2Monster',40,4550,1859,40.29,3.09,40,43,30,21,20,10,9017,1012,1814,576,1144,468,278,150,333,150,103,0,44,159,'tomb_clan',300,1,0,'LAST_HIT'),
	(21408,21408,'Royal Guard of Empire',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,7358,825,1996,524,1144,468,278,150,333,304,0,0,55,209,'tomb_clan',300,1,0,'LAST_HIT'),
	(21409,21409,'Royal Guard of Empire',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,80,'male','L2Monster',40,4550,1859,80.58,3.09,40,43,30,21,20,10,6857,769,1499,698,1144,468,278,150,333,304,0,0,55,209,'tomb_clan',300,1,0,'LAST_HIT'),
	(21410,21410,'Guardian Scarab',0,'',0,'Monster2.scarab_20_bi',17.00,26.50,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,7602,863,1863,587,1182,477,278,0,333,0,0,0,49,214,'tomb_clan',300,0,0,'LAST_HIT'),
	(21411,21411,'Guardian Scarab',0,'',0,'Monster2.scarab_20_bi',17.00,26.50,80,'male','L2Monster',40,4608,1896,53.72,3.09,40,43,30,21,20,10,7584,861,1863,587,1182,477,278,0,333,0,0,0,49,214,'tomb_clan',300,0,0,'LAST_HIT'),
	(21412,21412,'Ustralith',0,'',0,'Monster2.scorpion',28.00,66.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,9682,1099,1347,710,1182,477,317,150,333,0,0,0,40,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21413,21413,'Ustralith',0,'',0,'Monster2.scorpion',28.00,66.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,7445,845,1793,534,1182,477,317,150,333,0,0,0,40,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21414,21414,'Assassin of Empire',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,7236,821,1973,485,1182,477,317,0,333,946,945,0,88,192,'tomb_clan',300,1,0,'LAST_HIT'),
	(21415,21415,'Assassin of Empire',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,7299,828,1482,646,1182,477,317,0,333,946,945,0,88,192,'tomb_clan',300,1,0,'LAST_HIT'),
	(21416,21416,'Imperial Commander',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,8637,980,1863,587,1182,477,278,150,333,134,6721,0,42,154,'tomb_clan',300,1,0,'LAST_HIT'),
	(21417,21417,'Imperial Commander',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster',40,4608,1896,80.58,3.09,40,43,30,21,20,10,12557,1425,2255,485,1182,477,278,150,333,134,6721,0,42,154,'tomb_clan',300,1,0,'LAST_HIT'),
	(21418,21418,'Imperial Royal Guard',0,'',0,'Monster.death_knight',12.00,31.00,80,'male','L2Monster',40,4663,1934,53.72,3.09,40,43,30,21,20,10,8030,922,1912,598,1220,485,278,0,333,142,0,0,29,176,'tomb_clan',300,1,0,'LAST_HIT'),
	(21419,21419,'Imperial Royal Guard',0,'',0,'Monster.death_knight',12.00,31.00,80,'male','L2Monster',40,4663,1934,53.72,3.09,40,43,30,21,20,10,8173,939,1912,598,1220,485,278,0,333,142,0,0,29,176,'tomb_clan',300,1,0,'LAST_HIT'),
	(21420,21420,'Ashuras',0,'',0,'Monster2.ashuras',13.00,37.50,80,'male','L2Monster',40,4663,1934,67.15,3.09,40,43,30,21,20,10,7704,885,1912,598,1220,485,278,150,333,0,0,0,45,220,'tomb_clan',300,0,0,'LAST_HIT'),
	(21421,21421,'Ashuras',0,'',0,'Monster2.ashuras',13.00,37.50,80,'male','L2Monster',40,4663,1934,67.15,3.09,40,43,30,21,20,10,7231,830,1912,598,1220,485,278,150,333,0,0,0,45,220,'tomb_clan',300,0,0,'LAST_HIT'),
	(21422,21422,'Dancer of Empire',0,'',0,'Monster.banshee',9.00,23.00,80,'female','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,6913,794,2103,543,1220,485,278,0,333,0,0,0,88,132,'tomb_clan',300,0,0,'LAST_HIT'),
	(21423,21423,'Dancer of Empire',0,'',0,'Monster.banshee',9.00,23.00,80,'female','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,7328,842,2103,543,1220,485,278,150,333,0,0,0,88,132,'tomb_clan',300,0,0,'LAST_HIT'),
	(21424,21424,'Ashkenas',0,'',0,'Monster2.ashuras',13.00,37.50,80,'male','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,9288,1067,2544,449,1220,485,278,0,333,0,0,0,45,209,'tomb_clan',300,0,0,'LAST_HIT'),
	(21425,21425,'Ashkenas',0,'',0,'Monster2.ashuras',13.00,37.50,80,'male','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,9444,1085,2544,449,1220,485,278,150,333,0,0,0,45,209,'tomb_clan',300,0,0,'LAST_HIT'),
	(21426,21426,'Abraxion',0,'',0,'Monster2.erinyes',21.00,50.00,80,'male','L2Monster',40,4716,1972,53.72,3.09,40,43,30,21,20,10,16312,1896,2722,608,1258,494,200,150,333,0,0,0,34,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21427,21427,'Abraxion',0,'',0,'Monster2.erinyes',21.00,50.00,80,'male','L2Monster',40,4716,1972,53.72,3.09,40,43,30,21,20,10,9587,1114,2722,608,1258,494,200,150,333,0,0,0,34,143,'tomb_clan',300,0,0,'LAST_HIT'),
	(21428,21428,'Hasturan',0,'',0,'Monster2.erinyes',21.00,50.00,80,'male','L2Monster',40,4716,1972,67.15,3.09,40,43,30,21,20,10,7324,851,2994,553,1258,494,200,150,333,0,0,0,34,165,'tomb_clan',300,0,0,'LAST_HIT'),
	(21429,21429,'Hasturan',0,'',0,'Monster2.erinyes',21.00,50.00,80,'male','L2Monster',40,4716,1972,67.15,3.09,40,43,30,21,20,10,7647,889,2474,669,1258,494,200,150,333,0,0,0,34,165,'tomb_clan',300,0,0,'LAST_HIT'),
	(21430,21430,'Arimanes',0,'',0,'Monster2.ahrimanes',14.00,57.75,80,'male','L2Monster',40,4716,1972,80.58,3.09,40,43,30,21,20,10,8801,1023,3293,503,1258,494,200,0,333,6722,0,0,38,231,'tomb_clan',300,0,0,'LAST_HIT'),
	(21431,21431,'Arimanes',0,'',0,'Monster2.ahrimanes',14.00,57.75,80,'male','L2Monster',40,4716,1972,80.58,3.09,40,43,30,21,20,10,7507,872,2249,736,1258,494,200,0,333,6722,0,0,38,231,'tomb_clan',300,0,0,'LAST_HIT'),
	(21432,21432,'Chakram Beetle',0,'',0,'Monster2.tera_beetle',19.00,54.50,80,'male','L2Monster',40,4550,1859,80.58,3.09,40,43,30,21,20,10,12155,1364,1814,576,1144,468,278,0,333,0,0,0,49,187,'tomb_clan',300,0,0,'LAST_HIT'),
	(21433,21433,'Jamadar Beetle',0,'',0,'Monster2.tera_beetle_20_sm',20.00,43.60,79,'male','L2Monster',40,4490,1821,80.58,3.09,40,43,30,21,20,10,11788,1306,1765,566,1107,459,278,0,333,0,0,0,49,192,NULL,0,0,0,'LAST_HIT'),
	(21434,21434,'Seer of Blood',0,'',0,'Monster2.erinyes',21.00,50.00,82,'male','L2Monster',40,4663,1934,80.58,3.09,40,43,30,21,20,10,23561,2707,2655,598,1220,485,200,0,333,0,0,0,34,165,'tomb_clan',300,0,0,'LAST_HIT'),
	(21435,21435,'Guide of Offering',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster',40,4550,1859,80.58,3.09,40,43,30,21,20,10,11922,1338,1814,576,1144,468,278,0,333,134,6721,0,42,165,NULL,0,1,0,'LAST_HIT'),
	(21436,21436,'Leader of Offering',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster',40,4550,1859,80.58,3.09,40,43,30,21,20,10,12367,1388,1814,576,1144,468,278,0,333,134,6721,0,42,165,NULL,0,1,0,'LAST_HIT'),
	(21437,21437,'Offering Bug',0,'',0,'Monster2.scarab',14.00,22.00,79,'male','L2Monster',40,4490,1821,53.72,3.09,40,43,30,21,20,10,7489,830,1765,566,1107,459,278,0,333,0,0,0,49,198,NULL,0,0,0,'LAST_HIT'),
	(21438,21438,'Heathen Warrior',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,65,'male','L2Monster',40,3465,1319,2.96,2.78,40,43,30,21,20,10,5966,556,1140,346,619,340,317,150,333,946,945,0,88,192,'undead_clan',300,1,0,'LAST_HIT'),
	(21439,21439,'Heathen Executed ',0,'',0,'Monster.hungry_spirit',30.00,40.00,66,'male','L2Monster',40,3546,1353,2.96,2.78,40,43,30,21,20,10,6151,580,1358,301,649,348,278,150,333,0,0,0,16,192,'undead_clan',300,1,0,'LAST_HIT'),
	(21440,21440,'Heathen Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,67,'male','L2Monster',500,3626,1388,2.96,2.78,40,43,30,21,20,10,6735,640,3145,308,681,356,249,0,333,284,0,0,44,170,'undead_clan',300,1,0,'LAST_HIT'),
	(21441,21441,'Heathen Grunt',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,68,'male','L2Monster',40,3706,1423,2.96,2.78,40,43,30,21,20,10,6530,632,1473,371,713,365,278,150,333,96,0,0,55,187,'undead_clan',300,1,0,'LAST_HIT'),
	(21442,21442,'Heathen Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,69,'male','L2Monster',40,3784,1458,2.96,2.78,40,43,30,21,20,10,6723,656,1531,380,746,373,278,150,333,150,103,0,44,181,'undead_clan',300,1,0,'LAST_HIT'),
	(21443,21443,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,7006,633,649,530,560,323,317,150,333,153,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21444,21444,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,5887,532,741,530,560,323,278,150,333,153,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21445,21445,'Alpen Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,6076,556,1302,449,589,331,200,150,333,0,0,0,33,187,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21446,21446,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,7476,684,678,543,589,331,317,150,333,160,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21447,21447,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,7689,724,738,570,649,348,317,150,333,229,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21448,21448,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,6462,608,843,570,649,348,278,150,333,229,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21449,21449,'Raider of Pastureland',0,'',0,'Monster.dark_mahum',13.00,26.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8440,815,800,598,713,365,317,150,333,234,0,0,55,181,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21450,21450,'Alpen Grendel',0,'',0,'Monster2.bionic_bear',15.00,39.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8162,789,1690,449,713,365,200,150,333,0,0,0,39,170,'nonpet_clan',300,0,0,'LAST_HIT'),
	(21451,21451,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,5.93,2.78,40,43,30,21,20,10,5530,514,1077,418,619,340,278,0,333,0,0,0,14,121,'pet_clan',300,0,0,'LAST_HIT'),
	(21452,21452,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21453,21453,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21454,21454,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21455,21455,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21456,21456,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21457,21457,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21458,21458,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7312,679,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21459,21459,'Alpen Kookaburra',0,'',0,'Monster2.baby_ostrich',7.00,15.00,65,'male','L2FeedableBeast',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6144,571,890,506,619,340,278,0,333,0,0,0,14,154,'pet_clan',300,0,0,'LAST_HIT'),
	(21460,21460,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21461,21461,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21462,21462,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21463,21463,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21464,21464,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21465,21465,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7963,740,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21466,21466,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7661,711,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21467,21467,'Alpen Kookaburra',0,'',0,'Monster2.youth_ostrich',8.00,26.40,65,'male','L2FeedableBeast',40,3465,1319,23.70,2.78,40,43,30,21,20,10,7367,684,1077,418,619,340,278,150,333,0,0,0,25,209,'pet_clan',300,0,0,'LAST_HIT'),
	(21468,21468,'Alpen Kookaburra',0,'',0,'Monster2.rough_ostrich',10.00,33.00,65,'male','L2FeedableBeast',40,3465,1319,47.40,2.78,40,43,30,21,20,10,6457,600,1433,314,619,340,278,150,333,0,0,0,25,231,'pet_clan',300,0,0,'LAST_HIT'),
	(21469,21469,'Alpen Kookaburra',0,'',0,'Monster2.rough_ostrich',10.00,33.00,65,'male','L2FeedableBeast',40,3465,1319,47.40,2.78,40,43,30,21,20,10,6159,572,1433,314,619,340,278,150,333,0,0,0,25,231,'pet_clan',300,0,0,'LAST_HIT'),
	(21470,21470,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,5.93,2.78,40,43,30,21,20,10,5875,560,1169,439,681,356,278,0,333,0,0,0,33,121,'pet_clan',300,0,0,'LAST_HIT'),
	(21471,21471,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21472,21472,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21473,21473,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21474,21474,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21475,21475,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21476,21476,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21477,21477,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,7769,740,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21478,21478,'Alpen Buffalo',0,'',0,'Monster2.baby_buffalo',12.00,15.00,67,'male','L2FeedableBeast',40,3626,1388,11.85,2.78,40,43,30,21,20,10,6528,622,966,531,681,356,278,0,333,0,0,0,33,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21479,21479,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21480,21480,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21481,21481,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21482,21482,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21483,21483,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21484,21484,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8460,806,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21485,21485,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,8139,775,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21486,21486,'Alpen Buffalo',0,'',0,'Monster2.youth_buffalo',16.00,25.20,67,'male','L2FeedableBeast',40,3626,1388,23.70,2.78,40,43,30,21,20,10,7828,745,1624,439,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21487,21487,'Alpen Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,67,'male','L2FeedableBeast',40,3626,1388,47.40,2.78,40,43,30,21,20,10,6861,653,2162,329,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21488,21488,'Alpen Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,67,'male','L2FeedableBeast',40,3626,1388,47.40,2.78,40,43,30,21,20,10,6544,623,2162,329,681,356,200,150,333,0,0,0,22,187,'pet_clan',300,0,0,'LAST_HIT'),
	(21489,21489,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,5.93,2.78,40,43,30,21,20,10,6231,610,1265,460,746,373,278,0,333,0,0,0,30,121,'pet_clan',300,0,0,'LAST_HIT'),
	(21490,21490,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21491,21491,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21492,21492,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21493,21493,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21494,21494,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21495,21495,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21496,21496,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,8240,806,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21497,21497,'Alpen Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,69,'male','L2FeedableBeast',40,3784,1458,11.85,2.78,40,43,30,21,20,10,6924,678,1045,556,746,373,278,0,333,0,0,0,30,143,'pet_clan',300,0,0,'LAST_HIT'),
	(21498,21498,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21499,21499,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21500,21500,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21501,21501,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21502,21502,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21503,21503,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8973,878,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21504,21504,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8632,844,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21505,21505,'Alpen Cougar',0,'',0,'Monster2.youth_tiger',16.00,17.20,69,'male','L2FeedableBeast',40,3784,1458,23.70,2.78,40,43,30,21,20,10,8302,812,1265,460,746,373,278,150,333,0,0,0,66,192,'pet_clan',300,0,0,'LAST_HIT'),
	(21506,21506,'Alpen Cougar',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,69,'male','L2FeedableBeast',40,3784,1458,47.40,2.78,40,43,30,21,20,10,7276,712,1684,345,746,373,278,150,333,0,0,0,66,220,'pet_clan',300,0,0,'LAST_HIT'),
	(21507,21507,'Alpen Cougar',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,69,'male','L2FeedableBeast',40,3784,1458,47.40,2.78,40,43,30,21,20,10,6941,679,1684,345,746,373,278,150,333,0,0,0,66,220,'pet_clan',300,0,0,'LAST_HIT'),
	(21508,21508,'Splinter Stakato',0,'',0,'Monster.blade_stakato',15.00,36.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,8452,796,1123,364,649,348,278,150,333,235,0,0,27,192,'stakato_clan',300,0,0,'LAST_HIT'),
	(21509,21509,'Splinter Stakato Walker',0,'',0,'Monster.blade_stakato_worker',13.00,40.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,7445,709,1286,339,681,356,278,150,333,0,0,0,27,198,'stakato_clan',300,0,0,'LAST_HIT'),
	(21510,21510,'Splinter Stakato Soldier',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8972,867,1473,371,713,365,278,150,333,148,0,0,27,198,'stakato_clan',300,0,0,'LAST_HIT'),
	(21511,21511,'Splinter Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,9944,973,1265,460,746,373,278,150,333,132,0,0,27,203,'stakato_clan',300,0,0,'LAST_HIT'),
	(21512,21512,'Splinter Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,12636,1253,1086,569,780,382,278,0,333,132,0,0,27,203,'stakato_clan',300,0,0,'LAST_HIT'),
	(21513,21513,'Needle Stakato',0,'',0,'Monster.blade_stakato',15.00,36.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,9507,943,1314,399,780,382,278,150,333,235,0,0,27,203,'stakato_clan',300,0,0,'LAST_HIT'),
	(21514,21514,'Needle Stakato Walker',0,'',0,'Monster.blade_stakato_worker',13.00,40.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,8360,839,1499,371,814,390,278,150,333,0,0,0,27,209,'stakato_clan',300,0,0,'LAST_HIT'),
	(21515,21515,'Needle Stakato Soldier',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,10059,1022,1710,406,849,399,278,150,333,148,0,0,27,209,'stakato_clan',300,0,0,'LAST_HIT'),
	(21516,21516,'Needle Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,10340,1064,1463,502,885,407,278,150,333,132,0,0,27,214,'stakato_clan',300,0,0,'LAST_HIT'),
	(21517,21517,'Needle Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,74,'male','L2Monster',40,4158,1637,13.43,3.09,40,43,30,21,20,10,14121,1472,1250,620,921,416,278,0,333,132,0,0,27,214,'stakato_clan',300,0,0,'LAST_HIT'),
	(21518,21518,'Frenzy Stakato Soldier',0,'',0,'Monster.blade_stakato_soldier',15.00,38.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8002,773,1417,337,713,365,317,0,333,235,0,0,27,203,'stakato_clan',300,0,0,'LAST_HIT'),
	(21519,21519,'Frenzy Stakato Drone',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,8972,912,1645,369,849,399,317,0,333,235,0,0,27,214,'stakato_clan',300,0,0,'LAST_HIT'),
	(21520,21520,'Eye of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,7466,648,860,368,478,299,278,0,333,326,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21521,21521,'Claws of Splendor',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,7340,637,711,446,478,299,278,0,333,326,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21522,21522,'Claws of Splendor',0,'',0,'Monster.dark_fencer',7.00,13.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,8748,759,1041,259,478,299,278,0,333,0,0,0,27,170,'saint_clan',300,0,0,'LAST_HIT'),
	(21523,21523,'Flash of Splendor',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,61,'male','L2Monster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,7529,663,901,378,505,307,278,150,333,326,0,0,55,165,'saint_clan',300,0,0,'LAST_HIT'),
	(21524,21524,'Blade of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,61,'male','L2Monster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,8028,707,1200,284,505,307,278,0,333,242,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21525,21525,'Blade of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,61,'male','L2Monster',40,3137,1184,11.85,2.78,40,43,30,21,20,10,8028,707,901,378,505,307,278,0,333,242,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21526,21526,'Wisdom of Splendor',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,62,'male','L2Monster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,9220,822,944,388,532,315,278,150,333,193,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21527,21527,'Anger of Splendor',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,8132,734,987,398,560,323,278,0,333,193,0,0,55,165,'saint_clan',300,0,0,'LAST_HIT'),
	(21528,21528,'Anger of Splendor',0,'',0,'Monster.dark_fencer',7.00,13.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,9645,871,987,398,560,323,278,0,333,0,0,0,27,170,'saint_clan',300,0,0,'LAST_HIT'),
	(21529,21529,'Soul of Splendor',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,7377,666,987,398,560,323,278,150,333,193,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21530,21530,'Victory of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,8006,733,1031,408,589,331,278,0,333,196,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21531,21531,'Punishment of Splendor',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,8837,809,1373,306,589,331,278,0,333,242,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21532,21532,'Shout of Splendor',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,9456,879,1077,418,619,340,278,150,333,196,0,0,55,165,'saint_clan',300,0,0,'LAST_HIT'),
	(21533,21533,'Alliance of Splendor',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7767,722,890,430,619,340,278,0,333,196,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21534,21534,'Alliance of Splendor',0,'',0,'Monster.dark_fencer',7.00,13.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,10267,954,1303,346,619,340,278,0,333,0,0,0,27,170,'saint_clan',300,0,0,'LAST_HIT'),
	(21535,21535,'Signet of Splendor',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9331,878,1123,428,649,348,278,150,333,189,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21536,21536,'Crown of Splendor',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9487,893,1123,428,649,348,278,0,333,189,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21537,21537,'Fang of Splendor',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,8905,848,966,451,681,356,278,0,333,189,0,0,55,170,'saint_clan',300,0,0,'LAST_HIT'),
	(21538,21538,'Fang of Splendor',0,'',0,'Monster.dark_fencer',7.00,13.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,10908,1039,1415,362,681,356,278,0,333,0,0,0,27,170,'saint_clan',300,0,0,'LAST_HIT'),
	(21539,21539,'Wailing of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,9685,922,1557,329,681,356,278,0,333,242,0,0,55,187,'saint_clan',300,0,0,'LAST_HIT'),
	(21540,21540,'Wailing of Splendor',0,'',0,'Monster.kel_mahum',13.00,26.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,9685,922,1169,439,681,356,278,0,333,242,0,0,55,187,'saint_clan',300,0,0,'LAST_HIT'),
	(21541,21541,'Pilgrim of Splendor',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,9944,898,987,338,560,323,278,150,333,315,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21542,21542,'Disciple of Pilgrim',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,62,'male','L2Monster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,6932,618,1038,353,532,315,278,0,333,193,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21543,21543,'Page of Pilgrim',0,'',0,'Monster.kel_mahum',13.00,26.00,62,'male','L2Monster',40,3219,1217,11.85,2.78,40,43,30,21,20,10,7909,705,858,427,532,315,278,0,333,326,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21544,21544,'Judge of Splendor',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,11331,1079,1169,439,681,356,278,150,333,150,0,0,55,176,'saint_clan',300,0,0,'LAST_HIT'),
	(21545,21545,'Judge of Fire',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,7855,739,1235,331,649,348,278,0,333,189,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21546,21546,'Judge of Light',0,'',0,'Monster.kel_mahum',13.00,26.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,8963,844,1020,471,649,348,278,0,333,196,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21547,21547,'Corrupted Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,8116,733,987,398,560,323,278,0,333,150,103,0,44,181,'necro_clan',300,1,0,'LAST_HIT'),
	(21548,21548,'Resurrected Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,7019,634,987,398,560,323,278,0,333,150,103,0,44,181,'necro_clan',300,1,0,'LAST_HIT'),
	(21549,21549,'Corrupted Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,8375,767,902,408,589,331,317,0,333,946,0,0,88,192,'necro_clan',300,1,0,'LAST_HIT'),
	(21550,21550,'Corrupted Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,8543,782,1201,306,589,331,317,150,333,946,945,0,88,192,'necro_clan',300,1,0,'LAST_HIT'),
	(21551,21551,'Resurrected Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9541,898,982,428,649,348,317,0,333,221,0,0,88,192,'necro_clan',300,1,0,'LAST_HIT'),
	(21552,21552,'Resurrected Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9085,855,1307,322,649,348,317,150,333,221,945,0,88,192,'necro_clan',300,1,0,'LAST_HIT'),
	(21553,21553,'Trampled Man',0,'',0,'Monster.zombie',13.00,21.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6267,582,1077,355,619,340,278,0,333,0,0,0,16,44,'necro_clan',300,1,0,'LAST_HIT'),
	(21554,21554,'Trampled Man',0,'',0,'Monster.zombie',13.00,21.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,6267,582,1303,294,619,340,278,0,333,0,0,0,16,44,'necro_clan',300,1,0,'LAST_HIT'),
	(21555,21555,'Slaughter Executioner',0,'',0,'Monster.dark_horror',20.00,35.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7619,708,979,391,619,340,278,0,333,0,0,0,110,176,'necro_clan',300,1,0,'LAST_HIT'),
	(21556,21556,'Slaughter Executioner',0,'',0,'Monster.dark_horror',20.00,35.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,7435,691,1077,355,619,340,278,0,333,0,0,0,110,176,'necro_clan',300,1,0,'LAST_HIT'),
	(21557,21557,'Bone Snatcher',0,'',0,'Monster2.black_magician',8.00,30.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21558,21558,'Bone Snatcher',0,'',0,'Monster2.black_magician',8.00,30.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,8774,826,1123,428,649,348,278,0,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21559,21559,'Bone Maker',0,'',0,'Monster2.black_magician',8.00,30.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21560,21560,'Bone Shaper',0,'',0,'Monster2.black_magician',8.00,30.00,66,'male','L2Monster',40,3546,1353,11.85,2.78,40,43,30,21,20,10,9596,903,1020,471,649,348,278,150,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21561,21561,'Sacrificed Man',0,'',0,'Monster.zombie',13.00,21.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,8057,767,1063,410,681,356,278,150,333,0,0,0,16,44,'necro_clan',300,1,0,'LAST_HIT'),
	(21562,21562,'Guillotine''s Ghost',0,'',0,'Monster.liviona',15.00,28.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,8344,795,1169,373,681,356,278,150,333,0,0,0,88,165,'necro_clan',300,0,0,'LAST_HIT'),
	(21563,21563,'Bone Collector',0,'',0,'Monster2.black_magician',8.00,30.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,9695,923,1286,399,681,356,278,0,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21564,21564,'Skull Collector',0,'',0,'Monster2.black_magician',8.00,30.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,9223,878,1286,399,681,356,278,150,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21565,21565,'Bone Animator',0,'',0,'Monster2.black_magician',8.00,30.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,9314,900,1339,408,713,365,278,0,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21566,21566,'Skull Animator',0,'',0,'Monster2.black_magician',8.00,30.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,10186,984,1339,408,713,365,278,150,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21567,21567,'Bone Slayer',0,'',0,'Monster2.black_magician',8.00,30.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,12175,1176,1106,494,713,365,278,150,333,178,0,0,20,198,'necro_clan',300,0,0,'LAST_HIT'),
	(21568,21568,'Devil Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,10440,1009,1473,315,713,365,278,150,333,0,0,0,66,187,'vampire_clan',300,0,0,'LAST_HIT'),
	(21569,21569,'Devil Bat',0,'',0,'Monster.vampire_bat',10.00,33.50,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,8108,783,1217,382,713,365,278,150,333,0,0,0,66,187,'vampire_clan',300,0,0,'LAST_HIT'),
	(21570,21570,'Ghost of Betrayer',0,'',0,'Monster.binding',12.00,21.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,7557,739,1150,506,746,373,278,150,333,0,0,0,11,191,'necro_clan',300,1,0,'LAST_HIT'),
	(21571,21571,'Ghost of Rebellion Soldier',0,'',0,'Monster.skeleton_knight',10.00,25.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,10718,1049,1265,460,746,373,278,150,333,150,103,0,44,181,'necro_clan',300,1,0,'LAST_HIT'),
	(21572,21572,'Bone Sweeper',0,'',0,'Monster2.black_magician',8.00,30.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,10282,1006,1392,418,746,373,278,0,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21573,21573,'Atrox',0,'',0,'Monster2.kailiharim',45.00,39.00,69,'male','L2Monster',40,3784,1458,11.85,2.78,40,43,30,21,20,10,11456,1121,2127,380,746,373,200,150,333,0,0,0,115,203,'vampire_clan',300,0,0,'LAST_HIT'),
	(21574,21574,'Bone Grinder',0,'',0,'Monster2.black_magician',8.00,30.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,12902,1279,1194,517,780,382,278,150,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21575,21575,'Bone Grinder',0,'',0,'Monster2.black_magician',8.00,30.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,7269,721,1314,470,780,382,278,150,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21576,21576,'Ghost of Guillotine ',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,9350,927,1590,330,780,382,278,0,333,0,0,0,88,165,'vampire_clan',300,0,0,'LAST_HIT'),
	(21577,21577,'Ghost of Guillotine ',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,8195,813,1314,399,780,382,278,0,333,0,0,0,88,165,'vampire_clan',300,0,0,'LAST_HIT'),
	(21578,21578,'Behemoth Zombie',0,'',0,'Monster2.giant_zombie',13.00,40.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,10308,1034,1239,529,814,390,278,0,333,0,0,0,22,99,'necro_clan',300,1,0,'LAST_HIT'),
	(21579,21579,'Ghost of Rebellion Leader',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,10843,1088,1193,481,814,390,317,0,333,221,945,0,88,192,'necro_clan',300,1,0,'LAST_HIT'),
	(21580,21580,'Bone Caster',0,'',0,'Monster2.black_magician',8.00,30.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,10154,1019,1499,437,814,390,278,0,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21581,21581,'Bone Puppeteer',0,'',0,'Monster2.black_magician',8.00,30.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,11105,1114,1499,437,814,390,278,150,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21582,21582,'Vampire Soldier',0,'',0,'Monster2.vampire_soldier',8.00,23.50,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,11891,1193,1649,397,814,390,278,0,333,234,0,0,66,209,'vampire_clan',300,0,0,'LAST_HIT'),
	(21583,21583,'Bone Scavenger',0,'',0,'Monster2.black_magician',8.00,30.00,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,11196,1137,1554,446,849,399,278,0,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21584,21584,'Bone Scavenger',0,'',0,'Monster2.black_magician',8.00,30.00,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,10442,1061,1284,540,849,399,278,0,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21585,21585,'Vampire Magician',0,'',0,'Monster2.vampire_witch',6.00,21.50,72,'female','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,9628,978,1710,406,849,399,278,150,333,946,0,0,70,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21586,21586,'Vampire Adept',0,'',0,'Monster2.vampire_wizard',5.50,28.00,72,'female','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,11374,1156,1710,406,849,399,278,150,333,99,0,0,50,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21587,21587,'Vampire Warrior',0,'',0,'Monster2.vampire_soldier_20_bi',10.00,29.00,72,'male','L2Monster',40,4013,1565,13.43,3.09,40,43,30,21,20,10,11852,1204,1710,406,849,399,278,0,333,234,0,0,66,209,'vampire_clan',300,0,0,'LAST_HIT'),
	(21588,21588,'Vampire Wizard',0,'',0,'Monster2.vampire_witch',6.00,21.50,73,'female','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,9936,1022,1947,377,885,407,278,0,333,946,0,0,70,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21589,21589,'Vampire Wizard',0,'',0,'Monster2.vampire_witch',6.00,21.50,73,'female','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,10168,1046,1099,668,885,407,278,0,333,946,0,0,70,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21590,21590,'Vampire Magister',0,'',0,'Monster2.vampire_wizard',5.50,28.00,73,'female','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,9936,1022,1770,415,885,407,278,0,333,99,0,0,50,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21591,21591,'Vampire Magister',0,'',0,'Monster2.vampire_wizard',5.50,28.00,73,'female','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,11462,1179,1770,415,885,407,278,0,333,99,0,0,50,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21592,21592,'Vampire Magister',0,'',0,'Monster2.vampire_wizard',5.50,28.00,73,'female','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,7750,797,1330,552,885,407,278,0,333,99,0,0,50,198,'vampire_clan',300,0,0,'LAST_HIT'),
	(21593,21593,'Vampire Warlord',0,'',0,'Monster2.vampire_warrior',9.00,31.50,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,13346,1373,2459,415,885,407,200,0,333,6723,0,0,47,209,'vampire_clan',300,0,0,'LAST_HIT'),
	(21594,21594,'Vampire Warlord',0,'',0,'Monster2.vampire_warrior',9.00,31.50,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,12571,1294,2459,415,885,407,200,0,333,6723,0,0,47,209,'vampire_clan',300,0,0,'LAST_HIT'),
	(21595,21595,'Vampire Warlord',0,'',0,'Monster2.vampire_warrior',9.00,31.50,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,9161,943,1847,552,885,407,200,0,333,6723,0,0,47,209,'vampire_clan',300,0,0,'LAST_HIT'),
	(21596,21596,'Requiem Lord',0,'',0,'Monster2.black_magician',8.00,30.00,68,'male','L2Monster',40,3706,1423,11.85,2.78,40,43,30,21,20,10,12038,1163,1106,494,713,365,278,150,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21597,21597,'Requiem Behemoth',0,'',0,'Monster2.giant_zombie',13.00,40.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,8265,787,1286,399,681,356,278,0,333,0,0,0,22,110,'necro_clan',300,1,0,'LAST_HIT'),
	(21598,21598,'Requiem Behemoth',0,'',0,'Monster2.giant_zombie',13.00,40.00,67,'male','L2Monster',40,3626,1388,11.85,2.78,40,43,30,21,20,10,9179,874,1286,399,681,356,278,0,333,0,0,0,22,110,'necro_clan',300,1,0,'LAST_HIT'),
	(21599,21599,'Requiem Priest',0,'',0,'Monster2.black_magician',8.00,30.00,71,'male','L2Monster',40,3938,1529,13.43,3.09,40,43,30,21,20,10,12750,1279,1239,529,814,390,278,150,333,178,0,0,20,203,'necro_clan',300,0,0,'LAST_HIT'),
	(21600,21600,'Requiem Behemoth',0,'',0,'Monster2.giant_zombie',13.00,40.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,9022,895,1445,427,780,382,278,0,333,0,0,0,22,110,'necro_clan',300,1,0,'LAST_HIT'),
	(21601,21601,'Requiem Behemoth',0,'',0,'Monster2.giant_zombie',13.00,40.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,10732,1064,1445,427,780,382,278,0,333,0,0,0,22,110,'necro_clan',300,1,0,'LAST_HIT'),
	(21602,21602,'Zaken''s Pikeman',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,3693,250,332,223,163,181,278,150,333,292,0,0,55,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21603,21603,'Zaken''s Pikeman',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,5230,354,442,167,163,181,278,150,333,292,0,0,55,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21604,21604,'Zaken''s Elite Pikeman',0,'',0,'Monster.skeleton_pikeman_20_bi',12.00,33.60,43,'male','L2Monster',40,1728,618,34.76,2.14,40,43,30,21,20,10,2114,143,332,223,163,181,278,150,333,292,0,0,55,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21605,21605,'Zaken''s Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,44,'male','L2Monster',500,1799,648,8.69,2.14,40,43,30,21,20,10,4109,281,788,230,176,187,249,0,333,279,0,0,44,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21606,21606,'Zaken''s Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,44,'male','L2Monster',500,1799,648,8.69,2.14,40,43,30,21,20,10,5818,398,1048,173,176,187,249,0,333,279,0,0,44,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21607,21607,'Zaken''s Elite Archer',0,'',0,'Monster.skeleton_archer_20_bi',13.00,32.50,44,'male','L2Monster',500,1799,648,34.76,2.14,40,43,30,21,20,10,2273,155,788,230,176,187,249,0,333,279,0,0,44,191,'undead_clan1',300,1,0,'LAST_HIT'),
	(21608,21608,'Zaken''s Watchman',0,'',0,'Monster.liviona',15.00,28.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,3365,234,377,202,188,193,278,150,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(21609,21609,'Zaken''s Watchman',0,'',0,'Monster.liviona',15.00,28.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,4766,331,502,152,188,193,278,150,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(21610,21610,'Zaken''s High Grade Watchman',0,'',0,'Monster.liviona_20_bi',18.00,33.60,45,'male','L2Monster',40,1870,677,34.76,2.14,40,43,30,21,20,10,2174,151,377,202,188,193,278,150,333,0,0,0,88,191,NULL,0,0,0,'LAST_HIT'),
	(21611,21611,'Unpleasant Humming',0,'',0,'Monster.unpleasant_humming',12.00,26.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,3907,277,401,245,202,199,278,150,333,0,0,0,23,191,'undead_clan',300,1,3,'LAST_HIT'),
	(21612,21612,'Unpleasant Humming',0,'',0,'Monster.unpleasant_humming',12.00,26.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,5533,392,534,184,202,199,278,150,333,0,0,0,23,191,'undead_clan',300,1,3,'LAST_HIT'),
	(21613,21613,'Unpleasant Shout',0,'',0,'Monster.unpleasant_humming_20_bi',13.50,31.20,46,'male','L2Monster',40,1943,707,34.76,2.14,40,43,30,21,20,10,2360,167,401,245,202,199,278,150,333,0,0,0,23,191,'undead_clan',300,1,0,'LAST_HIT'),
	(21614,21614,'Death Flyer',0,'',0,'Monster.dark_horror',20.00,35.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,4035,289,427,253,216,206,278,0,333,0,0,0,110,191,'undead_clan',300,1,4,'LAST_HIT'),
	(21615,21615,'Death Flyer',0,'',0,'Monster.dark_horror',20.00,35.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,5714,410,568,190,216,206,278,0,333,0,0,0,110,191,'undead_clan',300,1,4,'LAST_HIT'),
	(21616,21616,'Gigantic Flyer',0,'',0,'Monster.dark_horror_bi',20.00,42.00,47,'male','L2Monster',40,2016,738,34.76,2.14,40,43,30,21,20,10,2607,187,427,253,216,206,278,0,333,0,0,0,110,191,'undead_clan',300,1,0,'LAST_HIT'),
	(21617,21617,'Fiend Archer',0,'',0,'Monster.fiend_archer',17.00,55.00,48,'male','L2Monster',500,2091,768,8.69,2.14,40,43,30,21,20,10,4103,300,1007,222,231,212,249,150,333,0,0,0,77,191,NULL,0,0,4,'LAST_HIT'),
	(21618,21618,'Fiend Archer',0,'',0,'Monster.fiend_archer',17.00,55.00,48,'male','L2Monster',500,2091,768,8.69,2.14,40,43,30,21,20,10,5811,425,1341,167,231,212,249,150,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(21619,21619,'Pit Archer',0,'',0,'Monster.fiend_archer_20_bi',20.00,66.00,48,'male','L2Monster',500,2091,768,34.76,2.14,40,43,30,21,20,10,2651,193,1007,222,231,212,249,150,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(21620,21620,'Musveren',0,'',0,'Monster.field_stalker',15.00,30.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,3951,292,480,270,247,219,278,0,333,0,0,0,77,191,NULL,0,0,4,'LAST_HIT'),
	(21621,21621,'Musveren',0,'',0,'Monster.field_stalker',15.00,30.00,49,'male','L2Monster',40,2168,799,8.69,2.14,40,43,30,21,20,10,5595,414,640,202,247,219,278,0,333,0,0,0,77,191,NULL,0,0,4,'LAST_HIT'),
	(21622,21622,'Greater Musveren',0,'',0,'Monster.field_stalker_20_bi',18.00,36.00,49,'male','L2Monster',40,2168,799,34.76,2.14,40,43,30,21,20,10,2553,188,480,270,247,219,278,0,333,0,0,0,77,191,NULL,0,0,0,'LAST_HIT'),
	(21623,21623,'Zaken''s Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,4994,376,445,278,264,226,317,150,333,225,945,0,88,191,'undead_clan',300,1,5,'LAST_HIT'),
	(21624,21624,'Zaken''s Guard',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,7072,533,593,209,264,226,317,150,333,225,945,0,88,191,'undead_clan',300,1,5,'LAST_HIT'),
	(21625,21625,'Zaken''s Elite Guard',0,'',0,'Monster.skeleton_royal_guard_20_bi',13.00,34.50,50,'male','L2Monster',40,2245,830,34.76,2.14,40,43,30,21,20,10,2858,215,445,278,264,226,317,150,333,225,945,0,88,191,'undead_clan',300,1,0,'LAST_HIT'),
	(21626,21626,'Kaim Vanul',0,'',0,'Monster.kaim_vanul',24.00,40.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,4453,340,539,286,281,232,278,0,333,0,0,0,40,191,'demonic_clan',300,0,5,'LAST_HIT'),
	(21627,21627,'Kaim Vanul',0,'',0,'Monster.kaim_vanul',24.00,40.00,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,6306,481,718,215,281,232,278,0,333,0,0,0,40,191,'demonic_clan',300,0,5,'LAST_HIT'),
	(21628,21628,'Kaim Vanul Lad',0,'',0,'Monster.kaim_vanul_20_bi',28.00,48.00,51,'male','L2Monster',40,2323,861,41.08,2.45,40,43,30,21,20,10,2877,219,539,286,281,232,278,0,333,0,0,0,40,191,'demonic_clan',300,0,0,'LAST_HIT'),
	(21629,21629,'Pirate Zombie Captain',0,'',0,'Monster.pirates_zombie_captain',17.00,28.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,6727,520,499,295,300,239,317,150,333,232,0,0,15,191,'zaken_clan',300,1,5,'LAST_HIT'),
	(21630,21630,'Pirate Zombie Captain',0,'',0,'Monster.pirates_zombie_captain',17.00,28.00,52,'male','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,9526,737,664,221,300,239,317,150,333,232,0,0,15,191,'zaken_clan',300,1,5,'LAST_HIT'),
	(21631,21631,'Zombie Captain''s Spiritual Body',0,'',0,'Monster.pirates_zombie_captain_20_bi',20.00,33.60,52,'male','L2Monster',40,2402,892,41.08,2.45,40,43,30,21,20,10,3948,305,499,295,300,239,317,150,333,232,0,0,15,191,'zaken_clan',300,1,0,'LAST_HIT'),
	(21632,21632,'Doll Blader',0,'',0,'Monster.doll_blader',6.00,12.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,5339,420,527,258,319,247,317,0,333,5129,5129,0,24,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(21633,21633,'Doll Blader',0,'',0,'Monster.doll_blader',6.00,12.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,7560,594,701,194,319,247,317,0,333,5129,5129,0,24,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(21634,21634,'Crimson Doll Blader',0,'',0,'Monster.doll_blader_20_bi',7.00,15.00,53,'male','L2Monster',40,2481,923,41.08,2.45,40,43,30,21,20,10,3450,271,527,258,319,247,317,0,333,5129,5129,0,24,191,'zaken_clan',300,0,0,'LAST_HIT'),
	(21635,21635,'Vale Master',0,'',0,'Monster.vale_master',12.00,40.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,5093,406,636,266,339,254,278,150,333,0,0,0,77,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(21636,21636,'Vale Master',0,'',0,'Monster.vale_master',12.00,40.00,54,'male','L2Monster',40,2562,955,10.27,2.45,40,43,30,21,20,10,7212,575,846,199,339,254,278,150,333,0,0,0,77,191,'zaken_clan',300,0,6,'LAST_HIT'),
	(21637,21637,'Crimson Vale Master',0,'',0,'Monster.vale_master_20_bi',14.50,48.00,54,'male','L2Monster',40,2562,955,41.08,2.45,40,43,30,21,20,10,3291,262,636,266,339,254,278,150,333,0,0,0,77,191,'zaken_clan',300,0,0,'LAST_HIT'),
	(21638,21638,'Dread Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,35,'male','L2Monster',40,1220,446,3.56,1.84,40,43,30,21,20,10,2303,136,211,154,89,137,278,150,333,0,0,0,26,154,NULL,0,0,0,'LAST_HIT'),
	(21639,21639,'Tasaba Lizardman',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,36,'male','L2Monster',500,1279,463,3.56,1.84,40,43,30,21,20,10,2725,164,417,193,96,142,249,0,333,2507,0,0,47,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21640,21640,'Tasaba Lizardman Shaman ',0,'',0,'Monster.virud_lizardman_shaman',10.00,29.00,37,'male','L2Monster',40,1338,480,3.56,1.84,40,43,30,21,20,10,2003,124,295,116,104,147,278,0,333,7,0,0,47,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21641,21641,'Ogre',0,'',0,'Monster.ogre',21.00,44.00,38,'male','L2Monster',40,1400,497,3.56,1.84,40,43,30,21,20,10,3555,222,300,207,112,153,200,150,333,98,0,0,24,191,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21642,21642,'Tasaba Lizardman Sniper',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,39,'male','L2Monster',500,1462,514,3.56,1.84,40,43,30,21,20,10,3263,208,566,165,121,158,249,150,333,2507,0,0,47,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21643,21643,'Tasaba Lizardman Sniper',0,'',0,'Monster.virud_lizardman_scout',10.00,22.00,39,'male','L2Monster',500,1462,514,3.56,1.84,40,43,30,21,20,10,4146,264,685,137,121,158,249,150,333,2507,0,0,47,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(21644,21644,'Lienrik',0,'',0,'Monster.lienrik',12.00,50.00,39,'male','L2Monster',40,1462,514,3.56,1.84,40,43,30,21,20,10,1990,126,297,146,121,158,317,0,333,0,0,0,110,165,'lienrik_clan',300,0,0,'LAST_HIT'),
	(21645,21645,'Lienrik Lad',0,'',0,'Monster.lienrik',12.00,50.00,40,'male','L2Monster',40,1527,531,3.56,1.84,40,43,30,21,20,10,3836,248,317,151,131,164,317,150,333,0,0,0,110,191,'lienrik_clan',300,0,0,'LAST_HIT'),
	(21646,21646,'Grave Scarab',0,'',0,'Monster2.scarab',14.00,22.00,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,10206,1050,1463,502,885,407,278,0,333,0,0,0,49,198,NULL,0,0,0,'LAST_HIT'),
	(21647,21647,'Scavenger Scarab',0,'',0,'Monster2.scarab',14.00,22.00,73,'male','L2Monster',40,4086,1601,13.43,3.09,40,43,30,21,20,10,8609,886,1463,502,885,407,278,150,333,0,0,0,49,198,NULL,0,0,0,'LAST_HIT'),
	(21648,21648,'Grave Ant',0,'',0,'Monster.ant_soldier',35.00,17.00,74,'male','L2Monster',40,4158,1637,13.43,3.09,40,43,30,21,20,10,9383,978,1513,512,921,416,278,0,333,0,0,0,88,165,NULL,0,0,0,'LAST_HIT'),
	(21649,21649,'Scavenger Ant',0,'',0,'Monster.ant_soldier',35.00,17.00,74,'male','L2Monster',40,4158,1637,13.43,3.09,40,43,30,21,20,10,11099,1157,1513,512,921,416,278,150,333,0,0,0,88,165,NULL,0,0,0,'LAST_HIT'),
	(21650,21650,'Shrine Knight',0,'',0,'Monster.skeleton_knight',10.00,25.00,75,'male','L2Monster',40,4229,1673,13.43,3.09,40,43,30,21,20,10,10149,1071,1563,523,957,425,278,0,333,150,103,0,44,181,NULL,0,1,0,'LAST_HIT'),
	(21651,21651,'Shrine Guard',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,75,'male','L2Monster',40,4229,1673,13.43,3.09,40,43,30,21,20,10,9695,1023,1563,523,957,425,278,0,333,98,0,0,55,187,NULL,0,1,0,'LAST_HIT'),
	(21652,21652,'Scarlet Stakato Noble',0,'',0,'Monster.blade_stakato_drone',15.00,39.00,79,'male','L2Monster',40,4490,1821,67.15,3.09,40,43,30,21,20,10,9382,1039,1544,566,1107,459,317,150,333,235,0,0,27,181,'fire_clan',300,0,0,'LAST_HIT'),
	(21653,21653,'Assassin Beetle',0,'',0,'Monster2.tera_beetle',19.00,54.50,80,'male','L2Monster',40,4550,1859,67.15,3.09,40,43,30,21,20,10,6804,763,1814,576,1144,468,278,150,333,0,0,0,49,181,'fire_clan',300,0,0,'LAST_HIT'),
	(21654,21654,'Necromancer of Destruction',0,'',0,'Monster.vale_master_20_bi',14.50,48.00,80,'male','L2Monster',40,4608,1896,67.15,3.09,40,43,30,21,20,10,8042,913,1863,587,1182,477,278,150,333,0,0,0,77,154,'fire_clan',300,0,0,'LAST_HIT'),
	(21655,21655,'Arimanes of Destruction',0,'',0,'Monster2.ahrimanes',14.00,57.75,80,'male','L2Monster',40,4663,1934,67.15,3.09,40,43,30,21,20,10,7148,821,2655,598,1220,485,200,150,333,6722,0,0,38,203,'fire_clan',300,0,0,'LAST_HIT'),
	(21656,21656,'Ashuras of Destruction',0,'',0,'Monster2.ashuras_30_bi',17.00,49.00,80,'male','L2Monster',40,4766,2011,80.58,3.09,40,43,30,21,20,10,10463,1230,2006,619,1296,502,278,150,333,0,0,0,45,209,'fire_clan',300,0,0,'LAST_HIT'),
	(21657,21657,'Magma Drake',0,'',0,'Monster2.inferno_drake_20_bi',29.00,42.00,80,'male','L2Monster',40,4813,2049,80.58,3.09,40,43,30,21,20,10,9062,1078,2052,629,1333,511,278,150,333,0,0,0,62,203,'fire_clan',300,0,0,'LAST_HIT'),
	(21658,21658,'Punishment of Splendor',0,'',0,'Monster.kel_mahum_warrior',13.00,28.00,64,'male','L2Monster',40,3384,1285,11.85,2.78,40,43,30,21,20,10,8837,809,1031,408,589,331,278,0,333,242,0,0,55,181,'saint_clan',300,0,0,'LAST_HIT'),
	(21659,21659,'Otherworldly Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,30,'male','L2RiftInvader',40,954,365,16.59,1.53,40,43,30,21,20,10,1457,79,115,119,58,114,317,0,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21660,21660,'Otherworldly Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,35,'male','L2RiftInvader',40,1220,446,21.33,1.84,40,43,30,21,20,10,2073,122,126,191,89,137,317,150,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21661,21661,'Otherworldly Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,33,'male','L2RiftInvader',500,1109,413,21.33,1.84,40,43,30,21,20,10,1492,85,491,100,75,128,249,150,333,275,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21662,21662,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.dark_horror',20.00,35.00,35,'male','L2RiftInvader',40,1220,446,21.33,1.84,40,43,30,21,20,10,1726,102,192,144,89,137,278,150,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21663,21663,'Otherworldly Invader Shaman',0,'',0,'Monster.dark_horror',20.00,35.00,33,'male','L2RiftInvader',40,1109,413,21.33,1.84,40,43,30,21,20,10,1884,108,166,134,75,128,278,150,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21664,21664,'Otherworldly Invader Priest',0,'',0,'Monster.dark_horror',20.00,35.00,30,'male','L2RiftInvader',40,954,365,11.06,1.53,40,43,30,21,20,10,1511,82,132,119,58,114,278,0,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21665,21665,'Otherworldly Invader Magus',0,'',0,'Monster.dark_horror',20.00,35.00,35,'male','L2RiftInvader',40,1220,446,21.33,1.84,40,43,30,21,20,10,1362,80,256,108,89,137,278,150,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21666,21666,'Otherworldly Invader Martyrs',0,'',0,'Monster.dark_horror',20.00,35.00,30,'male','L2RiftInvader',40,954,365,16.59,1.53,40,43,30,21,20,10,1018,55,132,119,58,114,278,0,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21667,21667,'Otherworldly Invader Warrior',0,'',0,'Monster.skeleton',11.00,25.00,33,'male','L2RiftInvader',40,1109,413,21.33,1.84,40,43,30,21,20,10,1211,69,145,157,75,128,317,150,333,220,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21668,21668,'Otherworldly Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,30,'male','L2RiftInvader',40,954,365,16.59,1.53,40,43,30,21,20,10,1071,58,115,119,58,114,317,150,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21669,21669,'Otherworldly Invader Discipline',0,'',0,'Monster.skeleton',11.00,25.00,33,'male','L2RiftInvader',40,1109,413,21.33,1.84,40,43,30,21,20,10,1275,73,145,157,75,128,317,0,333,220,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21670,21670,'Otherworldly Invader Berserker',0,'',0,'Monster.skeleton',11.00,25.00,35,'male','L2RiftInvader',40,1220,446,21.33,1.84,40,43,30,21,20,10,1785,105,139,205,89,137,317,150,333,220,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21671,21671,'Otherworldly Invader Food',0,'',0,'Monster.mimic',8.50,8.50,30,'male','L2Chest',40,954,365,5.53,1.53,40,43,30,21,20,10,1308,72,132,140,58,114,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21672,21672,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,35,'male','L2RiftInvader',40,1220,446,42.66,1.84,40,43,30,21,20,10,1599,94,192,169,89,137,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21673,21673,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,35,'male','L2RiftInvader',40,1220,446,42.66,1.84,40,43,30,21,20,10,1629,96,192,169,89,137,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21674,21674,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,35,'male','L2RiftInvader',40,1220,446,1.78,1.84,40,43,30,21,20,10,1525,92,192,169,89,137,278,0,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21675,21675,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,30,'male','L2RiftInvader',40,954,365,2.77,1.53,40,43,30,21,20,10,1555,84,132,140,58,114,278,0,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21676,21676,'Otherworldly Invader Warrior',0,'',0,'Monster.skeleton',11.00,25.00,33,'male','L2RiftInvader',40,1109,413,42.66,1.84,40,43,30,21,20,10,1452,83,145,157,75,128,317,150,333,220,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21677,21677,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,30,'male','L2RiftInvader',40,954,365,33.18,1.53,40,43,30,21,20,10,1164,63,109,170,58,114,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21678,21678,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,33,'male','L2RiftInvader',40,1109,413,42.66,1.84,40,43,30,21,20,10,1409,80,201,130,75,128,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21679,21679,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,30,'male','L2RiftInvader',40,954,365,33.18,1.53,40,43,30,21,20,10,1148,62,109,170,58,114,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21680,21680,'Otherworldly Invader Elite Soldier',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,35,'male','L2RiftInvader',40,1220,446,42.66,1.84,40,43,30,21,20,10,1562,92,232,140,89,137,278,150,333,96,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21681,21681,'Otherworldly Invader Magus',0,'',0,'Monster.dark_horror',20.00,35.00,33,'male','L2RiftInvader',40,1109,413,42.66,1.84,40,43,30,21,20,10,1343,77,166,157,75,128,278,0,333,0,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21682,21682,'Dimension Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,40,'male','L2RiftInvader',40,1527,531,21.33,1.84,40,43,30,21,20,10,2590,167,238,171,131,164,317,0,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21683,21683,'Dimension Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,45,'male','L2RiftInvader',40,1870,677,26.07,2.14,40,43,30,21,20,10,3427,238,248,269,188,193,317,150,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21684,21684,'Dimension Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,43,'male','L2RiftInvader',500,1728,618,26.07,2.14,40,43,30,21,20,10,2534,171,984,142,163,181,249,150,333,279,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21685,21685,'Dimension Invader Elite Soldier',0,'',0,'Monster.crimson_doll',15.00,38.00,45,'male','L2RiftInvader',40,1870,677,26.07,2.14,40,43,30,21,20,10,2853,198,377,202,188,193,278,150,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21686,21686,'Dimension Invader Shaman',0,'',0,'Monster.crimson_doll',15.00,38.00,43,'male','L2RiftInvader',40,1728,618,26.07,2.14,40,43,30,21,20,10,3199,216,332,189,163,181,278,150,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21687,21687,'Dimension Invader Priest',0,'',0,'Monster.crimson_doll',15.00,38.00,40,'male','L2RiftInvader',40,1527,531,14.22,1.84,40,43,30,21,20,10,2686,173,273,171,131,164,278,0,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21688,21688,'Dimension Invader Magus',0,'',0,'Monster.crimson_doll',15.00,38.00,45,'male','L2RiftInvader',40,1870,677,26.07,2.14,40,43,30,21,20,10,2253,156,502,152,188,193,278,150,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21689,21689,'Dimension Invader Martyrs',0,'',0,'Monster.crimson_doll',15.00,38.00,40,'male','L2RiftInvader',40,1527,531,21.33,1.84,40,43,30,21,20,10,1809,117,273,171,131,164,278,0,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21690,21690,'Dimension Invader Warrior',0,'',0,'Monster.skeleton_knight',10.00,25.00,43,'male','L2RiftInvader',40,1728,618,26.07,2.14,40,43,30,21,20,10,2057,139,332,223,163,181,278,150,333,70,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21691,21691,'Dimension Invader Soldier',0,'',0,'Monster.neer_crawler',14.00,22.00,40,'male','L2RiftInvader',40,1527,531,21.33,1.84,40,43,30,21,20,10,1905,123,238,171,131,164,317,150,333,0,0,0,55,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21692,21692,'Dimension Invader Discipline',0,'',0,'Monster.skeleton_knight',10.00,25.00,43,'male','L2RiftInvader',40,1728,618,26.07,2.14,40,43,30,21,20,10,2166,146,332,223,163,181,278,0,333,70,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21693,21693,'Dimension Invader Berserker ',0,'',0,'Monster.skeleton_knight',10.00,25.00,45,'male','L2RiftInvader',40,1870,677,26.07,2.14,40,43,30,21,20,10,2951,205,312,288,188,193,278,150,333,70,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21694,21694,'Dimension Invader Food',0,'',0,'Monster.mimic',8.50,8.50,40,'male','L2Chest',40,1527,531,7.11,1.84,40,43,30,21,20,10,2327,150,273,201,131,164,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21695,21695,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,45,'male','L2RiftInvader',40,1870,677,52.14,2.14,40,43,30,21,20,10,2643,183,377,238,188,193,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21696,21696,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,45,'male','L2RiftInvader',40,1870,677,52.14,2.14,40,43,30,21,20,10,2693,187,377,238,188,193,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21697,21697,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,45,'male','L2RiftInvader',40,1870,677,2.17,2.14,40,43,30,21,20,10,2521,176,377,238,188,193,278,0,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21698,21698,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,40,'male','L2RiftInvader',40,1527,531,3.56,1.84,40,43,30,21,20,10,2764,178,273,201,131,164,278,0,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21699,21699,'Dimension Invader Warrior',0,'',0,'Monster.skeleton_knight',10.00,25.00,43,'male','L2RiftInvader',40,1728,618,52.14,2.14,40,43,30,21,20,10,2466,166,332,223,163,181,278,150,333,70,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21700,21700,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,40,'male','L2RiftInvader',40,1527,531,42.66,1.84,40,43,30,21,20,10,2070,133,225,244,131,164,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21701,21701,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,43,'male','L2RiftInvader',40,1728,618,52.14,2.14,40,43,30,21,20,10,2392,161,402,184,163,181,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21702,21702,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,40,'male','L2RiftInvader',40,1527,531,42.66,1.84,40,43,30,21,20,10,2041,131,225,244,131,164,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21703,21703,'Dimension Invader Elite Soldier',0,'',0,'Monster.headless_knight',21.00,31.00,45,'male','L2RiftInvader',40,1870,677,52.14,2.14,40,43,30,21,20,10,2583,179,457,196,188,193,278,150,333,135,0,0,77,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21704,21704,'Dimension Invader Magus',0,'',0,'Monster.crimson_doll',15.00,38.00,43,'male','L2RiftInvader',40,1728,618,52.14,2.14,40,43,30,21,20,10,2281,154,332,223,163,181,278,0,333,0,0,0,66,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21705,21705,'Purgatory Invader Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,50,'male','L2RiftInvader',40,2245,830,26.07,2.14,40,43,30,21,20,10,4047,305,445,236,264,226,317,0,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21706,21706,'Purgatory Invader Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,55,'male','L2RiftInvader',40,2643,987,30.81,2.45,40,43,30,21,20,10,5120,413,440,364,360,261,317,150,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21707,21707,'Purgatory Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,53,'male','L2RiftInvader',500,2481,923,30.81,2.45,40,43,30,21,20,10,3850,302,1782,194,319,247,249,150,333,282,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21708,21708,'Purgatory Invader Elite Soldier',0,'',0,'Monster.banshee',9.00,23.00,55,'female','L2RiftInvader',40,2643,987,30.81,2.45,40,43,30,21,20,10,4262,344,670,273,360,261,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21709,21709,'Purgatory Invader Shaman',0,'',0,'Monster.banshee',9.00,23.00,53,'female','L2RiftInvader',40,2481,923,30.81,2.45,40,43,30,21,20,10,4861,382,602,258,319,247,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21710,21710,'Purgatory Invader Priest',0,'',0,'Monster.banshee',9.00,23.00,50,'female','L2RiftInvader',40,2245,830,17.38,2.14,40,43,30,21,20,10,4198,316,509,236,264,226,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21711,21711,'Purgatory Invader Magus',0,'',0,'Monster.banshee',9.00,23.00,55,'female','L2RiftInvader',40,2643,987,30.81,2.45,40,43,30,21,20,10,3365,271,892,205,360,261,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21712,21712,'Purgatory Invader Martyrs',0,'',0,'Monster.banshee',9.00,23.00,50,'female','L2RiftInvader',40,2245,830,26.07,2.14,40,43,30,21,20,10,2828,213,509,236,264,226,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21713,21713,'Purgatory Invader Warrior',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,53,'male','L2RiftInvader',40,2481,923,30.81,2.45,40,43,30,21,20,10,3125,245,527,304,319,247,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21714,21714,'Purgatory Invader Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,50,'male','L2RiftInvader',40,2245,830,26.07,2.14,40,43,30,21,20,10,2977,224,445,236,264,226,317,150,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21715,21715,'Purgatory Invader Disciples',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,53,'male','L2RiftInvader',40,2481,923,30.81,2.45,40,43,30,21,20,10,3291,258,527,304,319,247,317,0,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21716,21716,'Purgatory Invader Berserker',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,55,'male','L2RiftInvader',40,2643,987,30.81,2.45,40,43,30,21,20,10,4409,356,484,389,360,261,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21717,21717,'Purgatory Invader Food',0,'',0,'Monster.mimic',8.50,8.50,50,'male','L2Chest',40,2245,830,8.69,2.14,40,43,30,21,20,10,3636,274,509,278,264,226,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21718,21718,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,55,'female','L2RiftInvader',40,2643,987,61.62,2.45,40,43,30,21,20,10,3949,318,670,322,360,261,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21719,21719,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,55,'female','L2RiftInvader',40,2643,987,61.62,2.45,40,43,30,21,20,10,4023,324,670,322,360,261,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21720,21720,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,55,'female','L2RiftInvader',40,2643,987,2.57,2.45,40,43,30,21,20,10,3766,304,670,322,360,261,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21721,21721,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,50,'female','L2RiftInvader',40,2245,830,4.35,2.14,40,43,30,21,20,10,4319,326,509,278,264,226,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21722,21722,'Purgatory Invader Warrior',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,53,'male','L2RiftInvader',40,2481,923,61.62,2.45,40,43,30,21,20,10,3746,294,527,304,319,247,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21723,21723,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,50,'female','L2RiftInvader',40,2245,830,52.14,2.14,40,43,30,21,20,10,3235,243,421,336,264,226,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21724,21724,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,53,'female','L2RiftInvader',40,2481,923,61.62,2.45,40,43,30,21,20,10,3635,285,729,251,319,247,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21725,21725,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,50,'female','L2RiftInvader',40,2245,830,52.14,2.14,40,43,30,21,20,10,3189,240,421,336,264,226,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21726,21726,'Purgatory Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,55,'female','L2RiftInvader',40,2643,987,61.62,2.45,40,43,30,21,20,10,3859,311,811,266,360,261,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21727,21727,'Purgatory Invader Magus',0,'',0,'Monster.banshee',9.00,23.00,53,'female','L2RiftInvader',40,2481,923,61.62,2.45,40,43,30,21,20,10,3465,272,602,258,319,247,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21728,21728,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,60,'male','L2RiftInvader',40,3054,1150,30.81,2.45,40,43,30,21,20,10,5828,506,753,313,478,299,317,0,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21729,21729,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,65,'male','L2RiftInvader',40,3465,1319,35.55,2.78,40,43,30,21,20,10,7151,664,708,473,619,340,317,150,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21730,21730,'Forbidden Path Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,63,'male','L2RiftInvader',500,3302,1251,35.55,2.78,40,43,30,21,20,10,5439,491,2920,254,560,323,249,150,333,284,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21731,21731,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.banshee',9.00,23.00,65,'female','L2RiftInvader',40,3465,1319,35.55,2.78,40,43,30,21,20,10,5952,553,1077,355,619,340,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21732,21732,'Forbidden Path Invader Shaman',0,'',0,'Monster.banshee',9.00,23.00,63,'female','L2RiftInvader',40,3302,1251,35.55,2.78,40,43,30,21,20,10,6868,620,987,338,560,323,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21733,21733,'Forbidden Path Invader Priest',0,'',0,'Monster.banshee',9.00,23.00,60,'female','L2RiftInvader',40,3054,1150,20.54,2.45,40,43,30,21,20,10,6045,525,860,313,478,299,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21734,21734,'Forbidden Path Invader Magus',0,'',0,'Monster.banshee',9.00,23.00,65,'female','L2RiftInvader',40,3465,1319,35.55,2.78,40,43,30,21,20,10,4700,436,1433,267,619,340,278,150,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21735,21735,'Forbidden Path Invader Martyrs',0,'',0,'Monster.banshee',9.00,23.00,60,'female','L2RiftInvader',40,3054,1150,30.81,2.45,40,43,30,21,20,10,4072,353,860,313,478,299,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21736,21736,'Forbidden Path Invader Warrior',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,63,'male','L2RiftInvader',40,3302,1251,35.55,2.78,40,43,30,21,20,10,4415,398,864,398,560,323,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21737,21737,'Forbidden Path Invader Soldier',0,'',0,'Monster.doll_blader',6.00,12.00,60,'male','L2RiftInvader',40,3054,1150,30.81,2.45,40,43,30,21,20,10,4287,372,753,313,478,299,317,150,333,5129,5129,0,24,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21738,21738,'Forbidden Path Invader Disciple',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,63,'male','L2RiftInvader',40,3302,1251,35.55,2.78,40,43,30,21,20,10,4650,419,864,398,560,323,317,0,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21739,21739,'Forbidden Path Invader Berserker',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,65,'male','L2RiftInvader',40,3465,1319,35.55,2.78,40,43,30,21,20,10,6158,572,778,506,619,340,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21740,21740,'Forbidden Path Invader Food',0,'',0,'Monster.mimic',8.50,8.50,60,'male','L2Chest',40,3054,1150,10.27,2.45,40,43,30,21,20,10,5235,454,860,368,478,299,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21741,21741,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,65,'female','L2RiftInvader',40,3465,1319,71.10,2.78,40,43,30,21,20,10,5515,512,1077,418,619,340,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21742,21742,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,65,'female','L2RiftInvader',40,3465,1319,71.10,2.78,40,43,30,21,20,10,5620,522,1077,418,619,340,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21743,21743,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,65,'female','L2RiftInvader',40,3465,1319,2.96,2.78,40,43,30,21,20,10,5259,488,1077,418,619,340,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21744,21744,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2RiftInvader',40,3054,1150,5.14,2.45,40,43,30,21,20,10,6220,540,860,368,478,299,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21745,21745,'Forbidden Path Invader Warrior',0,'',0,'Monster.skeleton_royal_guard',11.00,28.50,63,'male','L2RiftInvader',40,3302,1251,71.10,2.78,40,43,30,21,20,10,5294,478,864,398,560,323,317,150,333,946,946,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21746,21746,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2RiftInvader',40,3054,1150,61.62,2.45,40,43,30,21,20,10,4658,404,711,446,478,299,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21747,21747,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,63,'female','L2RiftInvader',40,3302,1251,71.10,2.78,40,43,30,21,20,10,5136,463,1194,329,560,323,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21748,21748,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,60,'female','L2RiftInvader',40,3054,1150,61.62,2.45,40,43,30,21,20,10,4592,398,711,446,478,299,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21749,21749,'Forbidden Path Invader Elite Soldier',0,'',0,'Monster.bloody_queen',14.00,40.00,65,'female','L2RiftInvader',40,3465,1319,71.10,2.78,40,43,30,21,20,10,5390,500,1303,346,619,340,278,150,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21750,21750,'Forbidden Path Invader Magus',0,'',0,'Monster.banshee',9.00,23.00,63,'female','L2RiftInvader',40,3302,1251,71.10,2.78,40,43,30,21,20,10,4897,442,987,338,560,323,278,0,333,3939,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21751,21751,'Dark Omen Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,70,'male','L2RiftInvader',40,3862,1493,35.55,2.78,40,43,30,21,20,10,7933,786,1314,470,780,382,278,0,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21752,21752,'Dark Omen Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,75,'male','L2RiftInvader',40,4229,1673,40.29,3.09,40,43,30,21,20,10,9521,1004,1175,696,957,425,278,150,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21753,21753,'Dark Omen Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,73,'male','L2RiftInvader',500,4086,1601,40.29,3.09,40,43,30,21,20,10,7303,751,4327,320,885,407,249,150,333,288,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21754,21754,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.doll_master',20.00,42.00,75,'male','L2RiftInvader',40,4229,1673,40.29,3.09,40,43,30,21,20,10,7925,836,1368,445,957,425,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21755,21755,'Dark Omen Invader Shaman',0,'',0,'Monster.doll_master',20.00,42.00,73,'male','L2RiftInvader',40,4086,1601,40.29,3.09,40,43,30,21,20,10,9222,949,1280,426,885,407,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21756,21756,'Dark Omen Invader Priest',0,'',0,'Monster.doll_master',20.00,42.00,70,'male','L2RiftInvader',40,3862,1493,23.70,2.78,40,43,30,21,20,10,8228,816,1150,399,780,382,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21757,21757,'Dark Omen Invader Magus',0,'',0,'Monster.doll_master',20.00,42.00,75,'male','L2RiftInvader',40,4229,1673,40.29,3.09,40,43,30,21,20,10,6258,660,1821,334,957,425,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21758,21758,'Dark Omen Invader Martyrs',0,'',0,'Monster.doll_master',20.00,42.00,70,'male','L2RiftInvader',40,3862,1493,35.55,2.78,40,43,30,21,20,10,5542,549,1150,399,780,382,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21759,21759,'Dark Omen Invader Warrior',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,73,'male','L2RiftInvader',40,4086,1601,40.29,3.09,40,43,30,21,20,10,5929,610,1463,502,885,407,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21760,21760,'Dark Omen Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,70,'male','L2RiftInvader',40,3862,1493,35.55,2.78,40,43,30,21,20,10,5835,578,1314,470,780,382,278,150,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21761,21761,'Dark Omen Invader Disciple',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,73,'male','L2RiftInvader',40,4086,1601,40.29,3.09,40,43,30,21,20,10,6243,642,1463,502,885,407,278,0,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21762,21762,'Dark Omen Invader Berserker',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,75,'male','L2RiftInvader',40,4229,1673,40.29,3.09,40,43,30,21,20,10,8198,864,1292,633,957,425,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21763,21763,'Dark Omen Invader Food',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Chest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,7126,707,1314,470,780,382,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21764,21764,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,75,'male','L2RiftInvader',40,4229,1673,80.58,3.09,40,43,30,21,20,10,7343,774,1563,523,957,425,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21765,21765,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,75,'male','L2RiftInvader',40,4229,1673,80.58,3.09,40,43,30,21,20,10,7482,789,1563,523,957,425,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21766,21766,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,75,'male','L2RiftInvader',40,4229,1673,3.36,3.09,40,43,30,21,20,10,7002,740,1563,523,957,425,278,0,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21767,21767,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,70,'male','L2RiftInvader',40,3862,1493,5.93,2.78,40,43,30,21,20,10,8466,840,1314,470,780,382,278,0,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21768,21768,'Dark Omen Invader Warrior',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,73,'male','L2RiftInvader',40,4086,1601,80.58,3.09,40,43,30,21,20,10,7108,731,1463,502,885,407,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21769,21769,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,70,'male','L2RiftInvader',40,3862,1493,71.10,2.78,40,43,30,21,20,10,6341,628,1086,569,780,382,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21770,21770,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,73,'male','L2RiftInvader',40,4086,1601,80.58,3.09,40,43,30,21,20,10,6896,709,1770,415,885,407,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21771,21771,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,70,'male','L2RiftInvader',40,3862,1493,71.10,2.78,40,43,30,21,20,10,6251,619,1086,569,780,382,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21772,21772,'Dark Omen Invader Elite Soldier',0,'',0,'Monster.death_blader',15.00,45.00,75,'male','L2RiftInvader',40,4229,1673,80.58,3.09,40,43,30,21,20,10,7176,757,1892,432,957,425,278,150,333,1472,0,0,110,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21773,21773,'Dark Omen Invader Magus',0,'',0,'Monster.doll_master',20.00,42.00,73,'male','L2RiftInvader',40,4086,1601,80.58,3.09,40,43,30,21,20,10,6575,676,1280,426,885,407,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21774,21774,'Messenger Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,80,'male','L2RiftInvader',40,4550,1859,40.29,3.09,40,43,30,21,20,10,10362,1163,1814,576,1144,468,278,0,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21775,21775,'Messenger Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,80,'male','L2RiftInvader',40,4813,2049,40.29,3.09,40,43,30,21,20,10,12230,1455,1542,837,1333,511,278,150,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21776,21776,'Messenger Invader Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,80,'male','L2RiftInvader',500,4716,1972,40.29,3.09,40,43,30,21,20,10,9442,1097,5796,388,1258,494,249,150,333,289,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21777,21777,'Messenger Invader Elite Soldier',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4813,2049,40.29,3.09,40,43,30,21,20,10,10179,1211,1796,535,1333,511,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21778,21778,'Messenger Invader Shaman',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4716,1972,40.29,3.09,40,43,30,21,20,10,11921,1386,1714,517,1258,494,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21779,21779,'Messenger Invader Priest',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4550,1859,26.86,3.09,40,43,30,21,20,10,10747,1206,1587,490,1144,468,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21780,21780,'Messenger Invader Magus',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4813,2049,40.29,3.09,40,43,30,21,20,10,8038,957,2390,402,1333,511,317,150,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21781,21781,'Messenger Invader Martyrs',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4550,1859,40.29,3.09,40,43,30,21,20,10,7239,812,1587,490,1144,468,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21782,21782,'Messenger Invader Warrior',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2RiftInvader',40,4716,1972,40.29,3.09,40,43,30,21,20,10,7664,891,1959,608,1258,494,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21783,21783,'Messenger Invader Soldier',0,'',0,'Monster2.giant_zombie',13.00,40.00,80,'male','L2RiftInvader',40,4550,1859,40.29,3.09,40,43,30,21,20,10,7621,855,1814,576,1144,468,278,150,333,0,0,0,22,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21784,21784,'Messenger Invader Disciple',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2RiftInvader',40,4716,1972,40.29,3.09,40,43,30,21,20,10,8071,938,1959,608,1258,494,278,0,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21785,21785,'Messenger Invader Berserker',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2RiftInvader',40,4813,2049,40.29,3.09,40,43,30,21,20,10,10530,1253,1696,761,1333,511,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21786,21786,'Messenger Invader Food',0,'',0,'Monster.mimic',8.50,8.50,80,'male','L2Chest',40,4550,1859,13.43,3.09,40,43,30,21,20,10,9308,1045,1814,576,1144,468,278,0,333,0,0,0,88,181,'ssq_clan',300,0,0,'LAST_HIT'),
	(21787,21787,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4813,2049,80.58,3.09,40,43,30,21,20,10,9432,1122,2052,629,1333,511,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21788,21788,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4813,2049,80.58,3.09,40,43,30,21,20,10,9610,1144,2052,629,1333,511,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21789,21789,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4813,2049,3.36,3.09,40,43,30,21,20,10,8994,1072,2052,629,1333,511,278,0,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21790,21790,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4550,1859,6.72,3.09,40,43,30,21,20,10,11058,1242,1814,576,1144,468,278,0,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21791,21791,'Messenger Invader Warrior',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2RiftInvader',40,4716,1972,80.58,3.09,40,43,30,21,20,10,9189,1068,1959,608,1258,494,278,150,333,134,6721,0,42,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21792,21792,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4550,1859,80.58,3.09,40,43,30,21,20,10,8282,929,1499,698,1144,468,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21793,21793,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4716,1972,80.58,3.09,40,43,30,21,20,10,8915,1036,2371,503,1258,494,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21794,21794,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4550,1859,80.58,3.09,40,43,30,21,20,10,8165,916,1499,698,1144,468,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21795,21795,'Messenger Invader Elite Soldier',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2RiftInvader',40,4813,2049,80.58,3.09,40,43,30,21,20,10,9217,1097,2483,520,1333,511,278,150,333,78,0,0,44,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21796,21796,'Messenger Invader Magus',0,'',0,'Monster.doll_master',20.00,42.00,80,'male','L2RiftInvader',40,4716,1972,80.58,3.09,40,43,30,21,20,10,8499,988,1714,517,1258,494,317,0,333,0,0,0,88,181,'ssq_clan',300,1,0,'LAST_HIT'),
	(21797,21797,'Spirit of Timiniel',0,'',0,'Monster.pixy',5.00,25.00,55,'female','L2Monster',40,2643,987,5.14,2.45,40,43,30,21,20,10,3959,320,554,331,360,261,278,0,333,0,0,0,88,181,'timiniel_clan',300,0,0,'LAST_HIT'),
	(21798,21798,'Ghost of a Gatekeeper',0,'',0,'Monster.skeleton_knight',10.00,25.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,7104,759,1614,534,994,433,278,0,333,150,103,0,44,181,NULL,0,1,0,'LAST_HIT'),
	(21799,21799,'Ghost of a Gatekeeper',0,'',0,'Monster.skeleton_knight',10.00,25.00,76,'male','L2Monster',40,4297,1710,40.29,3.09,40,43,30,21,20,10,8710,931,1614,534,994,433,278,0,333,150,103,0,44,181,NULL,0,1,0,'LAST_HIT'),
	(21800,21800,'Vassal Ghost',0,'',0,'Monster.zombie',13.00,21.00,77,'male','L2Monster',40,4364,1747,26.86,3.09,40,43,30,21,20,10,6616,716,1664,544,1031,442,278,0,333,0,0,0,16,181,NULL,0,1,0,'LAST_HIT'),
	(21801,21801,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,21,'male','L2Chest',40,575,227,5.53,1.53,40,43,30,21,20,10,630,29,63,98,25,80,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21802,21802,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,24,'male','L2Chest',40,687,272,5.53,1.53,40,43,30,21,20,10,771,38,81,111,34,90,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21803,21803,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,27,'male','L2Chest',40,813,318,5.53,1.53,40,43,30,21,20,10,918,47,104,125,45,102,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21804,21804,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,30,'male','L2Chest',40,954,365,5.53,1.53,40,43,30,21,20,10,1080,59,132,140,58,114,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21805,21805,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,33,'male','L2Chest',40,1109,413,7.11,1.84,40,43,30,21,20,10,1306,75,166,157,75,128,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21806,21806,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,36,'male','L2Chest',40,1279,463,7.11,1.84,40,43,30,21,20,10,1555,94,206,175,96,142,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21807,21807,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,39,'male','L2Chest',40,1462,514,7.11,1.84,40,43,30,21,20,10,1825,116,255,195,121,158,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21808,21808,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,42,'male','L2Chest',40,1660,589,8.69,2.14,40,43,30,21,20,10,2116,141,311,215,152,175,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21809,21809,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,45,'male','L2Chest',40,1870,677,8.69,2.14,40,43,30,21,20,10,2430,169,377,238,188,193,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21810,21810,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,48,'male','L2Chest',40,2091,768,8.69,2.14,40,43,30,21,20,10,2764,202,453,261,231,212,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21811,21811,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,51,'male','L2Chest',40,2323,861,10.27,2.45,40,43,30,21,20,10,3121,238,539,286,281,232,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21812,21812,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,54,'male','L2Chest',40,2562,955,10.27,2.45,40,43,30,21,20,10,3499,279,636,313,339,254,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21813,21813,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,57,'male','L2Chest',40,2806,1052,10.27,2.45,40,43,30,21,20,10,3898,324,743,340,405,276,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21814,21814,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,60,'male','L2Chest',40,3054,1150,10.27,2.45,40,43,30,21,20,10,4320,375,860,368,478,299,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21815,21815,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,63,'male','L2Chest',40,3302,1251,11.85,2.78,40,43,30,21,20,10,4762,430,987,398,560,323,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21816,21816,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,66,'male','L2Chest',40,3546,1353,11.85,2.78,40,43,30,21,20,10,5227,492,1123,428,649,348,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21817,21817,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,69,'male','L2Chest',40,3784,1458,11.85,2.78,40,43,30,21,20,10,5713,559,1265,460,746,373,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21818,21818,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,72,'male','L2Chest',40,4013,1565,13.43,3.09,40,43,30,21,20,10,6220,632,1413,491,849,399,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21819,21819,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,75,'male','L2Chest',40,4229,1673,13.43,3.09,40,43,30,21,20,10,6750,712,1563,523,957,425,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21820,21820,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,78,'male','L2Chest',40,4428,1784,13.43,3.09,40,43,30,21,20,10,7300,799,1715,555,1069,451,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21821,21821,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,81,'male','L2Chest',40,4608,1896,13.43,3.09,40,43,30,21,20,10,7873,894,1863,587,1182,477,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21822,21822,'Treasure Chest',0,'',0,'Monster.mimic',8.50,8.50,84,'male','L2Chest',40,4766,2011,13.43,3.09,40,43,30,21,20,10,8467,996,2006,619,1296,502,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(21823,21823,'Executor of Sacrificial Offerings',0,'',0,'Monster2.imperial_warlord_zombie',7.00,30.00,80,'male','L2Monster',40,4550,1859,80.58,3.09,40,43,30,21,20,10,12042,1351,1814,576,1144,468,278,0,333,134,6721,0,42,209,'tomb_clan',300,1,0,'LAST_HIT'),
	(21824,21824,'Alpen Kookaburra',0,'',0,'Monster2.rough_ostrich',20.00,31.00,65,'male','L2FeedableBeast',80,13862,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), -- correct HP, other stats to be done
	(21825,21825,'Alpen Kookaburra',0,'',0,'Monster2.rough_ostrich',20.00,31.00,65,'male','L2FeedableBeast',80,13862,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), -- correct HP, other stats to be done
	(21826,21826,'Alpen Buffalo',0,'',0,'Monster2.buffalo',20.00,31.00,67,'male','L2FeedableBeast',80,14507,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), -- correct HP, other stats to be done
	(21827,21827,'Alpen Buffalo',0,'',0,'Monster2.buffalo',20.00,31.00,67,'male','L2FeedableBeast',80,14507,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), -- correct HP, other stats to be done
	(21828,21828,'Alpen Cougar',0,'',0,'Monster.saber_toothed_tiger',20.00,31.00,69,'male','L2FeedableBeast',80,15139,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), -- correct HP, other stats to be done
	(21829,21829,'Alpen Cougar',0,'',0,'Monster.saber_toothed_tiger',20.00,31.00,69,'male','L2FeedableBeast',80,15139,9999,13.43,3.09,40,43,30,21,20,10,0,0,1392,5000,746,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'); -- correct HP, other stats to be done

-- 
-- work in progress C5 stats - 22xxx mobs
-- 
-- HP, MP, level, aggro is from Korean L2 site (NOTE: ncsoft has changed skill IDs for HP mults)
-- SP, patk, pdef, matk, mdef are averages of existing clean data (based on level)
-- other values are defaults or based on known formulas
-- 
-- if you have questions/problems, ask HeXa in DP forums
-- 
INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(22001,22001,'Grim Wolf',0,'',0,'Monster.dire_wolf',13.00,11.00,25,'male','L2Monster',80,728,316,5.53,1.53,40,43,30,21,20,10,1199,60,99,112,37,94,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22002,22002,'Grim Grizzly',0,'',0,'Monster.grizzly',21.00,40.00,26,'male','L2Monster',80,770,333,5.53,1.53,40,43,30,21,20,10,879,44,115,114,41,98,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22003,22003,'Grave Robber Scout',0,'',0,'NPC.e_traderB_Fdwarf_mon',20.00,23.00,27,'male','L2Monster',80,814,350,5.53,1.53,40,43,30,21,20,10,1032,53,113,119,45,102,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22004,22004,'Grave Robber Lookout',0,'',0,'Monster.dwarf_ghost',9.00,16.50,27,'male','L2Monster',80,814,350,5.53,1.53,40,43,30,21,20,10,1032,53,113,119,45,102,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22005,22005,'Grave Robber Ranger',0,'',0,'NPC.e_collector_teacher_Fdwarf_mon',20.00,23.00,28,'male','L2Monster',80,859,367,5.53,1.53,40,43,30,21,20,10,1664,87,133,130,49,106,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22006,22006,'Grave Robber Guard',0,'',0,'NPC.e_collector_teacher_Mdwarf_mon',20.00,23.00,29,'male','L2Monster',80,906,384,5.53,1.53,40,43,30,21,20,10,1340,72,146,137,53,110,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22007,22007,'Ghost of a Soldier',0,'',0,'Monster.orc',10.00,21.00,29,'male','L2Monster',80,906,384,5.53,1.53,40,43,30,21,20,10,1340,72,146,137,53,110,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22008,22008,'Grave Robber Fighter',0,'',0,'NPC.e_collector_teacher_Mdwarf_mon',20.00,23.00,30,'male','L2Monster',80,954,402,5.53,1.53,40,43,30,21,20,10,1281,70,130,137,58,114,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22009,22009,'Ghost of a Loyal Vassal',0,'',0,'Monster.orc_shaman',9.00,22.00,31,'male','L2Monster',80,1005,419,7.11,1.84,40,43,30,21,20,10,1404,78,140,146,64,118,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22010,22010,'Ghost of a General',0,'',0,'Monster.orc_fighter',12.00,22.00,32,'male','L2Monster',80,1056,437,7.11,1.84,40,43,30,21,20,10,1449,81,185,147,69,123,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22011,22011,'Ghost of a Batur Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22012,22012,'Ghost of a Batur Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22013,22013,'Ghost of a Morek Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22014,22014,'Ghost of a Morek Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22015,22015,'Ghost of a Turka Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22016,22016,'Ghost of a Turka Chief',0,'',0,'Monster.orc_champion',10.00,23.00,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22017,22017,'Bandit Sweeper',0,'',0,'Monster2.northern_goblin',4.00,15.00,30,'male','L2Monster',80,954,402,5.53,1.53,40,43,30,21,20,10,1281,70,130,137,58,114,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22018,22018,'Bandit Hound',0,'',0,'Monster.dire_wolf',13.00,11.00,31,'male','L2Monster',80,1005,419,7.11,1.84,40,43,30,21,20,10,1404,78,140,146,64,118,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22019,22019,'Bandit Watchman',0,'',0,'Monster.ol_mahum_archer_04te',20.00,23.00,32,'male','L2Monster',80,1056,437,7.11,1.84,40,43,30,21,20,10,1449,81,185,147,69,123,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22020,22020,'Snow Lynx',0,'',0,'Monster.onyx_beast',14.00,14.50,33,'male','L2Monster',80,1109,455,7.11,1.84,40,43,30,21,20,10,1515,87,191,149,75,128,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22021,22021,'Bandit Undertaker',0,'',0,'Monster2.northern_goblin_110p',20.00,23.00,34,'male','L2Monster',80,1164,473,7.11,1.84,40,43,30,21,20,10,1593,93,203,150,82,132,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22022,22022,'Bandit Assassin',0,'',0,'Monster.wererat_01te',20.00,23.00,35,'male','L2Monster',80,1221,491,7.11,1.84,40,43,30,21,20,10,1735,103,199,161,89,137,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22023,22023,'Bandit Warrior',0,'',0,'Monster.ol_mahum_04te',20.00,23.00,36,'male','L2Monster',80,1279,509,7.11,1.84,40,43,30,21,20,10,1899,115,262,172,96,142,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22024,22024,'Bandit Inspector',0,'',0,'Monster2.northern_goblin_120p',4.00,15.00,37,'male','L2Monster',80,1339,528,7.11,1.84,40,43,30,21,20,10,1855,114,251,158,104,147,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22025,22025,'Frozen Wasteland Werewolf',0,'',0,'Monster.werewolf',10.00,26.00,38,'male','L2Monster',80,1400,547,7.11,1.84,40,43,30,21,20,10,3048,190,258,177,112,153,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22026,22026,'Bandit Captain',0,'',0,'Monster.ol_mahum_champion_04te',20.00,23.00,40,'male','L2Monster',80,1527,584,7.11,1.84,40,43,30,21,20,10,2537,164,273,195,131,164,278,500,333,69,19,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22027,22027,'Forgotten Crewman',0,'',0,'Monster.dwarf_ghost',9.00,16.50,39,'male','L2Minion',80,1463,565,7.11,1.84,40,43,30,21,20,10,2639,168,313,175,121,158,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22028,22028,'Vagabond of the Ruins',0,'',0,'NPC.a_mageguild_teacher_Mhuman_mon',20.00,23.00,40,'male','L2Monster',80,1527,584,7.11,1.84,40,43,30,21,20,10,2537,164,273,195,131,164,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22029,22029,'Ragna Orc',0,'',0,'Monster.batur_orc_03te',19.00,21.00,40,'male','L2Monster',80,1527,584,7.11,1.84,40,43,30,21,20,10,2537,164,273,195,131,164,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22030,22030,'Ragna Orc Shaman',0,'',0,'Monster.batur_orc_shaman_a_03te',17.00,17.00,42,'male','L2Monster',80,1660,648,8.69,2.14,40,43,30,21,20,10,2615,174,367,202,152,175,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22031,22031,'Ragna Orc Archer',0,'',0,'Monster.batur_orc_archer_03te',20.00,21.00,43,'male','L2Monster',80,1729,680,8.69,2.14,40,43,30,21,20,10,2660,180,363,214,163,181,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22032,22032,'Ragna Orc Warrior',0,'',0,'Monster.batur_orc_warrior_03te',20.00,20.00,44,'male','L2Monster',40,1799,712,8.69,2.14,40,43,30,21,20,10,3395,232,465,217,176,187,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22033,22033,'Ragna Orc Mage',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,45,'male','L2Monster',80,1870,745,8.69,2.14,40,43,30,21,20,10,2943,205,391,227,188,193,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22034,22034,'Ragna Orc Mage',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,45,'male','L2Monster',80,1870,745,8.69,2.14,40,43,30,21,20,10,2943,205,391,227,188,193,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22035,22035,'Ragna Orc Mage',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,45,'male','L2Monster',80,1870,745,8.69,2.14,40,43,30,21,20,10,2943,205,391,227,188,193,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22036,22036,'Ragna Orc Mage',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,45,'male','L2Monster',80,1870,745,8.69,2.14,40,43,30,21,20,10,2943,205,391,227,188,193,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22037,22037,'Ragna Orc Healer',0,'',0,'Monster.batur_orc_shaman_a_03te',20.00,23.00,45,'male','L2Monster',80,1870,745,8.69,2.14,40,43,30,21,20,10,2943,205,391,227,188,193,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22038,22038,'Ragna Orc Hero',0,'',0,'Monster.batur_orc_overlord_03te',20.00,23.00,48,'male','L2Monster',80,2092,845,8.69,2.14,40,43,30,21,20,10,3423,250,575,238,231,212,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22039,22039,'Ragna Orc Commander',0,'',0,'Monster.batur_orc_overlord_01te',20.00,23.00,49,'male','L2Monster',80,2168,878,8.69,2.14,40,43,30,21,20,10,3659,270,490,267,247,219,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22040,22040,'Ragna Orc Sniper',0,'',0,'Monster.batur_orc_archer_01te',20.00,21.00,47,'male','L2Monster',500,2017,811,8.69,2.14,40,43,30,21,20,10,3311,237,512,241,216,206,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22041,22041,'Ragna Orc Sorcerer',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,50,'male','L2Monster',80,2245,912,8.69,2.14,40,43,30,21,20,10,3629,273,509,273,264,226,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22042,22042,'Ragna Orc Sorcerer',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,50,'male','L2Monster',80,2245,912,8.69,2.14,40,43,30,21,20,10,3629,273,509,273,264,226,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22043,22043,'Ragna Orc Sorcerer',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,50,'male','L2Monster',80,2245,912,8.69,2.14,40,43,30,21,20,10,3629,273,509,273,264,226,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22044,22044,'Ragna Orc Sorcerer',0,'',0,'Monster.batur_orc_shaman_a_01te',17.00,17.00,50,'male','L2Monster',80,2245,912,8.69,2.14,40,43,30,21,20,10,3629,273,509,273,264,226,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22045,22045,'Dark Corpse',0,'',0,'Monster.zombie_02te',20.00,22.00,40,'male','L2Monster',80,1528,584,7.11,1.84,40,43,30,21,20,10,2537,164,273,195,131,164,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(22046,22046,'Varangka''s Dre Vanul',0,'',0,'Monster.dre_vanul',14.00,36.00,46,'male','L2Monster',80,1944,778,8.69,2.14,40,43,30,21,20,10,3274,232,431,246,202,199,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22047,22047,'Guardian of the Ghost Town',0,'',0,'Monster.monster_eye_05te',20.00,27.00,44,'male','L2Monster',80,1800,712,8.69,2.14,40,43,30,21,20,10,3395,232,465,217,176,187,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22048,22048,'Dark Spider',0,'',0,'Monster.giant_spider_04te',20.00,23.00,42,'male','L2Monster',80,1660,648,8.69,2.14,40,43,30,21,20,10,2615,174,367,202,152,175,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22049,22049,'Varangka''s Succubus',0,'',0,'Monster.succubus_05te',20.00,23.00,49,'male','L2Monster',80,2168,878,8.69,2.14,40,43,30,21,20,10,3659,270,490,267,247,219,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22050,22050,'Probe Golem Prodigy IV',0,'',0,'Monster3.golem_microscout',20.00,40.00,46,'male','L2Monster',80,1943,778,8.69,2.14,40,43,30,21,20,10,3274,232,431,246,202,199,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22051,22051,'Spelunking Spider',0,'',0,'Monster.giant_spider_05te',20.00,40.00,47,'male','L2Monster',80,2017,811,8.69,2.14,40,43,30,21,20,10,3311,237,512,241,216,206,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22052,22052,'Menacing Jackhammer Golem',0,'',0,'Monster3.golem_prop',20.00,40.00,47,'male','L2Monster',80,2017,811,8.69,2.14,40,43,30,21,20,10,3311,237,512,241,216,206,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22053,22053,'Horrifying Cannon Golem I',0,'',0,'Monster3.golem_cannon_catapult',20.00,40.00,48,'male','L2Monster',80,2092,845,8.69,2.14,40,43,30,21,20,10,3423,250,575,238,231,212,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22054,22054,'Horrifying Cannon Golem IV',0,'',0,'Monster3.golem_cannon_catapult',20.00,40.00,48,'male','L2Monster',80,2092,845,8.69,2.14,40,43,30,21,20,10,3423,250,575,238,231,212,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22055,22055,'Cruel Vice Golem',0,'',0,'Monster3.golem_repair',20.00,40.00,49,'male','L2Monster',80,2168,878,8.69,2.14,40,43,30,21,20,10,3659,270,490,267,247,219,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22056,22056,'Probe Golem Champion I',0,'',0,'Monster3.golem_microscout',20.00,40.00,49,'male','L2Monster',80,2168,878,8.69,2.14,40,43,30,21,20,10,3659,270,490,267,247,219,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22057,22057,'Spelunking Ant',0,'',0,'Monster.ant_soldier',35.00,17.00,50,'male','L2Monster',80,2245,912,8.69,2.14,40,43,30,21,20,10,3629,273,509,273,264,226,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22058,22058,'Horrifying Excavator Golem III',0,'',0,'Monster3.golem_carrier',20.00,40.00,51,'male','L2Monster',80,2323,946,10.27,2.45,40,43,30,21,20,10,3841,293,602,280,281,232,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22059,22059,'Bloodthirsty Ginzu Golem VII',0,'',0,'Monster3.golem_guardian_090p',20.00,40.00,51,'male','L2Monster',80,2323,946,10.27,2.45,40,43,30,21,20,10,3841,293,602,280,281,232,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22060,22060,'Horrifying Cannon Golem',0,'',0,'Monster3.golem_cannon_catapult_a',20.00,40.00,52,'male','L2Monster',80,2402,981,10.27,2.45,40,43,30,21,20,10,2198,170,561,306,300,239,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22061,22061,'Horrifying Cannon Golem III',0,'',0,'Monster3.golem_microscout_a',20.00,40.00,51,'male','L2Monster',80,2323,946,10.27,2.45,40,43,30,21,20,10,3841,293,602,280,281,232,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22062,22062,'Horrifying Jackhammer Golem',0,'',0,'Monster3.golem_prop',20.00,40.00,52,'male','L2Monster',80,2402,981,10.27,2.45,40,43,30,21,20,10,2198,170,561,306,300,239,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22063,22063,'Ginzu Golem Prodigy X',0,'',0,'Monster3.golem_guardian_090p',20.00,40.00,52,'male','L2Monster',80,2402,981,10.27,2.45,40,43,30,21,20,10,2198,170,561,306,300,239,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22064,22064,'Bloodthirsty Ginzu Golem II',0,'',0,'Monster3.golem_guardian_a_090p',20.00,40.00,52,'male','L2Monster',80,2402,981,10.27,2.45,40,43,30,21,20,10,2198,170,561,306,300,239,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22065,22065,'Horrifying Ginzu Golem V',0,'',0,'Monster3.golem_guardian',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22066,22066,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22067,22067,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22068,22068,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22069,22069,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22070,22070,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22071,22071,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22072,22072,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22073,22073,'Horrifying Cannon Golem VI',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22074,22074,'Epic Cannon Golem',0,'',0,'Monster3.golem_cannon_catapult_a_090p',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22075,22075,'Epic Cannon Golem Adjunct',0,'',0,'Monster3.golem_microscout_a',20.00,40.00,52,'male','L2Monster',80,2402,981,10.27,2.45,40,43,30,21,20,10,2198,170,561,306,300,239,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22076,22076,'Deadly Ginzu Golem V',0,'',0,'Monster3.golem_guardian',20.00,40.00,53,'male','L2Monster',80,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22077,22077,'Horrifying Ginzu Golem VIII',0,'',0,'Monster3.golem_guardian_a',20.00,40.00,54,'male','L2Monster',80,2562,1050,10.27,2.45,40,43,30,21,20,10,4370,348,667,293,339,254,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22078,22078,'Deadly Ginzu Golem VIII',0,'',0,'Monster3.golem_guardian_a',20.00,40.00,54,'male','L2Monster',80,2562,1050,10.27,2.45,40,43,30,21,20,10,4370,348,667,293,339,254,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22079,22079,'Lost Bandersnatch',0,'',0,'Monster2.bandersnatch_c',20.00,23.00,53,'male','L2Minion',40,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22080,22080,'Massive Maze Bandersnatch',0,'',0,'Monster2.bandersnatch',18.00,25.00,54,'male','L2Monster',40,2562,1050,10.27,2.45,40,43,30,21,20,10,4370,348,667,293,339,254,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22081,22081,'Lost Watcher',0,'',0,'Monster.field_stalker',15.00,30.00,53,'male','L2Minion',40,2482,1016,10.27,2.45,40,43,30,21,20,10,4398,346,636,283,319,247,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22082,22082,'Elder Lost Watcher',0,'',0,'Monster.field_stalker_110p',20.00,23.00,54,'male','L2Monster',40,2562,1050,10.27,2.45,40,43,30,21,20,10,4370,348,667,293,339,254,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22083,22083,'Baby Panthera',0,'',0,'Monster.saber_toothed_tiger_080p',20.00,23.00,55,'male','L2Minion',40,2644,1086,10.27,2.45,40,43,30,21,20,10,4519,365,733,302,360,261,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22084,22084,'Panthera',0,'',0,'Monster.saber_toothed_tiger',34.00,28.00,56,'male','L2Monster',40,2724,1121,10.27,2.45,40,43,30,21,20,10,4896,402,730,310,382,269,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22085,22085,'Lost Gargoyle',0,'',0,'Monster.gargoyle_02te',16.00,50.00,55,'male','L2Minion',40,2643,1086,10.27,2.45,40,43,30,21,20,10,4519,365,733,302,360,261,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22086,22086,'Lost Gargoyle Youngling',0,'',0,'Monster.gargoyle_02te_110p',17.50,56.00,56,'male','L2Monster',40,2725,1121,10.27,2.45,40,43,30,21,20,10,4896,402,730,310,382,269,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22087,22087,'Pronghorn Spirit',0,'',0,'Monster2.antelope',17.00,34.00,56,'male','L2Minion',40,2725,1121,10.27,2.45,40,43,30,21,20,10,4896,402,730,310,382,269,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22088,22088,'Pronghorn',0,'',0,'Monster2.antelope_110p',19.00,37.80,57,'male','L2Monster',40,2807,1157,10.27,2.45,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22089,22089,'Ice Tarantula',0,'',0,'Monster.giant_spider',26.00,25.50,57,'male','L2Monster',40,2807,1157,10.27,2.45,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22090,22090,'Frost Tarantula',0,'',0,'Monster.giant_spider_110p',20.00,23.00,58,'male','L2Monster',40,2889,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22091,22091,'Lost Iron Golem',0,'',0,'Monster.iron_golem_120p',22.00,42.50,58,'male','L2Minion',40,2890,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(22092,22092,'Frost Iron Golem',0,'',0,'Monster.iron_golem_130p',25.00,46.40,59,'male','L2Monster',40,2972,1229,10.27,2.45,40,43,30,21,20,10,6134,524,866,324,453,291,278,500,333,0,0,0,25,25,NULL,0,0,0,'LAST_HIT'),
	(22093,22093,'Lost Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,60,'male','L2Minion',40,3055,1265,10.27,2.45,40,43,30,21,20,10,5522,479,868,349,478,299,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22094,22094,'Frost Buffalo',0,'',0,'Monster2.buffalo_a_110p',24.00,34.70,61,'male','L2Monster',40,3137,1301,11.85,2.78,40,43,30,21,20,10,5254,462,1050,348,505,307,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22095,22095,'Ursus Cub',0,'',0,'Monster.grizzly',21.00,40.00,61,'male','L2Minion',40,3138,1301,11.85,2.78,40,43,30,21,20,10,5254,462,1050,348,505,307,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22096,22096,'Ursus',0,'',0,'Monster.grizzly_120p',20.00,48.80,62,'male','L2Monster',40,3220,1338,11.85,2.78,40,43,30,21,20,10,6303,562,1095,360,532,315,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22097,22097,'Lost Yeti',0,'',0,'Monster.yeti',15.00,27.50,62,'male','L2Minion',40,3220,1338,11.85,2.78,40,43,30,21,20,10,6303,562,1095,360,532,315,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22098,22098,'Frost Yeti',0,'',0,'Monster.yeti_110p',20.00,23.00,63,'male','L2Monster',40,3302,1375,11.85,2.78,40,43,30,21,20,10,6277,567,1136,384,560,323,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22099,22099,'Freya''s Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,57,'male','L2Monster',80,2807,1157,10.27,2.45,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22100,22100,'Freya''s Gardener',0,'',0,'Monster.field_stalker',15.00,30.00,58,'male','L2Monster',80,2889,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22101,22101,'Freya''s Servant',0,'',0,'Monster.gargoyle_02te',20.00,23.00,58,'male','L2Monster',80,2889,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22102,22102,'Freya''s Servant',0,'',0,'Monster.gargoyle_02te',20.00,23.00,58,'male','L2Monster',80,2889,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22103,22103,'Freya''s White Bear',0,'',0,'Monster.grizzly',21.00,40.00,57,'male','L2Monster',80,2807,1157,10.27,2.45,40,43,30,21,20,10,4087,340,861,298,405,276,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22104,22104,'Freya''s Dog',0,'',0,'Monster2.bandersnatch',18.00,25.00,58,'male','L2Monster',80,2889,1192,10.27,2.45,40,43,30,21,20,10,5053,427,834,325,428,284,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22105,22105,'Spiked Stakato',0,'',0,'Monster.blade_stakato_120p',20.00,44.00,72,'male','L2Monster',80,4014,1720,13.43,3.09,40,43,30,21,20,10,8759,890,1681,454,849,399,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22106,22106,'Spiked Stakato Worker',0,'',0,'Monster.blade_stakato_worker_120p',20.00,48.00,73,'male','L2Monster',80,4087,1760,13.43,3.09,40,43,30,21,20,10,8561,881,1747,456,885,407,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22107,22107,'Spiked Stakato Guard',0,'',0,'Monster.spike_stakato',20.00,26.00,74,'male','L2Monster',80,4159,1800,13.43,3.09,40,43,30,21,20,10,9177,956,1608,501,921,416,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22108,22108,'Female Spiked Stakato',0,'',0,'Monster.spike_stakato_soldier',20.00,29.00,74,'male','L2Monster',80,4159,1800,13.43,3.09,40,43,30,21,20,10,9177,956,1608,501,921,416,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22109,22109,'Male Spiked Stakato',0,'',0,'Monster.marsh_stakato_soldier_120p',20.00,31.00,74,'male','L2Monster',80,4159,1800,13.43,3.09,40,43,30,21,20,10,9177,956,1608,501,921,416,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22110,22110,'Male Spiked Stakato',0,'',0,'Monster3.marsh_stakato_soldier_tran',20.00,28.00,74,'male','L2Monster',80,4159,1800,13.43,3.09,40,43,30,21,20,10,9177,956,1608,501,921,416,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22111,22111,'Spiked Stakato Sorcerer',0,'',0,'Monster.blade_stakato_queen_120p',20.00,44.00,75,'male','L2Monster',80,4229,1840,13.43,3.09,40,43,30,21,20,10,8521,899,1683,488,957,425,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22112,22112,'Cannibalistic Stakato Follower',0,'',0,'Monster.spike_stakato_worker',20.00,24.00,74,'male','L2Monster',80,4159,1800,13.43,3.09,40,43,30,21,20,10,9177,956,1608,501,921,416,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22113,22113,'Cannibalistic Stakato Leader',0,'',0,'Monster3.cannibal_stakato_leader_120p',20.00,48.00,75,'male','L2Monster',80,4229,1840,13.43,3.09,40,43,30,21,20,10,8521,899,1683,488,957,425,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22114,22114,'Cannibalistic Stakato Leader',0,'',0,'Monster3.cannibal_stakato_leader_tran',20.00,48.00,75,'male','L2Monster',80,4229,1840,13.43,3.09,40,43,30,21,20,10,8521,899,1683,488,957,425,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22115,22115,'Spiked Stakato Soldier',0,'',0,'Monster.blade_stakato_120p',20.00,44.00,76,'male','L2Monster',80,4298,1880,13.43,3.09,40,43,30,21,20,10,8875,948,1824,506,994,433,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22116,22116,'Spiked Stakato Drone',0,'',0,'Monster.blade_stakato_drone_120p',20.00,47.00,77,'male','L2Monster',80,4364,1920,13.43,3.09,40,43,30,21,20,10,9190,994,1711,513,1031,442,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22117,22117,'Spiked Stakato Captain',0,'',0,'Monster.marsh_stakato_drone_120p',20.00,29.00,78,'male','L2Monster',80,4429,1961,13.43,3.09,40,43,30,21,20,10,8687,951,2111,522,1069,451,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22118,22118,'Spiked Stakato Nurse',0,'',0,'Monster.marsh_stakato_queen_120p',20.00,44.00,79,'male','L2Monster',80,4491,2002,13.43,3.09,40,43,30,21,20,10,8749,969,2200,550,1107,459,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22119,22119,'Spiked Stakato Nurse',0,'',0,'Monster3.marsh_stakato_queen_tran',20.00,36.00,79,'male','L2Monster',80,4491,2002,13.43,3.09,40,43,30,21,20,10,8749,969,2200,550,1107,459,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22120,22120,'Spiked Stakato Baby',0,'',0,'Monster.spike_stakato_drone',20.00,29.00,79,'male','L2Monster',80,4491,2002,13.43,3.09,40,43,30,21,20,10,8749,969,2200,550,1107,459,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22121,22121,'Spiked Stakato Shaman',0,'',0,'Monster.blade_stakato_queen_120p',20.00,44.00,80,'male','L2Monster',80,4551,2043,13.43,3.09,40,43,30,21,20,10,9431,1058,1890,556,1144,468,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22122,22122,'Monastic Pilgrim',0,'',0,'Monster.angel_080p',13.00,28.00,80,'male','L2Minion',80,4551,2043,13.43,3.09,40,43,30,21,20,10,9431,1058,1890,556,1144,468,278,0,333,148,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22123,22123,'Monastic Crusader',0,'',0,'Monster.archangel_050p',20.00,40.00,80,'male','L2Monster',80,4609,2085,13.43,3.09,40,43,30,21,20,10,10198,1158,1972,574,1182,477,278,500,333,1303,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22124,22124,'Solina Brother',0,'',0,'Monster3.solina_brother',20.00,25.00,80,'male','L2Monster',80,4609,2085,13.43,3.09,40,43,30,21,20,10,10198,1158,1972,574,1182,477,278,0,333,8212,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22125,22125,'Solina Lay Brother',0,'',0,'Monster3.solina_brother',20.00,25.00,80,'male','L2Monster',80,4664,2126,13.43,3.09,40,43,30,21,20,10,9577,1100,2203,573,1220,485,278,0,333,8212,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22126,22126,'Silent Seeker',0,'',0,'Monster3.solina_father',20.00,25.00,80,'male','L2Monster',80,4664,2126,13.43,3.09,40,43,30,21,20,10,9577,1100,2203,573,1220,485,278,0,333,8213,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22127,22127,'Silent Brother',0,'',0,'Monster3.solina_father',20.00,25.00,80,'male','L2Monster',80,4717,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,0,333,8212,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22128,22128,'Monastery Guardian',0,'',0,'Monster3.grail_protection',20.00,15.00,80,'male','L2Monster',80,4717,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22129,22129,'Warrior Monk',0,'',0,'Monster3.monk_warrior',20.00,28.00,80,'male','L2Monster',80,4767,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,0,333,8211,8210,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22130,22130,'Divine Advocate',0,'',0,'Monster2.apostle_warrior',8.00,30.00,80,'male','L2Minion',80,4814,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,0,333,6717,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22131,22131,'Pilgrim of Light',0,'',0,'Monster2.apostle_mage',11.00,38.50,80,'male','L2Minion',80,4814,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,0,333,6718,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22132,22132,'Judge of Light',0,'',0,'Monster3.apostle_grail_a',20.00,43.00,80,'male','L2Monster',500,4858,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,500,333,8220,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22133,22133,'Guardian of the Grail',0,'',0,'Monster.will_o_wisp',13.00,22.00,80,'male','L2Monster',80,4858,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22134,22134,'Guardian of the Holy Land',0,'',0,'Monster3.solina_priest',20.00,35.00,80,'male','L2Monster',80,4900,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,0,333,8214,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22135,22135,'Beholder of Light',0,'',0,'Monster3.apostle_grail',20.00,43.00,80,'male','L2Monster',80,4900,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,500,333,8221,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22136,22136,'Gatekeeper Zombie',0,'',0,'Monster3.zombie_gateguard',20.00,30.00,83,'male','L2Monster',80,4717,2168,13.43,3.09,40,43,30,21,20,10,250,25,1719,4500,2288,780,300,300,555,8217,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(22137,22137,'Penance Guard',0,'',0,'Monster3.zombie_gateguard_brd',44.00,29.00,80,'male','L2Monster',80,4608,1567,13.43,3.09,40,43,30,21,20,10,13824,658,2475,1127,1544,780,300,300,555,8217,0,0,0,0,NULL,0,1,0,'LAST_HIT'),
	(22138,22138,'Chapel Guard',0,'',0,'Monster3.zombie_gateguard_brd',44.00,29.00,80,'male','L2Monster',80,4812,2439,13.43,3.09,40,43,30,21,20,10,14436,688,2475,793,1144,780,300,300,600,8217,0,0,0,0,NULL,0,1,0,'LAST_HIT'),
	(22139,22139,'Old Aristocrat''s Soldier',0,'',0,'Monster3.zombie_enlisted_man',20.00,21.00,80,'male','L2Monster',80,4609,2439,13.43,3.09,40,43,26,21,20,10,13826,658,1719,1108,1144,780,300,0,555,8216,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22140,22140,'Zombie Worker',0,'',0,'Monster3.zombie_laborer',20.00,23.00,80,'male','L2Monster',80,4551,2439,13.43,3.09,40,43,25,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8218,0,0,61,130,NULL,0,1,0,'LAST_HIT'),
	(22141,22141,'Forgotten Victim',0,'',0,'Monster3.zombie_laborer',20.00,23.00,80,'male','L2Monster',80,4551,2439,13.43,3.09,40,43,25,21,20,10,13652,650,1886,1108,1144,780,300,0,555,8219,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22142,22142,'Triol''s Layperson',0,'',0,'Monster3.heretic_privates_a',20.00,28.00,80,'male','L2Monster',80,4609,3566,13.43,3.09,40,43,30,21,20,10,13826,658,1652,793,1144,780,300,300,555,8207,8207,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22143,22143,'Triol''s Believer',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,3731,2439,13.43,3.09,40,43,30,21,20,10,11193,533,1652,793,1211,780,300,0,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22144,22144,'Resurrected Temple Knight',0,'',0,'Monster3.zombie_enlisted_man',20.00,23.00,80,'male','L2Monster',80,4664,4599,13.43,3.09,40,43,26,21,20,10,13991,666,1698,1108,1144,780,550,300,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22145,22145,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,80,'male','L2Monster',80,4609,2499,13.43,3.09,40,43,30,21,20,10,13826,658,1719,793,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22146,22146,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4766,4599,13.43,3.09,40,43,30,21,20,10,14299,681,1719,793,1211,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22147,22147,'Ritual Offering',0,'',0,'Monster3.zombie_enlisted_man',20.00,23.00,80,'male','L2Monster',80,4717,4599,13.43,3.09,40,43,30,21,20,10,14150,674,1517,793,1144,780,400,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22148,22148,'Triol''s Believer',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,5830,4599,13.43,3.09,40,43,30,21,20,10,17489,830,1719,793,1144,780,300,300,555,8207,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22149,22149,'Ritual Offering',0,'',0,'Monster3.zombie_enlisted_man',20.00,23.00,80,'male','L2Monster',80,4664,4599,13.43,3.09,40,43,30,21,20,10,13991,666,1517,793,1144,780,400,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22150,22150,'Triol''s Believer',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4717,4599,13.43,3.09,40,43,30,21,20,10,14150,674,1719,793,1144,780,300,300,555,8207,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22151,22151,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22152,22152,'Temple Guard',0,'',0,'Monster3.zombie_em_knight',20.00,23.00,80,'male','L2Monster',80,4767,2699,13.43,3.09,40,43,30,21,20,10,14300,681,1869,793,1144,780,500,300,555,0,8219,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22153,22153,'Temple Guard Captain',0,'',0,'Monster3.zombie_em_knight',20.00,23.00,80,'male','L2Monster',80,4767,3201,13.43,3.09,40,43,30,21,20,10,14300,681,1899,793,1144,780,350,300,555,8218,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22154,22154,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,85,'male','L2Monster',80,4814,3201,13.43,3.09,40,43,31,21,20,10,14441,688,1719,677,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22155,22155,'Triol''s High Priest',0,'',0,'Monster3.heretic_priest_a',20.00,20.00,80,'male','L2Monster',80,4814,5505,13.43,3.09,40,43,30,21,20,10,14441,688,1883,793,1244,780,300,300,555,8206,8206,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22156,22156,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4858,4599,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22157,22157,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22158,22158,'Triol''s Believer',0,'',0,'Monster3.heretic_privates_a',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1650,793,1214,780,300,300,555,8207,8207,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22159,22159,'Triol''s High Priest',0,'',0,'Monster3.heretic_priest_a',20.00,20.00,80,'male','L2Monster',80,4858,5505,13.43,3.09,40,43,30,21,20,10,14574,694,1883,793,1144,780,300,300,555,8206,8206,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22160,22160,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4858,4599,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22161,22161,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,80,'male','L2Monster',80,4814,2439,13.43,3.09,40,43,30,21,20,10,14441,688,1719,793,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22162,22162,'Triol''s Believer',0,'',0,'Monster3.heretic_privates_a',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1883,793,1214,780,300,300,555,8207,8207,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22163,22163,'Triol''s High Priest',0,'',0,'Monster3.heretic_priest',20.00,20.00,80,'male','L2Monster',80,4858,5605,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,300,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22164,22164,'Triol''s Believer',0,'',0,'Monster3.heretic_privates_a',20.00,28.00,80,'male','L2Monster',80,4858,4599,13.43,3.09,40,43,30,21,20,10,14574,694,1916,793,1301,780,300,300,555,8207,8207,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22165,22165,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22166,22166,'Triol''s Believer',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4814,4599,13.43,3.09,40,43,30,21,20,10,14441,688,1916,793,1301,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22167,22167,'Triol''s High Priest',0,'',0,'Monster3.heretic_priest_a',20.00,20.00,80,'male','L2Monster',80,4900,6505,13.43,3.09,40,43,30,21,20,10,14699,700,1883,793,1144,780,300,300,555,8206,8206,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22168,22168,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4900,4599,13.43,3.09,40,43,30,21,20,10,14699,700,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22169,22169,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,80,'male','L2Monster',80,4858,2439,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22170,22170,'Triol''s Believer',0,'',0,'Monster3.heretic_privates_a',20.00,28.00,80,'male','L2Monster',80,4858,4599,13.43,3.09,40,43,30,21,20,10,14574,694,2033,793,1301,780,300,300,555,8207,8207,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22171,22171,'Triol''s High Priest',0,'',0,'Monster3.heretic_priest',20.00,20.00,80,'male','L2Monster',80,4900,5605,13.43,3.09,40,43,30,21,20,10,14699,700,1719,793,1144,780,300,300,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22172,22172,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,80,'male','L2Monster',80,4858,2439,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22173,22173,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4858,4599,13.43,3.09,40,43,30,21,20,10,14574,694,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22174,22174,'Triol''s Priest',0,'',0,'Monster3.heretic_privates',20.00,28.00,80,'male','L2Monster',80,4814,4325,13.43,3.09,40,43,30,21,20,10,14441,688,1719,793,1144,780,300,300,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22175,22175,'Andreas'' Captain of the Royal Guard',0,'',0,'Monster3.zombie_em_knight',20.00,22.00,80,'male','L2Monster',80,4812,430,13.43,3.09,40,43,30,21,20,10,14436,688,1719,793,1144,780,500,500,555,8218,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22176,22176,'Andreas'' Royal Guards',0,'',0,'Monster3.zombie_em_knight',20.00,23.00,85,'male','L2Monster',80,4812,430,13.43,3.09,40,43,25,21,20,10,14436,688,2475,1108,1144,780,300,500,555,8207,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22188,22188,'Andreas'' Captain of the Royal Guard',0,'',0,'Monster3.heretic_priest_120p',20.00,23.00,87,'male','L2Monster',80,4899,4599,13.43,3.09,40,43,31,21,20,10,14698,700,2682,960,1566,780,300,500,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22189,22189,'Andreas'' Royal Guards',0,'',0,'Monster3.heretic_privates_120p',22.00,34.00,86,'male','L2Monster',80,4858,2439,13.43,3.09,40,43,32,21,20,10,14574,694,2682,960,1566,780,460,500,555,8208,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22190,22190,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,23.00,86,'male','L2Monster',80,4858,2439,13.43,3.09,40,43,30,21,20,10,14574,694,1883,793,1144,780,300,0,555,0,0,0,61,180,NULL,0,1,0,'LAST_HIT'),
	(22191,22191,'Andreas'' Captain of the Royal Guard',0,'',0,'Monster3.heretic_priest_120p',20.00,23.00,87,'male','L2Monster',80,7350,4560,13.43,3.09,40,43,30,21,20,10,22049,1050,1719,793,1144,780,300,300,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22192,22192,'Andreas'' Royal Guards',0,'',0,'Monster3.heretic_privates_120p',20.00,23.00,86,'male','L2Monster',80,9716,2439,13.43,3.09,40,43,30,21,20,10,29148,1388,1719,793,1144,780,300,500,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22193,22193,'Andreas'' Royal Guards',0,'',0,'Monster3.heretic_privates_120p',20.00,23.00,86,'male','L2Monster',80,9716,2439,13.43,3.09,40,43,30,21,20,10,29148,1388,1719,793,1144,780,600,500,555,8206,0,0,61,180,NULL,0,0,0,'LAST_HIT'),
	(22194,22194,'Penance Guard',0,'',0,'Monster3.zombie_gateguard_slp',44.00,27.00,80,'male','L2Monster',80,4608,1566,13.43,3.09,40,43,30,21,20,10,13824,658,2475,1108,1544,780,300,300,555,8217,0,0,0,0,NULL,0,1,0,'LAST_HIT'),
	(22195,22195,'Ritual Sacrifice',0,'',0,'Monster3.self_blaster',20.00,31.00,99,'male','L2Monster',80,100000,9999,13.43,3.09,40,43,30,21,20,10,3083,500,3109,755,1893,651,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(22196,22196,'Velociraptor',0,'',0,'Monster3.velociraptor',19.00,47.20,86,'male','L2Monster',80,25106,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22197,22197,'Velociraptor',0,'',0,'Monster3.velociraptor',19.00,47.20,86,'male','L2Monster',80,12553,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22198,22198,'Velociraptor',0,'',0,'Monster3.velociraptor',19.00,47.20,86,'male','L2Monster',80,25106,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22199,22199,'Pterosaur',0,'',0,'Monster3.rhamphorhynchus',36.00,43.70,87,'male','L2Monster',80,101430,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22200,22200,'Ornithomimus',0,'',0,'Monster3.ornithomimus',15.00,37.20,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22201,22201,'Ornithomimus',0,'',0,'Monster3.ornithomimus',15.00,37.20,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22202,22202,'Ornithomimus',0,'',0,'Monster3.ornithomimus',15.00,37.20,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22203,22203,'Deinonychus',0,'',0,'Monster3.deinonychus',14.00,14.30,83,'male','L2Monster',80,12184,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22204,22204,'Deinonychus',0,'',0,'Monster3.deinonychus',14.00,14.30,83,'male','L2Monster',80,12184,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22205,22205,'Deinonychus',0,'',0,'Monster3.deinonychus',14.00,14.30,83,'male','L2Monster',80,12184,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22208,22208,'Pachycephalosaurus',0,'',0,'Monster3.pachycephalosaurus',22.00,40.00,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22209,22209,'Pachycephalosaurus',0,'',0,'Monster3.pachycephalosaurus',22.00,40.00,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22210,22210,'Pachycephalosaurus',0,'',0,'Monster3.pachycephalosaurus',22.00,40.00,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22211,22211,'Wild Strider',0,'',0,'Monster3.wild_giant_strider',32.00,44.20,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22212,22212,'Wild Strider',0,'',0,'Monster3.wild_giant_strider',32.00,44.20,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22213,22213,'Wild Strider',0,'',0,'Monster3.wild_giant_strider',32.00,44.20,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22214,22214,'Elroki',0,'',0,'Monster3.Crokian_Officer',25.00,33.00,85,'male','L2Monster',80,24857,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22215,22215,'Tyrannosaurus',0,'',0,'Monster3.tyranosaurus',60.00,89.70,87,'male','L2Boss',80,306406,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,0,0,0,88,188,'dino',500,0,12,'LAST_HIT'),
	(22216,22216,'Tyrannosaurus',0,'',0,'Monster3.tyranosaurus',60.00,89.70,87,'male','L2Boss',80,306406,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,0,0,0,88,188,'dino',500,0,12,'LAST_HIT'),
	(22217,22217,'Tyrannosaurus',0,'',0,'Monster3.tyranosaurus',60.00,89.70,87,'male','L2Boss',80,306406,2339,13.43,3.09,40,43,30,21,20,10,11131,1401,2269,635,1413,531,278,1000,333,0,0,0,88,188,'dino',500,0,12,'LAST_HIT'),
	(22218,22218,'Velociraptor',0,'',0,'Monster3.velociraptor',19.00,47.20,86,'male','L2Monster',80,12553,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22219,22219,'Ornithomimus',0,'',0,'Monster3.ornithomimus',15.00,37.20,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22220,22220,'Deinonychus',0,'',0,'Monster3.deinonychus',14.00,14.30,83,'male','L2Monster',80,12184,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22221,22221,'Pachycephalosaurus',0,'',0,'Monster3.pachycephalosaurus',22.00,40.00,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22222,22222,'Wild Strider',0,'',0,'Monster3.wild_giant_strider',32.00,44.20,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22223,22223,'Velociraptor',0,'',0,'Monster3.velociraptor',19.00,47.20,86,'male','L2Monster',80,12553,2296,13.43,3.09,40,43,30,21,20,10,11031,1351,2199,625,1373,521,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22224,22224,'Ornithomimus',0,'',0,'Monster3.ornithomimus',15.00,37.20,84,'male','L2Monster',80,12305,2211,13.43,3.09,40,43,30,21,20,10,11138,1310,2298,612,1296,502,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22225,22225,'Deinonychus',0,'',0,'Monster3.deinonychus',14.00,14.30,83,'male','L2Monster',80,12184,2168,13.43,3.09,40,43,30,21,20,10,9821,1141,2695,571,1258,494,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22226,22226,'Pachycephalosaurus',0,'',0,'Monster3.pachycephalosaurus',22.00,40.00,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT'),
	(22227,22227,'Wild Strider',0,'',0,'Monster3.wild_giant_strider',25.00,33.00,85,'male','L2Monster',80,12428,2253,13.43,3.09,40,43,30,21,20,10,10931,1301,2129,615,1333,511,278,1000,333,0,0,0,88,188,'dino',500,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(25001,25001,'Greyclaw Kutus',0,'Raid Boss',0,'Monster.ol_mahum_champion_50_bi',21.00,43.50,23,'male','L2RaidBoss',40,95986,545,117.62,4.73,60,57,73,76,70,80,714843,67170,61,857,6,348,278,0,3819,67,633,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25002,25002,'Guard of Kutus',0,'Raid Fighter',0,'Monster.ol_mahum',13.50,25.00,22,'male','L2Minion',40,6613,257,29.94,4.73,40,43,30,41,20,10,0,0,74,411,9,167,278,0,333,7,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25003,25003,'Pawn of Kutus',0,'Raid Fighter',0,'Monster.ol_mahum',13.50,25.00,22,'male','L2Minion',40,9870,257,29.94,4.73,40,43,30,41,20,10,0,0,111,411,22,167,278,0,333,123,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25004,25004,'Turek Mercenary Captain',0,'Raid Boss',0,'Monster.orc_champion_50_bi',15.00,35.00,30,'male','L2RaidBoss',40,168366,763,310.14,5.72,60,57,73,76,70,80,1424160,129276,226,1127,70,458,278,0,3819,124,0,0,72,275,NULL,0,0,0,'LAST_HIT'),
	(25005,25005,'Turek Mercenary Archer',0,'Raid Fighter',0,'Monster.orc_archer',14.00,25.00,29,'male','L2Minion',500,11414,365,79.32,4.73,40,43,30,41,20,10,0,0,604,542,111,220,249,0,333,271,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25006,25006,'Turek Mercenary Warrior',0,'Raid Fighter',0,'Monster.orc_fighter',12.00,22.00,29,'male','L2Minion',40,8518,365,79.32,4.73,40,43,30,41,20,10,0,0,203,542,62,220,278,0,333,2,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25007,25007,'Retreat Spider Cletu',0,'Raid Boss',0,'Monster.poison_spider',27.00,25.50,42,'male','L2RaidBoss',40,331522,1062,428.19,5.72,60,57,73,76,70,80,2299956,251972,746,1728,324,701,278,0,3819,0,0,0,97,275,NULL,0,0,0,'LAST_HIT'),
	(25008,25008,'Cletu''s Retainer',0,'Raid Fighter',0,'Monster.giant_spider',26.00,25.50,41,'male','L2Minion',40,33216,514,110.41,5.72,40,43,30,41,20,10,0,0,662,835,278,339,278,0,333,0,0,0,79,187,NULL,0,0,0,'LAST_HIT'),
	(25009,25009,'Cletu''s Pawn',0,'Raid Fighter',0,'Monster.giant_spider',26.00,25.50,41,'male','L2Minion',40,16608,514,110.41,5.72,40,43,30,41,20,10,0,0,662,835,278,339,278,0,333,0,0,0,79,187,NULL,0,0,0,'LAST_HIT'),
	(25010,25010,'Furious Thieles',0,'Raid Boss',0,'Monster.ti_mi_tran',23.00,90.00,55,'male','L2RaidBoss',40,624464,2039,592.29,7.70,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,3819,0,0,0,19,81,NULL,0,0,0,'LAST_HIT'),
	(25011,25011,'Guard of Thieles',0,'Raid Fighter',0,'Monster.zenta_lizardman_scout',11.00,30.00,54,'male','L2Minion',500,42806,987,153.99,7.70,40,43,30,41,20,10,0,0,6746,1252,2944,508,249,0,333,279,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25012,25012,'Follower of Thieles',0,'Raid Fighter',0,'Monster.dryad',9.00,20.00,54,'female','L2Minion',40,31945,987,153.99,7.70,40,43,30,41,20,10,0,0,2277,1252,1656,508,278,0,333,0,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25013,25013,'Ghost of Peasant Leader',0,'Raid Boss',0,'Monster.skeleton_knight_50_bi',15.00,39.00,50,'male','L2RaidBoss',40,507285,1722,529.53,7.70,60,57,73,76,70,80,2494222,346727,1510,2226,862,904,278,0,3819,145,0,0,64,275,NULL,0,1,0,'LAST_HIT'),
	(25014,25014,'Ghost of Peasant',0,'Raid Fighter',0,'Monster.skeleton',11.00,25.00,49,'male','L2Minion',40,51380,830,137.24,6.74,40,43,30,41,20,10,0,0,2751,1079,3086,438,278,0,333,68,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25015,25015,'Ghost of Peasant',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,49,'male','L2Minion',500,25690,830,137.24,6.74,40,43,30,41,20,10,0,0,1375,1079,771,438,278,0,333,14,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25016,25016,'The 3rd Underwater Guardian',0,'Raid Boss',0,'Monster.susceptor_100_bi',40.00,73.00,60,'male','L2RaidBoss',40,188376,2368,702.39,8.75,60,57,73,76,70,80,3346092,522780,3860,2951,3932,1198,278,0,3819,0,0,0,43,243,NULL,0,0,0,'LAST_HIT'),
	(25017,25017,'Escort of the 3rd Guardian',0,'Raid Fighter',0,'Monster.will_o_wisp',13.00,22.00,59,'male','L2Minion',40,24399,1150,183.19,7.70,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25018,25018,'Support of the 3rd Guardian',0,'Raid Fighter',0,'Monster.will_o_wisp',13.00,22.00,59,'male','L2Minion',40,12199,1150,183.19,7.70,40,43,30,41,20,10,0,0,3509,1437,3472,583,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25019,25019,'Pan Dryad',0,'Raid Boss',0,'Monster.pan_100_bi',42.00,73.00,25,'male','L2RaidBoss',40,206185,606,127.71,4.73,60,57,73,76,70,80,730469,69595,146,928,30,377,278,0,3819,291,0,0,72,275,NULL,0,0,0,'LAST_HIT'),
	(25020,25020,'Breka Warlock Pastu',0,'Raid Boss',0,'Monster.batur_orc_shaman_100_bi',22.00,35.00,34,'male','L2RaidBoss',40,156584,893,178.88,5.72,60,57,73,76,70,80,1174184,135023,280,1308,55,531,278,0,3819,8,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25021,25021,'Pastu''s Silhouette',0,'Raid Fighter',0,'Monster.silhouette',8.00,23.00,33,'female','L2Minion',40,15774,430,45.88,5.72,40,43,30,41,20,10,0,0,258,630,51,256,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25022,25022,'Pastu''s Shadow',0,'Raid Fighter',0,'Monster.shadow',10.00,30.00,33,'male','L2Minion',40,7887,430,45.88,5.72,40,43,30,41,20,10,0,0,258,630,51,256,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25023,25023,'Stakato Queen Zyrnna',0,'Raid Boss',0,'Monster.marsh_stakato_queen_100_bi',30.00,76.00,34,'female','L2RaidBoss',40,208019,1415,332.20,6.74,60,57,73,76,70,80,1753455,156895,340,1308,110,531,278,0,3819,150,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25024,25024,'Jeruna''s Guard Captain',0,'Raid Fighter',0,'Monster.marsh_stakato_drone',9.00,24.00,33,'male','L2Minion',40,20909,677,85.21,6.74,40,43,30,41,20,10,0,0,626,630,408,256,278,0,333,238,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25025,25025,'Jeruna''s Guard',0,'Raid Fighter',0,'Monster.marsh_stakato_soldier',10.00,25.00,33,'male','L2Minion',40,10454,677,85.21,6.74,40,43,30,41,20,10,0,0,313,630,102,256,278,0,333,257,0,0,33,187,NULL,0,0,0,'LAST_HIT'),
	(25026,25026,'Katu Van Leader Atui',0,'Raid Boss',0,'Monster.ketra_orc_overload',12.00,24.00,49,'male','L2RaidBoss',40,352421,1660,278.27,6.74,60,57,73,76,70,80,1655129,248433,1147,2160,383,877,278,0,3819,84,0,0,53,275,NULL,0,0,0,'LAST_HIT'),
	(25027,25027,'Katu Van Marksman',0,'Raid Fighter',0,'Monster.ketra_orc_archer',12.00,27.00,48,'male','L2Minion',500,23911,799,72.08,6.74,40,43,30,41,20,10,0,0,3102,1047,613,425,249,0,333,279,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25028,25028,'Katu Van Raider',0,'Raid Fighter',0,'Monster.ketra_orc_warrior',12.00,24.00,48,'male','L2Minion',40,17844,799,72.08,6.74,40,43,30,41,20,10,0,0,1047,1047,345,425,278,0,333,128,0,0,39,187,NULL,0,0,0,'LAST_HIT'),
	(25029,25029,'Atraiban',0,'Raid Boss',0,'Monster.field_stalker_200_bi',45.00,96.00,53,'male','L2RaidBoss',40,156190,1911,611.07,7.70,60,57,73,76,70,80,3145490,461913,2344,2433,1974,988,278,0,3819,0,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25030,25030,'Atraiban''s Top Disciple',0,'Raid Fighter',0,'Monster.will_o_wisp',13.00,22.00,52,'male','L2Minion',40,20135,923,158.68,7.70,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25031,25031,'Atraiban''s Disciple',0,'Raid Fighter',0,'Monster.liviona',15.00,28.00,52,'male','L2Minion',40,10067,923,158.68,7.70,40,43,30,41,20,10,0,0,2114,1181,1727,479,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25032,25032,'Eva''s Guardian Millenu',0,'Raid Boss',0,'Monster.banshee_50_bi',13.50,38.00,58,'female','L2RaidBoss',40,229722,2707,828.24,8.75,60,57,73,76,70,80,1820975,806823,5880,3349,7541,1360,278,0,3819,3939,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25033,25033,'Millenu Guard Shaman',0,'Raid Fighter',0,'Monster.heltor_silenos_shaman',13.00,32.00,57,'male','L2Minion',40,20074,1319,218.67,8.75,40,43,30,41,20,10,0,0,7473,1634,12940,663,278,0,333,5131,0,0,31,187,NULL,0,0,0,'LAST_HIT'),
	(25034,25034,'Mellenu Guard Warrior',0,'Raid Fighter',0,'Monster.skeleton_royal_guard',11.00,28.50,57,'male','L2Minion',40,30142,1319,218.67,8.75,40,43,30,41,20,10,0,0,11210,1634,29118,663,278,0,333,946,945,0,88,187,NULL,0,1,0,'LAST_HIT'),
	(25035,25035,'Shilen''s Messenger Cabrio',0,'Raid Boss',0,'Monster.vale_master_50_bi',18.00,63.00,70,'male','L2RaidBoss',40,888658,3058,844.90,9.81,60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,3819,189,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25036,25036,'Cabrio Captor',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,69,'male','L2Minion',500,62338,1493,223.73,8.75,40,43,30,41,20,10,0,0,19755,1840,15424,747,249,0,333,279,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25037,25037,'Cabrio Blader',0,'Raid Fighter',0,'Monster.doll_blader',6.00,12.00,69,'male','L2Minion',40,46520,1493,223.73,8.75,40,43,30,41,20,10,0,0,6668,1840,8676,747,278,0,333,5129,5129,0,24,187,NULL,0,0,0,'LAST_HIT'),
	(25038,25038,'Tirak',0,'Raid Boss',0,'Monster.dre_vanul_100_bi',28.00,75.00,28,'male','L2RaidBoss',40,116581,699,143.80,4.73,60,57,73,76,70,80,750326,74683,96,1044,10,424,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25039,25039,'Tirak''s Guard',0,'Raid Fighter',0,'Monster.spartoi',11.00,27.00,27,'male','L2Minion',40,11861,334,36.74,4.73,40,43,30,41,20,10,0,0,175,502,38,204,278,0,333,68,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25040,25040,'Tirak''s Knight',0,'Raid Fighter',0,'Monster.skeleton',11.00,25.00,27,'male','L2Minion',40,5930,334,36.74,4.73,40,43,30,41,20,10,0,0,87,502,9,204,278,0,333,2,945,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25041,25041,'Remmel',0,'Raid Boss',0,'Monster.marsh_stakato_queen_100_bi',30.00,76.00,35,'female','L2RaidBoss',40,165289,927,185.07,5.72,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,3819,221,109,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25042,25042,'Remmel''s Archer',0,'Raid Fighter',0,'Monster.batur_orc_archer',11.00,21.50,34,'male','L2Minion',500,11143,446,47.49,5.72,40,43,30,41,20,10,0,0,547,654,46,265,249,0,333,275,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25043,25043,'Remmel''s Guard',0,'Raid Fighter',0,'Monster.marsh_stakato',10.00,20.00,34,'male','L2Minion',40,8316,446,47.49,5.72,40,43,30,41,20,10,0,0,184,654,26,265,278,0,333,127,0,0,23,187,NULL,0,0,0,'LAST_HIT'),
	(25044,25044,'Barion',0,'Raid Boss',0,'Monster.skeleton_knight_50_bi',15.00,39.00,47,'male','L2RaidBoss',40,319791,1296,264.56,6.74,60,57,73,76,70,80,1624139,238098,956,2030,296,824,278,0,3819,70,0,0,64,275,NULL,0,1,0,'LAST_HIT'),
	(25045,25045,'Dark Mage''s of Barion',0,'Raid Fighter',0,'Monster.batur_orc_shaman',11.00,16.00,46,'male','L2Minion',40,32280,618,68.43,6.74,40,43,30,41,20,10,0,0,861,983,260,399,278,0,333,159,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(25046,25046,'Barion''s Grunt',0,'Raid Fighter',0,'Monster.spartoi',11.00,27.00,46,'male','L2Minion',40,16140,618,68.43,6.74,40,43,30,41,20,10,0,0,861,983,260,399,278,0,333,129,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25047,25047,'Karte',0,'Raid Boss',0,'Monster.death_knight_50_bi',18.00,47.50,49,'male','L2RaidBoss',40,352421,1660,278.27,6.74,60,57,73,76,70,80,1412364,185123,769,2160,184,877,278,0,3819,131,0,0,43,275,NULL,0,1,0,'LAST_HIT'),
	(25048,25048,'Karte''s Chief Knight',0,'Raid Fighter',0,'Monster.skeleton_knight',10.00,25.00,48,'male','L2Minion',40,35688,799,72.08,6.74,40,43,30,41,20,10,0,0,1403,1047,664,425,278,0,333,71,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25049,25049,'Karte''s Royal Guard',0,'Raid Fighter',0,'Monster.spartoi',11.00,27.00,48,'male','L2Minion',40,17844,799,72.08,6.74,40,43,30,41,20,10,0,0,701,1047,166,425,278,0,333,74,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25050,25050,'Verfa',0,'Raid Boss',0,'Monster.death_blader_200_bi',45.00,141.00,51,'male','L2RaidBoss',40,771340,2039,250.26,7.70,60,57,73,76,70,80,1381165,185853,1700,2294,879,931,278,0,3819,1472,0,0,162,275,NULL,0,1,0,'LAST_HIT'),
	(25051,25051,'Rahha',0,'Raid Boss',0,'Monster3.Bloody_Queen_Raid',28.00,36.00,65,'female','L2RaidBoss',40,818959,2707,673.33,8.75,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25052,25052,'Priestess of Rahha',0,'Raid Fighter',0,'Monster.medusa',10.00,25.00,64,'female','L2Minion',40,85286,1319,177.86,8.75,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,333,0,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25053,25053,'Fanatics of Rahha',0,'Raid Fighter',0,'Monster.harpy',10.00,42.00,64,'female','L2Minion',40,42643,1319,177.86,8.75,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25054,25054,'Kernon',0,'Raid Boss',0,'Monster.kaim_vanul',24.00,40.00,75,'male','L2RaidBoss',40,945900,3420,849.66,9.81,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,3819,0,0,0,59,275,NULL,0,0,0,'LAST_HIT'),
	(25055,25055,'Taliadon',0,'Raid Fighter',0,'Monster.death_blader',15.00,45.00,74,'male','L2Minion',40,99324,1673,225.62,9.81,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,333,1472,0,0,110,187,NULL,0,1,0,'LAST_HIT'),
	(25056,25056,'Vemsk',0,'Raid Fighter',0,'Monster.death_knight',12.00,31.00,74,'male','L2Minion',40,49662,1673,225.62,9.81,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,333,142,0,0,29,187,NULL,0,1,0,'LAST_HIT'),
	(25057,25057,'Biconne of Blue Sky',0,'Raid Boss',0,'Monster.lienrik',12.00,50.00,45,'male','L2RaidBoss',40,288415,2235,250.90,7.70,60,57,73,76,70,80,1358394,171282,538,1905,112,774,278,0,3819,0,0,0,162,275,NULL,0,0,0,'LAST_HIT'),
	(25058,25058,'Biconne''s Shooter',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,44,'male','L2Minion',500,19455,1084,64.81,7.70,40,43,30,41,20,10,0,0,1444,922,176,374,249,0,333,279,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25059,25059,'Biconne''s Warrior',0,'Raid Fighter',0,'Monster.skeleton_knight',10.00,25.00,44,'male','L2Minion',40,14518,1084,64.81,7.70,40,43,30,41,20,10,0,0,487,922,99,374,278,0,333,150,0,0,44,176,NULL,0,1,0,'LAST_HIT'),
	(25060,25060,'Unrequited Kael',0,'Raid Boss',0,'Monster.succubus_100_bi',20.00,75.00,24,'female','L2RaidBoss',40,99367,575,105.08,4.73,60,57,73,76,70,80,606920,51383,57,892,5,362,278,0,3819,0,0,0,97,275,NULL,0,0,0,'LAST_HIT'),
	(25061,25061,'Kael''s Bead',0,'Raid Fighter',0,'Monster.will_o_wisp',13.00,22.00,23,'male','L2Minion',40,6830,272,26.77,4.73,40,43,30,41,20,10,0,0,69,428,8,174,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25062,25062,'Kael''s Escort',0,'Raid Fighter',0,'Monster.harpy',10.00,42.00,23,'female','L2Minion',40,10195,272,26.77,4.73,40,43,30,41,20,10,0,0,103,428,19,174,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25063,25063,'Chertuba of Great Soul',0,'Raid Boss',0,'Monster.ketra_orc_warrior_100_bi',24.00,51.00,35,'male','L2RaidBoss',40,330579,927,185.07,5.72,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,3819,78,0,0,58,275,NULL,0,0,0,'LAST_HIT'),
	(25064,25064,'Wizard of Storm Teruk',0,'Raid Boss',0,'Monster.zenta_lizardman_shaman_50_bi',19.00,55.00,40,'male','L2RaidBoss',40,218810,1120,217.25,6.74,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,3819,90,0,0,69,275,NULL,0,0,0,'LAST_HIT'),
	(25065,25065,'Teruk''s Escort',0,'Raid Fighter',0,'Monster.zenta_lizardman',11.00,32.00,39,'male','L2Minion',40,21961,531,55.95,5.72,40,43,30,41,20,10,0,0,530,780,157,317,278,0,333,123,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25066,25066,'Teruk''s Knight',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,39,'male','L2Minion',40,10980,531,55.95,5.72,40,43,30,41,20,10,0,0,265,780,39,317,278,0,333,291,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25067,25067,'Captain of Red Flag Shaka',0,'Raid Boss',0,'Monster.oel_mahum_warrior_50_bi',30.00,60.00,52,'male','L2RaidBoss',40,554640,1598,554.85,6.74,60,57,73,76,70,80,2909180,424683,1951,2363,1304,959,278,0,3819,71,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25068,25068,'Shaka''s Shooter',0,'Raid Fighter',0,'Monster.ol_mahum_archer',14.00,25.00,51,'male','L2Minion',500,37786,768,143.99,6.74,40,43,30,41,20,10,0,0,5307,1147,2104,465,249,0,333,277,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25069,25069,'Shaka''s Follower',0,'Raid Fighter',0,'Monster.oel_mahum_champion',23.00,61.00,51,'male','L2Minion',40,28199,768,143.99,6.74,40,43,30,41,20,10,0,0,1791,1147,1183,465,278,0,333,128,633,0,73,187,NULL,0,0,0,'LAST_HIT'),
	(25070,25070,'Enchanted Forest Watcher Ruell',0,'Raid Boss',0,'Monster.ti_mi_tran',23.00,90.00,55,'male','L2RaidBoss',40,451391,2039,318.92,7.70,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,3819,0,0,0,19,81,NULL,0,0,0,'LAST_HIT'),
	(25071,25071,'Ruell''s Wind',0,'Raid Fighter',0,'Monster.sylph',11.00,35.00,54,'female','L2Minion',40,30975,987,82.92,7.70,40,43,30,41,20,10,0,0,1676,1252,705,508,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25072,25072,'Ruell''s Unicorn',0,'Raid Fighter',0,'Monster.unicorn',14.00,30.00,54,'male','L2Minion',40,46232,987,82.92,7.70,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,333,0,0,0,50,187,NULL,0,0,0,'LAST_HIT'),
	(25073,25073,'Bloody Priest Rudelto',0,'Raid Boss',0,'Monster.karik_100_bi',50.00,180.00,69,'male','L2RaidBoss',40,875948,2987,842.52,8.75,60,57,73,76,70,80,1894878,895518,6751,3680,8676,1494,278,0,3819,0,0,0,59,275,NULL,0,0,0,'LAST_HIT'),
	(25074,25074,'Rudelto''s Banshee',0,'Raid Fighter',0,'Monster.banshee',9.00,23.00,68,'female','L2Minion',40,91632,1458,223.10,8.75,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25075,25075,'Rudelto''s Dre Vanul',0,'Raid Fighter',0,'Monster.dre_vanul',14.00,36.00,68,'male','L2Minion',40,45816,1458,223.10,8.75,40,43,30,41,20,10,0,0,6447,1798,8379,730,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25076,25076,'Princess Molrang',0,'Raid Boss',0,'Monster.poison_toad_100_bi',40.00,20.00,25,'male','L2RaidBoss',40,103092,606,127.71,4.73,60,57,73,76,70,80,730469,69595,73,928,7,377,278,0,3819,0,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25077,25077,'Captain Dogun',0,'Raid Fighter',0,'Monster.grizzly',21.00,40.00,24,'male','L2Minion',40,10554,287,32.55,4.73,40,43,30,41,20,10,0,0,132,446,27,181,278,0,333,0,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25078,25078,'Princess'' Guard',0,'Raid Fighter',0,'Monster.grizzly',21.00,40.00,24,'male','L2Minion',40,5277,287,32.55,4.73,40,43,30,41,20,10,0,0,66,446,6,181,278,0,333,0,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25079,25079,'Cat''s Eye Bandit',0,'Raid Boss',0,'Monster3.Ol_Mahum_Raid',21.00,27.50,30,'male','L2RaidBoss',40,168366,763,288.00,5.72,60,57,73,76,70,80,1329219,122342,206,1127,53,458,278,0,3819,0,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25080,25080,'Mercenary',0,'Raid Fighter',0,'Monster.orc_shaman',9.00,22.00,29,'male','L2Minion',40,17036,365,73.66,4.73,40,43,30,41,20,10,0,0,185,542,47,220,278,0,333,179,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25081,25081,'Cat''s Eye Bandit',0,'Raid Fighter',0,'Monster.ol_mahum',13.50,25.00,29,'male','L2Minion',40,8518,365,73.66,4.73,40,43,30,41,20,10,0,0,185,542,47,220,278,0,333,218,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25082,25082,'Leader of Cat Gang',0,'Raid Boss',0,'Monster.cat_the_cat_50_bi',13.50,26.00,39,'male','L2RaidBoss',40,206753,1062,210.68,5.72,60,57,73,76,70,80,1078255,134578,268,1561,39,634,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25083,25083,'Cat Gang',0,'Raid Fighter',0,'Monster.cutie_cat',8.00,15.00,38,'female','L2Minion',40,13903,514,54.21,5.72,40,43,30,41,20,10,0,0,330,754,65,306,278,0,333,0,0,0,52,187,NULL,0,0,0,'LAST_HIT'),
	(25084,25084,'Cat Gang',0,'Raid Fighter',0,'Monster.cat_the_cat',9.00,16.00,38,'male','L2Minion',40,20752,514,54.21,5.72,40,43,30,41,20,10,0,0,495,754,146,306,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25085,25085,'Timak Orc Chief Ranger',0,'Raid Boss',0,'Monster.ketra_orc_warrior_100_bi',24.00,51.00,44,'male','L2RaidBoss',40,371721,1355,453.27,6.74,60,57,73,76,70,80,2352182,262175,893,1845,414,749,278,0,3819,157,0,0,58,275,NULL,0,0,0,'LAST_HIT'),
	(25086,25086,'Timak Orc Ranger',0,'Raid Fighter',0,'Monster.ketra_orc_archer',12.00,27.00,43,'male','L2Minion',500,24994,648,117.03,6.74,40,43,30,41,20,10,0,0,2392,892,653,362,249,0,333,14,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25087,25087,'Timak Orc Ranger',0,'Raid Fighter',0,'Monster.ketra_orc',12.00,29.00,43,'male','L2Minion',40,18652,648,117.03,6.74,40,43,30,41,20,10,0,0,807,892,367,362,278,0,333,68,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25088,25088,'Crazy Mechanic Golem',0,'Raid Boss',0,'Monster.mechanic_golem_200_bi',15.00,63.00,43,'male','L2RaidBoss',40,702418,2039,474.62,7.70,60,57,73,76,70,80,2492637,273103,1794,1785,1948,725,278,0,3819,0,0,0,48,243,NULL,0,0,0,'LAST_HIT'),
	(25089,25089,'Soulless Wild Boar',0,'Raid Boss',0,'Monster.giant_wild_hog',35.00,27.00,59,'male','L2RaidBoss',40,512194,2301,344.91,7.70,60,57,73,76,70,80,2072981,415763,2664,2875,1302,1167,278,0,3819,0,0,0,56,275,NULL,0,0,0,'LAST_HIT'),
	(25090,25090,'Soulless Wolf',0,'Raid Fighter',0,'Monster.dire_wolf',13.00,11.00,58,'male','L2Minion',40,35416,1117,89.90,7.70,40,43,30,41,20,10,0,0,3291,1399,2123,568,278,0,333,0,0,0,26,187,NULL,0,0,0,'LAST_HIT'),
	(25091,25091,'Soulless Bear',0,'Raid Fighter',0,'Monster.crimson_bear',19.00,36.00,58,'male','L2Minion',40,52860,1117,89.90,7.70,40,43,30,41,20,10,0,0,4936,1399,4777,568,278,0,333,0,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25092,25092,'Korim',0,'Raid Boss',0,'Monster.heltor_silenos_shaman_50_bi',19.50,51.00,70,'male','L2RaidBoss',40,888658,3058,685.96,9.81,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,278,0,3819,201,0,0,46,275,NULL,0,0,0,'LAST_HIT'),
	(25093,25093,'Korim Chief Guard Kaywon',0,'Raid Fighter',0,'Monster.heltor_silenos_warrior',13.00,31.00,69,'male','L2Minion',40,93041,1493,181.67,8.75,40,43,30,41,20,10,0,0,10724,1840,20400,747,278,0,333,162,0,0,39,187,NULL,0,0,0,'LAST_HIT'),
	(25094,25094,'Korim Guards',0,'Raid Fighter',0,'Monster.heltor_silenos',13.00,29.00,69,'male','L2Minion',40,46520,1493,181.67,8.75,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,333,86,0,0,37,187,NULL,0,0,0,'LAST_HIT'),
	(25095,25095,'Elf Renoa',0,'Raid Boss',0,'Monster.elf_ghost',7.00,21.00,29,'male','L2RaidBoss',40,121941,731,149.37,4.73,60,57,73,76,70,80,755659,76955,104,1085,11,440,278,0,3819,0,0,0,129,275,NULL,0,1,0,'LAST_HIT'),
	(25096,25096,'Renoa''s Elpy',0,'Raid Fighter',0,'Monster.elpy',5.00,4.50,28,'male','L2Minion',40,8296,349,38.19,4.73,40,43,30,41,20,10,0,0,126,522,18,212,278,0,333,0,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25097,25097,'Renoa''s Hog',0,'Raid Fighter',0,'Monster.giant_wild_hog',35.00,27.00,28,'male','L2Minion',40,12383,349,38.19,4.73,40,43,30,41,20,10,0,0,190,522,41,212,278,0,333,0,0,0,38,187,NULL,0,0,0,'LAST_HIT'),
	(25098,25098,'Sejarr''s Servitor',0,'Raid Boss',0,'Monster.dark_fencer_200_bi',30.00,43.00,35,'male','L2RaidBoss',40,330579,927,185.07,5.72,60,57,73,76,70,80,1018607,103175,401,1356,113,550,278,0,3819,0,0,0,40,275,NULL,0,0,0,'LAST_HIT'),
	(25099,25099,'Rotten Tree Repiro',0,'Raid Boss',0,'Monster.hanged_man_ripper',35.00,80.00,44,'male','L2RaidBoss',40,273375,1355,244.07,6.74,60,57,73,76,70,80,1344111,167614,493,1845,99,749,278,0,3819,0,0,0,89,89,NULL,0,0,0,'LAST_HIT'),
	(25100,25100,'Spirit of Sea of Spores',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,43,'female','L2Minion',40,27494,648,63.01,6.74,40,43,30,41,20,10,0,0,318,892,88,362,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25101,25101,'Fighter of Sea of Spores',0,'Raid Fighter',0,'Monster.troll',21.00,35.00,43,'male','L2Minion',40,13747,648,63.01,6.74,40,43,30,41,20,10,0,0,318,892,88,362,278,0,333,0,0,0,60,187,NULL,0,0,0,'LAST_HIT'),
	(25102,25102,'Shacram',0,'Raid Boss',0,'Monster.minotaur_100_bi',42.00,94.00,45,'male','L2RaidBoss',40,576831,1722,250.90,7.70,60,57,73,76,70,80,1591877,230991,1603,1905,927,774,278,0,3819,300,0,0,64,275,NULL,0,0,0,'LAST_HIT'),
	(25103,25103,'Sorcerer Isirr',0,'Raid Boss',0,'Monster.zenta_lizardman_matriarch_50_bi',30.00,63.00,55,'male','L2RaidBoss',40,451391,2039,318.92,7.70,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,3819,195,0,0,85,275,NULL,0,0,0,'LAST_HIT'),
	(25104,25104,'Isirr''s Guard',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,54,'male','L2Minion',40,46232,987,82.92,7.70,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,333,221,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25105,25105,'Isirr''s Guards',0,'Raid Fighter',0,'Monster.zenta_lizardman',11.00,32.00,54,'male','L2Minion',40,23116,987,82.92,7.70,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,333,16,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25106,25106,'Ghost of the Well Lidia',0,'Raid Boss',0,'Monster.bloody_queen_100_bi',28.00,85.00,60,'female','L2RaidBoss',40,526218,2570,358.55,8.75,60,57,73,76,70,80,2414839,561233,3581,3188,2006,1294,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25107,25107,'Lidia''s Archer',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,59,'male','L2Minion',500,36451,1251,94.61,8.75,40,43,30,41,20,10,0,0,9897,1554,3306,631,249,0,333,279,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25108,25108,'Lidia''s Fighter',0,'Raid Fighter',0,'Monster.death_blader',15.00,45.00,59,'male','L2Minion',40,27202,1251,94.61,8.75,40,43,30,41,20,10,0,0,3340,1554,1859,631,278,0,333,1472,0,0,110,187,NULL,0,1,0,'LAST_HIT'),
	(25109,25109,'Antharas Priest Cloe',0,'Raid Boss',0,'Monster.succubus_100_bi',20.00,75.00,74,'female','L2RaidBoss',40,935092,3347,849.66,9.81,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,3819,0,0,0,97,275,NULL,0,0,12,'PARTY_ONE_RANDOM'),
	(25110,25110,'Cloe''s Servitor',0,'Raid Fighter',0,'Monster.silhouette',8.00,23.00,73,'female','L2Minion',40,65759,1637,224.99,9.81,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25111,25111,'Cloe''s Servitor',0,'Raid Fighter',0,'Monster.shadow',10.00,30.00,73,'male','L2Minion',40,98148,1637,224.99,9.81,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25112,25112,'Agent of Beres, Meana',0,'Raid Boss',0,'Monster.medusa_100_bi',20.00,53.00,30,'female','L2RaidBoss',40,127782,763,155.08,5.72,60,57,73,76,70,80,890100,105037,169,1127,26,458,278,0,3819,0,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25113,25113,'Meana''s Maid',0,'Raid Fighter',0,'Monster.succubus',10.00,36.00,29,'female','L2Minion',40,8678,365,39.66,4.73,40,43,30,41,20,10,0,0,203,542,41,220,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25114,25114,'Meana''s Guard Doll',0,'Raid Fighter',0,'Monster.crimson_doll',15.00,38.00,29,'male','L2Minion',40,12952,365,39.66,4.73,40,43,30,41,20,10,0,0,305,542,94,220,278,0,333,0,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25115,25115,'Icarus Sample 1',0,'Raid Boss',0,'Monster3.Kernon_Raid',33.00,51.00,40,'male','L2RaidBoss',40,294846,1120,403.46,6.74,60,57,73,76,70,80,1910416,217891,520,1615,177,656,278,0,3819,0,0,0,145,275,NULL,0,0,0,'LAST_HIT'),
	(25116,25116,'Icarus Sample 2',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,39,'male','L2Minion',500,19779,531,103.89,5.72,40,43,30,41,20,10,0,0,1417,780,290,317,249,0,333,273,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25117,25117,'Icarus Sample 3',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,39,'male','L2Minion',40,14760,531,103.89,5.72,40,43,30,41,20,10,0,0,478,780,163,317,278,0,333,0,0,0,99,187,NULL,0,0,0,'LAST_HIT'),
	(25118,25118,'Guilotine, Warden of the Execution Grounds',0,'Raid Boss',0,'Monster.skeleton_pikeman_100_bi',20.00,58.00,35,'male','L2RaidBoss',40,330579,1415,185.07,6.74,60,57,73,76,70,80,1193687,138419,601,1356,236,550,278,0,3819,96,0,0,81,275,NULL,0,1,0,'LAST_HIT'),
	(25119,25119,'Messenger of Fairy Queen Berun',0,'Raid Boss',0,'Monster.pan_100_bi',42.00,73.00,50,'male','L2RaidBoss',40,507285,1722,652.12,7.70,60,57,73,76,70,80,1237500,455390,1918,2226,1530,904,278,0,3819,213,0,0,72,275,NULL,0,0,0,'LAST_HIT'),
	(25120,25120,'Berun''s Officer',0,'Raid Fighter',0,'Monster.pan',14.00,35.00,49,'male','L2Minion',40,34424,830,168.74,6.74,40,43,30,41,20,10,0,0,2336,1079,2443,438,278,0,333,90,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(25121,25121,'Berun''s Prattler',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,49,'female','L2Minion',40,51380,830,168.74,6.74,40,43,30,41,20,10,0,0,3504,1079,5498,438,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25122,25122,'Refugee Hopeful Leo',0,'Raid Boss',0,'Monster.oel_mahum_witch_doctor_50_bi',22.50,54.00,56,'male','L2RaidBoss',40,467209,2235,325.56,7.70,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,278,0,3819,201,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25123,25123,'Leo''s Servant',0,'Raid Fighter',0,'Monster.lesser_giant',21.00,44.00,55,'male','L2Minion',40,47946,1084,84.69,7.70,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,333,3937,0,0,16,198,NULL,0,0,0,'LAST_HIT'),
	(25124,25124,'Leo''s Steward',0,'Raid Fighter',0,'Monster.lesser_giant_mage',21.00,44.00,55,'male','L2Minion',40,23973,1084,84.69,7.70,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,333,3938,0,0,16,198,NULL,0,0,0,'LAST_HIT'),
	(25125,25125,'Fierce Tiger King Angel',0,'Raid Boss',0,'Monster.saber_toothed_tiger_200_bi',72.00,87.00,65,'male','L2RaidBoss',40,1637918,2707,828.24,8.75,60,57,73,76,70,80,1820975,806823,11761,3349,30166,1360,278,0,3819,0,0,0,97,275,NULL,0,0,0,'LAST_HIT'),
	(25126,25126,'Longhorn Golkonda',0,'Raid Boss',0,'Monster.minotaur_100_bi',42.00,94.00,79,'male','L2RaidBoss',40,1974940,3718,844.90,9.81,60,57,73,76,70,80,2346616,1166150,20224,4530,59372,1839,278,0,3819,91,0,0,64,275,NULL,0,0,0,'LAST_HIT'),
	(25127,25127,'Langk Matriarch Rashkos',0,'Raid Boss',0,'Monster.virud_lizardman_matriarch_50_bi',19.00,57.00,24,'male','L2RaidBoss',40,198734,763,122.59,5.72,60,57,73,76,70,80,723779,67853,134,892,27,362,278,0,3819,124,0,0,90,275,NULL,0,0,0,'LAST_HIT'),
	(25128,25128,'Vuku Grand Seer Gharmash',0,'Raid Boss',0,'Monster.batur_orc_shaman_100_bi',22.00,35.00,33,'male','L2RaidBoss',40,148507,860,172.79,5.72,60,57,73,76,70,80,984556,97626,174,1261,24,512,278,0,3819,195,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25129,25129,'Vuku Shaman',0,'Raid Fighter',0,'Monster.orc_shaman',9.00,22.00,32,'male','L2Minion',40,10036,414,44.29,5.72,40,43,30,41,20,10,0,0,213,607,39,246,278,0,333,7,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25130,25130,'Gharmash''s Pet Trimden',0,'Raid Fighter',0,'Monster.poison_spider',27.00,25.50,32,'male','L2Minion',40,14980,414,44.29,5.72,40,43,30,41,20,10,0,0,320,607,89,246,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25131,25131,'Carnage Lord Gato',0,'Raid Boss',0,'Monster.oel_mahum_50_bi',30.00,57.00,50,'male','L2RaidBoss',40,369009,1415,285.12,6.74,60,57,73,76,70,80,1670250,297042,1243,2226,429,904,278,0,3819,71,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25132,25132,'Gato''s Marksman',0,'Raid Fighter',0,'Monster.ol_mahum_archer',14.00,25.00,49,'male','L2Minion',500,25080,677,73.90,6.74,40,43,30,41,20,10,0,0,3356,1079,682,438,249,0,333,273,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25133,25133,'Gato''s Troop Leader',0,'Raid Fighter',0,'Monster.ol_mahum_champion',14.00,27.00,49,'male','L2Minion',40,18716,677,73.90,6.74,40,43,30,41,20,10,0,0,1132,1079,383,438,278,0,333,69,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25134,25134,'Leto Chief Talkin',0,'Raid Boss',0,'Monster3.Zenta_Lizardman_Raid',30.00,38.00,40,'male','L2RaidBoss',40,218810,1722,217.25,7.70,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,3819,0,0,0,85,275,NULL,0,0,0,'LAST_HIT'),
	(25135,25135,'Talkin''s Seer',0,'Raid Fighter',0,'Monster.virud_lizardman_shaman',10.00,29.00,39,'male','L2Minion',40,21961,830,55.95,6.74,40,43,30,41,20,10,0,0,393,780,80,317,278,0,333,7,0,0,47,187,NULL,0,0,0,'LAST_HIT'),
	(25136,25136,'Talkin''s Bodyguard',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,39,'male','L2Minion',40,10980,830,55.95,6.74,40,43,30,41,20,10,0,0,393,780,80,317,278,0,333,16,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25137,25137,'Beleth''s Seer Sephia',0,'Raid Boss',0,'Monster.bloody_queen_100_bi',28.00,85.00,55,'female','L2RaidBoss',40,451391,2039,318.92,7.70,60,57,73,76,70,80,2001376,387789,2034,2576,903,1046,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25138,25138,'Soul Drinker',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,54,'male','L2Minion',40,30975,987,82.92,7.70,40,43,30,41,20,10,0,0,2500,1252,1464,508,278,0,333,0,0,0,99,187,NULL,0,0,0,'LAST_HIT'),
	(25139,25139,'Sephia''s Salve',0,'Raid Fighter',0,'Monster.kaim_vanul',24.00,40.00,54,'male','L2Minion',40,46232,987,82.92,7.70,40,43,30,41,20,10,0,0,3750,1252,3295,508,278,0,333,0,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25140,25140,'Hekaton Prime',0,'Raid Boss',0,'Monster.susceptor',20.00,35.00,65,'male','L2RaidBoss',40,818959,2707,673.33,8.75,60,57,73,76,70,80,3674504,679343,4656,3349,4297,1360,278,0,3819,0,0,0,43,275,NULL,0,0,0,'LAST_HIT'),
	(25141,25141,'Hekaton Cottus',0,'Raid Fighter',0,'Monster.gamlin',11.00,32.00,64,'male','L2Minion',40,85286,1319,177.86,8.75,40,43,30,41,20,10,0,0,8885,1634,16636,663,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25142,25142,'Hekaton Chires',0,'Raid Fighter',0,'Monster.lesser_giant',21.00,44.00,64,'male','L2Minion',40,42643,1319,177.86,8.75,40,43,30,41,20,10,0,0,4442,1634,4159,663,278,0,333,3937,0,0,16,198,NULL,0,0,0,'LAST_HIT'),
	(25143,25143,'Fire of Wrath Shuriel',0,'Raid Boss',0,'Monster.angel',13.50,36.50,78,'male','L2RaidBoss',40,977229,3718,844.90,9.81,60,57,73,76,70,80,2287584,1166150,10051,4503,14666,1828,278,0,3819,2500,0,0,48,275,NULL,0,0,0,'LAST_HIT'),
	(25144,25144,'Shuriel''s Oracle',0,'Raid Fighter',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,78,'male','L2Minion',40,103799,1859,224.36,9.81,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,333,201,0,0,77,187,NULL,0,0,0,'LAST_HIT'),
	(25145,25145,'Shuriel''s Paladin',0,'Raid Fighter',0,'Monster.kel_mahum_champion',13.00,32.00,78,'male','L2Minion',40,51899,1859,224.36,9.81,40,43,30,41,20,10,0,0,9703,2222,14332,902,278,0,333,147,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25146,25146,'Serpent Demon Bifrons',0,'Raid Boss',0,'Monster.serpent_slave_50_bi',25.00,72.00,21,'male','L2RaidBoss',40,90169,485,92.58,4.73,60,57,73,76,70,80,578451,45688,42,789,3,320,278,0,3819,73,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25147,25147,'Assassin of Bifrons',0,'Raid Fighter',0,'Monster.virud_lizardman_scout',10.00,22.00,20,'male','L2Minion',500,6241,227,23.53,4.73,40,43,30,41,20,10,0,0,90,378,3,153,249,0,333,2507,0,0,47,187,NULL,0,0,0,'LAST_HIT'),
	(25148,25148,'Butcher of Bifrons',0,'Raid Fighter',0,'Monster.virud_lizardman_warrior',12.00,30.00,20,'male','L2Minion',40,4657,227,23.53,4.73,40,43,30,41,20,10,0,0,30,378,2,153,278,0,333,16,0,0,57,187,NULL,0,0,0,'LAST_HIT'),
	(25149,25149,'Zombie Lord Crowl',0,'Raid Boss',0,'Monster3.Zombie_Raid',26.00,45.00,25,'male','L2RaidBoss',40,103092,606,127.71,4.73,60,57,73,76,70,80,856025,92883,110,928,15,377,278,0,3819,0,0,0,24,24,NULL,0,1,0,'LAST_HIT'),
	(25150,25150,'Evil Spirit Archer',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,24,'male','L2Minion',500,7071,287,32.55,4.73,40,43,30,41,20,10,0,0,296,446,25,181,249,0,333,14,0,0,44,187,NULL,0,1,0,'LAST_HIT'),
	(25151,25151,'Evil Spirit Warrior',0,'Raid Fighter',0,'Monster.skeleton',11.00,25.00,24,'male','L2Minion',40,5277,287,32.55,4.73,40,43,30,41,20,10,0,0,100,446,14,181,278,0,333,946,0,0,66,187,NULL,0,1,0,'LAST_HIT'),
	(25152,25152,'Flame Lord Shadar',0,'Raid Boss',0,'Monster.dre_vanul_100_bi',28.00,75.00,35,'male','L2RaidBoss',40,165289,927,185.07,5.72,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25153,25153,'Claws of Shadar',0,'Raid Fighter',0,'Monster.imp',10.00,24.00,34,'male','L2Minion',40,16632,446,47.49,5.72,40,43,30,41,20,10,0,0,554,654,220,265,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25154,25154,'Whip of Shadar',0,'Raid Fighter',0,'Monster.succubus',10.00,36.00,34,'female','L2Minion',40,8316,446,47.49,5.72,40,43,30,41,20,10,0,0,277,654,55,265,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25155,25155,'Shaman King Selu',0,'Raid Boss',0,'Monster.batur_orc_overlord_100_bi',24.00,52.00,40,'male','L2RaidBoss',40,294846,1120,434.49,6.74,60,57,73,76,70,80,2046864,230791,570,1615,234,656,278,0,3819,79,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25156,25156,'Fanatic Shaman',0,'Raid Fighter',0,'Monster.batur_orc_shaman',11.00,16.00,39,'male','L2Minion',40,19779,531,111.88,5.72,40,43,30,41,20,10,0,0,699,780,383,317,278,0,333,123,19,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25157,25157,'Fanatic Soldier',0,'Raid Fighter',0,'Monster.batur_orc_warrior',10.00,20.00,39,'male','L2Minion',40,29521,531,111.88,5.72,40,43,30,41,20,10,0,0,1048,780,862,317,278,0,333,7,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25158,25158,'King Tarlk',0,'Raid Boss',0,'Monster.king_bugbear_200_bi',45.00,126.00,48,'male','L2RaidBoss',40,920790,1722,504.06,7.70,60,57,73,76,70,80,2448691,283783,2574,2094,2776,850,278,0,3819,160,0,0,89,275,NULL,0,0,0,'LAST_HIT'),
	(25159,25159,'Paniel the Unicorn',0,'Raid Boss',0,'Monster.unicorn',14.00,30.00,54,'male','L2RaidBoss',40,435256,1975,312.26,7.70,60,57,73,76,70,80,1983647,381736,1898,2504,823,1017,278,0,3819,0,0,0,74,275,NULL,0,0,0,'LAST_HIT'),
	(25160,25160,'Rapini the Unicorn',0,'Raid Fighter',0,'Monster.unicorn_boxer',11.00,18.00,53,'male','L2Minion',40,44492,955,81.13,7.70,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,333,0,0,0,29,187,NULL,0,0,0,'LAST_HIT'),
	(25161,25161,'Ririf the Unicorn',0,'Raid Fighter',0,'Monster.unicorn_mirage',13.00,17.00,53,'male','L2Minion',40,22246,955,81.13,7.70,40,43,30,41,20,10,0,0,1736,1216,740,494,278,0,333,0,0,0,29,187,NULL,0,0,0,'LAST_HIT'),
	(25162,25162,'Giant Marpanak',0,'Raid Boss',0,'Monster.lesser_giant_100_bi',42.00,91.00,60,'male','L2RaidBoss',40,1461912,2368,652.22,8.75,60,57,73,76,70,80,3123036,491139,7025,2951,11841,1198,278,0,3819,3937,0,0,24,291,NULL,0,0,0,'LAST_HIT'),
	(25163,25163,'Roaring Skylancer',0,'Raid Boss',0,'Monster3.Drake_Raid',30.00,50.00,70,'male','L2RaidBoss',40,888658,3058,844.90,9.81,60,57,73,76,70,80,1915900,918808,6981,3764,8986,1528,278,0,3819,0,0,0,113,275,NULL,0,0,12,'LAST_HIT'),
	(25166,25166,'Ikuntai',0,'Raid Boss',0,'Monster.skeleton_knight_50_bi',15.00,39.00,25,'male','L2RaidBoss',40,134813,606,237.19,4.73,60,57,73,76,70,80,1278325,108133,133,928,31,377,278,0,3819,150,0,0,64,275,NULL,0,1,0,'LAST_HIT'),
	(25167,25167,'Ikuntai''s Servitor',0,'Raid Fighter',0,'Monster.silhouette',8.00,23.00,24,'female','L2Minion',40,13786,287,60.47,4.73,40,43,30,41,20,10,0,0,121,446,28,181,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25168,25168,'Pawn of Ikuntai',0,'Raid Fighter',0,'Monster.skeleton_pikeman',10.00,28.00,24,'male','L2Minion',40,6893,287,60.47,4.73,40,43,30,41,20,10,0,0,121,446,28,181,278,0,333,299,0,0,55,187,NULL,0,1,0,'LAST_HIT'),
	(25169,25169,'Ragraman',0,'Raid Boss',0,'Monster.batur_orc_overlord_100_bi',24.00,52.00,30,'male','L2RaidBoss',40,336732,763,288.00,5.72,60,57,73,76,70,80,1329219,122342,412,1127,212,458,278,0,3819,72,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25170,25170,'Lizardmen Leader Hellion',0,'Raid Boss',0,'Monster.zenta_lizardman_matriarch_50_bi',30.00,63.00,38,'male','L2RaidBoss',40,195371,1028,204.16,5.72,60,57,73,76,70,80,1064286,131051,251,1508,36,612,278,0,3819,223,0,0,85,275,NULL,0,0,0,'LAST_HIT'),
	(25171,25171,'Hellion''s Archers',0,'Raid Fighter',0,'Monster.zenta_lizardman_scout',11.00,30.00,37,'male','L2Minion',500,13142,497,52.50,5.72,40,43,30,41,20,10,0,0,686,728,60,295,249,0,333,278,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25172,25172,'Hellion''s Guards',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,37,'male','L2Minion',40,9807,497,52.50,5.72,40,43,30,41,20,10,0,0,231,728,34,295,278,0,333,291,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25173,25173,'Tiger King Karuta',0,'Raid Boss',0,'Monster.saber_toothed_tiger_200_bi',72.00,87.00,45,'male','L2RaidBoss',40,288415,1415,250.90,6.74,60,57,73,76,70,80,1591877,230991,801,1905,231,774,278,0,3819,0,0,0,97,275,NULL,0,0,0,'LAST_HIT'),
	(25174,25174,'Karuta''s Follower',0,'Raid Fighter',0,'Monster.heltor_silenos_chieftain',13.00,31.50,44,'male','L2Minion',40,29037,677,64.81,6.74,40,43,30,41,20,10,0,0,725,922,205,374,278,0,333,127,0,0,29,187,NULL,0,0,0,'LAST_HIT'),
	(25175,25175,'Karuta''s Inferiors',0,'Raid Fighter',0,'Monster.crimson_bear',19.00,36.00,44,'male','L2Minion',40,14518,677,64.81,6.74,40,43,30,41,20,10,0,0,725,922,205,374,278,0,333,0,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25176,25176,'Black Lily',0,'Raid Boss',0,'Monster3.Succubus_Raid',28.00,34.00,55,'female','L2RaidBoss',40,451391,2039,318.92,7.70,60,57,73,76,70,80,1707842,285150,1364,2576,435,1046,278,0,3819,0,0,0,129,275,NULL,0,0,0,'LAST_HIT'),
	(25177,25177,'Guardian Knight of Black Lily',0,'Raid Fighter',0,'Monster.death_knight',12.00,31.00,54,'male','L2Minion',40,46232,987,82.92,7.70,40,43,30,41,20,10,0,0,2514,1252,1586,508,278,0,333,75,0,0,29,187,NULL,0,1,0,'LAST_HIT'),
	(25178,25178,'Servitor of Black Lily',0,'Raid Fighter',0,'Monster.silhouette',8.00,23.00,54,'female','L2Minion',40,23116,987,82.92,7.70,40,43,30,41,20,10,0,0,1257,1252,396,508,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25179,25179,'Guardian of the Statue of Giant Karum',0,'Raid Boss',0,'Monster.lesser_giant_shooter_50_bi',31.50,69.00,60,'male','L2RaidBoss',40,526218,2368,351.19,8.75,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,3819,3937,0,0,24,291,NULL,0,0,0,'LAST_HIT'),
	(25180,25180,'Karum''s Guard',0,'Raid Fighter',0,'Monster.lesser_giant_mage',21.00,44.00,59,'male','L2Minion',40,36451,1150,91.59,7.70,40,43,30,41,20,10,0,0,3509,1437,2314,583,278,0,333,3938,0,0,16,198,NULL,0,0,0,'LAST_HIT'),
	(25181,25181,'Karum''s Warrior',0,'Raid Fighter',0,'Monster.susceptor',20.00,35.00,59,'male','L2Minion',40,54404,1150,91.59,7.70,40,43,30,41,20,10,0,0,5263,1437,5208,583,278,0,333,0,0,0,29,187,NULL,0,0,0,'LAST_HIT'),
	(25182,25182,'Demon Kurikups',0,'Raid Boss',0,'Monster.karik_100_bi',50.00,180.00,59,'male','L2RaidBoss',40,512194,2707,362.57,8.75,60,57,73,76,70,80,2460640,581209,3838,3349,2140,1360,278,0,3819,0,0,0,59,324,NULL,0,0,0,'LAST_HIT'),
	(25183,25183,'Kurikups'' Wife',0,'Raid Fighter',0,'Monster.bloody_queen',14.00,40.00,58,'female','L2Minion',40,13187,1319,95.76,8.75,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25184,25184,'Devil Blader of Chaos',0,'Raid Fighter',0,'Monster.death_blader',15.00,45.00,58,'male','L2Minion',40,6593,1319,95.76,8.75,40,43,30,41,20,10,0,0,3661,1634,2071,663,278,0,333,1472,0,0,110,187,NULL,0,1,0,'LAST_HIT'),
	(25185,25185,'Tasaba Patriarch Hellena',0,'Raid Boss',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,35,'male','L2RaidBoss',40,165289,927,185.07,5.72,60,57,73,76,70,80,1193687,138419,300,1356,59,550,278,0,3819,225,0,0,85,275,NULL,0,0,0,'LAST_HIT'),
	(25186,25186,'Hellena''s Marksman',0,'Raid Fighter',0,'Monster.zenta_lizardman_scout',11.00,30.00,34,'male','L2Minion',500,11143,446,47.49,5.72,40,43,30,41,20,10,0,0,821,654,97,265,249,0,333,272,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25187,25187,'Helena''s Soldier',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,34,'male','L2Minion',40,8316,446,47.49,5.72,40,43,30,41,20,10,0,0,277,654,55,265,278,0,333,16,0,0,44,187,NULL,0,0,0,'LAST_HIT'),
	(25188,25188,'Apepi',0,'Raid Boss',0,'Monster.lienrik',12.00,50.00,30,'male','L2RaidBoss',40,255564,763,155.08,5.72,60,57,73,76,70,80,759553,78807,227,1127,50,458,278,0,3819,0,0,0,162,275,NULL,0,0,0,'LAST_HIT'),
	(25189,25189,'Cronos''s Servitor Mumu',0,'Raid Boss',0,'Monster.cutie_cat',8.00,15.00,34,'female','L2RaidBoss',40,156584,893,178.88,5.72,60,57,73,76,70,80,1001975,100648,187,1308,26,531,278,0,3819,0,0,0,77,275,NULL,0,0,0,'LAST_HIT'),
	(25190,25190,'Mumu''s Wizard',0,'Raid Fighter',0,'Monster.cutie_cat',8.00,15.00,33,'female','L2Minion',40,10568,430,45.88,5.72,40,43,30,41,20,10,0,0,229,630,43,256,278,0,333,0,0,0,52,187,NULL,0,0,0,'LAST_HIT'),
	(25191,25191,'Mumu''s Warrior',0,'Raid Fighter',0,'Monster.cat_the_cat',9.00,16.00,33,'male','L2Minion',40,15774,430,45.88,5.72,40,43,30,41,20,10,0,0,344,630,97,256,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25192,25192,'Earth Protector Panathen',0,'Raid Boss',0,'Monster.farhite',16.00,31.00,43,'male','L2RaidBoss',40,258849,1296,237.31,6.74,60,57,73,76,70,80,1557899,221896,673,1785,182,725,278,0,3819,183,0,0,24,275,NULL,0,0,0,'LAST_HIT'),
	(25193,25193,'Panathen''s Knight',0,'Raid Fighter',0,'Monster.nos',26.00,42.00,42,'male','L2Minion',40,26011,618,61.23,6.74,40,43,30,41,20,10,0,0,1213,864,644,350,278,0,333,5130,0,0,19,187,NULL,0,0,0,'LAST_HIT'),
	(25194,25194,'Panathen''s Protectors',0,'Raid Fighter',0,'Monster.dailaon',20.00,28.00,42,'male','L2Minion',500,13005,618,61.23,6.74,40,43,30,41,20,10,0,0,606,864,161,350,278,0,333,5127,0,0,19,187,NULL,0,0,0,'LAST_HIT'),
	(25198,25198,'Fafurion''s Herald Lokness',0,'Raid Boss',0,'Monster3.Water_Drake',45.00,150.00,70,'male','L2RaidBoss',40,1777317,2639,844.90,8.75,60,57,73,76,70,80,1915900,918808,13963,3764,35947,1528,278,0,3819,0,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25199,25199,'Water Dragon Seer Sheshark',0,'Raid Boss',0,'Monster.virud_lizardman_shaman',10.00,29.00,72,'male','L2RaidBoss',40,912634,2707,741.47,8.75,60,57,73,76,70,80,4674309,805512,7164,3933,8915,1597,278,0,3819,181,0,0,69,324,NULL,0,0,0,'LAST_HIT'),
	(25200,25200,'Family of Sheshark',0,'Raid Fighter',0,'Monster.lienrik',12.00,50.00,71,'male','L2Minion',40,64111,1319,196.58,8.75,40,43,30,41,20,10,0,0,9147,1924,15345,781,278,0,333,0,0,0,110,187,NULL,0,0,0,'LAST_HIT'),
	(25201,25201,'Guard of Sheshark',0,'Raid Fighter',0,'Monster.virud_lizardman_warrior',12.00,30.00,71,'male','L2Minion',40,95688,1319,196.58,8.75,40,43,30,41,20,10,0,0,13720,1924,34528,781,278,0,333,6370,0,0,57,187,NULL,0,0,0,'LAST_HIT'),
	(25202,25202,'Krokian Padisha Sobekk',0,'Raid Boss',0,'Monster.nos_100_bi',52.00,86.00,74,'male','L2RaidBoss',40,935092,2777,849.66,8.75,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,278,0,3819,5130,0,0,29,275,NULL,0,0,12,'PARTY_ONE_RANDOM'),
	(25203,25203,'Parhit Padisha Sobekk',0,'Raid Fighter',0,'Monster.farhite_100_bi',32.00,65.00,73,'male','L2Minion',40,98148,1353,224.99,8.75,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,333,5131,0,0,16,187,NULL,0,0,0,'LAST_HIT'),
	(25204,25204,'Krokian Padisha Sobekk',0,'Raid Fighter',0,'Monster.crokian_100_bi',36.00,61.00,73,'male','L2Minion',40,49074,1353,224.99,8.75,40,43,30,41,20,10,0,0,8345,2008,12049,815,278,0,333,5128,0,0,19,187,NULL,0,0,0,'LAST_HIT'),
	(25205,25205,'Ocean Flame Ashakiel',0,'Raid Boss',0,'Monster.archangel_50_bi',22.00,120.00,76,'male','L2RaidBoss',40,956490,3274,742.11,9.81,60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,3819,98,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25206,25206,'Ashakia''s Blade',0,'Raid Fighter',0,'Monster2.apostle_warrior',8.00,30.00,75,'female','L2Minion',40,100472,1601,197.17,9.81,40,43,30,41,20,10,0,0,15569,2094,39730,850,278,0,333,6717,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25207,25207,'Ashakiel''s Rod',0,'Raid Fighter',0,'Monster2.apostle_mage',11.00,38.50,75,'male','L2Minion',40,50236,1601,197.17,9.81,40,43,30,41,20,10,0,0,7784,2094,9932,850,278,0,333,6718,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25208,25208,'Water Couatle Ateka',0,'Raid Boss',0,'Monster.lienrik',12.00,50.00,40,'male','L2RaidBoss',40,218810,1722,217.25,7.70,60,57,73,76,70,80,1279280,187517,427,1615,87,656,278,0,3819,0,0,0,162,275,NULL,0,0,0,'LAST_HIT'),
	(25209,25209,'Ateka''s Shaman',0,'Raid Fighter',0,'Monster.lienrik',12.00,50.00,39,'male','L2Minion',40,14713,830,55.95,6.74,40,43,30,41,20,10,0,0,524,780,143,317,278,0,333,0,0,0,110,187,NULL,0,0,0,'LAST_HIT'),
	(25210,25210,'Ateka''s Grunt',0,'Raid Fighter',0,'Monster.lienrik',12.00,50.00,39,'male','L2Minion',40,21961,830,55.95,6.74,40,43,30,41,20,10,0,0,786,780,323,317,278,0,333,0,0,0,110,187,NULL,0,0,0,'LAST_HIT'),
	(25211,25211,'Sebek',0,'Raid Boss',0,'Monster.nos',26.00,42.00,36,'male','L2RaidBoss',40,174646,1975,191.35,7.70,60,57,73,76,70,80,1212311,142855,326,1405,65,570,278,0,3819,5130,0,0,29,275,NULL,0,0,0,'LAST_HIT'),
	(25212,25212,'Sebek''s Priest',0,'Raid Fighter',0,'Monster.zenta_lizardman_scout',11.00,30.00,35,'male','L2Minion',500,11763,955,49.14,7.70,40,43,30,41,20,10,0,0,879,678,105,275,249,0,333,279,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25213,25213,'Sebek''s Fanatic',0,'Raid Fighter',0,'Monster.dailaon',20.00,28.00,35,'male','L2Minion',500,8778,955,49.14,7.70,40,43,30,41,20,10,0,0,296,678,59,275,278,0,333,5127,0,0,19,187,NULL,0,0,0,'LAST_HIT'),
	(25214,25214,'Fafurion''s Page Sika',0,'Raid Boss',0,'Monster.water_giant',13.00,44.00,40,'male','L2RaidBoss',80,218810,2368,217.25,8.75,60,57,73,76,70,80,1091654,139773,287,1615,42,656,278,0,3819,5132,0,0,56,275,NULL,0,0,0,'LAST_HIT'),
	(25215,25215,'Sika''s Wizard',0,'Raid Fighter',0,'Monster.undine',12.00,27.00,39,'female','L2Minion',40,14713,1150,55.95,7.70,40,43,30,41,20,10,0,0,353,780,69,317,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25216,25216,'Sika''s Fighter',0,'Raid Fighter',0,'Monster.undine',12.00,27.00,39,'female','L2Minion',40,21961,1150,55.95,7.70,40,43,30,41,20,10,0,0,530,780,157,317,278,0,333,0,0,0,66,187,NULL,0,0,0,'LAST_HIT'),
	(25217,25217,'Cursed Clara',0,'Raid Boss',0,'Monster.medusa',10.00,25.00,50,'female','L2RaidBoss',40,369009,1722,285.12,7.70,60,57,73,76,70,80,1425270,224177,833,2226,206,904,278,0,3819,0,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25218,25218,'Clara''s Marksman',0,'Raid Fighter',0,'Monster.virud_lizardman_scout',10.00,22.00,49,'male','L2Minion',500,25080,830,73.90,6.74,40,43,30,41,20,10,0,0,2250,1079,328,438,249,0,333,2507,0,0,47,187,NULL,0,0,0,'LAST_HIT'),
	(25219,25219,'Clara''s Pawn',0,'Raid Fighter',0,'Monster.virud_lizardman_warrior',12.00,30.00,49,'male','L2Minion',40,18716,830,73.90,6.74,40,43,30,41,20,10,0,0,759,1079,184,438,278,0,333,94,0,0,57,187,NULL,0,0,0,'LAST_HIT'),
	(25220,25220,'Death Lord Hallate',0,'Raid Boss',0,'Monster.death_lord',21.00,40.00,73,'male','L2RaidBoss',40,924022,3274,847.28,9.81,60,57,73,76,70,80,2190219,1002134,8449,4017,12049,1631,278,0,3819,78,0,0,64,275,NULL,0,1,0,'LAST_HIT'),
	(25221,25221,'Death Mage Krician',0,'Raid Fighter',0,'Monster.death_blader',15.00,45.00,72,'male','L2Minion',40,64948,1601,224.99,9.81,40,43,30,41,20,10,0,0,10780,1966,20691,798,278,0,333,1472,0,0,110,187,NULL,0,1,0,'LAST_HIT'),
	(25222,25222,'Death Fighter Harik',0,'Raid Fighter',0,'Monster.death_knight',12.00,31.00,72,'male','L2Minion',40,96938,1601,224.99,9.81,40,43,30,41,20,10,0,0,16170,1966,46558,798,278,0,333,75,0,0,29,187,NULL,0,1,0,'LAST_HIT'),
	(25223,25223,'Soul Collector Acheron',0,'Raid Boss',0,'Monster.vale_master_50_bi',18.00,63.00,35,'male','L2RaidBoss',40,165289,1237,185.07,6.74,60,57,73,76,70,80,1018607,103175,200,1356,28,550,278,0,3819,192,0,0,113,259,NULL,0,0,0,'LAST_HIT'),
	(25224,25224,'Soul Slasher',0,'Raid Fighter',0,'Monster.dark_horror',20.00,35.00,34,'male','L2Minion',40,11143,589,47.49,6.74,40,43,30,41,20,10,0,0,246,654,46,265,278,0,333,0,0,0,110,154,NULL,0,1,0,'LAST_HIT'),
	(25225,25225,'Soul Strainer',0,'Raid Fighter',0,'Monster.hungry_spirit',30.00,40.00,34,'male','L2Minion',40,16632,531,47.49,5.72,40,43,30,41,20,10,0,0,369,654,104,265,278,0,333,0,0,0,16,170,NULL,0,1,0,'LAST_HIT'),
	(25226,25226,'Roaring Lord Kastor',0,'Raid Boss',0,'Monster.oel_mahum_witch_doctor_50_bi',22.50,54.00,62,'male','L2RaidBoss',40,768537,2502,712.52,8.75,60,57,73,76,70,80,3828086,679088,4510,3108,4959,1262,278,0,3819,186,0,0,113,291,NULL,0,0,0,'LAST_HIT'),
	(25227,25227,'Kastor''s Seer',0,'Raid Fighter',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,61,'male','L2Minion',40,79678,1217,187.91,8.75,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,333,9,0,0,77,187,NULL,0,0,0,'LAST_HIT'),
	(25228,25228,'Kastor''s Prefect',0,'Raid Fighter',0,'Monster.oel_mahum_warrior',20.00,38.00,61,'male','L2Minion',40,39839,1217,187.91,8.75,40,43,30,41,20,10,0,0,4297,1515,4800,615,278,0,333,79,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25229,25229,'Storm Winged Naga',0,'Raid Boss',0,'Monster.wyrm_50_bi',58.00,108.00,75,'male','L2RaidBoss',40,1891801,3420,849.66,9.81,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,3819,0,0,0,113,324,NULL,0,0,0,'LAST_HIT'),
	(25230,25230,'Timak Seer Ragoth',0,'Raid Boss',0,'Monster.batur_orc_shaman_50_bi',15.00,25.00,57,'male','L2RaidBoss',40,482650,2169,332.08,7.70,60,57,73,76,70,80,2036961,401639,2325,2723,1079,1106,278,0,3819,201,0,0,81,259,NULL,0,0,0,'LAST_HIT'),
	(25231,25231,'Ragoth''s Guard',0,'Raid Fighter',0,'Monster.batur_orc_warrior',10.00,20.00,56,'male','L2Minion',40,49626,1052,86.44,7.70,40,43,30,41,20,10,0,0,4299,1324,3954,537,278,0,333,74,657,0,88,192,NULL,0,0,0,'LAST_HIT'),
	(25232,25232,'Ragoth''s Herald',0,'Raid Fighter',0,'Monster.batur_orc',9.00,21.50,56,'male','L2Minion',40,24813,1052,86.44,7.70,40,43,30,41,20,10,0,0,2149,1324,988,537,278,0,333,74,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(25233,25233,'Spirit of Andras, the Betrayer',0,'Raid Boss',0,'Monster.headless_knight_50_bi',30.00,46.50,69,'male','L2RaidBoss',40,1256671,3643,368.40,9.81,60,57,73,76,70,80,2558623,621496,8956,3680,10177,1494,278,0,3819,2500,0,0,113,307,NULL,0,1,0,'LAST_HIT'),
	(25234,25234,'Ancient Weird Drake',0,'Raid Boss',0,'Monster.drake_50_bi',45.00,150.00,60,'male','L2RaidBoss',40,1052436,2707,362.57,8.75,60,57,73,76,70,80,2460640,581209,7676,3349,8563,1360,278,0,3819,0,0,0,113,275,NULL,0,0,0,'LAST_HIT'),
	(25235,25235,'Vanor Chief Kandra',0,'Raid Boss',0,'Monster.heltor_silenos_50_bi',19.00,43.50,72,'male','L2RaidBoss',40,912634,3202,847.28,9.81,60,57,73,76,70,80,2161728,977072,8186,3933,11639,1597,278,0,3819,135,0,0,55,291,NULL,0,0,0,'LAST_HIT'),
	(25236,25236,'Kandra''s Healer',0,'Raid Fighter',0,'Monster.heltor_silenos_shaman',13.00,32.00,71,'male','L2Minion',40,95688,1565,224.36,9.81,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,333,200,0,0,31,187,NULL,0,0,0,'LAST_HIT'),
	(25237,25237,'Kandra''s Guard',0,'Raid Fighter',0,'Monster.heltor_silenos_warrior',13.00,31.00,71,'male','L2Minion',40,47844,1565,224.36,9.81,40,43,30,41,20,10,0,0,7829,1924,11244,781,278,0,333,228,0,0,39,209,NULL,0,0,0,'LAST_HIT'),
	(25238,25238,'Abyss Brukunt',0,'Raid Boss',0,'Monster.drake_50_bi',45.00,150.00,59,'male','L2RaidBoss',40,512194,2846,365.85,8.75,60,57,73,76,70,80,2508399,600107,4130,3513,2312,1427,278,0,3819,0,0,0,113,299,NULL,0,0,0,'LAST_HIT'),
	(25239,25239,'Monstrous Beast of Abyss Brukunt',0,'Raid Fighter',0,'Monster.hunter_gargoyle',10.00,56.00,58,'male','L2Minion',40,52860,1388,96.74,8.75,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,333,0,0,0,11,187,NULL,0,0,0,'LAST_HIT'),
	(25240,25240,'Wild Beast of Abyss Brukunt',0,'Raid Fighter',0,'Monster.saber_toothed_tiger',34.00,28.00,58,'male','L2Minion',40,26430,1388,96.74,8.75,40,43,30,41,20,10,0,0,3923,1715,2213,696,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25241,25241,'Harit Hero Tamash',0,'Raid Boss',0,'Monster.zenta_lizardman_warrior_50_bi',18.00,53.00,55,'male','L2RaidBoss',40,624464,2639,592.29,8.75,60,57,73,76,70,80,2988757,448385,2471,2576,1817,1046,278,0,3819,298,0,0,64,283,NULL,0,0,0,'LAST_HIT'),
	(25242,25242,'Tamash''s Advisor',0,'Raid Fighter',0,'Monster.zenta_lizardman_shaman',13.00,35.00,54,'male','L2Minion',40,42806,1285,153.99,8.75,40,43,30,41,20,10,0,0,3036,1252,2944,508,278,0,333,193,0,0,47,170,NULL,0,0,0,'LAST_HIT'),
	(25243,25243,'Tamash''s Servant',0,'Raid Fighter',0,'Monster.zenta_lizardman',11.00,32.00,54,'male','L2Minion',40,63890,1285,153.99,8.75,40,43,30,41,20,10,0,0,4554,1252,6625,508,278,0,333,234,0,0,40,187,NULL,0,0,0,'LAST_HIT'),
	(25244,25244,'Last Lesser Giant Olkuth',0,'Raid Boss',0,'Monster.lesser_giant_50_bi',31.50,69.00,75,'male','L2RaidBoss',40,1891801,3420,742.51,9.81,60,57,73,76,70,80,4832156,847950,15764,4188,39730,1701,278,0,3819,78,0,0,24,226,NULL,0,0,0,'LAST_HIT'),
	(25245,25245,'Last Lesser Giant Glaki',0,'Raid Boss',0,'Monster.lesser_giant_mage_50_bi',30.00,66.00,78,'male','L2RaidBoss',40,977229,3643,687.11,9.81,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,278,0,3819,179,0,0,24,153,NULL,0,0,0,'LAST_HIT'),
	(25246,25246,'Glaki''s Henchman',0,'Raid Fighter',0,'Monster.lesser_giant',21.00,44.00,77,'male','L2Minion',40,102704,1784,182.77,9.81,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,333,169,0,0,16,165,NULL,0,0,0,'LAST_HIT'),
	(25247,25247,'Glaki''s Servant',0,'Raid Fighter',0,'Monster.lesser_giant',21.00,44.00,77,'male','L2Minion',40,51352,1784,182.77,9.81,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,333,166,0,0,16,154,NULL,0,0,0,'LAST_HIT'),
	(25248,25248,'Doom Blade Tanatos',0,'Raid Boss',0,'Monster3.Death_Blader_Raid',15.00,32.50,72,'male','L2RaidBoss',40,1825269,3274,688.51,9.81,60,57,73,76,70,80,4362668,764172,13026,3933,26791,1597,278,0,3819,0,0,0,162,291,NULL,0,1,0,'LAST_HIT'),
	(25249,25249,'Palatanos of Horrific Power',0,'Raid Boss',0,'Monster3.Jungle_Bleeze',50.00,50.00,75,'male','L2RaidBoss',40,945900,3420,742.51,9.81,60,57,73,76,70,80,4832156,847950,7882,4188,9932,1701,278,0,3819,0,0,0,89,267,NULL,0,0,0,'LAST_HIT'),
	(25250,25250,'Man-Eating Plant of Palatanos',0,'Raid Fighter',0,'Monster.mandragora_a',11.00,20.00,74,'male','L2Minion',40,66547,1673,197.18,9.81,40,43,30,41,20,10,0,0,10072,2051,17077,833,278,0,333,0,0,0,99,187,NULL,0,0,0,'LAST_HIT'),
	(25251,25251,'Sapling of Palatanos',0,'Raid Fighter',0,'Monster.mandragora_a',10.00,25.00,74,'male','L2Minion',40,99324,1673,197.18,9.81,40,43,30,41,20,10,0,0,15109,2051,38427,833,278,0,333,145,629,0,44,192,NULL,0,1,0,'LAST_HIT'),
	(25252,25252,'Palibati Queen Themis',0,'Raid Boss',0,'Monster.cave_maiden_50_bi',37.00,98.00,70,'female','L2RaidBoss',40,888658,3058,738.73,9.81,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,3819,234,0,0,113,259,NULL,0,0,0,'LAST_HIT'),
	(25253,25253,'Handmaiden of Themis',0,'Raid Fighter',0,'Monster.succubus',10.00,36.00,69,'female','L2Minion',40,62338,1493,195.65,8.75,40,43,30,41,20,10,0,0,7862,1840,12062,747,278,0,333,0,0,0,66,165,NULL,0,0,0,'LAST_HIT'),
	(25254,25254,'Themis''s Sentinel',0,'Raid Fighter',0,'Monster.death_blader',15.00,45.00,69,'male','L2Minion',40,93041,1493,195.65,8.75,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,333,1472,0,0,110,187,NULL,0,1,0,'LAST_HIT'),
	(25255,25255,'Gargoyle Lord Tiphon',0,'Raid Boss',0,'Monster.hunter_gargoyle_50_bi',37.00,98.00,65,'male','L2RaidBoss',40,1637918,2707,673.33,8.75,60,57,73,76,70,80,3674504,679343,9313,3349,17189,1360,278,0,3819,0,0,0,162,291,NULL,0,0,0,'LAST_HIT'),
	(25256,25256,'Taik High Prefect Arak',0,'Raid Boss',0,'Monster.ketra_orc_warrior_50_bi',18.00,37.00,60,'male','L2RaidBoss',40,526218,2368,351.19,8.75,60,57,73,76,70,80,2091330,424759,2895,2951,1474,1198,278,0,3819,71,0,0,58,283,NULL,0,0,0,'LAST_HIT'),
	(25257,25257,'Arak''s Archer',0,'Raid Fighter',0,'Monster.ketra_orc_archer',12.00,27.00,59,'male','L2Minion',500,36451,1150,91.59,7.70,40,43,30,41,20,10,0,0,7797,1437,2314,583,249,0,333,283,0,0,49,176,NULL,0,0,0,'LAST_HIT'),
	(25258,25258,'Arak''s Footman',0,'Raid Fighter',0,'Monster.ketra_orc',12.00,29.00,59,'male','L2Minion',40,27202,1150,91.59,7.70,40,43,30,41,20,10,0,0,2632,1437,1302,583,278,0,333,127,0,0,49,192,NULL,0,0,0,'LAST_HIT'),
	(25259,25259,'Zaken''s Butcher Krantz',0,'Raid Boss',0,'Monster.ogre_50_bi',30.00,66.00,55,'male','L2RaidBoss',40,1248928,2039,592.29,7.70,60,57,73,76,70,80,2988757,448385,4942,2576,7268,1046,278,0,3819,297,0,0,35,259,NULL,0,0,0,'LAST_HIT'),
	(25260,25260,'Iron Giant Totem',0,'Raid Boss',0,'Monster3.Steel_Trapper',27.00,52.00,45,'male','L2RaidBoss',40,392985,1722,465.93,7.70,60,57,73,76,70,80,2377188,267898,974,1905,466,774,278,0,3819,0,0,0,32,81,NULL,0,0,0,'LAST_HIT'),
	(25261,25261,'Totem Guard Archer',0,'Raid Fighter',0,'Monster.batur_orc_archer',11.00,21.50,44,'male','L2Minion',500,26454,830,120.36,6.74,40,43,30,41,20,10,0,0,2613,922,736,374,249,0,333,282,0,0,49,187,NULL,0,0,0,'LAST_HIT'),
	(25262,25262,'Totem Guard',0,'Raid Fighter',0,'Monster.batur_orc',9.00,21.50,44,'male','L2Minion',40,19741,830,120.36,6.74,40,43,30,41,20,10,0,0,882,922,414,374,278,0,333,215,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(25263,25263,'Kernon''s Faithful Servant Kelone',0,'Raid Boss',0,'Monster.medusa_100_bi',37.00,52.00,67,'female','L2RaidBoss',40,848789,2846,679.47,8.75,60,57,73,76,70,80,3745918,701317,5015,3513,4648,1427,278,0,3819,0,0,0,113,267,NULL,0,1,0,'LAST_HIT'),
	(25264,25264,'Kelone''s Assassin',0,'Raid Fighter',0,'Monster.skeleton_royal_guard',11.00,28.50,66,'male','L2Minion',40,59369,1388,179.66,8.75,40,43,30,41,20,10,0,0,6346,1715,7898,696,278,0,333,229,0,0,88,209,NULL,0,1,0,'LAST_HIT'),
	(25265,25265,'Kelone''s Secret Knight',0,'Raid Fighter',0,'Monster.skeleton_royal_guard',11.00,28.00,66,'male','L2Minion',40,88610,1388,179.66,8.75,40,43,30,41,20,10,0,0,9520,1715,17773,696,278,0,333,0,0,0,77,198,NULL,0,1,0,'LAST_HIT'),
	(25266,25266,'Bloody Empress Decarbia',0,'Raid Boss',0,'Monster3.lidia_von_helmann_120p',21.00,26.00,75,'female','L2RaidBoss',40,945900,3420,849.66,9.81,60,57,73,76,70,80,2238750,1054472,8986,4188,12912,1701,278,0,1972,8209,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25267,25267,'Decarbia''s Royal Guard',0,'Raid Fighter',0,'Monster.death_knight',12.00,31.00,74,'male','L2Minion',40,49662,1673,225.62,9.81,40,43,30,41,20,10,0,0,8608,2051,12471,833,278,0,333,5286,0,0,29,220,NULL,0,1,0,'LAST_HIT'),
	(25268,25268,'Decarbia''s Escort',0,'Raid Fighter',0,'Monster.skeleton_royal_guard',11.00,28.50,74,'male','L2Minion',40,99324,1673,225.62,9.81,40,43,30,41,20,10,0,0,17216,2051,49884,833,278,0,333,234,0,0,88,231,NULL,0,1,0,'LAST_HIT'),
	(25269,25269,'Beast Lord Behemoth',0,'Raid Boss',0,'Monster3.Elder_Troll',30.00,72.50,70,'male','L2RaidBoss',40,888658,3058,738.73,9.81,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,278,0,3819,0,0,0,89,291,NULL,0,0,12,'LAST_HIT'),
	(25270,25270,'Behemoth Javeliner',0,'Raid Fighter',0,'Monster.virud_lizardman_scout',10.00,22.00,69,'male','L2Minion',500,62338,1493,195.65,8.75,40,43,30,41,20,10,0,0,17470,1840,12062,747,249,0,333,2507,0,0,47,187,NULL,0,0,0,'LAST_HIT'),
	(25271,25271,'Behemoth Flare',0,'Raid Fighter',0,'Monster.will_o_wisp',13.00,22.00,69,'male','L2Minion',40,46520,1493,195.65,8.75,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,333,0,0,0,88,181,NULL,0,0,0,'LAST_HIT'),
	(25272,25272,'Partisan Leader Talakin',0,'Raid Boss',0,'Monster.ol_mahum_champion_50_bi',21.00,43.50,28,'male','L2RaidBoss',40,233163,1415,143.80,6.74,60,57,73,76,70,80,879287,99579,286,1044,86,424,278,0,3819,77,0,0,81,307,NULL,0,0,0,'LAST_HIT'),
	(25273,25273,'Carnamakos',0,'Raid Boss',0,'Monster3.Steel_Trapper',27.00,52.00,50,'male','L2RaidBoss',40,507285,2104,651.10,7.70,60,57,73,76,70,80,3230613,486967,2902,2649,2636,1075,278,0,3819,0,0,0,32,81,NULL,0,0,0,'LAST_HIT'),
	(25274,25274,'Carnabarun',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,49,'male','L2Minion',40,34424,1019,169.38,7.70,40,43,30,41,20,10,0,0,3572,1288,4283,523,278,0,333,0,0,0,99,187,NULL,0,0,0,'LAST_HIT'),
	(25275,25275,'Carnassiud',0,'Raid Fighter',0,'Monster.field_stalker',15.00,30.00,49,'male','L2Minion',40,51380,1019,169.38,7.70,40,43,30,41,20,10,0,0,5359,1288,9639,523,278,0,333,0,0,0,77,187,NULL,0,0,0,'LAST_HIT'),
	(25276,25276,'Death Lord Ipos',0,'Raid Boss',0,'Monster.death_lord_50_bi',31.00,61.50,75,'male','L2RaidBoss',40,1891801,3420,849.66,9.81,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,3819,78,0,0,64,307,NULL,0,1,0,'LAST_HIT'),
	(25277,25277,'Lilith''s Witch Marilion',0,'Raid Boss',0,'Monster.bloody_queen_50_bi',21.00,64.00,50,'female','L2RaidBoss',40,507285,1722,570.25,7.70,60,57,73,76,70,80,2672375,365590,1658,2226,1143,904,278,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25278,25278,'Dead Soul of Stigma',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,49,'male','L2Minion',40,51380,830,147.79,6.74,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,333,0,0,0,99,198,NULL,0,0,0,'LAST_HIT'),
	(25279,25279,'Evil Spirit of Stigma',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,49,'male','L2Minion',40,25690,830,147.79,6.74,40,43,30,41,20,10,0,0,1510,1079,1023,438,278,0,333,0,0,0,99,198,NULL,0,0,0,'LAST_HIT'),
	(25280,25280,'Pagan Watcher Cerberon',0,'Raid Boss',0,'Monster.kel_mahum_champion_50_bi',19.00,48.00,55,'male','L2RaidBoss',40,1248928,2039,637.86,7.70,60,57,73,76,70,80,3202235,477279,5426,2576,9639,1046,278,0,3819,75,0,0,81,340,NULL,0,0,0,'LAST_HIT'),
	(25281,25281,'Anakim''s Nemesis Zakaron',0,'Raid Boss',0,'Monster.karik_50_bi',37.00,136.50,70,'male','L2RaidBoss',40,1777317,3058,738.73,9.81,60,57,73,76,70,80,4135551,777993,12444,3764,28565,1528,278,0,3819,0,0,0,59,348,NULL,0,0,0,'LAST_HIT'),
	(25282,25282,'Death Lord Shax',0,'Raid Boss',0,'Monster.death_lord_50_bi',31.00,61.50,75,'male','L2RaidBoss',40,1891801,3420,849.66,9.81,60,57,73,76,70,80,2238750,1054472,17973,4188,51648,1701,278,0,3819,2500,0,0,64,340,NULL,0,1,0,'LAST_HIT'),
	(25283,25283,'Lilith',0,'Raid Boss',0,'Monster2.lilith',42.50,55.00,80,'female','L2RaidBoss',40,1639146,3793,842.52,9.81,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,3819,0,0,0,72,324,NULL,0,0,12,'FULL_PARTY'),
	(25284,25284,'Lilith''s Agent',0,'Raid Fighter',0,'Monster2.lilim_wizard',9.00,34.00,79,'female','L2Minion',40,115440,1859,224.36,9.81,40,43,30,41,20,10,0,0,13316,2265,26386,919,278,0,333,0,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25285,25285,'Lilith''s Escort',0,'Raid Fighter',0,'Monster2.lilim_knight',12.00,50.00,79,'male','L2Minion',40,172299,1859,224.36,9.81,40,43,30,41,20,10,0,0,19974,2265,59372,919,278,0,333,5800,5799,0,61,242,NULL,0,0,0,'LAST_HIT'),
	(25286,25286,'Anakim',0,'Raid Boss',0,'Monster2.anakim',15.50,29.00,80,'female','L2RaidBoss',40,1639146,3793,842.52,9.81,60,57,73,76,70,80,2374400,1196456,10404,4615,15367,1874,278,0,3819,0,0,0,72,324,NULL,0,0,12,'FULL_PARTY'),
	(25287,25287,'Anakim''s Guardian',0,'Raid Fighter',0,'Monster2.nephilim_priest',23.00,40.50,79,'male','L2Minion',40,172299,1859,224.36,9.81,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,333,0,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25288,25288,'Anakim''s Royal Guard',0,'Raid Fighter',0,'Monster2.nephilim_lord',10.00,41.50,79,'male','L2Minion',40,86149,1859,224.36,9.81,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,333,0,0,0,71,242,NULL,0,0,0,'LAST_HIT'),
	(25289,25289,'Anakim''s Executor',0,'',0,'Monster2.nephilim_slayer',12.00,36.00,79,'male','L2Minion',40,86149,1859,224.36,9.81,40,43,30,41,20,10,0,0,9987,2265,14843,919,278,0,333,0,0,0,71,209,NULL,0,0,0,'LAST_HIT'),
	(25290,25290,'Daimon the White-Eyed',0,'Raid Boss',0,'Monster2.hundred_eye',21.00,55.00,78,'male','L2RaidBoss',40,977229,3718,844.90,9.81,60,57,73,76,70,80,2318004,1136977,9824,4444,14332,1805,409,0,3819,0,0,0,48,307,NULL,0,0,0,'LAST_HIT'),
	(25291,25291,'Family of Daimon',0,'Raid Fighter',0,'Monster.field_stalker',15.00,30.00,77,'male','L2Minion',40,68811,1859,224.99,9.81,40,43,30,41,20,10,0,0,12565,2179,24607,885,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25292,25292,'Family of Daimon',0,'Raid Fighter',0,'Monster2.parasitic_eye',25.00,63.00,77,'male','L2Minion',40,102704,1859,224.99,9.81,40,43,30,41,20,10,0,0,9424,2179,13842,885,278,0,333,0,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25293,25293,'Hestia, Guardian Deity of the Hot Springs',0,'Raid Boss',0,'Monster.pixy_bi',10.00,54.00,78,'female','L2RaidBoss',40,977229,3718,687.11,9.81,60,57,73,76,70,80,4671563,943547,7940,4444,8508,1805,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25294,25294,'Fighter of Hestia',0,'Raid Fighter',0,'Monster.yeti',15.00,27.50,77,'male','L2Minion',40,102704,1859,182.77,9.81,40,43,30,41,20,10,0,0,15250,2179,32949,885,278,0,333,0,0,0,17,209,NULL,0,0,0,'LAST_HIT'),
	(25295,25295,'Follower of Hestia',0,'Raid Fighter',0,'Monster.yeti',15.00,27.50,77,'male','L2Minion',40,51352,1859,182.77,9.81,40,43,30,41,20,10,0,0,7625,2179,8237,885,278,0,333,0,0,0,17,209,NULL,0,0,0,'LAST_HIT'),
	(25296,25296,'Icicle Emperor Bumbalump',0,'Raid Boss',0,'Monster.yeti_20_bi',18.00,32.00,74,'male','L2RaidBoss',40,935092,3718,849.66,9.81,60,57,73,76,70,80,2212304,1028870,8715,4103,12471,1666,409,0,3819,0,0,0,25,307,NULL,0,0,0,'LAST_HIT'),
	(25297,25297,'Icicle Giant',0,'Raid Fighter',0,'Monster.stone_golem',20.00,31.00,73,'male','L2Minion',40,65759,1859,224.99,9.81,40,43,30,41,20,10,0,0,11127,2008,21420,815,278,0,333,0,0,0,25,209,NULL,0,0,0,'LAST_HIT'),
	(25298,25298,'Icicle Giant',0,'Raid Fighter',0,'Monster.stone_golem',20.00,31.00,73,'male','L2Minion',40,98148,1859,224.99,9.81,40,43,30,41,20,10,0,0,16691,2008,48198,815,278,0,333,0,0,0,25,209,NULL,0,0,0,'LAST_HIT'),
	(25299,25299,'Ketra''s Hero Hekaton',0,'Raid Boss',0,'Monster2.ketra_orc_chieftain_20_bi',17.00,46.20,80,'male','L2RaidBoss',40,714778,3718,368.11,9.81,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,3819,6719,0,0,38,307,NULL,0,0,0,'LAST_HIT'),
	(25300,25300,'Scout of Hekaton',0,'Raid Fighter',0,'Monster.ketra_orc_archer',12.00,27.00,79,'male','L2Minion',500,50349,1859,98.02,9.81,40,43,30,41,20,10,0,0,19811,2265,7884,919,278,0,333,288,0,0,49,209,NULL,0,0,0,'LAST_HIT'),
	(25301,25301,'Servant of Hekaton',0,'Raid Fighter',0,'Monster.ketra_orc',12.00,29.00,79,'male','L2Minion',40,37574,1859,98.02,9.81,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,333,79,0,0,49,209,NULL,0,0,0,'LAST_HIT'),
	(25302,25302,'Ketra''s Commander Tayr',0,'Raid Boss',0,'Monster2.ketra_orc_warlord_20_bi',15.00,36.00,84,'male','L2RaidBoss',40,743801,3718,362.02,9.81,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,3819,80,0,0,43,307,NULL,0,0,0,'LAST_HIT'),
	(25303,25303,'Tayr''s Aide',0,'Raid Fighter',0,'Monster.ketra_orc_shaman',10.00,23.00,83,'male','L2Minion',40,52409,1859,96.62,9.81,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,213,0,0,11,209,NULL,0,0,0,'LAST_HIT'),
	(25304,25304,'Tayr''s Guard',0,'Raid Fighter',0,'Monster.ketra_orc',12.00,29.00,83,'male','L2Minion',40,78223,1859,96.62,9.81,40,43,30,41,20,10,0,0,15123,2434,20916,988,278,0,333,79,6919,0,49,209,NULL,0,0,0,'LAST_HIT'),
	(25305,25305,'Ketra''s Chief Brakki',0,'Raid Boss',0,'Monster2.ketra_warbeast',20.00,33.50,87,'male','L2RaidBoss',40,1532678,3718,355.43,9.81,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,3819,0,0,0,42,307,NULL,0,0,0,'LAST_HIT'),
	(25306,25306,'Soul of Fire Nastron',0,'Raid Boss',0,'Monster2.ifrit',10.00,42.00,87,'male','L2RaidBoss',40,534922,3718,355.43,9.81,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,3819,0,0,0,61,307,NULL,0,0,0,'LAST_HIT'),
	(25307,25307,'Family of Nastron',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,86,'male','L2Minion',40,56256,1859,95.02,9.81,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25308,25308,'Family of Nastron',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,86,'male','L2Minion',40,28128,1859,95.02,9.81,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25309,25309,'Varka''s Hero Shadith',0,'Raid Boss',0,'Monster2.barka_silenos_shaman_20_bi',17.00,47.50,80,'male','L2RaidBoss',40,714778,3718,368.11,9.81,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,3819,6716,0,0,58,307,NULL,0,0,0,'LAST_HIT'),
	(25310,25310,'Shadith''s Royal Guard Captain',0,'Raid Fighter',0,'Monster2.barka_silenos_warrior',16.00,41.00,79,'male','L2Minion',40,75148,1859,98.02,9.81,40,43,30,41,20,10,0,0,13374,2265,17740,919,278,0,333,142,6918,0,37,209,NULL,0,0,0,'LAST_HIT'),
	(25311,25311,'Shadith''s Sentinel',0,'Raid Fighter',0,'Monster2.barka_silenos_hunter',16.00,38.00,79,'male','L2Minion',40,37574,1859,98.02,9.81,40,43,30,41,20,10,0,0,6687,2265,4435,919,278,0,333,2504,0,0,48,209,NULL,0,0,0,'LAST_HIT'),
	(25312,25312,'Varka''s Commander Mos',0,'Raid Boss',0,'Monster2.barka_silenos_chieftain_20_bi',22.00,51.00,84,'male','L2RaidBoss',40,743801,3718,362.02,9.81,60,57,73,76,70,80,3379556,898478,7856,4952,5408,2011,409,0,3819,2500,0,0,40,307,NULL,0,0,0,'LAST_HIT'),
	(25313,25313,'Mos'' Aide',0,'Raid Fighter',0,'Monster2.barka_silenos_priest',9.00,41.50,83,'male','L2Minion',40,78223,1859,96.62,9.81,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,333,6716,0,0,39,209,NULL,0,0,0,'LAST_HIT'),
	(25314,25314,'Mos'' Guard',0,'Raid Fighter',0,'Monster2.barka_silenos_hunter',16.00,38.00,83,'male','L2Minion',40,39111,1859,96.62,9.81,40,43,30,41,20,10,0,0,7561,2434,5229,988,278,0,333,142,0,0,48,209,NULL,0,0,0,'LAST_HIT'),
	(25315,25315,'Varka''s Chief Horus',0,'Raid Boss',0,'Monster2.barka_silenos_chieftain_20_bi',22.00,51.00,87,'male','L2RaidBoss',40,1532678,3718,355.43,9.81,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,3819,2500,0,0,40,307,NULL,0,0,0,'LAST_HIT'),
	(25316,25316,'Soul of Water Ashutar',0,'Raid Boss',0,'Monster.undine',12.00,27.00,87,'female','L2RaidBoss',40,534922,3718,355.43,9.81,60,57,73,76,70,80,3526018,952059,8503,5200,6040,2112,409,0,3819,0,0,0,97,307,NULL,0,0,0,'LAST_HIT'),
	(25317,25317,'Family of Ashutar',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,86,'male','L2Minion',40,56256,1859,95.02,9.81,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25318,25318,'Family of Ashutar',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,86,'male','L2Minion',40,28128,1859,95.02,9.81,40,43,30,41,20,10,0,0,8196,2559,5840,1039,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25319,25319,'Ember',0,'Raid Boss',0,'Monster2.inferno_drake_100_bi',48.00,73.00,85,'male','L2RaidBoss',40,1048567,3718,823.48,9.81,60,57,73,76,70,80,2535975,1356048,11906,5036,18324,2045,409,0,3819,0,0,0,92,307,NULL,0,0,13,'FULL_PARTY'),
	(25320,25320,'Sentinel of Ember',0,'Raid Fighter',0,'Monster2.lava_golem',22.00,45.00,84,'male','L2Minion',40,73883,1859,219.94,9.81,40,43,30,41,20,10,0,0,15276,2476,31447,1005,278,0,333,0,0,0,14,209,NULL,0,0,0,'LAST_HIT'),
	(25321,25321,'Messenger of Ember',0,'Raid Fighter',0,'Monster2.ifrit',10.00,42.00,84,'male','L2Minion',40,110274,1859,219.94,9.81,40,43,30,41,20,10,0,0,11457,2476,17689,1005,278,0,333,0,0,0,41,209,NULL,0,0,0,'LAST_HIT'),
	(25322,25322,'Demon''s Agent Falston',0,'Raid Boss',0,'Monster2.vampire_warrior',9.00,31.50,66,'male','L2RaidBoss',40,834231,3718,833.00,9.81,60,57,73,76,70,80,1838232,828036,6092,3431,7808,1393,409,0,3819,6723,0,0,69,307,NULL,0,0,0,'LAST_HIT'),
	(25323,25323,'Falston''s Disciple',0,'Raid Fighter',0,'Monster2.vampire_wizard',5.50,28.00,65,'female','L2Minion',40,58282,1859,219.94,9.81,40,43,30,41,20,10,0,0,7744,1674,13406,680,278,0,333,99,0,0,50,209,NULL,0,0,0,'LAST_HIT'),
	(25324,25324,'Servant of Falston',0,'Raid Fighter',0,'Monster2.black_magician',8.00,30.00,65,'male','L2Minion',40,86988,1859,219.94,9.81,40,43,30,41,20,10,0,0,11616,1674,30166,680,278,0,333,178,0,0,20,209,NULL,0,0,0,'LAST_HIT'),
	(25325,25325,'Flame of Splendor Barakiel',0,'Raid Boss',0,'Monster2.apostle_warrior',8.00,30.00,70,'female','L2RaidBoss',40,888658,3718,738.73,9.81,60,57,73,76,70,80,4135551,777993,6222,3764,7141,1528,409,0,3819,6717,0,0,81,307,NULL,0,0,0,'LAST_HIT'),
	(25326,25326,'Barakiel''s Disciple',0,'Raid Fighter',0,'Monster2.apostle_mage',11.00,38.50,69,'male','L2Minion',40,93041,1859,195.65,9.81,40,43,30,41,20,10,0,0,11794,1840,27141,747,278,0,333,6718,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25327,25327,'Barakiel''s Acolyte',0,'Raid Fighter',0,'Monster2.apostle_mage',11.00,38.50,69,'male','L2Minion',40,46520,1859,195.65,9.81,40,43,30,41,20,10,0,0,5897,1840,6785,747,278,0,333,6718,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25328,25328,'Eilhalder von Hellmann',0,'Raid Boss',0,'Monster2.vampire_lord',7.50,25.80,71,'male','L2RaidBoss',40,900867,3718,844.90,9.81,60,57,73,76,70,80,2142425,952990,7927,3848,11244,1562,409,0,3819,0,0,0,24,307,NULL,0,0,12,'PARTY_ONE_RANDOM'),
	(25329,25329,'Violet',0,'Raid Fighter',0,'Monster2.vampire_witch',6.00,21.50,70,'female','L2Minion',40,63242,1859,224.36,9.81,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,333,946,0,0,70,209,NULL,0,0,0,'LAST_HIT'),
	(25330,25330,'Kurstin',0,'Raid Fighter',0,'Monster2.vampire_witch',6.00,21.50,70,'female','L2Minion',40,63242,1859,224.36,9.81,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,333,946,0,0,70,209,NULL,0,0,0,'LAST_HIT'),
	(25331,25331,'Mina',0,'Raid Fighter',0,'Monster2.vampire_witch',6.00,21.50,70,'female','L2Minion',40,63242,1859,224.36,9.81,40,43,30,41,20,10,0,0,9193,1882,15976,764,278,0,333,946,0,0,70,209,NULL,0,0,0,'LAST_HIT'),
	(25332,25332,'Dorian',0,'Raid Fighter',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Minion',40,94391,1859,224.36,9.81,40,43,30,41,20,10,0,0,13791,1882,35947,764,278,0,333,234,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25333,25333,'Anakazel',0,'Invaders'' Leader',0,'Monster.dre_vanul_bi_one',21.00,54.00,28,'male','L2Boss',40,193763,3718,123.26,9.81,60,57,73,76,70,80,629182,56542,163,1044,32,424,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25334,25334,'Anakazel',0,'Invaders'' Leader',0,'Monster.dre_vanul_bi_one',21.00,54.00,38,'male','L2Boss',40,306698,3718,175.00,9.81,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25335,25335,'Anakazel',0,'Invaders'' Leader',0,'Monster.kaim_vanul_20_bi',28.00,48.00,48,'male','L2Boss',40,494363,3718,232.65,9.81,60,57,73,76,70,80,1173349,137957,1205,2094,514,850,409,0,3819,0,0,0,59,307,NULL,0,0,0,'LAST_HIT'),
	(25336,25336,'Anakazel',0,'Invaders'' Leader',0,'Monster.kaim_vanul_20_bi',28.00,48.00,58,'male','L2Boss',40,705074,3718,290.19,9.81,60,57,73,76,70,80,1470377,229005,2848,2798,1790,1136,409,0,3819,0,0,0,59,307,NULL,0,0,0,'LAST_HIT'),
	(25337,25337,'Anakazel',0,'Invaders'' Leader',0,'Monster.karik',25.00,90.00,68,'male','L2Boss',40,865808,3718,314.76,9.81,60,57,73,76,70,80,1812663,349493,4854,3596,3563,1460,409,0,3819,0,0,0,59,307,NULL,0,0,0,'LAST_HIT'),
	(25338,25338,'Anakazel',0,'Invaders'' Leader',0,'Monster.karik',25.00,90.00,78,'male','L2Boss',40,977523,3718,317.14,9.81,60,57,73,76,70,80,2238492,462266,7410,4444,6271,1805,409,0,3819,0,0,0,59,307,NULL,0,0,13,'FULL_PARTY'),
	(25339,25339,'Shadow of Halisha',0,'Ruler of Sepulcher',0,'Monster2.halisha_a',23.00,60.00,81,'female','L2RaidBoss',500,503921,3718,308.57,9.81,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,69,307,NULL,0,0,0,'LAST_HIT'),
	(25340,25340,'Knight of Shadow',0,'',0,'Monster.vale_master',12.00,40.00,80,'male','L2Minion',40,52995,1859,82.40,9.81,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25341,25341,'Knight of Shadow',0,'',0,'Monster2.eligor',21.00,35.00,80,'male','L2Minion',40,26497,1859,82.40,9.81,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,333,0,0,0,38,209,NULL,0,0,0,'LAST_HIT'),
	(25342,25342,'Shadow of Halisha',0,'Ruler of Sepulcher',0,'Monster2.halisha_b',23.00,60.00,81,'female','L2RaidBoss',500,503921,3718,308.57,9.81,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,69,307,NULL,0,0,0,'LAST_HIT'),
	(25343,25343,'Knight of Shadow',0,'',0,'Monster.vale_master',12.00,40.00,80,'male','L2Minion',40,52995,1859,82.40,9.81,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25344,25344,'Knight of Shadow',0,'',0,'Monster.fiend_archer',17.00,55.00,80,'male','L2Minion',500,35507,1859,82.40,9.81,40,43,30,41,20,10,0,0,12691,2419,3381,982,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25345,25345,'Knight of shadow',0,'',0,'Monster2.lilim_wizard',9.00,34.00,80,'female','L2Minion',40,35507,1859,82.40,9.81,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,333,0,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25346,25346,'Shadow of Halisha',0,'Ruler of Sepulcher',0,'Monster2.halisha_c',23.00,60.00,81,'female','L2RaidBoss',500,503921,3718,308.57,9.81,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,69,307,NULL,0,0,0,'LAST_HIT'),
	(25347,25347,'Knight of Shadow',0,'',0,'Monster2.lilim_wizard',9.00,34.00,80,'female','L2Minion',40,35507,1859,82.40,9.81,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,333,0,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25348,25348,'Knight of Shadow',0,'',0,'Monster.death_lord',21.00,40.00,80,'male','L2Minion',40,52995,1859,82.40,9.81,40,43,30,41,20,10,0,0,8567,2419,7608,982,278,0,333,78,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25349,25349,'Shadow of Halisha',0,'Ruler of Sepulcher',0,'Monster2.halisha_d',23.00,60.00,81,'female','L2RaidBoss',500,503921,3718,308.57,9.81,60,57,73,76,70,80,2226652,523301,4473,4920,1989,1998,409,0,3819,6720,0,0,69,307,NULL,0,0,0,'LAST_HIT'),
	(25350,25350,'Knight of Shadow',0,'',0,'Monster2.lilim_wizard',9.00,34.00,80,'female','L2Minion',40,35507,1859,82.40,9.81,40,43,30,41,20,10,0,0,5711,2419,3381,982,278,0,333,0,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25351,25351,'Knight of Shadow',0,'',0,'Monster.vale_master',12.00,40.00,80,'male','L2Minion',40,52995,1859,82.40,9.81,40,43,30,41,20,10,0,0,4283,2419,1902,982,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25352,25352,'Giant Wasteland Basilisk',0,'Raid Boss',0,'Monster.lesser_basilisk',34.00,25.00,30,'male','L2RaidBoss',40,127782,3718,132.92,9.81,60,57,73,76,70,80,636918,59660,96,1127,9,458,409,0,3819,0,0,0,56,307,NULL,0,0,0,'LAST_HIT'),
	(25353,25353,'Giant Wasteland Basilisk',0,'Raid Fighter',0,'Monster.lesser_basilisk_sm',32.00,22.00,29,'male','L2Minion',40,12952,1859,34.00,9.81,40,43,30,41,20,10,0,0,174,542,35,220,278,0,333,0,0,0,38,209,NULL,0,0,0,'LAST_HIT'),
	(25354,25354,'Gargoyle Lord Sirocco',0,'Raid Boss',0,'Monster.gargoyle_bi',16.00,65.00,35,'male','L2RaidBoss',40,165289,3718,185.07,9.81,60,57,73,76,70,80,1193687,138419,300,1356,59,550,409,0,3819,0,0,0,226,307,NULL,0,0,0,'LAST_HIT'),
	(25355,25355,'Sirocco''s Gargoyle',0,'Raid Fighter',0,'Monster.gargoyle',16.00,50.00,34,'male','L2Minion',40,8316,1859,47.49,9.81,40,43,30,41,20,10,0,0,277,654,55,265,278,0,333,0,0,0,154,209,NULL,0,0,0,'LAST_HIT'),
	(25356,25356,'Sirocco''s Guards',0,'Raid Fighter',0,'Monster.gargoyle',16.00,50.00,34,'male','L2Minion',40,16632,1859,47.49,9.81,40,43,30,41,20,10,0,0,554,654,220,265,278,0,333,0,0,0,154,209,NULL,0,0,0,'LAST_HIT'),
	(25357,25357,'Sukar Wererat Chief',0,'Raid Boss',0,'Monster.wererat',14.00,25.00,21,'male','L2RaidBoss',40,90169,3718,92.58,9.81,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,216,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25358,25358,'Sukar Wererat Guard',0,'Raid Fighter',0,'Monster.wererat_sm',12.00,18.70,20,'male','L2Minion',40,9314,1859,23.53,9.81,40,43,30,41,20,10,0,0,60,378,8,153,278,0,333,216,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25359,25359,'Sukar Wererat Priest',0,'Raid Fighter',0,'Monster.wererat_sm',12.00,18.70,20,'male','L2Minion',40,9314,1859,23.53,9.81,40,43,30,41,20,10,0,0,30,378,2,153,278,0,333,179,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25360,25360,'Tiger Hornet',0,'Raid Boss',0,'Monster.giant_bee_bi',8.00,32.00,26,'male','L2RaidBoss',40,107186,3718,113.98,9.81,60,57,73,76,70,80,621174,53601,67,966,6,392,409,0,3819,0,0,0,145,307,NULL,0,0,0,'LAST_HIT'),
	(25361,25361,'Yellow Hornet',0,'Raid Fighter',0,'Monster.giant_bee',8.00,24.50,25,'male','L2Minion',40,10950,1859,29.07,9.81,40,43,30,41,20,10,0,0,122,464,23,188,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25362,25362,'Tracker Leader Sharuk',0,'Raid Boss',0,'Monster.virud_lizardman_warrior',12.00,30.00,23,'male','L2RaidBoss',40,95986,3718,100.82,9.81,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,3819,291,0,0,84,307,NULL,0,0,0,'LAST_HIT'),
	(25363,25363,'Sharuk''s Tracker',0,'Raid Fighter',0,'Monster.virud_lizardman',10.00,23.00,22,'male','L2Minion',40,4935,1859,25.66,9.81,40,43,30,41,20,10,0,0,47,411,4,167,278,0,333,2,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25364,25364,'Sharuk''s Marksman',0,'Raid Fighter',0,'Monster.virud_lizardman_scout',10.00,22.00,22,'male','L2Minion',500,6613,1859,25.66,9.81,40,43,30,41,20,10,0,0,140,411,7,167,278,0,333,2507,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25365,25365,'Patriarch Kuroboros',0,'Raid Boss',0,'Monster.virud_lizardman_warrior_bi',12.00,34.50,26,'male','L2RaidBoss',40,214372,3718,113.98,9.81,60,57,73,76,70,80,621174,53601,135,966,25,392,409,0,3819,93,0,0,84,307,NULL,0,0,0,'LAST_HIT'),
	(25366,25366,'Kuroboros'' Priest',0,'Raid Boss',0,'Monster.virud_lizardman_matriarch',13.00,37.00,23,'male','L2RaidBoss',40,95986,3718,100.82,9.81,60,57,73,76,70,80,599426,50860,52,857,4,348,409,0,3819,2,0,0,90,307,NULL,0,0,0,'LAST_HIT'),
	(25367,25367,'Kuroboros'' Follower',0,'Raid Fighter',0,'Monster.virud_lizardman',10.00,23.00,22,'male','L2Minion',40,9870,1859,25.66,9.81,40,43,30,41,20,10,0,0,94,411,17,167,278,0,333,1,102,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25368,25368,'Kuroboros'' Discipline',0,'Raid Fighter',0,'Monster.virud_lizardman_shaman',10.00,29.00,22,'male','L2Minion',40,9870,1859,25.66,9.81,40,43,30,41,20,10,0,0,47,411,4,167,278,0,333,179,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25369,25369,'Soul Scavenger',0,'Raid Boss',0,'Monster.dark_horror_bi',20.00,42.00,25,'male','L2RaidBoss',40,103092,3718,109.48,9.81,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,162,307,NULL,0,1,0,'LAST_HIT'),
	(25370,25370,'Corpse Scavenger',0,'Raid Fighter',0,'Monster.skeleton_bi',11.00,31.00,24,'male','L2Minion',40,10554,1859,27.90,9.81,40,43,30,41,20,10,0,0,112,446,21,181,278,0,333,946,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25371,25371,'Anima Scavenger',0,'Raid Fighter',0,'Monster.spartoi',11.00,27.00,24,'male','L2Minion',40,5277,1859,27.90,9.81,40,43,30,41,20,10,0,0,56,446,5,181,278,0,333,946,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25372,25372,'Discarded Guardian',0,'Raid Boss',0,'Monster.stone_golem_bi',20.00,40.30,20,'male','L2RaidBoss',40,175392,3718,88.61,9.81,60,57,73,76,70,80,436632,37265,61,757,8,307,409,0,3819,0,0,0,37,307,NULL,0,0,0,'LAST_HIT'),
	(25373,25373,'Malex Herald of Dagoniel ',0,'Raid Boss',0,'Monster.dre_vanul_bi_one',21.00,54.00,21,'male','L2RaidBoss',40,90169,3718,92.58,9.81,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25374,25374,'Abyss Flyer',0,'Raid Fighter',0,'Monster.vampire_bat',10.00,33.50,20,'male','L2Minion',40,9314,1859,23.53,9.81,40,43,30,41,20,10,0,0,60,378,8,153,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25375,25375,'Zombie Lord Farakelsus',0,'Raid Boss',0,'Monster.zombie_bi',12.00,27.50,20,'male','L2RaidBoss',40,87696,3718,88.61,9.81,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,3819,0,0,0,24,307,NULL,0,1,0,'LAST_HIT'),
	(25376,25376,'Warrior Zombie of Farakelsus',0,'Raid Fighter',0,'Monster.zombie',13.00,21.00,19,'male','L2Minion',40,9080,1859,22.50,9.81,40,43,30,41,20,10,0,0,54,363,7,147,278,0,333,0,0,0,16,209,NULL,0,1,0,'LAST_HIT'),
	(25377,25377,'Priest Zombie of Farakelsus',0,'Raid Fighter',0,'Monster.zombie',13.00,21.00,19,'male','L2Minion',40,9080,1859,22.50,9.81,40,43,30,41,20,10,0,0,27,363,1,147,278,0,333,0,0,0,16,209,NULL,0,1,0,'LAST_HIT'),
	(25378,25378,'Madness Beast',0,'Raid Boss',0,'Monster.onyx_beast_bi',14.00,18.70,20,'male','L2RaidBoss',40,87696,3718,88.61,9.81,60,57,73,76,70,80,436632,37265,30,757,2,307,409,0,3819,0,0,0,48,307,NULL,0,0,0,'LAST_HIT'),
	(25379,25379,'Dementia Beast',0,'Raid Fighter',0,'Monster.onyx_beast',14.00,14.50,19,'male','L2Minion',40,9080,1859,22.50,9.81,40,43,30,41,20,10,0,0,54,363,7,147,278,0,333,0,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25380,25380,'Kaysha Herald of Icarus',0,'Raid Boss',0,'Monster.succubus_bi',10.00,43.20,21,'female','L2RaidBoss',40,90169,3718,92.58,9.81,60,57,73,76,70,80,578451,45688,42,789,3,320,409,0,3819,0,0,0,97,307,NULL,0,0,0,'LAST_HIT'),
	(25381,25381,'Nightmare Flyer',0,'Raid Fighter',0,'Monster.vampire_bat_bi',10.00,42.00,19,'male','L2Minion',40,9080,1859,22.50,9.81,40,43,30,41,20,10,0,0,54,363,7,147,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25382,25382,'Hostile Flyer',0,'Raid Fighter',0,'Monster.vampire_bat',10.00,33.50,19,'male','L2Minion',40,4540,1859,22.50,9.81,40,43,30,41,20,10,0,0,27,363,1,147,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25383,25383,'Revenant of Sir Calibus',0,'Raid Boss',0,'Monster.death_knight_bi',24.00,29.00,34,'male','L2RaidBoss',40,156584,3718,153.32,9.81,60,57,73,76,70,80,840195,76283,158,1308,20,531,409,0,3819,75,0,0,43,307,NULL,0,1,0,'LAST_HIT'),
	(25384,25384,'Servant of Calibus',0,'Raid Fighter',0,'Monster.spartoi',11.00,27.00,33,'male','L2Minion',40,15774,1859,39.33,9.81,40,43,30,41,20,10,0,0,292,630,75,256,278,0,333,946,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25385,25385,'Evil Spirit Tempest',0,'Raid Boss',0,'Monster.dre_vanul_bi_one',21.00,54.00,36,'male','L2RaidBoss',40,174646,3718,164.01,9.81,60,57,73,76,70,80,867472,80701,185,1405,24,570,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25386,25386,'Ghost of the Execution Grounds',0,'Raid Fighter',0,'Monster.skeleton_bi',11.00,31.00,35,'male','L2Minion',40,17556,1859,42.12,9.81,40,43,30,41,20,10,0,0,336,678,87,275,278,0,333,128,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25387,25387,'Malignant Spirit of the Execution Grounds',0,'Raid Fighter',0,'Monster.skeleton',11.00,25.00,35,'male','L2Minion',40,8778,1859,42.12,9.81,40,43,30,41,20,10,0,0,168,678,21,275,278,0,333,946,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25388,25388,'Red Eye Captain Trakia',0,'Raid Boss',0,'Monster.oel_mahum_bi',30.00,55.00,35,'male','L2RaidBoss',40,165289,3718,158.63,9.81,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,70,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25389,25389,'Red Eye Archer ',0,'Raid Fighter',0,'Monster.ol_mahum_archer',14.00,25.00,34,'male','L2Minion',500,11143,1859,40.72,9.81,40,43,30,41,20,10,0,0,464,654,36,265,278,0,333,279,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25390,25390,'Red Eye Guards',0,'Raid Fighter',0,'Monster.ol_mahum_champion',14.00,27.00,34,'male','L2Minion',40,8316,1859,40.72,9.81,40,43,30,41,20,10,0,0,156,654,20,265,278,0,333,128,0,0,55,209,NULL,0,0,0,'LAST_HIT'),
	(25391,25391,'Nurka''s Messenger',0,'Raid Boss',0,'Monster.ol_mahum_champion_bi',21.00,40.50,33,'male','L2RaidBoss',40,297015,3718,148.11,9.81,60,57,73,76,70,80,825587,73993,295,1261,75,512,409,0,3819,127,0,0,81,307,NULL,0,0,0,'LAST_HIT'),
	(25392,25392,'Captain of Queen''s Royal Guards',0,'Raid Boss',0,'Monster.marsh_stakato_queen',15.00,37.00,32,'female','L2RaidBoss',40,141034,3718,142.94,9.81,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,3819,129,0,0,210,307,NULL,0,0,0,'LAST_HIT'),
	(25393,25393,'Marsh Stakato Noble',0,'Raid Fighter',0,'Monster.marsh_stakato_drone',9.00,24.00,31,'male','L2Minion',40,14247,1859,36.61,9.81,40,43,30,41,20,10,0,0,246,585,61,237,278,0,333,223,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25394,25394,'Premo Prime',0,'Raid Boss',0,'Monster.twin_headed_giant',17.00,39.00,38,'male','L2RaidBoss',40,390743,3718,175.00,9.81,60,57,73,76,70,80,892440,99116,425,1508,113,612,409,0,3819,88,0,0,72,307,NULL,0,0,0,'LAST_HIT'),
	(25395,25395,'Archon Suscepter',0,'Raid Boss',0,'Monster.susceptor_prime',45.00,72.00,45,'male','L2RaidBoss',40,288415,3718,215.06,9.81,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,0,0,0,126,307,NULL,0,0,0,'LAST_HIT'),
	(25396,25396,'Kusion Suscepter',0,'Raid Fighter',0,'Monster.susceptor',20.00,35.00,44,'male','L2Minion',40,29037,1859,55.55,9.81,40,43,30,41,20,10,0,0,413,922,76,374,278,0,333,0,0,0,29,209,NULL,0,0,0,'LAST_HIT'),
	(25397,25397,'Gustos Suscepter',0,'Raid Fighter',0,'Monster.susceptor',20.00,35.00,44,'male','L2Minion',40,29037,1859,55.55,9.81,40,43,30,41,20,10,0,0,826,922,307,374,278,0,333,0,0,0,29,209,NULL,0,0,0,'LAST_HIT'),
	(25398,25398,'Eye of Beleth',0,'Raid Boss',0,'Monster.monster_eye',21.00,43.00,35,'male','L2RaidBoss',40,165289,3718,158.63,9.81,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,0,0,0,145,307,NULL,0,0,0,'LAST_HIT'),
	(25399,25399,'Apprentice of Watchman',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,34,'male','L2Minion',40,11143,1859,40.72,9.81,40,43,30,41,20,10,0,0,209,654,36,265,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25400,25400,'Page of Watchman',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,34,'male','L2Minion',40,16632,1859,40.72,9.81,40,43,30,41,20,10,0,0,156,654,20,265,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25401,25401,'Skyla',0,'Raid Boss',0,'Monster.zenta_lizardman_matriarch_bi',30.00,63.00,32,'male','L2RaidBoss',40,141034,3718,142.94,9.81,60,57,73,76,70,80,810271,71493,137,1215,17,493,409,0,3819,215,0,0,85,307,NULL,0,0,0,'LAST_HIT'),
	(25402,25402,'Retainer of Skyla',0,'Raid Fighter',0,'Monster.zenta_lizardman',11.00,32.00,31,'male','L2Minion',40,14247,1859,36.61,9.81,40,43,30,41,20,10,0,0,246,585,61,237,278,0,333,221,0,0,40,209,NULL,0,0,0,'LAST_HIT'),
	(25403,25403,'Follower of Skyla',0,'Raid Fighter',0,'Monster.zenta_lizardman_shaman',13.00,35.00,31,'male','L2Minion',40,9545,1859,36.61,9.81,40,43,30,41,20,10,0,0,164,585,27,237,278,0,333,180,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25404,25404,'Corsair Captain Kylon',0,'Raid Boss',0,'Monster.pirates_zombie_captain',17.00,28.00,33,'male','L2RaidBoss',40,148507,3718,148.11,9.81,60,57,73,76,70,80,825587,73993,147,1261,18,512,409,0,3819,231,0,0,22,307,NULL,0,1,0,'LAST_HIT'),
	(25405,25405,'Kylon''s Pirate',0,'Raid Fighter',0,'Monster.skeleton_bi_one',16.00,40.00,32,'male','L2Minion',40,14980,1859,37.97,9.81,40,43,30,41,20,10,0,0,271,607,69,246,278,0,333,946,945,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25406,25406,'Kylon''s Mate',0,'Raid Fighter',0,'Monster.skeleton_knight_50_bi',15.00,39.00,32,'male','L2Minion',40,14980,1859,37.97,9.81,40,43,30,41,20,10,0,0,271,607,69,246,278,0,333,130,103,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25407,25407,'Lord Ishka',0,'Raid Boss',0,'Monster.death_blader_bi',22.00,67.00,60,'male','L2RaidBoss',40,526218,3718,301.02,9.81,60,57,73,76,70,80,1496444,237315,1642,2951,547,1198,409,0,3819,1472,0,0,162,307,NULL,0,1,0,'LAST_HIT'),
	(25408,25408,'Ishka''s Elite Officer',0,'Raid Fighter',0,'Monster.skeleton_royal_guard',11.00,28.50,59,'male','L2Minion',40,54404,1859,78.51,9.81,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,333,946,945,0,88,209,NULL,0,1,0,'LAST_HIT'),
	(25409,25409,'Ishka''s Elite Soldier',0,'Raid Fighter',0,'Monster.skeleton_knight_20_bi',12.00,30.50,59,'male','L2Minion',40,54404,1859,78.51,9.81,40,43,30,41,20,10,0,0,2999,1437,1951,583,278,0,333,150,103,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25410,25410,'Road Scavenger Leader',0,'Raid Boss',0,'Monster.wererat_bi',21.00,38.00,40,'male','L2RaidBoss',40,218810,3718,217.25,9.81,60,57,73,76,70,80,1279280,187517,427,1615,87,656,409,0,3819,88,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25411,25411,'Road Scavenger Henchman',0,'Raid Fighter',0,'Monster.kobold_bi',15.00,24.00,39,'male','L2Minion',40,21961,1859,55.95,9.81,40,43,30,41,20,10,0,0,786,780,323,317,278,0,333,0,0,0,51,209,NULL,0,0,0,'LAST_HIT'),
	(25412,25412,'Necrosentinel Royal Guard',0,'Raid Boss',0,'Monster.skeleton_royal_guard',11.00,28.50,47,'male','L2RaidBoss',40,319791,3718,226.77,9.81,60,57,73,76,70,80,1162159,134535,546,2030,111,824,409,0,3819,946,946,0,129,307,NULL,0,1,0,'LAST_HIT'),
	(25413,25413,'Necrosentinel Archer',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,46,'male','L2Minion',500,21628,1859,58.67,9.81,40,43,30,41,20,10,0,0,1454,983,172,399,278,0,333,279,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25414,25414,'Necrosentinel Soldier',0,'Raid Fighter',0,'Monster.skeleton_knight',10.00,25.00,46,'male','L2Minion',40,16140,1859,58.67,9.81,40,43,30,41,20,10,0,0,490,983,97,399,278,0,333,150,103,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25415,25415,'Nakondas',0,'Raid Boss',0,'Monster.drake_bi',37.00,125.00,40,'male','L2RaidBoss',40,218810,3718,158.63,9.81,60,57,73,76,70,80,854153,78199,170,1356,21,550,409,0,3819,0,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25416,25416,'Nakondas'' Slave ',0,'Raid Fighter',0,'Monster.wyrm',29.00,72.00,39,'male','L2Minion',40,14713,1859,40.72,9.81,40,43,30,41,20,10,0,0,209,654,36,265,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25417,25417,'Nakondas'' Chain ',0,'Raid Fighter',0,'Monster.succubus',10.00,36.00,39,'female','L2Minion',40,21961,1859,40.72,9.81,40,43,30,41,20,10,0,0,156,654,20,265,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25418,25418,'Dread Avenger Kraven',0,'Raid Boss',0,'Monster.death_knight_bi',24.00,29.00,44,'male','L2RaidBoss',40,273375,3718,209.20,9.81,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,75,0,0,43,307,NULL,0,1,0,'LAST_HIT'),
	(25419,25419,'Dread Panther',0,'Raid Fighter',0,'Monster.onyx_beast',14.00,14.50,43,'male','L2Minion',40,27494,1859,54.02,9.81,40,43,30,41,20,10,0,0,756,892,272,362,278,0,333,0,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25420,25420,'Orfen''s Handmaiden',0,'Raid Boss',0,'Monster.riba',25.00,72.00,48,'female','L2RaidBoss',40,335987,3718,271.42,9.81,60,57,73,76,70,80,1639757,244248,1060,2094,345,850,409,0,3819,0,0,0,97,307,NULL,0,0,0,'LAST_HIT'),
	(25421,25421,'Trisalim Escort',0,'Raid Fighter',0,'Monster.poison_spider_bi',40.00,38.00,47,'male','L2Minion',40,22758,1859,70.25,9.81,40,43,30,41,20,10,0,0,1259,1015,526,412,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25422,25422,'Page of Rotting Tree',0,'Raid Fighter',0,'Monster.hanged_man_ripper',35.00,80.00,47,'male','L2Minion',40,33967,1859,70.25,9.81,40,43,30,41,20,10,0,0,945,1015,296,412,278,0,333,0,0,0,60,209,NULL,0,0,0,'LAST_HIT'),
	(25423,25423,'Fairy Queen Timiniel',0,'Raid Boss',0,'Monster.pixy_bi',10.00,54.00,61,'female','L2RaidBoss',40,539706,3718,325.56,9.81,60,57,73,76,70,80,1722981,291015,1459,2649,476,1075,409,0,3819,0,0,0,129,307,'timiniel_clan',300,0,0,'LAST_HIT'),
	(25424,25424,'Timiniel''s Royal Guards',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,60,'female','L2Minion',40,27947,1859,84.69,9.81,40,43,30,41,20,10,0,0,1347,1288,435,523,278,0,333,0,0,0,88,209,'timiniel_clan',300,0,0,'LAST_HIT'),
	(25425,25425,'Timiniel''s Royal Guard Captain',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,60,'female','L2Minion',40,55894,1859,84.69,9.81,40,43,30,41,20,10,0,0,2694,1288,1740,523,278,0,333,0,0,0,88,209,'timiniel_clan',300,0,0,'LAST_HIT'),
	(25426,25426,'Betrayer of Urutu Freki',0,'Raid Boss',0,'Monster.werewolf_bi',11.00,29.70,25,'male','L2RaidBoss',40,103092,3718,109.48,9.81,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,81,307,NULL,0,0,0,'LAST_HIT'),
	(25427,25427,'Freki''s Vampire Bat',0,'Raid Fighter',0,'Monster.vampire_bat',10.00,33.50,24,'male','L2Minion',40,10554,1859,27.90,9.81,40,43,30,41,20,10,0,0,112,446,21,181,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25428,25428,'Freki''s Wild Bear',0,'Raid Fighter',0,'Monster.grizzly',21.00,40.00,24,'male','L2Minion',40,10554,1859,27.90,9.81,40,43,30,41,20,10,0,0,112,446,21,181,278,0,333,0,0,0,44,209,NULL,0,0,0,'LAST_HIT'),
	(25429,25429,'Mammon Collector Talos',0,'Raid Boss',0,'Monster2.ashuras',13.00,37.50,25,'male','L2RaidBoss',40,103092,3718,109.48,9.81,60,57,73,76,70,80,612533,52699,62,928,5,377,409,0,3819,0,0,0,66,307,NULL,0,0,0,'LAST_HIT'),
	(25430,25430,'Talos'' Cohort',0,'Raid Fighter',0,'Monster.dre_vanul',14.00,36.00,22,'male','L2Minion',40,9870,1859,25.66,9.81,40,43,30,41,20,10,0,0,94,411,17,167,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25431,25431,'Flamestone Golem',0,'Raid Boss',0,'Monster2.lava_golem',22.00,45.00,44,'male','L2RaidBoss',40,273375,3718,209.20,9.81,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,0,0,0,21,307,NULL,0,0,0,'LAST_HIT'),
	(25432,25432,'Elemental of Flame',0,'Raid Fighter',0,'Monster.mana_vampire',11.00,20.00,43,'male','L2Minion',40,27494,1859,54.02,9.81,40,43,30,41,20,10,0,0,378,892,68,362,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25433,25433,'Elemental of Spark',0,'Raid Fighter',0,'Monster.magical_weaver',11.00,20.00,43,'male','L2Minion',40,13747,1859,54.02,9.81,40,43,30,41,20,10,0,0,378,892,68,362,278,0,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25434,25434,'Bandit Leader Barda',0,'Raid Boss',0,'Monster.oel_mahum_warrior_50_bi',30.00,60.00,55,'male','L2RaidBoss',40,451391,3718,273.37,9.81,60,57,73,76,70,80,1432099,216652,1156,2576,336,1046,409,0,3819,121,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25435,25435,'Barda''s Bandit',0,'Raid Fighter',0,'Monster.oel_mahum',20.00,37.00,54,'male','L2Minion',40,46232,1859,71.07,9.81,40,43,30,41,20,10,0,0,2132,1252,1228,508,278,0,333,145,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25436,25436,'Barda''s Shaman',0,'Raid Fighter',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,54,'male','L2Minion',40,30975,1859,71.07,9.81,40,43,30,41,20,10,0,0,1421,1252,546,508,278,0,333,201,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25437,25437,'Timak Orc Gosmos',0,'Raid Boss',0,'Monster.batur_orc_overlord_100_bi',24.00,52.00,45,'male','L2RaidBoss',40,576831,3718,215.06,9.81,60,57,73,76,70,80,1139085,129941,912,1905,346,774,409,0,3819,145,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25438,25438,'Thief Kelbar',0,'Raid Boss',0,'Monster.wererat_100_bi',25.00,50.00,44,'male','L2RaidBoss',40,273375,3718,209.20,9.81,60,57,73,76,70,80,1127093,127160,418,1845,77,749,409,0,3819,239,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25439,25439,'Kelbar''s Inferior',0,'Raid Fighter',0,'Monster.wererat_bi',21.00,38.00,43,'male','L2Minion',40,27494,1859,54.02,9.81,40,43,30,41,20,10,0,0,756,892,272,362,278,0,333,130,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25440,25440,'Kelbar''s Wizard',0,'Raid Fighter',0,'Monster.wererat',14.00,25.00,43,'male','L2Minion',40,18421,1859,54.02,9.81,40,43,30,41,20,10,0,0,504,892,121,362,278,0,333,99,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25441,25441,'Evil Spirit Cyrion',0,'Raid Boss',0,'Monster.drake_50_bi',45.00,150.00,45,'male','L2RaidBoss',40,288415,3718,215.06,9.81,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,0,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25442,25442,'Evil Creature of Forest',0,'Raid Fighter',0,'Monster.crimson_bear',19.00,36.00,44,'male','L2Minion',40,14518,1859,55.55,9.81,40,43,30,41,20,10,0,0,413,922,76,374,278,0,333,0,0,0,40,209,NULL,0,0,0,'LAST_HIT'),
	(25443,25443,'Anger of Forest',0,'Raid Fighter',0,'Monster.giant_wild_hog',35.00,27.00,44,'male','L2Minion',40,29037,1859,55.55,9.81,40,43,30,41,20,10,0,0,826,922,307,374,278,0,333,0,0,0,38,209,NULL,0,0,0,'LAST_HIT'),
	(25444,25444,'Enmity Ghost Ramdal',0,'Raid Boss',0,'Monster.dark_horror_100_bi',40.00,70.00,65,'male','L2RaidBoss',40,588136,3718,310.78,9.81,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,3819,0,0,0,162,307,NULL,0,1,0,'LAST_HIT'),
	(25445,25445,'Enmity Ghosts',0,'Raid Fighter',0,'Monster.crimson_doll',15.00,38.00,64,'male','L2Minion',40,30636,1859,82.08,9.81,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,333,0,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25446,25446,'Shooter of Enmity',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,64,'male','L2Minion',500,41052,1859,82.08,9.81,40,43,30,41,20,10,0,0,6153,1634,1367,663,278,0,333,279,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25447,25447,'Immortal Savior Mardil',0,'Raid Boss',0,'Monster.banshee_50_bi',13.50,38.00,71,'female','L2RaidBoss',40,645953,3718,317.28,9.81,60,57,73,76,70,80,2068252,367642,2947,3848,1195,1562,409,0,3819,3939,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25448,25448,'Immortal Savior ',0,'Raid Fighter',0,'Monster.binding',12.00,21.00,70,'male','L2Minion',40,33847,1859,84.07,9.81,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,333,0,0,0,11,209,NULL,0,1,0,'LAST_HIT'),
	(25449,25449,'Immortal Guide',0,'Raid Fighter',0,'Monster.liviona',15.00,28.00,70,'male','L2Minion',40,67694,1859,84.07,9.81,40,43,30,41,20,10,0,0,2611,1882,992,764,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25450,25450,'Cherub Galaxia',0,'Raid Boss',0,'Monster.archangel_50_bi',22.00,120.00,79,'male','L2RaidBoss',40,987470,3718,844.90,9.81,60,57,73,76,70,80,2377821,1136977,9883,4471,14504,1816,409,0,3819,97,0,0,81,307,NULL,0,0,0,'LAST_HIT'),
	(25451,25451,'Galaxia''s Guards',0,'Raid Fighter',0,'Monster.angel',13.50,36.50,78,'male','L2Minion',40,69545,1859,224.99,9.81,40,43,30,41,20,10,0,0,12640,2192,24904,890,278,0,333,148,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25452,25452,'Messenger of Angel',0,'Raid Fighter',0,'Monster.angel',13.50,36.50,79,'male','L2Minion',40,104887,1859,224.99,9.81,40,43,30,41,20,10,0,0,9537,2206,14177,895,278,0,333,148,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25453,25453,'Meanas Anor',0,'Raid Boss',0,'Monster.wyrm_50_bi',58.00,108.00,70,'male','L2RaidBoss',40,888658,3718,685.96,9.81,60,57,73,76,70,80,3859833,738431,5659,3764,5371,1528,409,0,3819,0,0,0,113,307,NULL,0,0,12,'PARTY_ONE_RANDOM'),
	(25454,25454,'Wyvern of Marsh',0,'Raid Fighter',0,'Monster.wyrm',29.00,72.00,69,'male','L2Minion',40,62338,1859,181.67,9.81,40,43,30,41,20,10,0,0,7149,1840,9066,747,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25455,25455,'Succubus of Marsh',0,'Raid Fighter',0,'Monster.succubus',10.00,36.00,69,'female','L2Minion',40,93041,1859,181.67,9.81,40,43,30,41,20,10,0,0,5362,1840,5100,747,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25456,25456,'Mirror of Oblivion',0,'Raid Boss',0,'Monster.mirror_50_bi',45.00,78.00,49,'male','L2RaidBoss',40,352421,3718,238.52,9.81,60,57,73,76,70,80,1184339,140317,652,2160,143,877,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25457,25457,'Shards of Oblivion',0,'Raid Fighter',0,'Monster.human_ghost',8.00,22.00,48,'male','L2Minion',40,17844,1859,61.78,9.81,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,333,0,0,0,88,209,NULL,0,1,0,'LAST_HIT'),
	(25458,25458,'Shadow of Oblivion',0,'Raid Fighter',0,'Monster.elf_ghost',7.00,21.00,48,'male','L2Minion',40,35688,1859,61.78,9.81,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,333,0,0,0,88,209,NULL,0,1,0,'LAST_HIT'),
	(25459,25459,'Shards of Oblivion',0,'Raid Fighter',0,'Monster.dwarf_ghost',9.00,16.50,48,'male','L2Minion',40,17844,1859,61.78,9.81,40,43,30,41,20,10,0,0,595,1047,128,425,278,0,333,0,0,0,88,209,NULL,0,1,0,'LAST_HIT'),
	(25460,25460,'Deadman Ereve',0,'Raid Boss',0,'Monster.death_blader_200_bi',45.00,141.00,51,'male','L2RaidBoss',40,385670,3718,250.26,9.81,60,57,73,76,70,80,1381165,185853,850,2294,219,931,409,0,3819,194,0,0,162,307,NULL,0,1,0,'LAST_HIT'),
	(25461,25461,'Ereve''s Knight',0,'Raid Fighter',0,'Monster.skeleton_knight',10.00,25.00,50,'male','L2Minion',40,39195,1859,64.91,9.81,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,333,70,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25462,25462,'Ereve''s Squire',0,'Raid Fighter',0,'Monster.skeleton_pikeman',10.00,28.00,50,'male','L2Minion',40,39195,1859,64.91,9.81,40,43,30,41,20,10,0,0,1395,1113,638,452,278,0,333,98,0,0,55,209,NULL,0,1,0,'LAST_HIT'),
	(25463,25463,'Harit Guardian Garangky',0,'Raid Boss',0,'Monster.saber_toothed_tiger',34.00,28.00,56,'male','L2RaidBoss',40,467209,3718,279.06,9.81,60,57,73,76,70,80,1444796,221098,1237,2649,368,1075,409,0,3819,0,0,0,97,307,NULL,0,0,0,'LAST_HIT'),
	(25464,25464,'Garangky Guard Captain',0,'Raid Fighter',0,'Monster.zenta_lizardman_warrior',13.00,35.00,55,'male','L2Minion',40,47946,1859,72.59,9.81,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,333,303,0,0,44,209,NULL,0,0,0,'LAST_HIT'),
	(25465,25465,'Garangky Guard Shaman',0,'Raid Fighter',0,'Monster.zenta_lizardman_shaman',13.00,35.00,55,'male','L2Minion',40,47946,1859,72.59,9.81,40,43,30,41,20,10,0,0,1142,1288,336,523,278,0,333,206,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25466,25466,'Garangky Guard ',0,'Raid Fighter',0,'Monster.zenta_lizardman',11.00,32.00,55,'male','L2Minion',40,47946,1859,72.59,9.81,40,43,30,41,20,10,0,0,2284,1288,1347,523,278,0,333,77,0,0,40,209,NULL,0,0,0,'LAST_HIT'),
	(25467,25467,'Gorgolos',0,'Raid Boss',0,'Monster.field_stalker_200_bi',45.00,96.00,64,'male','L2RaidBoss',40,576851,3718,309.11,9.81,60,57,73,76,70,80,1744167,326947,2103,3268,769,1327,409,0,3819,0,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25468,25468,'Cursed Life',0,'Raid Fighter',0,'Monster.field_stalker',15.00,30.00,63,'male','L2Minion',40,30008,1859,81.61,9.81,40,43,30,41,20,10,0,0,2006,1594,744,647,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25469,25469,'Cursed Soul',0,'Raid Fighter',0,'Monster.field_stalker',15.00,30.00,63,'male','L2Minion',40,60016,1859,81.61,9.81,40,43,30,41,20,10,0,0,4012,1594,2979,647,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25470,25470,'Last Titan Utenus',0,'Raid Boss',0,'Monster.lesser_giant_mage',21.00,44.00,66,'male','L2RaidBoss',40,598898,3718,312.26,9.81,60,57,73,76,70,80,1777636,338244,2252,3431,821,1393,409,0,3819,3938,0,0,24,307,NULL,0,0,0,'LAST_HIT'),
	(25471,25471,'Utenus''s Wizard',0,'Raid Fighter',0,'Monster.lesser_giant',21.00,44.00,65,'male','L2Minion',40,41855,1859,82.52,9.81,40,43,30,41,20,10,0,0,2866,1674,1412,680,278,0,333,0,0,0,16,209,NULL,0,0,0,'LAST_HIT'),
	(25472,25472,'Utenus''s Guard',0,'Raid Fighter',0,'Monster.leogul',15.00,35.00,65,'male','L2Minion',40,62470,1859,82.52,9.81,40,43,30,41,20,10,0,0,4299,1674,3178,680,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25473,25473,'Grave Robber Kim',0,'Raid Boss',0,'Monster.batur_orc_warrior_100_bi',20.00,42.00,52,'male','L2RaidBoss',40,402319,3718,256.09,9.81,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,3819,160,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25474,25474,'Kim''s Gang',0,'Raid Fighter',0,'Monster.batur_orc',9.00,21.50,51,'male','L2Minion',40,40965,1859,66.45,9.81,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,333,89,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25475,25475,'Ghost Knight Kabed',0,'Raid Boss',0,'Monster.headless_knight_50_bi',30.00,46.50,55,'male','L2RaidBoss',40,451391,3718,273.37,9.81,60,57,73,76,70,80,1393657,221098,1156,2576,336,1046,409,0,3819,145,0,0,113,307,NULL,0,1,0,'LAST_HIT'),
	(25476,25476,'Kabed''s Soldier',0,'Raid Fighter',0,'Monster.skeleton_knight',10.00,25.00,54,'male','L2Minion',40,23116,1859,71.07,9.81,40,43,30,41,20,10,0,0,1066,1252,307,508,278,0,333,125,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25477,25477,'Kabed''s Archer',0,'Raid Fighter',0,'Monster.skeleton_archer',11.00,27.00,54,'male','L2Minion',500,30975,1859,71.07,9.81,40,43,30,41,20,10,0,0,3158,1252,546,508,278,0,333,279,0,0,44,209,NULL,0,1,0,'LAST_HIT'),
	(25478,25478,'Shilen''s Priest Hisilrome',0,'Raid Boss',0,'Monster.cave_maiden',25.00,65.00,65,'female','L2RaidBoss',40,588136,3718,310.78,9.81,60,57,73,76,70,80,1760714,332726,2176,3349,794,1360,409,0,3819,230,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25479,25479,'Hisilrome''s Servitor',0,'Raid Fighter',0,'Monster.serpent_slave',17.00,46.00,64,'male','L2Minion',40,41052,1859,82.08,9.81,40,43,30,41,20,10,0,0,2769,1634,1367,663,278,0,333,68,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25480,25480,'Hisilrome''s Page',0,'Raid Fighter',0,'Monster.lienrik',12.00,50.00,64,'male','L2Minion',40,61272,1859,82.08,9.81,40,43,30,41,20,10,0,0,2077,1634,769,663,278,0,333,0,0,0,110,209,NULL,0,0,0,'LAST_HIT'),
	(25481,25481,'Magus Kenishee',0,'Raid Boss',0,'Monster.banshee_50_bi',13.50,38.00,53,'female','L2RaidBoss',40,66938,3718,261.90,9.81,60,57,73,76,70,80,1406722,209570,996,2433,274,988,409,0,3819,3939,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25482,25482,'Shadow of Kenishee',0,'Raid Fighter',0,'Monster.shadow',10.00,30.00,52,'male','L2Minion',40,8629,1859,68.00,9.81,40,43,30,41,20,10,0,0,1806,1181,969,479,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25483,25483,'Phantom of Kenishee',0,'Raid Fighter',0,'Monster.silhouette',8.00,23.00,52,'female','L2Minion',40,8629,1859,68.00,9.81,40,43,30,41,20,10,0,0,903,1181,242,479,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25484,25484,'Zaken''s Chief Mate Tillion',0,'Raid Boss',0,'Monster.skeleton_knight_50_bi',15.00,39.00,50,'male','L2RaidBoss',40,369009,3718,244.40,9.81,60,57,73,76,70,80,1195137,169534,706,2226,159,904,409,0,3819,160,0,0,64,307,NULL,0,1,0,'LAST_HIT'),
	(25485,25485,'Tillion''s Inferior',0,'Raid Fighter',0,'Monster.skeleton_bi',11.00,31.00,49,'male','L2Minion',40,7866,1859,63.34,9.81,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,333,131,0,0,66,209,NULL,0,1,0,'LAST_HIT'),
	(25486,25486,'Tillion''s Bat',0,'Raid Fighter',0,'Monster.vampire_bat',10.00,33.50,49,'male','L2Minion',40,37433,1859,63.34,9.81,40,43,30,41,20,10,0,0,1288,1079,572,438,278,0,333,0,0,0,66,209,NULL,0,0,0,'LAST_HIT'),
	(25487,25487,'Water Spirit Lian',0,'Raid Boss',0,'Monster.pixy_bi',10.00,54.00,40,'female','L2RaidBoss',40,218810,3718,186.21,9.81,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,3819,0,0,0,129,307,NULL,0,0,0,'LAST_HIT'),
	(25488,25488,'Spirit of Gildor',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,39,'female','L2Minion',40,14713,1859,47.95,9.81,40,43,30,41,20,10,0,0,299,780,54,317,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25489,25489,'Guardian of Gildor',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,39,'female','L2Minion',40,21961,1859,47.95,9.81,40,43,30,41,20,10,0,0,449,780,121,317,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25490,25490,'Gwindorr',0,'Raid Boss',0,'Monster.serpent_slave',17.00,46.00,40,'male','L2RaidBoss',40,218810,3718,186.21,9.81,60,57,73,76,70,80,915400,105938,243,1615,32,656,409,0,3819,129,0,0,113,307,NULL,0,0,0,'LAST_HIT'),
	(25491,25491,'Guard of Gwindorr',0,'Raid Fighter',0,'Monster.virud_lizardman_scout',10.00,22.00,39,'male','L2Minion',500,14713,1859,47.95,9.81,40,43,30,41,20,10,0,0,665,780,54,317,278,0,333,2507,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25492,25492,'Follower of Gwindorr',0,'Raid Fighter',0,'Monster.virud_lizardman',10.00,23.00,39,'male','L2Minion',40,10980,1859,47.95,9.81,40,43,30,41,20,10,0,0,224,780,30,317,278,0,333,2,0,0,47,209,NULL,0,0,0,'LAST_HIT'),
	(25493,25493,'Eva''s Spirit Niniel',0,'Raid Boss',0,'Monster.cutie_cat',8.00,15.00,55,'female','L2RaidBoss',40,451391,3718,273.37,9.81,60,57,73,76,70,80,1432097,216652,1156,2576,336,1046,409,0,3819,0,0,0,77,307,NULL,0,0,0,'LAST_HIT'),
	(25494,25494,'Spirit of Niniel',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,54,'female','L2Minion',40,46232,1859,71.07,9.81,40,43,30,41,20,10,0,0,2187,1252,1685,508,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25495,25495,'Spirit of Niniel',0,'Raid Fighter',0,'Monster.pixy',5.00,25.00,54,'female','L2Minion',40,23116,1859,71.07,9.81,40,43,30,41,20,10,0,0,1094,1252,420,508,278,0,333,0,0,0,88,209,NULL,0,0,0,'LAST_HIT'),
	(25496,25496,'Fafurion''s Envoy Pingolpin',0,'Raid Boss',0,'Monster.riba',25.00,72.00,52,'female','L2RaidBoss',40,402319,3718,256.09,9.81,60,57,73,76,70,80,1393971,205212,914,2363,242,959,409,0,3819,0,0,0,97,307,NULL,0,0,0,'LAST_HIT'),
	(25497,25497,'Fafurion''s Envoy   ',0,'Raid Fighter',0,'Monster.marsh_stakato_soldier',10.00,25.00,51,'male','L2Minion',40,8373,1859,66.45,9.81,40,43,30,41,20,10,0,0,1679,1147,879,465,278,0,333,76,0,0,33,209,NULL,0,0,0,'LAST_HIT'),
	(25498,25498,'Fafurion''s Henchman Istary',0,'Raid Boss',0,'Monster.farhite_50_bi',24.00,48.00,45,'male','L2RaidBoss',40,288415,3718,215.06,9.81,60,57,73,76,70,80,1139085,129941,456,1905,86,774,409,0,3819,5131,0,0,24,307,NULL,0,0,0,'LAST_HIT'),
	(25499,25499,'Alligator of Istary',0,'Raid Fighter',0,'Monster.crocodile',28.00,11.50,44,'male','L2Minion',40,29037,1859,55.55,9.81,40,43,30,41,20,10,0,0,826,922,307,374,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25500,25500,'Alligator of Istary',0,'Raid Fighter',0,'Monster.crocodile',28.00,11.50,44,'male','L2Minion',40,14518,1859,55.55,9.81,40,43,30,41,20,10,0,0,413,922,76,374,278,0,333,0,0,0,77,209,NULL,0,0,0,'LAST_HIT'),
	(25501,25501,'Boss Akata',0,'Raid Boss',0,'NPC.e_collector_teacher_Mdwarf_mon_130p',20.00,28.00,30,'male','L2RaidBoss',40,127782,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,8206,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25502,25502,'Akata''s Thug',0,'Raid Fighter',0,'NPC.e_traderB_Fdwarf_mon_120p',20.00,28.00,30,'male','L2Minion',40,9093,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,8205,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25503,25503,'Akata''s Lackey',0,'Raid Fighter',0,'NPC.e_collector_teacher_Fdwarf_mon_120p',20.00,23.00,30,'male','L2Minion',40,6786,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,8208,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25504,25504,'Nellis'' Vengeful Spirit',0,'Raid Boss',0,'NPC.a_mageguild_teacher_Mhuman_mon_120p',20.00,29.00,39,'male','L2RaidBoss',40,206753,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25505,25505,'Nellis'' Follower',0,'Raid Fighter',0,'Monster.dwarf_ghost',20.00,16.00,38,'male','L2Minion',40,20752,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25506,25506,'Rayito the Looter',0,'Raid Boss',0,'Monster.ol_mahum_champion_05te_120p',20.00,35.00,37,'male','L2RaidBoss',40,184670,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25507,25507,'Rayito''s Henchman',0,'Raid Fighter',0,'Monster.ol_mahum_05te_110p',20.00,25.00,36,'male','L2Minion',40,18550,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,134,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25508,25508,'Rayito''s Henchman',0,'Raid Fighter',0,'Monster2.northern_goblin_110p',20.00,25.00,36,'male','L2Minion',40,12428,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,135,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25509,25509,'Dark Shaman Varangka ',0,'Raid Boss',0,'Monster.batur_orc_shaman_a_01te_120p',45.00,50.00,53,'male','L2RaidBoss',40,418874,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,8000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25510,25510,'Varangka''s Descendant',0,'Raid Fighter',0,'Monster.batur_orc_overlord_01te_110p',20.00,25.00,52,'male','L2Minion',40,42733,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25511,25511,'Varangka''s Page',0,'Raid Fighter',0,'Monster.batur_orc_shaman_a_01te_110p',20.00,40.00,52,'male','L2Minion',40,21366,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25512,25512,'Gigantic Chaos Golem',0,'Raid Boss',0,'Monster3.chaos_golem',20.00,51.00,52,'male','L2RaidBoss',40,804638,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25514,25514,'Queen Shyeed',0,'Raid Boss',0,'Monster3.cannibal_stakato_leader_tran_120p',52.00,50.00,80,'male','L2RaidBoss',40,714778,3718,368.11,9.81,60,57,73,76,70,80,3206477,835990,6959,4615,4585,1874,409,0,3819,0,0,0,58,307,NULL,0,0,0,'LAST_HIT'),
	(25515,25515,'Spiked Stakato',0,'Raid Fighter',0,'Monster.spike_stakato_110p',20.00,25.00,79,'male','L2Minion',40,50349,1859,96.62,9.81,40,43,30,41,20,10,0,0,10082,2434,9295,988,278,0,333,0,0,0,40,209,NULL,0,0,0,'LAST_HIT'),
	(25516,25516,'Spiked Stakato',0,'Raid Fighter',0,'Monster.spike_stakato_worker_110p',20.00,25.00,79,'male','L2Minion',40,75148,1859,98.02,9.81,40,43,30,41,20,10,0,0,13374,2265,17740,919,278,0,333,0,0,0,37,209,NULL,0,0,0,'LAST_HIT'),
	(25517,25517,'Master Anays',0,'Raid Boss',0,'Monster3.solina_priest_120p',20.00,25.00,87,'male','L2RaidBoss',40,1069643,3718,355.43,9.81,60,57,73,76,70,80,3526018,952059,17006,5200,24162,2112,409,500,3819,0,0,0,42,307,NULL,0,0,0,'LAST_HIT'),
	(25518,25518,'Splendor Disciple',0,'Raid Fighter',0,'Monster3.apostle_grail',20.00,25.00,86,'male','L2Minion',40,56245,1859,95.02,9.81,40,43,30,41,20,10,0,0,16392,2559,23362,1039,278,500,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25519,25519,'Splendor Worshiper',0,'Raid Fighter',0,'Monster3.apostle_grail_a',20.00,25.00,86,'male','L2Minion',40,75369,2110,95.02,9.81,40,43,30,21,20,10,0,0,11325,2315,18521,1075,278,500,333,0,0,0,99,209,NULL,0,0,0,'LAST_HIT'),
	(25523,25523,'Plague Golem',0,'Raid Boss',0,'Monster3.Steel_Trapper',20.00,25.00,73,'male','L2RaidBoss',40,1848045,9999,13.43,3.09,60,57,73,76,70,80,440000,40000,9000,5000,6000,6000,300,500,333,8218,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(25524,25524,'Flamestone Giant',0,'Raid Boss',0,'Monster2.lava_golem',20.00,23.00,76,'male','L2RaidBoss',40,956490,3247,742.11,9.81,60,57,73,76,70,80,4888056,961047,8153,4273,10359,1735,278,0,3819,0,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(25525,25525,'Flame Spirit',0,'Raid Fighter',0,'Monster.mana_vampire',20,23,75,'male','L2Minion',40,100472,1601,197.17,9.81,40,43,30,21,20,10,0,0,15569,2094,39730,850,278,0,333,0,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25526,25526,'Charged Spirit',0,'Raid Fighter',0,'Monster.magical_weaver',20,23,75,'male','L2Minion',40,50236,1601,197.17,9.81,40,43,30,21,20,10,0,0,7784,2094,9932,850,278,0,333,0,0,0,55,187,NULL,0,0,0,'LAST_HIT'),
	(25527,25527,'Uruka',0,'Raid Boss',0,'Monster3.Crokian_Elder',30.00,42.51,86,'male','L2RaidBoss',40,1532678,3718,355.43,9.81,60,57,73,76,70,80,3526019,952059,17006,5200,24162,2112,409,0,3819,0,0,0,40,307,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(27001,27001,'Orc Sniper',0,'',0,'Monster.orc_archer',14.00,25.00,10,'male','L2Monster',500,257,120,3.16,0.91,40,43,30,21,20,10,0,0,51,61,8,49,249,0,333,14,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27002,27002,'Orc Fighter',0,'',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,27,66,10,54,278,0,333,1,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27003,27003,'Spirit Of Mirrors',0,'Quest Monster',0,'Monster.poison_toad',20.00,10.00,9,'male','L2Monster',40,226,111,3.16,0.91,40,43,30,21,20,10,0,0,20,58,7,47,278,0,333,0,0,0,55,110,NULL,0,0,0,'LAST_HIT'),
	(27004,27004,'Spirit Of Mirrors',0,'Quest Monster',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,0,0,22,61,8,49,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27005,27005,'Spirit Of Mirrors',0,'Quest Monster',0,'Monster.werewolf',10.00,26.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(27006,27006,'Bhato Bloodspear',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27007,27007,'Tanuki Skullcrusher',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27008,27008,'Kraacul Blackskull',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27009,27009,'Taarq Blackskull',0,'',0,'Monster.orc_archer',14.00,25.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27016,27016,'Nerkas',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,0,0,68,102,28,83,278,0,333,0,0,0,88,88,NULL,0,0,0,'LAST_HIT'),
	(27017,27017,'Plague Zombie',0,'Quest Monster',0,'Monster.zombie',13.00,21.00,14,'male','L2Monster',40,364,156,3.95,1.21,40,43,30,21,20,10,0,0,33,73,12,59,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(27018,27018,'Orc Warrior',0,'',0,'Monster.orc_fighter',12.00,22.00,10,'male','L2Monster',40,257,120,3.16,0.91,40,43,30,21,20,10,0,0,22,61,8,49,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27019,27019,'Orc Warrior Leader',0,'',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,0,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27020,27020,'Varool Foulclaw',0,'Quest Monster',0,'Monster.wererat',14.00,25.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27021,27021,'Kirunak',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,22,'male','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,0,0,68,102,28,83,278,0,333,0,0,0,88,88,'kirunak_clan',300,0,0,'LAST_HIT'),
	(27022,27022,'Merkenis',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,22,'female','L2Monster',40,611,242,5.53,1.53,40,43,30,21,20,10,0,0,68,102,28,83,278,0,333,0,0,0,66,110,NULL,0,0,0,'LAST_HIT'),
	(27024,27024,'Undead Priest',0,'Quest Monster',0,'Monster.zombie',13.00,21.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,48,75,17,67,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(27029,27029,'Phantom Salamander',0,'Quest Monster',0,'Monster.salamander',16.00,6.80,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,48,75,17,67,278,500,333,0,0,0,70,105,NULL,0,0,0,'LAST_HIT'),
	(27030,27030,'Water Seer',0,'Quest Monster',0,'Monster.monster_eye',21.00,43.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,48,75,17,67,278,500,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(27031,27031,'Ol Mahum Sentry',0,'Quest Monster',0,'Monster.ol_mahum',13.50,25.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,48,75,17,67,278,0,333,2,0,0,55,121,'ol_mahum_clan',300,0,0,'LAST_HIT'),
	(27032,27032,'Lizardman Warrior',0,'Quest Monster',0,'Monster.virud_lizardman_warrior',12.00,30.00,13,'male','L2Monster',80,339,147,3.95,1.21,40,43,30,21,20,10,0,0,33,63,11,56,237,500,333,16,0,0,57,143,NULL,0,0,0,'LAST_HIT'),
	(27033,27033,'Lizardman Scout',0,'Quest Monster',0,'Monster.virud_lizardman',10.00,23.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,30,60,10,54,278,500,333,1,0,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(27034,27034,'Lizardman',0,'Quest Monster',0,'Monster.virud_lizardman',10.00,23.00,11,'male','L2Monster',80,292,129,3.95,1.21,40,43,30,21,20,10,0,0,27,58,9,52,237,500,333,291,0,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(27035,27035,'Tamil',0,'Quest Monster',0,'Monster.bugbear',17.00,35.00,19,'male','L2Monster',40,508,203,3.95,1.21,40,43,30,21,20,10,0,0,58,82,21,73,278,500,333,4,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27036,27036,'Calpico',0,'Quest Monster',0,'Monster.orc_fighter',12.00,22.00,13,'male','L2Monster',40,339,147,3.95,1.21,40,43,30,21,20,10,0,0,33,63,11,56,278,0,333,2,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27037,27037,'Calpico''s Goons',0,'Quest Monster',0,'Monster.orc',10.00,21.00,10,'male','L2Minion',40,257,120,3.16,0.91,40,43,30,21,20,10,0,0,25,55,8,49,278,0,333,1,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27038,27038,'Cat''s Eye Bandit',0,'Quest Monster',0,'Monster.ol_mahum',13.50,25.00,15,'male','L2Monster',40,390,165,3.95,1.21,40,43,30,21,20,10,0,0,32,76,14,62,317,0,333,218,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27041,27041,'Baranka''s Messenger',0,'Quest Monster',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,25,73,10,54,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27042,27042,'Orc Escort',0,'Quest Monster',0,'Monster.orc_fighter',12.00,22.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,25,73,10,54,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27043,27043,'Varangka''s Tracker',0,'Quest Monster',0,'Monster.vampire_bat',10.00,33.50,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,23,70,9,52,278,500,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(27044,27044,'Kasha Bear Totem Spirit',0,'Quest Monster',0,'Monster.grizzly',21.00,40.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,40,91,17,67,278,500,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(27045,27045,'Kuruka Ratman Leader',0,'Quest Monster',0,'Monster.wererat',14.00,25.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,0,0,44,95,19,70,278,500,333,1,0,0,88,132,'wererat_clan',300,0,0,'LAST_HIT'),
	(27046,27046,'Sumi',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27047,27047,'Wanuk',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27048,27048,'Chewba',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27049,27049,'Heitafu',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27050,27050,'Picubo',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27051,27051,'Bumbum',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27052,27052,'Minsku',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27053,27053,'Chuchu',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27054,27054,'Umbar Orc',0,'Quest Monster',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27055,27055,'Zakan',0,'Orc Betrayer',0,'Monster.batur_orc',9.00,21.50,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,57,94,23,76,278,0,333,2,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27056,27056,'Durka Spirit',0,'Quest Monster',0,'Monster.magical_weaver',11.00,20.00,18,'male','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,0,0,48,87,19,70,278,500,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(27058,27058,'Honey Bear',0,'Quest Monster',0,'Monster.grizzly',21.00,40.00,17,'male','L2Monster',40,446,184,3.95,1.21,40,43,30,21,20,10,0,0,48,75,17,67,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(27059,27059,'Uoph',0,'Kaboo Chief',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27060,27060,'Kracha',0,'Kaboo Chief',0,'Monster.orc_archer',14.00,25.00,11,'male','L2Monster',500,292,129,3.95,1.21,40,43,30,21,20,10,0,0,56,64,9,52,249,0,333,275,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27061,27061,'Batoh',0,'Kaboo Chief',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,86,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27062,27062,'Tanukia',0,'Kaboo Chief',0,'Monster.orc_fighter',12.00,22.00,8,'male','L2Monster',40,197,102,3.16,0.91,40,43,30,21,20,10,0,0,18,55,6,45,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27063,27063,'Tanukia''s Warhound',0,'Quest Monster',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,0,0,12,46,4,37,278,0,333,0,0,0,26,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27064,27064,'Turel',0,'Kaboo Chief',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27065,27065,'Roko',0,'Kaboo Chief',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,0,0,41,55,6,45,249,0,333,275,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27066,27066,'Roko''s Warhound',0,'Quest Monster',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,0,0,12,46,4,37,278,0,333,0,0,0,26,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27067,27067,'Kamut',0,'Kaboo Chief',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,86,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27068,27068,'Murtika',0,'Kaboo Chief',0,'Monster.orc_archer',14.00,25.00,8,'male','L2Monster',500,197,102,3.16,0.91,40,43,30,21,20,10,0,0,41,55,6,45,249,0,333,275,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27069,27069,'Murtika''s Warhound',0,'Quest Monster',0,'Monster.wolf',13.00,9.00,4,'male','L2Monster',40,107,68,3.16,0.91,40,43,30,21,20,10,0,0,12,46,4,37,278,0,333,0,0,0,26,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27070,27070,'Tumran Orc Brigand',0,'Quest Monster',0,'Monster.orc_fighter',12.00,22.00,11,'male','L2Monster',40,292,129,3.95,1.21,40,43,30,21,20,10,0,0,25,64,9,52,278,0,333,2,0,0,49,121,'orc_clan',300,0,0,'LAST_HIT'),
	(27077,27077,'Unicorn Of Eva',0,'Quest Monster',0,'Monster.unicorn',14.00,30.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,0,0,145,128,58,114,278,0,333,0,0,0,50,165,NULL,0,0,0,'LAST_HIT'),
	(27078,27078,'Trimden Lord ',0,'Quest Monster',0,'Monster.poison_spider',27.00,25.50,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,255,195,121,158,278,0,333,0,0,0,66,154,NULL,0,0,0,'LAST_HIT'),
	(27079,27079,'Black Willow Lurker',0,'Quest Monster',0,'Monster.hanged_man_ripper',35.00,80.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,255,195,121,158,278,0,333,0,0,0,60,60,NULL,0,0,0,'LAST_HIT'),
	(27080,27080,'Pashika Son Of Voltar',0,'Quest Monster',0,'Monster.batur_orc_warrior',10.00,20.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,222,182,104,147,278,500,333,2,0,0,88,132,'orc_clan',300,0,0,'LAST_HIT'),
	(27081,27081,'Vultus Son Of Voltar',0,'Quest Monster',0,'Monster.batur_orc_warrior',10.00,20.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,222,182,104,147,278,500,333,2,0,0,88,132,'orc_clan',300,0,0,'LAST_HIT'),
	(27082,27082,'Enku Orc Overlord',0,'Quest Monster',0,'Monster.batur_orc_warrior',10.00,20.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,0,0,182,143,75,128,278,500,333,2,0,0,88,132,'orc_clan',300,0,0,'LAST_HIT'),
	(27083,27083,'Makum Bugbear Thug',0,'Quest Monster',0,'Monster.bugbear',17.00,35.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,244,165,104,147,278,500,333,2,0,0,60,143,'orc_clan',300,0,0,'LAST_HIT'),
	(27086,27086,'Revenant of Tantos Chief',0,'Quest Monster',0,'Monster.batur_orc_overlord',12.00,24.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,231,214,121,158,278,0,333,66,0,0,88,154,'orc_clan',300,0,0,'LAST_HIT'),
	(27088,27088,'Harpy Matriarch',0,'Quest Monster',0,'Monster.harpy',10.00,42.00,34,'female','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,0,0,178,163,82,132,278,500,333,0,0,0,66,110,NULL,0,0,0,'LAST_HIT'),
	(27089,27089,'Road Collector',0,'Quest Monster',0,'Monster.wererat',14.00,25.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,500,333,12,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27090,27090,'Serpent Demon Kadesh',0,'Quest Monster',0,'Monster.serpent_slave',17.00,46.00,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,0,0,291,208,141,169,278,0,333,73,0,0,77,121,NULL,0,0,0,'LAST_HIT'),
	(27092,27092,'Neer Bodyguard',0,'Quest Monster',0,'Monster.neer_crawler',14.00,22.00,33,'male','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,0,0,182,143,75,128,278,500,333,0,0,0,55,99,'lizardman_clan',300,1,0,'LAST_HIT'),
	(27093,27093,'Delu Chief Kalkis',0,'Quest Monster',0,'Monster.virud_lizardman_matriarch',13.00,37.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,244,165,104,147,278,0,333,12,0,0,61,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27094,27094,'Delu Lizardman Assassin',0,'Quest Monster',0,'Monster.virud_lizardman',10.00,23.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,227,159,96,142,278,500,333,2,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27095,27095,'Singing Flower Phantasm',0,'Quest Monster',0,'Monster.mandragora_b',12.00,25.50,44,'female','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,0,0,322,253,176,187,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27096,27096,'Singing Flower Nightmare',0,'Quest Monster',0,'Monster.mandragora_b',12.00,25.50,44,'female','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,0,0,322,253,176,187,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27097,27097,'Singing Flower Darkling',0,'Quest Monster',0,'Monster.mandragora_b',12.00,25.50,44,'female','L2Monster',40,1799,648,8.69,2.14,40,43,30,21,20,10,0,0,322,253,176,187,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27098,27098,'Ghost Fire',0,'Quest Monster',0,'Monster.will_o_wisp',13.00,22.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,0,0,311,215,152,175,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27099,27099,'Nameless Revenant',0,'Quest Monster',0,'Monster.zombie',13.00,21.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,0,0,261,171,112,153,278,0,333,0,0,0,16,16,NULL,0,1,0,'LAST_HIT'),
	(27100,27100,'Skeletal Mercenary',0,'Quest Monster',0,'Monster.skeleton_knight',10.00,25.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,280,177,121,158,278,0,333,69,0,0,44,176,NULL,0,1,0,'LAST_HIT'),
	(27101,27101,'Drevanul Prince Zeruel',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,0,0,342,196,152,175,278,0,333,0,0,0,88,88,NULL,0,0,0,'LAST_HIT'),
	(27102,27102,'Pako The Cat',0,'Quest Monster',0,'Monster.cat_the_cat',9.00,16.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,0,0,238,188,112,153,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27103,27103,'Unicorn Racer',0,'Quest Monster',0,'Monster.unicorn_boxer',11.00,18.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,0,0,238,188,112,153,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(27104,27104,'Shadow Turen',0,'Quest Monster',0,'Monster.shadow',10.00,30.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,255,195,121,158,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27105,27105,'Mimi The Cat',0,'Quest Monster',0,'Monster.cutie_cat',8.00,15.00,39,'female','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,255,195,121,158,278,0,333,0,0,0,52,154,NULL,0,0,0,'LAST_HIT'),
	(27106,27106,'Unicorn Phantasm',0,'Quest Monster',0,'Monster.unicorn_mirage',13.00,17.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,273,201,131,164,278,0,333,0,0,0,29,154,NULL,0,0,0,'LAST_HIT'),
	(27107,27107,'Silhouette Tilfo',0,'Quest Monster',0,'Monster.silhouette',8.00,23.00,40,'female','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,273,201,131,164,278,0,333,0,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27108,27108,'Stenoa Gorgon Queen',0,'Quest Monster',0,'Monster.cave_maiden',25.00,65.00,37,'female','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,244,165,104,147,278,0,333,127,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(27109,27109,'Handmaiden Of Stenoa',0,'Quest Monster',0,'Monster.medusa',10.00,25.00,33,'female','L2Monster',40,1109,413,7.11,1.84,40,43,30,21,20,10,0,0,182,143,75,128,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27110,27110,'Shyslassys',0,'Quest Monster',0,'Monster.medusa',10.00,25.00,36,'female','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,187,193,96,142,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27111,27111,'Cave Basilisk',0,'Quest Monster',0,'Monster.lesser_basilisk',34.00,25.00,30,'male','L2Minion',40,954,365,5.53,1.53,40,43,30,21,20,10,0,0,120,155,58,114,278,0,333,0,0,0,38,59,NULL,0,0,0,'LAST_HIT'),
	(27112,27112,'Gorr',0,'Quest Monster',0,'Monster.medusa',10.00,25.00,36,'female','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,227,159,96,142,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27113,27113,'Baraham',0,'Quest Monster',0,'Monster.medusa',10.00,25.00,36,'female','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,227,159,96,142,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27114,27114,'Succubus Queen',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,34,'female','L2Monster',40,1164,430,7.11,1.84,40,43,30,21,20,10,0,0,196,148,82,132,278,0,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(27115,27115,'Claw Of Succubus',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,28,'female','L2Monster',40,859,334,5.53,1.53,40,43,30,21,20,10,0,0,124,118,49,106,278,0,333,0,0,0,66,110,'demonic_clan',300,0,0,'LAST_HIT'),
	(27116,27116,'Lava Salamander',0,'Quest Monster',0,'Monster.salamander',16.00,6.80,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,174,186,89,137,278,0,333,0,0,0,70,105,'elemental3_clan',300,0,0,'LAST_HIT'),
	(27117,27117,'Nahir',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,174,186,89,137,278,0,333,0,0,0,88,88,NULL,0,0,0,'LAST_HIT'),
	(27118,27118,'Black Willow',0,'Quest Monster',0,'Monster.hanged_man_ripper',35.00,80.00,30,'male','L2Monster',40,954,365,5.53,1.53,40,43,30,21,20,10,0,0,145,128,58,114,278,0,333,0,0,0,60,60,NULL,0,0,0,'LAST_HIT'),
	(27119,27119,'Spirit of Sir Herod',0,'Quest Monster',0,'Monster.skeleton_royal_guard',11.00,28.50,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,69,0,0,88,132,'skeleton_clan',300,1,0,'LAST_HIT'),
	(27120,27120,'Luell Of Zephyr Winds',0,'Quest Monster',0,'Monster.sylph',11.00,35.00,37,'female','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,222,182,104,147,278,0,333,0,0,0,66,66,'elemental2_clan',300,0,0,'LAST_HIT'),
	(27121,27121,'Actea Of Verdant Wilds',0,'Quest Monster',0,'Monster.dryad',9.00,20.00,37,'female','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,222,182,104,147,278,0,333,0,0,0,44,121,'elemental1_clan',300,0,0,'LAST_HIT'),
	(27122,27122,'Leto Lizardman Agent',0,'Quest Monster',0,'Monster.zenta_lizardman',11.00,32.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,1,0,0,40,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27123,27123,'Leto Lizardman Leader',0,'Quest Monster',0,'Monster.zenta_lizardman_warrior',13.00,35.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,0,0,238,188,112,153,278,0,333,66,0,0,44,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27124,27124,'Leto Lizardman Assassin',0,'Quest Monster',0,'Monster.zenta_lizardman',11.00,32.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,244,165,104,147,278,500,333,217,0,0,40,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27125,27125,'Leto Lizardman Sniper',0,'Quest Monster',0,'Monster.zenta_lizardman_scout',11.00,30.00,36,'male','L2Monster',500,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,417,193,96,142,249,0,333,14,0,0,40,165,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27126,27126,'Leto Lizardman Wizard',0,'Quest Monster',0,'Monster.zenta_lizardman_shaman',13.00,35.00,39,'male','L2Monster',40,1462,514,7.11,1.84,40,43,30,21,20,10,0,0,280,177,121,158,278,0,333,7,0,0,47,143,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27127,27127,'Leto Lizardman Lord',0,'Quest Monster',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,248,222,131,164,278,500,333,69,0,0,58,154,'lizardman_clan',300,0,0,'LAST_HIT'),
	(27128,27128,'Aruraune',0,'Quest Monster',0,'Monster.mandragora_b',12.00,25.50,40,'female','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,273,201,131,164,278,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27129,27129,'Ol Mahum Inspector',0,'Quest Monster',0,'Monster.ol_mahum',13.50,25.00,38,'male','L2Monster',40,1400,497,7.11,1.84,40,43,30,21,20,10,0,0,261,171,112,153,278,500,333,2,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27130,27130,'Ol Mahum Betrayer',0,'Quest Monster',0,'Monster.ol_mahum',13.50,25.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,187,193,96,142,278,0,333,12,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27131,27131,'Crimson Werewolf',0,'Quest Monster',0,'Monster.werewolf',10.00,26.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,500,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(27132,27132,'Krudel Lizardman',0,'Quest Monster',0,'Monster.virud_lizardman',10.00,23.00,36,'male','L2Monster',80,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,237,500,333,291,0,0,47,143,'elemental1_clan',300,0,0,'LAST_HIT'),
	(27133,27133,'Evil Eye Lord',0,'Quest Monster',0,'Monster.monster_eye',21.00,43.00,37,'male','L2Monster',40,1338,480,7.11,1.84,40,43,30,21,20,10,0,0,244,165,104,147,278,500,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(27134,27134,'Tatoma',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,0,0,140,167,69,123,278,500,333,88,0,0,60,143,'orc_clan',300,0,0,'LAST_HIT'),
	(27135,27135,'Grima',0,'Quest Monster',0,'Monster.devastator',35.00,35.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,560,253,264,226,278,500,333,0,0,0,27,187,NULL,0,0,0,'LAST_HIT'),
	(27136,27136,'Succubus Of Seduction',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,40,'female','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,248,222,131,164,278,500,333,0,0,0,66,110,NULL,0,0,0,'LAST_HIT'),
	(27137,27137,'Demon King',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,50,'male','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,500,333,0,0,0,88,88,NULL,0,0,0,'LAST_HIT'),
	(27138,27138,'Great Demon King',0,'Quest Monster',0,'Monster.death_knight',12.00,31.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,0,0,946,335,478,299,278,500,333,127,0,0,29,121,NULL,0,1,0,'LAST_HIT'),
	(27139,27139,'Secret Keeper Tree',0,'Quest Monster',0,'Monster.ti_mi_tran',23.00,90.00,47,'male','L2Monster',40,2016,738,8.69,2.14,40,43,30,21,20,10,0,0,388,279,216,206,278,0,333,0,0,0,13,13,NULL,0,0,0,'LAST_HIT'),
	(27140,27140,'Breka Overlord Haka',0,'Quest Monster',0,'Monster.batur_orc_overlord',12.00,24.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,187,193,96,142,278,500,333,66,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27141,27141,'Breka Overlord Jaka',0,'Quest Monster',0,'Monster.batur_orc_overlord',12.00,24.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,187,193,96,142,278,500,333,66,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27142,27142,'Breka Overlord Marka',0,'Quest Monster',0,'Monster.batur_orc_overlord',12.00,24.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,187,193,96,142,278,500,333,66,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27143,27143,'Windsus Aleph',0,'Quest Monster',0,'Monster.giant_wild_hog',35.00,27.00,42,'male','L2Monster',40,1660,589,8.69,2.14,40,43,30,21,20,10,0,0,342,196,152,175,278,500,333,0,0,0,38,132,NULL,0,0,0,'LAST_HIT'),
	(27144,27144,'Tarlk Raider Athu',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,0,0,498,238,231,212,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27145,27145,'Tarlk Raider Lanka',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,0,0,498,238,231,212,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27146,27146,'Tarlk Raider Triska',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,0,0,498,238,231,212,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27147,27147,'Tarlk Raider Motura',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,0,0,498,238,231,212,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27148,27148,'Tarlk Raider Kalath',0,'Quest Monster',0,'Monster.king_bugbear',15.00,40.00,48,'male','L2Monster',40,2091,768,8.69,2.14,40,43,30,21,20,10,0,0,498,238,231,212,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27149,27149,'Gremlin Filcher',0,'Quest Monster',0,'Monster.gremlin',10.00,15.00,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,25,73,10,54,278,500,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(27150,27150,'Black Legion Stormtrooper',0,'Quest Monster',0,'Monster.skeleton_royal_guard',11.00,28.50,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,0,0,365,202,163,181,278,500,333,217,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(27151,27151,'Delu Lizardman Headhunter',0,'Quest Monster',0,'Monster.virud_lizardman_scout',10.00,22.00,28,'male','L2Monster',500,859,334,5.53,1.53,40,43,30,21,20,10,0,0,276,118,49,106,249,500,333,2507,0,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(27152,27152,'Marsh Stakato Marquess',0,'Quest Monster',0,'Monster.marsh_stakato_queen',15.00,37.00,35,'female','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,211,154,89,137,278,500,333,0,0,0,143,143,NULL,0,0,0,'LAST_HIT'),
	(27153,27153,'Alexandro Sanches ',0,'Dark Lord',0,'Monster.imp',10.00,24.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,0,0,10,48,3,35,278,0,333,0,0,0,66,88,NULL,0,0,0,'LAST_HIT'),
	(27154,27154,'Bonaparterius',0,'Abyss King',0,'Monster.goblin',10.00,16.50,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,0,0,10,48,3,35,278,0,333,4,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(27155,27155,'Ramsebalius',0,'Evil Overlord',0,'Monster.orc',10.00,21.00,3,'male','L2Monster',40,90,60,3.16,0.91,40,43,30,21,20,10,0,0,12,40,3,35,278,0,333,2,0,0,49,121,NULL,0,0,0,'LAST_HIT'),
	(27156,27156,'Leto Shaman Ketz',0,'Quest Monster',0,'Monster.zenta_lizardman_shaman',13.00,35.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,0,0,248,222,131,164,278,500,333,159,0,0,47,143,NULL,0,0,0,'LAST_HIT'),
	(27157,27157,'Leto Chief Narak',0,'Quest Monster',0,'Monster.zenta_lizardman_matriarch',20.00,40.00,41,'male','L2Monster',40,1593,560,8.69,2.14,40,43,30,21,20,10,0,0,265,229,141,169,278,500,333,221,0,0,58,154,NULL,0,0,0,'LAST_HIT'),
	(27158,27158,'Timak Raider Kaikee',0,'Quest Monster',0,'Monster.batur_orc',9.00,21.50,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,0,0,365,202,163,181,278,500,333,66,0,0,88,143,NULL,0,0,0,'LAST_HIT'),
	(27159,27159,'Timak Overlord Okun',0,'Quest Monster',0,'Monster.batur_orc_overlord',12.00,24.00,46,'male','L2Monster',40,1943,707,8.69,2.14,40,43,30,21,20,10,0,0,442,223,202,199,278,500,333,127,0,0,88,154,NULL,0,0,0,'LAST_HIT'),
	(27160,27160,'Gok Magok',0,'Grandis Chief',0,'Monster.twin_headed_giant',17.00,39.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,0,0,302,245,163,181,278,500,333,0,0,0,49,110,NULL,0,0,0,'LAST_HIT'),
	(27161,27161,'Taik Overlord Kakran',0,'Quest Monster',0,'Monster.ketra_orc_warrior',12.00,24.00,45,'male','L2Monster',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,415,216,188,193,278,500,333,69,0,0,39,187,NULL,0,0,0,'LAST_HIT'),
	(27162,27162,'Hatar Chieftain Kubel',0,'Quest Monster',0,'Monster.medusa',10.00,25.00,52,'female','L2Monster',40,2402,892,10.27,2.45,40,43,30,21,20,10,0,0,518,324,300,239,278,500,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(27163,27163,'Vanor Elder Kerunos',0,'Quest Monster',0,'Monster.heltor_silenos_chieftain',13.00,31.50,51,'male','L2Monster',40,2323,861,10.27,2.45,40,43,30,21,20,10,0,0,490,315,281,232,278,500,333,179,0,0,29,176,NULL,0,0,0,'LAST_HIT'),
	(27164,27164,'Karul Chief Orooto',0,'Quest Monster',0,'Monster.bugbear',17.00,35.00,43,'male','L2Monster',40,1728,618,8.69,2.14,40,43,30,21,20,10,0,0,365,202,163,181,278,500,333,88,0,0,60,143,NULL,0,0,0,'LAST_HIT'),
	(27165,27165,'Abyssal Jewel 1',0,'Quest Monster',0,'Monster.mirror',26.00,52.00,60,'male','L2Monster',40,3054,1150,92.43,2.45,40,43,30,21,20,10,0,0,782,405,478,299,278,0,333,0,0,0,88,181,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27166,27166,'Abyssal Jewel 2',0,'Quest Monster',0,'Monster.mirror',26.00,52.00,60,'male','L2Monster',40,3054,1150,92.43,2.45,40,43,30,21,20,10,0,0,782,405,478,299,278,0,333,0,0,0,88,181,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27167,27167,'Abyssal Jewel 3',0,'Quest Monster',0,'Monster.mirror',26.00,52.00,60,'male','L2Monster',40,3054,1150,92.43,2.45,40,43,30,21,20,10,0,0,782,405,478,299,278,0,333,0,0,0,88,181,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27168,27168,'Jewel Guardian Mara',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,53,'female','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,0,0,662,276,319,247,278,500,333,0,0,0,66,110,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27169,27169,'Jewel Guardian Musfel',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,53,'male','L2Monster',40,2481,923,10.27,2.45,40,43,30,21,20,10,0,0,547,334,319,247,278,500,333,0,0,0,88,88,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27170,27170,'Jewel Guardian Pyton',0,'Quest Monster',0,'Monster.serpent_slave',17.00,46.00,58,'male','L2Monster',40,2889,1084,10.27,2.45,40,43,30,21,20,10,0,0,710,384,428,284,278,500,333,223,0,0,77,121,'abyss_jewel_clan',300,0,0,'LAST_HIT'),
	(27171,27171,'Sacrifice Of The Sacrificed',0,'Quest Monster',0,'Monster.magical_weaver',11.00,20.00,20,'male','L2Monster',40,541,213,3.95,1.21,40,43,30,21,20,10,0,0,63,86,23,76,278,0,333,0,0,0,99,99,NULL,0,0,0,'LAST_HIT'),
	(27172,27172,'Harit Lizardman Zealot',0,'Quest Monster',0,'Monster.zenta_lizardman_warrior',13.00,35.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,737,292,360,261,278,500,333,16,0,0,44,154,NULL,0,0,0,'LAST_HIT'),
	(27173,27173,'Box Of Athrea 1',0,'Quest Monster',0,'NPC.coffer_a',12.00,9.50,50,'etc','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(27174,27174,'Box Of Athrea 2',0,'Quest Monster',0,'NPC.coffer_a',12.00,9.50,50,'etc','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(27175,27175,'Box Of Athrea 3',0,'Quest Monster',0,'NPC.coffer_a',12.00,9.50,50,'etc','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(27176,27176,'Box Of Athrea 4',0,'Quest Monster',0,'NPC.coffer_a',12.00,9.50,50,'etc','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(27177,27177,'Box Of Athrea 5',0,'Quest Monster',0,'NPC.coffer_a',12.00,9.50,50,'etc','L2Monster',40,2245,830,8.69,2.14,40,43,30,21,20,10,0,0,463,306,264,226,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(27178,27178,'Blitz Wyrm',0,'Quest Monster',0,'Monster.wyrm',29.00,72.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,0,0,946,335,478,299,278,500,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(27179,27179,'Grave Keymaster',0,'Quest Monster',0,'Monster.gargoyle',16.00,50.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,979,460,619,340,278,0,333,0,0,0,154,154,'grave_guard_clan',300,0,0,'LAST_HIT'),
	(27180,27180,'Imperial Slave',0,'Quest Monster',0,'Monster.binding',12.00,21.00,56,'male','L2Monster',40,2724,1019,10.27,2.45,40,43,30,21,20,10,0,0,642,364,382,269,278,500,333,0,0,0,11,154,'grave_keeper_clan',300,1,0,'LAST_HIT'),
	(27181,27181,'Imperial Gravekeeper',0,'Quest Monster',0,'Monster.death_blader',15.00,45.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,0,0,782,405,478,299,278,0,333,1472,0,0,110,187,'grave_keeper_clan',300,1,0,'LAST_HIT'),
	(27182,27182,'Ark Guardian Elberoth',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,60,'male','L2Monster',40,3054,1150,10.27,2.45,40,43,30,21,20,10,0,0,782,405,478,299,278,0,333,6370,0,0,55,220,NULL,0,0,0,'LAST_HIT'),
	(27183,27183,'Ark Guardian Shadowfang',0,'Quest Monster',0,'Monster.kel_mahum_archer',13.00,27.00,60,'male','L2Monster',500,3054,1150,10.27,2.45,40,43,30,21,20,10,0,0,2313,259,478,299,249,0,333,288,0,0,55,176,NULL,0,0,0,'LAST_HIT'),
	(27184,27184,'Angel Killer',0,'Quest Monster',0,'Monster.death_lord',21.00,40.00,60,'male','L2Monster',40,3054,1150,92.43,2.45,40,43,30,21,20,10,0,0,711,446,478,299,278,0,333,130,0,0,44,220,NULL,0,1,0,'LAST_HIT'),
	(27185,27185,'Fairy Tree of Wind',0,'Quest Monster',0,'NPC.human_tree',35.00,90.00,55,'etc','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,273,360,261,278,0,333,0,0,0,55,0,'q421_tree_clan',100,0,0,'LAST_HIT'),
	(27186,27186,'Fairy Tree of Star',0,'Quest Monster',0,'NPC.human_tree',35.00,90.00,55,'etc','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,554,389,360,261,278,0,333,0,0,0,55,0,'q421_tree_clan',100,0,0,'LAST_HIT'),
	(27187,27187,'Fairy Tree of Twilight',0,'Quest Monster',0,'NPC.human_tree',35.00,90.00,55,'etc','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,737,292,360,261,278,0,333,0,0,0,55,0,'q421_tree_clan',100,0,0,'LAST_HIT'),
	(27188,27188,'Fairy Tree of Abyss',0,'Quest Monster',0,'NPC.human_tree',35.00,90.00,55,'etc','L2Npc',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,0,'q421_tree_clan',100,0,0,'LAST_HIT'),
	(27189,27189,'Soul of Tree Guardian',0,'Quest Monster',0,'Monster.elf_ghost',7.00,21.00,50,'male','L2Monster',40,2245,830,4.35,2.14,40,43,30,21,20,10,0,0,509,236,264,226,278,500,333,0,0,0,88,154,'q421_tree_clan',100,1,0,'LAST_HIT'),
	(27190,27190,'Ol Mahum Support Troop',0,'Quest Monster',0,'Monster.ol_mahum_champion',14.00,27.00,26,'male','L2Monster',40,770,303,5.53,1.53,40,43,30,21,20,10,0,0,96,120,41,98,278,500,333,69,0,0,55,165,'orc_clan',200,0,0,'LAST_HIT'),
	(27191,27191,'Malcom',0,'Quest Monster',0,'Monster.grizzly',21.00,40.00,25,'male','L2Monster',40,728,287,5.53,1.53,40,43,30,21,20,10,0,0,103,116,37,94,237,500,333,0,0,0,44,174,NULL,0,0,0,'LAST_HIT'),
	(27192,27192,'Succubus Handmaiden',0,'Quest Monster',0,'Monster.succubus',10.00,36.00,18,'female','L2Monster',40,476,193,3.95,1.21,40,43,30,21,20,10,0,0,48,87,19,70,278,500,333,0,0,0,66,147,NULL,0,0,0,'LAST_HIT'),
	(27193,27193,'Goblin Servant',0,'Quest Monster',0,'Monster.goblin',10.00,16.50,12,'male','L2Monster',40,315,138,3.95,1.21,40,43,30,21,20,10,0,0,27,56,10,54,278,500,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(27194,27194,'Julie the Ripper',0,'Quest Monster',0,'Monster.doll_blader',6.00,12.00,40,'male','L2Monster',40,1527,531,14.22,1.84,40,43,30,21,20,10,0,0,289,141,131,164,317,500,333,5129,5129,0,24,191,NULL,0,0,0,'LAST_HIT'),
	(27195,27195,'Male Ant',0,'Quest Monster',0,'Monster.noble_ant',20.00,48.00,32,'male','L2Monster',40,1056,397,7.11,1.84,40,43,30,21,20,10,0,0,154,151,69,123,278,0,333,0,0,0,88,165,NULL,0,0,0,'LAST_HIT'),
	(27196,27196,'Bluebacked Alligator',0,'Quest Monster',0,'Monster.crocodile',28.00,11.50,40,'male','L2Monster',40,1527,531,14.22,1.84,40,43,30,21,20,10,0,0,248,222,131,164,278,500,333,0,0,0,77,121,'croc_clan',200,0,0,'LAST_HIT'),
	(27197,27197,'Bejewelled Alligator',0,'Quest Monster',0,'Monster.crocodile',28.00,11.50,40,'male','L2Monster',40,1527,531,21.33,1.84,40,43,30,21,20,10,0,0,248,222,131,164,278,500,333,0,0,0,77,121,'croc_clan',200,0,0,'LAST_HIT'),
	(27199,27199,'Crimson Werewolf',0,'Quest Monster',0,'Monster.werewolf',10.00,26.00,36,'male','L2Monster',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,0,333,0,0,0,55,132,'werewolf_clan',300,0,0,'LAST_HIT'),
	(27200,27200,'Krudel Lizardman',0,'Quest Monster',0,'Monster.virud_lizardman',10.00,23.00,36,'male','L2Monster',80,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,237,0,333,291,0,0,47,143,'elemental1_clan',300,0,0,'LAST_HIT'),
	(27201,27201,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27202,27202,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27203,27203,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27204,27204,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27205,27205,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27206,27206,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27207,27207,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27208,27208,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27209,27209,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27210,27210,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27211,27211,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27212,27212,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27213,27213,'',0,'',0,'Monster.bugbear',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27214,27214,'Guardian of Forbidden Knowledge',0,'Quest Monster',0,'Monster2.apostle_warrior',8.00,30.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,80,0,0,55,198,'guard_of_secrets_clan',300,0,0,'LAST_HIT'),
	(27215,27215,'Guardian of Forbidden Knowledge',0,'Quest Monster',0,'Monster2.apostle_warrior',8.00,30.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,80,0,0,55,198,'guard_of_secrets_clan',300,0,0,'LAST_HIT'),
	(27216,27216,'Guardian of Forbidden Knowledge',0,'Quest Monster',0,'Monster2.apostle_warrior',8.00,30.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,80,0,0,55,198,'guard_of_secrets_clan',300,0,0,'LAST_HIT'),
	(27217,27217,'Soul of Well',0,'Quest Monster',0,'Monster.dark_horror',20.00,35.00,63,'male','L2Monster',40,3302,1251,11.85,2.78,40,43,30,21,20,10,0,0,987,338,560,323,278,150,333,0,0,0,110,198,NULL,0,1,0,'LAST_HIT'),
	(27218,27218,'Triol''s Pawn',0,'Quest Monster',0,'Monster.dre_vanul',14.00,36.00,65,'male','L2Monster',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,150,333,0,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(27219,27219,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27220,27220,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27221,27221,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27222,27222,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27223,27223,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27224,27224,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27225,27225,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27226,27226,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27227,27227,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27228,27228,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27229,27229,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27230,27230,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27231,27231,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27232,27232,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27233,27233,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27234,27234,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27235,27235,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27236,27236,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27237,27237,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27238,27238,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27239,27239,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27240,27240,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27241,27241,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27242,27242,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27243,27243,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27244,27244,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27245,27245,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27246,27246,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27247,27247,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27248,27248,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27249,27249,'Archon of Halisha',0,'Quest Monster',0,'Monster2.ahrimanes',14.00,57.75,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,150,333,6722,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27250,27250,'Fallen Angel Allector',0,'Quest Monster',0,'Monster.karik',25.00,90.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,0,0,0,40,198,NULL,0,0,0,'LAST_HIT'),
	(27251,27251,'Fallen Angel Allector',0,'Quest Monster',0,'Monster.karik',25.00,90.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,0,0,0,40,198,NULL,0,0,0,'LAST_HIT'),
	(27252,27252,'Fallen Angel Allector',0,'Quest Monster',0,'Monster.karik',25.00,90.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,0,0,0,40,198,NULL,0,0,0,'LAST_HIT'),
	(27253,27253,'Hell Fire',0,'Quest Monster',0,'Monster.will_o_wisp',13.00,22.00,76,'male','L2Monster',40,4297,1710,6.72,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,0,0,0,88,187,NULL,0,0,0,'LAST_HIT'),
	(27254,27254,'Unknown Stopper',0,'Quest Monster',0,'Monster.fiend_archer',17.00,55.00,81,'male','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,333,0,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27255,27255,'Unknown Stopper',0,'Quest Monster',0,'Monster.fiend_archer',17.00,55.00,81,'male','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,333,0,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27256,27256,'Unknown Stopper',0,'Quest Monster',0,'Monster.fiend_archer',17.00,55.00,81,'male','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,499,1182,477,249,150,333,0,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27257,27257,'Archangel Iconoclasis',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27258,27258,'Archangel Iconoclasis',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27259,27259,'Archangel Iconoclasis',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27260,27260,'Archangel Iconoclasis',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27261,27261,'Bead of Sacred Flame',0,'Quest Monster',0,'Monster.will_o_wisp',13.00,22.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,0,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(27262,27262,'Death Lord Hallate',0,'Quest Monster',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,78,0,0,44,198,NULL,0,1,0,'LAST_HIT'),
	(27263,27263,'Death Lord Hallate',0,'Quest Monster',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,78,0,0,44,198,NULL,0,1,0,'LAST_HIT'),
	(27264,27264,'Death Lord Hallate',0,'Quest Monster',0,'Monster.death_lord',21.00,40.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,78,0,0,44,198,NULL,0,1,0,'LAST_HIT'),
	(27265,27265,'Lich King Icarus',0,'Quest Monster',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,333,205,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27266,27266,'Fallen Angel Haures',0,'Quest Monster',0,'Monster.doll_master',20.00,42.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,0,0,0,88,198,NULL,0,1,0,'LAST_HIT'),
	(27267,27267,'Fallen Angel Haures',0,'Quest Monster',0,'Monster.doll_master',20.00,42.00,76,'male','L2Monster',40,4297,1710,26.86,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,0,0,0,88,198,NULL,0,1,0,'LAST_HIT'),
	(27268,27268,'Guard of Haures',0,'Quest Monster',0,'Monster.neer_crawler',14.00,22.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1412,454,994,433,317,0,333,0,0,0,55,198,NULL,0,1,0,'LAST_HIT'),
	(27269,27269,'Fallen Angel Naverius',0,'Quest Monster',0,'Monster.banshee',9.00,23.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,3939,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(27270,27270,'Fallen Angel Naverius',0,'Quest Monster',0,'Monster.banshee',9.00,23.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,3939,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(27271,27271,'Chimera Golem',0,'Quest Monster',0,'Monster2.lava_golem',22.00,45.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,0,0,0,14,198,NULL,0,0,0,'LAST_HIT'),
	(27272,27272,'Hallate''s Dancer Lillian',0,'Quest Monster',0,'Monster.banshee',9.00,23.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,3939,0,0,88,198,NULL,0,0,0,'LAST_HIT'),
	(27273,27273,'Assassin Pezel',0,'Quest Monster',0,'Monster.skeleton_royal_guard',11.00,28.50,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,333,242,0,0,88,198,NULL,0,1,0,'LAST_HIT'),
	(27274,27274,'Fallen Angel Tanakia',0,'Quest Monster',0,'Monster2.halisha_d',23.00,60.00,81,'female','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,333,286,0,0,47,198,NULL,0,0,0,'LAST_HIT'),
	(27275,27275,'Fallen Angel Tanakia',0,'Quest Monster',0,'Monster2.halisha_d',23.00,60.00,81,'female','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,333,286,0,0,47,198,NULL,0,0,0,'LAST_HIT'),
	(27276,27276,'Fallen Angel Tanakia',0,'Quest Monster',0,'Monster2.halisha_d',23.00,60.00,81,'female','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,333,286,0,0,47,198,NULL,0,0,0,'LAST_HIT'),
	(27277,27277,'Fallen Angel Tanakia',0,'Quest Monster',0,'Monster2.halisha_d',23.00,60.00,81,'female','L2Monster',500,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,4141,587,1182,477,249,150,333,286,0,0,47,198,NULL,0,0,0,'LAST_HIT'),
	(27278,27278,'Shadow of Beleth',0,'Quest Monster',0,'Monster.vale_master',12.00,40.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,205,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27279,27279,'Cursed Kesadein',0,'Quest Monster',0,'Monster.doll_master',20.00,42.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,333,0,0,0,88,198,NULL,0,1,0,'LAST_HIT'),
	(27280,27280,'Fallen Angel Narcissus',0,'Quest Monster',0,'Monster.karik',25.00,90.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,40,198,NULL,0,0,0,'LAST_HIT'),
	(27281,27281,'Fallen Angel Metellus',0,'Quest Monster',0,'Monster.karik',25.00,90.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,40,198,NULL,0,0,0,'LAST_HIT'),
	(27282,27282,'Reverse Angel Odiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27283,27283,'Grandpapa Askalius',0,'Quest Monster',0,'Monster.susceptor_prime',45.00,72.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,85,198,NULL,0,0,0,'LAST_HIT'),
	(27284,27284,'Flame Evil Spirit Azira',0,'Quest Monster',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,41,198,NULL,0,0,0,'LAST_HIT'),
	(27285,27285,'Lizard''s Totem Sharuhi',0,'Quest Monster',0,'Monster.serpent_slave',17.00,46.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,72,0,0,77,198,NULL,0,0,0,'LAST_HIT'),
	(27286,27286,'Fallen Knight Adhil',0,'Quest Monster',0,'NPC.a_guard_MHuman',8.00,24.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,79,107,0,55,198,NULL,0,1,0,'LAST_HIT'),
	(27287,27287,'Bound Elf Panacea',0,'Quest Monster',0,'NPC.a_guard_MElf',8.00,23.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,145,0,0,55,198,NULL,0,1,0,'LAST_HIT'),
	(27288,27288,'Sword Player Biel',0,'Quest Monster',0,'NPC.a_patriarch_MElf',8.00,22.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,74,74,0,55,198,NULL,0,1,0,'LAST_HIT'),
	(27289,27289,'Ancient Sword Master Iron',0,'Quest Monster',0,'Monster2.lilim_knight_10_bi',13.00,55.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,5800,5799,0,61,198,NULL,0,0,0,'LAST_HIT'),
	(27290,27290,'White Wing Commander ',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27291,27291,'White Wing Fighter',0,'Quest Monster',0,'Monster2.apostle_warrior',8.00,30.00,76,'female','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,80,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27292,27292,'Fallen Noble Orc Muhark',0,'Quest Monster',0,'Monster.ketra_orc_warrior',12.00,24.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,7834,0,0,39,198,NULL,0,0,0,'LAST_HIT'),
	(27293,27293,'Khavatari Uruz',0,'Quest Monster',0,'Monster.ketra_orc_warrior',12.00,24.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,0,0,0,39,198,NULL,0,0,0,'LAST_HIT'),
	(27294,27294,'Overlord Atrus',0,'Quest Monster',0,'Monster2.ketra_orc_chieftain',11.00,38.50,76,'male','L2Monster',40,4297,1710,53.72,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,6719,0,0,26,198,NULL,0,0,0,'LAST_HIT'),
	(27295,27295,'Sharuhi Mouth Mudaha',0,'Quest Monster',0,'Monster2.ketra_orc_chieftain',11.00,38.50,76,'male','L2Monster',40,4297,1710,53.72,3.09,40,43,30,21,20,10,0,0,2242,534,994,433,200,0,333,6719,0,0,26,198,NULL,0,0,0,'LAST_HIT'),
	(27296,27296,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27297,27297,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27298,27298,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27299,27299,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27300,27300,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27301,27301,'Monument Watcher Ezekiel',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,534,994,433,278,0,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27302,27302,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27303,27303,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27304,27304,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27305,27305,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27306,27306,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27307,27307,'Monument Defender Azrael',0,'Quest Monster',0,'Monster.archangel',15.00,80.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,97,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27308,27308,'Assassin Frost',0,'Quest Monster',0,'Monster2.vampire_soldier',8.00,23.50,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1630,587,1182,477,317,150,333,229,0,0,66,198,NULL,0,0,0,'LAST_HIT'),
	(27309,27309,'Minervia Van Hacken',0,'Quest Monster',0,'Monster2.vampire_witch',6.00,21.50,81,'female','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1630,499,1182,477,317,150,333,229,0,0,70,198,NULL,0,0,0,'LAST_HIT'),
	(27310,27310,'Kitanis Van Hacken',0,'Quest Monster',0,'Monster2.vampire_lord',7.50,25.80,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,16,198,NULL,0,0,0,'LAST_HIT'),
	(27311,27311,'Judgment Hound Dog Kelvas',0,'Quest Monster',0,'Monster2.eligor',21.00,35.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,587,1182,477,278,150,333,0,0,0,38,198,NULL,0,0,0,'LAST_HIT'),
	(27312,27312,'Mysterious Servitor',0,'Quest Monster',0,'Monster.shadeless',7.00,28.00,81,'male','L2Monster',40,41478,1896,120.87,3.09,40,43,30,21,20,10,0,0,1863,499,1182,477,278,150,333,0,0,0,52,198,NULL,0,0,0,'LAST_HIT'),
	(27313,27313,'Vision Guardian Shakiel',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27314,27314,'Vision Guardian Shakiel',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27315,27315,'Vision Guardian Shakiel',0,'Quest Monster',0,'Monster2.apostle_mage',11.00,38.50,76,'male','L2Monster',40,4297,1710,13.43,3.09,40,43,30,21,20,10,0,0,1614,454,994,433,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27316,27316,'Fallen Chieftain Vegus',0,'Quest Monster',0,'Monster.ketra_orc_warrior',12.00,24.00,55,'male','L2Monster',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,273,360,261,278,0,333,161,0,0,39,198,NULL,0,0,0,'LAST_HIT'),
	(27317,27317,'Restrainer of Glory',0,'Quest Monster',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,399,780,382,278,0,333,161,0,0,55,198,NULL,0,0,0,'LAST_HIT'),
	(27318,27318,'Wendy''s Guardian',0,'Quest Monster',0,'Monster3.golem_guardian_090p',20.00,23.00,46,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27319,27319,'Black Leopard',0,'Quest Monster',0,'Monster.onyx_beast',20.00,23.00,18,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27320,27320,'Timora Orc',0,'Quest Monster',0,'Monster.batur_orc',20.00,23.00,20,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27321,27321,'Bruin Lizardman',0,'Quest Monster',0,'Monster.virud_lizardman',20.00,23.00,20,'male','L2Monster',80,541,213,13.43,3.09,40,43,30,21,20,10,0,0,52,100,82,72,300,0,333,291,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(27322,27322,'Picot Araneid',0,'Quest Monster',0,'Monster.giant_spider_50_bi',20.00,23.00,27,'male','L2Monster',80,813,245,13.43,3.09,40,43,30,21,20,10,0,0,64,114,94,82,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(29001,29001,'Queen Ant',0,'',0,'Monster.queen_ant',45.00,53.00,40,'female','L2Boss',40,229898,667,495.04,2.14,60,57,73,76,70,80,2179535,140740,329,1615,77,655,278,0,3819,0,0,0,129,372,'queen_ant_clan',1000,0,0,'LAST_HIT'),
	(29002,29002,'Queen Ant Larva',0,'',0,'Monster.ant_larva',12.00,8.00,38,'male','L2Monster',40,935,349,5.53,1.53,40,43,30,21,20,10,0,1,126,140,53,110,282,0,333,0,0,0,44,66,'queen_ant_clan',4500,0,0,'LAST_HIT'),
	(29003,29003,'Nurse Ant',0,'',0,'Monster.ant',26.00,15.00,35,'male','L2Monster',40,6320,446,170.64,1.84,40,43,30,41,20,10,0,1,947,678,889,275,278,0,333,0,0,0,44,143,'queen_ant_clan',700,0,0,'LAST_HIT'),
	(29004,29004,'Guard Ant',0,'',0,'Monster.ant',26.00,15.00,37,'male','L2Monster',40,6861,480,181.70,1.84,40,43,30,41,20,10,0,1,269,728,62,295,278,500,333,0,0,0,44,253,'queen_ant_clan',700,0,0,'LAST_HIT'),
	(29005,29005,'Royal Guard Ant',0,'',0,'Monster.ant',26.00,15.00,39,'male','L2Monster',40,11140,514,192.76,1.84,40,43,30,41,20,10,0,1,1827,780,2576,316,278,0,333,0,0,0,44,253,'queen_ant_clan',700,0,0,'LAST_HIT'),
	(29006,29006,'Core',0,'',0,'NPC.core',140.00,75.00,50,'male','L2Boss',40,162561,575,649.74,1.53,60,57,73,76,70,80,2041407,153786,535,2226,500,904,278,0,3819,0,0,0,0,0,'curma_core_clan',2500,0,0,'LAST_HIT'),
	(29007,29007,'Death Knight',0,'',0,'Monster.death_knight',12.00,31.00,50,'male','L2Monster',40,21830,830,262.28,2.14,40,43,30,41,20,10,0,1,683,1113,195,452,278,1050,333,75,0,0,29,121,'curma_core_clan',2300,1,0,'LAST_HIT'),
	(29008,29008,'Death Wraith',0,'',0,'Monster.death_blader',15.00,45.00,55,'male','L2Monster',40,25298,987,292.30,2.45,40,43,30,41,20,10,0,1,812,1288,2170,522,278,950,333,1472,0,0,110,253,'curma_core_clan',700,1,0,'LAST_HIT'),
	(29009,29009,'Dicor',0,'',0,'Monster.mandragora_b',12.00,25.50,47,'female','L2Monster',40,19819,738,243.32,2.14,40,43,30,41,20,10,0,1,577,1015,162,412,278,650,333,0,0,0,88,132,'curma_core_clan',800,0,0,'LAST_HIT'),
	(29010,29010,'Validus',0,'',0,'Monster.grave',15.00,29.00,46,'male','L2Monster',40,19165,707,237.00,2.14,40,43,30,41,20,10,0,1,545,984,154,400,278,750,333,0,0,0,77,121,'curma_core_clan',1200,0,0,'LAST_HIT'),
	(29011,29011,'Susceptor',0,'',0,'Monster.susceptor',20.00,35.00,49,'male','L2Monster',40,21154,799,255.96,2.14,40,43,30,41,20,10,0,1,647,1080,184,438,278,850,333,0,0,0,29,165,'curma_core_clan',1500,0,0,'LAST_HIT'),
	(29012,29012,'Perum',0,'',0,'Monster.iron_golem',18.00,34.00,48,'male','L2Monster',40,20483,768,249.64,2.14,40,43,30,41,20,10,0,1,611,1048,173,425,278,750,333,0,0,0,22,22,'curma_core_clan',800,0,0,'LAST_HIT'),
	(29013,29013,'Premo',0,'',0,'Monster.troll',21.00,35.00,45,'male','L2Monster',40,18519,677,230.68,2.14,40,43,30,41,20,10,0,1,514,952,144,386,278,0,333,0,0,0,60,121,'curma_core_clan',1200,0,0,'LAST_HIT'),
	(29014,29014,'Orfen',0,'',0,'Monster.orfen',35.00,143.00,50,'female','L2Boss',40,325124,1660,649.74,2.14,60,57,73,76,70,80,2041407,153786,553,2226,124,904,278,500,3819,0,0,0,97,372,'orfen_clan',3000,0,0,'LAST_HIT'),
	(29015,29015,'Raikel',0,'',0,'Monster.raikel',37.00,64.00,48,'male','L2Monster',40,10241,768,249.64,2.14,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,333,0,0,0,66,253,'orfen_clan',2500,0,0,'LAST_HIT'),
	(29016,29016,'Raikel Leos',0,'',0,'Monster.raikel',37.00,64.00,49,'male','L2Monster',40,10576,799,255.96,2.14,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,333,0,0,0,66,253,'orfen_clan',2700,0,0,'LAST_HIT'),
	(29017,29017,'Riba',0,'',0,'Monster.riba',25.00,72.00,48,'female','L2Monster',40,10241,768,249.64,2.14,40,43,30,41,20,10,0,1,489,1048,109,425,278,0,333,0,0,0,66,253,'orfen_clan',2700,0,0,'LAST_HIT'),
	(29018,29018,'Riba Iren',0,'',0,'Monster.riba',25.00,72.00,49,'female','L2Monster',40,21154,799,255.96,2.14,40,43,30,41,20,10,0,1,1752,1080,4358,438,278,0,333,0,0,0,66,253,'orfen_clan',2900,0,0,'LAST_HIT'),
	(29019,29019,'Antharas',0,'',0,'Monster.antaras',300.00,300.00,79,'male','L2Boss',40,13090000,22197,2380.00,265.32,60,57,73,76,70,80,262720918,29116376,13308,8064,28099,1641,333,0,3819,0,0,0,81,301,NULL,0,0,13,'FULL_PARTY'),
	(29020,29020,'Baium',0,'',0,'Monster.baium',65.00,174.00,75,'male','L2Boss',40,790857,3347,668.78,3.09,60,57,73,76,70,80,10253400,1081544,6559,6282,4378,4601,333,0,3819,0,0,0,129,194,NULL,0,0,12,'FULL_PARTY'),
	(29021,29021,'Archangel',0,'',0,'Monster.archangel',15.00,80.00,74,'male','L2Monster',40,444857,3274,376.04,3.09,60,57,73,76,70,80,6571,343,1564,8326,5772,6100,333,0,3819,93,0,0,81,275,NULL,0,0,0,'LAST_HIT'),
	(29022,29022,'Zaken',0,'',0,'Monster.zaken',16.00,32.00,60,'male','L2Boss',40,858518,1975,799.68,2.45,60,57,73,76,70,80,4879745,423589,7273,2951,19762,1197,333,0,3819,0,0,0,68,275,NULL,0,1,12,'FULL_PARTY'),
	(29023,29023,'Doll Blader',0,'',0,'Monster.doll_blader',6.00,12.00,58,'male','L2Monster',40,2888,1065,10.27,2.45,40,43,30,21,20,25,0,0,779,383,428,359,278,150,333,5129,0,0,24,165,NULL,0,0,0,'LAST_HIT'),
	(29024,29024,'Vale master',0,'',0,'Monster.vale_master',12.00,40.00,59,'male','L2Monster',40,2970,1102,10.27,2.45,40,43,30,21,20,25,0,0,818,395,452,369,278,150,333,0,0,0,77,170,NULL,0,0,0,'LAST_HIT'),
	(29025,29025,'Baium',0,'',0,'NPC.baium_npc',65.00,82.00,75,'male','L2Npc',40,6370,3347,20.23,3.09,60,57,73,76,70,80,0,0,3483,523,9402,850,409,0,3819,0,0,0,81,194,NULL,0,0,0,'LAST_HIT'),
	(29026,29026,'Pirate Zombie Captain',0,'',0,'Monster.pirates_zombie_captain',17.00,28.00,60,'male','L2Monster',40,3054,1029,10.27,2.45,40,43,30,21,20,25,0,0,750,405,477,379,317,150,333,232,0,0,15,154,NULL,0,1,5,'LAST_HIT'),
	(29027,29027,'Pirate Zombie',0,'',0,'Monster.pirates_zombie',10.00,23.00,57,'male','L2Monster',40,2806,747,10.27,2.14,40,43,30,21,20,25,0,0,649,373,404,349,317,150,333,225,0,0,12,154,NULL,0,1,0,'LAST_HIT'),
	(29028,29028,'Valakas',0,'',0,'Monster2.valakas',190.00,335.00,85,'male','L2Boss',40,16660000,22197,2856.00,265.32,60,57,73,76,70,80,284286178,27215401,14375,7999,36620,1999,333,0,3819,0,0,0,194,486,'valakas_clan',300,0,13,'FULL_PARTY'),
	(29029,29029,'Lavasaurus Elder',0,'Family of Valakas',0,'Monster2.magmagoil_lad',15.00,75.00,83,'male','L2Monster',500,4868,1972,79.00,4.16,40,43,30,21,20,10,0,0,4354,628,1258,510,249,500,333,0,0,0,1,1,'valakas_clan',300,0,0,'LAST_HIT'),
	(29030,29030,'Fenril Hound Kerinne',0,'Family of Valakas',0,'Monster2.bandersnatch_20_bi',21.00,30.00,81,'male','L2Monster',40,256613,3793,418.88,11.10,60,57,73,76,70,80,2407887,1226568,10699,4700,10558,1908,409,0,3819,0,0,0,48,324,'fire_clan',300,0,0,'LAST_HIT'),
	(29031,29031,'Kerinne''s Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,80,'male','L2Monster',40,33984,1859,55.62,4.16,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29032,29032,'Kerinne''s Golem',0,'',0,'Monster2.lava_golem',22.00,45.00,80,'male','L2Monster',40,4697,1859,79.00,4.16,40,43,30,21,20,10,0,0,10275,2307,6886,937,278,0,333,0,0,0,14,66,'fire_clan',300,0,0,'LAST_HIT'),
	(29033,29033,'Fenril Hound Freki',0,'Family of Valakas',0,'Monster2.bandersnatch_20_bi',21.00,30.00,82,'male','L2Monster',40,257118,3869,417.69,11.10,60,57,73,76,70,80,2434088,1257012,10997,4784,10896,1943,409,0,3819,0,0,0,48,324,'fire_clan',300,0,0,'LAST_HIT'),
	(29034,29034,'Freki''s Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29035,29035,'Freki''s Golem',0,'',0,'Monster2.lava_golem',22.00,45.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,333,0,0,0,14,66,'fire_clan',300,0,0,'LAST_HIT'),
	(29036,29036,'Fenril Hound Uruz',0,'Family of Valakas',0,'Monster2.bandersnatch_20_bi',21.00,30.00,83,'male','L2Monster',40,514943,3945,830.62,11.10,60,57,73,76,70,80,2466262,1289662,22594,4869,11233,1977,409,0,3819,0,0,0,48,324,'fire_clan',300,0,0,'LAST_HIT'),
	(29037,29037,'Fenril Hound Kinaz',0,'Family of Valakas',0,'Monster2.bandersnatch_20_bi',21.00,30.00,84,'male','L2Monster',40,257674,4022,414.12,11.10,60,57,73,76,70,80,2504880,1322688,11600,4952,11569,2011,409,0,3819,0,0,0,48,324,'fire_clan',300,0,0,'LAST_HIT'),
	(29038,29038,'Kinaz''s Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29039,29039,'Kinaz''s Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29040,29040,'Wings of Flame, Ixion',0,'Gatekeeper of Valakas',0,'Monster2.inferno_drake_20_bi',29.00,42.00,85,'male','L2Monster',40,515450,4099,823.48,11.10,60,57,73,76,70,80,2535975,1356048,23813,5036,11902,2045,409,0,3819,0,0,0,92,324,'fire_clan',300,0,0,'LAST_HIT'),
	(29041,29041,'Inferno Golem',0,'',0,'Monster2.lava_golem',22.00,45.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,21134,2350,28532,954,278,0,333,0,0,0,14,66,'fire_clan',300,0,0,'LAST_HIT'),
	(29042,29042,'Inferno Golem',0,'',0,'Monster2.lava_golem',22.00,45.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,333,0,0,0,14,66,'fire_clan',300,0,0,'LAST_HIT'),
	(29043,29043,'Howling Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,10567,2350,7133,954,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29044,29044,'Howling Ifrit',0,'',0,'Monster2.ifrit',10.00,42.00,81,'male','L2Monster',40,34071,1896,56.88,4.16,40,43,30,21,20,10,0,0,14054,2350,12682,954,278,0,333,0,0,0,41,187,'fire_clan',300,0,0,'LAST_HIT'),
	(29045,29045,'Frintezza',0,'',0,'Monster3.frintessa',10.00,42.00,90,'male','L2Boss',40,790857,1859,13.43,3.09,40,43,30,21,20,10,1470000,13232,9182,6214,962,4191,300,0,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(29046,29046,'Scarlet van Halisha',0,'',0,'Monster3.follower_of_frintessa',5.00,90.00,85,'male','L2Boss',40,63,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,8204,0,0,55,88,NULL,0,0,13,'FULL_PARTY'),
	(29047,29047,'Scarlet van Halisha',0,'',0,'Monster3.follower_of_frintessa_tran',10.00,110.00,90,'male','L2Boss',40,350000,85,13.43,3.09,40,43,30,21,20,10,148,4,13,49,4,38,253,0,333,8222,0,0,44,121,'goblin_clan',300,0,13,'FULL_PARTY'),
	(29048,29048,'Evil Spirit',0,'',0,'Monster3.Evilate',10.00,20.00,87,'male','L2Monster',40,350000,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29049,29049,'Evil Spirit',0,'',0,'Monster3.Evilate',10.00,20.00,87,'male','L2Monster',40,350000,9999,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(29050,29050,'Breath of Halisha',0,'',0,'Monster3.portrait_spirit',10.00,20.00,85,'male','L2Monster',40,350000,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29051,29051,'Breath of Halisha',0,'',0,'Monster3.portrait_spirit_winged',10.00,20.00,85,'male','L2Monster',40,350000,9999,13.43,3.09,40,43,30,21,20,10,30,2,4,40,40000,9000,999,6000,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29052,29052,' ',0,'',0,'Monster3.Organ_Dummy',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29053,29053,' ',0,'',0,'Monster3.Follower_Dummy',20.00,31.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29054,29054,'Benom',0,'Triol''s Leader',0,'Monster3.benom',10.00,57.50,75,'male','L2RaidBoss',40,1352750,1494,13.43,3.09,40,43,30,21,20,10,5879,590,1444,514,760,381,253,0,333,8203,8203,0,80,120,NULL,0,0,0,'LAST_HIT'),
	(29055,29055,'Teleportation Cubic',0,'',0,'NPC.teleport_npc',20.00,80.00,93,'male','L2Teleporter',40,350000,9999,13.43,3.09,40,43,30,21,20,10,30,2,4,40,40000,9000,999,6000,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(29056,29056,'Ice Fairy Sirra',0,'Raid Boss',0,'Monster3.ice_fairy',10.00,40.00,60,'female','L2RaidBoss',40,350000,9999,13.43,3.09,40,43,30,21,20,10,177,5,15,52,5,41,253,0,333,0,0,0,66,88,'demonic_clan',300,0,0,'LAST_HIT'),
	(29057,29057,'Sirra''s Page',0,'Raid Fighter',0,'Monster.sylph_110p',10.00,20.00,59,'male','L2Minion',40,350000,4000,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29058,29058,'Sirra''s Beholder',0,'Raid Fighter',0,'Monster.field_stalker_20_bi',10.00,20.00,59,'male','L2Minion',40,350000,4000,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29059,29059,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29060,29060,'Captain of the Ice Queen''s Royal Guard',0,'Raid Boss',0,'Monster.gargoyle_02te_120p',10.00,56.00,59,'male','L2RaidBoss',40,350000,9999,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(29061,29061,'Teleportation Cubic',0,'',0,'NPC.teleport_npc_frin',20.00,23.00,70,'male','L2Teleporter',40,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29062,29062,'High Priestess van Halter',0,'Raid Boss',0,'Monster3.heretic_priest_110p',20.00,23.00,87,'male','L2RaidBoss',40,400000,9999,13.43,3.09,40,43,30,21,20,10,440000,40000,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29063,29063,'Andreas'' Acolyte',0,'Raid Fighter',0,'Monster3.heretic_privates',20.00,23.00,86,'male','L2Minion',40,400000,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29064,29064,'Andreas'' Acolyte',0,'Raid Fighter',0,'Monster3.heretic_privates_a',20.00,23.00,86,'male','L2Minion',40,400000,4000,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,500,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29065,29065,'Sailren',0,'Sealed Evil Power',0,'Monster3.sailren',100.00,83.10,87,'male','L2RaidBoss',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,12,'LAST_HIT'),
	(29066,29066,'Antharas',0,'',0,'Monster.antaras',300.00,300.00,79,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29067,29067,'Antharas',0,'',0,'Monster.antaras',300.00,300.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29068,29068,'Antharas',0,'',0,'Monster.antaras',300.00,300.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29069,29069,'Behemoth Dragon',0,'',0,'Monster3.antaras_ex_a',63.00,54.00,78,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29070,29070,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29071,29071,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29072,29072,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29073,29073,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29074,29074,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29075,29075,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b_80p',37.00,28.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29076,29076,'Dragon Bomber',0,'',0,'Monster3.antaras_ex_b',42.00,34.50,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29077,29077,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29078,29078,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29079,29079,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29080,29080,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29081,29081,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29082,29082,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29083,29083,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29084,29084,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29085,29085,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29086,29086,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29087,29087,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29088,29088,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29089,29089,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29090,29090,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29091,29091,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29092,29092,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29093,29093,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29094,29094,'',0,'',0,'NPC.clear_npc',0.10,0.10,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29095,29095,'Gordon',0,'Knight of Destruction',0,'Monster3.Cruel_Rider',43.00,46.60,87,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29096,29096,'Lord of Splendor Anays',0,'Raid Boss',0,'Monster3.solina_priest_120p',16.00,41.80,87,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29097,29097,'Splendor Disciple',0,'Raid Fighter',0,'Monster3.apostle_grail',13.00,47.00,99,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(29098,29098,'Splendor Worshiper',0,'Raid Fighter',0,'Monster3.apostle_grail_a',13.00,47.00,86,'male','L2Monster',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(30001,30001,'Lector',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30002,30002,'Jackson',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30003,30003,'Silvia',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30004,30004,'Katerina',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30005,30005,'Wilford',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30006,30006,'Roxxy',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30008,30008,'Roien',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30009,30009,'Newbie Helper',0,'',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30010,30010,'Auron',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30014,30014,'Celma',0,'Master',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30017,30017,'Gallint',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30019,30019,'Newbie Helper',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30022,30022,'Zigaunt',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30026,30026,'Bitz',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30027,30027,'Gwinter',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30028,30028,'Pintage',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30029,30029,'Minia',0,'Master',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30030,30030,'Vivyan',0,'Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30031,30031,'Biotin',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30032,30032,'Yohanes',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30033,30033,'Baulro',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30034,30034,'Iris',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30035,30035,'Harrys',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30036,30036,'Petron',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30037,30037,'Levian',0,'High Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30039,30039,'Gilbert',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30040,30040,'Leon',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30041,30041,'Arnold',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30042,30042,'Abellos',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30043,30043,'Johnstone',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30044,30044,'Chiperan',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30045,30045,'Kenyos',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30046,30046,'Hanks',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30047,30047,'Firon',0,'Wharf Manager ',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30048,30048,'Darin',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30049,30049,'Bonnie',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30050,30050,'Elias',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30051,30051,'Cristel',0,'',0,'NPC.a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30054,30054,'Rant',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30055,30055,'Rolfe',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30057,30057,'Aldo',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30058,30058,'Holvas',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30059,30059,'Trisha',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30060,30060,'Sabrin',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30061,30061,'Casey',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30062,30062,'Sonia',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30063,30063,'Lara',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30064,30064,'Terry',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30065,30065,'Arnelle',0,'Master',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30066,30066,'Pabris',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30067,30067,'Glyvka',0,'Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30068,30068,'Shegfield',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30069,30069,'Rollant',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30070,30070,'Sylvain',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30071,30071,'Lucas',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30072,30072,'Metty',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30073,30073,'Jacob',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30074,30074,'Harlan',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30075,30075,'Xaber',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30076,30076,'Liam',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30078,30078,'Pano',0,'Grocer',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30079,30079,'Barder',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30080,30080,'Clarissa',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30081,30081,'Helvetia',0,'Grocer',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30082,30082,'Denkus',0,'Grocer',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30083,30083,'Pochi',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30084,30084,'Graham',0,'Weapons Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30085,30085,'Stanford',0,'Weapons Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30086,30086,'Taurin',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30087,30087,'Peta',0,'Armor Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30088,30088,'Radia',0,'Armor Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30090,30090,'Sandra',0,'Jeweler ',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30091,30091,'Ellie',0,'Jeweler ',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30092,30092,'Collob',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30093,30093,'Groot',0,'Magic Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30094,30094,'Gentler',0,'Magic Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30095,30095,'Randolf',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30097,30097,'Galladucci',0,'Trader',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30098,30098,'Alexandria',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30103,30103,'Valkon',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30104,30104,'Parman',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30105,30105,'Genwitter',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30106,30106,'Dufner',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30107,30107,'Goldian',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30108,30108,'Macken',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30109,30109,'Hannavalt',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30110,30110,'Iker',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30111,30111,'Dieter',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30112,30112,'Maurius',0,'Magister',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30113,30113,'Juris',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30114,30114,'Roa',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30115,30115,'Jurek',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30116,30116,'Dustin',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30117,30117,'Primos',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30118,30118,'Pupina',0,'Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30119,30119,'Isabellin',0,'Priestess',0,'NPC.a_mageguild_teacher_FElf',7.00,22.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30120,30120,'Maximilian',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30121,30121,'Jeronin',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30122,30122,'Bane',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30123,30123,'Vesa',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30124,30124,'Zerome',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30125,30125,'Belton',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30126,30126,'Rath',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30128,30128,'Atanas',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30129,30129,'Mitraell',0,'Hierarch ',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30130,30130,'Undrias',0,'Abyssal Celebrant',0,'NPC.a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30131,30131,'Newbie Helper',0,'',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30132,30132,'Cecktinon',0,'Abyssal Celebrant',0,'NPC.a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30133,30133,'Kartia',0,'Abyssal Celebrant',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30134,30134,'Jasmine',0,'Gatekeeper',0,'NPC.a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30135,30135,'Iria',0,'Trader',0,'NPC.a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30136,30136,'Payne',0,'Trader',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30137,30137,'Vollodos',0,'Trader',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30138,30138,'Minaless',0,'Trader',0,'NPC.a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30139,30139,'Dorankus',0,'Warehouse Keeper',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30140,30140,'Erviante',0,'Warehouse Keeper',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30141,30141,'Talloth',0,'Tetrarch ',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30143,30143,'Trudy',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30144,30144,'Harne',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30145,30145,'Vlasty',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30146,30146,'Mirabel',0,'Gatekeeper',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30147,30147,'Unoren',0,'Trader',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30148,30148,'Ariel',0,'Trader',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30149,30149,'Creamees',0,'Trader',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30150,30150,'Herbiel',0,'Trader',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30151,30151,'Chad',0,'Warehouse Freightman',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30152,30152,'Julia',0,'Warehouse Keeper',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30153,30153,'Markius',0,'Warehouse Keeper',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30154,30154,'Asterios',0,'Hierarch ',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30155,30155,'Ellenia',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30156,30156,'Cobendell',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30157,30157,'Greenis',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30158,30158,'Esrandell',0,'Magister',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30162,30162,'Karin',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30163,30163,'Rex',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30164,30164,'Ian',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30165,30165,'Ralford',0,'Trader',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30166,30166,'Wesley',0,'Magic Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30169,30169,'Marty',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30170,30170,'Radic',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30171,30171,'Galios',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30174,30174,'Arkenias',0,'Grand Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30175,30175,'Fairen',0,'Grand Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30176,30176,'Valleria',0,'Grand Magister',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30177,30177,'Valentina',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30178,30178,'Zenkin',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30179,30179,'Raudia',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30180,30180,'Sara',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30181,30181,'Galibredo',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30182,30182,'Cliff',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30183,30183,'Hagger',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30184,30184,'Rigol',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30185,30185,'Taniac Blackbird',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30186,30186,'Bhan',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30187,30187,'Klaus Blackbird',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30188,30188,'Vadin',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30189,30189,'Rovia',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30190,30190,'Phanovia',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30191,30191,'Hollint',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30192,30192,'Darya',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30194,30194,'Gideon',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30195,30195,'Brecson',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30196,30196,'Mouen',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30197,30197,'Hector',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30198,30198,'Jerin',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30199,30199,'Yates',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30200,30200,'Stan',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30201,30201,'Pinaps',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30207,30207,'Arodin',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30208,30208,'Damion',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30209,30209,'Colleen',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30210,30210,'Norman',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30216,30216,'Wheeler',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30217,30217,'Berros',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,276,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30218,30218,'Kendell',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,276,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30219,30219,'Veltress',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30220,30220,'Starden',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,276,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30221,30221,'Rayen',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30222,30222,'Alshupes',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30223,30223,'Arujien',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30224,30224,'Rayla',0,'Sentry Knight ',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,79,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30230,30230,'Edroc',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30231,30231,'Garette',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30232,30232,'Sorint',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30233,30233,'Esmeralda',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30253,30253,'Simplon',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30254,30254,'Harmony',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30255,30255,'Haprock',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30256,30256,'Bella',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30283,30283,'Altran',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30284,30284,'Alberius',0,'Sentinel Knight',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,150,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30285,30285,'Gartrandell',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30288,30288,'Rains',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30289,30289,'Raymond',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30290,30290,'Xenos',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30291,30291,'Alex',0,'Captain',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,1000,333,68,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30293,30293,'Manuel',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30294,30294,'Varan',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30297,30297,'Tobias',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30298,30298,'Pinter',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30300,30300,'Pushkin',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30301,30301,'Hally',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30305,30305,'Vellior',0,'Tetrarch',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30307,30307,'Karrod',0,'Blacksmith',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30311,30311,'Sir Collin Windawood',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30312,30312,'Rockswell',0,'Lighthouse Keeper',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30313,30313,'Asha',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30314,30314,'Nestle',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30315,30315,'Poesia',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30316,30316,'Raut',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30317,30317,'Kluto',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30320,30320,'Richlin',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30321,30321,'Sydnia',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30322,30322,'Ballin',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30325,30325,'Audiberti',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30326,30326,'Leona',0,'Master',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30327,30327,'Sorius',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30328,30328,'Reisa',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30329,30329,'Virgil',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30330,30330,'Sidra',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30331,30331,'Thoma',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30332,30332,'Bathis',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30333,30333,'Praga',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30334,30334,'Babenco',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30335,30335,'Brynn',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30336,30336,'Curtis',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30337,30337,'Moretti',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30338,30338,'Melville',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30342,30342,'Varsak',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30344,30344,'Rohmer',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30345,30345,'Ramoniell',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30346,30346,'Kayleen',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,277,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30347,30347,'Marion',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,132,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30348,30348,'Nelsya',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,132,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30349,30349,'Jenna',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,277,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30350,30350,'Carlon',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30351,30351,'Astaron',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30352,30352,'Karina',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30353,30353,'Jughead',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30354,30354,'Jewel',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30355,30355,'Roselyn',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,277,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30356,30356,'Altima',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,277,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30357,30357,'Kristin',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,132,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30358,30358,'Thifiell',0,'Tetrarch',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30359,30359,'Kaitar',0,'Tetrarch',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30360,30360,'Harant',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30361,30361,'Rizraell',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30362,30362,'Andellia',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30363,30363,'Aios',0,'Blacksmith',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30368,30368,'Lilith',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30369,30369,'Baenedes',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30370,30370,'Nerupa',0,'',0,'Monster.aracne',15.00,26.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,70,132,NULL,0,0,0,'LAST_HIT'),
	(30371,30371,'Thalia',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30373,30373,'Ramos',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30374,30374,'Rhodiell',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30375,30375,'Adonius',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30376,30376,'Nell',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30377,30377,'Talbot',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30378,30378,'Estella',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30379,30379,'Bezique',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,280,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30380,30380,'Plink',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30381,30381,'Alvah',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30382,30382,'Leikan',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30383,30383,'Scott',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30384,30384,'Linus',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30385,30385,'Weisz',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30386,30386,'Luis',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30387,30387,'Clancy',0,'Wharf Manager ',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30391,30391,'Parina',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30400,30400,'Newbie Helper',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30401,30401,'Newbie Helper',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30402,30402,'Newbie Helper',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30403,30403,'Newbie Helper',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30404,30404,'Newbie Helper',0,'',0,'NPC.a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30405,30405,'Marius',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30406,30406,'Matheo',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30407,30407,'Mesella',0,'',0,'NPC.a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30408,30408,'Lionel',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30409,30409,'Earth Snake',0,'',0,'Monster.lesser_basilisk',34.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,38,110,NULL,0,0,0,'LAST_HIT'),
	(30410,30410,'Wasteland Lizardman',0,'',0,'Monster.virud_lizardman',10.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,47,121,NULL,0,0,0,'LAST_HIT'),
	(30411,30411,'Flame Salamander',0,'',0,'Monster.salamander',16.00,6.80,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,70,105,NULL,0,0,0,'LAST_HIT'),
	(30412,30412,'Wind Sylph',0,'',0,'Monster.sylph',11.00,35.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,66,66,NULL,0,0,0,'LAST_HIT'),
	(30413,30413,'Water Undine',0,'',0,'Monster.undine',12.00,27.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,66,66,NULL,0,0,0,'LAST_HIT'),
	(30414,30414,'Rosella',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30415,30415,'Charkeren',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30416,30416,'Triskel',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30417,30417,'Sir Klaus Vasper',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30418,30418,'Annika',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30419,30419,'Arkenia',0,'Witch',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30420,30420,'Tyra',0,'',0,'NPC.a_trader_Fdarkelf',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30421,30421,'Varika',0,'Witch',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30422,30422,'Kalinta',0,'Abyssal Celebrant ',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30423,30423,'Northwind',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30424,30424,'Allana',0,'',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30425,30425,'Neti',0,'',0,'NPC.a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30426,30426,'Prias',0,'',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30427,30427,'Siff',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30428,30428,'Perrin',0,'',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30429,30429,'Tiramisa',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30430,30430,'Trionell',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30431,30431,'Eriel',0,'Sentinel',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,130,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30432,30432,'Irene',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,132,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30433,30433,'Kathaway',0,'Sentry',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,132,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30434,30434,'Samed',0,'',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30435,30435,'Leopold',0,'',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30436,30436,'Sarien',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30437,30437,'Rolento',0,'Trader',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30452,30452,'Kurt',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30458,30458,'Poitan',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30459,30459,'Wandius',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30460,30460,'Cardien',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30461,30461,'Mirien',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30462,30462,'Tronix',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30463,30463,'Ixia',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30464,30464,'Clayton',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30465,30465,'Herven',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30466,30466,'Bright',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30469,30469,'Jonas',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30471,30471,'Rupio',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30472,30472,'Rosheria',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30473,30473,'Bandellos',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30474,30474,'Angus',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30475,30475,'Stapin',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30476,30476,'Kaira',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30477,30477,'Sir Ortho Lancer',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30478,30478,'Reikin',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30483,30483,'Mozella',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30484,30484,'Ponti',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30485,30485,'Capella',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30486,30486,'Hanna',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30487,30487,'Penelope',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30497,30497,'Edmond',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30498,30498,'Moke',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30499,30499,'Tapoy',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30500,30500,'Osborn',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30501,30501,'Kasman',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30502,30502,'Umos',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30503,30503,'Rikadio',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30504,30504,'Mendio',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30505,30505,'Drikus',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30506,30506,'Buka',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30507,30507,'Racoy',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30508,30508,'Castor',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30509,30509,'Dowki',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30510,30510,'Somak',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30511,30511,'Gesto',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30512,30512,'Kusto',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30513,30513,'Penatus',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30514,30514,'Vokian',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30515,30515,'Manakia',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30516,30516,'Reep',0,'Trader',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30517,30517,'Shari',0,'Trader',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30518,30518,'Garita',0,'Trader',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30519,30519,'Mion',0,'Trader',0,'NPC.e_traderB_FDwarf',7.00,18.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30520,30520,'Reed',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30521,30521,'Murdoc',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30522,30522,'Airy',0,'Warehouse Keeper',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30523,30523,'Gouph',0,'Collector',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30524,30524,'Pippi',0,'Collector',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30525,30525,'Bronk',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30526,30526,'Brunon',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30527,30527,'Silvera',0,'Blacksmith',0,'NPC.e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30528,30528,'Laferon',0,'Foreman',0,'NPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30529,30529,'Maron',0,'Miner',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30530,30530,'Newbie Helper',0,'',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30531,30531,'Lockirin',0,'Iron Gate''s',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30532,30532,'Spiron',0,'Golden Wheel''s',0,'NPC.e_traderA_master_MDwarf',8.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30533,30533,'Balanki',0,'Silver Scale''s',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30534,30534,'Keef',0,'Bronze Key''s',0,'NPC.e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30535,30535,'Filaur',0,'Gray Pillar Member',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30536,30536,'Arin',0,'Black Anvil''s',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30537,30537,'Daichir',0,'Priest of the Earth',0,'NPC.e_celebrant_MDwarf',8.00,19.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30538,30538,'Zimenf',0,'Priest of the Earth',0,'NPC.e_clergyman_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30539,30539,'Chichirin',0,'Priestess of the Earth',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30540,30540,'Wirphy',0,'Gatekeeper',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30541,30541,'Paion',0,'Protector',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,282,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30542,30542,'Runant',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,273,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30543,30543,'Ethan',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,296,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30544,30544,'Cromwell',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,296,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30545,30545,'Proton',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,296,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30546,30546,'Dinkey',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,273,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30547,30547,'Tardyon',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,273,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30548,30548,'Nathan',0,'Defender',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,296,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30549,30549,'Ghouliff Droopstone',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30550,30550,'Gauri Twinklerock',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30551,30551,'Tink Wandergold',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30552,30552,'Kiril Sparkystone',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30553,30553,'Maryse Redbonnet',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30554,30554,'Bolter',0,'Miner',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30555,30555,'Torocco',0,'Carrier',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30556,30556,'Toma',0,'Master',0,'NPC.e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30557,30557,'Torai',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30558,30558,'Jakal',0,'Trader',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30559,30559,'Kunai',0,'Trader',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30560,30560,'Uska',0,'Trader',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30561,30561,'Papuma',0,'Trader',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30562,30562,'Grookin',0,'Warehouse Keeper',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30563,30563,'Imantu',0,'Warehouse Freightman',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30564,30564,'Sumari',0,'Blacksmith',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30565,30565,'Kakai',0,'Flame Lord',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30566,30566,'Varkees',0,'Atuba Chief ',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,81,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30567,30567,'Tantus',0,'Neruga Chief ',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,175,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30568,30568,'Hatos',0,'Urutu Chief',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30569,30569,'Brukurse',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30570,30570,'Karukia',0,'Prefect',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30571,30571,'Tanapi',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30572,30572,'Livina',0,'Seer',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30573,30573,'Vulkus',0,'Flame Guardian ',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30575,30575,'Newbie Helper',0,'',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30576,30576,'Tamil',0,'Gatekeeper',0,'NPC.e_teleporter_FOrc',8.00,32.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30577,30577,'Rukain',0,'Praetorian',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,279,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30578,30578,'Nakusin',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30579,30579,'Tamai',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30580,30580,'Parugon',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,91,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30581,30581,'Orinak',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30582,30582,'Tiku',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,91,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30583,30583,'Petukai',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,91,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30584,30584,'Vapook',0,'Centurion',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,91,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30585,30585,'Tataru Zu Hestui',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30586,30586,'Anai Zu Neruga',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30587,30587,'Gantaki Zu Urutu',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30588,30588,'Takia Zu Duda-Mara',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30589,30589,'Kazkin Zu Gandi',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30590,30590,'Rosheek',0,'Khavatari ',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30591,30591,'Toruku',0,'Khavatari ',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30592,30592,'Hestui Totem Spirit',0,'',0,'Monster.grizzly',21.00,40.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,121,NULL,0,0,0,'LAST_HIT'),
	(30593,30593,'Duda-Mara Totem Spirit',0,'',0,'Monster.giant_spider',26.00,25.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,79,143,NULL,0,0,0,'LAST_HIT'),
	(30594,30594,'Ranspo',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30595,30595,'Opix',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30596,30596,'Harkel',0,'Partisan Doorman',0,'Monster.ol_mahum',13.50,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(30597,30597,'Piotur',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30598,30598,'Newbie Guide',0,'',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30599,30599,'Newbie Guide',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30600,30600,'Newbie Guide',0,'',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30601,30601,'Newbie Guide',0,'',0,'NPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30602,30602,'Newbie Guide',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30608,30608,'Maria',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30609,30609,'Creta',0,'Astrologer',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30610,30610,'Cronos',0,'Elder',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30611,30611,'Triff',0,'Drunkard',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30612,30612,'Casian',0,'Elder',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30613,30613,'Alders Spirit',0,'',0,'Monster.human_ghost',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(30614,30614,'Metheus',0,'Brother',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30615,30615,'Voltar',0,'Breka Chief',0,'Monster.batur_orc_overlord',12.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,173,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(30616,30616,'Kepra',0,'Enku Chief',0,'Monster.orc_champion',10.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,162,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(30617,30617,'Burai',0,'Turek Chief',0,'Monster.orc_shaman',9.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,172,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(30618,30618,'Harak',0,'Leunt Chief',0,'Monster.orc_fighter',12.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,172,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(30619,30619,'Driko',0,'Vuku Chief',0,'Monster.batur_orc_shaman',11.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,183,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(30620,30620,'Emily',0,'',0,'NPC.a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30621,30621,'Nikola',0,'Maestro',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30622,30622,'Box Of Titan',0,'',0,'NPC.coffer_b',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30623,30623,'Kaien',0,'Duelist',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,135,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30624,30624,'Ascalon',0,'Veteran',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,16,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30625,30625,'Mason',0,'',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30626,30626,'Hamil',0,'Sagittarius',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30627,30627,'Tree',0,'',0,'NPC.human_tree',35.00,90.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(30628,30628,'Strong Wooden Chest',0,'',0,'NPC.box',18.00,14.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30629,30629,'Rukal',0,'Bard',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,4202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30630,30630,'Orim',0,'Shadow',0,'NPC.a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30631,30631,'Roderik',0,'Warden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30632,30632,'Endrigo',0,'Warden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30633,30633,'Evert',0,'Fisher',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30634,30634,'Galatea',0,'High Summoner',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30635,30635,'Almors',0,'Summoner',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30636,30636,'Camoniell',0,'Summoner',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30637,30637,'Belthus',0,'Summoner',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30638,30638,'Basilla',0,'Summoner',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30639,30639,'Celestiel',0,'Summoner',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30640,30640,'Brynthea',0,'Summoner',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30641,30641,'Takuna',0,'Duda-Mara Chief',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30642,30642,'Chianta',0,'Gandi Chief',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,175,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30643,30643,'First Orc',0,'',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30644,30644,'Kash',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30645,30645,'Martien',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30646,30646,'Raldo',0,'Champion',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30647,30647,'Chest Of Shyslassys',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30648,30648,'Santiago',0,'Hermit',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30649,30649,'Ancestor Martankus',0,'',0,'NPC.orc_head',110.00,103.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30650,30650,'Gerald',0,'Priest of the Earth',0,'NPC.e_clergyman_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30651,30651,'Dorf',0,'Wanderer',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30652,30652,'Uruha',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30653,30653,'Sir Aron Tanford',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30654,30654,'Sir Kiel Nighthawk',0,'',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,74,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30655,30655,'Isael Silvershadow',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30656,30656,'Spirit Of Sir Talianus',0,'',0,'Monster.human_ghost',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(30657,30657,'Seresin',0,'Cardinal ',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30658,30658,'Gupu',0,'Father',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30659,30659,'Orphan Girl',0,'',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30660,30660,'Windy Shaoring',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30661,30661,'Mysterious Dark Elf',0,'',0,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30662,30662,'Piper Longbow',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30663,30663,'Slein Shining Blade',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,69,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30664,30664,'Kein Flying Knife',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,217,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30665,30665,'Kristina',0,'Saint',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30666,30666,'Sla',0,'Preacher',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30667,30667,'Ramus',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30668,30668,'Katari',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30669,30669,'Kakan',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30670,30670,'Nyakuri',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30671,30671,'Croto',0,'Chief',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30672,30672,'Dubabah',0,'Jailer',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30673,30673,'Lorain',0,'Researcher',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30674,30674,'Daurin Hammercrush',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30675,30675,'Corpse Of Kamur',0,'',0,'NPC.e_trader_Morc_death',22.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30676,30676,'Croop',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30677,30677,'Flutter',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30678,30678,'Helton',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30679,30679,'Roameria',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30680,30680,'Egnos',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30681,30681,'Karia',0,'High Prefect ',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30682,30682,'Pekiron',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30683,30683,'Daunt',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30684,30684,'Viktor',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30685,30685,'Baxt',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30686,30686,'Silva',0,'Warehouse Freightman',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30687,30687,'Vergara',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30688,30688,'Duning',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30689,30689,'Siria',0,'Grand Master',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30690,30690,'Luther',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30691,30691,'Aren Athebalt',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30692,30692,'Stedmiel',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30693,30693,'Queenien',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30694,30694,'Scraide',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30695,30695,'Moses',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30696,30696,'Page',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30697,30697,'Videlrien',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30698,30698,'Evelyn',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30699,30699,'Medown',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30700,30700,'Prestan',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30701,30701,'Errickin',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30702,30702,'Bernard',0,'Guild President',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30703,30703,'Colin',0,'Guild President',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30704,30704,'Garvarentz',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30705,30705,'Chakiris',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30706,30706,'Lazenby',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30707,30707,'Raigen',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30708,30708,'Nasign',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30709,30709,'Norton',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30710,30710,'Weston',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30711,30711,'Byron',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30712,30712,'Makhis',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30713,30713,'Gardner',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30714,30714,'Paros',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30715,30715,'Marina',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30716,30716,'Cecile',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30717,30717,'Gauen',0,'Magister',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30718,30718,'Joan',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30719,30719,'Mariell',0,'Gatekeeper',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30720,30720,'Kaiena',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30721,30721,'Ladd',0,'Magister',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30722,30722,'Merian',0,'Gatekeeper',0,'NPC.a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30723,30723,'Roy',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30724,30724,'Tavillian',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30725,30725,'Yening',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30726,30726,'Tebose',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30727,30727,'Verona',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30728,30728,'Leirynn',0,'Militiaman',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,93,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30729,30729,'Borys',0,'Drunkard',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30730,30730,'Jax',0,'Bodyguard',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,232,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30731,30731,'Martin',0,'Pet Manager',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30732,30732,'Ol Mahum Pilgrim',0,'',0,'Monster.ol_mahum',13.50,25.00,36,'male','L2Npc',40,1279,463,7.11,1.84,40,43,30,21,20,10,0,0,206,175,96,142,278,0,333,1,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(30733,30733,'Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30734,30734,'Supply Box On Wharf',0,'',0,'NPC.box',18.00,14.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30735,30735,'Sophya',0,'Mercenary Captain',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30736,30736,'Redfoot',0,'Mercenary',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30737,30737,'Morgan',0,'Guildsman',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30738,30738,'Matild',0,'Alchemist',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30739,30739,'Keltir',0,'Royal Servant ',0,'Monster.fox',9.50,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,25,121,NULL,0,0,0,'LAST_HIT'),
	(30740,30740,'Toad',0,'Royal Servant ',0,'Monster.poison_toad',20.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,110,NULL,0,0,0,'LAST_HIT'),
	(30741,30741,'Rabbit',0,'Royal Servant ',0,'Monster.rabbit',5.00,4.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,88,NULL,0,0,0,'LAST_HIT'),
	(30742,30742,'Rupina',0,'Fairy of Love',0,'Monster.pixy',5.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(30743,30743,'Wisdom Chest',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30744,30744,'Grey',0,'Guild Member',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30745,30745,'Tor',0,'Guild Member',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30746,30746,'Cybellin',0,'',0,'NPC.a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30747,30747,'Mimyu',0,'Fairy',0,'Monster.pixy',5.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(30748,30748,'Exarion',0,'Drake',0,'Monster.drake',30.00,100.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(30749,30749,'Zwov',0,'Drake',0,'Monster.drake',30.00,100.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(30750,30750,'Kalibran',0,'Drake',0,'Monster.drake',30.00,100.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(30751,30751,'Suzet',0,'Wyrm',0,'Monster.wyrm',29.00,72.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(30752,30752,'Shamhai',0,'Wyrm',0,'Monster.wyrm',29.00,72.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,77,77,NULL,0,0,0,'LAST_HIT'),
	(30753,30753,'Gabrielle',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30754,30754,'Gilmore',0,'Antharas Watchman',0,'Monster.skeleton_knight',10.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,150,0,0,44,176,NULL,0,1,0,'LAST_HIT'),
	(30755,30755,'Theodric',0,'Antharas Watchman',0,'Monster.skeleton_knight',10.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,127,0,0,44,176,NULL,0,1,0,'LAST_HIT'),
	(30756,30756,'Sir Kristof Rodemai',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30757,30757,'Statue Of Offering',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(30758,30758,'Athrea',0,'Witch',0,'NPC.a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30759,30759,'Kalis',0,'Witch',0,'NPC.a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30760,30760,'Sir Gustav Athebaldt',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,128,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30761,30761,'Corpse Of Fritz',0,'',0,'NPC.e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30762,30762,'Corpse Of Lutz',0,'',0,'NPC.e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30763,30763,'Corpse Of Kurtz',0,'',0,'NPC.e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30764,30764,'Balthazar',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30765,30765,'Imperial Coffer',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30766,30766,'Cleo',0,'Witch',0,'NPC.a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30767,30767,'Auctioneer',0,'',0,'NPC.a_maidB_FHuman',8.00,22.00,70,'female','L2Auctioneer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30768,30768,'Auctioneer',0,'',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Auctioneer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30769,30769,'Auctioneer',0,'',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Auctioneer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30770,30770,'Auctioneer',0,'',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Auctioneer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30771,30771,'Auctioneer',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Auctioneer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30772,30772,'Wilson',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30773,30773,'Todd',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30827,30827,'Lundy',0,'Pet Manager ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30828,30828,'Waters',0,'Pet Manager ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30829,30829,'Cooper',0,'Pet Manager ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30830,30830,'Joey',0,'Pet Manager ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30831,30831,'Nelson',0,'Pet Manager ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30832,30832,'Hardin',0,'',0,'NPC.a_hardin_MHuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30833,30833,'Kaspar',0,'Magister',0,'NPC.a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30834,30834,'Cema',0,'Magic Trader',0,'NPC.a_hardins_pupil_FHuman',8.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30835,30835,'Icarus',0,'Lich King',0,'NPC.a_hardins_pupil_MHuman',12.00,40.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,212,0,0,77,16,NULL,0,1,0,'LAST_HIT'),
	(30836,30836,'Minerva',0,'Gatekeeper',0,'NPC.a_teleporter_FDarkElf',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30837,30837,'Woodrow',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30838,30838,'Woodley',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30839,30839,'Holly',0,'Trader',0,'NPC.a_traderA_FHuman',7.00,23.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30840,30840,'Lorenzo',0,'Trader',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30841,30841,'Carson',0,'Trader',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30842,30842,'Alexis',0,'Trader',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30843,30843,'Romp',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30844,30844,'Walderal',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30845,30845,'Klump',0,'Warehouse Chief ',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30846,30846,'Wilbert',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30847,30847,'Ferris',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30848,30848,'Elisa',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30849,30849,'Sedrick',0,'Grand Master',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30850,30850,'Aiken',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30851,30851,'Kendra',0,'Master',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30852,30852,'Sinden',0,'Master',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30853,30853,'Raien',0,'Master',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30854,30854,'Drikiyan',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30855,30855,'Desmond',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30856,30856,'Winonin',0,'Magister',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30857,30857,'Orven',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30858,30858,'Ross',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30859,30859,'Vivyan',0,'Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30860,30860,'Flownia',0,'Priestess',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30861,30861,'Leonard',0,'Priest',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30862,30862,'Oltlin',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30863,30863,'Ghest',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30864,30864,'Hanellin',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30865,30865,'Ladanza',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30866,30866,'Marestella',0,'Prefect',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30867,30867,'Reva',0,'Seer',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30868,30868,'Sir Eric Rodemai',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,128,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30869,30869,'Lemper',0,'Pet Manager',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30870,30870,'Kurtiz',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30871,30871,'Bret',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30872,30872,'Conroy',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30873,30873,'Coleman',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30874,30874,'Aldis',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30875,30875,'Carlton',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30876,30876,'Eastan',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30877,30877,'Grayson',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30878,30878,'Angelina',0,'Gatekeeper',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30879,30879,'Felton',0,'Wharf Manager',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30880,30880,'Viktor Van Dake',0,'Border Outpost Captain',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30881,30881,'Sanders',0,'Border Outpost Aide',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30882,30882,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30883,30883,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,14,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30884,30884,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30885,30885,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,14,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30886,30886,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30887,30887,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,14,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30888,30888,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30889,30889,'Frontier Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,14,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30890,30890,'Espen',0,'Trader',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30891,30891,'Verona',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30892,30892,'Enverun',0,'Trader',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30893,30893,'Payel',0,'Trader',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30894,30894,'Natools',0,'Warehouse Chief ',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30895,30895,'Kluck',0,'Warehouse Freightman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30896,30896,'Mia',0,'Warehouse Keeper',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30897,30897,'Roman',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30898,30898,'Morning',0,'Blacksmith',0,'NPC.e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30899,30899,'Flauen',0,'Gatekeeper',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30900,30900,'Marcus',0,'Grand Master',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30901,30901,'Arti',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30902,30902,'Karuna',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30903,30903,'Traus',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30904,30904,'Naiel',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30905,30905,'Squillari',0,'High Priest',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30906,30906,'Ranton',0,'Priest',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30907,30907,'Minevia',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30908,30908,'Tanios',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30909,30909,'Anabel',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30910,30910,'Xairakin',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30911,30911,'Brikus',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30912,30912,'Xenovia',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30913,30913,'Tushku',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30914,30914,'Sorbo',0,'Prefect',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30915,30915,'Takina',0,'Seer',0,'NPC.e_mageguild_teacher_FOrc',8.00,28.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30916,30916,'Gosta',0,'Captain',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,129,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30917,30917,'Dupuis',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30918,30918,'Kent',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30919,30919,'Rodic',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30920,30920,'Kraisen',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30921,30921,'Timos',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30922,30922,'Cage',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,2,102,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30923,30923,'Dunst',0,'Guard',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(30924,30924,'Nedy',0,'Wharf Manager',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30925,30925,'Morelyn',0,'High Priestess',0,'NPC.a_mageguild_teacher_FElf',7.00,22.20,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30926,30926,'Restina',0,'Priestess',0,'NPC.a_mageguild_teacher_FElf',7.00,22.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30927,30927,'Alicia',0,'Priestess',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30928,30928,'Fenster',0,'Mercenary',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30929,30929,'Patrin',0,'Antique Dealer',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30930,30930,'Rogent',0,'Antique Appraiser',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30931,30931,'Bentley',0,'',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30932,30932,'Benica',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30933,30933,'Braki',0,'',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30934,30934,'Marsha',0,'Collector',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30935,30935,'Trumpin',0,'Collector',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30936,30936,'Malcom1',0,'Frog Prince',0,'Monster.poison_toad',20.00,10.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(30937,30937,'Malcom2',0,'Wild Boar Prince',0,'Monster.giant_wild_hog',35.00,27.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,38,132,NULL,0,0,0,'LAST_HIT'),
	(30938,30938,'Malcom3',0,'Orc Prince',0,'Monster.ketra_orc',12.00,29.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(30939,30939,'Malcom4',0,'Prince of Darkness',0,'Monster.skeleton_royal_guard',11.00,28.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(30940,30940,'Malcom5',0,'Gremlin Prince',0,'Monster.gremlin',10.00,15.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,22,132,NULL,0,0,0,'LAST_HIT'),
	(30941,30941,'Malcom6',0,'Prince of Wild Beast',0,'Monster.saber_toothed_tiger',34.00,28.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,66,132,NULL,0,0,0,'LAST_HIT'),
	(30942,30942,'Malcom7',0,'Monster Eye Prince',0,'Monster.monster_eye',21.00,43.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,99,132,NULL,0,0,0,'LAST_HIT'),
	(30943,30943,'Malcom8',0,'Rabbit Prince',0,'Monster.rabbit',5.00,4.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(30944,30944,'Malcom9',0,'Human Prince',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30945,30945,'Malcom10',0,'Prince',0,'NPC.e_collector_master_MDwarf',8.00,18.40,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30946,30946,'Lucianne Tanford',0,'',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30947,30947,'Rerikya',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30948,30948,'Meridien',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30949,30949,'Keplon',0,'Researcher',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30950,30950,'Euclie',0,'Researcher',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30951,30951,'Pithgon',0,'Researcher',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30952,30952,'Dimensional Vortex 1',0,'',0,'NPC.broadcasting_tower',7.00,35.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30953,30953,'Dimensional Vortex 2',0,'',0,'NPC.broadcasting_tower',7.00,35.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30954,30954,'Dimensional Vortex 3',0,'',0,'NPC.broadcasting_tower',7.00,35.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30955,30955,'Gillian''s Revenant',0,'',0,'Monster.zombie',13.00,21.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,16,132,NULL,0,1,0,'LAST_HIT'),
	(30956,30956,'Nanarin',0,'Musician',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,325,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30957,30957,'Swan',0,'Bard',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,4202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30958,30958,'Galion',0,'',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30959,30959,'Barbado',0,'Musician',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5133,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30960,30960,'Beer Chest',0,'',0,'NPC.box',18.00,14.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30961,30961,'Cloth Chest',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30962,30962,'Statue of Water',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30963,30963,'Statue of Fire',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30964,30964,'Statue of Wind',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30965,30965,'Statue of Earth',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30966,30966,'Statue of Darkness',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30967,30967,'Statue of Light',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30968,30968,'Jennifer',0,'Lady Orc',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30969,30969,'Iason Heine',0,'',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30970,30970,'Dorothy',0,'Locksmith ',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30971,30971,'Orpheus',0,'Mad Doctor ',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30972,30972,'Orpheus Resurrecter',0,'',0,'Monster.susceptor',20.00,35.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,29,132,NULL,0,0,0,'LAST_HIT'),
	(30973,30973,'Medium Jar',0,'',0,'NPC.pot',10.00,15.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30974,30974,'Oliver',0,'Resurrected Adventurer',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30975,30975,'Clarine',0,'Resurrected Adventurer',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30976,30976,'Resurrected Town Maiden',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30977,30977,'Holy Ark of Secrecy1',0,'',0,'NPC.coffer_a',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30978,30978,'Holy Ark of Secrecy2',0,'',0,'NPC.coffer_b',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30979,30979,'Holy Ark of Secrecy3',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30980,30980,'Ark Guardian''s Corpse',0,'',0,'NPC.angel_death',25.00,36.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(30981,30981,'Black Judge',0,'',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30982,30982,'Sleeping Ant Larva1',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30983,30983,'Sleeping Ant Larva2',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30984,30984,'Sleeping Ant Larva3',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30985,30985,'Sleeping Ant Larva4',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30986,30986,'Sleeping Ant Larva5',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30987,30987,'Sleeping Ant Larva6',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(30988,30988,'Verce',0,'Leathersmith ',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30989,30989,'Chest of Bifrons',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30990,30990,'Lottery Ticket Seller',0,'',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30991,30991,'Lottery Ticket Seller',0,'',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30992,30992,'Lottery Ticket Seller',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30993,30993,'Lottery Ticket Seller',0,'',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30994,30994,'Lottery Ticket Seller',0,'',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(30995,30995,'Race Manager',0,'',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(31001,31001,'Claudia Athebalt',0,'',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31002,31002,'Reorin',0,'Maestro',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31003,31003,'Here I Come',0,'',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31004,31004,'Half Moon Love',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31005,31005,'Everlasting',0,'',0,'Monster.mechanic_golem',5.00,19.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(31006,31006,'Dark Side of the Moon',0,'',0,'Monster.silhouette',8.00,23.00,70,'female','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31007,31007,'Wind Rider',0,'',0,'Monster.unicorn_boxer',11.00,18.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,29,132,NULL,0,0,0,'LAST_HIT'),
	(31008,31008,'Shooting Star',0,'',0,'Monster.unicorn_mirage',13.00,17.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,29,132,NULL,0,0,0,'LAST_HIT'),
	(31009,31009,'Cyclone Thunder',0,'',0,'Monster.dark_fencer',7.00,13.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,27,132,NULL,0,0,0,'LAST_HIT'),
	(31010,31010,'Hungry Baby',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31011,31011,'Salty Dog',0,'',0,'Monster.pet_wolf',13.00,11.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31012,31012,'Raging Revolution',0,'',0,'Monster.silver_cat',7.00,15.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31013,31013,'Valentine Blue',0,'',0,'Monster.blue_eye',11.00,16.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31014,31014,'Light My Fire',0,'',0,'Monster.big_boom',6.00,13.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31015,31015,'Red Bullet',0,'',0,'Monster.fox',9.50,10.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,25,132,NULL,0,0,0,'LAST_HIT'),
	(31016,31016,'Shining Silver',0,'',0,'Monster.rabbit',5.00,4.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31017,31017,'Over the top',0,'',0,'Monster.ant_larva',12.00,8.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(31018,31018,'Royal Straight',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31019,31019,'All Seven',0,'',0,'Monster.wererat',14.00,25.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31020,31020,'Nasty Green',0,'',0,'Monster.dryad',9.00,20.00,70,'female','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(31021,31021,'Shortcut',0,'',0,'Monster.goblin',10.00,16.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,44,132,NULL,0,0,0,'LAST_HIT'),
	(31022,31022,'Typhoon Tiger',0,'',0,'Monster.giant_bee',8.00,24.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,99,132,NULL,0,0,0,'LAST_HIT'),
	(31023,31023,'Red Hot',0,'',0,'Monster.salamander',16.00,6.80,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,70,132,NULL,0,0,0,'LAST_HIT'),
	(31024,31024,'Galaxy Express',0,'',0,'Monster.onyx_beast',14.00,14.50,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(31025,31025,'Best Condition',0,'',0,'Monster.manadragora',14.00,17.80,70,'female','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31026,31026,'Albatross',0,'',0,'Monster.orc',10.00,21.00,70,'male','L2Monster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(31027,31027,'Coffer of the Dead',0,'',0,'NPC.coffer_b',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31028,31028,'Chest of Kernon',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31029,31029,'Chest of Golkonda',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31030,31030,'Chest of Hallate',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31031,31031,'Broadcasting Tower',0,'',0,'NPC.broadcasting_tower',7.00,35.00,70,'etc','L2Observation',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31032,31032,'Guard',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(31033,31033,'Sentinel',0,'',0,'NPC.a_guard_MElf',8.00,23.50,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,276,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(31034,31034,'Sentry',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,80,'female','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,277,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(31035,31035,'Defender',0,'',0,'NPC.e_guard_MDwarf',8.00,19.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(31036,31036,'Centurion',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,273,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(31042,31042,'Kantabilon',0,'Melody Maestro',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31043,31043,'Octavia',0,'Melody Maestro',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31044,31044,'Galman',0,'Valley Trader',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31045,31045,'Kitzka',0,'Valley Trader',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31046,31046,'Marsden',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31047,31047,'Kell',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31048,31048,'McDermott',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31049,31049,'Pepper',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31050,31050,'Thora',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31051,31051,'Keach',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31052,31052,'Heid',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31053,31053,'Kidder',0,'Symbol Maker',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31067,31067,'Rood',0,'Pet Manager',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31074,31074,'Corpse of Hutaku',0,'',0,'NPC.e_trader_Morc_death',22.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31075,31075,'Sales Cat of Ivory Tower',0,'',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31076,31076,'Newbie Guide',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31077,31077,'Newbie Guide',0,'',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31078,31078,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31079,31079,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31080,31080,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31081,31081,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31082,31082,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31083,31083,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31084,31084,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31085,31085,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31086,31086,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31087,31087,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31088,31088,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31089,31089,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31090,31090,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31091,31091,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31092,31092,'Black Marketeer of Mammon',0,'',0,'NPC.black_market_trader_MDwarf',8.00,18.00,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31093,31093,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31094,31094,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31095,31095,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31096,31096,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31097,31097,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31098,31098,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31099,31099,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31100,31100,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31101,31101,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31102,31102,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31103,31103,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31104,31104,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31105,31105,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31106,31106,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31107,31107,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31108,31108,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31109,31109,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31110,31110,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31111,31111,'Gatekeeper Spirit',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31112,31112,'Gatekeeper Spirit',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31113,31113,'Merchant of Mammon',0,'',0,'NPC.black_market_trader_MDwarf_set',22.00,18.00,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31114,31114,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31115,31115,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31116,31116,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31117,31117,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31118,31118,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31119,31119,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31120,31120,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31121,31121,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31122,31122,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31123,31123,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31124,31124,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31125,31125,'Gatekeeper Ziggurat',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31126,31126,'Blacksmith of Mammon',0,'',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31127,31127,'Festival Guide',0,'Level 31 and Below',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31128,31128,'Festival Guide',0,'Level 42 and Below',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31129,31129,'Festival Guide',0,'Level 53 and Below',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31130,31130,'Festival Guide',0,'Level 64 and Below',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31131,31131,'Festival Guide',0,'No Level Limit',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31132,31132,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31133,31133,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31134,31134,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31135,31135,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31136,31136,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31137,31137,'Festival Guide',0,'Level 31 and Below',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31138,31138,'Festival Guide',0,'Level 42 and Below',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31139,31139,'Festival Guide',0,'Level 53 and Below',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31140,31140,'Festival Guide',0,'Level 64 and Below',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31141,31141,'Festival Guide',0,'No Level Limit',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31142,31142,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31143,31143,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31144,31144,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31145,31145,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31146,31146,'Festival Witch',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2FestivalGuide',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31147,31147,'Sobling',0,'Head Researcher',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31148,31148,'Pirate''s Chest',0,'',0,'NPC.coffer_c',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31149,31149,'Alchemist''s Mixing Urn',0,'',0,'NPC.pot',10.00,15.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31168,31168,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31169,31169,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31170,31170,'Crest of Dawn',0,'',0,'Deco.flag_ssq',0.01,0.01,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31171,31171,'Crest of Dusk',0,'',0,'Deco.flag_ssq',0.01,0.01,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31172,31172,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31173,31173,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31174,31174,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31175,31175,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31176,31176,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31177,31177,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31178,31178,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31179,31179,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31180,31180,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31181,31181,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31182,31182,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31183,31183,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31184,31184,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31185,31185,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31186,31186,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31187,31187,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31188,31188,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31189,31189,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31190,31190,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31191,31191,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31192,31192,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31193,31193,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31194,31194,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31195,31195,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31196,31196,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31197,31197,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31198,31198,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31199,31199,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31200,31200,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31201,31201,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2CabaleBuffer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31202,31202,'Maximus',0,'',0,'Monster.pet_wolf',13.00,11.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31203,31203,'Moon Dancer',0,'',0,'Monster.pet_wolf',13.00,11.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31204,31204,'Georgio',0,'',0,'Monster.pet_wolf',13.00,11.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31205,31205,'Katz',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31206,31206,'Ten Ten',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31207,31207,'Sardinia',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31208,31208,'La Grange',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31209,31209,'Misty Rain',0,'',0,'Monster.pet_wolf',13.00,11.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31210,31210,'Race Track Gatekeeper',0,'',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31211,31211,'Race Track Guide',0,'',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31212,31212,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31213,31213,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31214,31214,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31215,31215,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31216,31216,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31217,31217,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31218,31218,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31219,31219,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31220,31220,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31221,31221,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31222,31222,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31223,31223,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31224,31224,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31225,31225,'Arena Manager',0,'',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31226,31226,'Arena Director',0,'',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31227,31227,'Orion the Cat',0,'Event Manager',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31228,31228,'Roy the Cat',0,'Event Manager',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2ClassMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31229,31229,'Winnie the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31230,31230,'Louie the Cat',0,'Event Manager',0,'Monster.silver_cat',7.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31231,31231,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31232,31232,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31233,31233,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31234,31234,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31235,31235,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31236,31236,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31237,31237,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31238,31238,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31239,31239,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31240,31240,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31241,31241,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31242,31242,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31243,31243,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31244,31244,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31245,31245,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31246,31246,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31247,31247,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31248,31248,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31249,31249,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31250,31250,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31251,31251,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31252,31252,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31253,31253,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31254,31254,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31255,31255,'Orion the Cat',0,'Event Manager',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31256,31256,'Leon',0,'Trader',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31257,31257,'Veronica',0,'Trader',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31258,31258,'Helmut',0,'Trader',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31259,31259,'Janne',0,'Trader',0,'NPC.a_common_peopleC_Fhuman',8.00,22.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31260,31260,'Judith',0,'Trader',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31261,31261,'Renee',0,'Trader',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31262,31262,'Rupert',0,'Trader',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31263,31263,'Liesel',0,'Trader',0,'NPC.a_common_peopleC_Fhuman',8.00,22.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31264,31264,'Olsun',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31265,31265,'Annette',0,'Pet Manager',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31266,31266,'Kaiser',0,'',0,'Monster2.youth_tiger',16.00,17.20,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,66,132,NULL,0,0,0,'LAST_HIT'),
	(31267,31267,'Lietta',0,'Warehouse Keeper',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31268,31268,'Hakon',0,'Warehouse Keeper',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31269,31269,'Mona',0,'Warehouse Chief',0,'NPC.e_traderB_FDwarf',7.00,18.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31270,31270,'Stefano',0,'Warehouse Freightman',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31271,31271,'Hilda',0,'Blacksmith',0,'NPC.e_smith_Fdwarf',8.00,17.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,87,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31272,31272,'Noel',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31273,31273,'Borodin',0,'Blueprint Seller',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31274,31274,'Fundin',0,'Mineral Trader',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31275,31275,'Tatiana',0,'Gatekeeper',0,'NPC.e_teleporter_Fhuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31276,31276,'Bernhard',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,76,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31277,31277,'Felix',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,125,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31278,31278,'Bronwyn',0,'Master',0,'NPC.a_fighterguild_teacher_MElf',7.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31279,31279,'Gregory',0,'High Priest',0,'NPC.a_temple_master_Mhuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,193,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31280,31280,'Bastian',0,'Priest',0,'NPC.a_temple_teacher_Mhuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31281,31281,'Cerenas',0,'Priest',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31282,31282,'Justin',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31283,31283,'Alminas',0,'Magister',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31284,31284,'Elena',0,'Spellbook Seller',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31285,31285,'Samael',0,'Grand Master',0,'NPC.a_patriarch_MDarkElf',6.00,23.80,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31286,31286,'Drakon',0,'Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,143,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31287,31287,'Kamilen',0,'Magister',0,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,204,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31288,31288,'Aklan',0,'High Prefect',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31289,31289,'Lakan',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,161,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31290,31290,'Skahi',0,'Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31291,31291,'Terava',0,'Amulet Seller',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31292,31292,'Andrei',0,'Captain',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,133,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31293,31293,'Gunter',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31294,31294,'Sven',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31295,31295,'Henrik',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31296,31296,'Cadmon',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31297,31297,'Bayard',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31298,31298,'Ulrich',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31299,31299,'Eugen',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31300,31300,'Drumond',0,'Trader',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31301,31301,'Nils',0,'Trader',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31302,31302,'Vladimir',0,'Trader',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31303,31303,'Alisha',0,'Trader',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31304,31304,'Astrid',0,'Trader',0,'NPC.a_traderC_Fhuman',8.00,22.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31305,31305,'Candice',0,'Trader',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31306,31306,'Natasha',0,'Trader',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31307,31307,'Weber',0,'Trader',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31308,31308,'Achim',0,'Symbol Maker',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31309,31309,'Woods',0,'Pet Manager',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31310,31310,'Rafael',0,'',0,'Monster.strider',23.00,31.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31311,31311,'Hugin',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31312,31312,'Durin',0,'Warehouse Keeper',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31313,31313,'Lunin',0,'Warehouse Keeper',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31314,31314,'Donal',0,'Warehouse Chief',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31315,31315,'Daisy',0,'Warehouse Freightman',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31316,31316,'Vincenz',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31317,31317,'Lombert',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31318,31318,'Greta',0,'Blueprint Seller',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31319,31319,'Hans',0,'Mineral Trader',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31320,31320,'Ilyana',0,'Gatekeeper',0,'NPC.e_teleporter_Fhuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31321,31321,'Siegmund',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,76,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31322,31322,'Erian',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,125,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31323,31323,'Beryl',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31324,31324,'Andromeda',0,'Grand Master',0,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,316,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31325,31325,'Themis',0,'Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,227,627,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31326,31326,'Lambac',0,'High Prefect',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31327,31327,'Tazki',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,161,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31328,31328,'Innocentin',0,'High Priest',0,'NPC.a_temple_master_Mhuman',8.00,22.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,193,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31329,31329,'Eliyah',0,'Priest',0,'NPC.a_temple_teacher_Mhuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31330,31330,'Wagner',0,'Priest',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31331,31331,'Valdis',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31332,31332,'Amelia',0,'Magister',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31333,31333,'Rumiel',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31334,31334,'Tifaren',0,'Grand Magister',0,'NPC.a_teleporter_FDarkElf',8.00,25.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31335,31335,'Kayan',0,'Magister',0,'NPC.a_clergyman_MDarkElf',8.00,22.30,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,317,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31336,31336,'Rahorakti',0,'Grand Seer',0,'NPC.e_clergyman_MOrc',8.00,29.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31337,31337,'Mekara',0,'Seer',0,'NPC.e_mageguild_teacher_FOrc',8.00,28.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31338,31338,'Anton',0,'Spellbook Seller',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31339,31339,'Hakran',0,'Amulet Seller',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31340,31340,'Mathias',0,'Captain',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,133,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31341,31341,'Richtor',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31342,31342,'Dimitri',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31343,31343,'Bellard',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31344,31344,'Schmidt',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31345,31345,'Ian',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31346,31346,'Sirius',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31347,31347,'Burke',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,126,628,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31348,31348,'Agripel',0,'High Priest',0,'NPC.a_temple_master_Mhuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31349,31349,'Benedict',0,'Priest',0,'NPC.a_temple_master_Mhuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31350,31350,'Dominic',0,'Priest',0,'NPC.a_temple_master_Mhuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31351,31351,'Volker',0,'Wharf Manager',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31356,31356,'Remy',0,'Porter',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31357,31357,'Leandro',0,'Secretary',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31358,31358,'Kasiel',0,'Bard',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,4202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31359,31359,'Jaradine',0,'Mother Tree Guardian',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,189,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31360,31360,'Alhena',0,'Tetrarch Agent',0,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,315,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31361,31361,'Kreed',0,'Tetrarch Executioner',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31362,31362,'Tate',0,'Carrier',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31363,31363,'Rogin',0,'Deliveryman',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31364,31364,'Rokar',0,'Guardian of Flame',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,203,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31365,31365,'Yakand',0,'Guardian of Flame',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,203,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31366,31366,'Feed Seller',0,'',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31367,31367,'Voice of Glory',0,'',0,'Monster.kel_mahum_witch_doctor',13.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,193,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31368,31368,'Mikellan',0,'Monk of Silence',0,'NPC.a_temple_teacher_Mhuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31369,31369,'Mennon',0,'Monk of Silence',0,'NPC.a_temple_teacher_Mhuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31370,31370,'Kadun Zu Ketra',0,'Hierarch',0,'Monster2.ketra_orc_chieftain',11.00,38.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,6719,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31371,31371,'Wahkan',0,'Ketra''s Messenger',0,'Monster.ketra_orc',12.00,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,175,0,0,49,132,NULL,0,0,0,'LAST_HIT'),
	(31372,31372,'Asefa',0,'Soul Guide',0,'Monster.ketra_orc_shaman',10.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,205,0,0,11,132,NULL,0,0,0,'LAST_HIT'),
	(31373,31373,'Atan',0,'Grocer',0,'Monster.ketra_orc_warrior',12.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31374,31374,'Jaff',0,'Warehouse Keeper',0,'Monster.ketra_orc_warrior',12.00,24.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31375,31375,'Jumara',0,'Trader',0,'Monster.ketra_orc_warrior',12.00,24.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31376,31376,'Kurfa',0,'Gatekeeper',0,'Monster.ketra_orc_shaman',10.00,23.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,205,0,0,11,132,NULL,0,0,0,'LAST_HIT'),
	(31377,31377,'Ashas Varka Durai',0,'Hierarch',0,'Monster2.barka_silenos_chieftain',18.00,42.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,139,0,0,27,132,NULL,0,0,0,'LAST_HIT'),
	(31378,31378,'Naran Ashanuk',0,'Varka''s Messenger',0,'Monster2.barka_silenos_warrior',16.00,41.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,173,0,0,37,132,NULL,0,0,0,'LAST_HIT'),
	(31379,31379,'Udan Mardui',0,'Soul Guide',0,'Monster2.barka_silenos_shaman',14.00,39.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,6716,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31380,31380,'Diyabu',0,'Grocer',0,'Monster2.barka_silenos_hunter',16.00,38.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,48,132,NULL,0,0,0,'LAST_HIT'),
	(31381,31381,'Hagos',0,'Warehouse Keeper',0,'Monster2.barka_silenos_warrior',16.00,41.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,37,132,NULL,0,0,0,'LAST_HIT'),
	(31382,31382,'Shikon',0,'Trader',0,'Monster2.barka_silenos_hunter',16.00,38.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,48,132,NULL,0,0,0,'LAST_HIT'),
	(31383,31383,'Teranu Mardui',0,'Gatekeeper',0,'Monster2.barka_silenos_shaman',14.00,39.50,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,6716,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31384,31384,'Gatekeeper of Fire Dragon',0,'',0,'Monster.skeleton_knight',10.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,84,0,0,44,132,NULL,0,1,0,'LAST_HIT'),
	(31385,31385,'Heart of Volcano',0,'',0,'NPC.heart_of_warding',17.00,120.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31386,31386,'Violet',0,'Trader',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31387,31387,'Kurstin',0,'',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31388,31388,'Mina',0,'',0,'NPC.a_traderB_FHuman',8.00,24.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31389,31389,'Dorian',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,297,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31390,31390,'Dummy - Boy A',0,'Ch4 Test',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31391,31391,'Dummy  - Boy B',0,'Ch4 Test',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31392,31392,'Dummy  - Boy C',0,'Ch4 Test',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31393,31393,'Dummy - Boy D',0,'Ch4 Test',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31394,31394,'Dummy - Boy E',0,'Ch4 Test',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31395,31395,'Dummy - Lady F',0,'Ch4 Test',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31396,31396,'Dummy - Lady G',0,'Ch4 Test',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31397,31397,'Dummy - Lady H',0,'Ch4 Test',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31398,31398,'Dummy - Lady I',0,'Ch4 Test',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31399,31399,'Dummy - Lady J',0,'Ch4 Test',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31400,31400,'Dummy - Sword Guard',0,'Ch4 Test',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,2,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31401,31401,'Dummy - Bow Guard',0,'Ch4 Test',0,'NPC.a_guard_MHuman',8.00,24.00,80,'female','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,14,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31404,31404,'Monster Race Guide',0,'Town of Gludio',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31405,31405,'Monster Race Guide',0,'Town of Dion',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31406,31406,'Monster Race Guide',0,'Town of Giran',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31407,31407,'Monster Race Guide',0,'Heine',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31408,31408,'Monster Race Guide',0,'Town of Oren',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31409,31409,'Monster Race Guide',0,'Hunters Village',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31410,31410,'Monster Race Guide',0,'Town of Aden',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31411,31411,'Monster Race Guide',0,'Town of Goddard',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31412,31412,'Monster Race Guide',0,'Rune Township',0,'NPC.e_teleporter_FDwarf',8.00,21.30,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31413,31413,'Antonio',0,'Spellbook Seller ',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31414,31414,'Lynn',0,'Spellbook Seller ',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31415,31415,'Triya',0,'Spellbook Seller ',0,'NPC.a_mageguild_teacher_MDarkElf',8.00,22.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31416,31416,'Aren',0,'Spellbook Seller ',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31417,31417,'Berynel',0,'Spellbook Seller ',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31418,31418,'Rouke',0,'Spellbook Seller ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31419,31419,'Lorel',0,'Spellbook Seller ',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31420,31420,'Tomanel',0,'Spellbook Seller ',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31421,31421,'Ratriya',0,'Spellbook Seller ',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31422,31422,'Migel',0,'Spellbook Seller ',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31423,31423,'Romas',0,'Spellbook Seller ',0,'NPC.a_traderB_MHuman',8.00,25.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31424,31424,'Shantra',0,'Amulet Seller ',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31425,31425,'Koram',0,'Amulet Seller ',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31426,31426,'Jaka',0,'Amulet Seller ',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31427,31427,'Urgal',0,'Amulet Seller ',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31428,31428,'Shafa',0,'Amulet Seller ',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31429,31429,'Shitara',0,'Amulet Seller ',0,'NPC.e_clergyman_FOrc',7.00,28.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31430,31430,'Donai',0,'Amulet Seller ',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31431,31431,'Karai',0,'Amulet Seller ',0,'NPC.e_mageguild_teacher_MOrc',8.00,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31432,31432,'Reeya',0,'Blueprint Seller',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31433,31433,'Ronaldo',0,'Blueprint Seller',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31434,31434,'Shaling',0,'Blueprint Seller',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31435,31435,'Daeger',0,'Blueprint Seller',0,'NPC.e_traderA_master_MDwarf',8.00,18.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31436,31436,'Dani',0,'Blueprint Seller',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31437,31437,'Luka',0,'Blueprint Seller',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31438,31438,'Lara',0,'Blueprint Seller',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31439,31439,'Rogen',0,'Mineral Trader',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31440,31440,'Lanna',0,'Mineral Trader',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31441,31441,'Gordo',0,'Mineral Trader',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31442,31442,'Kiki',0,'Mineral Trader',0,'NPC.e_traderB_FDwarf',7.00,18.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31443,31443,'Raban',0,'Mineral Trader',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31444,31444,'Cona',0,'Mineral Trader',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31445,31445,'Shutner',0,'Mineral Trader',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31452,31452,'Ghost of Wigoth',0,'',0,'NPC.a_temple_master_Mhuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31453,31453,'Nameless Spirit',0,'',0,'NPC.a_king_MHuman',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31454,31454,'Ghost of Wigoth',0,'',0,'NPC.a_temple_master_Mhuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31455,31455,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31456,31456,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31457,31457,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31458,31458,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31459,31459,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31460,31460,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31461,31461,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31462,31462,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31463,31463,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31464,31464,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31465,31465,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31466,31466,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31467,31467,'Key Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31468,31468,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31469,31469,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31470,31470,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31471,31471,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31472,31472,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31473,31473,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31474,31474,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31475,31475,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31476,31476,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31477,31477,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31478,31478,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31479,31479,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31480,31480,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31481,31481,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31482,31482,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31483,31483,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31484,31484,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31485,31485,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31486,31486,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31487,31487,'Mysterious Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31488,31488,'Rift Post Recruit',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31489,31489,'Rift Post Private',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,304,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31490,31490,'Rift Post Officer',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,79,111,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31491,31491,'Rift Post Captain',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,76,660,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31492,31492,'Rift Post Commander',0,'',0,'NPC.a_lord_MHuman',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,80,655,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31493,31493,'Rift Post Hero',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,135,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31494,31494,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31495,31495,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31496,31496,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31497,31497,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31498,31498,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31499,31499,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31500,31500,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31501,31501,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31502,31502,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31503,31503,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31504,31504,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31505,31505,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31506,31506,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31507,31507,'Dimensional Gate Keeper',0,'',0,'NPC.rift_keeper',38.00,120.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31508,31508,'Altar of Saints',0,'',0,'NPC.holy_altar',14.00,45.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31509,31509,'Altar of Saints',0,'',0,'NPC.holy_altar',14.00,45.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31510,31510,'Altar of Saints',0,'',0,'NPC.holy_altar',14.00,45.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31511,31511,'Altar of Saints',0,'',0,'NPC.holy_altar',14.00,45.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31512,31512,'Evil Altar',0,'',0,'NPC.evil_altar',11.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31513,31513,'Evil Altar',0,'',0,'NPC.evil_altar',11.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31514,31514,'Evil Altar',0,'',0,'NPC.evil_altar',11.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31515,31515,'Evil Altar',0,'',0,'NPC.evil_altar',11.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31516,31516,'Evil Altar',0,'',0,'NPC.evil_altar',11.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31517,31517,'Hierarch',0,'',0,'NPC.a_hardin_MHuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31518,31518,'Mysterious Necromancer',0,'',0,'NPC.a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31519,31519,'Enfeux',0,'',0,'NPC.saints_coffin',20.00,60.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31520,31520,'Leikar',0,'Maid',0,'NPC.a_maidA_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31521,31521,'Jeremy',0,'Chef',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31522,31522,'Mysterious Wizard',0,'',0,'NPC.a_hardin_MHuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31523,31523,'Tombstone',0,'',0,'NPC.old_tomb_stone',20.00,30.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31524,31524,'Ghost of von Hellmann',0,'',0,'NPC.a_temple_master_Mhuman',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31525,31525,'Ghost of von Hellmann''s Page',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31526,31526,'Broken Bookshelf',0,'',0,'NPC.old_bookshelf',15.00,32.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31527,31527,'Well',0,'',0,'NPC.umul',33.00,37.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31528,31528,'Ghost of Priest',0,'',0,'Monster.elf_ghost',7.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31529,31529,'Ghost of Adventurer',0,'',0,'Monster.human_ghost',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31530,31530,'Box',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31531,31531,'Tombstone',0,'',0,'NPC.old_tomb_stone',20.00,30.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31532,31532,'Maid of Lidia',0,'',0,'Monster2.vampire_witch',6.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,70,132,NULL,0,0,0,'LAST_HIT'),
	(31533,31533,'Broken Bookshelf',0,'',0,'NPC.old_bookshelf',15.00,32.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31534,31534,'Broken Bookshelf',0,'',0,'NPC.old_bookshelf',15.00,32.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31535,31535,'Broken Bookshelf',0,'',0,'NPC.old_bookshelf',15.00,32.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31536,31536,'Coffin',0,'',0,'Monster.mimic',8.50,8.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31537,31537,'Tunatun',0,'Beast Herder',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31538,31538,'Ghost of Adventurer',0,'',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31539,31539,'Vulcan',0,'Blacksmith of Flame',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,89,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31540,31540,'Klein',0,'Watcher of Valakas',0,'Monster.skeleton_royal_guard',11.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31541,31541,'Daimon''s Altar',0,'',0,'NPC.gianteye_altar',40.00,45.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31542,31542,'Yeti''s Table',0,'',0,'NPC.yetis_dinner_table',23.00,16.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31543,31543,'Pulin',0,'',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31544,31544,'Naff',0,'',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31545,31545,'Crocus',0,'',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31546,31546,'Kuber',0,'',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31547,31547,'Beolin',0,'',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31548,31548,'Mysterious Ancient Tablet',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31549,31549,'Mysterious Ancient Tablet',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31550,31550,'Mysterious Ancient Tablet',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31551,31551,'Mysterious Ancient Tablet',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31552,31552,'Mysterious Ancient Tablet',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31553,31553,'Pierce',0,'Mercenary Captain',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,135,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31554,31554,'Kahman',0,'Mercenary',0,'NPC.e_fighterguild_teacher_MOrc',8.00,28.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,161,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31555,31555,'Abercrombie',0,'Mercenary Supplier',0,'NPC.e_collector_teacher_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31556,31556,'Selina',0,'Mercenary Medic',0,'NPC.a_traderC_Fhuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,189,659,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31557,31557,'Mercenary Sentry',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,298,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31558,31558,'Ketra''s Holy Altar',0,'',0,'NPC.orcish_totem',25.00,47.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31559,31559,'Box of Asefa',0,'',0,'NPC.coffer_d',12.00,9.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31560,31560,'Varka''s Holy Altar',0,'',0,'NPC.silenos_totem',28.00,55.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31561,31561,'Udan Mardui''s Box',0,'',0,'NPC.coffer_b',12.00,9.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31562,31562,'Klufe',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31563,31563,'Perelin',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31564,31564,'Mishini',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31565,31565,'Ogord',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31566,31566,'Ropfi',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31567,31567,'Bleaker',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31568,31568,'Pamfus',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31569,31569,'Cyano',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31570,31570,'Lanosco',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31571,31571,'Hufs',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31572,31572,'O''Fulle',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31573,31573,'Monakan',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31574,31574,'Willie',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31575,31575,'Litulon',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31576,31576,'Berix',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31577,31577,'Linnaeus',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31578,31578,'Hilgendorf',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31579,31579,'Klaus',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31580,31580,'Galadrid',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,132,110,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31581,31581,'Anastia',0,'Magister',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31582,31582,'Mordred',0,'Dark Knight',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,137,634,0,66,132,NULL,0,1,0,'LAST_HIT'),
	(31583,31583,'Feynn',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,168,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31584,31584,'Valentine',0,'Brewer',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31585,31585,'Sparky the Cat',0,'Keats Servitor',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31586,31586,'Sparky the Cat',0,'Keats Servitor',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31587,31587,'Gedrik',0,'Gemcutter',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31588,31588,'Agnes',0,'Saint of Light',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31589,31589,'Duda-Mara Totem Spirit ',0,'',0,'Monster.giant_spider',26.00,25.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,79,132,NULL,0,0,0,'LAST_HIT'),
	(31590,31590,'Truth Scholar Devianne',0,'',0,'NPC.a_teleporter_FHuman',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,192,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31591,31591,'Sunset Guide Luna',0,'',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,189,633,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31592,31592,'Telson',0,'Chief Golem Crafter',0,'NPC.e_mine_master_MDwarf',8.00,19.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31593,31593,'Dorothy',0,'Golem of Telson',0,'Monster.mechanic_golem',5.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(31594,31594,'Mond',0,'Chief Inspector',0,'NPC.e_celebrant_MDwarf',8.00,19.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31595,31595,'Leona Blackbird',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,79,110,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31596,31596,'Tobald',0,'Master',0,'NPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,187,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31597,31597,'Tobald',0,'Master',0,'NPC.e_guard_MDwarf',8.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,187,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31598,31598,'Medina Blackheart',0,'',0,'NPC.a_trader_Fdarkelf',8.00,24.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,206,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31599,31599,'Disgraced Knight Waldstein',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,81,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31600,31600,'Pamela Aprodia',0,'',0,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31601,31601,'Pamela Aprodia',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31602,31602,'Sharona Artemia',0,'Bodyguard',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,232,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31603,31603,'Black Cat',0,'Hunter Guild Member',0,'NPC.a_common_people_FDarkElf',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,227,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31604,31604,'Grimst',0,'Information Broker',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31605,31605,'Kinsley',0,'Head Summoner',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,212,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31606,31606,'Alice de Catrina',0,'Kinsley''s Servitor',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31607,31607,'Sake Dun Zu Hestui',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,298,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31608,31608,'Belinda',0,'Summoner',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31609,31609,'Aurora the Unicorn',0,'Belinda Servitor',0,'Monster.unicorn_boxer',11.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,29,132,NULL,0,0,0,'LAST_HIT'),
	(31610,31610,'Shiken Gloomdrake',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,80,633,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31611,31611,'Scryde Heartseeker',0,'',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,81,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31612,31612,'Eternity Wanderer Staris',0,'',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,150,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31613,31613,'Noctisse',0,'Summoner',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,204,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31614,31614,'Radyss',0,'Head Summoner',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31615,31615,'Hermit',0,'',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31616,31616,'Hermit',0,'',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,8,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31617,31617,'Aria Firstmatter',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,236,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31618,31618,'Moon Voice Irene',0,'',0,'NPC.a_common_people_FElf',7.00,25.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,109,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31619,31619,'Erica Ken Weber',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,236,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31620,31620,'Verdure Elder Elikia',0,'',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,189,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31621,31621,'Abyss Saint Elcardia',0,'',0,'NPC.a_guard_FDarkelf',7.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,206,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31622,31622,'Keats',0,'Cursed Summoner',0,'Monster.poison_toad',20.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31623,31623,'Bavarin',0,'Information Broker',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31624,31624,'Donath',0,'Master Chef',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31625,31625,'Yeti',0,'Donath Kitchen Help',0,'NPC.yeti_cute',5.00,11.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5129,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31626,31626,'Duncan',0,'Chef',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5129,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31627,31627,'Mist',0,'Information Broker',0,'NPC.e_bath_MDwarf',6.00,16.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31628,31628,'Lilly',0,'Mist''s Granddaughter',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31629,31629,'Kaleidos the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31630,31630,'Kaleidos the Unicorn',0,'',0,'Monster.blue_eye',11.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31631,31631,'Eric Ramsheart',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,79,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31632,31632,'Mysterious Servitor',0,'',0,'Monster.shadeless',7.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31633,31633,'Winter Hunter Kadyth',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,285,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31634,31634,'Winter Hunter Kadyth',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,285,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31635,31635,'Winter Hunter Kadyth',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,285,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31636,31636,'Flame Successor Akkan',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,305,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31637,31637,'Khavatari Kashu',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,267,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31638,31638,'Starling Knight Kastien',0,'',0,'NPC.a_guard_MElf',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,142,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31639,31639,'Kain Van Halter',0,'',0,'NPC.a_traderA_MHuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,2626,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31640,31640,'Pilgrim of Darkness',0,'',0,'NPC.a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,318,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31641,31641,'Pilgrim of Darkness',0,'',0,'NPC.a_hardins_pupil_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,318,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31642,31642,'Tarkai Zu Duda-Mara',0,'',0,'NPC.e_guard_MOrc',8.00,27.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,210,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31643,31643,'Silver Feyshar',0,'',0,'NPC.a_patriarch_MElf',8.00,22.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,148,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31644,31644,'Dawn Witness Franz',0,'',0,'NPC.a_sanctuary_master_MHuman',8.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,205,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31645,31645,'Hindemith Truevoice',0,'',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,195,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31646,31646,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31647,31647,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31648,31648,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31649,31649,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31650,31650,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31651,31651,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31652,31652,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31653,31653,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31654,31654,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31655,31655,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31656,31656,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31657,31657,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31658,31658,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31659,31659,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31660,31660,'Tablet of Vision',0,'',0,'NPC.codex_stone',7.00,24.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31661,31661,'Forgotten Monument',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31662,31662,'Forgotten Monument',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31663,31663,'Forgotten Monument',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31664,31664,'Forgotten Monument',0,'',0,'NPC.old_tablet',32.00,46.50,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31665,31665,'Corpse of Dwarf',0,'',0,'NPC.e_guard_MDwarf_death',13.00,19.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31666,31666,'Lumen',0,'Spellbook Seller',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31667,31667,'Raik',0,'Amulet Seller ',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31668,31668,'Tangen',0,'Blueprint Seller',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31669,31669,'Onyx',0,'Mineral Trader',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31670,31670,'Burns',0,'Spellbook Seller',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31671,31671,'Patrol',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31672,31672,'Patrol',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31673,31673,'Patrol',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',1100,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,4031,576,1144,468,249,1000,333,275,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31674,31674,'Patrol',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,1000,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31675,31675,'Viktor Van Deik',0,'Border Outpost Captain',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,128,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31676,31676,'Gregory Athebaldt',0,'Border Outpost Captain',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,70,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31677,31677,'Border Patrol',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31678,31678,'Border Patrol',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,80,'male','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31679,31679,'Eustace Van Essen',0,'Frontier Guard Captain',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,70,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31680,31680,'Fleming Van Issen',0,'Frontier Guard Captain',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,128,632,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31681,31681,'Frontier Guard',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31682,31682,'Frontier Guard',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Npc',40,4551,1859,13.43,3.09,40,43,30,21,20,10,0,0,1814,576,1144,468,278,0,333,94,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31683,31683,'Eye of Argos',0,'',0,'NPC.argos_eye',205.00,305.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31684,31684,'Eye of Udan Mardui',0,'',0,'Monster.mana_vampire',11.00,20.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,99,132,NULL,0,0,0,'LAST_HIT'),
	(31685,31685,'Asefa''s Eye',0,'',0,'Monster.magical_weaver',11.00,20.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,99,132,NULL,0,0,0,'LAST_HIT'),
	(31686,31686,'Gatekeeper of Fire Dragon',0,'',0,'Monster.skeleton_knight',10.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,84,0,0,44,132,NULL,0,1,0,'LAST_HIT'),
	(31687,31687,'Gatekeeper of Fire Dragon',0,'',0,'Monster.skeleton_knight',10.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,84,0,0,44,132,NULL,0,1,0,'LAST_HIT'),
	(31688,31688,'Grand Olympiad Manager',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,70,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31689,31689,'Olympiad Finisher',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,70,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31690,31690,'Monument of Heroes ',0,'',0,'NPC.heroes_obelisk_human',24.00,69.00,70,'etc','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31691,31691,'Training Dummy ',0,'',0,'NPC.training_doll',9.00,22.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31692,31692,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31693,31693,'Priest of Dusk',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31694,31694,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',8.00,30.50,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,5802,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31695,31695,'Priest of Dusk',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'female','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31696,31696,'Platis',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31697,31697,'Eindarkner',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,7560,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31698,31698,'Arisha',0,'Gatekeeper',0,'NPC.e_teleporter_Fhuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31699,31699,'Stanislava',0,'Gatekeeper',0,'NPC.e_teleporter_Fhuman',8.00,25.00,70,'female','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31700,31700,'Saint''s Follower',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31701,31701,'Saint''s Follower',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31702,31702,'Saint''s Follower',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31703,31703,'Saint''s Follower',0,'',0,'NPC.a_common_peopleC_Fhuman',8.00,22.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31704,31704,'Saint''s Follower',0,'',0,'NPC.a_common_peopleA_FHuman',8.00,21.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31705,31705,'Daimon the White-Eyed',0,'',0,'Monster2.hundred_eye',21.00,55.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,33,132,NULL,0,0,0,'LAST_HIT'),
	(31706,31706,'Miki the Cat',0,'',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31707,31707,'Ketra Van Grunt',0,'',0,'Monster2.ketra_orc_chieftain',11.00,38.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,6719,0,0,26,132,NULL,0,0,0,'LAST_HIT'),
	(31708,31708,'Ketra Van Shaman',0,'',0,'Monster.ketra_orc_shaman',10.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,92,0,0,11,132,NULL,0,0,0,'LAST_HIT'),
	(31709,31709,'Ketra Van Captain',0,'',0,'Monster2.ketra_orc_warlord',12.00,30.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,80,0,0,29,132,NULL,0,0,0,'LAST_HIT'),
	(31710,31710,'Ketra Van Commander',0,'',0,'Monster2.barka_silenos_chieftain',18.00,42.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,2500,0,0,27,132,NULL,0,0,0,'LAST_HIT'),
	(31711,31711,'Ketra Van Shaman',0,'',0,'Monster2.barka_silenos_shaman',14.00,39.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,6716,0,0,39,132,NULL,0,0,0,'LAST_HIT'),
	(31712,31712,'Varka Raider',0,'',0,'Monster2.barka_silenos_warrior',16.00,41.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,142,0,0,37,132,NULL,0,0,0,'LAST_HIT'),
	(31713,31713,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31714,31714,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31715,31715,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31716,31716,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31717,31717,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31718,31718,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31719,31719,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31720,31720,'Preacher of Doom',0,'',0,'Monster.dark_horror',20.00,35.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,110,132,NULL,0,1,0,'LAST_HIT'),
	(31721,31721,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31722,31722,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31723,31723,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31724,31724,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31725,31725,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31726,31726,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31727,31727,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31728,31728,'Orator of Revelations',0,'',0,'Monster.liviona',15.00,28.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31729,31729,'Adventurer Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31730,31730,'Adventurer Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31731,31731,'Adventurer Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31732,31732,'Adventurer Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31733,31733,'Adventurer Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31734,31734,'Adventurer Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31735,31735,'Adventurer Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31736,31736,'Adventurer Guildsman',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31737,31737,'Adventurer Guildsman',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31738,31738,'Adventurer Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31739,31739,'Talien',0,'',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,4202,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31740,31740,'Caradine',0,'',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,285,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31741,31741,'Ossian',0,'',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31742,31742,'Virgil',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31743,31743,'Kassandra',0,'',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31744,31744,'Ogmar',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31745,31745,'Lady of the Lake',0,'',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31746,31746,'Fallen Unicorn',0,'',0,'Monster.death_unicorn',14.00,30.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,50,132,NULL,0,0,0,'LAST_HIT'),
	(31747,31747,'Pure White Unicorn',0,'',0,'Monster.unicorn',14.00,30.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,50,132,NULL,0,0,0,'LAST_HIT'),
	(31748,31748,'Cornerstone of Restraining',0,'',0,'NPC.grave_keeper',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31750,31750,'Mysterious Woman',0,'',0,'NPC.a_teleporter_FElf',8.50,23.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31751,31751,'Mysterious Dark Knight',0,'',0,'Monster.death_lord',21.00,40.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,78,0,0,44,132,NULL,0,1,0,'LAST_HIT'),
	(31752,31752,'Corpse of Angel',0,'',0,'NPC.angel_death',25.00,36.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31755,31755,'Halaster',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31756,31756,'Mr. Cat',0,'Test Server Helper',0,'Monster.cat_the_cat',9.00,16.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31757,31757,'Miss Queen',0,'Test Server Helper',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31758,31758,'Rafi',0,'',0,'Monster.hatchling',9.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31759,31759,'Teleport Cube',0,'',0,'NPC.teleport_npc',40.00,80.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31760,31760,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31761,31761,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31762,31762,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31763,31763,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31764,31764,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31765,31765,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31766,31766,'Miss Queen',0,'Adventurers'' Guide',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT'),
	(31767,31767,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31768,31768,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31769,31769,'Monument of Heroes',0,'',0,'NPC.heroes_obelisk_elf',24.00,77.50,70,'etc','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31770,31770,'Monument of Heroes',0,'',0,'NPC.heroes_obelisk_darkelf',25.00,77.00,70,'etc','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31771,31771,'Monument of Heroes',0,'',0,'NPC.heroes_obelisk_orc',24.00,72.50,70,'etc','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31772,31772,'Monument of Heroes',0,'',0,'NPC.heroes_obelisk_dwarf',23.00,80.00,70,'etc','L2OlympiadManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31773,31773,'Sonin',0,'Warehouse Keeper',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'female','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31774,31774,'Beryl the Cat',0,'Event Manager',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(31775,31775,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31776,31776,'Adventure Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31777,31777,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31778,31778,'Adventure Guildsman',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31779,31779,'Adventure Guildsman',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31780,31780,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31781,31781,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31782,31782,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31783,31783,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31784,31784,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31785,31785,'Adventure Guildsman',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31786,31786,'Adventure Guildsman',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31787,31787,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31788,31788,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31789,31789,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31790,31790,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31791,31791,'Adventure Guildsman',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31792,31792,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31793,31793,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31794,31794,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31795,31795,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31796,31796,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31797,31797,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31798,31798,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31799,31799,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31800,31800,'Adventure Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31801,31801,'Adventure Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31802,31802,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31803,31803,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31804,31804,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31805,31805,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31806,31806,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31807,31807,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31808,31808,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31809,31809,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31810,31810,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31811,31811,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31812,31812,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31813,31813,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31814,31814,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31815,31815,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31816,31816,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31817,31817,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31818,31818,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31819,31819,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31820,31820,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31821,31821,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31822,31822,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31823,31823,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31824,31824,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31825,31825,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31826,31826,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31827,31827,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31828,31828,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31829,31829,'Adventure Guildsman',0,'',0,'NPC.a_trader_MDarkElf',8.00,22.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,151,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31830,31830,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31831,31831,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31832,31832,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31833,31833,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,231,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31834,31834,'Adventure Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,156,20,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31835,31835,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31836,31836,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31837,31837,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,224,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31838,31838,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,99,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31839,31839,'Adventure Guildsman',0,'',0,'NPC.a_common_people_MElf',6.00,21.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,130,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31840,31840,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',8.00,26.00,70,'male','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31841,31841,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,22.40,70,'female','L2Adventurer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,129,102,0,52,132,NULL,0,1,0,'LAST_HIT'),
	(31842,31842,'Teleport Cube',0,'',0,'NPC.teleport_npc',40.00,80.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,1,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31843,31843,'Teleport Cube',0,'',0,'NPC.teleport_npc',40.00,80.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(31844,31844,'Aracna',0,'',0,'Monster.aracne',15.00,26.00,50,'female','L2Monster',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,0,3819,0,0,0,103,194,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31845,31845,'Bloody Pixy',0,'',0,'Monster.pixy',5.00,25.00,80,'female','L2FriendlyMob',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,1000,3819,0,0,0,129,194,'all_elemental2_clan',300,0,0,'LAST_HIT'),
	(31846,31846,'Satyros',0,'',0,'Monster.pan',14.00,35.00,50,'male','L2Monster',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,0,3819,291,0,0,72,178,'all_elemental2_clan',300,0,0,'LAST_HIT'),
	(31847,31847,'Pan',0,'',0,'Monster.pan',14.00,35.00,50,'male','L2Monster',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,0,3819,291,0,0,72,178,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31848,31848,'Pixy',0,'',0,'Monster.pixy',5.00,25.00,80,'female','L2FriendlyMob',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,0,3819,0,0,0,129,194,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31849,31849,'Red Arachne',0,'',0,'Monster.aracne',15.00,26.00,50,'female','L2Monster',40,3381,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1135,278,2360,452,409,0,3819,0,0,0,103,194,'all_elemental2_clan',300,0,0,'LAST_HIT'),
	(31850,31850,'Blight Treant',0,'',0,'Monster.ti_mi_riran',23.00,90.00,80,'male','L2FriendlyMob',40,3720,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1032,278,2360,452,409,0,3819,0,0,0,19,19,'all_elemental2_clan',300,0,0,'LAST_HIT'),
	(31851,31851,'Treant',0,'',0,'Monster.ti_mi_tran',23.00,90.00,80,'male','L2FriendlyMob',40,3720,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1032,278,2360,452,409,0,3819,0,0,0,19,19,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31852,31852,'Pixy Murika',0,'',0,'Monster.pixy',5.00,25.00,50,'female','L2Npc',40,2469,830,8.69,2.14,40,43,30,21,20,10,3000,226,509,278,264,226,278,0,333,0,0,0,88,132,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31853,31853,'Treant Bremec',0,'',0,'Monster.ti_mi_tran',23.00,90.00,80,'male','L2Npc',40,3720,1660,13.09,2.14,60,57,73,76,70,80,3000,226,1032,278,2360,452,409,0,3819,0,0,0,19,19,'all_elemental_clan',300,0,0,'LAST_HIT'),
	(31854,31854,'Event Manager',0,'',0,'NPC.a_maidA_FHuman',8.00,20.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31855,31855,'Event Manager',0,'',0,'NPC.a_trader_FElf',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31856,31856,'Event Manager',0,'',0,'NPC.a_clergyman_FDarkElf',8.00,25.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31857,31857,'Event Manager',0,'',0,'NPC.e_traderA_FDwarf',7.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31858,31858,'Event Manager',0,'',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31859,31859,'Teleport Cube',0,'',0,'NPC.teleport_npc',40.00,80.00,70,'etc','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,1,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31860,31860,'Orion the Cat',0,'Event Manager',0,'Monster.cat_the_cat',7.00,15.00,70,'female','L2Npc',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31861,31861,'Gatekeeper',0,'',0,'NPC.a_teleporter_FHuman',7.00,15.00,56,'female','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,88,132,NULL,0,1,0,'LAST_HIT'),
	(31862,31862,'Angelic Vortex',0,'',0,'NPC.broadcasting_tower',7.00,35.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31863,31863,'Santa Trainee',0,'',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31864,31864,'Santa Trainee',0,'',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(31865,31865,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31866,31866,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31867,31867,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31868,31868,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31869,31869,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31870,31870,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31871,31871,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31872,31872,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31873,31873,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,35,'etc','L2Teleporter',40,1220,446,7.11,1.84,40,43,30,21,20,10,0,0,192,169,89,137,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31874,31874,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31875,31875,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31876,31876,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31877,31877,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31878,31878,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31879,31879,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31880,31880,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31881,31881,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31882,31882,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,45,'etc','L2Teleporter',40,1870,677,8.69,2.14,40,43,30,21,20,10,0,0,377,238,188,193,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31883,31883,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31884,31884,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31885,31885,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31886,31886,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31887,31887,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31888,31888,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31889,31889,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31890,31890,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31891,31891,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,55,'etc','L2Teleporter',40,2643,987,10.27,2.45,40,43,30,21,20,10,0,0,670,322,360,261,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31892,31892,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31893,31893,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31894,31894,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31895,31895,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31896,31896,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31897,31897,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31898,31898,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31899,31899,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31900,31900,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,65,'etc','L2Teleporter',40,3465,1319,11.85,2.78,40,43,30,21,20,10,0,0,1077,418,619,340,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31901,31901,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31902,31902,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31903,31903,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31904,31904,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31905,31905,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31906,31906,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31907,31907,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31908,31908,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31909,31909,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,75,'etc','L2Teleporter',40,4229,1673,13.43,3.09,40,43,30,21,20,10,0,0,1563,523,957,425,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31910,31910,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31911,31911,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31912,31912,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31913,31913,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31914,31914,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31915,31915,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31916,31916,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31917,31917,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31918,31918,'Guardian of Border',0,'',0,'NPC.teleport_npc_sm',7.00,15.00,85,'etc','L2Teleporter',40,4813,2049,13.43,3.09,40,43,30,21,20,10,0,0,2052,629,1333,511,278,0,333,0,0,0,55,1,NULL,0,1,0,'LAST_HIT'),
	(31919,31919,'Ghost Chamberlain of Elmoreden',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(31920,31920,'Ghost Chamberlain of Elmoreden',0,'',0,'NPC.a_tombkeeperA',8.00,23.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(31921,31921,'Conquerors'' Sepulcher Manager',0,'',0,'NPC.grave_keeper',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31922,31922,'Emperors'' Sepulcher Manager',0,'',0,'NPC.grave_keeper',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31923,31923,'Great Sages'' Sepulcher Manager',0,'',0,'NPC.grave_keeper',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31924,31924,'Judges'' Sepulcher Manager',0,'',0,'NPC.grave_keeper',8.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31925,31925,'Baron''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31926,31926,'Viscount''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31927,31927,'Count''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31928,31928,'Marquis'' Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31929,31929,'Duke''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31930,31930,'Baron''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31931,31931,'Viscount''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31932,31932,'Count''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31933,31933,'Marquis'' Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31934,31934,'Duke''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31935,31935,'Baron''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31936,31936,'Viscount''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31937,31937,'Count''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31938,31938,'Marquis'' Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31939,31939,'Duke''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31940,31940,'Baron''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31941,31941,'Viscount''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31942,31942,'Count''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31943,31943,'Marquis'' Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31944,31944,'Duke''s Hall Gatekeeper',0,'',0,'NPC.rift_keeper_25_sm',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,0,0,'LAST_HIT'),
	(31945,31945,'Auzendorff',0,'Trader',0,'NPC.e_traderB_MDwarf',8.00,17.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31946,31946,'Hombre',0,'Trader',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31947,31947,'Owaki',0,'Trader',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31948,31948,'Adrian',0,'Trader',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31949,31949,'Rouge',0,'Trader',0,'NPC.a_traderC_Fhuman',8.00,22.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31950,31950,'Mailland',0,'Trader',0,'NPC.e_traderB_FDwarf',7.00,18.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31951,31951,'Jose',0,'Trader',0,'NPC.a_traderD_Fhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31952,31952,'Pele',0,'Trader',0,'NPC.a_common_peopleC_Fhuman',8.00,22.50,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31953,31953,'Rankar',0,'Symbol Maker',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2SymbolMaker',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31954,31954,'Saroyan',0,'Pet Manager',0,'NPC.a_traderD_Mhuman',8.00,25.30,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31955,31955,'Ruby',0,'',0,'Monster2.baby_tiger',9.50,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31956,31956,'Rydel',0,'Warehouse Keeper',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31957,31957,'Cherbal',0,'Warehouse Keeper',0,'NPC.a_warehouse_keeper_MDwarf',8.00,17.00,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31958,31958,'Yasheni',0,'Warehouse Chief ',0,'NPC.e_warehouse_keeper_FDwarf',7.00,18.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31959,31959,'Axel',0,'Warehouse Freightman',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2Warehouse',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31960,31960,'Byron',0,'Blacksmith',0,'NPC.e_smith_Fdwarf',8.00,18.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31961,31961,'Newyear',0,'Head Blacksmith',0,'NPC.e_smith_master_MDwarf',8.00,16.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31962,31962,'Altair',0,'Blueprint Seller',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31963,31963,'Hitchi',0,'Mineral Trader',0,'NPC.e_traderB_master_MDwarf',8.00,17.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31964,31964,'Bilia',0,'Gatekeeper',0,'NPC.e_teleporter_Fhuman',8.00,25.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31965,31965,'Hector',0,'Grand Master',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31966,31966,'Karamon',0,'Master',0,'NPC.a_fighterguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31967,31967,'Euline',0,'Master',0,'NPC.a_fighterguild_teacher_FElf',8.00,22.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31968,31968,'Baryl',0,'High Priest',0,'NPC.a_temple_master_Mhuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,193,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31969,31969,'Evelyn',0,'Priest',0,'NPC.a_mageguild_master_FHuman',8.00,25.30,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31970,31970,'Sinis',0,'Priest',0,'NPC.a_mageguild_teacher_MElf',7.00,22.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31971,31971,'Otillo',0,'Magister',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31972,31972,'Atraxia',0,'Magister',0,'NPC.a_mageguild_teacher_FElf',7.00,21.20,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31973,31973,'Raheel',0,'Spellbook Seller',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31974,31974,'Drizzit',0,'Grand Master',0,'NPC.a_guild_master_MDarkElf',8.00,23.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31975,31975,'Aerina',0,'Master',0,'NPC.a_fighterguild_teacher_MDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31976,31976,'Talia',0,'Magister',0,'NPC.a_mageguild_teacher_FDarkElf',8.00,23.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31977,31977,'Shaka',0,'High Prefect ',0,'NPC.e_patriarch_MOrc',8.00,26.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31978,31978,'Tazeer',0,'Prefect',0,'NPC.e_fighterguild_teacher_MOrc',9.50,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31979,31979,'Moira',0,'Seer',0,'NPC.e_clergyman_FOrc',9.50,29.00,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31980,31980,'Rumba',0,'Amulet Seller',0,'NPC.e_clergyman_FOrc',9.50,29.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31981,31981,'Vishotsky',0,'Captain',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31982,31982,'Glen',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31983,31983,'Friggar',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31984,31984,'Sherring',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31985,31985,'Kosmos',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31986,31986,'Erstack',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31987,31987,'Gotter',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31988,31988,'Singa',0,'Guard',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,80,'male','L2Guard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31989,31989,'Batidae',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',8.00,23.00,70,'male','L2Fisherman',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31990,31990,'Siger',0,'Blacksmith',0,'NPC.a_smith_MDwarf',7.00,16.50,70,'male','L2Trainer',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31991,31991,'Adventure Guildsman',0,'',0,'NPC.e_collector_teacher_FDwarf',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31992,31992,'Adventure Guildsman',0,'',0,'NPC.a_fighterguild_teacher_FHuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31993,31993,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MDwarf',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31994,31994,'Adventure Guildsman',0,'',0,'NPC.e_common_people_MOrc',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31995,31995,'Adventure Guildsman',0,'',0,'NPC.a_common_peopleA_MHuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31996,31996,'Javier',0,'Grand Magister',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31997,31997,'Priest of Dawn',0,'',0,'NPC.priest_of_dawn',9.50,29.00,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5802,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31998,31998,'Dusk Priestess',0,'',0,'NPC.priest_of_dusk',8.00,22.00,70,'male','L2SignsPriest',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,5801,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(31999,31999,'Preacher of Doom',0,'',0,'Monster.dark_horror',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32000,32000,'Preacher of Doom',0,'',0,'Monster.dark_horror',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(32001,32001,'Preacher of Doom',0,'',0,'Monster.dark_horror',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32002,32002,'Preacher of Doom',0,'',0,'Monster.dark_horror',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32003,32003,'Orator of Revelations',0,'',0,'Monster.liviona',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32004,32004,'Orator of Revelations',0,'',0,'Monster.liviona',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32005,32005,'Orator of Revelations',0,'',0,'Monster.liviona',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32006,32006,'Orator of Revelations',0,'',0,'Monster.liviona',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32007,32007,'Galba',0,'Fishing Guild Member',0,'NPC.a_fisherA_Mhuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32008,32008,'Gremory',0,'Priest',0,'NPC.a_temple_master_Mhuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32009,32009,'Devorin',0,'Nurse',0,'NPC.e_common_people_FDwarf',9.50,16.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32010,32010,'Flauron',0,'Priest',0,'NPC.a_temple_master_Mhuman',9.50,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32011,32011,'Imperial Tomb Guide',0,'',0,'NPC.a_tombkeeperA',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32012,32012,'Tantan',0,'Retired Adventurer',0,'NPC2.a_old_people_Mhuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32013,32013,'Suki',0,'Wild Maiden',0,'NPC.a_common_peopleB_FHuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32014,32014,'Ivan ',0,'Runaway Youth',0,'NPC.a_traderD_Mhuman',8.00,25.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32015,32015,'Scout''s Corpse',0,'',0,'NPC.e_guard_MDwarf_death',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32016,32016,'Torrant',0,'Beacon Tower Manager',0,'NPC.e_guard_MOrc',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32017,32017,'Karuda',0,'',0,'NPC.e_guard_MOrc',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32018,32018,'Misa',0,'',0,'NPC.a_maidB_FHuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32019,32019,'Suspicious Man',0,'',0,'NPC.a_sanctuary_teacher_MHuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32020,32020,'Rafforty',0,'',0,'NPC.a_common_peopleC_Mhuman',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32021,32021,'Ice Sculpture',0,'',0,'NpcEV.ice_sculpture_c',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32022,32022,'Kierre',0,'',0,'NpcEV.ice_sculpture_b',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32023,32023,'Ice Shelf',0,'',0,'NpcEV.ice_shelf',35.00,14.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32024,32024,'Mulia',0,'Clan Trader',0,'NPC.e_smith_master_MDwarf',9.50,16.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32025,32025,'Ilia',0,'Clan Trader',0,'NPC.e_smith_Fdwarf',9.50,17.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32026,32026,'Hestui Guard',0,'',0,'NPC.e_fighterguild_teacher_MOrc',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32027,32027,'Holy Brazier',0,'',0,'NpcEV.grail_brazier_b',9.50,29.00,78,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32028,32028,'Holy Grail',0,'',0,'NpcEV.holy_grail',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32029,32029,'Freya''s Steward',0,'',0,'NPC.a_common_people_MElf',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32030,32030,'Garden Sculpture',0,'',0,'NpcEV.ice_sculpture_c',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32031,32031,'Ice Fairy Sculpture',0,'',0,'NpcEV.ice_sculpture_b',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32032,32032,'Strange Machine',0,'',0,'NpcEV.strange_mechanical_instrument',9.50,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(32033,32033,'Doctor Chaos',0,'',0,'NPC2.doctor_chaos',9.50,14.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(32034,32034,'Temple Gatekeeper',0,'',0,'NpcEV.heretical_sanctuary_gatekeeper_a',80.00,182.50,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32035,32035,'Temple Gatekeeper',0,'',0,'NpcEV.heretical_sanctuary_openner_a',28.00,70.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32036,32036,'Temple Gatekeeper',0,'',0,'NpcEV.heretical_sanctuary_gatekeeper_b',80.00,203.50,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32037,32037,'Temple Gatekeeper',0,'',0,'NpcEV.heretical_sanctuary_openner_b',28.00,70.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32038,32038,'Ritual Offering',0,'',0,'NPC.a_traderA_Mhuman_deco',9.50,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32039,32039,'Triol''s Mirror',0,'',0,'NpcEV.heretical_devil_mirror',9.50,70.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32040,32040,'Triol''s Mirror',0,'',0,'NpcEV.heretical_devil_mirror',9.50,70.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32041,32041,'Yumi',0,'Collector',0,'NPC.e_collector_teacher_FDwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32042,32042,'Weathermaster',0,'',0,'NpcEV.pavel_weather_controller',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32043,32043,'Weathermaster',0,'',0,'NpcEV.pavel_weather_controller',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32044,32044,'Weathermaster',0,'',0,'Monster3.Evilate_weather',9.50,29.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32045,32045,'Doctor Chaos'' Secret Bookshelf',0,'',0,'Monster3.Evilate_doc_chaos',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32046,32046,'Suspicious-Looking Pile of Stones',0,'',0,'Monster.susceptor_env',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32047,32047,'Wendy',0,'',0,'NPC.e_teleporter_FDwarf',10.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32048,32048,'Event Gatekeeper',0,'',0,'Monster.cutie_cat',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32049,32049,'Rooney',0,'Blacksmith of Wind',0,'NPC.a_smith_MDwarf',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32050,32050,'Parts Box',0,'',0,'NPC.box',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32051,32051,'Altar Gatekeeper',0,'',0,'NpcEV.trioll_altar',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32052,32052,'Obi',0,'Railroad Worker',0,'NPC.e_mine_teacher_MDwarf',8.00,18.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32053,32053,'Abey',0,'Railroad Worker',0,'NPC.e_mine_teacher_FDwarf',8.00,18.50,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32054,32054,'Ghost of a Railroad Engineer',0,'',0,'Monster.dwarf_ghost',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32055,32055,'Ghost of an Ancient Railroad Engineer',0,'',0,'Monster.dwarf_ghost',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32056,32056,'Aren',0,'Khavatari ',0,'NPC.e_mageguild_teacher_FOrc',10.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32057,32057,'Totem Spirit of Gandi',0,'',0,'Monster.onyx_beast',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32058,32058,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32059,32059,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32060,32060,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32061,32061,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32062,32062,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32063,32063,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32064,32064,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32065,32065,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32066,32066,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32067,32067,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32068,32068,'Triol''s Revelation',0,'',0,'NpcEV.trioll_altar',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32069,32069,'Gutenhagen',0,'Collector',0,'NPC.e_guard_MDwarf',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32070,32070,'Adolph',0,'',0,'NPC2.a_child_people_Mhuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32071,32071,'Linda',0,'',0,'NPC2.a_child_people_Fhuman',10.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32072,32072,'Edwin',0,'',0,'NPC2.a_old_people_Mhuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32073,32073,'Old Female Drifter',0,'',0,'NPC2.a_old_people_Fhuman',10.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32074,32074,'Gludio Territory Manager',0,'Guild President',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32075,32075,'Sandy the Cat',0,'Tournament Helper',0,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,52,132,NULL,0,0,0,'LAST_HIT'),
	(32076,32076,'Box',0,'',0,'NPC.box',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32077,32077,'Ice Sculpture',0,'',0,'NpcEV.ice_sculpture_c',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32078,32078,'Ice Sculpture',0,'',0,'NpcEV.ice_sculpture_c',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32079,32079,'Ice Sculpture',0,'',0,'NpcEV.ice_sculpture_c',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32082,32082,'Dion Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32083,32083,'Giran Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32084,32084,'Oren Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32085,32085,'Aden Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32086,32086,'Innadril Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32087,32087,'Schuttgart Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32088,32088,'Goddard Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32089,32089,'Rune Territory Manager',0,'Adventure Guildsman',0,'NPC.a_mageguild_teacher_MHuman',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32090,32090,'Dead Leopard''s Carcass',0,'',0,'Monster.onyx_beast_ns',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32091,32091,'Omega''s Cat',0,'Event Manager',0,'Monster.cutie_cat',10.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32092,32092,'Alder',0,'Warehouse Chief',0,'NPC.e_warehouse_master_MDwarf',8.00,17.50,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32093,32093,'Bolin',0,'Head Blacksmith',0,'NPC.e_common_people_MDwarf',8.00,17.00,70,'male','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32094,32094,'Schule',0,'Grand Master',0,'NPC.a_fighterguild_master_FHuman',8.00,21.50,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32095,32095,'Marie',0,'High Priest',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,193,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32096,32096,'Helminter',0,'Grand Master',0,'NPC.a_fighterguild_teacher_FDarkElf',8.00,23.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32097,32097,'Finker',0,'High Prefect',0,'NPC.e_trader_FOrc',8.00,24.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32098,32098,'Celes',0,'Grand Magister',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2VillageMaster',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32099,32099,'Tony the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32100,32100,'Tony the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32101,32101,'Tony the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32102,32102,'Tony the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32103,32103,'Telling the Cat',0,'Event Manager',0,'Monster.cutie_cat',8.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32104,32104,'Vervato',0,'',0,'Monster3.Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32105,32105,'Dinn',0,'',0,'NPC.a_traderC_Mhuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32106,32106,'Singsing',0,'',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Merchant',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32107,32107,'Teleport Cube',0,'',0,'NPC.teleport_npc',40.00,80.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32108,32108,'',0,'',0,'NPC2.rhamphorhynchus_npc',1.00,30.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32109,32109,'Shilen''s Stone Statue',0,'',0,'NpcEV.primeval_raid_teleporter',24.00,72.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32110,32110,'',0,'',0,'NPC.clear_npc',0.10,0.10,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32111,32111,'Orahochin',0,'',0,'Monster3.Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32112,32112,'Gariachin',0,'',0,'Monster3.Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32113,32113,'Marquez',0,'',0,'NPC.a_wharfinger_MHuman',8.00,23.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32114,32114,'Mushika',0,'',0,'Monster3.Crokian_Elder',25.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32115,32115,'Asamah',0,'',0,'Monster3.Crokian_Vice_Elder',45.00,41.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32116,32116,'Kirikachin',0,'',0,'Monster3.Crokian_Vice_Elder',45.00,41.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32117,32117,'Karakawei',0,'',0,'Monster3.Crokian_Sorcerer',25.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32118,32118,'Mantarasa Egg',0,'',0,'NpcEV.dinosaur_nest',43.00,33.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,0,0,NULL,0,0,0,'LAST_HIT'),
	(32119,32119,'Ulu Kaimu',0,'',0,'Monster3.Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32120,32120,'Balu Kaimu',0,'',0,'Monster3.Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32121,32121,'Chuta Kaimu',0,'',0,'Monster3.Evilate_doc_chaos',25.00,33.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32122,32122,'Warrior''s Grave',0,'',0,'Monster3.Evilate_weather',16.00,18.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32123,32123,'Valakas',0,'',0,'Monster3.valakas_f',190.00,335.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32124,32124,'Great Soul',0,'',0,'NPC2.Soul_Collector_Npc',14.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32125,32125,'Great Soul',0,'',0,'NPC2.Soul_Collector_Npc',14.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32126,32126,'Priest Guard',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32127,32127,'Priest Guard',0,'',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32128,32128,'Guardian Wizard of the Cloth',0,'',0,'NPC.a_traderB_FHuman',8.00,25.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32129,32129,'',0,'',0,'NPC2.valakas_f_dummy',5.00,10.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32130,32130,'Looney the Cat',0,'Event Manager',0,'Monster3.king_of_cat',6.00,16.01,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32131,32131,'Bonny',0,'Event Manager',0,'NPC.e_smith_Fdwarf',8.00,17.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(32132,32132,'Alchemist''s Servitor',0,'',0,'NPC.training_doll_150p',13.00,40.00,70,'etc','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT');

INSERT INTO `npc` (`id`,`idTemplate`,`name`,`serverSideName`,`title`,`serverSideTitle`,`class`,`collision_radius`,`collision_height`,`level`,`sex`,`type`,`attackrange`,`hp`,`mp`,`hpreg`,`mpreg`,`str`,`con`,`dex`,`int`,`wit`,`men`,`exp`,`sp`,`patk`,`pdef`,`matk`,`mdef`,`atkspd`,`aggro`,`matkspd`,`rhand`,`lhand`,`armor`,`walkspd`,`runspd`,`faction_id`,`faction_range`,`isUndead`,`absorb_level`,`absorb_type`) VALUES
	(35010,35010,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',40,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,683,287,546,233,416,0,333,128,628,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35011,35011,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',80,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,798,287,546,233,357,0,333,93,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35012,35012,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',1100,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,889,244,546,233,322,0,333,280,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35013,35013,'Mercenary',0,'',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,50,'female','L2SiegeGuard',40,2317,1245,3.32,3.30,40,43,30,21,20,10,250,1,683,317,546,233,416,0,333,316,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35014,35014,'Mercenary',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,50,'male','L2SiegeGuard',40,2317,1245,3.32,3.30,40,43,30,21,20,10,250,1,683,317,546,233,416,0,333,179,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35015,35015,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',40,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,683,287,546,233,416,0,333,128,628,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35016,35016,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',80,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,798,287,546,233,357,0,333,93,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35017,35017,'Mercenary',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,50,'male','L2SiegeGuard',1100,2317,830,3.32,2.14,40,43,30,21,20,10,250,1,889,244,546,233,322,0,333,280,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35018,35018,'Mercenary',0,'',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,50,'female','L2SiegeGuard',40,2317,1245,3.32,3.30,40,43,30,21,20,10,250,1,683,317,546,233,416,0,333,316,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35019,35019,'Mercenary',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,50,'male','L2SiegeGuard',40,2317,1245,3.32,3.30,40,43,30,21,20,10,250,1,683,317,546,233,416,0,333,179,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35020,35020,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',40,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,1763,485,1610,394,416,0,333,150,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35021,35021,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',80,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,2058,485,1610,394,357,0,333,97,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35022,35022,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',1100,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,2292,412,1610,394,322,0,333,288,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35023,35023,'Mercenary of Dawn',0,'',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2SiegeGuard',40,3986,2240,4.27,4.26,40,43,30,21,20,10,490,1,1763,536,1610,394,416,0,333,325,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35024,35024,'Mercenary of Dawn',0,'',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2SiegeGuard',40,3986,2240,4.27,4.26,40,43,30,21,20,10,490,1,1763,536,1610,394,416,0,333,196,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35025,35025,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',40,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,1763,485,1610,394,416,0,333,150,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35026,35026,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',80,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,2058,485,1610,394,357,0,333,97,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35027,35027,'Mercenary of Dawn',0,'',0,'NPC.a_fighterguild_master_Mhuman',8.00,23.50,70,'male','L2SiegeGuard',1100,3986,1493,4.27,2.78,40,43,30,21,20,10,490,1,2292,412,1610,394,322,0,333,288,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35028,35028,'Mercenary of Dawn',0,'',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,70,'female','L2SiegeGuard',40,3986,2240,4.27,4.26,40,43,30,21,20,10,490,1,1763,536,1610,394,416,0,333,325,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35029,35029,'Mercenary of Dawn',0,'',0,'NPC.a_mageguild_master_MHuman',8.00,24.00,70,'male','L2SiegeGuard',40,3986,2240,4.27,4.26,40,43,30,21,20,10,490,1,1763,536,1610,394,416,0,333,196,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35030,35030,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1154,380,988,309,416,0,333,132,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35031,35031,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,60,'male','L2SiegeGuard',80,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1347,380,988,309,357,0,333,301,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35032,35032,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,60,'male','L2SiegeGuard',1100,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1501,323,988,309,322,0,333,280,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35033,35033,'Elite Mercenary Guild Member',0,'',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,60,'female','L2SiegeGuard',40,3153,1726,3.79,3.74,40,43,30,21,20,10,360,1,1154,420,988,309,416,0,333,316,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35034,35034,'Elite Mercenary Guild Member',0,'',0,'NPC.a_patriarch_MElf',8.00,22.50,60,'male','L2SiegeGuard',40,3153,1726,3.79,3.74,40,43,30,21,20,10,360,1,1154,420,988,309,416,0,333,325,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35035,35035,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1154,380,988,309,416,0,333,132,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35036,35036,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,60,'male','L2SiegeGuard',80,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1347,380,988,309,357,0,333,301,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35037,35037,'Elite Mercenary Guild Member',0,'',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,60,'male','L2SiegeGuard',1100,3153,1150,3.79,2.45,40,43,30,21,20,10,360,1,1501,323,988,309,322,0,333,280,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35038,35038,'Elite Mercenary Guild Member',0,'',0,'NPC.a_sanctuary_teacher_FHuman',8.00,22.50,60,'female','L2SiegeGuard',40,3153,1726,3.79,3.74,40,43,30,21,20,10,360,1,1154,420,988,309,416,0,333,316,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35039,35039,'Elite Mercenary Guild Member',0,'',0,'NPC.a_patriarch_MElf',8.00,22.50,60,'male','L2SiegeGuard',40,3153,1726,3.79,3.74,40,43,30,21,20,10,360,1,1154,420,988,309,416,0,333,325,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35040,35040,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',40,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,899,332,744,270,416,0,333,66,20,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35041,35041,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',80,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,1050,332,744,270,357,0,333,16,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35042,35042,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',1100,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,1169,282,744,270,322,0,333,274,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35043,35043,'Greater Recruit',0,'',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,55,'female','L2SiegeGuard',40,2728,1481,3.79,3.74,40,43,30,21,20,10,302,1,899,367,744,270,416,0,333,7,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35044,35044,'Greater Recruit',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,55,'male','L2SiegeGuard',40,2728,1481,3.79,3.74,40,43,30,21,20,10,302,1,899,367,744,270,416,0,333,154,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35045,35045,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',40,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,899,332,744,270,416,0,333,66,20,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35046,35046,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',80,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,1050,332,744,270,357,0,333,16,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35047,35047,'Greater Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,55,'male','L2SiegeGuard',1100,2728,987,3.79,2.45,40,43,30,21,20,10,302,1,1169,282,744,270,322,0,333,274,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35048,35048,'Greater Recruit',0,'',0,'NPC.a_mageguild_teacher_FHuman',8.00,23.50,55,'female','L2SiegeGuard',40,2728,1481,3.79,3.74,40,43,30,21,20,10,302,1,899,367,744,270,416,0,333,7,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35049,35049,'Greater Recruit',0,'',0,'NPC.a_mageguild_teacher_MHuman',8.00,23.00,55,'male','L2SiegeGuard',40,2728,1481,3.79,3.74,40,43,30,21,20,10,302,1,899,367,744,270,416,0,333,154,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35050,35050,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',40,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,506,245,390,199,416,0,333,66,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35051,35051,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',80,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,591,245,390,199,357,0,333,16,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35052,35052,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',1100,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,658,209,390,199,322,0,333,14,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35053,35053,'Recruit',0,'',0,'NPC.a_traderB_FHuman',8.00,24.50,45,'female','L2SiegeGuard',40,1930,1016,3.32,3.30,40,43,30,21,20,10,202,1,506,271,390,199,416,0,333,6,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35054,35054,'Recruit',0,'',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,45,'male','L2SiegeGuard',40,1930,1016,3.32,3.30,40,43,30,21,20,10,202,1,506,271,390,199,416,0,333,99,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35055,35055,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',40,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,506,245,390,199,416,0,333,66,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35056,35056,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',80,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,591,245,390,199,357,0,333,16,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35057,35057,'Recruit',0,'',0,'NPC.a_guard_MHuman',8.00,24.00,45,'male','L2SiegeGuard',1100,1930,677,3.32,2.14,40,43,30,21,20,10,202,1,658,209,390,199,322,0,333,14,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35058,35058,'Recruit',0,'',0,'NPC.a_traderB_FHuman',8.00,24.50,45,'female','L2SiegeGuard',40,1930,1016,3.32,3.30,40,43,30,21,20,10,202,1,506,271,390,199,416,0,333,6,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35059,35059,'Recruit',0,'',0,'NPC.a_sanctuary_teacher_MHuman',8.00,23.00,45,'male','L2SiegeGuard',40,1930,1016,3.32,3.30,40,43,30,21,20,10,202,1,506,271,390,199,416,0,333,99,0,0,55,214,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35060,35060,'Nephilim Mercenary',0,'',0,'Monster3.Kight_of_Dawn',10.00,41.50,75,'male','L2Npc',40,189460,855,641.88,2.35,84,71,73,76,70,80,562,1,5261,1047,3228,425,526,0,3819,0,0,0,105,315,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35061,35061,'Nephilim Mercenary',0,'',0,'Monster3.Elite_Mage',23.00,40.50,72,'male','L2Npc',40,185726,800,640.80,2.35,84,71,73,76,70,80,518,1,4792,983,2909,399,613,0,3819,7,0,0,81,315,'mercenary_siege_clan',1200,1,0,'LAST_HIT'),
	(35062,35062,'Headquarters',0,'',0,'Deco.flag_a',21.00,82.00,1,'etc','L2Npc',40,158000,989,3.16,0.91,40,43,30,21,20,10,0,0,652,753,358,295,423,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35063,35063,'Gludio Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35064,35064,'Baron Lewin Waldner',0,'',0,'NPC.a_lord_MHuman',7.00,23.00,65,'male','L2SiegeGuard',40,55449,3958,11.85,2.78,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,333,79,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35065,35065,'Cronenberg',0,'Sir',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35066,35066,'Royal Knight',0,'Gludio',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35067,35067,'Court Sorcerer',0,'Gludio',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35068,35068,'Court Sorcerer',0,'Gludio',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35069,35069,'Court Guard',0,'Gludio',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35070,35070,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35071,35071,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35072,35072,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35073,35073,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35074,35074,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35075,35075,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35076,35076,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35077,35077,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35078,35078,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35079,35079,'Royal Knight',0,'Gludio',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35080,35080,'Court Sorcerer',0,'Gludio',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35081,35081,'Court Sorcerer',0,'Gludio',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35082,35082,'Court Guard',0,'Gludio',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35083,35083,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,93,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35084,35084,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35085,35085,'Guard',0,'Gludio',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35086,35086,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35087,35087,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35088,35088,'Guard',0,'Gludio',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35089,35089,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35090,35090,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35091,35091,'Guard',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'gludio_siege_clan',1200,1,0,'LAST_HIT'),
	(35092,35092,'Gatekeeper',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,0,0,706,331,382,269,278,0,333,0,0,0,55,0,'gludio_siege_clan',600,1,0,'LAST_HIT'),
	(35093,35093,'Gatekeeper',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,0,0,706,331,382,269,278,0,333,0,0,0,55,0,'gludio_siege_clan',600,1,0,'LAST_HIT'),
	(35094,35094,'Gatekeeper',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,0,0,706,331,382,269,278,0,333,0,0,0,55,0,'gludio_siege_clan',600,1,0,'LAST_HIT'),
	(35095,35095,'Mass Gatekeeper',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35096,35096,'Outer Doorman',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35097,35097,'Inner Doorman',0,'Gludio',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35098,35098,'Blacksmith',0,'Gludio',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',80,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35099,35099,'Warehouse Keeper',0,'Gludio',0,'NPC.a_warehouse_keeper_MDwarf',20.00,31.00,70,'male','L2CastleWarehouse',80,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35100,35100,'Sayres',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35101,35101,'Grad',0,'Wyvern Manager',0,'NPC.a_traderB_MHuman',20.00,31.00,70,'male','L2WyvernManager',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35102,35102,'Greenspan',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35103,35103,'Manor Manager',0,'Gludio',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35104,35104,'Tyron',0,'Sir',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35105,35105,'Dion Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35106,35106,'Duke Byron Ashton',0,'',0,'NPC.a_lord_MHuman',7.00,23.00,65,'male','L2SiegeGuard',40,55449,3958,11.85,2.78,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,333,79,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35107,35107,'Ivano',0,'Sir',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35108,35108,'Royal Knight',0,'Dion',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35109,35109,'Court Sorcerer',0,'Dion',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35110,35110,'Court Sorcerer',0,'Dion',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35111,35111,'Court Guard',0,'Dion',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35112,35112,'Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35113,35113,'Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35114,35114,'Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35115,35115,'Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35116,35116,'Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35117,35117,'Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35118,35118,'Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35119,35119,'Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35120,35120,'Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35121,35121,'Royal Knight',0,'Dion',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35122,35122,'Court Sorcerer',0,'Dion',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35123,35123,'Court Sorcerer',0,'Dion',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35124,35124,'Court Guard',0,'Dion',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35125,35125,'Court Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,93,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35126,35126,'Court Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35127,35127,'Court Guard',0,'Dion',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35128,35128,'Court Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35129,35129,'Court Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35130,35130,'Court Guard',0,'Dion',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35131,35131,'Court Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35132,35132,'Court Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35133,35133,'Court Guard',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'dion_siege_clan',1200,1,0,'LAST_HIT'),
	(35134,35134,'Gatekeeper',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35135,35135,'Gatekeeper',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35136,35136,'Gatekeeper',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35137,35137,'Mass Gatekeeper',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeGuard',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35138,35138,'Outer Doorman',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35139,35139,'Inner Doorman',0,'Dion',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35140,35140,'Blacksmith',0,'Dion',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',80,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35141,35141,'Warehouse Keeper',0,'Dion',0,'NPC.a_warehouse_keeper_MDwarf',20.00,31.00,70,'male','L2CastleWarehouse',80,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35142,35142,'Crosby',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35143,35143,'Hodler',0,'Wyvern Manager',0,'NPC.a_traderB_MHuman',20.00,31.00,70,'male','L2WyvernManager',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35144,35144,'Mercenary Manager Sanford',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35145,35145,'Manor Manager',0,'Dion',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35146,35146,'Gibbson',0,'Herald',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35147,35147,'Giran Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35148,35148,'Baron Carmon Esthus',0,'',0,'NPC.a_lord_MHuman',7.00,23.00,65,'male','L2SiegeGuard',40,55449,3958,11.85,2.78,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,333,79,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35149,35149,'Ulric',0,'Sir',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35150,35150,'Royal Knight',0,'Giran',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35151,35151,'Court Sorcerer',0,'Giran',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35152,35152,'Court Sorcerer',0,'Giran',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35153,35153,'Court Guard',0,'Giran',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35154,35154,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35155,35155,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35156,35156,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35157,35157,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35158,35158,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35159,35159,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35160,35160,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35161,35161,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35162,35162,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35163,35163,'Royal Knight',0,'Giran',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35164,35164,'Court Sorcerer',0,'Giran',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35165,35165,'Court Sorcerer',0,'Giran',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35166,35166,'Court Guard',0,'Giran',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35167,35167,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,93,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35168,35168,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35169,35169,'Guard',0,'Giran',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35170,35170,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35171,35171,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,2,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35172,35172,'Guard',0,'Giran',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35173,35173,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35174,35174,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35175,35175,'Guard',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35176,35176,'Gatekeeper',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'giran_siege_clan',600,1,0,'LAST_HIT'),
	(35177,35177,'Gatekeeper',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'giran_siege_clan',600,1,0,'LAST_HIT'),
	(35178,35178,'Gatekeeper',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'giran_siege_clan',600,1,0,'LAST_HIT'),
	(35179,35179,'Mass Gatekeeper',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Teleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35180,35180,'Outer Doorman',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35181,35181,'Inner Doorman',0,'Giran',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35182,35182,'Blacksmith',0,'Giran',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,88,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35183,35183,'Warehouse Keeper',0,'Giran',0,'NPC.a_warehouse_keeper_MDwarf',8.00,23.50,70,'male','L2CastleWarehouse',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,88,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35184,35184,'Saul',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35185,35185,'Bryce',0,'Wyvern Manager',0,'NPC.a_traderB_MHuman',7.00,25.00,70,'female','L2WyvernManager',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,88,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35186,35186,'Arvid',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35187,35187,'Manor Manager',0,'Giran',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35188,35188,'Holmes',0,'Sir',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35189,35189,'Oren Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35190,35190,'Balthus Van Dyke',0,'Duke',0,'NPC.a_lord_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,88,132,'giran_siege_clan',1200,1,0,'LAST_HIT'),
	(35191,35191,'Quant',0,'Sir',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35192,35192,'Royal Knight',0,'Oren',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35193,35193,'Court Sorcerer',0,'Oren',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35194,35194,'Court Sorcerer',0,'Oren',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35195,35195,'Court Guard',0,'Oren',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35196,35196,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35197,35197,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,8.69,2.14,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35198,35198,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35199,35199,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35200,35200,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,8.69,2.14,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35201,35201,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,8.69,2.14,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35202,35202,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35203,35203,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,8.69,2.14,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35204,35204,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35205,35205,'Royal Knight',0,'Oren',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35206,35206,'Court Sorcerer',0,'Oren',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,8.69,2.14,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35207,35207,'Court Sorcerer',0,'Oren',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,8.69,2.14,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35208,35208,'Court Guard',0,'Oren',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35209,35209,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,93,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35210,35210,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,33,154,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35211,35211,'Guard',0,'Oren',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35212,35212,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,11.85,2.78,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35213,35213,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35214,35214,'Guard',0,'Oren',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35215,35215,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35216,35216,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35217,35217,'Guard',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35218,35218,'Gatekeeper',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'oren_siege_clan',600,1,0,'LAST_HIT'),
	(35219,35219,'Gatekeeper',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'oren_siege_clan',600,1,0,'LAST_HIT'),
	(35220,35220,'Gatekeeper',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'oren_siege_clan',600,1,0,'LAST_HIT'),
	(35221,35221,'Mass Gatekeeper',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35222,35222,'Outer Doorman',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35223,35223,'Inner Doorman',0,'Oren',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35224,35224,'Blacksmith',0,'Oren',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35225,35225,'Warehouse Keeper',0,'Oren',0,'NPC.a_warehouse_keeper_MDwarf',20.00,31.00,70,'male','L2CastleWarehouse',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35226,35226,'Brasseur',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35227,35227,'Finrod',0,'Wyvern Manager',0,'NPC.a_trader_MElf',20.00,31.00,99,'male','L2WyvernManager',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35228,35228,'Morrison',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35229,35229,'Manor Manager',0,'Oren',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35230,35230,'Manor Manager',0,'Oren',0,'NPC.a_trader_MElf',6.00,24.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35231,35231,'Manor Manager',0,'Oren',0,'NPC.a_common_people_MDarkElf',7.00,23.00,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35232,35232,'Sherwood',0,'Messenger',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35233,35233,'Aden Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,721,213,3.95,1.21,40,43,30,21,20,10,40,10,57,189,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35234,35234,'Amadeo Cadmus',0,'King',0,'NPC.a_lord_MHuman',7.00,23.00,75,'male','L2SiegeGuard',40,84582,6694,13.43,3.09,40,43,30,21,20,10,562,1,9383,523,957,425,278,0,333,80,0,0,55,132,'oren_siege_clan',1200,1,0,'LAST_HIT'),
	(35235,35235,'Royal Knight',0,'Aden',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2SiegeGuard',40,38622,5975,11.85,2.78,40,43,30,21,20,10,490,1,3943,470,780,382,278,0,333,76,2497,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35236,35236,'Court Sorcerer',0,'Aden',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,68,'male','L2SiegeGuard',40,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,333,325,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35237,35237,'Court Sorcerer',0,'Aden',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,68,'male','L2SiegeGuard',40,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,333,193,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35238,35238,'Court Guard',0,'Aden',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,68,'male','L2SiegeGuard',80,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,237,0,333,1376,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35239,35239,'Guard',0,'Aden',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,66,'male','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,300,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35240,35240,'Guard',0,'Aden',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,66,'male','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,132,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35241,35241,'Guard',0,'Aden',0,'NPC.a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,14,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35242,35242,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,16,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35243,35243,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,2,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35244,35244,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,14,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35245,35245,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,16,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35246,35246,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,2,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35247,35247,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,14,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35248,35248,'Royal Knight',0,'Aden',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,70,'male','L2SiegeGuard',40,38622,5975,11.85,2.78,40,43,30,21,20,10,490,1,3943,470,780,382,278,0,333,76,2497,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35249,35249,'Court Sorcerer',0,'Aden',0,'NPC.a_patriarch_MElf',8.00,22.50,68,'male','L2SiegeGuard',40,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,333,325,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35250,35250,'Court Sorcerer',0,'Aden',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,68,'female','L2SiegeGuard',40,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,278,0,333,193,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35251,35251,'Court Guard',0,'Aden',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,68,'male','L2SiegeGuard',80,37063,5693,11.85,2.78,40,43,30,21,20,10,462,1,3652,449,713,365,237,0,333,300,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35252,35252,'Guard',0,'Aden',0,'NPC.a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,16,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35253,35253,'Guard',0,'Aden',0,'NPC.a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,2,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35254,35254,'Guard',0,'Aden',0,'NPC.a_guard_MElf',8.00,23.50,66,'male','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,285,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35255,35255,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,16,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35256,35256,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,2,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35257,35257,'Guard',0,'Aden',0,'NPC.a_guard_FDarkelf',7.00,25.00,66,'female','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,14,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35258,35258,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',80,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,237,0,333,16,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35259,35259,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',40,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,3369,428,649,348,278,0,333,2,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35260,35260,'Guard',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,66,'male','L2SiegeGuard',1100,35465,5415,11.85,2.78,40,43,30,21,20,10,435,1,7486,428,649,348,249,0,333,14,0,0,55,132,'aden_siege_clan',1200,1,0,'LAST_HIT'),
	(35261,35261,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35262,35262,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35263,35263,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35264,35264,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35265,35265,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35266,35266,'Mass Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35267,35267,'Outer Doorman',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35268,35268,'Inner Doorman',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35269,35269,'Hall Doorman',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35270,35270,'Inner Doorman',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35271,35271,'Gatekeeper',0,'Aden',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35272,35272,'Blacksmith',0,'Aden',0,'NPC.a_smith_MDwarf',8.00,17.00,99,'male','L2CastleBlacksmith',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35273,35273,'Warehouse Keeper',0,'Aden',0,'NPC.a_warehouse_keeper_MDwarf',20.00,31.00,70,'male','L2CastleWarehouse',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35274,35274,'Logan',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35275,35275,'Kruger',0,'Wyvern Manager',0,'NPC.a_fighterguild_teacher_MHuman',20.00,31.00,70,'male','L2WyvernManager',80,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35276,35276,'Eldon',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35277,35277,'Manor Manager',0,'Aden',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35278,35278,'Messenger Ruford',0,'Messenger',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,135,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35279,35279,'Innadril Holy Artifact',0,'',0,'NPC.castle_kent_statue_jewel',25.00,98.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35280,35280,'Baron Lionel Hunter',0,'',0,'NPC.a_lord_MHuman',7.00,23.00,65,'male','L2SiegeGuard',40,55449,3958,11.85,2.78,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,333,79,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35281,35281,'Schaht',0,'Sir',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35282,35282,'Royal Knight',0,'Innadril',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35283,35283,'Court Sorcerer',0,'Innadril',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35284,35284,'Court Sorcerer',0,'Innadril',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35285,35285,'Court Guard',0,'Innadril',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35286,35286,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35287,35287,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35288,35288,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35289,35289,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35290,35290,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35291,35291,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35292,35292,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35293,35293,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35294,35294,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35295,35295,'Royal Knight',0,'Innadril',0,'NPC.a_royal_guardA_MHuman',7.00,24.00,60,'male','L2SiegeGuard',40,24436,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35296,35296,'Court Sorcerer',0,'Innadril',0,'NPC.a_patriarch_MElf',8.00,22.50,58,'male','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,325,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35297,35297,'Court Sorcerer',0,'Innadril',0,'NPC.a_mageguild_master_FHuman',8.00,23.00,58,'female','L2SiegeGuard',40,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35298,35298,'Court Guard',0,'Innadril',0,'NPC.a_royal_guardB_MHuman',7.00,24.00,58,'male','L2SiegeGuard',80,23114,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35299,35299,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,93,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35300,35300,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2499,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35301,35301,'Guard',0,'Innadril',0,'NPC.a_guard_MElf',8.00,23.50,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,276,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35302,35302,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35303,35303,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35304,35304,'Guard',0,'Innadril',0,'NPC.a_guard_FDarkelf',7.00,25.00,56,'female','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35305,35305,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',80,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,16,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35306,35306,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,2,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35307,35307,'Guard',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,14,0,0,55,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35308,35308,'Gatekeeper',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35309,35309,'Gatekeeper',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35310,35310,'Gatekeeper',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35311,35311,'Mass Gatekeeper',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2CastleTeleporter',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35312,35312,'Outer Doorman',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35313,35313,'Inner Doorman',0,'Innadril',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35314,35314,'Blacksmith',0,'Innadril',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,88,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35315,35315,'Warehouse Keeper',0,'Innadril',0,'NPC.a_warehouse_keeper_MDwarf',8.00,24.00,70,'male','L2CastleWarehouse',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,88,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35316,35316,'Neurath',0,'Chamberlain ',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35317,35317,'Tate',0,'Wyvern Manager',0,'NPC.a_traderB_MHuman',8.00,24.00,70,'male','L2WyvernManager',40,3633,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,88,132,'aden_siege_clan',600,1,0,'LAST_HIT'),
	(35318,35318,'Solinus',0,'Mercenary Manager',0,'NPC.a_common_peopleA_MHuman',8.00,21.50,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1335,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35319,35319,'Manor Manager',0,'Innadril',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35320,35320,'Raybell',0,'Sir',0,'NPC.a_guard_MHuman',8.00,24.00,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,470,780,382,282,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35322,35322,'Altar of Fire',0,'',0,'NPC.godad_holything',25.00,65.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35323,35323,'Altar of Water',0,'',0,'NPC.godad_holything',25.00,65.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35324,35324,'Heinz',0,'Royal Guard Captain',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,62,'male','L2SiegeGuard',40,51515,3653,11.85,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,55,132,'godad_siege_clan',1200,1,0,'LAST_HIT'),
	(35325,35325,'Duke Mora Ken Abygail',0,'',0,'NPC.a_lord_MHuman',8.00,24.00,65,'male','L2SiegeNpc',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35326,35326,'Royal Knight',0,'Goddard',0,'NPC.a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard',40,24436,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,76,2497,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35327,35327,'Court Sorcerer',0,'Goddard',0,'NPC.a_patriarch_MElf',8.00,24.00,58,'male','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,325,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35328,35328,'Court Sorcerer',0,'Goddard',0,'NPC.a_mageguild_master_FHuman',8.00,24.00,58,'female','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,193,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35329,35329,'Guard',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,58,'male','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35330,35330,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MDwarf',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,93,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35331,35331,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MDwarf',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,2499,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35332,35332,'Bodyguard',0,'Goddard',0,'NPC.a_guard_MElf',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,276,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35333,35333,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,16,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35334,35334,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,2,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35335,35335,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,14,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35336,35336,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MOrc',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,16,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35337,35337,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MOrc',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,2,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35338,35338,'Bodyguard',0,'Goddard',0,'NPC.a_guard_MHuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,14,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35339,35339,'Royal Knight',0,'Goddard',0,'NPC.a_royal_guardA_MHuman',8.00,24.00,60,'male','L2SiegeGuard',40,24436,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,76,2497,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35340,35340,'Court Sorcerer',0,'Goddard',0,'NPC.a_patriarch_MElf',8.00,24.00,58,'male','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,325,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35341,35341,'Court Sorcerer',0,'Goddard',0,'NPC.a_mageguild_master_FHuman',8.00,24.00,58,'female','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,193,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35342,35342,'Guard',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,58,'male','L2SiegeGuard',40,23114,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35343,35343,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MDwarf',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,93,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35344,35344,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MDwarf',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,2499,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35345,35345,'Bodyguard',0,'Goddard',0,'NPC.a_guard_MElf',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,276,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35346,35346,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,16,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35347,35347,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,2,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35348,35348,'Bodyguard',0,'Goddard',0,'NPC.a_guard_FDarkelf',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,14,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35349,35349,'Bodyguard',0,'Goddard',0,'NPC.e_guard_MOrc',8.00,24.00,56,'male','L2SiegeGuard',80,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,16,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35350,35350,'Bodyguard',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2SiegeGuard',40,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,2,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35351,35351,'Bodyguard',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2SiegeGuard',1100,21799,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,14,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35352,35352,'Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35353,35353,'Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35354,35354,'Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35355,35355,'Mass Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35356,35356,'Outer Doorman',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,70,'male','L2Doormen',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35357,35357,'Inner Doorman',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,70,'male','L2Doormen',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35358,35358,'Inner Doorman',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,70,'male','L2Doormen',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35359,35359,'Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,70,'male','L2Doormen',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35360,35360,'Gatekeeper',0,'Goddard',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,70,'male','L2Doormen',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,55,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35361,35361,'Blacksmith',0,'Goddard',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,88,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35362,35362,'Warehouse Keeper',0,'Goddard',0,'NPC.a_warehouse_keeper_MDwarf',8.00,24.00,70,'male','L2CastleWarehouse',40,3862,1019,11.85,2.78,40,43,30,21,20,10,313,10,706,662,382,268,282,0,333,0,0,0,88,132,'godad_siege_clan',600,1,0,'LAST_HIT'),
	(35363,35363,'Alfred',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2CastleChamberlain',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35364,35364,'Hadley',0,'Wyvern Manager',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2WyvernManager',40,3862,1710,13.43,3.09,40,21,30,20,35,10,6922,761,1770,584,962,434,278,0,692,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(35365,35365,'Rowell',0,'Manager of Mercenary',0,'NPC.a_common_peopleC_Mhuman',10.00,24.00,70,'male','L2MercManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35366,35366,'Manor Manager',0,'Goddard',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35367,35367,'Daven',0,'Messenger',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,70,'male','L2SiegeNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,74,0,0,55,176,NULL,0,1,0,'LAST_HIT'),
	(35368,35368,'Bloody Lord Nurka',0,'',0,'Monster.oel_mahum',20.00,37.00,55,'male','L2Monster',40,1264000,987,63.20,2.45,40,43,30,21,20,10,1512,1,670,322,360,261,282,0,333,72,0,0,77,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35369,35369,'Partisan Healer',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,40,'male','L2Monster',40,1527,531,7.11,5.25,40,43,30,21,20,10,800,1,273,201,131,164,282,0,333,7,0,0,55,132,'partisan_clan',300,0,0,'LAST_HIT'),
	(35370,35370,'Partisan Court Guard',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,800,1,273,201,131,164,282,0,333,69,0,0,55,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35371,35371,'Partisan Court Guard',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,40,'male','L2Monster',1100,1527,531,7.11,1.84,40,43,30,21,20,10,800,1,333,201,131,164,254,0,333,14,0,0,55,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35372,35372,'Partisan Soldier',0,'',0,'Monster.ol_mahum',13.50,25.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,612,1,192,169,89,137,282,0,333,2,0,0,55,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35373,35373,'Partisan Sorcerer',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,35,'male','L2Monster',40,1220,446,7.11,1.84,40,43,30,21,20,10,612,1,192,169,89,137,282,0,333,7,0,0,55,132,'partisan_clan',300,0,0,'LAST_HIT'),
	(35374,35374,'Partisan Archer',0,'',0,'Monster.ol_mahum_archer',14.00,25.00,35,'male','L2Monster',1100,1220,446,7.11,1.84,40,43,30,21,20,10,612,1,427,169,89,137,254,0,333,14,0,0,55,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35375,35375,'Bloody Lord Nurka',0,'',0,'Monster.oel_mahum',20.00,37.00,55,'male','L2Monster',40,1264000,987,94.80,2.45,40,43,30,21,20,10,1512,1,670,322,360,261,282,0,333,72,0,0,77,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35376,35376,'Partisan Healer',0,'',0,'Monster.batur_orc_shaman',11.00,16.00,40,'male','L2Monster',40,1527,531,7.11,5.25,40,43,30,21,20,10,800,1,273,201,131,164,282,0,333,7,0,0,55,132,'partisan_clan',300,0,0,'LAST_HIT'),
	(35377,35377,'Partisan Court Guard',0,'',0,'Monster.ol_mahum_champion',14.00,27.00,40,'male','L2Monster',40,1527,531,7.11,1.84,40,43,30,21,20,10,800,1,273,201,131,164,282,0,333,69,0,0,55,121,'partisan_clan',300,0,0,'LAST_HIT'),
	(35378,35378,'Partisan Court Guard',0,'',0,'Monster.ol_mahum_archer',8.50,8.50,40,'male','L2Monster',40,594,227,7.11,1.84,40,43,30,21,20,10,882,41,65,101,25,80,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(35379,35379,'Partisan Soldier',0,'',0,'Monster.ol_mahum',8.50,8.50,35,'male','L2Monster',40,631,242,7.11,1.84,40,43,30,21,20,10,948,45,71,106,28,83,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(35380,35380,'Partisan Sorcerer',0,'',0,'Monster.batur_orc_shaman',8.50,8.50,35,'male','L2Monster',40,751,287,7.11,1.84,40,43,30,21,20,10,1143,57,91,119,37,94,278,0,333,0,0,0,55,132,NULL,0,0,0,'LAST_HIT'),
	(35381,35381,'Partisan Archer',0,'',0,'Monster.ol_mahum_archer',8.50,8.50,35,'male','L2Monster',40,840,318,7.11,1.84,40,43,30,21,20,10,1283,66,107,129,45,102,278,0,333,0,0,0,55,121,NULL,0,0,0,'LAST_HIT'),
	(35382,35382,'Brakel',0,'Partisan Herald',0,'Monster.ol_mahum_champion',14.00,27.00,70,'male','L2Npc',40,3862,1493,5.53,1.53,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,0,0,'LAST_HIT'),
	(35383,35383,'Tamutak',0,'Ol Mahum Steward',0,'Monster.ol_mahum_champion',14.00,27.00,70,'male','L2Npc',40,3862,1493,7.11,1.84,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,0,0,'LAST_HIT'),
	(35384,35384,'Black',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,7.11,1.84,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35385,35385,'Renny',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35386,35386,'Boyer',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,7.11,1.84,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35387,35387,'Baback',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35388,35388,'Tim',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,8.69,2.14,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35389,35389,'Loring',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35390,35390,'Dillon',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,8.69,2.14,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35391,35391,'Latif',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35392,35392,'Bremmer',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,8.69,2.14,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35393,35393,'Faolan',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35394,35394,'Kalis',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,5.53,1.53,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35395,35395,'Kogan',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35396,35396,'Winker',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,5.53,1.53,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35397,35397,'Merton',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35398,35398,'Ruben',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,5.53,1.53,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35399,35399,'Luce',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35400,35400,'Horner',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,7.11,1.84,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35401,35401,'Amiel',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35402,35402,'Borna',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35403,35403,'Ron',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,7.11,1.84,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35404,35404,'Jamal',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35405,35405,'Flynn',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,8.69,2.14,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35406,35406,'Jabilo',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35407,35407,'Seth',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,8.69,2.14,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35408,35408,'Dietrich',0,'',0,'Monster.headless_knight',21.00,31.00,67,'male','L2Monster',40,16388,2777,8.69,2.14,60,57,73,76,70,80,448,0,3548,438,1510,356,333,0,3819,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35409,35409,'Mikhail',0,'',0,'Monster.headless_knight',21.00,31.00,67,'male','L2Monster',40,16388,2777,10.27,2.45,60,57,73,76,70,80,448,0,3548,438,1510,356,333,0,3819,0,0,0,88,171,NULL,0,1,0,'LAST_HIT'),
	(35410,35410,'Gustav',0,'',0,'Monster.headless_knight',21.00,31.00,70,'male','L2Monster',40,8092000,2987,17.85,2.78,60,57,73,76,70,80,490,0,3987,469,1732,381,333,0,3819,0,0,0,113,291,NULL,0,1,0,'LAST_HIT'),
	(35411,35411,'Doom Servant',0,'',0,'Monster.hungry_spirit',30.00,40.00,65,'male','L2Monster',40,9571,1150,11.85,2.78,40,43,30,21,20,10,422,0,2151,417,617,338,278,150,333,0,0,0,16,132,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35412,35412,'Doom Guard',0,'',0,'Monster.hungry_spirit',30.00,40.00,66,'male','L2Monster',50,10639,1184,11.85,2.78,40,43,30,21,20,10,435,0,2243,427,649,347,278,0,333,0,0,0,16,132,'gustav_clan',1000,1,9,'LAST_HIT'),
	(35413,35413,'Doom Archer',0,'',0,'Monster.skeleton_archer',11.00,27.00,67,'male','L2Monster',1100,10879,1217,11.85,2.78,40,43,30,21,20,10,448,0,5191,438,680,356,249,0,333,286,0,0,44,154,'gustav_clan',700,1,9,'LAST_HIT'),
	(35414,35414,'Doom Trooper',0,'',0,'Monster.skeleton_pikeman',10.00,28.00,68,'male','L2Monster',80,11118,1251,11.85,2.78,40,43,30,21,20,10,462,0,2839,449,713,364,238,0,333,301,0,0,55,170,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35415,35415,'Doom Warrior',0,'',0,'Monster.skeleton_knight',10.00,25.00,69,'male','L2Monster',40,11353,1285,11.85,2.78,40,43,30,21,20,10,476,0,2529,459,745,373,317,150,333,71,0,0,44,176,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35416,35416,'Doom Knight',0,'',0,'Monster.death_blader',15.00,45.00,70,'male','L2Monster',40,11586,1319,11.85,2.78,40,43,30,21,20,10,490,0,2297,469,779,381,278,150,333,1472,0,0,110,187,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35417,35417,'Doorman of Hell',0,'',0,'Monster.dwarf_ghost',15.00,45.00,70,'male','L2Monster',40,11586,1319,13.43,3.09,40,43,30,21,20,10,490,0,2297,469,779,381,278,150,333,1472,0,0,88,132,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35418,35418,'Doorman of Hell',0,'',0,'Monster.dwarf_ghost',15.00,45.00,70,'male','L2Monster',40,11586,1319,13.43,3.09,40,43,30,21,20,10,490,0,2297,469,779,381,278,150,333,1472,0,0,88,132,'gustav_clan',1000,1,0,'LAST_HIT'),
	(35419,35419,'Hephaeston',0,'Wyvern Manager',0,'Monster.human_ghost',10.00,20.00,70,'male','L2WyvernManager',40,350000,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35420,35420,'Loken',0,'Messenger',0,'Monster.human_ghost',8.00,22.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,74,0,0,88,0,NULL,0,1,0,'LAST_HIT'),
	(35421,35421,'Biggerstaff',0,'Steward',0,'Monster.elf_ghost',7.00,21.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,0,NULL,0,1,0,'LAST_HIT'),
	(35422,35422,'Flag of Winner',0,'',0,'Deco.azit_a',100.00,72.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35423,35423,'Red Flag',0,'',0,'Deco.azit_b',75.00,55.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35424,35424,'Yellow Flag',0,'',0,'Deco.azit_b',75.00,55.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35425,35425,'Green Flag',0,'',0,'Deco.azit_b',75.00,55.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35426,35426,'Blue Flag',0,'',0,'Deco.azit_b',75.00,55.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35427,35427,'Purple Flag',0,'',0,'Deco.azit_b',75.00,55.00,56,'etc','L2Deco',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35428,35428,'Oel Mahum Berserker',0,'',0,'Monster.oel_mahum_warrior',20.00,38.00,60,'male','L2Monster',40,125202,3420,466.48,11.10,60,57,73,76,70,80,4320,247,680,1476,5200,598,333,0,3819,0,0,0,113,226,NULL,0,0,0,'LAST_HIT'),
	(35429,35429,'Oel Mahum Scout',0,'',0,'Monster.oel_mahum_warrior',20.00,38.00,60,'male','L2Monster',40,56341,3420,466.48,11.10,60,57,73,76,70,80,4320,247,680,1476,5200,598,333,0,3819,0,0,0,113,226,NULL,0,0,0,'LAST_HIT'),
	(35430,35430,'Oel Mahum Leader',0,'',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,60,'male','L2Monster',40,62601,3420,466.48,11.10,60,57,73,76,70,80,4320,247,680,2953,5200,299,333,0,3819,0,0,0,113,226,NULL,0,0,0,'LAST_HIT'),
	(35431,35431,'Oel Mahum Cleric',0,'',0,'Monster.oel_mahum_witch_doctor',15.00,34.00,60,'male','L2Monster',40,62601,3420,466.48,11.10,60,57,73,76,70,80,4320,247,680,738,5200,1197,333,0,3819,0,0,0,113,226,NULL,0,0,0,'LAST_HIT'),
	(35432,35432,'Oel Mahum Thief',0,'',0,'Monster.oel_mahum_40_sm',12.00,19.00,60,'male','L2Monster',40,50080,3420,373.18,11.10,60,57,73,76,70,80,4320,247,544,1181,5200,538,333,0,3819,0,0,0,113,226,NULL,0,0,0,'LAST_HIT'),
	(35433,35433,'Inner Doorman',0,'',0,'Monster.oel_mahum',20.00,37.00,70,'male','L2Npc',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(35434,35434,'Inner Doorman',0,'',0,'Monster.oel_mahum',20.00,37.00,70,'male','L2Npc',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(35435,35435,'Outer Doorman',0,'',0,'Monster.oel_mahum',20.00,37.00,70,'male','L2Npc',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(35436,35436,'Outer Doorman',0,'',0,'Monster.oel_mahum',20.00,37.00,70,'male','L2Npc',40,5149,1493,11.85,2.78,40,43,30,21,20,10,490,10,1314,941,780,382,282,0,333,0,0,0,77,132,NULL,0,0,0,'LAST_HIT'),
	(35437,35437,'Messenger',0,'',0,'Monster.oel_mahum',20.00,37.00,56,'male','L2Npc',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,77,132,'dion_siege_clan',600,0,0,'LAST_HIT'),
	(35438,35438,'Chamberlain',0,'',0,'Monster.oel_mahum',20.00,37.00,56,'male','L2ClanHallManager',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,77,132,'dion_siege_clan',600,0,0,'LAST_HIT'),
	(35439,35439,'Carey',0,'Clan Hall Manager',0,'NPC.a_maidB_FHuman',8.00,22.00,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35440,35440,'Daniel',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',10.00,20.00,70,'male','L2Npc',40,350000,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35441,35441,'Dianne',0,'Clan Hall Manager',0,'NPC.a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35442,35442,'Jacques',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35443,35443,'Crissy',0,'Clan Hall Manager',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35444,35444,'Joff',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35445,35445,'Albert',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35446,35446,'Niels',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35447,35447,'Korgen',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35448,35448,'Rudy',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35449,35449,'DiMaggio',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35450,35450,'Gellar',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35451,35451,'Emma',0,'Clan Hall Manager',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35452,35452,'Theobolt',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35453,35453,'Adrienne',0,'Clan Hall Manager',0,'NPC.a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35454,35454,'Rosconne',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35455,35455,'Bianca',0,'Clan Hall Manager',0,'NPC.a_maidB_FHuman',8.00,22.00,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35456,35456,'Stewart',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35457,35457,'Gladys',0,'Clan Hall Manager',0,'NPC.a_maidA_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35458,35458,'Theron',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35459,35459,'Regina',0,'Clan Hall Manager',0,'NPC.a_maidB_FHuman',8.00,22.00,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35460,35460,'Trey',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35461,35461,'Aida',0,'Clan Hall Manager',0,'NPC.a_traderC_Fhuman',8.00,22.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35462,35462,'Kalmer',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35463,35463,'Helga',0,'Clan Hall Manager',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35464,35464,'Volfrem',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35465,35465,'Millicent',0,'Clan Hall Manager',0,'NPC.a_common_peopleB_FHuman',8.00,20.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35466,35466,'Gerard',0,'Clan Hall Gatekeeper',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35467,35467,'Branhillde',0,'Clan Hall Manager',0,'NPC.a_traderC_Fhuman',8.00,22.50,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35468,35468,'Lambert',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35469,35469,'Gods'' Altar',0,'',0,'NpcEV.rune_holything',46.00,72.50,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35470,35470,'Astair van Halter',0,'King',0,'NPC.a_lord_MHuman',10.00,23.00,93,'male','L2Npc',40,350000,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35471,35471,'Royal Knight',0,'Rune',0,'NPC.a_royal_guardA_MHuman',10.00,23.00,70,'male','L2SiegeGuard',40,38622,5975,13.43,3.09,40,43,30,21,20,10,30,2,3943,470,780,382,253,0,333,76,2497,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35472,35472,'Court Sorcerer',0,'Rune',0,'NPC.a_patriarch_MElf',10,21,68,'male','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,325,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35473,35473,'Court Sorcerer',0,'Rune',0,'NPC.a_mageguild_master_FHuman',10,21,68,'female','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,193,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35474,35474,'Court Guard',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10,23,68,'male','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,94,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35475,35475,'Guard',0,'Rune',0,'NPC.e_guard_MDwarf',10,18,66,'male','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,7486,428,649,348,253,0,333,93,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35476,35476,'Guard',0,'Rune',0,'NPC.e_guard_MDwarf',10,18,66,'male','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,2499,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35477,35477,'Guard',0,'Rune',0,'NPC.a_guard_MElf',10,23,66,'male','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,276,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35478,35478,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,16,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35479,35479,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,2,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35480,35480,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,14,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35481,35481,'Guard',0,'Rune',0,'NPC.e_guard_MOrc',10,27,66,'male','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,7486,428,649,348,253,0,333,16,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35482,35482,'Guard',0,'Rune',0,'NPC.e_guard_MOrc',10,27,66,'male','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,2,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35483,35483,'Guard',0,'Rune',0,'NPC.a_guard_MHuman',10,23,66,'male','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,14,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35484,35484,'Royal Knight',0,'Rune',0,'NPC.a_royal_guardA_MHuman',10,23,70,'male','L2SiegeGuard',40,38622,5975,13.43,3.09,40,43,30,21,20,10,30,2,3943,470,780,382,253,0,333,76,2497,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35485,35485,'Court Sorcerer',0,'Rune',0,'NPC.a_patriarch_MElf',10,21,68,'male','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,325,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35486,35486,'Court Sorcerer',0,'Rune',0,'NPC.a_mageguild_master_FHuman',10,21,68,'female','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,193,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35487,35487,'Court Guard',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10,23,68,'male','L2SiegeGuard',40,37063,5693,13.43,3.09,40,43,30,21,20,10,30,2,3652,449,713,365,253,0,333,94,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35488,35488,'Guard',0,'Rune',0,'NPC.e_guard_MDwarf',10,18,66,'male','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,93,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35489,35489,'Guard',0,'Rune',0,'NPC.e_guard_MDwarf',10,18,66,'male','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,2499,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35490,35490,'Guard',0,'Rune',0,'NPC.a_guard_MElf',10,23,66,'male','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,276,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35491,35491,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,7486,428,649,348,253,0,333,16,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35492,35492,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,2,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35493,35493,'Guard',0,'Rune',0,'NPC.a_guard_FDarkelf',10,23,66,'female','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,14,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35494,35494,'Guard',0,'Rune',0,'NPC.e_guard_MOrc',10,27,66,'male','L2SiegeGuard',80,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,16,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35495,35495,'Guard',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10,23,66,'male','L2SiegeGuard',40,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,7486,428,649,348,253,0,333,2,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35496,35496,'Guard',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10,23,66,'male','L2SiegeGuard',1100,35465,5415,13.43,3.09,40,43,30,21,20,10,30,2,3369,428,649,348,253,0,333,14,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35497,35497,'Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35498,35498,'Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35499,35499,'Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35500,35500,'Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35501,35501,'Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35502,35502,'Group Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2CastleTeleporter',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35503,35503,'Outer Doorman',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35504,35504,'Inner Doorman',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35505,35505,'Inner Doorman',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35506,35506,'Dungeon Gatekeeper',0,'Rune',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35507,35507,'Blacksmith',0,'Rune',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35508,35508,'Warehouse Keeper',0,'Rune',0,'NPC.a_warehouse_keeper_MDwarf',10.00,16.00,70,'male','L2CastleWarehouse',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,55,132,'rune_siege_clan',600,1,0,'LAST_HIT'),
	(35509,35509,'Frederick',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',10.00,22.00,70,'male','L2CastleChamberlain',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35510,35510,'Titus',0,'Wyvern Manager',0,'NPC.a_fighterguild_teacher_MHuman',10.00,23.00,70,'male','L2WyvernManager',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35511,35511,'Gompus',0,'Mercenary Manager',0,'NPC.a_common_peopleC_Mhuman',10.00,23.00,70,'male','L2MercManager',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35512,35512,'Manor Manager',0,'Rune',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35513,35513,'Sherman',0,'Messenger',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2SiegeNpc',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35514,35514,'Altar of Wind',0,'',0,'NPC.godad_holything',25.00,65.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35515,35515,'Altar of Earth',0,'',0,'NPC.godad_holything',25.00,65.00,20,'etc','L2Artefact',40,541,213,3.95,1.21,40,43,30,21,20,10,40,10,57,94,23,76,282,0,333,0,0,0,55,0,NULL,0,1,0,'LAST_HIT'),
	(35516,35516,'Verus',0,'Royal Guard Captain',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,62,'male','L2Npc',40,51515,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35517,35517,'Swain Ken Orwen',0,'Count',0,'NPC.a_lord_MHuman',10.00,23.00,65,'male','L2Npc',40,55449,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35518,35518,'Royal Knight',0,'Schuttgart ',0,'NPC.a_royal_guardA_MHuman',10,23,60,'male','L2SiegeGuard',40,24436,3452,13.43,3.09,40,43,30,21,20,10,30,2,1721,368,478,299,253,0,333,76,2497,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35519,35519,'Court Sorcerer',0,'Schuttgart ',0,'NPC.a_patriarch_MElf',10,21,58,'male','L2SiegeGuard',40,23114,3254,13.43,3.09,40,43,30,21,20,10,30,2,1562,349,428,284,253,0,333,325,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35520,35520,'Court Sorcerer',0,'Schuttgart ',0,'NPC.a_mageguild_master_FHuman',10,23,58,'female','L2SiegeGuard',40,23114,3254,13.43,3.09,40,43,30,21,20,10,30,2,1562,349,428,284,253,0,333,193,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35521,35521,'Court Guard',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10,23,58,'male','L2SiegeGuard',40,23114,3254,13.43,3.09,40,43,30,21,20,10,30,2,1562,349,428,284,253,0,333,94,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35522,35522,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MDwarf',10,18,56,'male','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,93,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35523,35523,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MDwarf',10,18,56,'male','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2499,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35524,35524,'Guard',0,'Schuttgart ',0,'NPC.a_guard_MElf',10,23,56,'male','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,276,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35525,35525,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,16,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35526,35526,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35527,35527,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,14,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35528,35528,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MOrc',10,27,56,'male','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,16,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35529,35529,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MOrc',10,27,56,'male','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35530,35530,'Guard',0,'Schuttgart ',0,'NPC.a_guard_MHuman',10,23,56,'male','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,14,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35531,35531,'Royal Knight',0,'Schuttgart ',0,'NPC.a_royal_guardA_MHuman',10,23,60,'male','L2SiegeGuard',40,24436,3452,13.43,3.09,40,43,30,21,20,10,30,2,1721,368,478,299,253,0,333,76,2497,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35532,35532,'Court Sorcerer',0,'Schuttgart ',0,'NPC.a_patriarch_MElf',20,21,58,'male','L2SiegeGuard',80,23114,3254,13.43,3.09,40,43,30,21,20,10,0,0,1562,349,428,284,300,0,333,325,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35533,35533,'Court Sorcerer',0,'Schuttgart ',0,'NPC.a_mageguild_master_FHuman',20,23,58,'female','L2SiegeGuard',80,23114,3254,13.43,3.09,40,43,30,21,20,10,0,0,1562,349,428,284,300,0,333,193,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35534,35534,'Court Guard',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',20,23,58,'male','L2SiegeGuard',80,23114,3254,13.43,3.09,40,43,30,21,20,10,0,0,1562,349,428,284,300,0,333,94,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35535,35535,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MDwarf',10,18,56,'male','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,93,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35536,35536,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MDwarf',10,18,56,'male','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2499,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35537,35537,'Guard',0,'Schuttgart ',0,'NPC.a_guard_MElf',10,23,56,'male','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,276,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35538,35538,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,16,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35539,35539,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35540,35540,'Guard',0,'Schuttgart ',0,'NPC.a_guard_FDarkelf',10,23,56,'female','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,14,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35541,35541,'Guard',0,'Schuttgart ',0,'NPC.e_guard_MOrc',10,27,56,'male','L2SiegeGuard',80,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,16,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35542,35542,'Guard',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10,23,56,'male','L2SiegeGuard',40,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,2,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35543,35543,'Guard',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10,23,56,'male','L2SiegeGuard',1100,21799,3059,13.43,3.09,40,43,30,21,20,10,30,2,1412,331,382,269,253,0,333,14,0,0,55,132,'schutt_siege_clan',600,1,0,'LAST_HIT'),
	(35544,35544,'Gatekeeper',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2Doormen',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35545,35545,'Gatekeeper',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,56,'male','L2Doormen',40,2724,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35546,35546,'Gatekeeper',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',8.00,24.00,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,490,10,2703,470,6964,764,409,0,3819,14,0,0,81,259,NULL,0,1,0,'LAST_HIT'),
	(35547,35547,'Group Gatekeeper',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',8.00,23.50,56,'male','L2CastleTeleporter',40,2724,44,13.43,3.09,40,43,30,21,20,10,490,10,2703,470,6964,764,409,0,3819,14,0,0,81,259,NULL,0,1,0,'LAST_HIT'),
	(35548,35548,'Outer Doorman',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',7.00,23.00,70,'female','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,490,10,2703,470,6964,764,409,0,3819,14,0,0,81,259,NULL,0,1,0,'LAST_HIT'),
	(35549,35549,'Inner Doorman',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',8.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,490,10,2703,470,6964,764,409,0,3819,14,0,0,81,259,NULL,0,1,0,'LAST_HIT'), 
	(35550,35550,'Inner Doorman',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',8.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,490,10,2703,470,6964,764,409,0,3819,14,0,0,81,259,NULL,0,1,0,'LAST_HIT'),
	(35551,35551,'Doorman  ',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35552,35552,'Doorman  ',0,'Schuttgart ',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2Doormen',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35553,35553,'Blacksmith',0,'Schuttgart ',0,'NPC.a_smith_MDwarf',8.00,17.00,70,'male','L2CastleBlacksmith',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35554,35554,'Warehouse Keeper',0,'Schuttgart ',0,'NPC.a_warehouse_keeper_MDwarf',10.00,15.00,70,'male','L2CastleWarehouse',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35555,35555,'August',0,'Chamberlain',0,'NPC.a_chamberlain_MHuman',10.00,22.00,70,'male','L2CastleChamberlain',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35556,35556,'Gallic',0,'Wyvern Manager',0,'NPC.a_common_peopleC_Mhuman',10.00,23.00,70,'male','L2WyvernManager',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35557,35557,'Kendrew',0,'Mercenary Manager',0,'NPC.a_common_peopleC_Mhuman',10.00,23.00,70,'male','L2MercManager',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35558,35558,'Manor Manager',0,'Schuttgart',0,'NPC.a_chamberlain_MHuman',9.50,22.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35559,35559,'Daguerre',0,'Messenger',0,'NPC.e_elmore_guard_Mhuman',10.00,23.00,70,'male','L2SiegeNpc',40,3862,44,13.43,3.09,40,43,30,21,20,10,30,2,4,40,3,31,253,0,333,0,0,0,22,55,NULL,0,0,0,'LAST_HIT'),
	(35560,35560,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',7.00,23.00,56,'male','L2Teleporter',40,2724,3958,23.70,2.78,40,43,30,21,20,10,422,1,4308,418,619,340,278,0,333,79,0,0,88,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35561,35561,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',7.00,24.00,56,'male','L2Teleporter',40,2724,3653,23.70,2.78,40,43,30,21,20,10,384,1,3777,388,532,315,278,0,333,142,0,0,88,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35562,35562,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',7.00,24.00,56,'male','L2Teleporter',40,2724,3452,10.27,2.45,40,43,30,21,20,10,360,1,1721,368,478,299,278,0,333,76,2497,0,88,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35563,35563,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',8.00,25.00,56,'female','L2Teleporter',40,2724,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'dion_siege_clan',600,1,0,'LAST_HIT'),
	(35564,35564,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',8.00,23.00,56,'female','L2Teleporter',40,2724,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,278,0,333,193,0,0,88,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35565,35565,'Mass Gatekeeper',0,'',0,'Monster.oel_mahum',7.00,24.00,56,'male','L2Teleporter',40,2724,3254,10.27,2.45,40,43,30,21,20,10,336,1,1562,349,428,284,237,0,333,94,0,0,88,132,'innadrile_siege_clan',1200,1,0,'LAST_HIT'),
	(35566,35566,'Ronald',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.50,70,'male','L2ClanHallManager',40,3862,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,237,0,333,0,0,0,88,132,NULL,1200,1,0,'LAST_HIT'),
	(35567,35567,'Emil',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.50,70,'male','L2Doormen',40,3862,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,0,0,0,88,132,NULL,1200,1,0,'LAST_HIT'),
	(35568,35568,'Wayne',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.50,70,'male','L2ClanHallManager',40,3862,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,0,0,0,88,132,NULL,1200,1,0,'LAST_HIT'),
	(35569,35569,'Daniel',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,22.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35570,35570,'Patty',0,'Clan Hall Manager',0,'NPC.a_traderC_Fhuman',7.00,25.00,70,'female','L2ClanHallManager',40,3862,3059,10.27,2.45,40,43,30,21,20,10,313,1,1412,331,382,269,278,0,333,0,0,0,88,132,NULL,1200,1,0,'LAST_HIT'),
	(35571,35571,'Dale',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',7.00,25.00,70,'female','L2Doormen',40,3862,3059,10.27,2.45,40,43,30,21,20,10,313,1,3139,331,382,269,249,0,333,0,0,0,88,132,NULL,1200,1,0,'LAST_HIT'),
	(35572,35572,'Jimmy',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',7.00,25.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35573,35573,'Shawn',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',7.00,25.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35574,35574,'Michael',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',7.00,25.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35575,35575,'Ryan',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.50,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35576,35576,'Jack',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.50,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35577,35577,'Harry',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.50,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35578,35578,'Karuto',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35579,35579,'Egon',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35580,35580,'Carol',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35581,35581,'Osho',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35582,35582,'Stanley',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35583,35583,'Walter',0,'Clan Hall Gatekeeper',0,'NPC.a_common_peopleB_MHuman',8.00,23.00,70,'male','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35584,35584,'Billy',0,'Clan Hall Manager',0,'NPC.a_casino_MHuman',8.00,23.00,70,'male','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35585,35585,'Alice',0,'Clan Hall Gatekeeper',0,'NPC.a_traderC_Fhuman',8.00,23.00,70,'female','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35586,35586,'Serena',0,'Clan Hall Manager',0,'NPC.a_maidA_FHuman',8.00,23.00,70,'female','L2ClanHallManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35587,35587,'Neria',0,'Clan Hall Gatekeeper',0,'NPC.a_traderC_Fhuman',8.00,21.00,70,'female','L2Doormen',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35588,35588,'Hot Springs Gourd',0,'',0,'NPC.drop_gourd_50_bi',20.00,31.00,56,'male','L2Npc',40,64201,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35589,35589,'Hot Springs Gourd',0,'',0,'NPC.drop_gourd_50_bi',20.00,31.00,56,'male','L2Npc',40,64201,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35590,35590,'Hot Springs Gourd',0,'',0,'NPC.drop_gourd_50_bi',20.00,31.00,56,'male','L2Npc',40,64201,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35591,35591,'Hot Springs Gourd',0,'',0,'NPC.drop_gourd_50_bi',20.00,31.00,56,'male','L2Npc',40,64201,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35592,35592,'Enraged Yeti',0,'',0,'Monster.yeti',20.00,31.00,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35593,35593,'Treasure Chest',0,'',0,'Monster.mimic',20.00,31.00,52,'male','L2Npc',40,2402,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35594,35594,'Treasure Chest',0,'',0,'Monster.mimic',20.00,31.00,52,'male','L2Npc',40,2402,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35595,35595,'Treasure Chest',0,'',0,'Monster.mimic',20.00,31.00,52,'male','L2Npc',40,600,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35596,35596,'Hot Springs Yeti',0,'Maitre ''D',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35597,35597,'Hot Springs Yeti',0,'Maitre ''D',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35598,35598,'Hot Springs Yeti',0,'Maitre ''D',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35599,35599,'Hot Springs Yeti',0,'Maitre ''D',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35600,35600,'Manager',0,'',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35601,35601,'Doorman',0,'',0,'NPC.yeti_cute',5.00,11.50,70,'male','L2Npc',40,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35602,35602,'Doorman',0,'',0,'NPC.yeti_cute',5.00,11.50,70,'male','L2Npc',40,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'), 
	(35603,35603,'Coordinator',0,'',0,'Monster.yeti',15.00,27.50,70,'male','L2Npc',40,3862,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35604,35604,'Messenger',0,'',0,'NPC.yeti_cute',5.00,11.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35605,35605,'Angout',0,'Steward',0,'Monster.yeti',15.00,27.50,56,'male','L2Npc',40,2724,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35606,35606,'Victor''s Flag',0,'',0,'NpcEV.azit_contest_pile_winner',63.50,97.50,99,'male','L2Npc',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35607,35607,'Red Flag',0,'',0,'NpcEV.azit_contest_pile_a',52.00,195.50,99,'male','L2Npc',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35608,35608,'Yellow Flag',0,'',0,'NpcEV.azit_contest_pile_b',51.80,108.25,99,'male','L2Npc',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35609,35609,'Green Flag',0,'',0,'NpcEV.azit_contest_pile_c',51.80,108.25,99,'male','L2Npc',40,400000,9999,13.43,3.09,40,43,30,21,20,10,0,0,9000,5000,6000,6000,300,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35610,35610,'Blue Flag',0,'',0,'NpcEV.azit_contest_pile_d',51.80,108.25,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35611,35611,'Purple Flag',0,'',0,'NpcEV.azit_contest_pile_e',51.80,108.25,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35612,35612,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,56,'male','L2SiegeGuard',40,2725,1019,10.27,2.45,40,43,30,21,20,10,313,10,706,331,382,268,282,0,333,0,0,0,55,132,'innadrile_siege_clan',600,1,0,'LAST_HIT'),
	(35613,35613,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35614,35614,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35615,35615,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35616,35616,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35617,35617,'Group Gatekeeper',0,'',0,'Monster.kel_mahum',13.00,26.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35618,35618,'Frenzied Cougar',0,'',0,'Monster.saber_toothed_tiger',10.00,28.00,60,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35619,35619,'Frenzied Buffalo',0,'',0,'Monster2.buffalo',22.00,31.00,60,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35620,35620,'Frenzied Kookaburra',0,'',0,'Monster2.rough_ostrich',10.00,33.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35621,35621,'Frenzied Buffalo Baby',0,'',0,'Monster2.baby_buffalo',12.00,15.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35622,35622,'Frenzied Baby Cougar',0,'',0,'Monster2.baby_tiger',11.00,15.70,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35623,35623,'Inner Doorman',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35624,35624,'Inner Doorman',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35625,35625,'Outer Doorman',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35626,35626,'Outer Doorman',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35627,35627,'Messenger',0,'',0,'Monster.kel_mahum_champion',13.00,32.00,56,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35628,35628,'Quigby',0,'Farm Manager',0,'Monster.kel_mahum_champion',13.00,32.00,56,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35629,35629,'Lidia von Hellmann',0,'',0,'Monster3.lidia_von_helmann',10.00,25.40,73,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35630,35630,'Alfred von Hellmann',0,'',0,'Monster3.Vampire_Troop_Leader',19.00,35.00,72,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35631,35631,'Giselle von Hellmann',0,'',0,'Monster2.vampire_wizard',5.50,28.00,72,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35632,35632,'Vampire Adept',0,'',0,'Monster2.vampire_witch',6.00,21.50,68,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35633,35633,'Vampire Soldier',0,'',0,'Monster2.vampire_soldier',10.00,15.00,68,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35634,35634,'Vampire Caster',0,'',0,'Monster2.vampire_witch',6.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35635,35635,'Vampire Magister',0,'',0,'Monster2.vampire_wizard',5.50,28.00,71,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35636,35636,'Vampire Warlord',0,'',0,'Monster2.vampire_warrior',9.00,31.50,72,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35637,35637,'Vampire Leader',0,'',0,'Monster2.vampire_lord',7.50,25.80,73,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35638,35638,'Valens',0,'Wyvern Manager',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2WyvernManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35639,35639,'Jacquard',0,'Messenger',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35640,35640,'Bandello',0,'Steward',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35641,35641,'Fortress Guard',0,'',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35642,35642,'Fortress Guard',0,'',0,'Monster2.vampire_soldier',8.00,23.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35643,35643,'Gate  ',0,'',0,'NpcEV.farm_hedge',184.00,24.00,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35644,35644,'Manor Manager',0,'Schuttgart',0,'NPC.a_traderA_MDwarf',8.00,17.00,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35645,35645,'Manor Manager',0,'Schuttgart',0,'NPC.e_trader_MOrc',8.00,23.50,70,'male','L2ManorManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(35646,35646,'Vampire Caster',0,'',0,'Monster2.vampire_witch',6.00,21.50,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35647,35647,'Vampire Leader',0,'',0,'Monster2.vampire_lord',7.50,25.80,73,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35648,35648,'Court Magician',0,'Gludio',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35649,35649,'Court Magician',0,'Dion',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35650,35650,'Court Magician',0,'Giran',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35651,35651,'Court Magician',0,'Oren',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35652,35652,'Court Magician',0,'Aden',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35653,35653,'Court Magician',0,'Innadril',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35654,35654,'Court Magician',0,'Goddard',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35655,35655,'Court Magician',0,'Rune',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT'),
	(35656,35656,'Court Magician',0,'Schuttgart',0,'Monster3.Elite_Mage',6.50,21.96,70,'male','L2Npc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,88,132,NULL,0,0,0,'LAST_HIT');

INSERT INTO `npc` VALUES
	(50007,31324,'Andromeda',1,'Wedding Manager',1,'NPC.a_casino_FDarkElf',8.00,23.00,70,'female','L2WeddingManager',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,316,0,0,55,132,NULL,0,1,0,'LAST_HIT'),
	(70010,31606,'Catrina',1,'TvT Event Manager',1,'Monster2.queen_of_cat',8.00,15.00,70,'female','L2TvTEventNpc',40,3862,1493,11.85,2.78,40,43,30,21,20,10,0,0,1314,470,780,382,278,0,333,0,0,0,28,132,NULL,0,0,0,'LAST_HIT');

UPDATE `npc` SET `type` = 'L2NpcWalker' WHERE `id` IN (31358,31359,31360,31361,31362,31363,31357,31356,31364,31365,32070,32072);

-- Try lowering walkspeed of walking NPC since seems to walk faster than retail
UPDATE `npc` SET `runspd` = '45', `walkspd` = '45' WHERE `id` = '31360';
UPDATE `npc` SET `runspd` = '45', `walkspd` = '45' WHERE `id` = '31362';
UPDATE `npc` SET `runspd` = '45', `walkspd` = '45' WHERE `id` = '31359';
UPDATE `npc` SET `runspd` = '45', `walkspd` = '45' WHERE `id` = '31358';
UPDATE `npc` SET `runspd` = '45', `walkspd` = '45' WHERE `id` = '31357';
UPDATE `npc` SET `runspd` = '25', `walkspd` = '25' WHERE `id` = '31364';
UPDATE `npc` SET `runspd` = '25', `walkspd` = '25' WHERE `id` = '31365';
UPDATE `npc` SET `runspd` = '50', `walkspd` = '50' WHERE `id` = '32070';
UPDATE `npc` SET `collision_height` = '17.00', `runspd` = '12', `walkspd` = '12' WHERE `id` = '32072';